//---------------------------------------------------------------------------
//		Copyright (C) 1991-93, Microsoft Corporation
//
// You have a royalty-free right to use, modify, reproduce and distribute
// the Sample Custom Control Files (and/or any modified version) in any way
// you find useful, provided that you agree that Microsoft has no warranty,
// obligation or liability for any Custom Control File.
//---------------------------------------------------------------------------
// matlab.h
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
// Resource Information
//---------------------------------------------------------------------------
// Toolbox bitmap resource IDs numbers.
//---------------------------------------------------------------------------
#define IDBMP_ML			8000
#define IDBMP_MLDOWN		8001
#define IDBMP_MLMONO		8003
#define IDBMP_MLEGA 		8006

#define	IDBMP_MEMBRANE		8007
//---------------------------------------------------------------------------
// Change these for each new VBX file
//---------------------------------------------------------------------------
#define VBX_COMPANYNAME 	   "The Mathworks, Inc.\0"
#define VBX_FILEDESCRIPTION	   "Visual Basic Matlab Custom Control\0"
#define VBX_INTERNALNAME	   "matlab\0"
#define VBX_LEGALCOPYRIGHT	   "Copyright \251 The Mathworks, Inc"

//---------------------------------------------------------------------------
// Update these fields for each build.
//---------------------------------------------------------------------------
#define VBX_VERSION		    	3,00,0,00
#define VBX_VERSION_STR			"3.00.000\0"

#ifndef RC_INVOKED
//---------------------------------------------------------------------------
// Macro for referencing member of structure
//---------------------------------------------------------------------------
#define OFFSETIN(struc, field)	    ((USHORT)&(((struc *)0)->field))


LONG FAR PASCAL _export MatlabCtlProc(HCTL, HWND, USHORT, USHORT, LONG);


//---------------------------------------------------------------------------
// Global Variables and Constants
//---------------------------------------------------------------------------
extern	HANDLE hmodDLL;     // From ccinit.c

//---------------------------------------------------------------------------
// MATLAB control data and structs
//---------------------------------------------------------------------------
typedef struct tagMATLAB
{
    HSZ		hszCommand;
    HSZ		hszResult;
    void	FAR *lpIPC;			/* this is a void * because of name clashes between DDEML.h and vbapi.h */
								/* its ACTUALLY of type "LPIPC" */
} MATLAB;


typedef MATLAB FAR * LPML;


//---------------------------------------------------------------------------
// Property info
//---------------------------------------------------------------------------

PROPINFO Property_Command =
    {
    "Command",
    DT_HSZ | PF_fGetData | PF_fSetData | PF_fSetMsg | PF_fEditable,
    OFFSETIN (MATLAB, hszCommand),
    0,
    0,
    NULL,
    0
    };

PROPINFO Property_Result =
    {
    "Result",
    DT_HSZ | PF_fGetData | PF_fSetData | PF_fSetMsg | PF_fEditable,
    OFFSETIN (MATLAB, hszResult),
    0,
    0,
    NULL,
    0
    };


//---------------------------------------------------------------------------
// Property list
//---------------------------------------------------------------------------


// Define the consecutive indicies for the properties
//---------------------------------------------------------------------------
#define IPROP_CIRCLE_CTLNAME		  0
#define IPROP_CIRCLE_INDEX                1
#define IPROP_CIRCLE_BACKCOLOR            2
#define IPROP_CIRCLE_LEFT                 3
#define IPROP_CIRCLE_TOP                  4
#define IPROP_CIRCLE_WIDTH                5
#define IPROP_CIRCLE_HEIGHT               6
#define IPROP_CIRCLE_VISIBLE              7
#define IPROP_CIRCLE_PARENT               8
#define IPROP_CIRCLE_DRAGMODE             9
#define IPROP_CIRCLE_DRAGICON            10
#define IPROP_CIRCLE_TAG                 11
#define IPROP_CIRCLE_CAPTION             12
#define IPROP_CIRCLE_TABINDEX		 13
#define IPROP_CIRCLE_TABSTOP		 14
#define IPROP_CIRCLE_ENABLED		 15
#define IPROP_CIRCLE_MOUSEPOINTER	 16
#define IPROP_CIRCLE_HWND            17
#define IPROP_CIRCLE_HELPCONTEXTID   18
#define IPROP_CIRCLE_DATASOURCE      19
#define IPROP_CIRCLE_DATAFIELD       20
#define IPROP_CIRCLE_DATACHANGED     21

#define IPROP_ML_COMMAND		22
#define IPROP_ML_RESULT			23




PPROPINFO Matlab_Properties[] =
    {
    PPROPINFO_STD_CTLNAME,
    PPROPINFO_STD_INDEX,
    PPROPINFO_STD_BACKCOLOR,
    PPROPINFO_STD_LEFT,
    PPROPINFO_STD_TOP,
    PPROPINFO_STD_WIDTH,
    PPROPINFO_STD_HEIGHT,
    PPROPINFO_STD_VISIBLE,
    PPROPINFO_STD_PARENT,
    PPROPINFO_STD_DRAGMODE,
    PPROPINFO_STD_DRAGICON,
    PPROPINFO_STD_TAG,
    PPROPINFO_STD_CAPTION,
    PPROPINFO_STD_TABINDEX,
    PPROPINFO_STD_TABSTOP,
    PPROPINFO_STD_ENABLED,
    PPROPINFO_STD_MOUSEPOINTER,
    PPROPINFO_STD_HWND,
    PPROPINFO_STD_HELPCONTEXTID,
    PPROPINFO_STD_DATASOURCE,
    PPROPINFO_STD_DATAFIELD,
    PPROPINFO_STD_DATACHANGED,
    &Property_Command,
    &Property_Result,
    NULL
    };


//---------------------------------------------------------------------------
// Model struct
//---------------------------------------------------------------------------
// Define the control model (using the event and property structures).
//---------------------------------------------------------------------------
MODEL modelMatlab =
    {
    VB_VERSION, 			// VB version being used
    MODEL_fLoadMsg, 		// MODEL flags
    (PCTLPROC) MatlabCtlProc,	// Control procedure
    CS_HREDRAW | CS_VREDRAW,		// Class style
    WS_BORDER, 					// Default Windows style
    sizeof(MATLAB),			// Size of MATLAB structure
    IDBMP_ML,				// Palette bitmap ID
    "Matlab",				// Default control name
    "matlab",				// Visual Basic class name
    NULL,					// Parent class name
    Matlab_Properties,		// Property information table
    NULL,					// Event information table
    IPROP_ML_COMMAND,		// Default property
    0,						// Default event
    IPROP_ML_RESULT			// Property representing value of ctl
    };

LPMODEL modellistML[] =
    {
    &modelMatlab,
    NULL
    };

MODELINFO modelinfoMatlab =
    {
    VB_VERSION, 			// VB version being used
    modellistML				// MODEL list
    };

#endif	// RC_INVOKED

//---------------------------------------------------------------------------

