% Compressible Flow Toolbox
% Version 1.1     23-FEB-96
%
% Written By: Kevin J. Melcher
%             NASA Lewis Research Center
%             Cleveland, Ohio
%             Phone: 216-433-3743
%	      Email: kmelcher@lerc.nasa.gov
%
%
%      AMES2.M	computes isentropic & normal shock properties
%		specified in Tables I & II of NACA Report 1135. Given
%		a value or values for any column in the tables, this
%		function computes corresponding values for all of the
%		other properties.
%
%   AMES2ERR.M	computes the error between a Mach number used as
%		input to the AMES2 function and a Mach number
%		calculated by AMES2 from the other properties. This
%		is essentially a continuity test for function AMES2.
%
%   AMES2PLT.M	plots normalized output of function AMES2 for a
%		logarithmically spaced vector of 250 Mach number from
%		0.01 to 10.
%
%   DELTAMAX.M	computes the maximum angle through which isentropic
%		flow may be turned without separation. DELTAMAX by
%		itself plots the maximum turning angle for a Mach
%		range from 1.0 to 15.
%
%   DELTASON.M	computes the angle through which isentropic flow
%		may be turned resulting in a sonic downstream Mach
%		number. DELTASON by itself plots the sonic turning
%		angle for a Mach range from 1.0 to 15.
%
%      FANNO.M	computes the Fanno functions specified in Tables A4
%		of "Compressible Fluid Flow" by Michel A. Saad. Given
%		a value or values for any column in the table, this
%		function computes corresponding values for all of the
%		other properties.
%
%   FANNOERR.M	computes the error between a Mach number used as
%		input to the FANNO function and a Mach number
%		calculated by FANNO from the other properties. This
%		is essentially a continuity test for function FANNO.
%
%   FANNOPLT.M	plots normalized output of function FANNO for a
%		logarithmically spaced vector of 250 Mach number from
%		0.01 to 10.
%
%    ISENTBL.M	generates an ASCII table of the isentropic flow
%		functions found in columns 1 thru 8 of Tables I & II
%		in NACA Report 1135. The user may specify values for
%		Mach number and the ratio of specific heats.
%
%    OBLQSHK.M	computes both the weak and the strong shock angles
%		that result from compressing a supersonic flow by
%		turning. OBLQSHK by itself, generates a plot showing
%		shock angle vs. deflection angle for lines of constant
%		Mach from 1 to 20. 
%
%    OBLQW12.M	computes weak shock functions (downstream Mach number,
%		oblique shock angle, and total pressure ratio across
%		the oblique shock) from upstream Mach number, angle
%		through which the flow is turned compressively, and
%		ratio of specific heats. OBLQW12 by itself generates
%		plots for a Mach range from 1 to 20.
%
%    OBLQW21.M	computes weak shock functions (upstream Mach number,
%		oblique shock angle, and total pressure ratio across
%		the oblique shock) from downstream Mach number, angle
%		through which the flow is turned compressively, and
%		ratio of specific heats. OBLQW21 by itself generates
%		plots for a Mach range from 1 to 20.

