% GLMLAB: fitting generalised linear models
% Version 1.52, September 1996.
% By: Peter Dunn 
%     Department of Mathematics and Computing
%     The University of Southern Queensland
%     Toowoomba, Queensland, Australia, 4350.
%     (email: dunn@sci.usq.edu.au)
%
%
%The set of files included are below:
%
%In this directory:
% demo.txt:    a simple text file showing how to use glmlab (but see glmdemo)
% BASICS.txt:  explains some of the basics of using  glmlab
% Contents.m:  this file you're reading
% glmdemo.m:   a demo of glmlab in operation
% intro.txt:   a file introducing  glmlab
% README.v15:  some information for installing and using  glmlab
%
%In the /fit directory:
% Contents: a help file for the contents of the directory
% alias:    detects aliasing in covariates
% helpget:  the help screen for obtaining  glmlab
% helpcont: the help screen for contacting the author
% helpint:  the help screen for interactions
% helpopt:  the help screen for the menu options
% helpvar:  the help screen for variables areas
% fac:      declares a factor and makes a matrix of full-rank of the levels
% facfidle: fiddles with factor terms in the covariates
% findvars: finds the location of different types of x-variables
% fixmeup:  fixes up variable name inputs into glmlab
% fixnames: fixes up variable names for including in the output
% glmfit:   the general routine for fitting glms
% glmlab:   the main gui window for coordinating all the tasks
% glmsplsh: the initial splash screen
% interact: coordinates the interactions terms
% irls:     iteratively reweighted least squares: does the calculating
% makefac:  makes a new factor (like the GLIM %gl command)
% menuwork: does the hard work for the glmlab option window
% newmodel: declares a new model or data is being used
% opterr:   some error messages used in glmlab
% ovarcont: controls naming the offset variable name
% paramtrs: some program defaults that the user can feel free to monkey with
% postint:  does some work after interact is called
% preint:   does some work before interact is called
% prepare:  prepares the x-variables named in the glmlab window for later use
% varok:    makes sure the variables given are ok
% wvarcont: controls naming the prior weights variable name
% xvarcont: controls naming the x-variable name
% yvarcont: controls naming the y-variable name
%
%In the /fit/dist subdirectory:
% Contents: a help file for the contents of the directory
% dbinoml:  information for the binomial distribution
% dgamma:   information for the gamma distribution
% distlist: produces a list of error distributions available
% dlist:    the list of error distributions  glmlab  sees
% dnormal:  information for the normal distribution
% dpoisson: information for the Poisson distribution
% dstyle:   the template style for user defined distributions
%
%In the /fit/link subdirectory:
% Contents: a help file for the contents of the directory
% lcomplog:  information for the complementary log-log link
% lid:       information for the identity link
% llinklist: produces a list of link functions available
% llist:     the list of link functions  glmlab  sees
% llog:      information for the logarithm link
% llogit:    information for the logit (logistic) link
% lprobit:   information for the probit link
% lrecip:    information for the reciprocal link
% lsqroot:   information for the square root link
% lstyle:    the template style for user defined link functions
%
%In the /plotting directory:
% Contents: a help file for the contents of the directory
% fhisto:   produces a frequency histogram of ungrouped data
% glmplot:  presents a menu from which to choose the required plots
% npplot:   produces a normal probability plot
% plotwork: does the hard work for glmplot
% rhisto:   produces a relative frequency histogram of ungrouped data
% title2:   a  MATHWORKS  files to produce two-line titles on plots
%
%In the /misc directory:
% Contents: a help file for the contents of the directory
% bell:     produces a noise (for warnings, etc)
% cdfbino:  the cdf of the binomial distribution
% cdfgam:   the cdf of the gamma distribution
% cdfnorm:  the cdf of the normal distribution
% cdfpoiss: the cdf of the Poisson distribution
% diagm:    a function for doing some multiplying within glmlab
% findmat:  finds strings scattered throughout a matrix
% intleave: interleaves two matrices removing double-ups, and orders them
% invnorm:  inverse cdf of the normal distribution
% loadseed: loads the random number seed (from Gordon Smyth, UQ)
% makeline: a file to prints different line styles so things look prettier
% mmat2str  converts matrices to strings
% mystrrep: string replacement given _positions_
% mytime:   prints the time
% omit:     omits certain columns from the incidence matrix
% pad:      pads a string with blanks to make it a certain length
% saveseed: saves the current random number seed (from Gordon Smyth, UQ)
% wildfind: finds a string using a wildcard character (*)
%
%In the /data directory:
% Contents:      a help file for the contents of the directory
% chemical.hlp:  A file explaining  chemical.mat
% chemical.mat:  The data from Example 3.2 of `Learning glmlab'
% dummydta.m:    A file to quickly find the data directory
% loadme.hlp:    A file explaining  loadme.mat
% loadme.mat:    An example data set (see section 2.3 of `Learning glmlab')
% leuk.hlp:      A file explaining  leuk.mat
% leuk.mat:      An example data set
% tester.hlp:    A file explaining  tester.txt
% tester.txt:    An example data set (see section 2.3 of `Learning glmlab')
% turkey.hlp:    A file explaining  turkeys.mat.
% turkeys.mat:   The data from Example 3.1 of `Learning glmlab'
