%
%   Main script file illustrating Bessel interpolation

%      by Howard Wilson, U. of Alabama, Spring 1990

fprintf('\n PIECEWISE CUBIC BESSEL INTERPOLATION\n')
fprintf('\ninput xlower, xupper, and the number of data points')
fprintf('\n(0, 2*pi, and 12 are typical values)\n')
tmp=readv(3); a=tmp(1); b=tmp(2); n=tmp(3);
% the exact function being interpolated is y=sin(x)^3
d=(b-a)/n; xdat=a+d*(0:n)'; ydat=sin(xdat).^3;
% [s,w,z]=setup(xdat,ydat);
cofs=bescof(xdat,ydat);
dtrp=(b-a)/100; xtrp=a+dtrp*(0:100)'; lincub=2;
% [ytrp,yptrp]=trplatv(xtrp,xdat,ydat,s,w,z,lincub);
[ytrp,yptrp]=bestrp(xtrp,cofs);
ytrp=ytrp(:); yptrp=yptrp(:);
ytrpex=sin(xtrp).^3; yptrpex=(3*sin(xtrp).^2).*cos(xtrp);
yterr=ytrp-ytrpex; ypterr=yptrp-yptrpex;
plot(xtrp,ytrpex,'-',xdat,ydat,'o',xtrp,yptrpex,'-.',xtrp,yterr,':',xtrp,ypterr,'--');
title('BESSEL INTERPOLATION OF Y=SIN(X)^3 AND ITS DERIVATIVE')
xlabel('x axis'); ylabel('y(x), y''(x) and error terms')
txt=['using ',int2str(n),' data points,  '];
text(.2,1.2,[txt,'solid -> y(x),  dashed -> y''(x)'])
text(.2,-1.4,'dots -> function error,  dashdot -> derivative error')

