function indx=findseg(x,xdat)
% indx = findseg(x,xdat)
% This function determines a set of indices which identify
% interval in which components of xdat lie among the components
% of vector xdat. Vector xdat must have components arranged in
% ascending order. The k'th element of vector indx is an integer
% kx such that xdat(kx) <= xdat(k) < xdat(kx+1). Any points to
% the left of the first point are considered to be in the first
% interval. Points to the right of the last point are con-
% sidered to be in the last interval.

%           H. B. Wilson, Spring 1990
%      Modified by D.Thomas 5/21/93

x=x(:); nx=length(x); nd=length(xdat); xd=xdat(1:nd-1);
%indx=zeros(x); for j=1:nx, indx(j)=sum(x(j)>=xdat); end
indx=x*0; for j=1:nx, indx(j)=sum(x(j)>=xdat); end %DT
indx=indx+(indx==0);
