function cplot(z,wsiz)
% cplot(z,wsiz)
% Plot complex array z undistorted in a square window. If the
% vector wsiz is present, it is used to set the window size.
% Otherwise, the z array is examined to set the window.

%     H.B.Wilson, Spring 1989
[nrow,ncol]=size(z);
if nargin==1,  rl=real(z(:)); img=imag(z(:));
  xmin=min(rl); xmax=max(rl); ymin=min(img); ymax=max(img);
else
 xmin=wsiz(1); xmax=wsiz(2); ymin=wsiz(3); ymax=wsiz(4);
end
w=max((xmax-xmin),(ymax-ymin))*.5;
xc=.5*(xmin+xmax); yc=.5*(ymin+ymax);
v=[xc-w,xc+w,yc-w,yc+w]; axis(v), axis('square')
if ncol>1
for i=1:nrow, plot(real(z(i,:)),imag(z(i,:)),'-'),hold on, end;
end
if nrow>1
for j=1:ncol, plot(real(z(:,j)),imag(z(:,j)),'-'),hold on, end;
end
hold off; axis('normal');
