function c=dvdcof(x,y)
% This function uses divided differences to compute
% coefficients c needed to perform polynomial using the
% Newton form of the interpolating polynomial. The data
% values used are x(i),y(x), i=1:n. See for reference
% "Elementary Numerical Analysis" by S. Conte and C. de Boor
n=length(x);
for k=1:(n-1), for i=1:(n-k)
    y(i)=(y(i+1)-y(i))./(x(i+k)-x(i));
end, end, c=y;
