% RIOTS optimal control toolbox.
% Version 1.1a
% 
%   aug_lagrng     - Solve problems with equality constraints and 
%                    simple bounds.
%   check_deriv    - Check derivatives of user-supplied functions.
%   check_grad     - Check gradient computed by simulate().
%   control_error  - Estimate control solution error from 
%                    solutions on different meshes.
%   distribute     - Mesh refinements strategies and control interpolation. 
%   est_errors     - Computes integration error and function space norm
%                    of the augmented Lagrangian used by control_error().
%   outer          - Example of an outer loop for riots() that adjusts the
%                    mesh after each call to riots() in order to achieve a
%                    specified control error tolerance.
%   pdmin          - Solve problems with simple bounds.
%   riots          - Solve general constraint problems.
%   simulate       - Simulate system, compute gradients, interface to system.
%   sp_plot        - Plot control splines.
%   transform      - Compute spline transform matrix.
%   RIOTS_demo     - List of various RIOTS demonstrations.

%
% Copyright (c) 1996 by Adam L. Schwartz
% All right reserved.  
%
