% RIOTS_demo     Before using this demo, all RIOTS programs as well as 
%                the sample optimal control systems must be compiled
%                and ready to link.  Follow the directions on compiling
%                and linking given in the appendix of the RIOTS user's
%		 manual and the file README.
%
%                You should go through these demos in order.
%		 Demos 3, 4 and 6 only work if riots() is linked with NPSOL.
%
%                Demos 3 and 5 require LSODA.
%
%                List of RIOTS demonstrations:
%                -----------------------------
%                1) System simulation, gradients, plotting.
%                2) Solving optimal control problems.
%                3) Solving a singular control problem.
%                4) Mesh redistribution.
%                5) Integration and control solution error estimation.
%		 6) Warm starts.
%
%                0) Quit.

% adapted from Carl de Boor's spdemos.m adaption of JNL's demos.m for Matlab.
%
% Copyright (c) 1996 by Adam L. Schwartz
% All right reserved.  
%

echo off
clear
Plotted = 0;
while 1
    demos= ['RIOTSdem1'
            'RIOTSdem2'
            'RIOTSdem3'
            'RIOTSdem4'
            'RIOTSdem5'
	    'RIOTSdem6'];
    echo off
    clc
    help RIOTS_demo
    n = input('Select a demo number: ');
    if ( (n > 0) & (n <= size(demos,1)) )
      demos = demos(n,:);
      eval(demos)
      Plotted = 1;
    elseif n == 0
      break
    end
end
echo off
if Plotted, 
  subplot(1,1,1)
  legend off
  set(gca,'xtickmode','auto')
end
clc
