% This function computes values of the nominal trajectory for plantc.
% User must have nominal_t and nominal_x defined as global variables
% in Matlab's workspace.

function f = sys_time_fnc(t)

global nominal_t nominal_x;
if nominal_t == [] | nominal_x == [],
   error('Have to define global variables nominal_t and nominal_x.')
end
	
time  = t(1);
index = t(2);
flag  = t(3);

t1 = nominal_t(index); t2 = nominal_t(index+1);
dT = t2-t1;
a = (t2-time)/dT; b = (time-t1)/dT;

f = nominal_x(1:6,index)*a + nominal_x(1:6,index+1)*b;
