function q = bodst3(p,R)
%BODST3   Hilfsfunktion fuer bod.m
%         q = bodst3(p,R)
% notwendig bei Stoeroptimierung digitaler PID-Regler mit dem Digitalen Be-
% tragsoptimum (BOD); Vorbereitung von fsolve, Def.: p=[x=V0 y=V0*d1 z=V0*d2]

% SCHLUESSELWORTE: Hilfsfile

%  Copyright (c) 1992 Dr. Gert-Helge Geitner; TU Dresden, Fak. ET,
%                     Elektrotechnisches Institut (ETI); Mommsenstr. 13;
%                     D-01062 Dresden, Germany;
%                     Tel./Fax (0351)-463-2917/7280
%                     e-mail: geitner@eeiwzb.et.tu-dresden.de
%  Literatur zum Digitalen Betragsoptimum: Geitner, G.-H.:
%                     Entwurf digitaler Regler fr elektrische Antriebe.
%                     VDE-Verlag GmbH Berlin und Offenbach 1995

x = p(1); y = p(2); z = p(3);
q = zeros(3,1);
q(1)=R(1,1)+x*R(1,2)+y*R(1,3)+z*R(1,4)+y*(x+z)*(R(1,6)-R(1,5))...
                                      +x*z*(R(1,7)-R(1,5));
q(2)=R(2,1)+x*R(2,2)+y*R(2,3)+z*R(2,4)+y*(x+z)*(R(2,6)-R(2,5))...
                                      +x*z*(R(2,7)-R(2,5));
q(3)=R(3,1)+x*R(3,2)+y*R(3,3)+z*R(3,4)+y*(x+z)*(R(3,6)-R(3,5))...
                                      +x*z*(R(3,7)-R(3,5));
