function K=kmatrix(Z,S)
%KMATRIX  Wichtungsfaktoren fuer das Optimierungsgleichungssystem nach (BOD)
%         K=kmatrix(Z,S)
% BOD: Digitales Betragsoptimum - vgl. unten angegebene Literaturstelle
%      Gleichung 3.11 und Tabelle 3.1; S: Spaltenanzahl; Z: Zeilenanzahl

% SCHLUESSELWORTE: Digitales Betragsoptimum, Wichtungsfaktoren

%  Copyright (c) 1995 Dr. Gert-Helge Geitner; TU Dresden, Fak. ET,
%                     Elektrotechnisches Institut (ETI); Mommsenstr. 13;
%                     D-01062 Dresden, Germany;
%                     Tel./Fax (0351)-463-2917/7280
%                     e-mail: geitner@eeiwzb.et.tu-dresden.de
%  Literatur zum Digitalen Betragsoptimum: Geitner, G.-H.:
%                     Entwurf digitaler Regler fr elektrische Antriebe.
%                     VDE-Verlag GmbH Berlin und Offenbach 1995

for i=1:Z
 for j=1:S
  if     i==1         K(i,j)=j^2;
  else   if j==1      K(i,j)=0;
	 elseif  j==2 K(i,j)=K(i,j-1)+K(i-1,j-1);
	 elseif  j==3 K(i,j)=K(i,j-1)+K(i,j-2)+K(i-1,j-1)+K(i-1,j-2);
	 else         K(i,j)=K(i,j-1)+K(i,j-2)-K(i,j-3)+K(i-1,j-1)+K(i-1,j-2);
end; end; end; end
