function [hiv] = vaib(maxi,mini,zei,siz,Kz,Ks)
%VAIB     Hilfsfunktion fuer vobo.m und bod.m
%         [hiv] = vaib(maxi,mini,zei,siz,Kz,Ks)
% Verwendung zur Regleroptimierung nach dem Digitalen Betragsoptimum. Vorbe-
% reitung fuer allg. Indexberechnung und Ordnungsueberpruefung der K-Matrix

% SCHLUESSELWORTE: Hilfsfile

%  Copyright (c) 1992 Dr. Gert-Helge Geitner; TU Dresden, Fak. ET,
%                     Elektrotechnisches Institut (ETI); Mommsenstr. 13;
%                     D-01062 Dresden, Germany;
%                     Tel./Fax (0351)-463-2917/7280
%                     e-mail: geitner@eeiwzb.et.tu-dresden.de
%  Literatur zum Digitalen Betragsoptimum: Geitner, G.-H.:
%                     Entwurf digitaler Regler fr elektrische Antriebe.
%                     VDE-Verlag GmbH Berlin und Offenbach 1995

if (mini<0)
   hiv (-mini)=0;
end
hiv (1-mini)=1;
for i=1:siz(zei,2)
    hiv (1-mini+i)=siz(zei,2+i);
end
hiv (maxi+1-mini)=0;  % Vorsicht: Wenn Vektorordnung nicht ohnehin ber-
                      % schritten wird, extern maxi:=maxi+1 ntig !!!
if (Kz>5)
   error ('Zeilendimension der K-Matrix berschritten')
end
if (Ks>8)
   error ('Spaltendimension der K-Matrix berschritten')
end
