function [J,nfun]=bod_esp(p,a_o,b_o,c_o,d_o,EZW,QQ,BMEA,ZVe,NVe,NV)
%BOD_ESP  Hilfsfile fr bod_es.m - Struktur im Z-Bereich optimieren
%         [J,nfun]=bod_esp(p,a_o,b_o,c_o,d_o,EZW,QQ,BMEA,ZVe,NVe,NV)
%         Definition von Strecken- und Regelstruktur erfolgt in einem
%         File strucxxx.m (Beispiel: struc000.m)
%	  Hier: Berechnung partieller Ableitungen - nur anwendbar bei Para-
%		meterprodukten mit Potenzen <= 4

%  SCHLUESSELWORTE: Digitales Betragsoptimum, Optimierung im Z-Bereich
%                   Hilfsfile fr bod_es

%  Copyright (c) 1996 Dr. Gert-Helge Geitner; TU Dresden, Fak. ET,
%                     Elektrotechnisches Institut (ETI); Mommsenstr. 13;
%                     D-01062 Dresden, Germany;
%                     Tel./Fax ++49-351-463-2917/7280
%                     e-mail: geitner@eeiwzb.et.tu-dresden.de

%Auspacken der wegen fsolve eingepackten bergabeargumente
 BRF=EZW(1,1); MAU=EZW(1,2); TAZ=EZW(1,3); iS=EZW(1,4);
 knr=EZW(1,5);                       % Anzahl schon vorhandener Ergebnisse
 for i=1:knr KZV_o(i)=EZW(2,i); end; % KZV_o entspricht erg
 [i,j]=size(BMEA);j=j/2;BME(:,1:j)=BMEA(:,1:j);BMA(:,1:j)=BMEA(:,j+1:2*j);


KZV_o(MAU)=0;	  % "Rest" der Koeffizienten zunchst mit Nullen auffllen
for i=1:TAZ
    KZV_o(knr+i)=p(i); % fsolve-Zwischenergebnisse; KZV_o: Originalwert
end
J(TAZ,TAZ)=0;          % Ordnung Ergebnismatrix setzen
KZV_s=[1 -1 2 -2 3 -3];% Setzwerte
for u=1:TAZ            % TAZ-partielle Ableitungen pro Gleichung
    q=zeros(6,TAZ);    % Vorbereitung der q(ii)-Berechnung fr fsolve
		       % Handbuch S.3-87 falscher Aufbau der Jacobimatrix
    KZV=KZV_o;
    for w=1:6          % f(x=1);f(x=-1);f(x=2);f(x=-2);f(x=3);f(x=-3);
        KZV(knr+u)=KZV_s(w);
 	a=a_o; b=b_o; c=c_o; d=d_o;
        				    % Algorithmusbeginn
%Namen-Vektor der Reglerparameter auspacken und Werte zuordnen:
 i=0; n0=0; k=length(NV);
 while i<k n0=n0+1; i=i+1; j=1; vtext=0;     %i um "2" erhhen wegen: "; "
       while NV(i)~=';' vtext(j)=NV(i); i=i+1; j=j+1; end
       eval([vtext '=KZV(' num2str(n0) ');']); i=i+1; end

%Zhler-Vektoren der einzelnen Blcke auspacken
 i=0; n1=0; k=length(ZVe);
 while i<k n1=n1+1; i=i+1; j=1; vtext=0;
       while ZVe(i)~=';'  vtext(j)=ZVe(i); i=i+1;  j=j+1; end
       eval(['rz' num2str(n1) '=' vtext ';']); end

%Nenner-Vektoren der einzelnen Blcke auspacken
 i=0; n=0; k=length(NVe);
 while i<k n=n+1; i=i+1; j=1; vtext=0;
       while NVe(i)~=';'  vtext(j)=NVe(i); i=i+1;  j=j+1; end
       eval(['rn' num2str(n) '=' vtext ';']); end

%Unverbundenes Diagonalsystem erzeugen:
for i=1:n
    RZ=eval(['rz' num2str(i)]);RN=eval(['rn' num2str(i)]);
    zl=length(RZ); nl=length(RN); if nl<zl RN(zl)=0; end    % wegen tf2ss
    [at,bt,ct,dt]=tf2ss(RZ,RN);
    [a,b,c,d]=append(a,b,c,d,at,bt,ct,dt); end

%Verbundenes System berechnen
 [ac,bc,cc,dc]=connect(a,b,c,d,QQ,BME(iS,BRF),BMA(iS,BRF));
 [acm,bcm,ccm,dcm]=minreal1(ac,bc,cc,dc);  %Unbedingt notwendig !!!
 [a,b]=ss2tf(acm,bcm,ccm,dcm);

% berprfung der Berechenbarkeit
  oz=length(a); on=length(b);   % Ordnung von Zhler und Nenner
  o=max(oz,on);			% Absicherung gegen Nennerpolynomnherungen
  if oz>on b(oz)=0; elseif on>oz a(on)=0; end
  Z=TAZ;			% Zeilenanzahl fr K-Matrix
  S=o-1;			% Spaltenanzahl fr K-Matrix
  if TAZ>=o disp('Warnung: Ordnung<Anzahl Unbekannte!')
     a(TAZ+1)=0; b(TAZ+1)=0; o=TAZ+1;
  end

% if u==1&w==1                 % S(f(x=1)); K-Matrix nur einmal berechnen
%Berechnung der K-Matrix: Spalten=S; Zeilen=Z
for i=1:Z
 for j=1:S
  if     i==1         K(i,j)=j^2;
  else   if j==1      K(i,j)=0;
	 elseif  j==2 K(i,j)=K(i,j-1)+K(i-1,j-1);
	 elseif  j==3 K(i,j)=K(i,j-1)+K(i,j-2)+K(i-1,j-1)+K(i-1,j-2);
	 else         K(i,j)=K(i,j-1)+K(i,j-2)-K(i,j-3)+K(i-1,j-1)+K(i-1,j-2);
end; end; end; end; % end

for ii=1:TAZ
    for i=ii:(o-1), x=0;
        for j=1:(o-i)
            x = x + a(j) * a(j+i) - b(j) * b(j+i);  end
        q(w,ii) = q(w,ii) + x * K(ii,i);  end; end
					% Algorithmusende
	    end

D(1,:)=q(1,:)-q(2,:); D(2,:)=q(1,:)+q(2,:);
D(3,:)=q(3,:)-q(4,:); D(4,:)=q(3,:)+q(4,:); D(6,:)=q(5,:)+q(6,:);
D(5,:)=D(6,:)-D(2,:); D(6,:)=D(6,:)-D(4,:);
PK(1,:)=(8*D(1,:)-D(3,:))/12; PK(2,:)=13/24*D(5,:)-2/3*D(6,:);
PK(3,:)=(D(3,:)-2*D(1,:))/4;  PK(4,:)=(D(5,:)-1.6*D(6,:))/92;
J(u,:)=PK(1,:)+PK(2,:)*KZV_o(knr+u)+...
       PK(3,:)*KZV_o(knr+u)^2+PK(4,:)*KZV_o(knr+u)^3;
end
nfun=TAZ^2;				% wegen Def. MATLAB-HB S.3-87


%J(u,:)=J(u,:)+(2*w-3)*q(1,:);   % -f(x=1)+f(x=2)
