function [ZVe,NVe,Q,IN,OU,MT,NV,BRF]=struc999(SOR,OU,P1,P2)
%STRUC999 Formularfile zur Strukturdefinition fr bod_es.m
%         Zur Erluterung der Definitionen siehe struc000.m
%ANWENDUNG:- Dieses File kopieren und dabei "999" im Namen sowie fileintern
%            durch eine dreistellige Zahl ersetzen.
%          - Zwischen den mit %****** eingerahmten Stellen die jeweilige
%            Strecken- und Regelstruktur definieren.
%          - Die Zeilen 2 bis 10 dieses Files streichen und durch Kurzbe-
%            schreibung der betrachteten Struktur ersetzen.
%          - Den neuen Filenamen bei Aufruf von bod_es verwenden

%HILFSFILE zur symbolischen Definition - kein selbstndiger Aufruf !!!
%	  SOR: Schalter - zur Auswahl der Strecken oder Regelstruktur
%	  OU:  Vektor mit fortlaufenden Nummern der Ausgnge der diskreti-
%              sierten Streckenzustandsdarstellung
%         P1,P2: Parameterweitergabemglichkeit ber bod_es.m

% SCHLUESSELWORTE: Digitales Betragsoptimum, Symbolische Strecken-
%                  und Regel-Strukturdefinition fr bod_es/bod_esg

%  Copyright (c) 1996 Dr. Gert-Helge Geitner; TU Dresden, Fak. ET,
%                     Elektrotechnisches Institut (ETI); Mommsenstr. 13;
%                     D-01062 Dresden, Germany;
%                     Tel./Fax ++49-351-463-2917/7280
%                     e-mail: geitner@eeiwzb.et.tu-dresden.de
%  Literatur zum Digitalen Betragsoptimum: Geitner, G.-H.:
%                     Entwurf digitaler Regler fr elektrische Antriebe.
%                     VDE-Verlag GmbH Berlin und Offenbach 1996

if SOR==0  %Streckendefinition

% ****** Beginn ******
  sz1=';';           sn1=';';
   .                  .
   .                  .
  szx=';';           snx=';';
   Q=[];
  IN=[];             OU=[];
  MT=[];
  NV=['; '];
% ****** Ende ******

s=0; zae=0; ZVe=[]; NVe=[]; BRF=0;
while s==0 zae=zae+1;  eval(['ZVe=[ZVe sz' num2str(zae) '];'],'s=1;');
                       eval(['NVe=[NVe sn' num2str(zae) '];'],'s=1;'); end

else  %Regelstrukturdefinition

% ****** Beginn ******
  rzy=';';           rny=';';
   .                  .
   .                  .
  rzz=';';           rnz=';';
   QQ=[];
  BME=[];
  BMA=[];
  BM=[0];
  BRF=[];
  NV=['; '];
% ****** Ende ******

s=0; zae=length(OU); ZVe=[]; NVe=[];
while s==0 zae=zae+1;  eval(['ZVe=[ZVe rz' num2str(zae) '];'],'s=1;');
                       eval(['NVe=[NVe rn' num2str(zae) '];'],'s=1;'); end
Q=QQ;IN=BME;OU=BMA;MT=BM;
end

