function [ZVe,NVe,Q,IN,OU,MT,NV,BRF]=struc001(SOR,OU,P1,P2)
%STRUC001 K(2S):  Par=[VS1 T1 VS2 T2 T3];  Reg=[VR1 d11 VR2 d21 d22];
%         Zweischleifige Kaskadenstruktur - Unverzgerte Eingangssignale;
%         Beispiel nach Abschnitt 5.4 in "Entwurf digitaler Regler fr
%         elektrische Antriebe", Geitner, VDE-Verlag 1996;
%	  Struktur und Simulation siehe SIST001; Aufbau:
%         Innen: PI-Regler,  1 Verzgerungsglied
%	  Auen: PID-Regler, 2 Verzgerungsglieder

%HILFSFILE zur symbolischen Definition - kein selbstndiger Aufruf !!!
%	  SOR: Schalter - zur Auswahl der Strecken oder Regelstruktur
%	  OU:  Vektor mit fortlaufenden Nummern der Ausgnge der diskreti-
%              sierten Streckenzustandsdarstellung
%         P1,P2: Parameterweitergabemglichkeit ber bod_es.m

% SCHLUESSELWORTE: Digitales Betragsoptimum, Symbolische Strecken-
%                  und Regel-Strukturdefinition fr bod_es/bod_esg

%  Copyright (c) 1996 Dr. Gert-Helge Geitner; TU Dresden, Fak. ET,
%                     Elektrotechnisches Institut (ETI); Mommsenstr. 13;
%                     D-01062 Dresden, Germany;
%                     Tel./Fax ++49-0351-463-2917/7280
%                     e-mail: geitner@eeiwzb.et.tu-dresden.de
%  Literatur zum Digitalen Betragsoptimum: Geitner, G.-H.:
%                     Entwurf digitaler Regler fr elektrische Antriebe.
%                     VDE-Verlag GmbH Berlin und Offenbach 1996

if SOR==0  %Streckendefinition

%****** Beginn
%

sz1='VS1;';   sn1='[T1 1];';
sz2='VS2;';   sn2='conv([T2 1],[T3 1]);';
 Q=[1 0
    2 1]; IN=[1]; OU=[1 2];
 MT=[0 1
     0 1];
 NV=['VS1; T1; VS2; T2; T3; '];
%****** Ende

s=0; zae=0; ZVe=[]; NVe=[]; BRF=0;
while s==0 zae=zae+1;  eval(['ZVe=[ZVe sz' num2str(zae) '];'],'s=1;');
                       eval(['NVe=[NVe sn' num2str(zae) '];'],'s=1;'); end

else  %Regelstrukturdefinition

%****** Beginn

rz3='VR1*[1 d11];';               rn3='[1 -1];';
rz4='VR2*[1 d21 d22];';           rn4='[1 -1];';
QQ=[1  3  0
    2  3  0
    3  4 -1
    4 -2  0];
BME=[3
     4];
BMA=[1
     2];
 BM=[2
     3
     0];  BRF=1;
NV=['VR1; d11; VR2; d21; d22; '];
%****** Ende

s=0; zae=length(OU); ZVe=[]; NVe=[];
while s==0 zae=zae+1;  eval(['ZVe=[ZVe rz' num2str(zae) '];'],'s=1;');
                       eval(['NVe=[NVe rn' num2str(zae) '];'],'s=1;'); end
Q=QQ;IN=BME;OU=BMA;MT=BM;
end
