function [ZVe,NVe,Q,IN,OU,MT,NV,BRF]=struc012(SOR,OU,P1,P2)
%STRUC012 E(Buch:Bei2/Ab3-F/PID): Par=[VS T1 T2];   Reg=[VR VRd1 VRd2];
%         Einzelregelkreis - unverzgerte Eingangssignale
%         Beispiel 2 / Abschnitt 3 in "Entwurf digitaler Regler fr
%         elektrische Antriebe", Geitner, VDE-Verlag 1996;
%	  Struktur und Simulation siehe SIST010; Aufbau:
%         PID-Regler, 2 Verzgerungsglieder,

%HILFSFILE zur symbolischen Definition - kein selbstndiger Aufruf !!!
%	  SOR: Schalter - zur Auswahl der Strecken oder Regelstruktur
%	  OU:  Vektor mit fortlaufenden Nummern der Ausgnge der diskreti-
%              sierten Streckenzustandsdarstellung
%         P1,P2: Parameterweitergabemglichkeit ber bod_es.m

% SCHLUESSELWORTE: Digitales Betragsoptimum, Symbolische Strecken-
%                  und Regel-Strukturdefinition fr bod_es/bod_esg

%  Copyright (c) 1996 Dr. Gert-Helge Geitner; TU Dresden, Fak. ET,
%                     Elektrotechnisches Institut (ETI); Mommsenstr. 13;
%                     D-01062 Dresden, Germany;
%                     Tel./Fax ++49-0351-463-2917/7280
%                     e-mail: geitner@eeiwzb.et.tu-dresden.de
%  Literatur zum Digitalen Betragsoptimum: Geitner, G.-H.:
%                     Entwurf digitaler Regler fr elektrische Antriebe.
%                     VDE-Verlag GmbH Berlin und Offenbach 1996

if SOR==0  %Streckendefinition

% ****** Beginn

sz1='VS;';  sn1='conv([T1 1],[T2 1]);';
 Q=[1 0]; IN=[1]; OU=[1];
 MT=[0 1];
 NV=['VS; T1; T2; '];
% ****** Ende

s=0; zae=0; ZVe=[]; NVe=[]; BRF=0;
while s==0 zae=zae+1;  eval(['ZVe=[ZVe sz' num2str(zae) '];'],'s=1;');
                       eval(['NVe=[NVe sn' num2str(zae) '];'],'s=1;'); end

else  %Regelstrukturdefinition

% ******* Beginn

rz2='[VR VRd1 VRd2];';           rn2='[1 -1];';
QQ=[1  2
    2 -1];
BME=[2];
BMA=[1];
 BM=[3
     0];  BRF=1;
NV=['VR; VRd1; VRd2; '];
%****** Ende

s=0; zae=length(OU); ZVe=[]; NVe=[];
while s==0 zae=zae+1;  eval(['ZVe=[ZVe rz' num2str(zae) '];'],'s=1;');
                       eval(['NVe=[NVe rn' num2str(zae) '];'],'s=1;'); end
Q=QQ;IN=BME;OU=BMA;MT=BM;
end
