function [ZVe,NVe,Q,IN,OU,MT,NV,BRF]=struc020(SOR,OU,P1,P2)
%STRUC020 Z(bran): Par=[Tel TM TF TL]; Reg=[Kd Km Kn];
%         Zustandsregelstruktur nach Brandenburg at 35(1987)7, S.275/83
%	  Struktur und Simulation siehe SIST020; Hinweis: KL=-(1+K2)

%HILFSFILE zur symbolischen Definition - kein selbstndiger Aufruf!!!
%	  SOR: Schalter - zur Auswahl der Strecken oder Regelstruktur
%	  OU:  Vektor mit fortlaufenden Nummern der Ausgnge der diskreti-
%              sierten Streckenzustandsdarstellung
%         P1,P2: Parameterweitergabemglichkeit ber bod_es.m

% SCHLUESSELWORTE: Digitales Betragsoptimum, Symbolische Strecken-
%                  und Regel-Strukturdefinition fr bod_es/bod_esg

%  Copyright (c) 1996 Dr. Gert-Helge Geitner; TU Dresden, Fak. ET,
%                     Elektrotechnisches Institut (ETI); Mommsenstr. 13;
%                     D-01062 Dresden, Germany;
%                     Tel./Fax ++49-0351-463-2917/7280
%                     e-mail: geitner@eeiwzb.et.tu-dresden.de
%  Literatur zum Digitalen Betragsoptimum: Geitner, G.-H.:
%                     Entwurf digitaler Regler fr elektrische Antriebe.
%                     VDE-Verlag GmbH Berlin und Offenbach 1996

if SOR==0  %Streckendefinition

% ****** Beginn
 sz1='1;';			sn1='[Tel 1];';
 sz2='1;';			sn2='[TM 0];';
 sz3='1;';			sn3='1;';
 sz4='1;';			sn4='[TF 0];';
 sz5='1;';			sn5='[TL 0];';
 Q=[1 0  0
    2 1 -4
    3 2 -5
    4 3  0
    5 4  0]; IN=[1]; OU=[2 5 3 4];
 MT=[0 1
     0 1
     0 1
     0 1];
 NV=['Tel; TM; TF; TL; '];
% ****** Ende

s=0; zae=0; ZVe=[]; NVe=[]; BRF=0;
while s==0 zae=zae+1;  eval(['ZVe=[ZVe sz' num2str(zae) '];'],'s=1;');
                       eval(['NVe=[NVe sn' num2str(zae) '];'],'s=1;'); end

else  %Regelstrukturdefinition

%******* Beginn
 rz5='Kd;';              rn5='1;';
 rz6='Km;';              rn6='1;';
 rz7='Kn;';              rn7='1;';

QQ=[1 -5 -6 7
    2 -5 -6 7
    3 -5 -6 7
    4 -5 -6 7
    5  3  0 0
    6  4  0 0
    7 -1  0 0];
BME=[1 1
     7 7];
BMA=[4 4
     1 2];
 BM=[2 2
     1 1
     0 0];  BRF=2;
NV=['Kd; Km; Kn; '];
%****** Ende

s=0; zae=length(OU); ZVe=[]; NVe=[];
while s==0 zae=zae+1;  eval(['ZVe=[ZVe rz' num2str(zae) '];'],'s=1;');
                       eval(['NVe=[NVe rn' num2str(zae) '];'],'s=1;'); end
Q=QQ;IN=BME;OU=BMA;MT=BM;
end
