function [ZVe,NVe,Q,IN,OU,MT,NV,BRF]=struc031(SOR,OU,P1,P2)
%STRUC031 E(Totz./Vo/R-F/PI): Par=[VS TM TSu];Reg=[VR d1];P1=m;P2=[T1 T2]
%         Einzelregelkreis mit Totzeiten in Vor- und Rckwrtszweig,
%         unverzgerte Eingangssignale; Aufbau:
%             Vorwrts: PI-Regler, Zeitverschiebung(m)<T, ganzzahlige Tot-
%                       zeit(T1), 2 Verzgerungsglieder, Mittelwertmessung
%             Rckwrts: ganzzahlige Totzeit(T2)
%             >>>Nutzung einer mglichen Parameterbergabe an strucxxx.m<<<
%		 P1=m      echte Zeitverschiebung (vorwrts)
%                P2(1)=T1  ganzzahlige Zeitverschiebung (vorwrts)
%                P2(2)=T2  ganzzahlige Zeitverschiebung (rckwrts)
%	      Anwendung: Berechnung einer mittleren Reglereinstellung bei
%			 Einsatz eines Bussystems - unverz. Eingangssignale
%	      Simulation: SIST031 fr mittlere Reglereinstellung

%HILFSFILE zur symbolischen Definition - kein selbstndiger Aufruf !!!
%	  SOR: Schalter - zur Auswahl der Strecken oder Regelstruktur
%	  OU:  Vektor mit fortlaufenden Nummern der Ausgnge der diskreti-
%              sierten Streckenzustandsdarstellung
%         P1,P2: Parameterweitergabemglichkeit ber bod_es.m

% SCHLUESSELWORTE: Digitales Betragsoptimum, Symbolische Strecken-
%                  und Regel-Strukturdefinition fr bod_es/bod_esg

%  Copyright (c) 1996 Dr. Gert-Helge Geitner; TU Dresden, Fak. ET,
%                     Elektrotechnisches Institut (ETI); Mommsenstr. 13;
%                     D-01062 Dresden, Germany;
%                     Tel./Fax ++49-0351-463-2917/7280
%                     e-mail: geitner@eeiwzb.et.tu-dresden.de
%  Literatur zum Digitalen Betragsoptimum: Geitner, G.-H.:
%                     Entwurf digitaler Regler fr elektrische Antriebe.
%                     VDE-Verlag GmbH Berlin und Offenbach 1996

if SOR==0  %Streckendefinition

% ****** Beginn
  sz1='VS;';			sn1='[TM 1];';
  sz2='1;';			sn2='[TSu 1];';

 Q=[1 0
    2 1]; IN=[1]; OU=[2];
 MT=[P1 2];			% Parameter P1 = echte Zeitverschiebung
 NV=['VS; TM; TSu; '];
% ****** Ende

s=0; zae=0; ZVe=[]; NVe=[]; BRF=0;
while s==0 zae=zae+1;  eval(['ZVe=[ZVe sz' num2str(zae) '];'],'s=1;');
                       eval(['NVe=[NVe sn' num2str(zae) '];'],'s=1;'); end

else  %Regelstrukturdefinition

%******* Beginn
 rz2='VR*[1 d1];';                      rn2='[1 -1];';
 rz3='[';
    for i=1:P2(1) rz3=[rz3,'0 ']; end   %P2(1)=ganzzahlige Zeitverschiebung
    rz3=[rz3,'1];'];                    rn3='1;';
 rz4='[';
    for i=1:P2(2) rz4=[rz4,'0 ']; end   %P2(2)=ganzzahlige Zeitverschiebung
    rz4=[rz4,'1];'];                    rn4='1;';

QQ=[1  3
    2 -4
    3  2
    4  1];
BME=[2]'; BMA=[1]'; BRF=1; BM=[2 0]';
NV=['VR; d1; '];
%****** Ende


s=0; zae=length(OU); ZVe=[]; NVe=[];
while s==0 zae=zae+1;  eval(['ZVe=[ZVe rz' num2str(zae) '];'],'s=1;');
                       eval(['NVe=[NVe rn' num2str(zae) '];'],'s=1;'); end
Q=QQ;IN=BME;OU=BMA;MT=BM;
end
