function [ZVe,NVe,Q,IN,OU,MT,NV,BRF]=struc041(SOR,OU,P1,P2)
%STRUC041 E(3 PT1): Par=[TN1 TN2 TN3]; Reg=F-ni./St-ausge.; P2=[F/St Re];
%         Einzelregelkreis mit Berechnungsumschaltung
%	            P2(1): Umschaltung Fhrungs- (0) / Stroptimierung (1)
%                   P2(2): Umschaltung PI- (0) / PID-Regler (1)
%         Struktur und Simulation mit SIST041;
%         Strecken-Aufbau: 3 Verzgerungsglieder

%HILFSFILE zur symbolischen Definition - kein selbstndiger Aufruf !!!
%	  SOR: Schalter - zur Auswahl der Strecken oder Regelstruktur
%	  OU:  Vektor mit fortlaufenden Nummern der Ausgnge der diskreti-
%              sierten Streckenzustandsdarstellung
%         P1,P2: Parameterweitergabemglichkeit ber bod_es.m

% SCHLUESSELWORTE: Digitales Betragsoptimum, Symbolische Strecken-
%                  und Regel-Strukturdefinition fr bod_es/bod_esg

%  Copyright (c) 1996 Dr. Gert-Helge Geitner; TU Dresden, Fak. ET,
%                     Elektrotechnisches Institut (ETI); Mommsenstr. 13;
%                     D-01062 Dresden, Germany;
%                     Tel./Fax ++49-0351-463-2917/7280
%                     e-mail: geitner@eeiwzb.et.tu-dresden.de
%  Literatur zum Digitalen Betragsoptimum: Geitner, G.-H.:
%                     Entwurf digitaler Regler fr elektrische Antriebe.
%                     VDE-Verlag GmbH Berlin und Offenbach 1996

if SOR==0  %Streckendefinition

% ****** Beginn
    sz1='1;';  sn1='conv(conv([TN1 1],[TN2 1]),[TN3 1]);';
    Q=[1 0];   IN=[1];   OU=[1];
    MT=[0 1];
    NV=['TN1; TN2; TN3; '];
% ****** Ende

s=0; zae=0; ZVe=[]; NVe=[]; BRF=0;
while s==0 zae=zae+1;  eval(['ZVe=[ZVe sz' num2str(zae) '];'],'s=1;');
                       eval(['NVe=[NVe sn' num2str(zae) '];'],'s=1;'); end

else  %Regelstrukturdefinition

%******* Beginn
rn2='[1 -1];';             % Definitionen fr alle Varianten
BMA=[1]; BRF=1;
if P2(1)==0                % Def. fr unverzgertes Eingangssignal
   QQ=[1  2
       2 -1];
   BME=[2];
   if P2(2)==0	           % Def. fr unv. Eing. und PI-Regler
       rz2='[VR VRd1];';
       BM=[2
           0];
       NV=['VR; VRd1; '];
   else		           % Def. fr unv. Eing. und PID-Regler
       rz2='[VR VRd1 VRd2];';
       BM=[3
           0];
       NV=['VR; VRd1; VRd2; '];
   end
else                        % Def. fr verzgertes Eingangssignal
   QQ=[1  2 0
       2 -1 3
       3  0 0];
   BME=[3];
   if P2(2)==0	            % Def. fr ver. Eing. und PI-Regler
       rz2='VR*[1 d1];';
       rz3='(1+d1);';       rn3='[1 d1];';
       BM=[2
           0];
       NV=['VR; d1; '];
   else		            % Def. fr ver. Eing. und PID-Regler
       rz2='VR*[1 d1 d2];';
       rz3='(1+d1+d2);';    rn3='[1 d1 d2];';
       BM=[3
           0];
       NV=['VR; d1; d2; '];
   end
end
%****** Ende

s=0; zae=length(OU); ZVe=[]; NVe=[];
while s==0 zae=zae+1;  eval(['ZVe=[ZVe rz' num2str(zae) '];'],'s=1;');
                       eval(['NVe=[NVe rn' num2str(zae) '];'],'s=1;'); end
Q=QQ;IN=BME;OU=BMA;MT=BM;
end
