%
%  Function fresponse
%
%  Calculates the frequency response of a SISO transfer function
%  and returns a vector of complex numbers (rather than magnitude
%  and phase).
%
%   Written by Jesse Leitner
%   PhD Student/Graduate Research Assistant/Teaching Assistant
%   School of Aerospace Engineering
%   Georgia Tech
%   Atlanta, Georgia  30332-0150
%   Phone (404) 894-2995
%   Email:  leitner@iscl1.gatech.edu
%
%function comp=fresponse(num,den,w)
function comp=fresponse(num,den,w)
%Calculates frequency response (complex number) of
%a SISO transfer function for range of frequencies, w
%(Mainly for use with buildvar routine)
%
jay=sqrt(-1);
for i=1:length(w)
        w(i)=jay*w(i);
        comp(i)=polyval(num,w(i))/polyval(den,w(i));
end
comp=comp';
