function co = lctrb(a,b)
%LCTRB   Linear controllability matrix.
%        CO = LCTRB(A,B)  returns the controllability matrix of the system:
%
%             px = Ax + Bu
%              y = Cx + Du
%
%        such that the columns are linearly independent.


%        P.Thind.
%        7/89

    error(nargchk(2,2,nargin));
    error(abcdchk(a,b));

    [ra,ca] = size(a);
    co = b;
    for i=1:ca-1
            co = [b a*co];
    end
    [r_co,c_co] = size(co);
    rw_reduce_co = rref(co);
    rw_ones = ones(1,c_co);
    rw_zeros = zeros(1,c_co);
    detect_mat = zeros(r_co,c_co);
    i = 1;
    for j = 1:r_co
        detect_mat(i,:) = rw_zeros;
        i = j;
        detect_mat(j,:) = rw_ones;
        result = rw_reduce_co - detect_mat;
        for k = 1:c_co
            if ~any(result(:,k))
                ctrl = [ctrl,co(:,k)];
                break
            end
        end
    end
    co = ctrl;

