function ob = lobsv(a,c)
%LOBSV   Linear observability matrix.
%        OB = LOBSV(A,C)   returns the observability matrix of the system:
%
%               px = Ax + Bu
%                y = Cx + Du
%
%        such that the rows are linearly independent.


%        P. Thind
%        7/89

    error(nargchk(2,2,nargin));

    [ra,ca] = size(a);
    b = ones(ra,ca);
    error(abcdchk(a,b,c));

    ob = c;
    for i=1:ca - 1
            ob = [c; ob*a];
    end
    [r_ob,c_ob] = size(ob);
    rw_reduce_fm = rref(ob');
    ob = ob';
    rw_ones = ones(1,r_ob);
    rw_zeros = zeros(1,r_ob);
    detect_mat = zeros(c_ob,r_ob);
    i = 1;
    for j = 1:c_ob
        detect_mat(i,:) = rw_zeros;
        i = j;
        detect_mat(j,:) = rw_ones;
        result = rw_reduce_fm - detect_mat;
        for k = 1:r_ob
            if ~any(result(:,k))
                obsl = [obsl,ob(:,k)];
                break
            end
        end
    end
    ob = obsl';
