function [num,den] = tfmult(num1,den1,num2,den2)
%TFMULT   Multiplication of two transfer functions.
%         [NUM,DEN] = TFMULT(NUM1,DEN1,NUM2,DEN2)  multiplies the two transfer
%         functions
%             NUM1/DEN1
%         and
%             NUM2/DEN2
%         together.
%

%         I.Kaspura
%         11/89

error(nargchk(4,4,nargin));

[a1,b1,c1,d1] = tf2ss(num1,den1);
[a2,b2,c2,d2] = tf2ss(num2,den2);

[na1,ma1] = size(a1);
[na2,ma2] = size(a2);

a = [a1,b1*c2;zeros(na2,ma1),a2];
b = [b1*d2;b2];
c = [c1,d1*c2];
d = d1*d2;

[num,den] = ss2tf(a,b,c,d,1);

