function [Y,X]=dobserver(A,B,C,D,K,u,y_measured)
%function [Y,X]=dobserver(A,B,C,D,K,u,y_measured)
%
%  impelement a steady state OBSERVER
%   (for example : kalman filter )
% for the discrete system
%
%   x[k+1]=A*x[k]+B*u[k]+e[k]
%
%    y[k]=C*x[k]+D*u[k] + v[k]  , X0=0
%
%     the function clculated the new estimation of the  state
%     x[k|k]  that i.e. x[k] given measurments up to time k
%
%   x[k+1|k]=A*x[k|k] + B*u[k]   + K(y[k]-C*x[k|k]-D*u[k])
%   y[k|k] = C*x[k|k] + B*u[k]
%   [ can be implemented easily for continus time systems ]
%   INPUT : A,B,C,D - discrete State-space model
%           K       - observer gain (see place.m,dlqe.m etc.)
%   See : OBSDEMO.M
%  By : bucher Izhak 5/ June 1991 (Email : merbrbi@technion)

  X=ltitr(A-K*C,[B-K*D K],[u y_measured]);
  Y=X*C.'+u*D.';
