function [af,bf,cf,df,kp1,bnd] = hkapp(a,b,c,d,tol);
%
% [AF,BF,CF,DF,KP1,BND] = HKAPP(A,B,C,D,TOL) produces the Minimal Degree
%       Hankel-norm approximation Ghed(s) of a stable plant(A,B,C,D).
%
[ma,na] = size(a);
gc = gram(a,b);
go = gram(a',c');
[vv,dd] = eig(gc*go);
hsv = sqrt(dd);
kp1 = 0.;
bnd = tol;
for i = 1:na
    if real(hsv(i,i)) < tol
       kp1 = kp1 + 1;
       bnd = bnd + hsv(i,i);
    end
end
%
% ----- Hankel approximation :
%
gama = go*gc - tol*tol*eye(ma);
gamai = inv(gama);
ahed = gamai * (tol*tol*a' + go * a * gc);
bhed = gamai * go * b;
ched = c * gc;
dhed = d;
[af,bf,cf,df,agh,bgh,cgh,dgh,msat] = satsf(ahed,bhed,ched,dhed);
%
% ----- End of HKAPP.M ---- 2/13/86 RYC ---- %
