function [i] = less(a,b)
%
% [I] = LESS(A,B) returns the indices of the elements of vector A
%       that are less than elements of vector B.  A and B must be
%       the same length.  The size of I is the no. of smaller
%       elements. If there are none smaller, I = 0.
%       LESS(B,A) does the greater than case.
%
% -------- Richard Y. Chiang (4/1/86, USC)
%
[m,n] = size(a);
x = a-b;
r = 0.;
for p = 1 : m
    if x(p,1) < 0.
       r = r + 1;
       i(r,1) = p;
    end
end
if r == 0., i = 0.; end
%
% ---- End of LESS.M --- RYC --- %
