function [a11h,b1h,c1h,d1h,a22h,b2h,c2h,d2h,m] = satsf(a,b,c,d)
%
% [A11H,B1H,C1H,D1H,A22H,B2H,C2H,D2H,M] = SATSF(A,B,C,D) produces
%     a decomposition of the stable and unstable transfer function
%     matrix via HQR5 & RSASFAC.
%
% ----- Real Schur Decomposition :
%
[u,u1,u1p,t,a11h,a12h,a22h,m] = rsasfac(a);
%
[rd,cd] = size(d);
[ra,ca] = size(a);
kk = -1;
if m == 0.
    b2h = b;
    c2h = c;
    d2h = d;
    b1h = zeros(ra,cd);
    c1h = zeros(rd,ca);
    d1h = zeros(rd,cd);
    kk = 1;
end
if m == ra
    b1h = b;
    c1h = c;
    d1h = zeros(rd,cd);
    b2h = zeros(ra,cd);
    c2h = zeros(rd,ca);
    d2h = d;
    kk = 1;
end
if kk < 0
    x = lyap(a11h,-a22h,a12h);
    v1 = u1;
    v2 = u1p;
    t1 = v1;
    t2 = v1 * x + v2;
    s1 = v1' - x * v2';
    s2 = v2';
    b1h = s1 * b;
    b2h = s2 * b;
    c1h = c * t1;
    c2h = c * t2;
    [rb1h,cb1h] = size(b1h);
    [rc1h,cc1h] = size(c1h);
    d1h = zeros(rc1h,cb1h);
    d2h = d;
end
%
% ------ End of SATSF.M ---- RYC ---- %
