function x=backsb(R,b);
%
%  function x=backsb(R,b);
%
%  Using back substitution, this function solves the system  R*x=b,
% with  R  upper triangular,
%
%      Written by  George S. Miminis
%                  Department of Computer Science
%                  Memorial University of Newfoundland
%                  St. John's, Newfoundland, CANADA,
%                  A1C 5S7.
%             tel: (709)737-8635
%          e-mail: george@garfield.cs.mun.ca
%                  na.miminis@na-net.ornl.gov
%
n=length(b);
x(n)=b(n)/R(n,n);
x=x.';
for i=n-1:-1:1,
    x(i)=(b(i)-R(i,i+1:n)*x(i+1:n))/R(i,i);
end;
