function l=randeig(m,n);
%
%    This function creates a vector  l  of size  m+n,  with  m  always even,
% so that the first  m  positions are occupied by  m/2  complex conjugate
% random eigenvalues and the last  n  positions by  n  real random
% eigenvalues.
%
%      Written by  George S. Miminis
%                  Department of Computer Science
%                  Memorial University of Newfoundland
%                  St. John's, Newfoundland, CANADA,
%                  A1C 5S7.
%             tel: (709)737-8635
%          e-mail: george@garfield.cs.mun.ca
%                  na.miminis@na-net.ornl.gov
%
i=sqrt(-1);
l1=rand(floor(m/2),1);
l2=i*rand(floor(m/2),1);
for j=1:2:m-1,
    k=floor(j/2)+1;
    l(j)=l1(k)+l2(k);
    l(j+1)=l(j)';
end;
l(m+1:m+n)=rand(n,1);
l=l';
