function y=rot(x);
%
%  function y=rot(x);     with  y=[s,c].
%
%          ROT:  returns two scalars  s, c  which may define a rotation
%                matrix, say  R  that eliminates element  x(2)  into  element
%                x(1)  of the 2-dimensional vector  x.
%                It works for complex  x  as well.
%  Application:  If  x  is a column vector then  R*x. If  x  is a row vector
%                then  x*R.
%
%      Written by  George S. Miminis
%                  Department of Computer Science
%                  Memorial University of Newfoundland
%                  St. John's, Newfoundland, CANADA,
%                  A1C 5S7.
%             tel: (709)737-8635
%          e-mail: george@garfield.cs.mun.ca
%                  na.miminis@na-net.ornl.gov
%
c=1;
s=0;
if x(1) == 0 & x(2) == 0,
   y=[c,s];
   return;
end;
maxim=max(abs([x(1),x(2)]));
x(1)=x(1)/maxim;
x(2)=x(2)/maxim;
ro=norm([x(1),x(2)]);
tol=ro*eps;
if abs(x(2)) < tol,
   y=[c,s];
   return;
else
   s=x(2)/ro;
   c=x(1)/ro;
end;
y=[c,s];
