function  [nz,dz,ncz,dcz]=s2zzoh(num,den,T,Td);
%  [nz,dz,ncz,dcz]=s2zzoh(num,den,T{,Td})
% calculates  Z transform of  s transfer function g(s) with ZOH
% g(s)=num(s)/den(s)*exp(-Td.s)*ZOH (ZERO ORDER HOLD ADDED  -DO NOT INCLUDE)
% T--- is sampling time for discrete system
% Td-- is Dead Time {optional}
%	open loop   : g(z) = nz/dz
%	closed loop : g(z)/(1 + g(z)) = ncz/dcz {=nz/(nz+dz)}


% convert to ss without delay (deadtime)
[a,b,c,d]=tf2ss(num,den);
% convert to discrete
if nargin ==4
      [ad,bd,cd,dd]=c2dt(a,b,c,T,Td); % use delayed conversion
      else
      [ad,bd]=c2d(a,b,T);% use undelayed conversion
      cd=c;dd=d; % c and d won't change
end
% convert back to discrete tf
%disp (' open loop : g(z) = nz/dz')
[nz,dz]=ss2tf(ad,bd,cd,dd,1);
%disp  (' closed loop : g(z)/(1 + g(z)) = ncz/dcz')
ncz=nz;
dcz=nz+dz;
return
