function dropcurs(vh, vv, ah, av)
% DROPCURS   Drop the cursor.
%
%            Usage:  dropcurs(v0_x, v0_y, a_x, a_y)
%
%            (Acceleration behaves most naturally between -1 and 1)

EFFICIENCY = .85;
MAX = 50000;
PL = 'pointerLocation';

screenSize = get(0, 'screenSize');
screenWidth = screenSize(3);
screenHeight = screenSize(4);

if ~nargin
  vh = fix(rand*13) - 6;
  vv = 0;
  av = -.4;
  ah = 0;
elseif nargin ~= 4
  error(['Usage: ' mfilename '(vh, vv, ah, av)'])
end

if ah > 0
  if av > 0
    quadrant = 1;
  elseif av < 0
    quadrant = 4;
  else
    quadrant = 'r';
  end
elseif ah < 0
  if av > 0
    quadrant = 2;
  elseif av < 0
    quadrant = 3;
  else
    quadrant = 'l';
  end
else
  if av > 0
    quadrant = 't';
  elseif av < 0
    quadrant = 'b';
  else
    error('This is going nowhere!')
  end
end

pt = get(0, PL);

count = 0;
while count < MAX
  pt(1) = pt(1) + vh;
  pt(2) = pt(2) + vv;
    
  if pt(1) < 2
    pt(1) = 1;
    if abs(vh) > 1
	 vh = -1 * EFFICIENCY * vh;
    end
  elseif pt(1) > (screenWidth-1)
    pt(1) = screenWidth - 1;
    if abs(vh) > 1
	 vh = -1 * EFFICIENCY * vh;
    end
  end
  
  if pt(2) < 2
    pt(2) = 1;
    if abs(vv) > 1
	 vv = -1 * EFFICIENCY * vv;
    end
  elseif pt(2) > (screenHeight-2)
    pt(2) = screenHeight - 1;
    if abs(vv) > 1
	 vv = -1 * EFFICIENCY * vv;
    end
  end

  set(0, PL, pt);  %  Put it there
  drawnow

  vv = vv + av;
  vh = vh + ah;
  count = count + 1;

  if quadrant == 1
    if (abs(vv)<1) & (pt(2)>(screenHeight-2)) & ...
		  (abs(vh)<1) & (pt(1)>(screenWidth-2))
	 break
    end
  elseif quadrant == 2
    if (abs(vv)<1) & (pt(2)>(screenHeight-2)) & ...
		  (abs(vh)<1) & (pt(1)<2)
	 break
    end
  elseif quadrant == 3
    if (abs(vv)<1) & (pt(2)<2) & ...
		  (abs(vh)<1) & (pt(1)<2)
	 break
    end
  elseif quadrant == 4
    if (abs(vv)<1) & (pt(2)<2) & ...
		  (abs(vh)<1) & (pt(1)>(screenWidth-2))
	 break
    end
  elseif quadrant == 'l'
    if (abs(vh)<1) & (pt(1)<2)
	 break
    end
  elseif quadrant == 'r'
    if (abs(vh)<1) & (pt(1)>(screenWidth-2))
	 break
    end
  elseif quadrant == 't'
    if (abs(vv)<1) & (pt(2)>(screenHeight-2))
	 break
    end
  elseif quadrant == 'b'
    if (abs(vv)<1) & (pt(2)<2)
	 break
    end
  end
end
