function taquin(cmd, p1, p2, imaname)
% The game purpose is to order an image divided in mxn squares
% Each square can be moved by clicking on it, provided that the
% empty square is in the same line or column.

% Le but du jeu est de rarranger une images dcoupe en m x n carrs
% Les carrs peuvent tre dplacs en cliquant dessus. 

% (c) Daniel Scharstein  1/27/94   (schar@cs.cornell.edu)
% modified by Markus Matern 2/20/96   (Markus.Matern@student.uni-ulm.de)
% modifi et imag par j.t Laprest 8/10/96 (lapreste@lasmea.univ-bpclermont.fr)

global ct ff ha hb hi ax trou allok b_m li co valterm pterm ima;

again = 0;
if nargin == 0
  cmd = 'init';
elseif ~isstr(cmd)
  fprintf('use :\n    taquin\n');
  fprintf(' or taquin(''init'')\n');
  fprintf(' or taquin(''init'', nblines)\n');
  fprintf(' or taquin(''init'', nblines, nbcols)\n');
  fprintf(' or taquin(''init'', nblines, nbcols, imageName)\n');
  fprintf(' imageName is the name of a bmp image\n');
  return;
elseif strcmp(cmd, 'again')
  a = str2num(get(ha,'String'));
  b = str2num(get(hb,'String'));
  ima = get(hi, 'String');
  cmd = 'init';
  again = 1;
elseif strcmp(cmd, 'nbl')|strcmp(cmd, 'nbc')
  a = str2num(get(ha,'String'));
  b = str2num(get(hb,'String'));
  cmd = 'init';
  again = 2;
elseif strcmp(cmd, 'image')
  a = str2num(get(ha,'String'));
  b = str2num(get(hb,'String'));
  ima = get(hi, 'String');
  cmd = 'init';
  again = 3;
end;

if strcmp(cmd, 'init')
  oldfig=watchon;
  if nargin == 4
    a = p1;
    b = p2;
    ima = imaname;
  elseif nargin == 3
    a = p1;
    b = p2;
    ima = 'logo2.bmp';
  elseif nargin == 2 & again == 0
    a = p1;
    b = a;
    ima = 'logo2.bmp';
  elseif nargin <= 1 & again == 0
    a = 3;
    b = 3;
    ima = 'logo2.bmp';
  end;
  
  allok = reshape(1:a*b, b,a )';
  allok(a,b)=0;
  [im, map] = loadbmp(ima);
  [m, n] = size(im);

  r = get(0, 'screensize');
  ratio = m/n;
  fact1 = r(3)/(n*1.1);
  fact2 = r(4)/m;
  if fact1 > fact2
    fact = fact2.*0.8;
  else
    fact = fact1.*0.8;
  end;  
  r =[(r(3)-n*fact)/2, (r(4)-m*fact)/2, n*fact, m*fact];

  m = fix(m/a); n=fix(n/b);

  if again == 0 | again == 3
    [existFlag,fignumber]=figflag('Window Help',1);
    if existFlag
      delete(fignumber);
    end;  
    [existFlag,fignumber]=figflag('taquin''s game. oct 96',0);
    if ~existFlag 
      ff=figure(...
          'NumberTitle', 'off',...
          'Name', 'taquin''s game. oct 96',...
          'MenuBar', 'none',...
          'resize', 'off',...
          'Position',r);
    else
      set(ff, 'Position', r);
    end;    
  end;        
  while 1 
    l = randperm(a*b-1); 		% creation d'une permutation alatoire
    ll = l(ones(length(l),1), :);		
    if rem(sum(sum(triu(ll<ll'))), 2) 	% si la permutation est impaire
      l = [l(2) l(1) l(3:length(l))];   % on la rend paire
    end;
    l = [l 0];                          % case vide  la fin
    b_m = reshape(l,b,a)';
    if any(any(b_m-allok))
      break;
    end;
  end;
  for i = 1:a
    for j = 1:b
      li(j+(i-1)*b) = fix((i-1)*m);
      co(j+(i-1)*b) = fix((j-1)*n);
    end;
  end;  
  trou = [a,b];
  ch=get(ff, 'children');
  for h = ch'
    s = get(h, 'type');
    if strcmp(s,'axes')
      delete(h);
    elseif again == 0
      delete(h);
    end;  
  end;
  if again ==0
    uimenu('label', 'Quit', 'Callback', 'taquin(''quit'')');
    uimenu('label', 'Again', 'Callback', 'taquin(''again'')');
    uimenu('label', 'Show', 'Callback', 'taquin(''show'')');
    uimenu('label', 'Help', 'Callback', 'taquin(''help'')');
    uicontrol('Style', 'frame',...
            'Units', 'Normalized',...
            'BackGroundColor', [0 0 1],... 
            'Position', [0, 0.9, 1, 0.1]);
    uicontrol('Style', 'text',...
            'String', 'nb of cols: ',...
            'Horiz', 'right',...
            'Units', 'Normalized',...
            'BackGroundColor', [0 0 1],...
            'ForeGroundColor',[1, 1 ,1],...
            'Position', [0, 0.95, 0.23, 0.05]);           
    uicontrol('Style', 'text',...
            'String', 'nb of lines: ',...
            'Horiz', 'right',...
            'Units', 'Normalized',...
            'BackGroundColor', [0 0 1],...
            'ForeGroundColor',[1, 1 ,1],...
            'Position', [0, 0.9, 0.23, 0.05]);           
    hb=uicontrol('Style', 'edit',...
            'String', num2str(b),...
            'Units', 'Normalized',...
            'BackGroundColor', [1 1 0],...
            'ForeGroundColor', [0 0 0],...
            'Position', [0.23, 0.95, 0.16, 0.05],...
            'CallBack','taquin(''nbc'')');
    ha=uicontrol('Style', 'edit',...
            'String', num2str(a),...
            'Units', 'Normalized',...
            'BackGroundColor', [1 1 0],...
            'ForeGroundColor', [0 0 0],...
            'Position', [0.23, 0.9, 0.16, 0.05],...
            'CallBack','taquin(''nbl'')');
    uicontrol('Style', 'text',...
            'String', 'image name: ',...
            'Horiz', 'right',...
            'Units', 'Normalized',...
            'BackGroundColor', [0 0 1],...
            'ForeGroundColor', [1 1 1],...
            'Position', [0.39, 0.92, 0.2, 0.05]);           
    hi=uicontrol('Style', 'edit',...
            'String', ima,...
            'Units', 'Normalized',...
            'BackGroundColor', [1 1 0],...
            'ForeGroundColor', [0 0 0],...
            'Position', [0.59, 0.92, 0.31, 0.05],...
            'CallBack', 'taquin(''image'')');
    ct=uicontrol('Style', 'text',...
            'Horiz', 'center',...
            'Units', 'Normalized',...
            'BackGroundColor', [1 1 0],...
            'ForeGroundColor', [0 0 0],...
            'Position', [0.91, 0.92, 0.09, 0.05]);
  end;
  set(ct, 'String', '0');
  for i = 1:a
    for j = 1:b
      p=axes( ...,
	      'Units', 'Normalized', ...
		    'Visible', 'off',...
		    'Position', [(j-1)/b 0.9*(1-i/a) 1/b 0.9/a]);
      if( i*j ~= a*b)
        axes(p);
        ind = b_m(i,j);
        h =image(im( li(ind)+1:li(ind)+m, co(ind)+1:co(ind)+n));
        ax(i,j)=h;
        colormap(map);
        set(h,'ButtonDown', sprintf('taquin(''move'', %.20g)', h));
		    set(h,'UserData', [i j]);     % [ligne col]
        set(p, 'Visible', 'off');
        drawnow;
      else
        ind = a*b;
        valterm =im( li(ind)+1:li(ind)+m, co(ind)+1:co(ind)+n);
        pterm = p; 
        set(pterm,'userdata', 1);
      end;  
    end;
  end;
  watchoff(oldfig);
elseif strcmp(cmd, 'show')       %montrer la solution
  oldfig=watchon;
  [aa bb] = size(b_m);
  for i=1:aa
    for j = 1:bb
      if b_m(i,j)~=0
        h = get(ax(i,j), 'parent');
        [l, c] = find(b_m(i,j) == allok);
        set(h, 'Position', [(c-1)/bb 0.9*(1-l/aa) 1/bb 0.9/aa]);
      else
        axes(pterm);
        image(valterm);
        set(pterm,'visible', 'off');
      end;  
    end;
  end;
  watchoff(oldfig);
  drawnow;
elseif strcmp(cmd, 'help')
  hlpstr =['                                                           '  
           ' This program allows to play to ''taquin'' game.             '  
           ' An image is drawed divided in rectangles put              '
           ' at random.                                                '
           ' By clicking on them you must restore the                  '
           ' right order.                                              ' 
           '                                                           '  
           ' Number of lines and of columns can be changed.            '  
           ' The image provided can be replaced by any bmp one,        '  
           ' not compacted, with no more than 256 colors               '  
           ' (because of the use of loadbmp.m)                         '  
           '                                                           '  
           ' File name            : taquin.m                           '
           ' secondary files      : loadbmp.m, helpf.m                 '  
           ' ressource file       : logo2.bmp                          '];
      helpf('taquin''s help', hlpstr);
elseif strcmp(cmd, 'move')  % le bouton b a t press
  oldfig =watchon;
  if get(pterm,'userdata')
    [aa bb] = size(b_m);
    pos = get(p1, 'UserData');     % informations bouton
    dy = pos(1)-trou(1);
    dx = pos(2)-trou(2);
    if ~dx | ~dy
      set(ct, 'String', num2str(str2num(get(ct,'String'))+1));
      if dx
        l = pos(1);
        start = trou(2);
        stop  = pos(2);
        step = sign(dx);
        for c=start+step:step:stop
          b = ax(l,c);
          h = get(b, 'parent');
          set(h, 'Position', [(c-step-1)/bb 0.9*(1-l/aa) 1/bb 0.9/aa]);%l'axes change de position
          set(b, 'UserData', [l, c-step]); % le bouton prend les informations du prcdent
          set(h,'ButtonDown', sprintf('taquin(0, %.20g)', b));
          set(h, 'Visible', 'off');
          ax(l,c) = ax(l,c-step);
          ax(l,c-step)=b;
          b_m(l, c-step) = b_m(l,c);
          b_m(l,c) = 0;
        end;  
      else
        c = pos(2);
        start = trou(1);
        stop  = pos(1);
        step = sign(dy);
        for l=start+step:step:stop
          b = ax(l,c);
          h = get(b, 'parent');
          set(h, 'Position', [(c-1)/bb 0.9*(1-(l-step)/aa) 1/bb 0.9/aa]); %l'axes change de position
          set(b, 'UserData', [l-step,c]); % le bouton prend les informations du prcdent
          set(h,'ButtonDown', sprintf('taquin(0, %.20g)', b));
          set(h, 'Visible', 'off');
          ax(l,c) = ax(l-step,c);
          ax(l-step,c)=b;
          b_m(l-step,c) = b_m(l,c);
          b_m(l,c) = 0;
        end;
      end;   
      drawnow;
      trou = pos;
      if ~any(any(b_m-allok))
        axes(pterm);
        image(valterm);
        set(pterm,'visible', 'off');
        set(pterm,'userdata', 0);
        drawnow;
      end;
    end;  
  end;
  watchoff(oldfig);
elseif strcmp(cmd,'quit');  
  delete(ff);
  [existflag,fignumber]=figflag('Help Window',0);
  if existflag
    delete(fignumber);
  end;  
  clear global f1 f2;
  fprintf('bye\n ');
else
  taquin(0);
  return;
end;


