function tile_puzzle(a, b)
% TILE_PUZZLE(m, n) creates m x n tile puzzle with pushbuttons
 
% (c) Daniel Scharstein  1/27/94   (schar@cs.cornell.edu)
 
global SIZE HOLE FINISHED;
 
if nargin == 0,
  a = 3; b = 3;
elseif nargin == 1,
  b = a;
end;
 
if a > 0,                               % initialization
  clf; figure(gcf);
  SIZE = [a b a b];
  l = randperm(a*b-1);                  % create random permutation vector l
  ll = ones(size(l))'*l;                % and make sure permutation is even
  if rem(sum(sum(triu(ll<ll'))), 2)     % so that the puzzle is solvable
    l = [l(2) l(1) l(3:length(l))]; 
  end;
  l = [l 0]; FINISHED = []; k = 1;
  for j=b:-1:1;
    for i = 1:a;
      if l(1) == 0;
        HOLE = [i j k 0];
      else
        p = uicontrol('Style', 'Pushbutton', 'String', num2str(l(1)), ...
            'UserData', [i j k l(1)], 'Units', 'Normalized', ...
            'Position', [i j .9 .9]./(SIZE+2));
        set(p, 'Callback', sprintf('tile_puzzle(0, %.20g)', p));
        FINISHED(l(1)) = (l(1) ~= k);
      end;
      l(1) = []; k = k+1;
    end;
  end;
else                                    % button b pressed
  pos = get(b, 'UserData');
  if sum(abs(pos(1:2)-HOLE(1:2))) == 1;
    set(b, 'UserData', [HOLE(1:3) pos(4)]);
    set(b, 'Position', [HOLE(1:2) .9 .9]./(SIZE+2));
    FINISHED(pos(4)) = (HOLE(3) ~= pos(4));
    HOLE(1:3) = pos(1:3);
    if sum(FINISHED) == 0
      uicontrol('Style', 'Pushbutton', 'String', 'done', ...
          'Units', 'Normalized', 'Position', [SIZE(1) 1 .9 .9]./(SIZE+2), ...
          'Callback', 'clf');
      HOLE = [0 0 0 0];
    end;
  end;
end;
