sss = sprintf('\n'); disp(sss)
disp('Please type in the name of the session or options file you''d like to Append')
disp('to this one in your STAPLOT workspace.  Sessions must have been stored')
disp('within your Matlabpath. Do not specify a pathname.  Remember that variables')
disp('not on the proplist will be overwritten if their names are not unique.')
disp('If you are not sure you will have enough memory, STOP NOW, and check.')
sss = sprintf('\n'); disp(sss)
disp('The new data must already be in STAPLOT format. If they aren''t, quit this')
disp('session, start STAPLOT again, and use Loaddata to load and convert it.')
sss = sprintf('\n'); disp(sss)

isopts = 0;
new_optsfile = input('Options filename? ([CR] to abort) >> ','s');
if ~isempty(new_optsfile)
  if exist(new_optsfile) == 2
    sss = sprintf('\n'); disp(sss)
    disp(['Evaluating and comparing ' new_optsfile])
    disp('Please wait a minute ... ')
    sss = sprintf('\n'); disp(sss)
    % now we have to backup ALL the user-specified options
    optsmerg
    eval(new_optsfile)
    newnstn = oldnstn + nstn;
    if ~isempty(nstn)
      isopts = 1;
    else
      disp([new_optsfile ' did not appear to be a valid staplot options file'])
      return
    end
  else
    disp('Not a valid options file')
    return
  end
else
  return
end

s = size(proplist); sss = []; for i = 1:s(1); sss = [sss ' ']; end
sss = sprintf('%s',[proplist sss']');
eval(['global ' sss]);

olen = size(oldproplist); olen = olen(1);
tmpnames = []; % we have a new opts file to use.  Hallelujah.
% back up the old data in proplist
for i = 1:olen
  t = ['tmp' num2str(round(10*rand(1,10)))];
  tmpnames = str2mat(tmpnames,t);
  eval([t ' = ' deblank(oldproplist(i,:)) ';'])
  eval([deblank(oldproplist(i,:)) ' = [];'])
end
tmpnames = tmpnames(2:i+1,:);

% now check the concept vars for consistency!
% pr_var etc.  We'll make a matrix and keep them in order.
% there are 8 concept vars.
oldconcepts = str2mat(oldlat_var, oldlon_var, oldsta_var, oldpr_var, ...
    oldpt_var, oldsa_var, oldde_var, oldte_var);
concepts = str2mat(lat_var, lon_var, sta_var, pr_var, ...
    pt_var, sa_var, de_var, te_var);

newproplist = 'Dist';
data_flag = zeros(9,3); % first line is reserved for 'Dist', always a flag of zero.
for i = 1:8
  if ~isempty(deblank(oldconcepts(i,:)));
    newproplist = str2mat(newproplist,deblank(oldconcepts(i,:)));
    if ~isempty(deblank(concepts(i,:)));
      data_flag(i+1,1) = 3; % listed on both
    else
      data_flag(i+1,1) = 1; % listed on old only
     end
  elseif ~isempty(deblank(concepts(i,:)));
    newproplist = str2mat(newproplist,deblank(concepts(i,:)));
    data_flag(i+1,1) = 2; % listed on new only
  else
    newproplist = str2mat(newproplist,'');
    data_flag(i+1,1) = 0; % this concept listed on neither proplist
  end
end

% add on everything in the old list not in the concepts list
for i = 1:olen;
  k = 1;
  for j = 1:8
    if strcmp(deblank(oldproplist(i,:)),deblank(oldconcepts(j,:)))
      k = 0; % we found a match
    elseif strcmp(deblank(oldproplist(i,:)),'Dist')
      k = 0;
    end
  end
  if k
    newproplist = str2mat(newproplist,deblank(oldproplist(i,:)));
    s = size(newproplist); data_flag(s(1),:) = [1 i 0];
  end
end

% add on everything in the new list not in the concepts list
len = size(proplist); len = len(1);
for i = 1:len;
  k = 1;
  for j = 1:8
    if strcmp(deblank(proplist(i,:)),deblank(concepts(j,:)))
      k = 0; % we found a match
    elseif strcmp(deblank(proplist(i,:)),'Dist')
      k = 0; % we found a match
    end
  end
  if k
    newproplist = str2mat(newproplist,deblank(proplist(i,:)));
    s = size(newproplist); data_flag(s(1),:) = [2 0 i];
  end
end

% eliminate duplicates
newlen = size(newproplist); newlen = newlen(1);
k = ones(newlen,1);
for i = 9:newlen
  for j = i+1:newlen
    if strcmp(newproplist(i,:),newproplist(j,:))
      k(i) = 0; data_flag(j,:) = data_flag(i,:) + data_flag(j,:);
    end
  end
end
k = find(k);
newproplist = newproplist(k,:); data_flag = data_flag(k,:);
s = size(newproplist); newlen = s(1);

% set the variable types
s = size(newproplist); newlen = s(1);
newtypevar = zeros(1,newlen); newtypevar(1) = 1; % for 'Dist'
for i = 2:newlen
  old_var_type = 0; var_type = 0;
  if i <= 9 % find location of variable name on oldproplist
    for ox = 1:olen
      if strcmp(deblank(oldproplist(ox,:)), deblank(oldconcepts(i-1,:)))
	old_var_type = oldtypevar(ox);
	break
      end
    end
    for nx = 1:len
      if strcmp(deblank(proplist(nx,:)), deblank(concepts(i-1,:)))
	var_type = typevar(nx);
	break
      end
    end
  else
    for ox = 1:olen
      if strcmp(deblank(oldproplist(ox,:)), deblank(newproplist(i,:)))
	old_var_type = oldtypevar(ox);
	break
      end
    end
    for nx = 1:len
      if strcmp(deblank(proplist(nx,:)), deblank(newproplist(i,:)))
	var_type = typevar(nx);
	break
      end
    end
  end
  if data_flag(i,1) == 3
    if old_var_type == var_type
      if (old_var_type < 1) | (old_var_type > 3) | (old_var_type ~= round(old_var_type))
	disp(['Variable ' deblank(newproplist(i,:)) ' is of invalid type.'])
	disp('At the prompt, please input the correct type (1, 2 or 3).')
	disp('[CR] or an invalid answer will cause the variable to be deleted.')
	tt = input('Variable type? >> ');
	if ~isempty(tt)
	  newtypevar(i) = tt;
	else
	  newtypevar(i) = 0;
	end
      else
	newtypevar(i) = old_var_type;
      end
    else
      disp(['Warning; variable types for ''' deblank(newproplist(i,:)), ...
		''' are different!'])
      aa = sprintf('Old variable type is %i.  New variable type is %i.', ...
	  old_var_type, var_type);
      disp(aa)
      disp('At the prompt, please input the correct type (1, 2 or 3).')
      disp('[CR] or an invalid answer will cause the variable to be deleted.')
      tt = input('Variable type? >> ');
      if ~isempty(tt)
	newtypevar(i) = tt;
      else
	newtypevar(i) = 0;
      end
    end
  elseif data_flag(i,1) == 1
    if (old_var_type < 1) | (old_var_type > 3) | (old_var_type ~= round(old_var_type))
      disp(['Variable ''' deblank(newproplist(i,:)) ''' is of type ', ...
	      num2str(old_var_type) ' (invalid).'])
      disp('At the prompt, please input the correct type (1, 2 or 3).')
      disp('[CR] or an invalid answer will cause the variable to be deleted.')
      tt = input('Variable type? >> ');
      if ~isempty(tt)
	newtypevar(i) = tt;
      else
	newtypevar(i) = 0;
      end
    else
      newtypevar(i) = old_var_type;
    end
  elseif data_flag(i,1) == 2
    if (var_type < 1) | (var_type > 3) | (var_type ~= round(var_type))
      disp(['Variable ''' deblank(newproplist(i,:)) ''' is of type ', ...
	      num2str(old_var_type) ' (invalid).'])
      disp('At the prompt, please input the correct type (1, 2 or 3).')
      disp('[CR] or an invalid answer will cause the variable to be deleted.')
      tt = input('Variable type? >> ');
      if ~isempty(tt)
	newtypevar(i) = tt;
      else
	newtypevar(i) = 0;
      end
    else
      newtypevar(i) = var_type;
    end
  else
    newtypevar(i) = 0;
  end
end
% -----------------LOAD THE DATA -------------------------------------------

disp(['options file loaded. Data file is: ' file])
q = input('Do you wish to change the path? y/n [n] >> ','s');
if isempty(q)
  q = 'n';
end
if strcmp(lower(deblank(q)),'y')
  newpath = input('New path >> ','s');
  if ~isempty(newpath)
    newpath = fliplr(deblank(fliplr(deblank(newpath))));
    if ~isempty(newpath)
      ll = size(newpath,2);
      dirsep = '/';
      c = computer;
      if strcmp(c(1:2),'PC')
	dirsep = '\';
      elseif strcmp(c(1:2),'MA')
	dirsep = ':';
      else
	if isvms
	  %shite
	  disp('Sorry, I''m foxed.')
	  return
	end
      end
      % strip off old path
      p = findstr(file,dirsep);
      if ~isempty(p)
	file = file(max(p)+1:size(file,2));
      end
      if ~strcmp(newpath(ll),dirsep);
	newpath = [newpath dirsep];
      end
      file = [newpath file];
    end
  end
end
disp(['Now attempting to load the data file ' file])
if ~isempty(file)
  if isstr(file)
    file = deblank(file);
    file = fliplr(deblank(fliplr(file)));
    l = length(file);
    if l > 4,
	if strcmp(file(l-3:l),'.mat')
	  file = file(1:l-4);
	end
    end
    if exist([file '.mat']) == 2
	isopts = 1;
    else
	disp('not a valid filename')
	disp('Please quit STAPLOT now and start again')
	return
    end
  else
    disp('not a valid filename')
    disp('Please quit STAPLOT now and start again')
    return
  end
end

disp(['loading data ' file ' ...'])
% take care of weird filenames
while (~isempty(findstr(file,'''')))
  file = strrep(file,'''','');
end
eval(['load ' '''' file '''']);
k = ones(newlen,1);
for i = 2:newlen
  var = deblank(newproplist(i,:));
  if isempty(var)
    k(i) = 0;
  else
    if data_flag(i,1) == 3
      if i <= 9 % we have to find location of variable name on oldproplist
	for ox = 1:olen
	  if strcmp(deblank(oldproplist(ox,:)), deblank(oldconcepts(i-1,:)))
	    break
	  end
	end
	for nx = 1:len
	  if strcmp(deblank(proplist(nx,:)), deblank(concepts(i-1,:)))
	    break
	  end
	end
	old_var = deblank(tmpnames(ox,:)); % from position on oldproplist
	new_var = deblank(concepts(i-1,:)); % new name might not be the same
      else
	old_var = deblank(tmpnames(data_flag(i,2),:));
	new_var = deblank(proplist(data_flag(i,3),:));
      end
      nsz = size(eval(new_var));
      osz = size(eval(old_var));
      if all(nsz > 0) & all(osz > 0) 	% both actually exist
	if newtypevar(i) == 3
	  % must check for pressure or depth
	  if i == 5,
	    if oldpr_reverse ~= pr_reverse
	      eval([new_var '= -1*' new_var ';']);
	      pr_reverse = oldpr_reverse;
	    end
	  elseif i == 8,
	    if oldde_reverse ~= de_reverse
	      eval([new_var '= -1*' new_var ';']);
	      de_reverse = oldde_reverse;
	    end
	  end
	  if nsz(1) < osz(1)
	    eval([var  ' = [' old_var ', [' new_var, ...
			    '; nan*ones(osz(1)-nsz(1),nsz(2))]];'])
	  elseif nsz(1) == osz(1)
	    eval([var ' = [' old_var ',' new_var '];'])
	  elseif nsz(1) > osz(1)
	    eval([var ' = [ [' old_var '; nan*ones(nsz(1)-osz(1),osz(2))],', ...
			new_var '];'])
	  end
	elseif newtypevar(i) == 1
	  eval([var ' = [' old_var '(:)'',' new_var '(:)''];'])
	elseif newtypevar(i) == 2
	  % simply write in new_var.
	  eval([var ' = ' new_var ';'])
	else 				% unknown type. DELETE!
	  k(i) = 0;
	end
      elseif all(nsz > 0)
	disp(['Data ' var ' exist only in new dataset.'])
	if newtypevar(i) == 3
	  eval([var ' = [nan*zeros(nsz(1),oldnstn),'  new_var '];'])
	elseif newtypevar(i) == 1
	  eval([var ' = [nan*ones(1,oldnstn), ' new_var '(:)''];'])
	elseif newtypevar(i) == 2
	  eval([var ' = ' new_var ';'])
	else
	  k(i) = 0;
	end
      elseif all(osz > 0)
	if i == 5 % this is pressure
	  pr_reverse = oldpr_reverse
	elseif i == 8;
	  de_reverse = oldde_reverse;
	end
	disp(['Data ' var ' exist only in old dataset. '])
	if newtypevar(i) == 3
	  eval([var ' = [' old_var ', nan*zeros(osz(1),nstn)];'])
	elseif newtypevar(i) == 1
	  eval([var  ' = [' old_var '(:)'', nan*ones(1,nstn)];'])
	elseif newtypevar(i) == 2
	  eval([var ' = ' old_var ';'])
	else
	  k(i) = 0;
	end
      else
	k(i) = 0;
      end
      if ~strcmp(var, new_var)
	eval(['clear ' new_var])
      end
      eval(['clear ' old_var])
    elseif data_flag(i,1) == 1 		% these data only exist in old set
      if i <= 9 % we have to find location of variable name on oldproplist
	for ox = 1:olen
	  if strcmp(deblank(oldproplist(ox,:)), deblank(oldconcepts(i-1,:)))
	    break
	  end
	end
	old_var = deblank(tmpnames(ox,:)); % from position on oldproplist
      else
	old_var = deblank(tmpnames(data_flag(i,2),:));
      end
      sz = size(eval(old_var));
      if all(sz > 0)
	if newtypevar(i) == 3
	  eval([var  '= nan*ones(sz(1),newnstn);'])
	  eval([var '(:,1:oldnstn) = ' old_var ';'])
	elseif newtypevar(i) == 1
	  eval([var ' = [' old_var '(:)'', nan*ones(1,nstn)];'])
	elseif newtypevar(i) == 2
	  eval([var  ' = ' old_var ';'])
	else
	  k(i) = 0;
	end
      else
	k(i) = 0;
      end
      eval(['clear ' old_var])
    elseif data_flag(i,1) == 2 		% these data exist only in new dataset
      if i <= 9 % we have to find location of variable name on oldproplist
	for nx = 1:len
	  if strcmp(deblank(proplist(nx,:)), deblank(concepts(i-1,:)))
	    break
	  end
	end
	new_var = deblank(concepts(i-1,:)); % new name might not be the same
      else
	new_var = deblank(proplist(data_flag(i,3),:));
      end
      sz = size(eval(new_var));
      if all (sz > 0)
	if newtypevar(i) == 3
	  eval([var ' = [nan*zeros(sz(1),oldnstn), ' new_var '];'])
	elseif newtypevar(i) == 1
	  eval([var ' = [nan*ones(1,oldnstn), ' new_var '(:)''];'])
	elseif newtypevar(i) == 2
	  eval([var ' = ' new_var ';'])
	else
	  k(i) = 0;
	end
      else
	k(i) = 0;
      end
    end
  end
end

% reset concepts
for i = 1:newlen
  var = deblank(newproplist(i,:));
  if k(i) == 0;
    if ~isempty(var)
      eval(['clear global ' var])
      var = '';
    end
  end
  if i == 2
    lat_var = var;
  elseif i == 3 
    lon_var = var;
  elseif i == 4
    sta_var = var;
  elseif i == 5
    pr_var = var;
  elseif i == 6
    pt_var = var;
  elseif i == 7
    sa_var = var;
  elseif i == 8
    de_var = var;
  elseif i == 9
    te_var = var;
  end
end

k = find(k); proplist = newproplist(k,:); typevar = newtypevar(k);
sections = [oldsections; sections+oldnstn];
station_style = [oldstation_style station_style];
nstn = newnstn; clear newnstn
% and now to strike a blow for continuity
proj = oldproj; 
if ~isempty(oldprojlim)
  projlim = oldprojlim;
end
colornames = oldcolornames;
mapcolors = oldmapcolors; plotcolors = oldplotcolors;
plotstyle = oldplotstyle; isopycnals = oldisopycnals;
contno = oldcontno; marksize = oldmarksize;
pr_reverse =  oldpr_reverse; de_reverse =  oldde_reverse;
sta_write = oldsta_write;

for i = 1:olen
  eval(['clear ' tmpnames(i,:)])
end
sss = sprintf('\n'); disp(sss)

max_nrow = 0;
disp('New type 2 and 3 variables may have unequal numbers of rows.')
q = input('Pad them to the same length? y/n [y] >> ','s');
if isempty(q)
  q = 'y';
end
if strcmp(lower(deblank(q)),'y')
  for i = 1:length(typevar)
    s = size(eval(proplist(i,:)));
    if typevar(i) == 2
      ss(i) = max(s);
    elseif typevar(i) == 3
      ss(i) = s(1);
    end
  end
  max_nrow = max(ss);
  aa = ['cc = [proplist(i,:) '' = '' deblank(proplist(i,:)) ''(:);'' ', ...
	      'proplist(i,:) '' = ['' proplist(i,:) ', ...
		  '''; nan*ones(max_nrow-ss(i),1)];''];'];
  bb = ['cc = [proplist(i,:) '' = ['' proplist(i,:) ', ...
		  '''; nan*ones(max_nrow-ss(i),nstn)];''];'];
  for i = 1:length(typevar)
    if typevar(i) == 2
      if ss(i) < max_nrow
	eval(aa)
	eval(cc)
      end
    elseif typevar(i) == 3
      if ss(i) < max_nrow
	eval(bb)
	eval(cc)
      end
    end
  end
end

sss = sprintf('\n'); disp(sss)
disp('Datasets and options'' files merged.  To be able to reload the new, merged')
disp('session at startup, you will have to save the merged dataset as a single')
disp('file. Note that only the variables on the plot list will be saved.  Please')
disp('specify a fully qualified path with the file.')
q = input('Would you like to save the merged data now? (y/n) [y] >> ','s');
if isempty(q)
  q = 'y';
end
if strcmp(deblank(lower(q)),'y')
  file = input('Filename ([CR] to abort) >> ','s');
  if ~isempty(file)
    file = deblank(file);
    file = fliplr(deblank(fliplr(file)));
    sss = []; s = size(proplist); for i = 1:s(1); sss = [sss ' ']; end
    sss = sprintf('%s',[proplist sss']');
    % take care of weird filenames
    while (~isempty(findstr(file,'''')))
      file = strrep(file,'''','');
    end
    eval(['save '''  file ''' ' sss ]);
    sss = sprintf('\n'); disp(sss)
    disp('Merged data saved.')
    disp(' Don''t forget to save the merged session options with ''saveopts''.')
  else
    disp('Merge finished.')
  end
else
  disp('Merge finished.')
end

clear old_var_type ox nx var_type newproplist newtypevar
clear f i ii isopts j k l len olen newlen concepts
clear sz osz nsz q s t sss tmpnames new_optsfile oldconcepts
clear oldproj oldprojlim oldcolornames oldmapcolors oldplotcolors
clear oldplotstyle oldisopycnals oldcontno oldmarksize
clear oldpr_reverse oldde_reverse oldsta_write oldtypevar
clear oldpr_var oldde_var oldpt_var oldsa_var oldsta_var
clear oldte_var oldlon_var oldlat_var olddist_var 
clear oldsections oldfile oldstation_style oldproplist 
clear oldnstn old_var new_var newfile var data_flag

kids = get(0,'children');
for i = 1:length(kids) 			% close all subsidiary staplot plots
  if isstrcmp(get(kids(i),'userdata'),'staplot')
    close(kids(i))
  end
end
F_HANDLES = []; figchars = [];
set(B_HANDLES(4),'Style','Popup','String', proplist)
drawnow
if ~isempty(sections)
  s = size(sections);
  buttonstring = ['Sel All'];
  for i = 1:s(1)
    newstring = ['section ' num2str(i)];
    buttonstring = str2mat(buttonstring, newstring);
  end
end
set(B_HANDLES(3),'Style','Popup', 'String', ...
    buttonstring)
drawnow
prop = [0 0 0]; Dist = [];
hydroplt('replot')
return
