type Contents

% Contents of adhamlet GUI folder
%
% Figure:    Creates a new figure window and installs adhamlet
%
% adhamlet:  Umbrella program - adds window control
%            buttons and a full menubar to the
%            current figure window:
%              Print, Axes, Lines, Text, Display
%            PRINT menu will have some machine-
%              specific commands, but it does allow 
%              easy printing to an m-file or a post-script file!
%            DISPLAY menu allows manipulation
%              of control buttons, as well as the 
%              figure-dating function.
%			 Also prescribes a WindowButtonDownFunction
%            for the window which enable object selection
%            via the mouse: 
%            The remaining menus ONLY WORK on objects that
%            have been selected with the mouse, or with 
%            something like: >> set(gco,'Selected','on') 
%            These menus are described below:
%
% axesmenu:  Adds menu allowing you to easily change the
%            properties of axes in the current window. 
%            Also allows alignment and copy/paste.
% linemenu:  Adds menu containing a variety of plot-line
%            manipulation tools to current window
% textmenu:  Adds menu containing a variety of text
%            manipulation tools to current window
% dateme:    Adds the current date to the top right corner
%            of the current window. (It can then be moved 
%            and manipulated using the textmenu.)
%
% changeme:  Function to alter properties of selected objects
%            ESSENTIAL FOR OPERATION OF ALL MENUS (except print)
% moveobj:   Making an object's ButtonDownFcn callback, 'moveobj'	
%            enables you to click and drag an object anywhere  
%            on the figure window. (Used in buttons and some menus)
%
% cpaxes:    Function to copy/paste axes from one figure to another
% cpline2:   Function to copy/paste line objects from one axes to another
% cplabels:  Function to copy/paste title, x,y,z labels from one axes to another
% cpsurfs:   Function to copy/paste surfaces objects from one axes to another 
%    *       * all "cp" functions are only used by the Axesmenu function
% 
% gcmenu:    Short function aquires handle of current menu
%            Required! (but easy to write if missing)
%
% nohamlet:  Deletes all buttons and menus installed by adhamlet
%            Also deletes the date axes, and resets the figure's
%            Window button down function to [], which is the only 
%            sign that adhamlet has ever been there.
%
% hamdemo:   Generates multiple figures with which to test the capabilities
%            of adhamlet
%
% samplefi.gs:  Folder containing 4 basic figures (a-d) and one composite
%               figure (totalfig) built and fine-tuned using adhamlet.
%
% NOTE:      Some filenames have been changed since the original documentation
%            was written in order to accommodate the limitations of DOS based
%            computers and those with case-insensitive file naming protocols.
%            If a certain file name in the documentation cannot be found, look
%            for something similar (i.e. eight characters long and all in  
%            either upper case or lower case)
