% Filename: adhamlet.m
% Rev.date: 07/10/95
% Class: Function
%
% USAGE: "adhamlet" originally was named "addHamlet" and placed two 
%     uicontrol buttons at the bottom corners of the current figure window.
%	  One button deleted all uicontrols, clearing the window "for printing"
%	  The other button deleted the whole window (thus clearing the screen)
%	  I called them "to be" and "not to be"; hence the function's name.
%	  As it turns out, uicontrols don't print anyway.
%	  A sampling of the New Stuff since then:
%	  Submenu: Adjust line width of selected plot lines
%	  Submenu: Adjust line style of selected plot lines
%	  Submenu: Adjust marker size of selected plot lines
%	  Submenu: Adjust font size of selected text
%	  Submenu: Adjust font weight of selected text
%	  Submenu: Print to listed printers or an m-file
%	  Submenu: Show or hide date on side of figure window
%	  Buttons: Zoom button (imzoom if you have the image processing toolbox)
%	  Buttons: "to be" button now "cls": hides buttons for "capture" cmd
%	  Buttons: "Delete Figure" button now labelled just plain "X".
%     Buttons: All buttons are fully mobile! Click NEXT to the button
%              and drag to new location! (Then release mouse button).
%     Submenu: Workspace default values indicated by red lettering in menus.
%		
%	  Submenu: Axes manpulation, and more! ( I got tires of typing )
%
% Required Subroutines:
%
% 	function "axesmenu.m"	to enable Axes manipulation 
% 	function "linemenu.m"	to enable Line manipulation 
% 	function "textmenu.m"	to enable Text manipulation 
%	
% 	function "gcmenu.m" 
% 	  If you don't have it, write it:
%			function h = gcmenu
%			h = get( gcf, 'CurrentMenu' );
% 	  Pretty simple, huh?  ( If Matlab had a 'gcm' to go with 'gcf', 'gca',
%	  and 'gco', this would not have been neccessary; hint, hint... )
%
%	function "moveobj.m"  
%		If you don't have it, make a useless stand-in:
%			function moveobj
%			disp('Sorry, Object Mobility not currently available')
% 	    or else kill the "ButtonDownFcn" in all buttons.
%
%	function "dateme.m"  
%		If you don't have it, make a useless stand-in  
% 	    or kill the "Show Date" and "Hide Date" submenus.
	
% Written By: Kevin G. Kohrt
% Written on: 8/11/94 - 7/10/95
%
% Permission granted to include ADDHAMLET or some variation of it
% with any other script(s), as long no part of this comment section 
% is deleted or changed (excluding the Rev.Date, Filename, & Class). -KGK
% 
% Adapted By: 
% Adapted On:  
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	
	function adhamlet
	
%	size = get( gcf, 'Pos' );
%	set( gcf, 'Position', [ size(1:2)+[0 10] 500 400] );

	%
	% Enable  line and text identification
	% (WBDF ==> "Window Button Down Fcn")
	% ------------------------------------
	WBDF = [	'if exist(''ClickPoint'');',...
					'DoubleClick = ',...
						'( ClickPoint == get( gcf,''CurrentPoint'') );',...
				'end;',...
				'temp = get( gco,''Type'');',...
				'if DoubleClick;',...
					'if ( strcmp( temp,''line'') );',...
						'set( gco,''Color'', abs(1-get(gco,''Color'')) ),',...
						'if strcmp( get( gco,''Selected''),''on''); ',...
							 'set( gco,''Selected'',''off'');',...
						'else,'...
							 'set( gco,''Selected'',''on'');',...
						'end;',...
					'elseif(  ( strcmp( temp,''text'') ) ',...
							'| ( strcmp( temp,''axes'') ) );',...
						'if strcmp( get( gco,''Selected''),''on'');',...
							'set( gco,''Selected'',''off'');',...
						'else;',...
							'set( gco,''Selected'',''on'');',...
						'end;',...
					'end;',...
				'end; clear temp;',...
				'ClickPoint = get( gcf,''CurrentPoint'');'];
	set(gcf,'WindowButtonDownFcn', WBDF);

	%
	% Position vectors for buttons:
	% -----------------------------
		Pos(1,:) = [0.01 0.01 0.1 0.05];
		Pos(2,:) = [0.94 0.01 0.05 0.05];
		Pos(3,:) = [0.40 0.01 0.2 0.05];

	% ========================================================================
	% BUTTONS: Delete the figure window; Zoom on axis
	% ========================================================================
	% All Buttons are Mobile! Using Kev's great new moveobj Function!
	% ========================================================================
	% This button deletes the entire figure window (Boom!)
	% ----------------------------------------------------------
	  uicontrol( gcf,...
				'String',			'X',...
				'Style',			'push',...
				'Units',			'normalized',...
				'Position',			Pos(2,:),...
				'ButtonDownFcn',	'moveobj',...
		     	'CallBack',			[ ...
					' delete(gcf);',...
					' fprintf(''Plot deleted; Continue.\n>>'');' ]);
	% This button toggles the zoom state of the window
	% ----------------------------------------------------------
 	  uicontrol( gcf,...
				'String',			'Zoom!',...
				'Style',			'push',...
				'Units',			'normalized',...
				'Position',			Pos(3,:),...
				'ButtonDownFcn',	'moveobj',...
				'UserData',			WBDF,...
		     	'CallBack',			[...
					'if exist(''imzoom'');imzoom;else;zoom;end; ',...
					'if strcmp(get( gco,''String''),''Zoom!''); ',...
						'set(gco,''String'',''End Zoom''); ',...
					'else;',...
					 	'set(gco,''String'',''Zoom!'');',...
						'set(gcf,''WindowButtonDownFcn'',',...
									'get( gco,''UserData'') );',...
					'end; ' ] );
	% This button causes all uicontrols in the figure window to be deleted 
	% (i.e. for screen capture)
	% ----------------------------------------------------------
	uicontrol(gcf,'Style',		'push',	'String',	'cls',...
	     	'HorizontalAlign',	'center',...
			'Units',			'normalized',...
	        'Position',			Pos(1,:),...
			'ButtonDownFcn',	'moveobj',...
	    	'CallBack',			[...
				'set( findobj( gcf,''Style'',''pushbutton''), ',...
				'''Visible'',''off'');',...
				'set( findobj(gcf,''Label'',''Hide Pushbuttons''), ',...
				'''Checked'',''on'');',...
				'set( findobj(gcf,''Label'',''Show Pushbuttons''), ',...
				'''Checked'',''off'');',...
			' fprintf(''Buttons concealed; Continue.\n>>'');']);
	
	%
	% ========================================================================
	% MENU: 'Print  ': Chose printer
	% ========================================================================
	%
	  f = uimenu( 	'Label',		'Print '); 
	%
	% SUBMENU: Designate a printer: -Plw in the lab, or -Pme in the ME office
	% -----------------------------------------------------------------------
	     uimenu( f, 'Label',	'Page Setup',...
					'Callback',	[ 'if exist(''pgsetup'')>0;',...
						  ' fprintf(''pgsetup, by Keith Rogers\n>> '');',...
						  ' pgsetup; ',...
						  'else;',...
						  ' disp(''Feature not available'');',...
						  'end;' ],...
					'Separat',	'off' );

	     uimenu( f, 'Label',		'Print',...
					'Callback',		'print',...
					'Separator',	'off' );

	 g = uimenu( f, 'Label',		'Print as...',... 	
					'Separator',	'on' );

	     uimenu( g, 'Label',		'Color',...
					'Callback',		'print -dpsc',...
					'Separator',	'off' );

	     uimenu( g, 'Label',		'm-file...',...
					'Separator',	'on' ,...
					'Callback',		[...
						'filename = input(''Enter Filename: '',''s'');',...
						' set(gcf,''Name'',filename);',...
						'eval( [''print -dmfile '' filename ] );',...
						'fprintf(''\n>>''); clear filename' ] );  
	     uimenu( g, 'Label',		'post-script file...',...
					'Separator',	'off' ,...
					'Callback',		[...
						'filename = input(''Enter Filename: '',''s'');',...
						'eval( [''print -dps '' filename ] );',...
						'fprintf(''\n>>''); ' ] );  

	     uimenu( g, 'Label',		'B&W to another printer',...
					'Callback',		['ans = input(''Printer name?'',''s'');',...
									 ' eval( [''print -P''ans ] );' ],...  
					'Separator',	'on' );

	% ========================================================================
	% MENU: 'Axes  ': Adjust Axes Properties
	% ========================================================================
		axesmenu
	% ========================================================================
	% MENU: 'Line  ': Adjust line thickness and style
	% ========================================================================
		linemenu	
	% ========================================================================
	% MENU: 'Text ': Adjusts text properties of all selected objects in window
	% ========================================================================
		textmenu
	% ========================================================================
	% MENU: 'Display  ': Adjust display
	% ========================================================================
	%
	  k = uimenu( 	'Label',		'Display ');
	%
	% SUBMENU: Show or hide pushbuttons
	% -----------------------------------------------------------------------
		uimenu( k,	'Label',		'Deselect All',...
					'Callback',		[...
						'changeme(''line'',''Selected'',''off'');' ...
						'changeme(''text'',''Selected'',''off'');' ...
						'changeme(''axes'',''Selected'',''off'');' ] );

	    uimenu( k, 	'Label',		'Show Pushbuttons',...
					'Checked',		'on' ,...
					'Separator',	'on' ,...
					'Callback',		[...
						'state = get( gcmenu,''checked'');',...
						'if strcmp( state,''on''); state =''off'';',...
						'else; state =''on''; end;',...
						'set( gcmenu,''checked'', state );',...
						'set( findobj( gcf,''Style'',''pushbutton''), ',...
						'''Visible'', state ); clear state;'] ); 

		h = uimenu( k, 'Label',		'Show Date',...
					'Checked',		'on' ,...
					'Callback',		[...
						'state = get( gcmenu,''checked'');',...
						'if strcmp( state,''on''); state =''off'';',...
						'else; state =''on''; end;',...
						'set( gcmenu,''checked'', state );',...
						'dateme(state);' ] );

		datehand = findobj( gcf, 'UserData', 'datetext' );
		if isempty( datehand )
			ax = gca; dateme on; axes( ax ); %set( h, 'Checked', 'on' );
		end;

	    uimenu( k, 	'Label',		'Show Actual Size',...
					'Separator',	'on' ,...
					'Callback',		[...
						'oldu = get( gcf,''Units'');',...
						'set( gcf,''Units'', get( gcf,''PaperUnits'') );',...
						'newp = get( gcf,''PaperPosition'');',...
						'set( gcf,''Position'', [ 1 1 newp( 3:4 ) ] );',...
						'set( gcf,''Units'', oldu );' ] )


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	%
	% REVISION HISTORY
	%
	% 8/11/94	Script written for use with Prog2 and hairSPG
	%
	% 9/x/94	Printing menu added
	%
	% 9/29/94	Delete Buttons button removed
	%			Delete Plot button shank to minimum
	%
	% 9/30/94	Accelerators dropped, since their function isn't retained 
	%				by the figure window
	% 			Properties of any graphs in window now adapted as follows:
	%			 	Line width doubled
	%
	% 10/6/94  Properties of graphs can now be adjusted via Plot Options menu
	%			Adjustable Properties:
	%			Line Weight
	%			Font Size
	%			Font Weight
	%
	% 10/7/94	Text adjustments put under own main menu labeled 'Text'
	%
	% 10/10/94	Plot line options put under own 'Line' Menu
	%			 adj. Line Style added
	%			 adj. Marker Size added
	%
	% 12/1/94	"findobj" used instead of my own lengthy search method.
	%			It really cleaned up the code.
	%
	% 01/16/95	"Hide Buttons" returned to code for use with screen captures
	%			using xview or some such thing
	%
	% 01/26/95	"Zoom" added to "Display" menu, and as a button
	%
	% 03/27/95  Color printing and printing to -dmfile debugged at last.
	%			Ability of dateme.m to toggle date-text on and off employed.
	%			Documentation updated.
	%			Function "Imzoom" used instead of "zoom" if available
    %
	% 03/30/95	All buttons made mobile with a moveobj fuction call
	%			  in their ButtonDownFcn.
	%			"Zoom" menu deleted ( "Zoom" button remains )
	%			"Show Date" & "Hide Date" buttons checked according whether
	%			  or not the figure contains a "dateme" date yet.
	%           Workspace default values indicated by red lettering, and 
	%			  are not initially checked off
	%
	% 03/31/95	Wowza! Axes menu added, then Axes, Line, and Text menus
	%			broken out into individual function calls. Full blown 
	% 			manipulation now possible: Grid Lines, Axes Labels, Line 
	%			Colors, Mass object selection/deselection, DoubleClick
	%			to select, Axes limits, Axes box thickness, Hide axes,
	%			delete selected items, etc... Try it out!
	% 04/05/95	Bug fixed in group line selection so that only unselected
	%			lines in a group are marked selected (otherwise, when 
	%			selected lines were reselected, their color would be wrong)
	% 07/10/95  Printing commands changed to (hopefully) be more applicable
    %           to any given setup. Probably still limited to unix mach, though.
    %           Oh, well.
	% 08/11/95  Figure given same name as m-file when printing to an Mfile
	%			(but only if the figure does not have a name yet)
