% filename: hamfig.m
% rev.date: 2/8/95
% class   : function
%
% USAGE: hamfig     - creates a figure window and adds the adhamlet GUI
%                     buttons and menus; 
%
%        h = hamfig - The figure's handle, h, is returned (optional)
%
%        hamfig(f)  - hamfig no. f is made the current window, and if there
%                     are fewer than 4 uimenus on it, adhamlet is added.
%                     (optional)
%
% NOTE:               (options 2 & 3 can be used together, though redundant)

%   Written by: Kevin G Kohrt
%   Written on: 31 Oct 1994
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%% START OF FUNCTION %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

	function h = hamfig( f )
%-----------------------------------------------------------------------------
%	Verify inputs, and create figure if necessary
%-----------------------------------------------------------------------------
	if nargin == 1;
		figure( f );
	elseif nargin > 1
		error('Error using ==> hamfig;  Too many input arguments')
	else
		f = figure;
	end 
%-----------------------------------------------------------------------------
%	Add adhamlet if not already present
%-----------------------------------------------------------------------------
	kids = get( f, 'children' );
	if isempty( kids );
		adhamlet;
	else
		menus = findobj( kids, 'flat', 'type', 'uimenu' ); 
		if menus < 4; 			adhamlet;		end;
	end;  
%-----------------------------------------------------------------------------
%	Verify Outputs
%-----------------------------------------------------------------------------
	if nargout == 1; 			h = f; 			end;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% END FUNCTION %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% Revision Data:
%
% 10/31/94  hamfig function created as one line: figure; adhamlet
%
% 02/08/95  Options added:  h - returned handle of figure window
%                           f - user defined figure to add adhamlet to
%          (for use in For loops, or other places where you want a figure
%           with adhamlet, but don't know if the figure exists or if it
%           has adhamlet already)
%           I/O arguments checked
