% Filename: moveobj.m
% Rev.Date: 8/12/95
%
% USAGE:  Making an object's ButtonDownFcn callback, 'moveobj'	
%         enables you to click and drag an object anywhere on the 
%         figure window. 
%         CAVEATS: 1 - must click NEXT to (not on) most uicontrols
%                  2 - the current figure's WindowButtonMotionFcn
%                      and WindowButtonUpFcn are overwritten in this
%                      process!
%                  3 - mouse position determines bottom left corner
%                      of object being moved
%                  4 - Tested on the following objects:
%                         Pushbuttons
%						  Axes
%						  Text! - but not very well:
%        If the text 'disappears' DON'T let go of the mouse button!
%        Instead, drag the cursor very close to the origin, the text
%        should show up again. I can't quite find the translation of
%        units between current mouse position and place-the-text position.

% Written by: Kevin G. Kohrt
% Written on: 28 March 1995
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function moveobj

    Object 		= gco;
    ObjUnits 	= get( Object,'Units' ); 

	if strcmp( get( Object, 'Type' ), 'text' )
		Axs = get( Object, 'Parent' );
		axes( Axs );
    	set( Object, 'Units', 'data' );   %get( Axs, 'Units' ) ); 
		dx = get( Axs, 'Xlim' ); dy = get( Axs, 'Ylim' );
	    WBMF	= [	' ObjPos = get( gca,''CurrentPoint'' );',...
				 	' set( gco,''Position'',',...
				    '	  [ ObjPos(1,1:2) ] );' ];
	    WBUF = [ ' set( gcf, ''WindowButtonMotionFcn'','' '' );',...
				 ' set( gcf, ''WindowButtonUpFcn'','' '' );',...
				 ' set( gco, ''Units'', ''' ObjUnits ''' );',...
				 ' fprintf( ''New position: [ %4.2f %4.2f %4.2f ] ',...
				 ' \n>> '',  get(gco,''Pos'') );' ];
	else
    	set( Object, 'Units', get( gcf, 'Units' ) ); 
    	ObjSiz 		= get( Object,'Position' );
		ObjSiz 		= ObjSiz( 1, 3:4 ); 
    
	    WBMF = [ ' ObjPos = get( gcf,''CurrentPoint'' );',...	
				 ' set( gco,''Position'',',...
				 '	  [ ObjPos, ' num2str(ObjSiz(1)) ', ',...
							      num2str(ObjSiz(2)) ' ] );' ];
     
	    WBUF = [ ' set( gcf, ''WindowButtonMotionFcn'','' '' );',...
				 ' set( gcf, ''WindowButtonUpFcn'','' '' );',...
				 ' set( gco, ''Units'', ''' ObjUnits ''' );',...
				 ' fprintf( ''New position: [ %3.0f %3.0f ] ',...
				 ' \n>> '', ObjPos);' ];
	end
%					' NewPos = [(ObjPos(1)-(' num2str(dx(1)) '))/',...
%						num2str( dx(2) - dx(1) ) ', (ObjPos(2)-(',...
%						num2str(dy(1)) '))/' num2str( dy(2) - dy(1) ) '];',...
    
	    set( gcf,'WindowButtonMotionFcn', WBMF );
		set( gcf, 'WindowButtonUpFcn', WBUF );


% 3/28/95  Code written
% 7/10/95  segment added to display new position of object on button release
% 8/12/95  Ah!Ha! Setting 'units' = 'data' allows text objects to be 
%          moved correctly!
% 8/18/95  Bug in moving text on axes with negative limits fixed.
%		   New position text response corrected for text.
