% filename: nohamlet.m
% Rev.Date: 7/11/95
% Class:    function
%
% USAGE: nohamlet( Fig ) removes all traces of addHamlet from 
%        the figure window Fig (default is current figure).
%        It well be as if addHamlet was never applied - except
%        for the figure's 'WindowButtonDownFunction', which had
%        to be overwritten.

% Written By: Kevin G. Kohrt, kkohrt@engr.iupui.edu
% Written On: 4/12/95 - 7/10/95
%
% Permission granted to include nohamlet or some variation of it
% with any other script(s), as long no part of this comment section 
% is deleted or changed (excluding the Rev.Date, Filename, & Class). -KGK
%
% Adapted By: 
% Adapted On:  
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  function nohamlet

  if nargin < 1; Fig = gcf; end

  ch = get( Fig, 'children' );

  for idx = 1 : length(ch)
% find and kill all addHamlet menus
	if  strcmp( lower( get( ch(idx), 'type' ) ), 'uimenu' ) ...
		ans = get( ch(idx), 'label' );
		if	 strcmp( ans, 'Print ' ) | ...
			 strcmp( ans, 'Axes ' ) | ...
			 strcmp( ans, 'Lines ' ) | ...
			 strcmp( ans, 'Text ' ) | ...
			 strcmp( ans, 'Display ' )
		delete( ch(idx) )
		end
% find and kill all addHamlet buttons
	 elseif strcmp( lower( get( ch(idx), 'type' ) ), 'uicontrol' ) 
		ans = get( ch(idx), 'string' );
		if	 strcmp( ans, 'cls' ) | ...
			 strcmp( ans, 'Zoom!' ) | ...
			 strcmp( ans, 'End Zoom' ) | ...
			 strcmp( ans, 'X' ) 
		delete( ch(idx) );
		end 
% find and kill the date 
	 elseif strcmp( lower( get( ch(idx), 'userdata' ) ), 'dateaxes' )
		delete( ch(idx) );
	 end
  end
% reset the window button down function
  set( Fig, 'WindowButtonDownF', '' )

% END
