%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                                                         %
%                       CURSORES  1.0                     %
%                                                         %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
%For a good appearance, please set your screen resolution
%to 800x600 or higher and UIControl Fontsize to 8 or 10
%
%
%CURSORES is a GUI aid for helping you to get numerical
%values from a Line_plot.
%It lets the user to stablish up to four simultaneous
%crosshairs, assigned to any of the line_objects present
%in the figure being analized.
%You're also allowed to assign a function between a pair
%of crosshairs, choosing one from seven possibilities.
%If the case is that your figure has many line_objects and
%some of them are drawn in the same color, you'll be able
%to modify some properties to make them appear different
%so to have a better appearance, CURSORES has functions to
%let the user change the Color, LineWidth and LineStyle.
%
%CURSORES works over a pre-created figure where you've plotted
%some line_objects, without restrictions about their number
%or length of its X and YData.
%The only restrictions at this release are the following:
%    the figure has only one axis child
%    there aren't any uicontrols
%    view is [0,90] (MATLAB's default view for 2-D plots)
%    at least, there's one line_object
%Once you have a plot to analize, at the MATLAB prompt enter:
%cursores
%then, your figure will change, axes will be resized in order
%to free space for the uicontrols that will appear on the screen,
%at the first moment, you'll be suggested for an operating mode
%by an EditableText at the figure's bottom, follow it and take 
%advantage of the tools provided.
%
%In the beguinning, nothing works but the PushButton which activates
%lines, if you press it, then you may select any line_object in the
%figure by pressing near it with either one of the mouse buttons,
%once selected, the line becomes more width for a second to remark
%your selection, after what the other functionallities are stated.
%Now you may assign one or several cursors to that line by selecting
%the appropiate CheckBoxes and then accepting your selection with the 
%Accept_C PushButton, you may also wish to perform a mathematical
%operation between a pair of cursors, so you should select the desired
%function from the PopupMenu and assigning it by selecting the function's
%RadioButton and then accepting with the Accept_F PushButton.
%If you would like to change the appearance of any line, I encourage you
%to do it just after selecting it, prior to make work the cursors.
%Once you've stated the functionallity desired, make it work by selecting
%one cursor with its PushButton and then pressing the mouse inside the
%axis, the crosshair which stands for the cursor will track the pointer's
%movement while maintaining itself over the line_object to which it's
%associated, besides, the values representig the cursor's place and the
%function performed will be updated. This operation will be made in
%real time depending on your machine's speed, but in most cases this will
%be true. Releasing the mouse stops the cursor's and function's updating.
%If you decide to change any function, you'll need to select again the
%cursor's PushButton to make this change active.
%
%
%I hope you'll find this group of functions useful and easy to use
%if you had any problem, want any acclaration or anything else you
%could desire to do about it, please contact me and I'll be very
%pleased to try to help you as far as I can.
%Thank you for paying me your attention.
%
%
%___________________________________________________
%   Copyright (c) Pepe Moreno Andrades, Mayo-1996   
%
%       Grupo de Sistemas Fotonicos
%       DEPARTAMENTO DE TECNOLOGIA FOTONICA
%       E T S I TELECOMUNICACION 
%       UNIVERSIDAD POLITECNICA MADRID
%       28040 MADRID (SPAIN)
%       Tf:    (34)-1-3367318
%       Fax:   (34)-1-3367319
%       Email: pepe@tfo.upm.es
%
%
%	This Work has been supported by Spanish CICYT TIC95-0250-C02-01
%	Leadered by Professor: Miguel Angel Muriel
%________________________________________________________________________
