function ezarrow(command)
%
%   GUI input for adding arrows to the current figure 
%   
%   typing 'ezarrow' from the command line opens an 
%   interactive dialogue box, allowing the user to add
%   arrows to the current figure.  Ezarrow places arrows `on top'
%   of the existing figure, and hence arrows should be added after
%   the figure is completed.  
%
%   Note: This function uses arrow.m written by 
%         Erik A. Johnson <johnsone@uxh.cso.uiuc.edu>, 11/13/95
%         Available on the Mathworks' ftp site. 
%                             
%   Richard G. Cobb    3/96
%   rcobb@afit.af.mil
%

if nargin < 1
%
figold=gcf;
haold=gca;
arrax=axes('position',[0,0,1,1],'units','normalized',...
          'visible','off');
siblines=999;
si=zeros(9,1);si2=si;
si(1:length(siblines))=siblines;
leginp=figure('Color','k','NumberTitle','off','Name',...
	'EZ ARROW',...
	'NextPlot','new',...
	'Units','Normalized',...
        'Menubar','none',...
	'Position',[.1 .1  .4 .2+.05*length(siblines)]);
sfactor=.25/(.1+.05*length(siblines))/2;
axis off
axis([0,1,0,1])
   Y = linspace(0,.75,length(siblines))';
ui=zeros(9,1); bi=zeros(9,1);
exaxx=gca;
 
T=['tbd'];
T1=['30 ';'45 ';'60 ';'90 ';'120'];
T2=['15';'30';'45';'60'];
T3=['3 ';'6 ';'9 ';'12';'15';'20';'30';'60'];
T4=[' - ';' --';' : ';' -.'];
T5=['THIN';'Thin';'thin';'fat ';'Fat ';'FAT '];
T7=['cyan   ';'magenta';'green  ';'red    ';'yellow ';...
      'blue   ';'black  ';'white  '];

 uicontrol('Parent',leginp,...
			'style','pushbutton',...
			'string','Close',...
			'units','normalized',...
			'position',[.1 .8 .15 .1*sfactor],...
			'callback','ezarrow(8)');
 
 uicontrol('Parent',leginp,...
			'style','pushbutton',...
			'string','Refresh',...
			'units','normalized',...
			'position',[.3 .8 .15 .1*sfactor],...
			'callback','ezarrow(5)');


 uicontrol('Parent',leginp,...
			'style','pushbutton',...
			'string','Add arrow',...
			'units','normalized',...
			'position',[.5 .8 .2 .1*sfactor],...
			'callback','ezarrow(6)');
uicontrol('Parent',leginp,...
			'style','pushbutton',...
			'string','Delete arrow',...
			'units','normalized',...
			'position',[.75 .8 .2 .1*sfactor],...
			'callback','ezarrow(7)');

uicontrol('Parent',leginp,...
			'style','pushbutton',...
			'string','Next',...
			'units','normalized',...
			'position',[.02 .02 .2 .1*sfactor],...
			'callback','ezarrow(4)');


 ui(1) = uicontrol('Style','Popup','Units','Normalized',...
			'Position',[.3 .6 .2 .1*sfactor],...
			'String',T1,...
			'Visible','off',...
                        'HorizontalAlignment', 'left',...
			'CallBack','ezarrow(9)');
 bi(1) = uicontrol('Style','pushbutton','Units','Normalized',...
			'Position',[.3 .6 .2 .1*sfactor],...		
			'String','BaseAngle',...
			'Visible','on',...
                        'CallBack','ezarrow(10)');
 ui(2) = uicontrol('Style','Popup','Units','Normalized',...
			'Position',[.3 .5 .2 .1*sfactor],...
			'String',T2,...
			'Visible','off',...
                        'HorizontalAlignment', 'left',...
			'CallBack','ezarrow(11)');
 bi(2) = uicontrol('Style','pushbutton','Units','Normalized',...
			'Position',[.3 .5 .2 .1*sfactor],...		
			'String','TipAngle',...
			'Visible','on',...
                        'CallBack','ezarrow(12)');
 ui(3) = uicontrol('Style','Popup','Units','Normalized',...
			'Position',[.3 .4 .2 .1*sfactor],...
			'String',T3,...
			'Visible','off',...
                        'HorizontalAlignment', 'left',...
			'CallBack','ezarrow(13)');
 bi(3) = uicontrol('Style','pushbutton','Units','Normalized',...
			'Position',[.3 .4 .2 .1*sfactor],...		
			'String','Length',...
			'Visible','on',...
                        'CallBack','ezarrow(14)');
 ui(4) = uicontrol('Style','Popup','Units','Normalized',...
			'Position',[.52 .6 .2 .1*sfactor],...
			'String',T4,...
			'Visible','off',...
                        'HorizontalAlignment', 'left',...
			'CallBack','ezarrow(15)');
 bi(4) = uicontrol('Style','pushbutton','Units','Normalized',...
			'Position',[.52 .6 .2 .1*sfactor],...		
			'String','LineStyle',...
			'Visible','on',...
                        'CallBack','ezarrow(16)');
 ui(5) = uicontrol('Style','Popup','Units','Normalized',...
			'Position',[.52 .5 .2 .1*sfactor],...
			'String',T5,...
			'Visible','off',...
                        'HorizontalAlignment', 'left',...
			'CallBack','ezarrow(17)');
 bi(5) = uicontrol('Style','pushbutton','Units','Normalized',...
			'Position',[.52 .5 .2 .1*sfactor],...		
			'String','LineWidth',...
			'Visible','on',...
                        'CallBack','ezarrow(18)');
 ui(6) = uicontrol('Style','Popup','Units','Normalized',...
			'Position',[.52 .4 .2 .1*sfactor],...
			'String',T5,...
			'Visible','off',...
                        'HorizontalAlignment', 'left',...
			'CallBack','ezarrow(19)');
 bi(6) = uicontrol('Style','pushbutton','Units','Normalized',...
			'Position',[.52 .4 .2 .1*sfactor],...		
			'String','Width',...
			'Visible','on',...
                        'CallBack','ezarrow(20)');
 ui(7) = uicontrol('Style','Popup','Units','Normalized',...
			'Position',[.74 .6 .2 .1*sfactor],...
			'String',T7,...
			'Visible','off',...
                        'HorizontalAlignment', 'left',...
			'CallBack','ezarrow(21)');
 bi(7) = uicontrol('Style','pushbutton','Units','Normalized',...
			'Position',[.74 .6 .2 .1*sfactor],...		
			'String','Color',...
			'Visible','on',...
                        'CallBack','ezarrow(22)');
 ui(8) = uicontrol('Style','Popup','Units','Normalized',...
			'Position',[.74 .5 .2 .1*sfactor],...
			'String',T7,...
			'Visible','off',...
                        'HorizontalAlignment', 'left',...
			'CallBack','ezarrow(23)');
 bi(8) = uicontrol('Style','pushbutton','Units','Normalized',...
			'Position',[.74 .5 .2 .1*sfactor],...		
			'String','EdgeColor',...
			'Visible','on',...
                        'CallBack','ezarrow(24)');
 ui(9) = uicontrol('Style','Popup','Units','Normalized',...
			'Position',[.74 .4 .2 .1*sfactor],...
			'String',T7,...
			'Visible','off',...
                        'HorizontalAlignment', 'left',...
			'CallBack','ezarrow(25)');
 bi(9) = uicontrol('Style','pushbutton','Units','Normalized',...
			'Position',[.74 .4 .2 .1*sfactor],...		
			'String','FaceColor',...
			'Visible','on',...
                        'CallBack','ezarrow(26)');

	SliderH = uicontrol('Style','Slider',...
				'Position',[.3 .25 .3 .07],...
				'Units','normalized',...
				'Value',0,...
				'Min',-.25,...
				'Max',.25,...
				'Callback','ezarrow(30)');
      		 uicontrol(...
			'style','text',...
			'string','Horizontal',...
			'units','normalized',...
                        'HorizontalAlignment','Center',...
			'position',[.3 .175 .3 .07],...
			'BackgroundColor',[ 0 0 0 ],... 
			'ForegroundColor',[ 0 1 0 ]);

       SliderV = uicontrol('Style','Slider',...
				'Position',[.3 .1 .3 .07],...
				'Units','normalized',...
				'Value',0,...
				'Min',-.25,...
				'Max',.25,...
				'Callback','ezarrow(31)');
		uicontrol(...
			'style','text',...
			'string','Vertical',...
			'units','normalized',...
                        'HorizontalAlignment','Center',...
			'position',[.3 .025 .3 .07],...
			'BackgroundColor',[ 0 0 0 ],... 
			'ForegroundColor',[ 0 1 0 ]);

       SliderR = uicontrol('Style','Slider',...
				'Position',[.65 .25 .3 .07],...
				'Units','normalized',...
				'Value',0,...
				'Min',-90,...
				'Max',90,...
				'Callback','ezarrow(32)');
 	uicontrol(...
			'style','text',...
			'string','Rotation',...
			'units','normalized',...
                        'HorizontalAlignment','Center',...
			'position',[.65 .175 .3 .07],...
			'BackgroundColor',[ 0 0 0 ],... 
			'ForegroundColor',[ 0 1 0 ]);

       SliderS = uicontrol('Style','Slider',...
				'Position',[.65 .1 .3 .07],...
				'Units','normalized',...
				'Value',1,...
				'Min',.5,...
				'Max',1.5,...
				'Callback','ezarrow(33)');

	uicontrol(...
			'style','text',...
			'string','Scaling',...
			'units','normalized',...
                        'HorizontalAlignment','Center',...
			'position',[.65 .025 .3 .07],...
			'BackgroundColor',[ 0 0 0 ],... 
			'ForegroundColor',[ 0 1 0 ]);



mh=zeros(size(ui));mh(6)=haold;mh(5)=arrax;mh(4)=exaxx;
lh=zeros(size(ui));lh(1)=leginp;lh(2)=figold;lh(3)=SliderH;
lh(4)=SliderV; lh(5)=SliderR; lh(6)=SliderS;
%[si ui bi mh si2 lh]
set(leginp,'UserData',[si ui bi mh si2 lh]);

elseif command == 1

elseif command == 2

elseif command == 3
elseif command == 4
  handles = get(gcf,'UserData');
   if handles(1,1) ~= 999
    tmp=handles(1,1);
    handles(find(handles(2:size(handles,1),1)),1)=handles(find(handles(2:size(handles,1),1))+1,1);
    handles(max(find(handles(:,1))),1)=tmp;
      delete(handles(1,5))
      handles(1,5)=arrow([.05 0],[.05 .75]);
      ud=get(handles(1,1),'UserData');
      uxex=get(handles(1,5),'UserData');
      uxex(7:15)=ud(7:15);
      set(handles(1,5),'UserData',uxex);
      arrow(handles(1,5))
      set(handles(1,5),'FaceColor',get(handles(1,1),'FaceColor'),...
	'EdgeColor',get(handles(1,1),'EdgeColor'),...
	'Cdata',get(handles(1,1),'Cdata'),...
	'LineWidth',get(handles(1,1),'LineWidth'))

   end 
  set(handles(1,6),'Userdata',handles);
elseif command == 5
  handles = get(gcf,'UserData');
  refresh(handles(1,6));
  refresh(handles(2,6));
 
elseif command == 6
  handles = get(gcf,'UserData');
  axes(handles(5,4));
  if handles(1,1) ~= 999
   handles(find(handles(:,1))+1,1)=handles(find(handles(:,1)),1);
  end
  handles(1,1)=myarrow;
  axes(handles(4,4));
  if handles(1,5) ~= 0
   delete(handles(1,5))
  end
  handles(1,5)=arrow([.05 0],[.05 .75]);
  set(handles(1,6),'Userdata',handles);

elseif command == 7
  handles = get(gcf,'UserData');
   if handles(1,1) ~= 999
    delete(handles(1,1));
    delete(handles(1,5));
    if handles(2,1) ~= 0
      handles(1,5)=arrow([.05 0],[.05 .75]);
      ud=get(handles(2,1),'UserData');
      uxex=get(handles(1,5),'UserData');
      uxex(7:15)=ud(7:15);
      set(handles(1,5),'UserData',uxex);
      arrow(handles(1,5))
      set(handles(1,5),'FaceColor',get(handles(2,1),'FaceColor'),...
	'EdgeColor',get(handles(2,1),'EdgeColor'),...
	'Cdata',get(handles(2,1),'Cdata'),...
	'LineWidth',get(handles(2,1),'LineWidth'))
     else
     handles(1,5)=0;
    end
    handles(1,1)=0;
    handles(find(handles(:,1))-1,1)=handles(find(handles(:,1)),1); 
  end
  if handles(1,1) == 0
     handles(1,1) = 999;
  elseif max(find(handles(:,1))) > 1
     handles(max(find(handles(:,1))),1)=0;
  end
  set(handles(1,6),'Userdata',handles);
elseif command == 8
  handles = get(gcf,'UserData');
  delete(handles(1,6));

elseif command == 9
        T1=['30 ';'45 ';'60 ';'90 ';'120'];
	handles = get(gcf,'UserData');
        if handles(1,1) ~= 999
        arrow(handles(1,1),'BaseAngle',eval(T1(get(handles(1,2),'Value'),:)));
        arrow(handles(1,5),'BaseAngle',eval(T1(get(handles(1,2),'Value'),:)));
     	end   
	set(handles(1,3),'Visible', 'on')
        set(handles(1,2),'Visible', 'off')
        
elseif command == 10
	handles = get(gcf,'UserData');
        set(handles(1,2),'Visible', 'on')
        set(handles(1,3),'Visible', 'off')

elseif command == 11
        T2=['15';'30';'45';'60'];
	handles = get(gcf,'UserData');
        if handles(1,1) ~= 999
        arrow(handles(1,1),'TipAngle',eval(T2(get(handles(2,2),'Value'),:)));
        arrow(handles(1,5),'TipAngle',eval(T2(get(handles(2,2),'Value'),:)));
    	end
        set(handles(2,3),'Visible', 'on')
        set(handles(2,2),'Visible', 'off')
	
elseif command == 12
	handles = get(gcf,'UserData');
        set(handles(2,2),'Visible', 'on')
        set(handles(2,3),'Visible', 'off')

elseif command == 13
        T3=['3 ';'6 ';'9 ';'12';'15';'20';'30';'60'];
	handles = get(gcf,'UserData');
	if handles(1,1) ~= 999
        arrow(handles(1,1),'Length',eval(T3(get(handles(3,2),'Value'),:)));
        arrow(handles(1,5),'Length',eval(T3(get(handles(3,2),'Value'),:)));
	end
	set(handles(3,3),'Visible', 'on')
        set(handles(3,2),'Visible', 'off')
	
elseif command == 14
	handles = get(gcf,'UserData');
        set(handles(3,2),'Visible', 'on')
        set(handles(3,3),'Visible', 'off')

elseif command == 15
        T4=[' - ';' --';' : ';' -.'];
	handles = get(gcf,'UserData');
	if handles(1,1) ~= 999
        figure(handles(2,6));
        handles(1,1) = arrow(handles(1,1),'LineStyle',T4(get(handles(4,2),'Value'),:));
        figure(handles(1,6));
 	handles(1,5) = arrow(handles(1,5),'LineStyle',T4(get(handles(4,2),'Value'),:));
    	end
    	set(handles(4,3),'Visible', 'on')
        set(handles(4,2),'Visible', 'off')
	set(handles(1,6),'Userdata',handles);

elseif command == 16
	handles = get(gcf,'UserData');
        set(handles(4,2),'Visible', 'on')
        set(handles(4,3),'Visible', 'off')

elseif command == 17
        T5=['1';'2';'3';'4';'5';'6'];
	handles = get(gcf,'UserData');
	if handles(1,1) ~= 999
        arrow(handles(1,1),'LineWidth',eval(T5(get(handles(5,2),'Value'),:)));
        arrow(handles(1,5),'LineWidth',eval(T5(get(handles(5,2),'Value'),:)));
	end
        set(handles(5,3),'Visible', 'on')
        set(handles(5,2),'Visible', 'off')
	
elseif command == 18
	handles = get(gcf,'UserData');
        set(handles(5,2),'Visible', 'on')
        set(handles(5,3),'Visible', 'off')

elseif command == 19
        T6=['1 ';'3 ';'6 ';'10';'16';'20'];
	handles = get(gcf,'UserData');
	if handles(1,1) ~= 999
        arrow(handles(1,1),'Width',eval(T6(get(handles(6,2),'Value'),:)));
        arrow(handles(1,5),'Width',eval(T6(get(handles(6,2),'Value'),:)));
	end
        set(handles(6,3),'Visible', 'on')
        set(handles(6,2),'Visible', 'off')


elseif command == 20
	handles = get(gcf,'UserData');
        set(handles(6,2),'Visible', 'on')
        set(handles(6,3),'Visible', 'off')

elseif command == 21
        T7=['cyan   ';'magenta';'green  ';'red    ';'yellow ';...
      'blue   ';'black  ';'white  '];
	handles = get(gcf,'UserData');
        if handles(1,1) ~= 999
        arrow(handles(1,1),'Color',T7(get(handles(7,2),'Value'),:));
        arrow(handles(1,5),'Color',T7(get(handles(7,2),'Value'),:));
        end
        set(handles(7,3),'Visible', 'on')
        set(handles(7,2),'Visible', 'off')

elseif command == 22
	handles = get(gcf,'UserData');
        set(handles(7,2),'Visible', 'on')
        set(handles(7,3),'Visible', 'off')

elseif command == 23
         T8=['cyan   ';'magenta';'green  ';'red    ';'yellow ';...
      'blue   ';'black  ';'white  '];
	handles = get(gcf,'UserData');
        if handles(1,1) ~= 999
        arrow(handles(1,1),'EdgeColor',T8(get(handles(8,2),'Value'),:));
        arrow(handles(1,5),'EdgeColor',T8(get(handles(8,2),'Value'),:));
        end
        set(handles(8,3),'Visible', 'on')
        set(handles(8,2),'Visible', 'off')

elseif command == 24
	handles = get(gcf,'UserData');
        set(handles(8,2),'Visible', 'on')
        set(handles(8,3),'Visible', 'off')

elseif command == 25
        T9=['cyan   ';'magenta';'green  ';'red    ';'yellow ';...
      'blue   ';'black  ';'white  '];
	handles = get(gcf,'UserData');
	if handles(1,1) ~= 999
        arrow(handles(1,1),'FaceColor',T9(get(handles(9,2),'Value'),:));
        arrow(handles(1,5),'FaceColor',T9(get(handles(9,2),'Value'),:));
	end
        set(handles(9,3),'Visible', 'on')
        set(handles(9,2),'Visible', 'off')

elseif command == 26
	handles = get(gcf,'UserData');
        set(handles(9,2),'Visible', 'on')
        set(handles(9,3),'Visible', 'off')

elseif command == 30
	handles = get(gcf,'UserData');
	if handles(1,1) ~= 999
        trnslate(handles(1,1),[get(handles(3,6),'Value') 0 0 ])
	end
        set(handles(3,6),'Value',0)
     
elseif command == 31
	handles = get(gcf,'UserData');
	if handles(1,1) ~= 999
        trnslate(handles(1,1),[0 get(handles(4,6),'Value') 0 ])
	end
	set(handles(4,6),'Value',0)
elseif command == 32
	handles = get(gcf,'UserData');
	if handles(1,1) ~= 999
        rotate(handles(1,1),[0 90],get(handles(5,6),'Value'),findcntr(handles(1,1)))
        nx = get(handles(1,1),'Xdata');
        ny = get(handles(1,1),'Ydata');
        nz = get(handles(1,1),'Zdata');
        ud=get(handles(1,1),'Userdata');
	ud(1)=nx(6);
	ud(2)=ny(6);
	ud(3)=nz(6);
	ud(4)=nx(1);
	ud(5)=ny(1);
	ud(6)=nz(1);
	set(handles(1,1),'Userdata',ud);
	end
	set(handles(5,6),'Value',0)
elseif command == 33
	handles = get(gcf,'UserData');
	if handles(1,1) ~= 999
        scalhand(handles(1,1),get(handles(6,6),'Value') )
        nx = get(handles(1,1),'Xdata');
        ny = get(handles(1,1),'Ydata');
        nz = get(handles(1,1),'Zdata');
        ud=get(handles(1,1),'Userdata');
	ud(1)=nx(6);
	ud(2)=ny(6);
	ud(3)=nz(6);
	ud(4)=nx(1);
	ud(5)=ny(1);
	ud(6)=nz(1);
	set(handles(1,1),'Userdata',ud);
	end
	set(handles(6,6),'Value',1)

elseif command == 98
elseif command == 99
end
