function reply=figarrow(callback)
%function figarrow
%
global FGkey
global FGfig_mode
global FGselect FGhselect FGarrowmode FGjoinmode

% dialog box which will also create the text object
[hdata,htext,hkey]=figga(gca);
if htext~=0 
   axes(htext); 
end

if strcmp(callback,'startadd')
   FGselect=0; FGhselect=0;
% create a text axis behind the data axis!
   if htext==0
      pos=get(hdata,'position');
      units=get(hdata,'units');
      htext=axes('position',pos,'units',units,...
	'xlim',[0 1],'ylim',[0 1],'visible','off');
      figsa(hdata,htext,hkey);
   end

   figmess('Enter start position');
   [x,y,k]=figginp(htext);
% figginp can modify thee current axis so need to re-do it
   axes(htext);
% this'll create the arrow object
   handles=arrow([x y],[x y]);
% this'll select it
   figsel( handles(1) );
% this'll join it to the cursor
   figjoina( 'start' , handles , 1 );
   figmess('Enter finish position');
   FGarrowmode='add';
% disable main menus
   figmena(0);
   FGfig_mode=3;
   return;
end

if strcmp(callback,'startedit')
   FGselect=0; FGhselect=0;
   FGarrowmode='edit';
   figmess('Click on arrow to edit');
% disable main menus
   figmena(0);
   FGfig_mode=3;
   return;
end

if strcmp(callback,'startmove')
   FGselect=0; FGjoinmode=0; FGhselect=0;
   FGarrowmode='move';
   figmess('Click on arrow to move');
% disable main menus
   figmena(0);
   FGfig_mode=3;
   return;
end

if strcmp(callback,'check') & strcmp(FGarrowmode,'add')
% unselect the text
   figsel;
% remove it from the cursor
   figjoina('finish');
   figmess('');
% re-enable main menus
   figmena(1);
% enable edit and move menus if necessary
   figmena
   FGfig_mode=1;
   return;
end

if strcmp(callback,'check') & strcmp(FGarrowmode,'edit')
   if FGselect
      if FGkey=='d' | FGkey=='D'
         delete(FGhselect);
         FGselect=0;
         figmess('Click on arrow to edit');
         return
      end
      if any(gco==FGhselect)
% unselect it and ...
         figsel
% use dialog box to edit
         dlarrow(FGhselect);
         figmess('Click on arrow to edit');
         return;
      end
   end
   ud=get(gco,'userdata');
   [m,n]=size(ud);
   if (m>0)
      if strcmp(ud(1,:),'arrow')
         figsel(gco);
         figmess('Arrow selected, click again to edit or ''d'' to delete');
         return;
      end
   end
% unselect any selected text
   figsel;
   FGfig_mode=1;
% re-enable main menus
   figmena(1);
% adjust menu's as appropriate
   figmena
   figmess('Arrow edit finished');
   return;
end

if strcmp(callback,'check') & strcmp(FGarrowmode,'move')

   if FGjoinmode~=0
      figjoina('finish');      
      figsel
      figmess('Click on arrow to move');
      FGjoinmode=0;
      return;
   end

   ud=get(gco,'userdata');
   [m,n]=size(ud);
   if (m>0)
      if strcmp(ud(1,:),'arrow')
         figsel(gco);
% this'll join it to the cursor
% work out what type of movement we want
         pos=get(gca,'currentpoint');
         xpos=pos(1,1); ypos=pos(1,2);
         xd=get(FGhselect(1),'xdata'); yd=get(FGhselect(1),'ydata');
         xdp=get(FGhselect(2),'xdata'); ydp=get(FGhselect(2),'ydata');
         rad=((ydp(1)-yd(1))^2 + (xdp(1)-xd(1))^2)/4;
         d1=(xpos-xd(1))^2  + (ypos-yd(1))^2;
         d2=(xpos-xdp(1))^2 + (ypos-ydp(1))^2;
         if (d1<rad)
	    figmess('Arrow base movement selected');
            joinmove=2;
         else
	    figmess('Arrow head movement selected');
            joinmove=1;
         end
         figjoina( 'start' , FGhselect , joinmove );
         return;
      end
   end
% unselect any selected arrows and finish
   figsel;
   figmess('Arrow move finished');
% re-enable main menus
   figmena(1);
   FGfig_mode=1;
   return;
end

