function [x,y,button,uic] = figginp(haxis)
%FIGGINP  Graphical input from a mouse or cursor.
% 	  [X,Y,BUTTON,UI] = FIGGINP() 
%         Used with FIGEDIT RSO 11/04/94
%

pointer = get(gcf,'pointer');
set(gcf,'pointer','crosshair');
keydown=waitforbuttonpress;

% this will ensure the current axis is changed
% when the current object is a child of another axis
if length(gco)~=0
   if gco~=gca
      p=get(gco,'parent');
      if strcmp(get(p,'type'),'axes')
         axes(p);
      end
   end
% this says whether a uicontrol has been entered
   if strcmp(get(gco,'type'),'uicontrol')
      uic=1;
   else
      uic=0;
   end
end

%fprintf('gca=%f\n gco=%f\n gcotype=%s\n',gca,gco,get(gco,'type'));

if nargin==0
   haxis=gca;
end

if (keydown)
   button=abs(get(gcf,'CurrentCharacter'));
   pt = get(haxis, 'CurrentPoint');
   x=pt(1,1);
   y=pt(1,2);
else
   pt = get(haxis, 'CurrentPoint');
   button = get(gcf, 'SelectionType');
   if strcmp(button,'open')
      button = b(max(size(b)));
   elseif strcmp(button,'normal')
      button = 1;
   elseif strcmp(button,'alt')
      button = 2;
   elseif strcmp(button,'extend')
      button = 3;
   else
      error('Invalid mouse selection.')
   end
   x=pt(1,1);
   y=pt(1,2);
end
set(gcf,'pointer',pointer);

% select a new axis if and when required
figsela;

return
end
