function [xp,yp,index,hline]=fignear(haxis,x,y)
%function [xp,yp,index,hline]=fignear(haxis,x,y)
%
% Function to return the index point closest to the point
% x,y
%

hl=findobj(haxis,'type','line');

% get position of axis in inches
aunits=get(haxis,'units');
set(haxis,'units','inches');
pos=get(haxis,'position');
set(haxis,'units',aunits);

% calulate user to inches scaling factors
xlim=get(haxis,'xlim');
ylim=get(haxis,'ylim');
mx=pos(3)/(xlim(2)-xlim(1));
my=pos(4)/(ylim(2)-ylim(1));

% position of cursor position in inches
xin=(x-xlim(1))*mx;
yin=(y-ylim(1))*my;

% loop over all lines
min_dist=1000;
index=0;

for i=1:length(hl)

   xd=get(hl(i),'xdata');
   yd=get(hl(i),'ydata');

   xdin=(xd-xlim(1))*mx;
   ydin=(yd-ylim(1))*my;

   dist=(xdin-xin).^2 + (ydin-yin).^2;
   [mdist,mi]=min(dist);
   if mdist<min_dist
      min_dist=mdist;
      index=mi;
      hline=hl(i);
      xp=xd(mi); yp=yd(mi);
   end
end

return
end
