function figprint(callback)
%
global FGfigmu FGfigmw FGfigmh
%
if strcmp(callback,'meta')|strcmp(callback,'bitmap')
% change figure size
% store original position
   cpos=get(gcf,'position');
   cunits=get(gcf,'units');

% dialog box to edit figure size
   [ret,units,newpos]=dlfsize(FGfigmu,[FGfigmw FGfigmh]);
   if ret<0 return; end

% set up figure size
   set(gcf,'units',units);
   pos=get(gcf,'position');
   set(gcf,'position',[pos(1) pos(2) newpos(1) newpos(2)]);
   FGfigmu=units;
   FGfigmw=newpos(1); FGfigmh=newpos(2);

% perform meta file or bitmap plotting
   if strcmp(callback,'meta')
      print -dmeta
      figmess('Meta file created in clipboard');
   elseif strcmp(callback,'bitmap')
      h=findobj(gcf,'type','uicontrol');
      set(h,'visible','off');
      print -dbitmap
      set(h,'visible','on');
      figmess('Bitmap file created in clipboard');
   end

% restore units and position of original plot
   set(gcf,'units',cunits,'position',cpos)
   return;
elseif strcmp(callback,'other')
% change plot size
   ret=dlpaper(gcf);
   if ret<0 return; end
% choose device and use print (all in one!);
   dlprint;
   return;
elseif strcmp(callback,'windowscol')
% change plot size
   ret=dlpaper(gcf);
   if ret<0 return; end
   print -dwinc -v
   return;
elseif strcmp(callback,'windowsbw')
% change plot size
   ret=dlpaper(gcf);
   if ret<0 return; end
   print -dwin -v
   return;
end


