function figrsz
%
global FGhd FGhddisp FGlinkx

lFGhd=length(FGhd);
lFGhddisp=length(FGhddisp);
if lFGhddisp<3
   m=lFGhddisp; n=1;
elseif lFGhddisp==4
   m=2; n=2;
else
   m=3; n=ceil(lFGhddisp/m);
end
xborder=0.05; yborder=0.1; xoff=0.13; yoff=0.11;

if FGlinkx
   ylinkoff=0.04;
else
   ylinkoff=yoff;
end

apos=zeros(1,4);
p=0;
for i=1:lFGhd
   [hd,ht,hk]=figga(FGhd(i));
   if any(FGhd(i)==FGhddisp)
% store old position
      if hk~=0
         apos=get(FGhd(i),'position');
         kpos=get(hk,'position');
         x=(kpos(1)-apos(1))/apos(3);
         y=(kpos(2)+kpos(4)-apos(2))/apos(4);
      end
% re-size
      apos(3)=(1-xborder)/n-xoff;
      apos(4)=(1-yborder-yoff-(m-1)*ylinkoff)/m;
      apos(1)=(p-fix(p/n)*n)*(apos(3)+xoff)+xoff;
      apos(2)=(m-fix(p/n)-1)*(apos(4)+ylinkoff)+yoff;
      set(FGhd(i),'position',apos);

      if hk~=0
         set(hk,'position',[apos(1)+x*apos(3) apos(2)+y*apos(4)-kpos(4) kpos(3) kpos(4)]);
         h=findobj(hk);
% this prevents the display of the H char used for character sizing
         hc=findobj(hk,'userdata','hchar');
% and the patch used for movement
         hp=findobj(hp,'userdata','hpatch');
         h=h( (h~=hc) & (h~=hp) );
	 set(hk,'visible','on');
         set(h,'visible','on');
      end

      if ht~=0
         set(ht,'position',apos);
         h=get(ht,'children');
         set(h,'visible','on');
      end

% this will make the axis and its children invisible....
      h=findobj(FGhd(i));
      set(h,'visible','on');
% this remove the axis text from linked axes
      if (p/n) < (m-1) & FGlinkx
         set(FGhd(i),'xticklabels','');
         set(FGhd(i),'xticklabelmode','manual');
         set(get(FGhd(i),'xlabel'),'visible','off');
      else
         set(FGhd(i),'xticklabelmode','auto');
         set(get(FGhd(i),'xlabel'),'visible','on');
      end
% this will re-position the selection handle
      ud=get(FGhd(i),'userdata');
      if ud(2,4)~=0
         hsel=abs(ud(2,4));
         set(hsel,'position',...
                  [apos(1)+apos(3)+0.01 apos(2)+apos(4)-0.05 0.05 0.05],...
		'visible','on');
      end
      p=p+1;
   else
% this will make the axis and its children invisible....
      h=findobj(FGhd(i));
      set(h,'visible','off');
      if hk~=0
         h=findobj(hk);
         set(h,'visible','off');
      end
      if ht~=0
         h=get(ht,'children');
         set(h,'visible','off');
      end
% this will make its selection handle invisible
      ud=get(FGhd(i),'userdata');
      if ud(2,4)~=0
         hsel=abs(ud(2,4));
         set(hsel,'visible','off');
      end
   end
end


