function figsel( handle )
%
% function to select a text or arrow object
%
global FGselect FGhselect FGold_colour

if FGselect
   for i=1:length(FGhselect)
      type=get(FGhselect(i),'type');
      if strcmp(type,'patch')
         set(FGhselect(i),'facecolor',FGold_colour(i,:));
      else
         set(FGhselect(i),'color',FGold_colour(i,:));
      end
   end
   set(FGhselect,'erasemode','normal');
   FGselect=0;
end

if nargin>0
   FGhselect=handle;
   axes(get(FGhselect,'parent'));
% select more objects if the userdata has some handles in it
   ud=get(FGhselect,'userdata');
   [m,n]=size(ud);
   if m>1
% this extracts the non-zero elements of the second row
      eh=abs(ud(2,:));
      FGhselect=eh(eh~=0);
   end
   for i=1:length(FGhselect)
      type=get(FGhselect(i),'type');
      if strcmp(type,'patch')
         FGold_colour(i,:)=get(FGhselect(i),'facecolor');
         set(FGhselect(i),'facecolor',[0.5 0.5 0.5]);
      else
         FGold_colour(i,:)=get(FGhselect(i),'color');
         set(FGhselect(i),'color',[0.5 0.5 0.5]);
      end
   end
   set(FGhselect,'erasemode','xor');
   FGselect=1;
end
