function figsela(callback)
%
global FGhd FGhsdaxis

if nargin==0
% no arguments so change selection after call to ginput
% which as we all know can change the current axis
% also make sure we've left with any text or key axes to the front
   [hdata,htext,hkey]=figga(gca);
% this means the selection has been changed
   if hdata~=FGhsdaxis
      FGhsdaxis=hdata;
% only applicable for more than one axis
      if length(FGhd)>1
         for i=1:length(FGhd)
            ud=get(FGhd(i),'userdata');
            if FGhsdaxis==FGhd(i)
               value=1;
            else
               value=0;
            end
            hrb=abs(ud(2,4));
            set(hrb,'value',value);
         end
      end
% also change the menus as well!
      figmena;
   end
   if htext~=0 axes(htext); end
   if hkey~=0 axes(hkey);   end
   return
end


% this sets up a list of data axes in global
% memory and creates the select check boxes if needed
if strcmp(callback,'start')

% add selection controls if needed
   lFGhd=length(FGhd);
   if lFGhd>1
      for i=1:lFGhd
         ud=get(FGhd(i),'userdata');
         hsel=abs(ud(2,4));
         if hsel==0
            pos=get(FGhd(i),'position');         
            hsel=uicontrol('style','radiobutton','backgroundcolor',[0 0 0],...
                        'foregroundcolor',[1 1 1],'units','normalized',...
			'position',[pos(1)+pos(3)+0.01 pos(2)+pos(4)-0.05 0.05 0.05]);
            ud(2,4)=hsel;
            set(FGhd(i),'userdata',setstr(ud));
         end
      end
   end

% set up the initial value of the current axis
   FGhsdaxis=0;

   return
end
