function figselp(callback,xp,yp,index,hline)
%
global FGhd FGhddisp FGhsdaxis FGlinkx

if strcmp(callback,'remove')
   hp=findobj(gcf,'tag','selectpoint');
   hl=findobj(gcf,'userdata','selectline');
   if length(hp)>0
%      set(hp,'visible','off');
      delete(hp);
   end
   if length(hl)>0
%      set(hl,'visible','off');
      delete(hl);
   end
   return;
end

% select point doesn't exist so create it!
if strcmp(callback,'position')
% if the buttons don't exist create them
   hb=findobj(gcf,'userdata','selbutton');
   if length(hb)==0
      drawnow;
      uicontrol('style','pushbutton','position',[0 0 18 18],...
                'string','<','callback','figselp(''left'')','userdata','selbutton');
      uicontrol('style','pushbutton','position',[18 0 18 18],...
                'string','^','callback','figselp(''up'')','userdata','selbutton');
      uicontrol('style','pushbutton','position',[36 0 18 18],...
             'string','>','callback','figselp(''right'')','userdata','selbutton');
   end

% loop through other axes and turn the visibilitites off
% of any other select points
   hgca=gca;
   for i=1:length(FGhddisp)
      axes(FGhddisp(i));
      hp=findobj(FGhddisp(i),'tag','selectpoint');
      if FGhddisp(i)~=FGhsdaxis
         if length(hp)>0
            set(hp,'visible','off');
         end
      else
         if length(hp)==0      
            hp=line(0,0,'erasemode','xor','color',[1 0 0],...
                    'linestyle','+','tag','selectpoint');
         else
            set(hp,'visible','on');
         end
      end
   end
   axes(hgca);
   hp=findobj(FGhsdaxis,'tag','selectpoint');
end

if strcmp(callback,'right') | strcmp(callback,'left')
%
   hp=findobj(FGhsdaxis,'tag','selectpoint');
   if length(hp)==0 return; end
   ud=get(hp,'userdata');
   hline=ud(1); index=ud(2);
   xd=get(hline,'xdata');
   yd=get(hline,'ydata');
   if strcmp(callback,'right')
      index=index+1;
   else
      index=index-1;
   end
   lxd=length(xd);
   if index<1 index=lxd; end
   if index>lxd index=1; end
   xp=xd(index); yp=yd(index);
end

if strcmp(callback,'right') | strcmp(callback,'left') | strcmp(callback,'position')

   set(hp,'xdata',xp,'ydata',yp);
   set(hp,'userdata',[hline index]);

   if FGlinkx
      hgca=gca;
      for i=1:length(FGhddisp)
         axes(FGhddisp(i));
         hl=findobj(FGhddisp(i),'userdata','selectline');
         if length(hl)==0
            hl=line(0,0,'erasemode','xor','linestyle','-',...
               'color',[1 1 1],'userdata','selectline');
         end
         ylim=get(FGhddisp(i),'ylim');
         set(hl,'visible','on');
         set(hl,'xdata',[xp xp],'ydata',ylim);
      end
      axes(hgca);
   end
end

if strcmp(callback,'up')
   hp=findobj(FGhsdaxis,'tag','selectpoint');
   hl=findobj(FGhsdaxis,'userdata','selectline');
   if length(hp)==0 return; end
   ud=get(hp,'userdata');
   hline=ud(1); index=ud(2);
   hls=findobj(FGhsdaxis,'type','line');
   if length(hl)>0
      hls=hls(hls~=hl);
   end
   hls=hls(hls~=hp);
   for hlsi=1:length(hls)
      if hls(hlsi)==hline
         break;
      end
   end
   hlsi=hlsi+1;
   if hlsi>length(hls)
      hlsi=1;
   end
   hline=hls(hlsi);
   xd=get(hline,'xdata');
   yd=get(hline,'ydata');
   if index>length(xd)
      index=length(xd);
   end
   xp=xd(index); yp=yd(index);
   set(hp,'xdata',xp,'ydata',yp);
   set(hp,'userdata',[hline index]);
end

figmess(sprintf('x=%-14.4g y=%-14.4g index=%-6.0f',xp,yp,index));
end
