function figstart(option)
%
% function to start figedit 
% (internal to fig edit )
%
global FGhd FGhddisp

if nargin==0 
   option=''; 
end

% GRAB AXES AND MAKE SURE THEY ARE LABELLED
h=findobj(gcf,'type','axes');
if length(h)==0
% this should create a default axis
   h=gca;
end
FGhd=[];
% perform in reverse order so that they are stored
% in the order the axes were created
for i=length(h):-1:1
   ud=get(h(i),'userdata');
% if they have no label then label them!
   [m,n]=size(ud);
% assume it to be a data axis
   if m==0
      ud='dataaxis';
      ud(2,1)=h(i);
      set(h(i),'userdata',setstr(ud));
% set as default axes all other which forces them to the front
      FGhd=[FGhd;h(i)];
   else
      if strcmp(ud(1,:),'textaxis')|strcmp(ud(1,:),'keyaxis')
         axes(h(i));
      end
      if strcmp(ud(1,:),'dataaxis')
         FGhd=[FGhd;h(i)];
      end
   end   
end
% sets up the axes to be actually displayed
FGhddisp=FGhd;

% ADD MESSAGE LINE
h=findobj(gcf,'userdata','FigMess');
% create it if it doesn't already exist
if length(h)==0
% Message box at top of display
   uicontrol('style','text',...
                'units','normalized',...
                'position',[0.0 0.96 1 0.04],...
                'backgroundcolor',[0.5 0.5 0.5],...
                'foregroundcolor',[1 1 0],...
                'horizontalalignment','left',...
                'userdata','FigMess');
end

% ADD MENUS
h=findobj(gcf,'userdata','FigAxis');
if length(h)==0
   i=uimenu('Label','Axis','userdata','FigAxis');
   uimenu(i,'label','Re-draw','callback','figrd');   
   uimenu(i,'label','Axis limits etc','callback','figaxis(''limits'')');   
   uimenu(i,'label','Axis title/labels','callback','figaxis(''titles'')');
   uimenu(i,'label','Auto x','callback','figauto(''x'')');   
   uimenu(i,'label','Auto y','callback','figauto(''y'')');   
   uimenu(i,'label','Auto xy','callback','figauto(''xy'')');   
   uimenu(i,'label','Zoom x','callback','figzoom(''x'')');   
   uimenu(i,'label','Zoom y','callback','figzoom(''y'')');   
   uimenu(i,'label','Zoom xy','callback','figzoom(''xy'')');   
   uimenu(i,'label','Zoom out x','callback','figzoom(''outx'')');   
   uimenu(i,'label','Zoom out y','callback','figzoom(''outy'')');   
   uimenu(i,'label','Zoom out xy','callback','figzoom(''outxy'')');   
   uimenu(i,'label','Scroll x','callback','figscrl(''getnewdivs'')');   
   uimenu(i,'label','Link x on/off','callback','figlinkx(''toggle'')');
   uimenu(i,'label','Plot selected axis','callback','figaxis(''plotselect'')');   
   uimenu(i,'label','Plot all','callback','figaxis(''plotall'')');
else
   set(h,'enable','on');
end

h=findobj(gcf,'userdata','FigAddEdit');
if length(h)==0
   g=uimenu('Label','Add/Edit','userdata','FigAddEdit');
   uimenu(g,'label','Add text','callback','figtext(''startadd'')');
   uimenu(g,'label','Edit text','callback','figtext(''startedit'')');
   uimenu(g,'label','Move text','callback','figtext(''startmove'')');
   uimenu(g,'label','Add arrow','callback','figarrow(''startadd'')');
   uimenu(g,'label','Edit arrow','callback','figarrow(''startedit'')');
   uimenu(g,'label','Move arrow','callback','figarrow(''startmove'')');
   uimenu(g,'label','Add key','callback','figkey(''startadd'')');
   uimenu(g,'label','Edit key','callback','figkey(''startedit'')');
   uimenu(g,'label','Delete key','callback','figkey(''delete'')');
   uimenu(g,'label','Move key','callback','figkey(''startmove'')');
else
   set(h,'enable','on');
end

h=findobj(gcf,'userdata','FigLoadSave');
if length(h)==0
   k=uimenu('Label','Save/load','userdata','FigLoadSave');
   uimenu(k,'label','Save figure','callback','figls(''save'')');
   uimenu(k,'label','Load figure','callback','figls(''load'')');
else
   set(h,'enable','on');
end

h=findobj(gcf,'userdata','FigPrint');
if length(h)==0
   j=uimenu('Label','Print','userdata','FigPrint');
   uimenu(j,'label','Meta file to clipboard','callback','figprint(''meta'')');
   uimenu(j,'label','Bitmap file to clipboard','callback','figprint(''bitmap'')');
   uimenu(j,'label','Windows printer (colour)','callback','figprint(''windowscol'')');
   uimenu(j,'label','Windows printer (b/w)','callback','figprint(''windowsbw'')');
   uimenu(j,'label','Other printer...','callback','figprint(''other'')');
else
   set(h,'enable','on');
end

% RESIZE DATA AXES ?
if strcmp(option,'resize')
% re-size add selection controls if we're using more than one data axis
   figrsz;
end

% CREATE SELECTION RADIO BUTTONS
figsela('start');
% and select an axis...
figsela;

return
end
