function matsave(fid,matrix,name)
% MATSAVE function to write out (in binary form) a matrix to an opened file
%      
% matsave(fid,matrix,name);
%
% fid     - File id
% matrix  - Matrix to save
% name    - Name to use for matrix
% 
% See also FOPEN, FCLOSE
%
[m,n]=size(matrix);
fwrite(fid,isstr(matrix),'long'); % type
fwrite(fid,m,'long');
fwrite(fid,n,'long');
fwrite(fid,0,'long'); % imag flag
fwrite(fid,length(name)+1,'long');
fwrite(fid,name,'char');
fwrite(fid,0,'char');
% WRITE OUT DATA
fwrite(fid,matrix,'double');

return
end
