function htext=textpatch(arg1,arg2,arg3,arg4,arg5,arg6,arg7,arg8,arg9,arg10,arg11,arg12,...
                         arg13,arg14,arg15,arg16,arg17,arg18,arg19,arg20,arg21,arg22,arg23,arg24)
% TEXTPATCH   Creates a text object with its background removed by using a
%             patch object
%
% h=textpatch(arg1,arg2,arg3,....) 
%        - will create a text object using idential parameters to routine TEXT
% textpatch(h)
%        - will re-position the patch background of an existing textpatch object
%          due to axis changes etc.
%
% See also TEXT
%

if nargin==1
   htext=arg1;
   ud=get(htext,'userdata');
   hpatch=abs(ud(2,1));
   cunits=get(htext,'units');
   set(htext,'units','data');
   ext=get(htext,'extent');
   set(htext,'units',cunits);
   set(hpatch,'xdata',[ext(1) ext(1) ext(1)+ext(3) ext(1)+ext(3)],...
	      'ydata',[ext(2) ext(2)+ext(4) ext(2)+ext(4) ext(2)]);
   return;
end

hpatch=patch(0,0,[0 0 0],'edgecolor',[0 0 0],'clipping','off');

com='htext=text(';
for i=1:nargin
   com=[com 'arg' int2str(i)];
   if i==nargin
      com=[com ');'];
   else
      com=[com ','];
   end
end
eval(com);

ud='textpatch';
ud(2,1)=htext;
ud(2,2)=hpatch;
set(htext,'userdata',setstr(ud));

cunits=get(htext,'units');
set(htext,'units','data');
ext=get(htext,'extent');
set(htext,'units',cunits);
set(hpatch,'xdata',[ext(1) ext(1) ext(1)+ext(3) ext(1)+ext(3)],...
           'ydata',[ext(2) ext(2)+ext(4) ext(2)+ext(4) ext(2)],...
           'userdata',setstr(ud));

