function ctext(x,y,s,colour,scpar)
%CTEXT	An enhanced text command for Color-PostScript printers.
%	Instead of GPP the commands MET2PS or MET2EPS are required
%	for postprocessing of the graphics meta-file.
%	CTEXT(X,Y,'string',COLOUR) writes the text in the quotes 
%	at (X,Y) on the graphics screen, where (X,Y) are in units from
%	the last plot. If X and Y are vectors, CTEXT writes the text at
%       all locations given. If 'string' is an array the same length
%	as X and Y, CTEXT marks each point with the corresponding row
%	of the 'string' array. The string variable COLOUR specifies
%	the colour the string will be rendered on a Colour-PostScript
%	printer. Valid printer colours are:
%
%	 black  k	red    r	green   g	blue    b
%	 white  w	yellow y	magenta m	cyan	c
%
%	On noncolour printers different shades of gray will be
%	reproduced instead.
%       CTEXT(X,Y,'string',COLOUR,'sc') interprets the (X,Y) points in
%	screen coordinates, where (0.0,0.0) is the lower left corner
%	of the screen, and (1.0,1.0) is the upper right.
%	This is for MATLAB version 3.5 !


%	@LEM U. Kaestli 7-7-93
%
%	calls getplarg.m for analyzing the colour string
%
if nargin < 4, error('Not enough input arguments.'); end
if nargin > 5, error('Too many input arguments.'); end

[linecol,dummy,dummy]=getplarg(colour);
    
% set color and plot text:
% do insert a string with "escape" sequences at an "invisible"
% position, which can be interpreted by MET2PS
setcolor=['#P',linecol,' 1 Pc#']; % set color and dummy linewidth
text(1,.5,setcolor,'sc')
if nargin == 4
  text(x,y,s)
else
  text(x,y,s,scpar)
end
text(1,.5,'#PEc#','sc')		% reset color
