function [com,lismath]=getfile1(file)
% GETFILE1 Lee un grafo de la salida de mathematica en una lista de adyacencias
%          tambien deja en las columnas 2 y 3 la lista de las coordenadas
%          la dificultad es que las lineas pueden ser de distinta longitud
%          pero se rellena con ceros para que lismath sea un elemento MATLAB
%       [com,lismath]=GETFILE1(file)
%       file    is a name for input file
%       lismath is the adjacency list with coordinates and rectangular shape
%       com     un posible comentario aadido en algun proceso
%               (no por Mathematica, pues de hecho dara error)


fid=fopen(file);
fila=0;

while 1

% leemos las lineas que pueden ser de comentario
line = fgetl(fid);
    if ~isstr(line), break, end

    if line(1)=='%'
           com=str2mat(com,line(2:length(line)));
    else

    % la primera linea no comentario, nos marcara un tamao basico
    % la desglosamos en sus elementos y nos dice cuantos
        if fila==0
            [cadena,col]=sscanf(line,'%f');
            lismath(1,:)=cadena';
            fila=1;
        else

% ahora todas las demas y va adaptando la dimension de la matriz
            [cadena,coln]=sscanf(line,'%f');
            if coln==col
                lismath(fila+1,:)=cadena';
            else
% si la nueva fila no es de tamao standard ajustamos los tamaos y el standard
                if coln>col
                    lismath=[lismath zeros(fila,coln-col)];
                    col=coln;
                else
                    cadena=[cadena;zeros(col-coln,1)];
                end
                lismath(fila+1,:)=cadena';
            end
            fila=fila+1;
        end
    end

end

fclose(fid);
