function editgraf(action);
%GRAPHEDT    Graphical menu-drived Graph Editor program in Matlab 4.0
%
%       Usage: graphedt
%
%       This function is the driver program which allows us to
%       create, edit, save and print simple undirected graphs
%       in a menu-drived way.

%       The input and output formats are adjacency list with coordinate values
%       is directly readible for Mathematica with command ReadGraph["filename"]
 

%       Miguel Revilla
%       Dpto. Matemtica Aplicada y Computacin
%       Facultad de Ciencias
%       Universidad de Valladolid (Spain)
%       revilla@mac.cie.uva.es
%       January, 1995 (v 1.1)


ver='GRAPHEDT v1.1';

global ANCHO ALTO REJILLA NOMBRE RATIO
global POS MATRIZ LISTA EJES NODOS
global DRIVERH CHILD AUTO INTER
global FLAG PROH NOD1 NOD2 PUN
global tipo PADRES HIJOS

global autoejes rejilla ratio
global camino filename com texto
global nuevo grabar grabarb imprimir
global libres1 libres2 binario1 binario2

if nargin<1,
    action='initialize';
end;

%create controls
if strcmp(action,'initialize'),

NOMBRE=ver;
com='Noname graph';
INTER=50;
RATIO='square';
EJES=[-1 101 -1 101];
NODOS=0;
AUTO=0;
REJILLA=0;

% lo segundo customizar las caracteristicas basicas segun la pantalla
screen=get(0,'screensize');
ANCHO=screen(3);ALTO=screen(4);

clc;

%presentacion de la pantalla basica del programa

DRIVERH=figure('number','off','name',NOMBRE,...
    'position',[ANCHO-ALTO 0 ALTO ALTO],...
    'resize','off');

%seleccion de accion a realizar
items2 = str2mat('New','Load','Save','Save as...','Print as...','Quit');

selection = uimenu(DRIVERH,...
'label','&Graph...');

nuevo=uimenu(selection,...
'label',items2(1,:),...
'enable','off',...
'callback','graphedt(''nuevocb'')');

cargar=uimenu(selection,...
'label',items2(2,:),...
'separator','on',...
'callback','graphedt(''cargarcb'')');

grabar=uimenu(selection,...
'label',items2(3,:),...
'enable','off',...
'callback','graphedt(''grabarcb'')');

grabarb=uimenu(selection,...
'label',items2(4,:),...
'enable','off',...
'callback','graphedt(''grabarbcb'')');

imprimir=uimenu(selection,...
'label',items2(5,:),...
'enable','off',...
'callback','graphedt(''printcb'')');

salir=uimenu(selection,...
'label',items2(6,:),...
'separator','on',...
'callback','graphedt(''salircb'')');

%seleccion de opciones a tener en cuenta
items3 = str2mat('Autoaxis','Autogrid');

opciones = uimenu(DRIVERH,...
'label','&Options');

autoejes=uimenu(opciones,...
'label',items3(1,:),...
'enable','off',...
'callback',['global autoejes AUTO;',...
'AUTO=1-AUTO;',...
'if AUTO==1,',...
'set(autoejes,''checked'',''on''),',...
'graphedt(''editar''),',...
'else,',...
'set(autoejes,''checked'',''off''),',...
'end']);


rejilla=uimenu(opciones,...
'label',items3(2,:),...
'separator','on',...
'callback',['global REJILLA rejilla;',...
'REJILLA=1-REJILLA;',...
'if REJILLA==1,',...
'set(rejilla,''checked'',''on''),',...
'graphedt(''editar''),',...
'else,',...
'set(rejilla,''checked'',''off''),',...
'end']);

ratio=uimenu(opciones,...
'label','Normal',...
'separator','on',...
'callback',['global DRIVERH ANCHO ALTO RATIO ratio;',...
'if strcmp(get(ratio,''label''),''Normal''),',...
    'set(ratio,''label'',''Square''),',...
    'RATIO=''normal'';',...
    'set(DRIVERH,''position'',[0 0 ANCHO ALTO]),',...
    'graphedt(''editar''),',...
'else,',...
    'set(ratio,''label'',''Normal''),',...
    'RATIO=''square'';',...
    'set(DRIVERH,''position'',[ANCHO-ALTO 0 ALTO ALTO]),',...
    'graphedt(''editar''),',...
'end']);

%seleccion de transformaciones automaticas especiales para arboles
items4 = str2mat('Rooted','Rooted-2','Binary','Binary-2');

arboles = uimenu(DRIVERH,...
'label','&Trees...');

libres1=uimenu(arboles,...
'label',items4(1,:),...
'enable','off',...
'callback',['global AUTO autoejes POS PADRES;',...
'POS=treeplo2('''',PADRES,1);',...
'AUTO=1;',...
'set(autoejes,''enable'',''on'',''checked'',''on'');',...
'graphedt(''editar'')']);

libres2=uimenu(arboles,...
'label',items4(2,:),...
'enable','off',...
'callback',['global AUTO autoejes POS PADRES;',...
'POS=treeplo2('''',PADRES,2);',...
'AUTO=1;',...
'set(autoejes,''enable'',''on'',''checked'',''on'');',...
'graphedt(''editar'')']);

binario1=uimenu(arboles,...
'label',items4(3,:),...
'enable','off',...
'callback',['global AUTO autoejes POS HIJOS;',...
'[POS,nul]=binplot('''',HIJOS,2);',...
'AUTO=1;',...
'set(autoejes,''enable'',''on'',''checked'',''on'');',...
'graphedt(''editar'')']);

binario2=uimenu(arboles,...
'label',items4(4,:),...
'enable','off',...
'callback',['global AUTO autoejes POS PADRES HIJOS MATRIZ NODOS;',...
'[POS MATRIZ]=binplot('''',HIJOS,1);',...
'NODOS=length(MATRIZ);',...
'[tipo,PADRES,HIJOS]=treeq(MATRIZ,POS);',...
'AUTO=1;',...
'set(autoejes,''enable'',''on'',''checked'',''on'');',...
'graphedt(''editar'')']);


graphedt('editar');

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% define callbacks
elseif strcmp(action,'down'),
% si se toca en la linea no hay que hacer nada o avisar
    if gco==PROH,
    graphedt('editar');
% toma del primer dato
    elseif FLAG==1,

% si NO pica ningun punto, aadimos uno en las coordenadas x,y enterizadas
        if gco==DRIVERH,
            pt=get(gca,'CurrentPoint');
            NODOS=NODOS+1;
            if NODOS>=2,
                set(autoejes,'enable','on');
                if (pt(1,1)<EJES(1) | pt(1,1)>EJES(2) | ...
                    pt(1,2)<EJES(3) | pt(1,2)>EJES(4)),
                    AUTO=1;
                    set(autoejes,'checked','on');
                end
            end
            POS=[POS;[pt(1,1) pt(1,2)]];
            MATRIZ(NODOS,NODOS)=0;

            graphedt('editar');

 % deteccion del nodo tocado
        else
            for j=1:NODOS,
                if CHILD(j)==gco,break,end
            end
            NOD1=j;
            set(gco,'color','g');
            FLAG=2;
        end

% se va a la lectura del segundo nodo (cambiamos el raton)
    elseif FLAG==2,

% si NO pica ningun punto, se trata de un traslado de nodo
        if gco==DRIVERH,
            pt=get(gca,'CurrentPoint');
            POS(NOD1,:)=[pt(1,1) pt(1,2)];
% deteccion del nodo tocado
        else
            for j=1:NODOS,
                if CHILD(j)==gco,break,end
            end
            NOD2=j;
% si se trata del mismo nodo tenemos eliminacion de un nodo
            if NOD2==NOD1,
                if NODOS==1,
                    graphedt('nuevocb');
                else
                    PUN(NOD1)=0;
                    POS=POS(PUN,:);
                    MATRIZ=MATRIZ(PUN,PUN);
                    NODOS=NODOS-1;
                    if NODOS==1,
                        AUTO=0;
                        set(autoejes,'enable','off','checked','off');
                    end
                end
            else
% si se trata de otro, se cambia el status del eje
                MATRIZ(NOD1,NOD2)=1-MATRIZ(NOD1,NOD2);
                MATRIZ(NOD2,NOD1)=MATRIZ(NOD1,NOD2);
            end
        end
        [tipo,PADRES,HIJOS]=treeq(MATRIZ,POS);
        if tipo==0,
            set(libres1,'enable','off');
            set(libres2,'enable','off');
            set(binario1,'enable','off');
            set(binario2,'enable','off');
        elseif tipo==1,
            set(libres1,'enable','on');
            set(libres2,'enable','on');
            set(binario1,'enable','off');
            set(binario2,'enable','off');
        else
            set(libres1,'enable','on');
            set(libres2,'enable','on');
            set(binario1,'enable','on');
            set(binario2,'enable','on');
        end

        graphedt('editar');
    end


% define callbacks
elseif strcmp(action,'nuevocb'),
    gplot(zeros(size(MATRIZ)),POS);
    clear global MATRIZ;
    clear global POS;
    com='Noname graph';
    EJES=[-1 101 -1 101];
    NODOS=0;
% reiniciar las opciones
    AUTO=0;
    set(autoejes,'checked','off');
    REJILLA=0;
    set(rejilla,'checked','off');
    RATIO='square';
    set(libres1,'enable','off');
    set(libres2,'enable','off');
    set(binario1,'enable','off');
    set(binario2,'enable','off');

    graphedt('editar');

% define callbacks
elseif strcmp(action,'cargarcb'),
    [fichero,camino]=uigetfile('*.grf','GRAPH SELECTION...',500,300);
    if fichero~=0,
        filename=fichero(1:length(fichero)-4);
        [com,datos]=getfile1([camino,fichero]);

        % toma como nombre la primera fila de comentarios
        inf=size(com,1);
        if inf>1
            com=com(2,:);
        else
            com=fichero;
        end

        POS=datos(:,2:3);
        NODOS=size(datos,1);
        % para prever el grafo vacio
        m=size(datos,2);
        if m==3
            datos=[datos zeros(NODOS,1)];
            m=4;
        end
        LISTA=[datos(:,1) datos(:,4:m)];
        matrizsp=lismatad(LISTA);
        MATRIZ=full(matrizsp);
        AUTO=1;
        set(autoejes,'enable','on','checked','on');
        REJILLA=0;
        set(rejilla,'checked','off');

        [tipo,PADRES,HIJOS]=treeq(MATRIZ,POS);
        if tipo==0,
            set(libres1,'enable','off');
            set(libres2,'enable','off');
            set(binario1,'enable','off');
            set(binario2,'enable','off');
        elseif tipo==1,
            set(libres1,'enable','on');
            set(libres2,'enable','on');
            set(binario1,'enable','off');
            set(binario2,'enable','off');
        else
            set(libres1,'enable','on');
            set(libres2,'enable','on');
            set(binario1,'enable','on');
            set(binario2,'enable','on');
        end

        set(nuevo,'enable','on');
        set(grabar,'enable','on');
        set(grabarb,'enable','on');
        set(imprimir,'enable','on');
    end

    graphedt('editar');

% define callbacks
elseif strcmp(action,'grabarcb'),
    putfile1([camino,filename],POS,MATRIZ);

% define callbacks
elseif strcmp(action,'grabarbcb'),
        [fichero,camino]=uiputfile('*.grf','SAVE AS...',500,300);
    if fichero ~=0,
        filename=fichero(1:length(fichero)-4);
        putfile1([camino,filename],POS,MATRIZ);
        set(grabar,'enable','on');
        com=fichero;
        NOMBRE=[ver ':' com];
        set(DRIVERH,'name',NOMBRE);
    end

% define callbacks
elseif strcmp(action,'printcb'),
    [fichero,camino2]=uiputfile([filename,'.eps'],'PRINT (EPSF) AS...',500,300);
    if fichero ~=0,
        filename2=fichero(1:length(fichero)-4);
        fichero=[camino2,filename2];
        print(fichero,'-deps');
    end

% define callbacks
elseif strcmp(action,'salircb'),
    close(DRIVERH);
    clear global;

% cuando se trata de editar
else

    set(DRIVERH,'WindowButtonDownFcn','graphedt(''down'')');

    if NODOS==0,
        axis(EJES);axis(RATIO);axis('off');
        set(nuevo,'enable','off');
        set(grabar,'enable','off');
        set(grabarb,'enable','off');
        set(imprimir,'enable','off');
        NOMBRE=[ver ':' com];
        set(DRIVERH,'name',NOMBRE);
    else
        set(nuevo,'enable','on');
        set(grabarb,'enable','on');
        set(imprimir,'enable','on');

        if AUTO
            [v1]=min(POS);
            [v2]=max(POS);
            v(1)=v1(1);v(2)=v2(1);v(3)=v1(2);v(4)=v2(2);
            rgx=v(2)-v(1);
            if rgx==0, rgx=1;,end
            rgy=v(4)-v(3);
            if rgy==0, rgy=1;,end
            v(1)=v(1)-.05*rgx;
            v(2)=v(2)+.05*rgx;
            v(3)=v(3)-.05*rgy;
            v(4)=v(4)+.05*rgy;
            EJES=v;
        end

        if REJILLA
            rgx=EJES(2)-EJES(1);
            rgy=EJES(4)-EJES(3);
          POS(:,1)=EJES(1)+rgx*round((INTER+1)*(POS(:,1)-EJES(1))/rgx)/(INTER+1);
          POS(:,2)=EJES(3)+rgy*round((INTER+1)*(POS(:,2)-EJES(3))/rgy)/(INTER+1);
        end

        figure(DRIVERH);
        gplot(MATRIZ,POS);hold on;
        for i=size(POS,1):-1:1,
            plot(POS(i,1),POS(i,2),'oy');
        end
        hold off;
        axis(EJES);axis(RATIO);axis('off');
        NOMBRE=[ver ':' com];
        set(DRIVERH,'name',NOMBRE);

        child1=get(DRIVERH,'children');
        for j=1:size(child1,1),
            if get(child1(j),'type')=='axes',break,end
        end

        CHILD=get(child1(j),'children');
        PUN=ones(NODOS,1);
% si no hay ejes, no hay prohibidos
        if size(CHILD,1)>NODOS,
            PROH=CHILD(NODOS+1);
        else
            PROH=0;
        end
    end
    FLAG=1;

end

return
end
