function putfile1(file,xy,A,com);
% PUTFILE1 Escribe un grafo como lista de adyacencias en un fichero
%          apto para ser leido con mathematica ReadGraph["filename"]
%          aade, por tanto, las coordenadas en las columnas 2 y 3
%       PUTFILE1(file,xy,A,com)
%       file    is a name for output file (will be 'file.grf')
%       xy      is a matrix with coordinates for vertex
%       A       matriz de adyacencias dada en forma full o sparse
%       com     un comentario que deseemos aadir al fichero
%               (dara error al ser leido por Mathematica)

% separamos las coordenadas
x=xy(:,1);
y=xy(:,2);

% calculamos la lista de adyacencias en forma rectangular (con ceros en su caso)
listadya=matlisad(A);
n=size(listadya,1);
mmax=size(listadya,2);

% ahora abrimos el fichero
file=[file '.grf'];

fid=fopen(file,'w');

% y escribimos en el fichero
for i=1:n,
    fprintf(fid,'%4.0f %6.4f %6.4f',listadya(i,1),x(i),y(i));
    if mmax>1,
        for j=2:mmax,
            if listadya(i,j)~=0,
                fprintf(fid,'%4.0f',listadya(i,j));
            else
                break
            end
        end
    end
    fprintf(fid,'\n');
end

% al final se escribe el posible comentario
if nargin==4,
    fprintf(fid,'%s %s \n','%',com);
end

fclose(fid);

return
