function pos=treeplo2(file,pad,opt)
%TREEPLO2 Plot a picture of a tree and save it in Mathematica graph format.
%       TREEPLO2(file,pad,opt)
%       file    is a name for output file (will be 'file.grf')
%       pad     is a vector of parent pointers, with p(i) == 0 for a root.
%       opt     2 if you want all leafs on the same level. 1 in other case.
%
%       pos     matriz de coordenadas de los nodos
%
%   es una modificacion del 'treeplot.m' de sparfun matlab package
%       Copyright (c) 1984-93 by The MathWorks, Inc.

% calculamos el postorden con nuestra nueva rutina
post=postord(pad);
% y se lo damos a treelayout que ya no lo calculara (no lo hace)

if nargin==2, opt=1;, end

% aqui calculamos las coordenadas de los ejes
[x,y]=treelay2(pad,post,opt);

f = find(pad~=0);
pp = pad(f);
X = [x(f); x(pp); NaN*ones(size(f))];
Y = [y(f); y(pp); NaN*ones(size(f))];
X = X(:);
Y = Y(:);

n = max(size(pad));

% proporcionamos un comentario
com='arbol';

% si se da un argumento de salida, se graba y no se dibuja (de momento)
if length(file)>0,

    % primer calculamos la lista de adyacencias
    % calculamos la matriz de adyacencias
    j = find(pad);
    A = sparse (pad(j), j, 1, n, n);
    A = A + A';

    putfile1(file,[x' y'],A,com);

else

pos=[x' y'];
%    figure(1);set(gcf,'menubar','none','number','off','name',com);
%    if n < 500,
% ponemos los nodos de amarillo
%            plot (x, y, 'yo', X, Y, 'r-');
%    else,
%            plot (X, Y, 'r-');
%    end;
%   xlabel(['height = ' int2str(h)]);
%    axis('square');axis('off');axis([0 1 0 1]);
%    axis('off');axis([0 1 0 1]);

end
