function axesh_lgd=create_lgd(axesh_fig)
%CREATE_LGD	Create a legend figure
%
%	This function creates a gui_plot legend.  axesh_fig is the axis
%	handle for the figure requiring a legend.  axesh_lgd is the axis
%	handle for the legend returned to the invoking function.
%
%	axesh_lgd=create_lgd(axesh_fig)
%

%	Rich Field
%	NASA Ames-Dryden Flight Research Facility
%	P.O. Box 273
%	Edwards, CA  93523-0273

figh_lgd=figure('NumberTitle','off','Name','Legend',...	%Create legend
        'Position',[850 544 400 420],'Color',[.6 .6 .6]);

axesh_lgd=axes('Visible','off');	%Turn of axes

ud=get(axesh_fig,'Userdata');		%Define ud(axesh_fig) matrix
[nrows,ncols]=size(ud);			
names=setstr(ud(2:nrows,:)');		%Determine names matrix

set(axesh_lgd,'Userdata',axesh_fig);	%Save figure handle in ud(axesh_lgd)

yt=1;					%Initial text y-coordinate
for nn=1:ncols,
        linec=get(ud(1,nn),'Color');    	%Get line color
        lines=get(ud(1,nn),'LineStyle');	%Get line style
        text(0,yt,names(nn,:),'Color',linec);   %Print line color
        text(.5,yt,lines,'Color',linec);	%Print line style
        yt=yt-(1/ncols);                	%New y text location
	drawnow;
end

figh=get(axesh_fig,'Parent');		%Get plot figure handle
set(figh,'Userdata',axesh_lgd);		%Save axesh_lgd in ud(figh)

drawnow;



