function update_lgd
%UPDATE_LGD	Update legend the legend figure created with CREATE_LGD
%
%	This function updates the legend created with CREATE_LGD.
%
%	Usage: update_lgd()
%

%	Rich Field
%	NASA Ames-Dryden Flight Research Facility
%	P.O. Box 273
%	Edwards, CA  93523-0273

figh=get(gca,'Parent');			%Get plot handle
axesh_lgd=get(figh,'Userdata');		%Define axesh_lgd
axesh_fig=get(axesh_lgd,'Userdata');	%Define axesh_fig
ud=get(axesh_fig,'Userdata');		%Get ud(axesh_fig)
[nrows,ncols]=size(ud);
names=setstr(ud(2:nrows,:)');		%Determine names matrix

axes(axesh_lgd);			%Make legend current
cla;
yt=1;                                   %Initial text y-coordinate
for nn=1:ncols,
	axes(axesh_fig);			%Make figure current
        linec=get(ud(1,nn),'Color');    	%Get line color
        lines=get(ud(1,nn),'LineStyle');	%Get line style
	axes(axesh_lgd);			%Make legend current
        text(0,yt,names(nn,:),'Color',linec);   %Print line color
        text(.5,yt,lines,'Color',linec);	%Print line style
        yt=yt-(1/ncols);                	%New y text location
	drawnow;
end

drawnow;
