function edit_ui(handle,button_type,button_property)
%
%  edit_ui.m
%
% 	This function helps edit the properties of a uicontrol button.
%
%
%  usage:
%		edit_ui(handle,button_type,button_property)
%  where
%
%		handle : handle of uicontrol object whose properties are
%			 to be edited.
%		button_type : the uicontrol type.
%		button_property  : property that is to be edited ('string').
%
%  Author :  Patrick Marchand
%  Mods.  :  
%   

%  Copyright (c) 1994 by Patrick Marchand 
%       Permission is granted to modify and re-distribute this 
%	code in any manner as long as this notice is preserved. 
%	All standard disclaimers apply. 


if nargin == 3
	sco(handle);
	button_type = lower(button_type)
	button_property = lower(button_property);
	if strcmp(button_type,'pushbutton')
		if strcmp(button_property,'string')
		  txt = input('Enter string: ','s');
		  set(handle,button_property,txt);
		end
	elseif strcmp(button_type,'popupmenu')
		if strcmp(button_property,'string')
		  num_choice = input('Enter number of choices:');
		  txt = [];
		  for loop = 1:num_choice
		    txt1 = input(['Enter string' num2str(loop) ': '],'s');
		    if loop == 1
			txt = [' ' txt1];
		    else
			txt = [txt ' | ' txt1];
		    end
		  end
		  set(handle,button_property,txt);
		end
	elseif strcmp(button_type,'edit')
		if strcmp(button_property,'string')
		  txt = input('Enter string: ','s');
		  set(handle,button_property,txt);
		end
	elseif strcmp(button_type,'slider')
	elseif strcmp(button_type,'checkbox')
		if strcmp(button_property,'string')
		  txt = input('Enter string: ','s');
		  set(handle,button_property,txt);
		end
	elseif strcmp(button_type,'radiobutton')
		if strcmp(button_property,'string')
		  txt = input('Enter string: ','s');
		  set(handle,button_property,txt);
		end
	elseif strcmp(button_type,'text')
		if strcmp(button_property,'string')
		  txt = input('Enter string: ','s');
		  set(handle,button_property,txt);
		end
	elseif strcmp(button_type,'frame')
	end
end
