function example1(command,param1) 
%  Template for uicontrol form. 
%   
%  1. Optional: Replace all occurances of 'example1' with desired 'filename'. 
%  2. Optional: Resave this file as that 'filename'. 
%  3. Optional: Fill in the 'elseif command == ...' sections with 
%          code that does something other than display which 
%          uicontrol button was pressed. Be creative! 
%  4. Optional: Change each 'h(index)' ,where index is 1,2,3,.. 
%               to a functionally more descriptive name. 
%  5. Optional: Delete these first 10 comment lines. 
%   
%  example1.m 
%   
%  usage:       example1(command,parameter1) 
%   
%           where 
%   
%               'command' is used to perform some defined operation 
%               'parameter1' can be used pass extra information 
%                              to a defined operation 
%   
%           If no arguements are used the GUI is initialized. 
%   
%   
%  Created: 12-Jan-94 
%  Using  : guimaker by Patrick Marchand 
%                         (pmarchan@motown.ge.com) 
%  Author :  
%  Mods.  :  
%   

%  Copyright (c) 1994 by Patrick Marchand 
%       Permission is granted to modify and re-distribute this 
%	code in any manner as long as this notice is preserved. 
%	All standard disclaimers apply. 


if nargin == 0 
	command = 'new'; 
end 

if isstr(command) 
	if strcmp(lower(command),'initialize') | strcmp(lower(command),'new') 
		command = 0; 
	elseif strcmp(lower(command),lower('frame2')) 
		command = 1; 
	elseif strcmp(lower(command),lower('chkbox1')) 
		command = 2; 
	elseif strcmp(lower(command),lower('radio(1)')) 
		command = 3; 
	elseif strcmp(lower(command),lower('radio(2)')) 
		command = 4; 
	elseif strcmp(lower(command),lower('frame1')) 
		command = 5; 
	elseif strcmp(lower(command),lower('push1')) 
		command = 6; 
	elseif strcmp(lower(command),lower('popup1')) 
		command = 7; 
	elseif strcmp(lower(command),lower('slider1')) 
		command = 8; 
	elseif strcmp(lower(command),lower('edit1')) 
		command = 9; 
	end 
end 

if command ~= 0 
	handle_list = get(gcf,'userdata'); 
	if length(handle_list) > 0 
		frame2 = handle_list(1); 
		chkbox1 = handle_list(2); 
		radio(1) = handle_list(3); 
		radio(2) = handle_list(4); 
		frame1 = handle_list(5); 
		push1 = handle_list(6); 
		popup1 = handle_list(7); 
		slider1 = handle_list(8); 
		edit1 = handle_list(9); 
		txt1 = handle_list(10); 
		txt2 = handle_list(11); 
		txt3 = handle_list(12); 
	end 
end 


if command == 0 
	figure('position',[426 251 560 420 ],'resize','on'); 
	set(gca,'visible','off'); 

	%  Uicontrol Object Creation 
	frame2 = uicontrol(... 
		'BackgroundColor',[0.7 0.7 0.7 ],... 
		'CallBack','example1(''frame2'');',... 
		'ForegroundColor',[0 0 0 ],... 
		'Position',[0.6 0.53 0.22 0.26 ],... 
		'String',' ',... 
		'Style','frame',... 
		'Units','normalized',... 
		'Visible','on',... 
		'UserData',['frame2']); 
	chkbox1 = uicontrol(... 
		'BackgroundColor',[0.7 0.7 0.7 ],... 
		'CallBack','example1(''chkbox1'');',... 
		'ForegroundColor',[0 0 0 ],... 
		'Position',[0.61 0.72 0.2 0.05 ],... 
		'String','Show Results',... 
		'Style','checkbox',... 
		'Units','normalized',... 
		'Visible','on',... 
		'UserData',['chkbox1']); 
	radio(1) = uicontrol(... 
		'BackgroundColor',[0.7 0.7 0.7 ],... 
		'CallBack','example1(''radio(1)'');',... 
		'ForegroundColor',[0 0 0 ],... 
		'Position',[0.61 0.6 0.2 0.05 ],... 
		'String','Print Values',... 
		'Style','radiobutton',... 
		'Units','normalized',... 
		'Visible','on',... 
		'UserData',['radio(1)']); 
	radio(2) = uicontrol(... 
		'BackgroundColor',[0.7 0.7 0.7 ],... 
		'CallBack','example1(''radio(2)'');',... 
		'ForegroundColor',[0 0 0 ],... 
		'Position',[0.61 0.55 0.2 0.05 ],... 
		'String','Graph Values',... 
		'Style','radiobutton',... 
		'Units','normalized',... 
		'Visible','on',... 
		'UserData',['radio(2)']); 
	frame1 = uicontrol(... 
		'BackgroundColor',[0.7 0.7 0.7 ],... 
		'CallBack','example1(''frame1'');',... 
		'ForegroundColor',[0 0 0 ],... 
		'Position',[0.16 0.44 0.32 0.43 ],... 
		'String',' ',... 
		'Style','frame',... 
		'Units','normalized',... 
		'Visible','on',... 
		'UserData',['frame1']); 
	push1 = uicontrol(... 
		'BackgroundColor',[0.7 0.7 0.7 ],... 
		'CallBack','example1(''push1'');',... 
		'ForegroundColor',[0 1 0 ],... 
		'Position',[0.2 0.79 0.24 0.05 ],... 
		'String','Start Simulation',... 
		'Style','pushbutton',... 
		'Units','normalized',... 
		'Visible','on',... 
		'UserData',['push1']); 
	popup1 = uicontrol(... 
		'BackgroundColor',[0.7 0.7 0.7 ],... 
		'CallBack','example1(''popup1'');',... 
		'ForegroundColor',[0 0 0 ],... 
		'Position',[0.18 0.71 0.28 0.05 ],... 
		'String',' Simulation 1 | Simulation 2 | Simulation 3',... 
		'Style','popupmenu',... 
		'Units','normalized',... 
		'Visible','on',... 
		'UserData',['popup1']); 
	slider1 = uicontrol(... 
		'BackgroundColor',[0.7 0.7 0.7 ],... 
		'CallBack','example1(''slider1'');',... 
		'ForegroundColor',[0 0 0 ],... 
		'Position',[0.2 0.6 0.24 0.03 ],... 
		'String',' ',... 
		'Style','slider',... 
		'Units','normalized',... 
		'Visible','on',... 
		'UserData',['slider1']); 
	edit1 = uicontrol(... 
		'BackgroundColor',[0.7 0.7 0.7 ],... 
		'CallBack','example1(''edit1'');',... 
		'ForegroundColor',[0 0 0 ],... 
		'Position',[0.19 0.47 0.26 0.05 ],... 
		'String','filename.m',... 
		'Style','edit',... 
		'Units','normalized',... 
		'Visible','on',... 
		'UserData',['edit1']); 

	handle_ui_list = [ frame2 chkbox1 radio(1) radio(2) frame1 push1 ... 
			 popup1 slider1 edit1 ]; 


	%  Text Object Creation 
	txt1 = text(... 
		'Color',[1 1 1 ],... 
		'EraseMode','normal',... 
		'Position',[0.1 0.19 0 ],... 
		'Rotation',0 ,... 
		'String','Slider Value:'); 
	txt2 = text(... 
		'Color',[1 1 1 ],... 
		'EraseMode','xor',... 
		'Position',[0.36 0.19 0 ],... 
		'Rotation',0 ,... 
		'String','0.00'); 
	txt3 = text(... 
		'Color',[1 1 1 ],... 
		'EraseMode','normal',... 
		'Position',[0.39 1.02 0 ],... 
		'Rotation',0 ,... 
		'String','Example1'); 

	handle_txt_list = [ txt1 txt2 txt3 ]; 


	handle_list = [handle_ui_list handle_txt_list]; 
	set(gcf,'userdata',handle_list); 


elseif command == 1 
	disp('frame2 selected.') 
elseif command == 2 
	disp('chkbox1 selected.') 
elseif command == 3 
	disp('radio(1) selected.') 
elseif command == 4 
	disp('radio(2) selected.') 
elseif command == 5 
	disp('frame1 selected.') 
elseif command == 6 
	disp('push1 selected.') 
elseif command == 7 
	disp('popup1 selected.') 
elseif command == 8 
	disp('slider1 selected.') 
	set(txt2,'string',num2str(get(slider1,'value'))); 
elseif command == 9 
	disp('edit1 selected.') 
else 
	error('Error: example1.m called with incorrect command.') 
end 
