function t = find_txt
%
%  find_txt.m
%
%        Passes back all text objects handles in current figure that are not
%        attached to a uicontrol object.
%
%  usage:
%		t = find_txt
%
%
%  Author :  Patrick Marchand
%  Mods.  :  
%   

%  Copyright (c) 1994 by Patrick Marchand 
%       Permission is granted to modify and re-distribute this 
%	code in any manner as long as this notice is preserved. 
%	All standard disclaimers apply. 


ch = [get(gcf,'children')' get(gca,'children')'];
num_text = 0;
num_uitxt = 0;
num_uicontrol = 0;
uitxt_handle_set = [];
text_handle_set = [];
for loop = 1:length(ch)
  if strcmp(get(ch(loop),'type'),'uicontrol')
	num_uicontrol = num_uicontrol + 1;
	if isobj(get(ch(loop),'userdata'))
	  if strcmp(get(get(ch(loop),'userdata'),'type'),'text')
	    num_uitxt = num_uitxt + 1;
	    uitxt_handle_set = [uitxt_handle_set get(ch(loop),'userdata')];
	  end
	end
  end
  if strcmp(get(ch(loop),'type'),'text')
	num_text = num_text + 1;
	text_handle_set = [text_handle_set ch(loop)];
  end
end

t = [];
if num_text > num_uitxt
 for loop = 1:num_text
   if sum(text_handle_set(loop) == uitxt_handle_set) == 0
	t = [t text_handle_set(loop)];
   end
 end
end
