function h = find_ui
%
%  find_ui.m
%
%        Lables all uicontrol objects in current figure and passes back
%        the handles.
%
%  usage:
%		h = find_ui
%
%
%  Author :  Patrick Marchand
%  Mods.  :  
%   

%  Copyright (c) 1994 by Patrick Marchand 
%       Permission is granted to modify and re-distribute this 
%	code in any manner as long as this notice is preserved. 
%	All standard disclaimers apply. 


ch = get(gcf,'children');
num_uicontrol = 0;
for loop = 1:length(ch)
  if strcmp(get(ch(loop),'type'),'uicontrol')
	num_uicontrol = num_uicontrol + 1;
  end
end
cnt_uicontrol = 0;
h = [];
h_cnt = 1;
for loop = 1:length(ch)
  if strcmp(get(ch(loop),'type'),'uicontrol')
	cnt_uicontrol = cnt_uicontrol + 1;
	if isobj(get(ch(loop),'userdata'))
	   txt = get(get(ch(loop),'userdata'),'string');
	   if length(txt) >= 2
	     if strcmp(txt(1:2),'h(')
		txt = ['h(' num2str(h_cnt) ')'];
	        h_cnt = h_cnt + 1;
		set(get(ch(loop),'userdata'),'string',txt);
	     end
	   end
 	   set(ch(loop),'selected','off',...
		'callback',['disp(''' txt ''');']);
	else
	   if isstr(get(ch(loop),'userdata'))
	     txt = get(ch(loop),'userdata');
	   else
	     txt = ['h(' num2str(h_cnt) ')'];
	     h_cnt = h_cnt + 1;
	   end

	   set(ch(loop),'selected','off',...
		     'callback',['disp(''' txt ''');']);
	
	   if isobj(get(ch(loop),'userdata'))
	     delete(get(ch(loop),'userdata'));
	   end

	   axpos = get(gca,'position');
	   objpos = get(ch(loop),'position');
	   txtpos = [(objpos(1)+objpos(3)) (objpos(2)+objpos(4))];
	   txtpos = (txtpos - [axpos(1) axpos(2)])./[axpos(3) axpos(4)];
	   tx1 = text(txtpos(1),txtpos(2),0,...
		[txt],'units','normalized');
	   set(ch(loop),'userdata',tx1);
	end
	h(cnt_uicontrol) = ch(loop);
  end
end
