function moveobj(command,oneclick)
% FUNCTION MOVEOBJ(COMMAND)
% This is a callback designed to be called by a
% WindowButtonDown event.  COMMAND dictates the
% function's behavior. Basically, the function 
% gcos mouse-controlled movement of objects.
%
%  Origin :  movetxt.m by Keith Rogers 11/30/93
%  Author :  Patrick Marchand
%  Mods.  :  Modified to move uicontrol objects
%   

%  Copyright (c) 1994 by Patrick Marchand 
%       Permission is granted to modify and re-distribute this 
%	code in any manner as long as this notice is preserved. 
%	All standard disclaimers apply. 


global moveobj_pos
global oldobj
global oldunits_fig oldunits_obj

if nargin < 2 & nargin > 0
   oneclick = 0;
end

if(command <= 2)	  % If we're setting up a buttondown funtion

	%%%%%%%%%%%%%%%%%%%%%%%
	% De-select old objects
	%%%%%%%%%%%%%%%%%%%%%%%

%	if(oldobj ~= gco)
%		set(oldobj,'Selected','off');
%	end


	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	% Make sure we are dealing with a text object
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

	if(strcmp(get(gco,'Type'),'uicontrol'))
		set(gco,'Selected','on');
		oldobj = gco;

	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	% Set up functions for a text move
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

		button = get(gcf, 'SelectionType');
		oldunits_fig = get(gcf,'units');
		oldunits_obj = get(gco,'units');
		set(gcf,'units','normalized');
		set(gco,'units','normalized');
	   if oneclick == 0
		if strcmp(button,'normal')
			set(gcf,'WindowButtonMotionFcn','moveobj(7)');
		elseif strcmp(button,'extend')
			set(gcf,'pointer','topr');
			set(gcf,'WindowButtonMotionFcn','moveobj(8)');
		end
		set(gcf,'WindowButtonUpFcn','moveobj(6)');
	   else
		if command == 1
			set(gcf,'WindowButtonMotionFcn','moveobj(7)');
		elseif command == 2
			set(gcf,'pointer','topr');
			set(gcf,'WindowButtonMotionFcn','moveobj(8)');
		end
		set(gcf,'WindowButtonDownFcn','moveobj(6)');
	   end
	else
	  disp('An uicontrol object must be selected for this operation!')
	end

%%%%%%%%%%%%%%%%%%%%
% WindowButtonUpFcn
%%%%%%%%%%%%%%%%%%%%

elseif(command == 6)
	set(gco,'units',oldunits_obj);
	set(oldobj,'selected','off');
	set(gcf,'units',oldunits_fig);
	set(gcf,'pointer','arrow');
	set(gcf,'WindowButtonMotionFcn','');
	set(gcf,'WindowButtonUpFcn','');
	txt2 = ['if isobj(gco),sco(gco);else,' ...
		'if isobj(get(gca,''userdata'')),'...
		'set(get(gca,''userdata''),''selected'',''off'');end;end'];
%		'set(last_selected_obj,''selected'',''off'');end'];
	set(gcf,'WindowButtonDownFcn',txt2);
%	set(gcf,'ButtonDownFcn','');

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Do the Text Move (this is for WindowButtonMotionFcn) 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

elseif(command == 7)
%	set(gco,'Selected','off');
	pold = get(gco,'position');
	att_txt = get(gco,'userdata');
	p = round((get(gcf,'CurrentPoint')+.01)*100)/100;
	set(gco,'Position',[p(1,1) p(1,2) pold(1,3) pold(1,4)]);
	if isobj(att_txt)
		oldunits = get(att_txt,'Units');
		set(att_txt,'Units','normalized');
		axpos = get(gca,'position');
		txtpos = [(p(1,1)+pold(1,3)) (p(1,2)+pold(1,4))];
		set(att_txt,'Units',oldunits);
		txtpos = (txtpos - [axpos(1) axpos(2)])./[axpos(3) axpos(4)];
	   set(att_txt,'position',[txtpos]);
	end
elseif(command == 8)
%	set(gco,'Selected','off');
	pold = get(gco,'position');
	p = get(gcf,'CurrentPoint');
	newwidth = round((p(1,1)-pold(1,1))*100)/100;
	newheight = round((p(1,2)-pold(1,2))*100)/100;
	if newwidth <= 0
	  newwidth = eps;
	end
	if newheight <= 0
	  newheight = eps;
	end
	set(gco,'Position',[pold(1,1) pold(1,2) newwidth newheight]);
	pold = get(gco,'position');
	att_txt = get(gco,'userdata');
	if isobj(att_txt)
		oldunits = get(att_txt,'Units');
		set(att_txt,'Units','normalized');
		axpos = get(gca,'position');
		txtpos = [(p(1,1)) (p(1,2))];
		set(att_txt,'Units',oldunits);
		txtpos = (txtpos - [axpos(1) axpos(2)])./[axpos(3) axpos(4)];
	   set(att_txt,'position',[txtpos]);
	end
end
