% Case 1:
clear xy;
for i = 0:5,
  for j = 1:4,
    xy(i*4+j,1)=i;
    xy(i*4+j,2)=j;
  end
end
    
[v,i]=hull2d(xy); [i v]
subplot(121)
plot(xy(:,1),xy(:,2),'x',v(:,1),v(:,2),'o',v(:,1),v(:,2))
axis([-1 6 0 5])
subplot(122)
plot(xy(:,1),xy(:,2),'x',xy(i,1),xy(i,2),'o',xy(i,1),xy(i,2))
axis([-1 6 0 5])
pause

%Case 2:
clear xy;
for i = 5:-1:0,
  for j = 1:4,
    xy(i*4+j,1)=i;
    xy(i*4+j,2)=j;
  end
end
    
[v,i]=hull2d(xy); [i v]
subplot(121)
plot(xy(:,1),xy(:,2),'x',v(:,1),v(:,2),'o',v(:,1),v(:,2))
axis([-1 6 0 5])
subplot(122)
plot(xy(:,1),xy(:,2),'x',xy(i,1),xy(i,2),'o',xy(i,1),xy(i,2))
axis([-1 6 0 5])
pause

%Case 3:
clear xy;
for i = 5:-1:0,
  for j = 4:-1:1,
    xy(i*4+j,1)=i;
    xy(i*4+j,2)=j;
  end
end
    
[v,i]=hull2d(xy); [i v]
subplot(121)
plot(xy(:,1),xy(:,2),'x',v(:,1),v(:,2),'o',v(:,1),v(:,2))
axis([-1 6 0 5])
subplot(122)
plot(xy(:,1),xy(:,2),'x',xy(i,1),xy(i,2),'o',xy(i,1),xy(i,2))
axis([-1 6 0 5])
pause

%Case 4:
clear xy;
for i = 0:5,
  for j = 4:-1:1,
    xy(i*4+j,1)=i;
    xy(i*4+j,2)=j;
  end
end
    
[v,i]=hull2d(xy); [i v]
subplot(121)
plot(xy(:,1),xy(:,2),'x',v(:,1),v(:,2),'o',v(:,1),v(:,2))
axis([-1 6 0 5])
subplot(122)
plot(xy(:,1),xy(:,2),'x',xy(i,1),xy(i,2),'o',xy(i,1),xy(i,2))
axis([-1 6 0 5])
pause


% Test a degenerate case:
clear xy;
xy = [1 2];
   
[v,i]=hull2d(xy); [i v]
subplot(121)
plot(xy(:,1),xy(:,2),'x',v(:,1),v(:,2),'o',v(:,1),v(:,2))
axis([-1 6 0 5])
subplot(122)
plot(xy(:,1),xy(:,2),'x',xy(i,1),xy(i,2),'o',xy(i,1),xy(i,2))
axis([-1 6 0 5])
pause

% Test another degenerate case:
clear xy;
xy=[1 2;5 3];
   
[v,i]=hull2d(xy); [i v]
subplot(121)
plot(xy(:,1),xy(:,2),'x',v(:,1),v(:,2),'o',v(:,1),v(:,2))
axis([-1 6 0 5])
subplot(122)
plot(xy(:,1),xy(:,2),'x',xy(i,1),xy(i,2),'o',xy(i,1),xy(i,2))
axis([-1 6 0 5])
pause

% Test a near-degenerate case:
clear xy;
xy = [0 1;3 2;0 3];
   
[v,i]=hull2d(xy); [i v]
subplot(121)
plot(xy(:,1),xy(:,2),'x',v(:,1),v(:,2),'o',v(:,1),v(:,2))
axis([-1 6 0 5])
subplot(122)
plot(xy(:,1),xy(:,2),'x',xy(i,1),xy(i,2),'o',xy(i,1),xy(i,2))
axis([-1 6 0 5])
pause

% A more complex case:
clear xy;
i=1;
for r=1:5,
  for theta=0:pi/8:2*pi,
    xy(i,1) = r*cos(theta);
    xy(i,2) = r*sin(theta);
    i = i+1;
  end
end

[v,i]=hull2d(xy); [i v]
subplot(121)
plot(xy(:,1),xy(:,2),'x',v(:,1),v(:,2),'o',v(:,1),v(:,2))
axis('normal')
subplot(122)
plot(xy(:,1),xy(:,2),'x',xy(i,1),xy(i,2),'o',xy(i,1),xy(i,2))
axis('normal')
pause

% And another
clear xy;
i=1;
for r=1:5,
  for theta=0:(pi/8):(pi/2),
    xy(i,1) = r*cos(theta);
    xy(i,2) = r*sin(theta);
    i = i+1;
  end
end

[v,i]=hull2d(xy); [i v]
subplot(121)
plot(xy(:,1),xy(:,2),'x',v(:,1),v(:,2),'o',v(:,1),v(:,2))
axis('normal')
subplot(122)
plot(xy(:,1),xy(:,2),'x',xy(i,1),xy(i,2),'o',xy(i,1),xy(i,2))
axis('normal')
pause

% And yet another
clear xy;
i=1;
K = 1e10;
for r=1:5,
  for theta=-(pi/2):(pi/8):(pi/2),
    xy(i,1) = round(r*cos(theta)*K)/K;
    xy(i,2) = round(r*sin(theta)*K)/K;
    i = i+1;
  end
end

[v,i]=hull2d(xy); [i v]
subplot(121)
plot(xy(:,1),xy(:,2),'x',v(:,1),v(:,2),'o',v(:,1),v(:,2))
axis('normal')
subplot(122)
plot(xy(:,1),xy(:,2),'x',xy(i,1),xy(i,2),'o',xy(i,1),xy(i,2))
axis('normal')
pause

xy = [ -1 -1; -1 -1 ; 1 -1 ; 1 1];
[v,i]=hull2d(xy); [i v]
subplot(121)
plot(xy(:,1),xy(:,2),'x',v(:,1),v(:,2),'o',v(:,1),v(:,2))
axis('normal')
subplot(122)
plot(xy(:,1),xy(:,2),'x',xy(i,1),xy(i,2),'o',xy(i,1),xy(i,2))
axis('normal')
pause

xy = [ -1 0; -1 -1; -1 0; -1 1; -1 0; 1 -1 ; 1 1];
[v,i]=hull2d(xy); [i v]
subplot(121)
plot(xy(:,1),xy(:,2),'x',v(:,1),v(:,2),'o',v(:,1),v(:,2))
axis([-2 2 -2 2])
subplot(122)
plot(xy(:,1),xy(:,2),'x',xy(i,1),xy(i,2),'o',xy(i,1),xy(i,2))
axis([-2 2 -2 2])
pause

xy = [0 0; 1 0; 2 0; 2 1; 2 10; 2 2; 2 3];

[v,i]=hull2d(xy); [i v]
subplot(121)
plot(xy(:,1),xy(:,2),'x',v(:,1),v(:,2),'o',v(:,1),v(:,2))
axis('normal')
subplot(122)
plot(xy(:,1),xy(:,2),'x',xy(i,1),xy(i,2),'o',xy(i,1),xy(i,2))
axis('normal')
pause
