function smilie(x, y)

%SMILY    Plot using smilies :-)
%          SMILY(Y) plots vector Y using smilies.
%          SMILY(X, Y) plots vector Y at X using smilies.

%         Jayanth N. Anantharaman, 02/19/90
%         jayanth@ee.eng.ohio-state.edu

npt = length(x);

if nargin < 2,
  y = x;
  x = 1:npt;
end

[ mx nx ] = size(x);
[ my, ny ] = size(y);

% make into row vectors
if nx == 1,     x = x.';        end
if ny == 1,     y = y.';        end

scale = 60;
ay = (max(y) - min(y)) / scale;
ax = (max(x) - min(x)) / scale;

r2 = sqrt(2);
y0a2 =  y - ay/2;              % 0 for -, 1 for + in y0a2 etc.
y1a2 =  y + ay/2;
y0a24 = y - (ay+r2*ay)/4;
y1a24 = y + (ay+r2*ay)/4;
y0a22 = y - (ay+r2*ay)/2;
y1a22 = y + (ay+r2*ay)/2;

x0a2 =  x - ax/2;
x1a2 =  x + ax/2;
x0a24 = x - (ax+r2*ax)/4;
x1a24 = x + (ax+r2*ax)/4;
x0a22 = x - (ax+r2*ax)/2;
x1a22 = x + (ax+r2*ax)/2;

plot([x0a2; x0a22; x0a22; x0a2; x1a2; x1a22; x1a22; x1a2; x0a2], ...
    [y0a22; y0a2; y1a2; y1a22; y1a22; y1a2; y0a2; y0a22; y0a22], 'r-', ...
    [x0a24; (x-ax/3); (x+ax/3); x1a24], [y0a2; y0a24; y0a24; y0a2], 'r-')
hold on
plot([x; x], [(y-ay/3); (y+ay/3)], 'r-', ...
    [(x-ax/2-ax/6); (x-ax/2+ax/6)], [y1a24; y1a24], 'r-', ...
    [(x+ax/2-ax/6); (x+ax/2+ax/6)], [y1a24; y1a24], 'r-', ...
    x0a2, (y1a24-ay/10), 'r.', x1a2, (y1a24-ay/10), 'r.')
hold off

%------------------ EOF ------------------------
