%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% movie           a poor man's slow motion animation with zoom
%                 in capability.
%
% movie(U)        plot each row of U between keystroks
% movie(U,k)      plot every other k rows of U
% movie(U,m,n)    plot only columns m .. n of U
% movie(U,m,n,k)    every other k rows
%                 if m, n are non-integers or are out of range,
%                   plot entire row using [m,n] as range for U
% movie(U,m,n,x,y)  plot columns m .. n, range [x,y]
% movie(U,m,n,x,y,k)     guess what this means.
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% APPLICATION:  U(m,.)  may represent the temperature/wave
%                 profile at time t(m), obtained from solving
%                 a heat/wave equation.
%               movie(U)  is then a slide show of the profile,
%                 stepping through time.
%
%               Or perhpas  U(m,.)  is the solution of an ode
%                 depending on the parameter  m.
%
%               Hope that mathwork can provide the real thing
%                 in the future.
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function movie(u,n,N,m,M,d)

hold off
disp('Press any keystroke to continue.')
s=size(u);
if nargin==1|nargin==3|nargin==5 d=1;
elseif nargin==2 d=n;
elseif nargin==4 d=m;
end
if nargin<=2 n=1; N=s(2);
elseif n<1 | N>s(2) m=n; M=N; n=1; N=s(2); end
if ~exist('M') M=max(max(u(:,n:N))); m=min(min(u(:,n:N))); end
axis([n N m M])
plot(u(d,:))
hold on
grid
pause
for i=2*d:d:s(1)
plot(u(i,:))
pause
end
disp('  --*  THE END  *--')
