function  string = linkinit(obj)

% LINKINIT  Initializes the "linking" string with the data
%       from the root text object OBJ

%  Kirill K. Pankratov,  kirill@plume.mit.edu
%  April 6, 1994

 % Switch for version 4.0-4.1 (set 0 for 4.0, 1 for 4.1 and +)
isvalid = 0;

string = get(obj,'string');
string = [string(:)' '  '];

if all(string(1:2)=='\l')
  cstr = [];
  ftnm = get(obj,'fontname');
  ftsz = get(obj,'fontsize');
  if isvalid
    ftwt = get(obj,'fontweight');
    ftan = get(obj,'fontangle');
  end
  col = get(obj,'color');
  if any(col~=[1 1 1])
    cstr = ['\color{[' sprintf('%6.3f',col) ']} '];
  end
  if ~strcmp(ftnm,'Helvetica'), cstr = [cstr '\' ftnm ' ']; end
  if ftsz~=12, cstr = [cstr '\fontsize{' num2str(ftsz) '} ']; end
  if isvalid
    if ~strcmp(ftwt,'normal'), cstr = [cstr '\' ftwt ' ']; end
    if ~strcmp(ftan,'normal'), cstr = [cstr '\' ftan ' ']; end
  end
  string = [cstr string(1:length(string)-2)];
else
  string = [];
end
