function  setlink(Link)
% SETLINK  Inserts LINK information into "userdata" of the 
%        objects specified by the first column of LINK matrix

%  Kirill K. Pankratov,  kirill@plume.mit.edu
%  April 3, 1994

 % Make root a first line ..................................
A = Link(:,[4:6 8:10]);
fnd = find(all(A'==0));
if fnd==[], fnd = 1; end
num = [fnd(1) 1:fnd(1)-1 fnd(1)+1:size(Link,1)];
Link = Link(num,:);


 % Set "userdata" properties ...............................
 % The root text
usd = get(Link(1,1),'userdata');
if isstr(usd)    % If string
  cstr = sprintf('%10.6f',Link(1,2:size(Link,2)));
  lmin = min(length(cstr),size(usd,2));
  A = cstr(ones(size(usd,1),1),1:lmin)==usd(:,1:lmin);
  fnd = find(sum(A')>lmin-3);
  if fnd~=[]
    usd(fnd(1),1:lenght(cstr)) = cstr;
  else, usd = str2mat(usd,cstr);
  end
elseif usd~=[]   % If number
  lmin = min(size(Link,2)-1,size(usd,2));
  A = Link(ones(size(usd,1),1),2:lmin+1)==usd(:,1:lmin);
  fnd = find(sum(A')>lmin-3);
  if fnd~=[]
    usd(fnd(1),1:size(Link,2)-1) = Link(1,2:size(Link,2));
  else
    usd(size(usd,1)+1,1:size(Link,2)-1) = Link(1,2:size(Link,2));
  end
else             % If no userdata
  usd = Link(1,2:size(Link,2));
end
set(Link(1,1),'userdata',usd)

 % All other pieces
for jl = 2:size(Link,1)
  set(Link(jl,1),'userdata',Link(jl,2:size(Link,2)))
end
