function PGhelp()
if(get(gcf,'CurrentCharacter') == 'h')
	rootloc = getset(0,'PointerLocation','Units','Points');
	figpos = getset(gcf,'Position','Units','Points');
	loc = rootloc-figpos(1:2);

	%%%%%%%%%%%%%%%%%%%%%
	% pushbutton: Print %
	%%%%%%%%%%%%%%%%%%%%%

	if(uh_isin(loc,[110.000000 270.000000 80.000000 25.000000]))
		disp(' ');
		disp('Prints commands that will generate the figure and');
		disp('axes configuration to the command window; you may');
		disp('then copy and paste into another file.');

	%%%%%%%%%%%%%%%%%%%%%
	% checkbox: WYSIWYG %
	%%%%%%%%%%%%%%%%%%%%%

	elseif(uh_isin(loc,[20.000000 270.000000 80.000000 25.000000]))
		disp(' ');
		disp('When checked, pgsetup will resize the figure window');
		disp('to match the size at which it will be printed on the');
		disp('page.  This will allow you to check for labels that');
		disp('may have been cut off and generally make sure the');
		disp('proportions are what you intended.');

	%%%%%%%%%%%%%%%%%%%%
	% pushbutton: Save %
	%%%%%%%%%%%%%%%%%%%%

	elseif(uh_isin(loc,[200.000000 270.000000 80.000000 25.000000]))
		disp(' ');
		disp('Saves to a file commands that will generate the');
		disp('figure and axes configuration shown in the display.');

	%%%%%%%%%%%%%%%%%%%%%
	% pushbutton: Apply %
	%%%%%%%%%%%%%%%%%%%%%

	elseif(uh_isin(loc,[290.000000 270.000000 80.000000 25.000000]))
		disp(' ');
		disp('Shows results of manipulations so far without closing');
		disp('the Page Setup window.');

	%%%%%%%%%%%%%%%%%%%%%%
	% pushbutton: Cancel %
	%%%%%%%%%%%%%%%%%%%%%%

	elseif(uh_isin(loc,[290.000000 305.000000 80.000000 25.000000]))
		disp(' ');
		disp('Closes this figure and does nothing else.');

	%%%%%%%%%%%%%%%%%%
	% pushbutton: OK %
	%%%%%%%%%%%%%%%%%%

	elseif(uh_isin(loc,[290.000000 340.000000 80.000000 25.000000]))
		disp(' ');
		disp('Applies changes that have been made and closes');
		disp('the Page Setup window.');

	%%%%%%%%%%%%%%%%%%%%%%%%%
	% popupmenu: PaperUnits %
	%%%%%%%%%%%%%%%%%%%%%%%%%

	elseif(uh_isin(loc,[280.000000 380.000000 90.000000 20.000000]))
		disp(' ');
		disp('Sets the units in which the PaperPosition will be');
		disp('calculated.  The PaperPosition determines how the');
		disp('figure will be printed on a page; the figure''s');
		disp('''position'' property determines how the figure''s');
		disp('window will be sized and placed on the screen.');

	%%%%%%%%%%
	% text:  %
	%%%%%%%%%%

	elseif(uh_isin(loc,[270.000000 400.000000 90.000000 20.000000]))
		disp(' ');
		disp('No help available for this UIcontrol');

	%%%%%%%%%%%%%%%%%%%%
	% checkbox: Invert %
	%%%%%%%%%%%%%%%%%%%%

	elseif(uh_isin(loc,[150.000000 305.000000 130.000000 20.000000]))
		disp(' ');
		disp('Normally, MATLAB displays its figures with a black');
		disp('background.  When you print, you will normally want');
		disp('a white background instead.  Invert Hardcopy does');
		disp('this.');

	%%%%%%%%%%%%%%%%%%%%%
	% popupmenu: Orient %
	%%%%%%%%%%%%%%%%%%%%%

	elseif(uh_isin(loc,[150.000000 335.000000 120.000000 20.000000]))
		disp(' ');
		disp('Options:');
		disp('   Portrait  -- MATLAB''s default');
		disp('   Tall      -- like portrait, but no margins');
		disp('   Landscape -- Again, no margins.');

	%%%%%%%%%%
	% text:  %
	%%%%%%%%%%

	elseif(uh_isin(loc,[150.000000 355.000000 120.000000 20.000000]))
		disp(' ');
		disp('No help available for this UIcontrol');

	%%%%%%%%%%%%%%%%%%%%%%%%
	% popupmenu: PaperType %
	%%%%%%%%%%%%%%%%%%%%%%%%

	elseif(uh_isin(loc,[150.000000 380.000000 120.000000 20.000000]))
		disp(' ');
		disp('In America, the standard is usletter.');
		disp('In Europe and Japan, A4 is the standard.');

	%%%%%%%%%%
	% text:  %
	%%%%%%%%%%

	elseif(uh_isin(loc,[150.000000 400.000000 100.000000 20.000000]))
		disp(' ');
		disp('No help available for this UIcontrol');

	%%%%%%%%%%%%%%%
	% edit: Right %
	%%%%%%%%%%%%%%%

	elseif(uh_isin(loc,[70.000000 305.000000 60.000000 20.000000]))
		disp(' ');
		disp('Adjusts the right margin; units are as shown in');
		disp('the PaperUnits popupmenu');

	%%%%%%%%%%
	% text:  %
	%%%%%%%%%%

	elseif(uh_isin(loc,[5.000000 305.000000 60.000000 20.000000]))
		disp(' ');
		disp('No help available for this UIcontrol');

	%%%%%%%%%%%%%
	% edit: Top %
	%%%%%%%%%%%%%

	elseif(uh_isin(loc,[70.000000 330.000000 60.000000 20.000000]))
		disp(' ');
		disp('Adjusts the top margin; units are as shown in');
		disp('the PaperUnits popupmenu');

	%%%%%%%%%%
	% text:  %
	%%%%%%%%%%

	elseif(uh_isin(loc,[5.000000 330.000000 60.000000 20.000000]))
		disp(' ');
		disp('No help available for this UIcontrol');

	%%%%%%%%%%%%%%
	% edit: Left %
	%%%%%%%%%%%%%%

	elseif(uh_isin(loc,[70.000000 355.000000 60.000000 20.000000]))
		disp(' ');
		disp('Adjusts the left margin; units are as shown in');
		disp('the PaperUnits popupmenu');

	%%%%%%%%%%
	% text:  %
	%%%%%%%%%%

	elseif(uh_isin(loc,[5.000000 355.000000 60.000000 20.000000]))
		disp(' ');
		disp('No help available for this UIcontrol');

	%%%%%%%%%%%%%%%%
	% edit: Bottom %
	%%%%%%%%%%%%%%%%

	elseif(uh_isin(loc,[70.000000 380.000000 60.000000 20.000000]))
		disp(' ');
		disp('Adjusts the bottom margin; units are as shown in');
		disp('the PaperUnits popupmenu');

	%%%%%%%%%%
	% text:  %
	%%%%%%%%%%

	elseif(uh_isin(loc,[5.000000 380.000000 60.000000 20.000000]))
		disp(' ');
		disp('No help available for this UIcontrol');

	%%%%%%%%%%
	% text:  %
	%%%%%%%%%%

	elseif(uh_isin(loc,[25.000000 400.000000 60.000000 20.000000]))
		disp(' ');
		disp('No help available for this UIcontrol');
	end
end
