%  This callback routine has to be an m-file, not a function
%  because it modifies the workspace.  We know which function to
%  execute by examining the label of the current menu item.
%
% Keith Rogers 11/93
% Mods:
%     12/02/94  Shorten name to appease DOS users,
%               Change "makemenus" to "matdraw"

SavedFile = get(get(gcm,'Parent'),'UserData');

if (strcmp(get(gcm,'Label'),'Load'))
	[filename,pathname] = uigetfile('*.mat',...
	'Choose a MATLAB Data file',50,50);
	if (filename ~= 0)
		SavedFile = [pathname filename];
		clear filename pathname;
		eval(['load ' SavedFile ';']);
		set(get(gcm,'Parent'),'UserData',SavedFile);
	end
elseif (strcmp(get(gcm,'Label'),'Save'))
	if (strcmp(SavedFile,''))
		[filename,pathname] = uiputfile('*.mat','Data Filename',...
			50,50);
		if (filename)
			SavedFile = [pathname filename];
			clear filename pathname;
			eval(['save ' SavedFile ';']);
			set(get(gcm,'Parent'),'UserData',SavedFile);
		end
	else
		eval(['save ' SavedFile ';']);
	end
elseif (strcmp(get(gcm,'Label'),'Save As'))
	if (strcmp(SavedFile,''))
		[filename,pathname] = uiputfile('*.mat','Data Filename',...
			50,50);
	else
		[filename,pathname] = uiputfile(SavedFile,'Data Filename',...
			50,50);
	end
	if (filename)
		SavedFile = [pathname filename];
		clear filename pathname;
		eval(['save ' SavedFile ';']);
		set(get(gcm,'Parent'),'UserData',SavedFile);
	end
elseif (strcmp(get(gcm,'Label'),'Print'))
	DatObjs = get(findfig('Draw Tools'),'UserData');
	Defaults = get(DatObjs(5),'UserData');
	SaveString = get(Defaults(13),'UserData');
	if(SaveString(2) == 'd' & SaveString(3) == 'e' | SaveString(3) == 'i' | ...
	   SaveString(3) == 'p' | SaveString(3) == 'g' & ...
	   ~strcmp(SaveString,'-depson') & ~strcmp(SaveString,'-deps9high')) 
		if(SaveString(3) == 'e')
			extension = '*.eps';
		elseif(SaveString(3) == 'i')
			extension = '*.ill';
		elseif(SaveString(3) == 'p')
			if(SaveString(4) == 'c')
				extension = '*.pcx';
			else
				extension = '*.ps';
			end
		elseif(SaveString(3) == 'g')
				extension = '*.gif';
		end
		[filename,pathname] = uiputfile(extension,'Filename',...
			50,50);
		if(filename)
			print(SaveString,[pathname filename]);
		end
		clear extension filename pathname;
	else
		print(SaveString);
	end
	clear SaveString DatObjs Defaults

elseif (strcmp(get(gcm,'Label'),'New Figure'))
	figure;
	matdraw;
elseif (strcmp(get(gcm,'Label'),'Save Figure'))
	delete(findobj(gcf,'Type','uimenu','Parent',gcf));
	wbdfcn = get(gcf,'WindowButtonDownFcn');
	set(gcf,'ResizeFcn','','WindowButtonDownFcn','','KeypressFcn','');
	[fname,pname] = uiputfile('*.m','Save figure to m-file:');
	if(fname)
		print('-dmfile',[pname fname]);
	else
		disp('Save failed!');
	end
	mdprog(3);
	set(gcf,'WindowButtonDownFcn',wbdfcn);
elseif (strcmp(get(gcm,'Label'),'Add to Path'))
    [MDpathfile,MDpathpath] = uigetfile('*','Select a file in the directory which you wish to add.');
    if(~isempty(MDpathfile))
		path(path,MDpathpath(1:length(MDpathpath)-1));
	end
	clear MDpathfile MDpathpath;
elseif (strcmp(get(gcm,'Label'),'Quit MatDraw'))
	pfig = findfig('Draw Tools');
	datObjs = get(pfig,'UserData');
	figList = get(datObjs(14),'UserData');
	fig = gcf;
	if(find(figList==fig))
		menuList = get(datObjs(7),'UserData');
		menuList = menuList(find(figList~=fig),:);
		figList = figList(find(figList~=fig));
		set(datObjs(14),'UserData',figList);
		set(datObjs(7),'UserData',menuList);
	end
	if(isempty(figList))
		delete(pfig);
	end
	delete(findobj(fig,'Type','uimenu','Parent',fig));
	set(fig,'ResizeFcn','',...
	        'WindowButtonDownFcn','',...
			'KeypressFcn','',...
			'Pointer','arrow',...
			'menubar','figure');
end

