function objdata = zoom3d(newlims,DataObj)
% Issues:
% Must save data for each surface object
% What about line objects?
% What about new plots after a zoom?

objdata = get(DataObj,'UserData');
pfig = findfig('Draw Tools');
kids = get(gca,'Children');
for(i=1:size(objdata,1))
	if(~any(kids == objdata(i,2)))
		objdata = objdata(find(objdata(:,2)~=objdata(i,2)),:);
	end
end
for(i = 1:length(kids))
	if(strcmp(get(kids(i),'Type'),'surface'))
		h = store(pfig,1);
		if(isempty(objdata))
			objdata = [h kids(i)];
		elseif(all(kids(i) ~= objdata(:,2)))  % If unstored surface
			objdata = [objdata;h kids(i)];
		end
		XD = get(kids(i),'XData');
		YD = get(kids(i),'YData');
		if(min(size(XD)) == 1)
			XD = XD(ones(size(YD,1),1),:);
		end
		if(min(size(YD)) == 1)
			YD = YD(:,ones(1,size(XD,2)));
		end
		data = [XD; YD; get(kids(i),'ZData');get(kids(i),'CData')];

		set(h,'UserData',data);
	elseif(strcmp(get(kids(i),'Type'),'line'))
		if(isempty(objdata))
			h = store(pfig,1);
			objdata = [h(1) kids(i)];
			set(h,'UserData',[get(kids(i),'XData');
									get(kids(i),'YData');
									get(kids(i),'ZData')]);
		elseif(all(kids(i) ~= objdata(:,2)))  % If unstored line
			h = store(pfig,1);
			objdata = [objdata;h(1) kids(i)];
			set(h,'UserData',[get(kids(i),'XData');
									get(kids(i),'YData');
									get(kids(i),'ZData')]);
		end
	end
end
set(DataObj,'UserData',objdata);
if(ishold)
	h = 1;
else
	h = 0;
end
hold on;
for(i = 1:size(objdata,1))
	C = get(objdata(i,1),'UserData');
	if(size(C,1) > 3)
		m = size(C,1)/4;
		n = size(C,2);
		X = C(1:m,:);
		Y = C(m+1:2*m,:);
		Z = C(2*m+1:3*m,:);
		C = C(3*m+1:4*m,:);
		Xlims = find((X(1,:) > newlims(1)) & (X(1,:) < newlims(2)));
		Ylims = find((Y(:,1) > newlims(3)) & (Y(:,1) < newlims(4)));
		X = X(Ylims,Xlims);
		Y = Y(Ylims,Xlims);
		Z = Z(Ylims,Xlims);
		C = C(Ylims,Xlims);
		ZHclip = find(Z > newlims(6));
		if(~isempty(ZHclip))
			Z(ZHclip) = newlims(6)*ones(size(ZHclip));
		end
		ZLclip = find(Z < newlims(5));
		if(~isempty(ZLclip))
			Z(ZLclip) = newlims(5)*ones(size(ZLclip));
		end
		set(objdata(i,2),'XData',X,'YData',Y,'ZData',Z,'CData',C);
	else
		X = C(1,:);
		Y = C(2,:);
		Z = C(3,:);
		OOB = find((X < newlims(1)) |...
					  (X > newlims(2)) |...
					  (Y < newlims(3)) |...
					  (Y > newlims(4)) |...
					  (Z < newlims(5)) |...
					  (Z > newlims(6)));
		Z(OOB) = NaN*ones(size(OOB));
		set(objdata(i,2),'XData',X,'YData',Y,'ZData',Z);
	end
end

if(~h)
	hold off;
end
axis(newlims);
set(gcf,'pointer','arrow');
pfig  = findfig('Draw Tools');
eval('set(gcf,''WindowButtonDownFcn'',get(findobj(pfig,''Tag'',''Old WBDFcn''),''UserData''))','');
