function AxisCallback(command,ax)
% This function is a callback for makemenus.
% it should not be called from the command line.
%
% Keith Rogers 11/30/93

if (command == 1)
	if (ax == 'X')
		if(strcmp(get(gcm,'Label'),'Log'))
			set(gca,'Xscale','log');
			set(gcm,'Label','Linear');
		else
			set(gca,'Xscale','linear');
			set(gcm,'Label','Log');
		end
	elseif (ax == 'Y')
		if(strcmp(get(gcm,'Label'),'Log'))
			set(gca,'Yscale','log');
			set(gcm,'Label','Linear');
		else
			set(gca,'Yscale','linear');
			set(gcm,'Label','Log');
		end
	elseif (ax == 'Z')
		if(strcmp(get(gcm,'Label'),'Log'))
			set(gca,'Zscale','log');
			set(gcm,'Label','Linear');
		else
			set(gca,'Zscale','linear');
			set(gcm,'Label','Log');
		end
	end
elseif (command == 2)
	if (ax == 'X')
		minmax = get(gca,'XLim');
		set(gca,'XLim',[-inf minmax(2)]);
	elseif (ax == 'Y')
		minmax = get(gca,'YLim');
		set(gca,'YLim',[-inf minmax(2)]);
	elseif (ax == 'Z')
		minmax = get(gca,'ZLim');
		set(gca,'ZLim',[-inf minmax(2)]);
	end
elseif (command == 3)
	if (ax == 'X')
		minmax = get(gca,'XLim');
		set(gca,'XLim',[minmax(1) inf]);
	elseif (ax == 'Y')
		minmax = get(gca,'YLim');
		set(gca,'YLim',[minmax(1) inf]);
	elseif (ax == 'Z')
		minmax = get(gca,'ZLim');
		set(gca,'ZLim',[minmax(1) inf]);
	end
elseif (command == 4)
	if (ishold)
		hold off;
		set(gcm,'Label','Hold on');
	else
		hold on;
		set(gcm,'Label','Hold off');
	end
elseif (command == 5)
	if(strcmp(get(gcm,'Label'),'Freeze'))
		axis(axis);
		set(gcm,'Label','Auto');
	else
		axis('auto');
		set(gcm,'Label','Freeze');
	end
elseif (command == 6)
	menuhandle = get(gcm,'Parent');
	UserData = get(menuhandle,'UserData');
	if (ax == 'X')
		if (UserData(1))
			set(gcm,'Checked','off');
			UserData(1) = 0;
		else
			set(gcm,'Checked','on');
			UserData(1) = 1;
		end
	elseif (ax == 'Y')
		if (UserData(2))
			set(gcm,'checked','off');
			UserData(2) = 0;
		else
			set(gcm,'Checked','on');
			UserData(2) = 1;
		end
	else
		if (UserData(3))
			set(gcm,'Checked','off');
			UserData(3) = 0;
		else
			set(gcm,'Checked','on');
			UserData(3) = 1;
		end
	end
	set(menuhandle,'UserData',UserData);
elseif (command == 7)
	UserData = get(get(gcm,'Parent'),'UserData');
	UserData(4) = input2('Magnification Level?',UserData(4));	
	set(gcm,'Label',['Mag Level -' num2str(UserData(4)) '-']);
	set(get(gcm,'Parent'),'UserData',UserData);
end
