function plset( mode )

%  removing and replacing all 
% (for bitmap plotting)
if (mode==1 | mode==2)
   h=get(gcf,'Children');
   for i=1:length(h)
      type=get(h(i),'type');
      if ( strcmp('uicontrol',type) )
         if (mode==1) set(h(i),'visible','off'); end
         if (mode==2) set(h(i),'visible','on'); end
      end
   end
   return;
end

% determine whether current figure is a PL figure
% if it is delete all children except uimenus
% and 'exit' button
name=get(gcf,'name');
h=get(gcf,'children');
for i=1:length(h)
   ud=get(h(i),'userdata');
   if (strcmp(ud,'keep')==0) delete(h(i)); end
end

if (length(name)>1)
   if (strcmp(name(1:2),'PL'))
      return;
   end
end

%now delete current figure and create a PL one!
set(gcf,'name','PL v1.1');
%set(gcf,'menubar','none');
set(gcf,'numbertitle','off');
set(0,'defaultlinemarkersize',5);

%ui menus
f=uimenu('Label','Axes','userdata','keep');
uimenu(f,'label','Redraw','callback','pl(''redraw'')');
uimenu(f,'label','Auto axes','callback','pl(''auto'')');
uimenu(f,'label','Auto x axis','callback','pl(''auto_x'')');
uimenu(f,'label','Auto y axis','callback','pl(''auto_y'')');
uimenu(f,'label','Axis limits','callback','pl(''axis'')');
uimenu(f,'label','Scroll x on/off','callback','pl(''scroll'')');
uimenu(f,'label','Diff x','callback','pl(''xdiff'')');
uimenu(f,'label','Diff y','callback','pl(''ydiff'')');
uimenu(f,'label','Zoom x','callback','pl(''zoomx'')');
uimenu(f,'label','Zoom y','callback','pl(''zoomy'')');
uimenu(f,'label','Zoom xy','callback','pl(''zoomxy'')');
uimenu(f,'label','Lin/log axes','callback','pl(''linlog'')');
uimenu(f,'label','Compression on/off','callback','pl(''comp_onoff'')');
uimenu(f,'label','Grid on/off','callback','pl(''grid_onoff'')');
uimenu(f,'label','Save','callback','pl(''save'')');

g=uimenu('Label','Text','userdata','keep');
uimenu(g,'label','Titles\labels','callback','pl(''titles'')');
uimenu(g,'label','Add text','callback','pl(''add_text'')');
uimenu(g,'label','Edit text','callback','pl(''edit_text'')');
uimenu(g,'label','Text on/off','callback','pl(''text_onoff'')');

h=uimenu('Label','Key','userdata','keep');
uimenu(h,'label','Key on/off','callback','pl(''key_onoff'')');
uimenu(h,'label','Position key','callback','pl(''pos_key'')');
uimenu(h,'label','Key info','callback','pl(''key_info'')');

i=uimenu('Label','Subplot','userdata','keep');
uimenu(i,'label','Plot only','callback','pl(''plot_only'')');
uimenu(i,'label','Delete plot','callback','pl(''plot_del'')');
uimenu(i,'label','Plot all','callback','pl(''plot_all'')');
uimenu(i,'label','Link x axes on/off','callback','pl(''linkx_onoff'')');
uimenu(i,'label','Select next','callback','pl(''select_next'')');

j=uimenu('Label','Print','userdata','keep');
uimenu(j,'label','Plot setup','callback','pl(''plot_setup'')');
uimenu(j,'label','Postscript output','callback','pl(''postscript'')');
uimenu(j,'label','Meta file output','callback','pl(''meta'')');
uimenu(j,'label','Bitmap output','callback','pl(''bitmap'')');

uicontrol('style','pushbutton','position',[0 0 34 18],'string','Exit',...
		'callback','pl(''exit'')','userdata','keep');

end
