% Version 1.0 of ProPlot 1.0
%
%    // datajump.m \\
%
%     Scott Keane
%  skeane@uceng.uc.edu
%
%  Created on:     12:06 AM 3/27/96
%  Last Modified:  5:54 AM 4/26/96
% *****************************************
% Matlab script to add plotting uicontrols
% and run all valid branch scripts
% *****************************************

numoffigs=numoffigs+1; % *** holds the number of user figures in proplot ***

startedyet=1; % *** holds whether we are still on startup figures ***

if numoffigs==1
	plotvar=[]; % *** define plotvar
	loaddatastore=zeros(10,20); % *** matrix to hold loaded data for save write ***

	% *************************************************
	% ********** define global variables **************
	% *************************************************
	global figanddatawin;
	global modifylinessingle;
	global modifylinesall;
	global modifyleaderssingle;
	global modifyleadersall; 
	global textsmart;
	global winsize_figure_width;
	global timer;
	global modifytextssingle;
	global modifytextsall;

	global linecolor linestyle linewidth markersize;
	global popslistx popslisty popsx popsy plotvar;

	global numoffigs;

	% change text on input's save/exit window

	set(saveloadfile,'Visible','on');
	
	set(newfigure,'String','New Figure');

	set(savedatabutton,'Visible','on');
	% *** Load Data is not fully supported in ProPlot 1.0! ***
	if loaddataoption==1
		set(loaddata,'Visible','off');
	end


	% *********************************************
	% ******** Figure Text(Add to figinput)********
	% *********************************************

	curfiguretext=uicontrol(figinput,...
		'Style','text',...
		'Visible','on',...
		'Position',[80 30 100 20],...
		'String','Current Figure',...
		'BackgroundColor','k',...
		'ForegroundColor','w');
end



% ***************************************************
% ******** Create a new figure **********************
% ***************************************************

if numoffigs > 1 
	% *** use current figure size for new figure ***
	previousfigsize=get(figanddatawin(1,numoffigs-1),'Position');
	winsize_figure_left=previousfigsize(1,1);
	winsize_figure_bottom=previousfigsize(1,2);
	winsize_figure_width=previousfigsize(1,3);
	winsize_figure_height=previousfigsize(1,4);
end
	
dumfig86=['figanddatawin(1,numoffigs)=figure(''Resize'',''on'',''Pointer'',''circle'',''Position'',[',num2str(winsize_figure_left),' ',num2str(winsize_figure_bottom),' ',num2str(winsize_figure_width),' ',num2str(winsize_figure_height),'],''NumberTitle'',''off'',''Name'',''ProPlot 1.0  / Figure ',num2str(numoffigs),''');'];
eval(dumfig86);

% ***************************************************
% ******** Create a new data figure  ****************
% ***************************************************

declaredatafig=['figanddatawin(2,numoffigs)=figure(''Resize'',''on'',''Pointer'',''arrow'',''Position'',[',num2str(winsize_data_left),' ',num2str(winsize_data_bottom),' ',num2str(winsize_data_width),' ',num2str(winsize_data_height),'],''MenuBar'',''none'',''NumberTitle'',''off'',''Name'',''Figure ',num2str(numoffigs),' / Data'');'];
eval(declaredatafig);

% ***************************************************
% ******** Create a new label figure  ****************
% ***************************************************

declaredatafig=['figanddatawin(3,numoffigs)=figure(''Visible'',''off'',''Resize'',''on'',''Pointer'',''arrow'',''MenuBar'',''none'',''Position'',[',num2str(winsize_label_left),' ',num2str(winsize_label_bottom),' ',num2str(winsize_label_width),' ',num2str(winsize_label_height),'],''NumberTitle'',''off'',''Name'',''Figure ',num2str(numoffigs),' / Labels'');'];
eval(declaredatafig);
end

if numoffigs==1
	donelabels=[];
end
[donelabels,submitlabels,removelabels,resetlabels,figedit,figxedit,figyedit]=labelfun(donelabels,numoffigs,figanddatawin,figedit,figxedit,figyedit);


% *******************************************
% ******* Define Data 1,2 *******************
% *******************************************

uicontrol(figanddatawin(2,numoffigs),...
	'Style','text',...
	'String','Data #1',...
	'Position',[120 420 50 20],...
	'ForegroundColor','w',...
	'BackgroundColor','k');

uicontrol(figanddatawin(2,numoffigs),...
	'Style','text',...
	'String','Data #2',...
	'Position',[120 200 50 20],...
	'ForegroundColor','w',...
	'BackgroundColor','k');

uicontrol(figanddatawin(2,numoffigs),...
	'Style','text',...
	'String','____________________________________________________________',...
	'Position',[0 220 350 20],...
	'ForegroundColor','r',...
	'BackgroundColor','k');


% *************************************************
% ************ Specify x,y data to plot ***********
% *************************************************

xtoplot(numoffigs,1)=uicontrol(figanddatawin(2,numoffigs),...
	'Style','edit',...
	'Position',[30 400 100 20],...
	'ForegroundColor','w',...
	'BackgroundColor','b');



ytoplot(numoffigs,1)=uicontrol(figanddatawin(2,numoffigs),...
	'Style','edit',...
	'Position',[180 400 100 20],...
	'ForegroundColor','w',...
	'BackgroundColor','b');



xtoplot(numoffigs,2)=uicontrol(figanddatawin(2,numoffigs),...
	'Style','edit',...
	'Position',[30 180 100 20],...
	'ForegroundColor','w',...
	'BackgroundColor','b');



ytoplot(numoffigs,2)=uicontrol(figanddatawin(2,numoffigs),...
	'Style','edit',...
	'Position',[180 180 100 20],...
	'ForegroundColor','w',...
	'BackgroundColor','b');


% ************************************************
% ***************** x#,y# ************************
% ************************************************

xvalue1=uicontrol(figanddatawin(2,numoffigs),...
	'Style','text',...
	'String','x=',...
	'ForegroundColor','b',...	
	'BackgroundColor','k',...
	'Position',[10 400 15 20]);

yvalue1=uicontrol(figanddatawin(2,numoffigs),...
	'Style','text',...
	'String','y=',...
	'ForegroundColor','b',...	
	'BackgroundColor','k',...
	'Position',[160 400 15 20]);

xvalue2=uicontrol(figanddatawin(2,numoffigs),...
	'Style','text',...
	'String','x=',...
	'ForegroundColor','b',...	
	'BackgroundColor','k',...
	'Position',[10 180 15 20]);

yvalue2=uicontrol(figanddatawin(2,numoffigs),...
	'Style','text',...
	'String','y=',...
	'ForegroundColor','b',...	
	'BackgroundColor','k',...
	'Position',[160 180 15 20]);

% *************************************************
% ************* Call plotit for plotting **********
% *************************************************

plotit

% *************************************************
% *************** Reset Buttons *******************
% *************************************************

resetbutton(numoffigs,1)=uicontrol(figanddatawin(2,numoffigs),...
	'Style','push',...
	'String','Reset',...
	'Position',[135 280 50 20],...
	'CallBack',['for bb=1:numoffigs,if figanddatawin(2,bb)==gcf,',...
		'currentfigurenum=bb;callfigurenum=bb;end,end,',...
		'laststringinplotx=abs(get(xtoplot(currentfigurenum,1),''String''));',...
		'laststringinploty=abs(get(ytoplot(currentfigurenum,1),''String''));',...
		'lengthlaststringx=length(laststringinplotx);',...
		'lengthlaststringy=length(laststringinploty);',...
		'set(xtoplot(currentfigurenum,1),''String'','''');',...
		'set(ytoplot(currentfigurenum,1),''String'','''');',...
		'topbotdata=1;',...
		'if enmul==1,',...
			'for cc=1:numoffigs,',...
				'if get(figbox(currentfigurenum,cc),''Value'') == 1,',...					
					'[plotvar]=removfun(1,lengthlaststringx,lengthlaststringy,plotvar,bb,currentfigurenum,callfigurenum,numoffigs,gcf,topbotdata,figanddatawin),',...	
					'tempfigbox(cc)=1;',...
				'else;',...
					'tempfigbox(cc)=0;',...
				'end,',...
			'end,',...
			'if tempfigbox==zeros(1:length(tempfigbox)) & lengthlaststringx==0 & lengthlaststringy==0;',...
				'messtext=''Nothing to Reset! No checked boxes exist!'';',...
				'typeofcall=0;',...
				'messfun(typeofcall,messtext,currentfigurenum);',...
			'end;',...
		'else,',...
			'[plotvar]=removfun(1,lengthlaststringx,lengthlaststringy,plotvar,bb,currentfigurenum,callfigurenum,numoffigs,gcf,topbotdata,figanddatawin),',...	
		'end;',...
		'if enaddon==1;',...
			'if isempty(plotvar)==0;',...
				'testing=get(plotvar(currentfigurenum,1),''UserData'');',...
				'if isempty(testing)==1;',...%disable numeric if nothing in userdata
					'set(letmeint(currentfigurenum),''Enable'',''off'');',...% enable numerical
					'set(letmeder(currentfigurenum),''Enable'',''off'');',...
					'set(cfitmenus(currentfigurenum),''Enable'',''off'');',...
					'set(letmestat(currentfigurenum),''Enable'',''off'');',...
				'end;',...
			'end;',...
		'end;clear tempfigbox;']);


resetbutton(numoffigs,2)=uicontrol(figanddatawin(2,numoffigs),...
	'Style','push',...
	'String','Reset',...
	'Position',[135 60 50 20],...
	'CallBack',['for bb=1:numoffigs,if figanddatawin(2,bb)==gcf,',...
		'currentfigurenum=bb;callfigurenum=bb;end,end,',...
		'laststringinplotx=abs(get(xtoplot(currentfigurenum,2),''String''));',...
		'laststringinploty=abs(get(ytoplot(currentfigurenum,2),''String''));',...
		'lengthlaststringx=length(laststringinplotx);',...
		'lengthlaststringy=length(laststringinploty);',...
		'set(xtoplot(currentfigurenum,2),''String'','''');',...
		'set(ytoplot(currentfigurenum,2),''String'','''');',...
		'topbotdata=2;',...
		'if enmul==1,',...
			'for cc=1:numoffigs,',...
				'if get(figbox(currentfigurenum+numoffigs,cc),''Value'') == 1,',...
					'[plotvar]=removfun(1,lengthlaststringx,lengthlaststringy,plotvar,bb,currentfigurenum,callfigurenum,numoffigs,gcf,topbotdata,figanddatawin),',...
					'tempfigbox(cc)=1;',...
				'else;',...
					'tempfigbox(cc)=0;',...
				'end,',...
			'end,',...
			'if tempfigbox==zeros(1:length(tempfigbox)) & lengthlaststringx==0 & lengthlaststringy==0;',...
				'messtext=''Nothing to Reset! No checked boxes exist!'';',...
				'typeofcall=0;',...
				'messfun(typeofcall,messtext,currentfigurenum);',...
			'end;',...
		'else,',...
			'[plotvar]=removfun(1,lengthlaststringx,lengthlaststringy,plotvar,bb,currentfigurenum,callfigurenum,numoffigs,gcf,topbotdata,figanddatawin),',...
		'end;',...
		'if enaddon==1;',...
			'if isempty(plotvar)==0;',...
				'testing=get(plotvar(currentfigurenum,1),''UserData'');',...
				'if isempty(testing)==1;',...%disable numeric if nothing in userdata
					'set(letmeint(currentfigurenum),''Enable'',''off'');',...% enable numerical
					'set(letmeder(currentfigurenum),''Enable'',''off'');',...
					'set(cfitmenus(currentfigurenum),''Enable'',''off'');',...
					'set(letmestat(currentfigurenum),''Enable'',''off'');',...
				'end;',...
			'end;',...
		'end;clear tempfigbox;']);

% *************************************************
% *************** Remove Buttons *******************
% *************************************************

removebutton1(numoffigs)=uicontrol(figanddatawin(2,numoffigs),...
	'Style','push',...
	'String','Remove',...
	'Position',[70 280 60 20],...
	'CallBack',['for bb=1:numoffigs,if figanddatawin(2,bb)==gcf,',...
		'currentfigurenum=bb;callfigurenum=bb;end,end,',...
		'topbotdata=1;',...
		'if enmul==1,',...
			'for cc=1:numoffigs,',...
				'if get(figbox(currentfigurenum,cc),''Value'') == 1,',...
					'[plotvar]=removfun(2,0,0,plotvar,bb,currentfigurenum,callfigurenum,numoffigs,gcf,topbotdata,figanddatawin),',...
					'tempfigbox(cc)=1;',...
				'else;',...
					'tempfigbox(cc)=0;',...
				'end,',...
			'end,',...
			'if tempfigbox==zeros(1:length(tempfigbox));',...
				'messtext=''Nothing to Remove! No checked boxes exist!'';',...
				'typeofcall=0;',...
				'messfun(typeofcall,messtext,currentfigurenum);',...
			'end;',...
		'else,',...
			'[plotvar]=removfun(2,0,0,plotvar,bb,currentfigurenum,callfigurenum,numoffigs,gcf,topbotdata,figanddatawin),',...
		'end;',...
		'if enaddon==1;',...
			'if isempty(plotvar)==0;',...
				'testing=get(plotvar(currentfigurenum,1),''UserData'');',...
				'if isempty(testing)==1;',...%disable numeric if nothing in userdata
					'set(letmeint(currentfigurenum),''Enable'',''off'');',...% enable numerical
					'set(letmeder(currentfigurenum),''Enable'',''off'');',...
					'set(cfitmenus(currentfigurenum),''Enable'',''off'');',...
					'set(letmestat(currentfigurenum),''Enable'',''off'');',...
				'end;',...
			'end;',...
		'end;clear tempfigbox;']);


removebutton2(numoffigs)=uicontrol(figanddatawin(2,numoffigs),...
	'Style','push',...
	'String','Remove',...
	'Position',[70 60 60 20],...
	'CallBack',['for bb=1:numoffigs,if figanddatawin(2,bb)==gcf,',...
		'currentfigurenum=bb;callfigurenum=bb;end,end,',...
		'topbotdata=2;',...
		'if enmul==1,',...
			'for cc=1:numoffigs,',...
				'if get(figbox(currentfigurenum+numoffigs,cc),''Value'') == 1,',...
					'[plotvar]=removfun(2,0,0,plotvar,bb,currentfigurenum,callfigurenum,numoffigs,gcf,topbotdata,figanddatawin),',...
					'tempfigbox(cc)=1;',...
				'else;',...
					'tempfigbox(cc)=0;',...
				'end,',...
			'end,',...
			'if tempfigbox==zeros(1:length(tempfigbox));',...
				'messtext=''Nothing to Remove! No checked boxes exist!'';',...
				'typeofcall=0;',...
				'messfun(typeofcall,messtext,currentfigurenum);',...
			'end;',...
		'else,',...
			'[plotvar]=removfun(2,0,0,plotvar,bb,currentfigurenum,callfigurenum,numoffigs,gcf,topbotdata,figanddatawin),',...
		'end;',...
		'if enaddon==1;',...
			'if isempty(plotvar)==0;',...
				'testing=get(plotvar(currentfigurenum,1),''UserData'');',...
				'if isempty(testing)==1;',...%disable numeric if nothing in userdata
					'set(letmeint(currentfigurenum),''Enable'',''off'');',...% enable numerical
					'set(letmeder(currentfigurenum),''Enable'',''off'');',...
					'set(cfitmenus(currentfigurenum),''Enable'',''off'');',...
					'set(letmestat(currentfigurenum),''Enable'',''off'');',...		
				'end;',...
			'end;',...
		'end;clear tempfigbox;']);


% ***************************************************************
% ************************* Grid ********************************
% ***************************************************************

grid1(numoffigs)=uicontrol(figanddatawin(2,numoffigs),...
	'Style','checkbox',...
	'ForegroundColor','y',...
	'BackgroundColor','k',...
	'String','Grid',...
	'Value',0,...
	'Position',[215 280 50 20],...
	'CallBack',['for bb=1:numoffigs,if figanddatawin(2,bb)==gcf,',...
		'currentfigurenum=bb;end,end,',...
		'testing=get(grid1(currentfigurenum),''Value'');',...
		'if testing==1;',...
			'set(grid2(currentfigurenum),''Value'',1);',...
			'figure(figanddatawin(1,currentfigurenum));',...
			'grid on;',...
			'if enaddon==1;',...
				'set(gridyn(currentfigurenum),''Checked'',''on'');',...
				'set(gridboth(currentfigurenum),''Checked'',''on'');',...
				'set(gridx(currentfigurenum),''Checked'',''off'');',...
				'set(gridy(currentfigurenum),''Checked'',''off'');',...
				'set(gridstyle(currentfigurenum),''Enable'',''on'');',...
			'end;',...
		'else;',...
			'set(grid2(currentfigurenum),''Value'',0);',...
			'figure(figanddatawin(1,currentfigurenum));',...
			'grid off;',...
			'if enaddon==1;',...
				'set(gridyn(currentfigurenum),''Checked'',''off'');',...
				'set(gridboth(currentfigurenum),''Checked'',''off'');',...
				'set(gridx(currentfigurenum),''Checked'',''off'');',...
				'set(gridyn(currentfigurenum),''Checked'',''off'');',...
				'set(gridstyle(currentfigurenum),''Enable'',''off'');',...
			'end;',...
		'end;']);


grid2(numoffigs)=uicontrol(figanddatawin(2,numoffigs),...
	'Style','checkbox',...
	'ForegroundColor','y',...
	'BackgroundColor','k',...
	'String','Grid',...
	'Value',0,...
	'Position',[215 60 50 20],...
	'CallBack',['for bb=1:numoffigs,if figanddatawin(2,bb)==gcf,',...
		'currentfigurenum=bb;end,end,',...
		'testing=get(grid2(currentfigurenum),''Value'');',...
		'if testing==1;',...
			'set(grid1(currentfigurenum),''Value'',1);',...
			'figure(figanddatawin(1,currentfigurenum));',...
			'grid on;',...
			'if enaddon==1;',...
				'set(gridyn(currentfigurenum),''Checked'',''on'');',...
				'set(gridboth(currentfigurenum),''Checked'',''on'');',...
				'set(gridx(currentfigurenum),''Checked'',''off'');',...
				'set(gridy(currentfigurenum),''Checked'',''off'');',...
				'set(gridstyle(currentfigurenum),''Enable'',''on'');',...
			'end;',...
		'else;',...
			'set(grid1(currentfigurenum),''Value'',0);',...
			'figure(figanddatawin(1,currentfigurenum));',...
			'grid off;',...
			'if enaddon==1;',...
				'set(gridyn(currentfigurenum),''Checked'',''off'');',...
				'set(gridboth(currentfigurenum),''Checked'',''off'');',...
				'set(gridx(currentfigurenum),''Checked'',''off'');',...
				'set(gridyn(currentfigurenum),''Checked'',''off'');',...
				'set(gridstyle(currentfigurenum),''Enable'',''off'');',...
			'end;',...
		'end;']);



if enhist==1  %history enabled
	% *************************************************
	% ************* Create smart popup for x **********
	% *************************************************
	if numoffigs ==1 | timesplotted == 0
		a=['{ x history }'];
		popsstringx=[a];
		popslistx=popsstringx;
	else
		popsstringx=popslistx;
	end

	popsx(numoffigs,1)=uicontrol(figanddatawin(2,numoffigs),...
		'Style','popup',...
		'Position',[30 375 100 100],...
		'BackgroundColor','r',...
		'ForegroundColor','k',...
		'String',setstr(popsstringx),...
		'CallBack',['for bb=1:numoffigs,if figanddatawin(2,bb)==gcf,',...
			'currentfigurenum=bb;end,end,',...
			'popsvalue=abs(get(popsx(currentfigurenum,1),''Value''));',...
			'set(xtoplot(currentfigurenum,1),''String'',popslistx(popsvalue,:));']);


	popsx(numoffigs,2)=uicontrol(figanddatawin(2,numoffigs),...
		'Style','popup',...
		'Position',[30 155 100 20],...
		'BackgroundColor','r',...
		'ForegroundColor','k',...
		'String',setstr(popsstringx),...
		'CallBack',['for bb=1:numoffigs,if figanddatawin(2,bb)==gcf,',...
			'currentfigurenum=bb;end,end,',...
			'popsvalue=abs(get(popsx(currentfigurenum,2),''Value''));',...
			'set(xtoplot(currentfigurenum,2),''String'',popslistx(popsvalue,:));']);


	% *************************************************
	% ************* Create smart popup for y **********	
	% *************************************************

	if numoffigs ==1 | timesplotted == 0
		a=['{ y history }'];
		popsstringy=[a];
		popslisty=popsstringy;
	else
		popsstringy=popslisty;
	end


	popsy(numoffigs,1)=uicontrol(figanddatawin(2,numoffigs),...
		'Style','popup',...
		'Position',[180 375 100 100],...
		'BackgroundColor','r',...
		'ForegroundColor','k',...
		'String',setstr(popsstringy),...
		'CallBack',['for bb=1:numoffigs,if figanddatawin(2,bb)==gcf,',...
			'currentfigurenum=bb;end,end,',...
			'popsvalue=abs(get(popsy(currentfigurenum,1),''Value''));',...
			'set(ytoplot(currentfigurenum,1),''String'',popslisty(popsvalue,:));']);



	popsy(numoffigs,2)=uicontrol(figanddatawin(2,numoffigs),...
		'Style','popup',...
		'Position',[180 155 100 20],...
		'BackgroundColor','r',...
		'ForegroundColor','k',...
		'String',setstr(popsstringy),...
	'CallBack',['for bb=1:numoffigs,if figanddatawin(2,bb)==gcf,',...
		'currentfigurenum=bb;end,end,',...
		'popsvalue=abs(get(popsy(currentfigurenum,2),''Value''));',...
		'set(ytoplot(currentfigurenum,2),''String'',popslisty(popsvalue,:));']);

else
	popsx=0;popsy=0;


end


% Add the ability to modify lines,etc.
promodfy



% Note Labels are always on no matter what user specifies

% @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@


labelitup(numoffigs)=uimenu(figanddatawin(1,numoffigs),...
	'Label','&Label',...
	'Checked','off',...
	'CallBack',['for bb=1:numoffigs,if figanddatawin(1,bb)==gcf,',...
		'currentfigurenum=bb;end,end,',...
		'testing=get(labelitup(currentfigurenum),''Checked'');',...	
		'if length(testing)==3;',...
			'set(figanddatawin(3,currentfigurenum),''Visible'',''on'');',...
			'set(labelitup(currentfigurenum),''Checked'',''on'');',...
		'else;',...
			'set(figanddatawin(3,currentfigurenum),''Visible'',''off'');',...
			'set(labelitup(currentfigurenum),''Checked'',''off'');',...
		'end;']);







% @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@


loaditup(numoffigs)=uimenu(figanddatawin(1,numoffigs),...
	'Label','D&ata',...
	'Checked','off',...
	'CallBack',['for bb=1:numoffigs,if figanddatawin(1,bb)==gcf,',...
		'currentfigurenum=bb;end,end,',...
		'testing=get(loaditup(currentfigurenum),''Checked'');',...	
		'if length(testing)==3;',...
			'set(specialfig,''Visible'',''on'');',...
			'for yimi=1:numoffigs;',...
				'set(loaditup(yimi),''Checked'',''on'');',...
			'end;',...
		'else;',...
			'set(specialfig,''Visible'',''off'');',...
			'for yimi=1:numoffigs;',...
				'set(loaditup(yimi),''Checked'',''off'');',...
			'end;',...
		'end;']);

% Add ability to control message duration
	protimer

if enaddon==1
	datagrid;
	dataplot;
	dataaxs1;
	dataaxs2;
	datafig;
	integrun
	
	
	% add the ability to take derivatives from menu
	derivrun
	der2
	der3
	derrmv

	% add the ability to curve fit from menus
	cfit1
	cfit2
	cfit3
	cfitrmv

	statrun
	goodies(numoffigs)=uimenu(figanddatawin(1,numoffigs),...
		'Label','&Goodies');

	if numoffigs==1
		global linesmart;
		global leadersmart;
		linesmart=[];
		leadersmart=[];
		dersmart=[];
		cfitsmart=[];
	else
		linesmart(1,1+(numoffigs-1).*11)=0;
		leadersmart(1,1+(numoffigs-1).*11)=0;
		cfitsmart(1,1+(numoffigs-1).*16)=0;
		dersmart(1,1+(numoffigs-1).*8)=0;
	end

	% Add All Horizontal & Vertical Line Files via menu
	datalin1;
	datalin2;
	datalin3;
	datalin4;
	datarmv;

	% Add Label Modify Capabilities via menu
	datalab1;
	datalab2;

	% Add the ability to add text via menu
	datatex1;
	datatex2;
	datatex3;
	datatex4;
	datatex5;

	% Add the ability to add leaders via menu
	lines1;
	lines2;
	lines3;
	lines4;
	lines5;
	linesrmv;

	% Add the ability to add crosshatching via menu(available later)
	%chatch1;
	%chatch2;
	%chatch3;
	%chatcrmv;

	

	

end



% *************************************************
% ************* Call figsma1.m ********************
% *************************************************

figsma1

% *************************************************
% ******** Run "on-the-fly" profigio.m ************
% *************************************************

profigio;


if enmul==1



	% *********************************************************
	% *********** Text apply to figure ************************
	% *********************************************************

	applytext1(numoffigs)=uicontrol(figanddatawin(2,numoffigs),...
		'Style','text',...
		'ForegroundColor','w',...
		'BackgroundColor','k',...
		'String','Apply x,y to figure',...
		'Position',[85 250 150 20]);

	applytext2(numoffigs)=uicontrol(figanddatawin(2,numoffigs),...
		'Style','text',...
		'ForegroundColor','w',...
		'BackgroundColor','k',...
		'String','Apply x,y to figure',...
		'Position',[85 30 150 20]);

	% *************************************************
	% ************* Call datasmar.m *******************
	% *************************************************

	datasmar;

	% *************************************************
	% ******** Run "on-the-fly" prodatio.m ************
	% *************************************************

	prodatio;


end

% *** add an about menu item for user ***

menuabout(numoffigs)=uimenu(figanddatawin(1,numoffigs),...
	'Label','A&bout',...
	'CallBack','set(figabout,''Visible'',''on'');');
	

% Add ability to control menu title bar
	prored

% ************ return to read if called? ************
if gobacktoread==1
	return
else % run setup file to check proper menu items
	loadaxex
end
