% Version 1.0 of ProPlot 1.0
%
%    // datalab1.m \\
%
%     Scott Keane
%  skeane@uceng.uc.edu
%
%
% *****************************************
% Matlab script to add a menu driven 
% xlabel & ylabel modifier(Color,FontType,FontSize)
% *****************************************


% ****************************************************************
% ********************** Label Properties ***************************
% ****************************************************************

labelprops(numoffigs)=uimenu(axisdata(numoffigs),...
	'Label','&Label Modify',...
	'Separator','on',...
	'CallBack',['for bb=1:numoffigs,if figanddatawin(1,bb)==gcf,',...
		'currentfigurenum=bb;end,end,']);


labelxyprops(numoffigs)=uimenu(labelprops(numoffigs),...
	'Label','&X && Y Labels',...
	'Separator','off',...
	'CallBack',['for bb=1:numoffigs,if figanddatawin(1,bb)==gcf,',...
		'currentfigurenum=bb;end,end,']);




% ****************************************************************
% ********************** Label Properties ***************************
% ****************************************************************

labelxypropscolor(numoffigs)=uimenu(labelxyprops(numoffigs),...
	'Label','&Color',...
	'CallBack',['for bb=1:numoffigs,if figanddatawin(1,bb)==gcf,',...
		'currentfigurenum=bb;end,end,']);



labelxyaxis(1,numoffigs)=uimenu(labelxypropscolor(numoffigs),...
	'Label','&White',...
	'Checked','off',...
	'CallBack',['globalcolortypeofcall=1;indexnum=1;hold_datavar=labelxyaxis;',...
		'[labelxyaxis,nullvalue]=modcolor(hold_datavar,0,globalcolortypeofcall,numoffigs,figanddatawin,indexnum);']);

labelxyaxis(2,numoffigs)=uimenu(labelxypropscolor(numoffigs),...
	'Label','&Blue',...
	'Separator','on',...
	'Checked','off',...
	'CallBack',['globalcolortypeofcall=1;indexnum=2;hold_datavar=labelxyaxis;',...
		'[labelxyaxis,nullvalue]=modcolor(hold_datavar,0,globalcolortypeofcall,numoffigs,figanddatawin,indexnum);']);

labelxyaxis(3,numoffigs)=uimenu(labelxypropscolor(numoffigs),...
	'Label','&Magenta',...
	'Separator','on',...
	'Checked','off',...
	'CallBack',['globalcolortypeofcall=1;indexnum=3;hold_datavar=labelxyaxis;',...
		'[labelxyaxis,nullvalue]=modcolor(hold_datavar,0,globalcolortypeofcall,numoffigs,figanddatawin,indexnum);']);

labelxyaxis(4,numoffigs)=uimenu(labelxypropscolor(numoffigs),...
	'Label','&Red',...
	'Separator','on',...
	'Checked','off',...
	'CallBack',['globalcolortypeofcall=1;indexnum=4;hold_datavar=labelxyaxis;',...
		'[labelxyaxis,nullvalue]=modcolor(hold_datavar,0,globalcolortypeofcall,numoffigs,figanddatawin,indexnum);']);

labelxyaxis(5,numoffigs)=uimenu(labelxypropscolor(numoffigs),...
	'Label','&Yellow',...
	'Separator','on',...
	'Checked','off',...
	'CallBack',['globalcolortypeofcall=1;indexnum=5;hold_datavar=labelxyaxis;',...
		'[labelxyaxis,nullvalue]=modcolor(hold_datavar,0,globalcolortypeofcall,numoffigs,figanddatawin,indexnum);']);

labelxyaxis(6,numoffigs)=uimenu(labelxypropscolor(numoffigs),...
	'Label','&Cyan',...
	'Separator','on',...
	'Checked','off',...
	'CallBack',['globalcolortypeofcall=1;indexnum=6;hold_datavar=labelxyaxis;',...
		'[labelxyaxis,nullvalue]=modcolor(hold_datavar,0,globalcolortypeofcall,numoffigs,figanddatawin,indexnum);']);

labelxyaxis(7,numoffigs)=uimenu(labelxypropscolor(numoffigs),...
	'Label','&Green',...
	'Separator','on',...
	'Checked','off',...
	'CallBack',['globalcolortypeofcall=1;indexnum=7;hold_datavar=labelxyaxis;',...
		'[labelxyaxis,nullvalue]=modcolor(hold_datavar,0,globalcolortypeofcall,numoffigs,figanddatawin,indexnum);']);


labelxyaxis(8,numoffigs)=uimenu(labelxypropscolor(numoffigs),...
	'Label','&Black',...
	'Separator','on',...
	'Checked','off',...
	'CallBack',['globalcolortypeofcall=1;indexnum=8;hold_datavar=labelxyaxis;',...
		'[labelxyaxis,nullvalue]=modcolor(hold_datavar,0,globalcolortypeofcall,numoffigs,figanddatawin,indexnum);']);


% ****************************************************************
% ********************** Label Properties ***************************
% ****************************************************************

labelxypropsfont(numoffigs)=uimenu(labelxyprops(numoffigs),...
	'Label','Font &Type',...
	'Separator','on',...
	'CallBack',['for bb=1:numoffigs,if figanddatawin(1,bb)==gcf,',...
		'currentfigurenum=bb;end,end,']);


% ############# Axis Font ###################################

labelxyfont(1,numoffigs)=uimenu(labelxypropsfont(numoffigs),...
	'Label','Times New &Roman',...
	'Checked','off',...
	'Separator','off',...
	'CallBack',['globalfonttypeofcall=1;indexnum=1;hold_datavar=labelxyfont;',...
		'[labelxyfont,nullvalue]=modfont(hold_datavar,0,globalfonttypeofcall,numoffigs,figanddatawin,indexnum);']);

% ############# label Font ###################################

labelxyfont(2,numoffigs)=uimenu(labelxypropsfont(numoffigs),...
	'Label','&Terminal',...
	'Checked','off',...
	'Separator','on',...
	'CallBack',['globalfonttypeofcall=1;indexnum=2;hold_datavar=labelxyfont;',...
		'[labelxyfont,nullvalue]=modfont(hold_datavar,0,globalfonttypeofcall,numoffigs,figanddatawin,indexnum);']);


% ############# label Font ###################################

labelxyfont(3,numoffigs)=uimenu(labelxypropsfont(numoffigs),...
	'Label','&System',...
	'Checked','off',...
	'Separator','on',...
	'CallBack',['globalfonttypeofcall=1;indexnum=3;hold_datavar=labelxyfont;',...
		'[labelxyfont,nullvalue]=modfont(hold_datavar,0,globalfonttypeofcall,numoffigs,figanddatawin,indexnum);']);



% ############# label Font ###################################

labelxyfont(4,numoffigs)=uimenu(labelxypropsfont(numoffigs),...
	'Label','MS S&erif',...
	'Checked','off',...
	'Separator','on',...
	'CallBack',['globalfonttypeofcall=1;indexnum=4;hold_datavar=labelxyfont;',...
		'[labelxyfont,nullvalue]=modfont(hold_datavar,0,globalfonttypeofcall,numoffigs,figanddatawin,indexnum);']);



% ############# label Font ###################################

labelxyfont(5,numoffigs)=uimenu(labelxypropsfont(numoffigs),...
	'Label','MS Sans Ser&if',...
	'Checked','off',...
	'Separator','on',...
	'CallBack',['globalfonttypeofcall=1;indexnum=5;hold_datavar=labelxyfont;',...
		'[labelxyfont,nullvalue]=modfont(hold_datavar,0,globalfonttypeofcall,numoffigs,figanddatawin,indexnum);']);



% ############# label Font ###################################

labelxyfont(6,numoffigs)=uimenu(labelxypropsfont(numoffigs),...
	'Label','&Modern',...
	'Checked','off',...
	'Separator','on',...
	'CallBack',['globalfonttypeofcall=1;indexnum=6;hold_datavar=labelxyfont;',...
		'[labelxyfont,nullvalue]=modfont(hold_datavar,0,globalfonttypeofcall,numoffigs,figanddatawin,indexnum);']);



% ############# label Font ###################################

labelxyfont(7,numoffigs)=uimenu(labelxypropsfont(numoffigs),...
	'Label','&Fixedsys',...
	'Checked','off',...
	'Separator','on',...
	'CallBack',['globalfonttypeofcall=1;indexnum=7;hold_datavar=labelxyfont;',...
		'[labelxyfont,nullvalue]=modfont(hold_datavar,0,globalfonttypeofcall,numoffigs,figanddatawin,indexnum);']);



% ############# label Font ###################################

labelxyfont(8,numoffigs)=uimenu(labelxypropsfont(numoffigs),...
	'Label','&Courier',...
	'Checked','off',...
	'Separator','on',...
	'CallBack',['globalfonttypeofcall=1;indexnum=8;hold_datavar=labelxyfont;',...
		'[labelxyfont,nullvalue]=modfont(hold_datavar,0,globalfonttypeofcall,numoffigs,figanddatawin,indexnum);']);




% ############# label Font ###################################

labelxyfont(9,numoffigs)=uimenu(labelxypropsfont(numoffigs),...
	'Label','Courier &New',...
	'Checked','off',...
	'Separator','on',...
	'CallBack',['globalfonttypeofcall=1;indexnum=9;hold_datavar=labelxyfont;',...
		'[labelxyfont,nullvalue]=modfont(hold_datavar,0,globalfonttypeofcall,numoffigs,figanddatawin,indexnum);']);


% ############# label Font ###################################

labelxyfont(10,numoffigs)=uimenu(labelxypropsfont(numoffigs),...
	'Label','&Arial',...
	'Checked','off',...
	'Separator','on',...
	'CallBack',['globalfonttypeofcall=1;indexnum=10;hold_datavar=labelxyfont;',...
		'[labelxyfont,nullvalue]=modfont(hold_datavar,0,globalfonttypeofcall,numoffigs,figanddatawin,indexnum);']);




% ############# label Font ###################################

labelxyfont(11,numoffigs)=uimenu(labelxypropsfont(numoffigs),...
	'Label','&Helvetica',...
	'Checked','off',...
	'Separator','on',...
	'CallBack',['globalfonttypeofcall=1;indexnum=11;hold_datavar=labelxyfont;',...
		'[labelxyfont,nullvalue]=modfont(hold_datavar,0,globalfonttypeofcall,numoffigs,figanddatawin,indexnum);']);





% ****************************************************************
% ***************** label Font Size *******************************
% ****************************************************************

% ****************************************************************
% ********************** Label Properties ***************************
% ****************************************************************

labelxypropsfontsize(numoffigs)=uimenu(labelxyprops(numoffigs),...
	'Label','Font &Size',...
	'Separator','on',...
	'CallBack',['for bb=1:numoffigs,if figanddatawin(1,bb)==gcf,',...
		'currentfigurenum=bb;end,end,']);


% ############# Label Font Size ################################

labelxyfontsize(1,numoffigs)=uimenu(labelxypropsfontsize(numoffigs),...
	'Label','&8',...
	'Checked','off',...
	'Separator','off',...
	'CallBack',['globalfontsizetypeofcall=1;indexnum=1;hold_datavar=labelxyfontsize;',...
		'[labelxyfontsize,nullvalue]=modsize(hold_datavar,0,globalfontsizetypeofcall,numoffigs,figanddatawin,indexnum);']);


% ############# Label Font Size ################################

labelxyfontsize(2,numoffigs)=uimenu(labelxypropsfontsize(numoffigs),...
	'Label','&9',...
	'Checked','off',...
	'Separator','on',...
	'CallBack',['globalfontsizetypeofcall=1;indexnum=2;hold_datavar=labelxyfontsize;',...
		'[labelxyfontsize,nullvalue]=modsize(hold_datavar,0,globalfontsizetypeofcall,numoffigs,figanddatawin,indexnum);']);

% ############# Label Font Size ################################

labelxyfontsize(3,numoffigs)=uimenu(labelxypropsfontsize(numoffigs),...
	'Label','1&0',...
	'Checked','off',...
	'Separator','on',...
	'CallBack',['globalfontsizetypeofcall=1;indexnum=3;hold_datavar=labelxyfontsize;',...
		'[labelxyfontsize,nullvalue]=modsize(hold_datavar,0,globalfontsizetypeofcall,numoffigs,figanddatawin,indexnum);']);


% ############# Label Font Size ################################

labelxyfontsize(4,numoffigs)=uimenu(labelxypropsfontsize(numoffigs),...
	'Label','1&1',...
	'Checked','off',...
	'Separator','on',...
	'CallBack',['globalfontsizetypeofcall=1;indexnum=4;hold_datavar=labelxyfontsize;',...
		'[labelxyfontsize,nullvalue]=modsize(hold_datavar,0,globalfontsizetypeofcall,numoffigs,figanddatawin,indexnum);']);


% ############# Label Font Size ################################

labelxyfontsize(5,numoffigs)=uimenu(labelxypropsfontsize(numoffigs),...
	'Label','1&2',...
	'Checked','off',...
	'Separator','on',...
	'CallBack',['globalfontsizetypeofcall=1;indexnum=5;hold_datavar=labelxyfontsize;',...
		'[labelxyfontsize,nullvalue]=modsize(hold_datavar,0,globalfontsizetypeofcall,numoffigs,figanddatawin,indexnum);']);

% ############# Label Font Size ################################


labelxyfontsize(6,numoffigs)=uimenu(labelxypropsfontsize(numoffigs),...
	'Label','1&3',...
	'Checked','off',...
	'Separator','on',...
	'CallBack',['globalfontsizetypeofcall=1;indexnum=6;hold_datavar=labelxyfontsize;',...
		'[labelxyfontsize,nullvalue]=modsize(hold_datavar,0,globalfontsizetypeofcall,numoffigs,figanddatawin,indexnum);']);

% ############# Label Font Size ################################

labelxyfontsize(7,numoffigs)=uimenu(labelxypropsfontsize(numoffigs),...
	'Label','1&4',...
	'Checked','off',...
	'Separator','on',...
	'CallBack',['globalfontsizetypeofcall=1;indexnum=7;hold_datavar=labelxyfontsize;',...
		'[labelxyfontsize,nullvalue]=modsize(hold_datavar,0,globalfontsizetypeofcall,numoffigs,figanddatawin,indexnum);']);

% ############# Label Font Size ################################

labelxyfontsize(8,numoffigs)=uimenu(labelxypropsfontsize(numoffigs),...
	'Label','1&5',...
	'Checked','off',...
	'Separator','on',...
	'CallBack',['globalfontsizetypeofcall=1;indexnum=8;hold_datavar=labelxyfontsize;',...
		'[labelxyfontsize,nullvalue]=modsize(hold_datavar,0,globalfontsizetypeofcall,numoffigs,figanddatawin,indexnum);']);

% ############# Label Font Size ################################

labelxyfontsize(9,numoffigs)=uimenu(labelxypropsfontsize(numoffigs),...
	'Label','1&6',...
	'Checked','off',...
	'Separator','on',...
	'CallBack',['globalfontsizetypeofcall=1;indexnum=9;hold_datavar=labelxyfontsize;',...
		'[labelxyfontsize,nullvalue]=modsize(hold_datavar,0,globalfontsizetypeofcall,numoffigs,figanddatawin,indexnum);']);

% ######################### Label Font Size ##################

labelxyfontsize(10,numoffigs)=uimenu(labelxypropsfontsize(numoffigs),...
	'Label','1&7',...
	'Checked','off',...
	'Separator','on',...
	'CallBack',['globalfontsizetypeofcall=1;indexnum=10;hold_datavar=labelxyfontsize;',...
		'[labelxyfontsize,nullvalue]=modsize(hold_datavar,0,globalfontsizetypeofcall,numoffigs,figanddatawin,indexnum);']);



