% Version 1.0 of ProPlot 1.0
%
%    // datalab2.m \\
%
%     Scott Keane
%  skeane@uceng.uc.edu
%
%
% *****************************************
% Matlab script to add a menu driven 
% title modifier(Color,FontType,FontSize)
% *****************************************

% ****************************************************************
% ********************** Title Label Properties ******************
% ****************************************************************



labeltitprops(numoffigs)=uimenu(labelprops(numoffigs),...
	'Label','&Title',...
	'Separator','on',...
	'CallBack',['for bb=1:numoffigs,if figanddatawin(1,bb)==gcf,',...
		'currentfigurenum=bb;end,end,']);


% ****************************************************************
% ********************** Label Properties ***************************
% ****************************************************************

labeltitpropscolor(numoffigs)=uimenu(labeltitprops(numoffigs),...
	'Label','&Color',...
	'CallBack',['for bb=1:numoffigs,if figanddatawin(1,bb)==gcf,',...
		'currentfigurenum=bb;end,end,']);



labeltitaxis(1,numoffigs)=uimenu(labeltitpropscolor(numoffigs),...
	'Label','&White',...
	'Checked','off',...
	'CallBack',['globalcolortypeofcall=2;indexnum=1;hold_datavar=labeltitaxis;',...
		'[labeltitaxis,nullvalue]=modcolor(hold_datavar,0,globalcolortypeofcall,numoffigs,figanddatawin,indexnum);']);

labeltitaxis(2,numoffigs)=uimenu(labeltitpropscolor(numoffigs),...
	'Label','&Blue',...
	'Separator','on',...
	'Checked','off',...
	'CallBack',['globalcolortypeofcall=2;indexnum=2;hold_datavar=labeltitaxis;',...
		'[labeltitaxis,nullvalue]=modcolor(hold_datavar,0,globalcolortypeofcall,numoffigs,figanddatawin,indexnum);']);

labeltitaxis(3,numoffigs)=uimenu(labeltitpropscolor(numoffigs),...
	'Label','&Magenta',...
	'Separator','on',...
	'Checked','off',...
	'CallBack',['globalcolortypeofcall=2;indexnum=3;hold_datavar=labeltitaxis;',...
		'[labeltitaxis,nullvalue]=modcolor(hold_datavar,0,globalcolortypeofcall,numoffigs,figanddatawin,indexnum);']);

labeltitaxis(4,numoffigs)=uimenu(labeltitpropscolor(numoffigs),...
	'Label','&Red',...
	'Separator','on',...
	'Checked','off',...
	'CallBack',['globalcolortypeofcall=2;indexnum=4;hold_datavar=labeltitaxis;',...
		'[labeltitaxis,nullvalue]=modcolor(hold_datavar,0,globalcolortypeofcall,numoffigs,figanddatawin,indexnum);']);

labeltitaxis(5,numoffigs)=uimenu(labeltitpropscolor(numoffigs),...
	'Label','&Yellow',...
	'Separator','on',...
	'Checked','off',...
	'CallBack',['globalcolortypeofcall=2;indexnum=5;hold_datavar=labeltitaxis;',...
		'[labeltitaxis,nullvalue]=modcolor(hold_datavar,0,globalcolortypeofcall,numoffigs,figanddatawin,indexnum);']);



labeltitaxis(6,numoffigs)=uimenu(labeltitpropscolor(numoffigs),...
	'Label','&Cyan',...
	'Separator','on',...
	'Checked','off',...
	'CallBack',['globalcolortypeofcall=2;indexnum=6;hold_datavar=labeltitaxis;',...
		'[labeltitaxis,nullvalue]=modcolor(hold_datavar,0,globalcolortypeofcall,numoffigs,figanddatawin,indexnum);']);

labeltitaxis(7,numoffigs)=uimenu(labeltitpropscolor(numoffigs),...
	'Label','&Green',...
	'Separator','on',...
	'Checked','off',...
	'CallBack',['globalcolortypeofcall=2;indexnum=7;hold_datavar=labeltitaxis;',...
		'[labeltitaxis,nullvalue]=modcolor(hold_datavar,0,globalcolortypeofcall,numoffigs,figanddatawin,indexnum);']);


labeltitaxis(8,numoffigs)=uimenu(labeltitpropscolor(numoffigs),...
	'Label','&Black',...
	'Separator','on',...
	'Checked','off',...
	'CallBack',['globalcolortypeofcall=2;indexnum=8;hold_datavar=labeltitaxis;',...
		'[labeltitaxis,nullvalue]=modcolor(hold_datavar,0,globalcolortypeofcall,numoffigs,figanddatawin,indexnum);']);



% ****************************************************************
% ********************** Label Properties ***************************
% ****************************************************************

labeltitpropsfont(numoffigs)=uimenu(labeltitprops(numoffigs),...
	'Label','Font &Type',...
	'Separator','on',...
	'CallBack',['for bb=1:numoffigs,if figanddatawin(1,bb)==gcf,',...
		'currentfigurenum=bb;end,end,']);


% ############# Axis Font ###################################

labeltitfont(1,numoffigs)=uimenu(labeltitpropsfont(numoffigs),...
	'Label','Times New &Roman',...
	'Checked','off',...
	'Separator','off',...
	'CallBack',['globalfonttypeofcall=2;indexnum=1;hold_datavar=labeltitfont;',...
		'[labeltitfont,nullvalue]=modfont(hold_datavar,0,globalfonttypeofcall,numoffigs,figanddatawin,indexnum);']);

% ############# label Font ###################################

labeltitfont(2,numoffigs)=uimenu(labeltitpropsfont(numoffigs),...
	'Label','&Terminal',...
	'Checked','off',...
	'Separator','on',...
	'CallBack',['globalfonttypeofcall=2;indexnum=2;hold_datavar=labeltitfont;',...
		'[labeltitfont,nullvalue]=modfont(hold_datavar,0,globalfonttypeofcall,numoffigs,figanddatawin,indexnum);']);

% ############# label Font ###################################

labeltitfont(3,numoffigs)=uimenu(labeltitpropsfont(numoffigs),...
	'Label','&System',...
	'Checked','off',...
	'Separator','on',...
	'CallBack',['globalfonttypeofcall=2;indexnum=3;hold_datavar=labeltitfont;',...
		'[labeltitfont,nullvalue]=modfont(hold_datavar,0,globalfonttypeofcall,numoffigs,figanddatawin,indexnum);']);


% ############# label Font ###################################

labeltitfont(4,numoffigs)=uimenu(labeltitpropsfont(numoffigs),...
	'Label','MS S&erif',...
	'Checked','off',...
	'Separator','on',...
	'CallBack',['globalfonttypeofcall=2;indexnum=4;hold_datavar=labeltitfont;',...
		'[labeltitfont,nullvalue]=modfont(hold_datavar,0,globalfonttypeofcall,numoffigs,figanddatawin,indexnum);']);


% ############# label Font ###################################

labeltitfont(5,numoffigs)=uimenu(labeltitpropsfont(numoffigs),...
	'Label','MS Sans Ser&if',...
	'Checked','off',...
	'Separator','on',...
	'CallBack',['globalfonttypeofcall=2;indexnum=5;hold_datavar=labeltitfont;',...
		'[labeltitfont,nullvalue]=modfont(hold_datavar,0,globalfonttypeofcall,numoffigs,figanddatawin,indexnum);']);


% ############# label Font ###################################

labeltitfont(6,numoffigs)=uimenu(labeltitpropsfont(numoffigs),...
	'Label','&Modern',...
	'Checked','off',...
	'Separator','on',...
	'CallBack',['globalfonttypeofcall=2;indexnum=6;hold_datavar=labeltitfont;',...
		'[labeltitfont,nullvalue]=modfont(hold_datavar,0,globalfonttypeofcall,numoffigs,figanddatawin,indexnum);']);


% ############# label Font ###################################

labeltitfont(7,numoffigs)=uimenu(labeltitpropsfont(numoffigs),...
	'Label','&Fixedsys',...
	'Checked','off',...
	'Separator','on',...
	'CallBack',['globalfonttypeofcall=2;indexnum=7;hold_datavar=labeltitfont;',...
		'[labeltitfont,nullvalue]=modfont(hold_datavar,0,globalfonttypeofcall,numoffigs,figanddatawin,indexnum);']);

% ############# label Font ###################################

labeltitfont(8,numoffigs)=uimenu(labeltitpropsfont(numoffigs),...
	'Label','&Courier',...
	'Checked','off',...
	'Separator','on',...
	'CallBack',['globalfonttypeofcall=2;indexnum=8;hold_datavar=labeltitfont;',...
		'[labeltitfont,nullvalue]=modfont(hold_datavar,0,globalfonttypeofcall,numoffigs,figanddatawin,indexnum);']);



% ############# label Font ###################################

labeltitfont(9,numoffigs)=uimenu(labeltitpropsfont(numoffigs),...
	'Label','Courier &New',...
	'Checked','off',...
	'Separator','on',...
	'CallBack',['globalfonttypeofcall=2;indexnum=9;hold_datavar=labeltitfont;',...
		'[labeltitfont,nullvalue]=modfont(hold_datavar,0,globalfonttypeofcall,numoffigs,figanddatawin,indexnum);']);


% ############# label Font ###################################

labeltitfont(10,numoffigs)=uimenu(labeltitpropsfont(numoffigs),...
	'Label','&Arial',...
	'Checked','off',...
	'Separator','on',...
	'CallBack',['globalfonttypeofcall=2;indexnum=10;hold_datavar=labeltitfont;',...
		'[labeltitfont,nullvalue]=modfont(hold_datavar,0,globalfonttypeofcall,numoffigs,figanddatawin,indexnum);']);



% ############# label Font ###################################

labeltitfont(11,numoffigs)=uimenu(labeltitpropsfont(numoffigs),...
	'Label','&Helvetica',...
	'Checked','off',...
	'Separator','on',...
	'CallBack',['globalfonttypeofcall=2;indexnum=11;hold_datavar=labeltitfont;',...
		'[labeltitfont,nullvalue]=modfont(hold_datavar,0,globalfonttypeofcall,numoffigs,figanddatawin,indexnum);']);







% ****************************************************************
% ***************** label Font Size *******************************
% ****************************************************************

% ****************************************************************
% ********************** Label Properties ***************************
% ****************************************************************

labeltitpropsfontsize(numoffigs)=uimenu(labeltitprops(numoffigs),...
	'Label','Font &Size',...
	'Separator','on',...
	'CallBack',['for bb=1:numoffigs,if figanddatawin(1,bb)==gcf,',...
		'currentfigurenum=bb;end,end,']);


% ############# Label Font Size ################################

labeltitfontsize(1,numoffigs)=uimenu(labeltitpropsfontsize(numoffigs),...
	'Label','&8',...
	'Checked','off',...
	'Separator','off',...
	'CallBack',['globalfonsizetypeofcall=2;indexnum=1;hold_datavar=labeltitfontsize;',...
		'[labeltitfontsize,nullvalue]=modsize(hold_datavar,0,globalfontsizetypeofcall,numoffigs,figanddatawin,indexnum);']);



% ############# Label Font Size ################################

labeltitfontsize(2,numoffigs)=uimenu(labeltitpropsfontsize(numoffigs),...
	'Label','&9',...
	'Checked','off',...
	'Separator','on',...
	'CallBack',['globalfontsizetypeofcall=2;indexnum=2;hold_datavar=labeltitfontsize;',...
		'[labeltitfontsize,nullvalue]=modsize(hold_datavar,0,globalfontsizetypeofcall,numoffigs,figanddatawin,indexnum);']);

% ############# Label Font Size ################################

labeltitfontsize(3,numoffigs)=uimenu(labeltitpropsfontsize(numoffigs),...
	'Label','1&0',...
	'Checked','off',...
	'Separator','on',...
	'CallBack',['globalfontsizetypeofcall=2;indexnum=3;hold_datavar=labeltitfontsize;',...
		'[labeltitfontsize,nullvalue]=modsize(hold_datavar,0,globalfontsizetypeofcall,numoffigs,figanddatawin,indexnum);']);


% ############# Label Font Size ################################

labeltitfontsize(4,numoffigs)=uimenu(labeltitpropsfontsize(numoffigs),...
	'Label','1&1',...
	'Checked','off',...
	'Separator','on',...
	'CallBack',['globalfontsizetypeofcall=2;indexnum=4;hold_datavar=labeltitfontsize;',...
		'[labeltitfontsize,nullvalue]=modsize(hold_datavar,0,globalfontsizetypeofcall,numoffigs,figanddatawin,indexnum);']);


% ############# Label Font Size ################################

labeltitfontsize(5,numoffigs)=uimenu(labeltitpropsfontsize(numoffigs),...
	'Label','1&2',...
	'Checked','off',...
	'Separator','on',...
	'CallBack',['globalfontsizetypeofcall=2;indexnum=5;hold_datavar=labeltitfontsize;',...
		'[labeltitfontsize,nullvalue]=modsize(hold_datavar,0,globalfontsizetypeofcall,numoffigs,figanddatawin,indexnum);']);

% ############# Label Font Size ################################


labeltitfontsize(6,numoffigs)=uimenu(labeltitpropsfontsize(numoffigs),...
	'Label','1&3',...
	'Checked','off',...
	'Separator','on',...
	'CallBack',['globalfontsizetypeofcall=2;indexnum=6;hold_datavar=labeltitfontsize;',...
		'[labeltitfontsize,nullvalue]=modsize(hold_datavar,0,globalfontsizetypeofcall,numoffigs,figanddatawin,indexnum);']);

% ############# Label Font Size ################################

labeltitfontsize(7,numoffigs)=uimenu(labeltitpropsfontsize(numoffigs),...
	'Label','1&4',...
	'Checked','off',...
	'Separator','on',...
	'CallBack',['globalfontsizetypeofcall=2;indexnum=7;hold_datavar=labeltitfontsize;',...
		'[labeltitfontsize,nullvalue]=modsize(hold_datavar,0,globalfontsizetypeofcall,numoffigs,figanddatawin,indexnum);']);

% ############# Label Font Size ################################

labeltitfontsize(8,numoffigs)=uimenu(labeltitpropsfontsize(numoffigs),...
	'Label','1&5',...
	'Checked','off',...
	'Separator','on',...
	'CallBack',['globalfontsizetypeofcall=2;indexnum=8;hold_datavar=labeltitfontsize;',...
		'[labeltitfontsize,nullvalue]=modsize(hold_datavar,0,globalfontsizetypeofcall,numoffigs,figanddatawin,indexnum);']);

% ############# Label Font Size ################################

labeltitfontsize(9,numoffigs)=uimenu(labeltitpropsfontsize(numoffigs),...
	'Label','1&6',...
	'Checked','off',...
	'Separator','on',...
	'CallBack',['globalfontsizetypeofcall=2;indexnum=9;hold_datavar=labeltitfontsize;',...
		'[labeltitfontsize,nullvalue]=modsize(hold_datavar,0,globalfontsizetypeofcall,numoffigs,figanddatawin,indexnum);']);

% ######################### Label Font Size ##################

labeltitfontsize(10,numoffigs)=uimenu(labeltitpropsfontsize(numoffigs),...
	'Label','1&7',...
	'Checked','off',...
	'Separator','on',...
	'CallBack',['globalfontsizetypeofcall=2;indexnum=10;hold_datavar=labeltitfontsize;',...
		'[labeltitfontsize,nullvalue]=modsize(hold_datavar,0,globalfontsizetypeofcall,numoffigs,figanddatawin,indexnum);']);


