% Version 1.0 of ProPlot 1.0
%
%    // dataplot.m \\
%
%     Scott Keane
%  skeane@uceng.uc.edu
%
%
% *****************************************
% Matlab script to add a menu driven 
% plot modifier(plot,xlog,ylog,loglog)
% *****************************************



% ********************************************************
% ****************** Plot on Menu ************************
% ********************************************************


plottype(numoffigs)=uimenu(figanddatawin(1,numoffigs),...
	'Label','&Plot',...
	'Separator','on');

plotreg(numoffigs)=uimenu(plottype(numoffigs),...
	'Label','&Plot',...
	'Checked','on',...
	'CallBack',['for bb=1:numoffigs,if figanddatawin(1,bb)==gcf,',...
		'currentfigurenum=bb;end,end,',...
		'testing=get(plotreg(currentfigurenum),''Checked'');',...
		'if length(testing)==3,',...
			'set(gca,''XScale'',''linear'');',...
			'set(gca,''YScale'',''linear'');',...
			'set(logx(currentfigurenum),''Checked'',''off'');',...
			'set(logy(currentfigurenum),''Checked'',''off'');',...
			'set(logboth(currentfigurenum),''Checked'',''off'');',...
			'set(plotreg(currentfigurenum),''Checked'',''on'');',...
		'else,',...
			'set(plotreg(currentfigurenum),''Checked'',''on'');',...
		'end;']);


logx(numoffigs)=uimenu(plottype(numoffigs),...
	'Label','Log &X',...
	'Checked','off',...
	'Separator','on',...
	'CallBack',['for bb=1:numoffigs,if figanddatawin(1,bb)==gcf,',...
		'currentfigurenum=bb;end,end,',...
		'testing=get(logx(currentfigurenum),''Checked'');',...
		'if length(testing)==3,',...
			'set(gca,''XScale'',''log'');',...
			'set(gca,''YScale'',''linear'');',...
			'set(logx(currentfigurenum),''Checked'',''on'');',...
			'set(logy(currentfigurenum),''Checked'',''off'');',...
			'set(logboth(currentfigurenum),''Checked'',''off'');',...
			'set(plotreg(currentfigurenum),''Checked'',''off'');',...
		'else,',...
			'set(logx(currentfigurenum),''Checked'',''on'');',...
		'end;']);


logy(numoffigs)=uimenu(plottype(numoffigs),...
	'Label','Log &Y',...
	'Checked','off',...
	'Separator','on',...
	'CallBack',['for bb=1:numoffigs,if figanddatawin(1,bb)==gcf,',...
		'currentfigurenum=bb;end,end,',...
		'testing=get(logy(currentfigurenum),''Checked'');',...
		'if length(testing)==3,',...
			'set(gca,''XScale'',''linear'');',...
			'set(gca,''YScale'',''log'');',...
			'set(logx(currentfigurenum),''Checked'',''off'');',...
			'set(logy(currentfigurenum),''Checked'',''on'');',...
			'set(logboth(currentfigurenum),''Checked'',''off'');',...
			'set(plotreg(currentfigurenum),''Checked'',''off'');',...
		'else,',...
			'set(logy(currentfigurenum),''Checked'',''on'');',...
		'end;']);


logboth(numoffigs)=uimenu(plottype(numoffigs),...
	'Label','&Log X && Y',...
	'Checked','off',...
	'Separator','on',...
	'CallBack',['for bb=1:numoffigs,if figanddatawin(1,bb)==gcf,',...
		'currentfigurenum=bb;end,end,',...
		'testing=get(logboth(currentfigurenum),''Checked'');',...
		'if length(testing)==3,',...
			'set(gca,''XScale'',''log'');',...
			'set(gca,''YScale'',''log'');',...
			'set(logx(currentfigurenum),''Checked'',''off'');',...
			'set(logy(currentfigurenum),''Checked'',''off'');',...
			'set(logboth(currentfigurenum),''Checked'',''on'');',...
			'set(plotreg(currentfigurenum),''Checked'',''off'');',...
		'else,',...
			'set(logboth(currentfigurenum),''Checked'',''on'');',...
		'end;']);

% &&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
% &&&&&&&&&&&&&&&& Bug Fix &&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
% &&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
set(plotreg,'Checked','on');

