function [hold_datavar]=entcolor(hold_datavar,numoffigs,globalcolortypeofcall,indexnum,winsize_figure_width,figanddatawin)

% Version 1.0 of ProPlot 1.0
%
%    // entcolor.m \\
%
%     Scott Keane
%  skeane@uceng.uc.edu
%
%  Created on:     8:01 AM 6/1/96
%  Last Modified:  6:13 PM 6/15/96
% *****************************************
% Matlab function to modify single entities pertaining to
% text, lines, and leaders, not just color as the name
% implies.
% *****************************************

global timer;

% ************* Initialize Index and Messages *********************

if globalcolortypeofcall==1 | globalcolortypeofcall==5 | globalcolortypeofcall==6
	if indexnum==1,indexcolor=abs('w');appendonto=abs('color white');
	elseif indexnum==2,indexcolor=abs('b');appendonto=abs('color blue');
	elseif indexnum==3,indexcolor=abs('m');appendonto=abs('color magenta');
	elseif indexnum==4,indexcolor=abs('r');appendonto=abs('color red');
	elseif indexnum==5,indexcolor=abs('y');appendonto=abs('color yellow');
	elseif indexnum==6,indexcolor=abs('c');appendonto=abs('color cyan');
	elseif indexnum==7,indexcolor=abs('g');appendonto=abs('color green');
	else indexnum==8,indexcolor=abs('k');appendonto=abs('color black');
	end;
elseif globalcolortypeofcall==2
	if indexnum==1,indexfont=abs('Times New Roman');appendonto=abs('font Times New Roman');
	elseif indexnum==2,indexfont=abs('Terminal');appendonto=abs('font Terminal');
	elseif indexnum==3,indexfont=abs('System');appendonto=abs('font System');
	elseif indexnum==4,indexfont=abs('MS Serif');appendonto=abs('font MS Serif');
	elseif indexnum==5,indexfont=abs('MS Sans Serif');appendonto=abs('font MS Sans Serif');
	elseif indexnum==6,indexfont=abs('Modern');appendonto=abs('font Modern');
	elseif indexnum==7,indexfont=abs('Fixedsys');appendonto=abs('font Fixedsys');
	elseif indexnum==8,indexfont=abs('Courier');appendonto=abs('font Courier');
	elseif indexnum==9,indexfont=abs('Courier New');appendonto=abs('font Courier New');
	elseif indexnum==10,indexfont=abs('Arial');appendonto=abs('font Arial');
	else indexnum==11,indexfont=abs('Helvetica');appendonto=abs('font Helvetica');
	end;
elseif globalcolortypeofcall==3
	if indexnum==1,indexfontsize=8;appendonto=abs('font size 8');
	elseif indexnum==2,indexfontsize=9;appendonto=abs('font size 9');
	elseif indexnum==3,indexfontsize=10;appendonto=abs('font size 10');
	elseif indexnum==4,indexfontsize=11;appendonto=abs('font size 11');
	elseif indexnum==5,indexfontsize=12;appendonto=abs('font size 12');
	elseif indexnum==6,indexfontsize=13;appendonto=abs('font size 13');
	elseif indexnum==7,indexfontsize=14;appendonto=abs('font size 14');
	elseif indexnum==8,indexfontsize=15;appendonto=abs('font size 15');
	elseif indexnum==9,indexfontsize=16;appendonto=abs('font size 16');
	else indexnum==10,indexfontsize=17;appendonto=abs('font size 17');
	end;
elseif globalcolortypeofcall==4 | globalcolortypeofcall==7
	if indexnum==1,indexfonttype=abs(':');appendonto=abs('linetype dotted');
	elseif indexnum==2,indexfonttype=abs('-');appendonto=abs('linetype solid');
	elseif indexnum==3,indexfonttype=abs('--');appendonto=abs('linetype dashed');
	else indexnum==4,indexfonttype=abs('-.');appendonto=abs('linetype dashdot');
	end;

end

% Determine currentfigurenum for data storage and message

for bb=1:numoffigs
	if figanddatawin(1,bb)==gcf
		currentfigurenum=bb;
	end

end

% *************************************************************
% ******************** Text ***********************************
% *************************************************************
% globalcolortypeofcall=1  ~ change text color
% globalcolortypeofcall=2  ~ change text font type
% globalcolortypeofcall=3  ~ change text font size

if globalcolortypeofcall==1 | globalcolortypeofcall==2 | globalcolortypeofcall==3 
	textsmart=hold_datavar;

	stamat=1+(currentfigurenum-1).*24; % Set up table insertion point

	[smartcircle,countcircle,tempcircle]=entselec(hold_datavar,stamat,1);	% call entselec function to highlight all text(1) on current plot

	% Determine which entity is to be modified and modify it.

	if countcircle~=1
		if timer~=0
			dumtext=abs('Select text for ');
			messtext=[dumtext,appendonto]; % concatenate strings to create full expression
			typeofcall=1; % white text
			messfun(typeofcall,messtext,currentfigurenum);
		end

		% Call function to determine which entity was selected
		[numberofwinner]=closest(smartcircle);

		if globalcolortypeofcall==1
			set(textsmart(smartcircle(numberofwinner,3),stamat),'Color',setstr(indexcolor));
			
			textsmart(smartcircle(numberofwinner,3),stamat+3:stamat+5)=get(textsmart(smartcircle(numberofwinner,3),stamat),'Color');
			
			delete(tempcircle);clear tempcircle;
		elseif globalcolortypeofcall==2
			set(textsmart(smartcircle(numberofwinner,3),stamat),'FontName',setstr(indexfont));
			fontname=abs(setstr(indexfont));
			fontnamelength=length(fontname);
			fontname=[fontname zeros(1,15-fontnamelength)];
			textsmart(smartcircle(numberofwinner,3),stamat+7:stamat+21)=fontname;
			delete(tempcircle);clear tempcircle;
		elseif globalcolortypeofcall==3
			set(textsmart(smartcircle(numberofwinner,3),stamat),'FontSize',indexfontsize);
			textsmart(smartcircle(numberofwinner,3),stamat+6)=indexfontsize;
			delete(tempcircle);clear tempcircle;
		end
	
	hold_datavar=textsmart;
	end

% *************************************************************
% ******************** Lines **********************************
% *************************************************************
% globalcolortypeofcall=4  ~ change line type
% globalcolortypeofcall=5  ~ change line color

elseif globalcolortypeofcall==4 | globalcolortypeofcall==5 
% fprintf('entcolor,start lines loop! \n');
	linesmart=hold_datavar;
	stamat=1+(currentfigurenum-1).*11; % Set up table insertion point
	
	[smartcircle,countcircle,tempcircle]=entselec(hold_datavar,stamat,2); %call funtion entselec to highlight all lines(2) on current plot
		
	if countcircle~=1
		if timer~=0
			dumtext=abs('Select line for ');
			messtext=[dumtext,appendonto]; % concatenate strings to create full expression
			typeofcall=1; % white text
			messfun(typeofcall,messtext,currentfigurenum);
		end
		% Call function to determine which entity was selected
		[numberofwinner]=closest(smartcircle);

		if globalcolortypeofcall==5 % modify color
			set(linesmart(smartcircle(numberofwinner,3),stamat),'Color',setstr(indexcolor));
			linesmart(smartcircle(numberofwinner,3),stamat+5:stamat+7)=get(linesmart(smartcircle(numberofwinner,3),stamat),'Color');
			delete(tempcircle);clear tempcircle;
		else % modify line type
			set(linesmart(smartcircle(numberofwinner,3),stamat),'Linestyle',setstr(indexfonttype));
			if length(indexfonttype)==1 % does linetype require double element storage
				linesmart(smartcircle(numberofwinner,3),stamat+8:stamat+9)=[indexfonttype 0];
				delete(tempcircle);clear tempcircle;
			else % linetype requires single element storage
				linesmart(smartcircle(numberofwinner,3),stamat+8:stamat+9)=[indexfonttype];
				delete(tempcircle);clear tempcircle;
			end
		end
			
		%end
	%fprintf('entcolor,end line loop! \n');
	hold_datavar=linesmart;
	end

% *************************************************************
% ******************** Leader *********************************
% *************************************************************
% globalcolortypeofcall=6  ~ change leader color
% globalcolortypeofcall=7  ~ change leader line type

elseif globalcolortypeofcall==6 | globalcolortypeofcall==7 
% fprintf('entcolor,start leader loop! \n');
	leadersmart=hold_datavar;

	stamat=1+(currentfigurenum-1).*11; % Set up table insertion point

	[smartcircle,countcircle,tempcircle]=entselec(hold_datavar,stamat,3); % call function entselec to highlight all leaders(3) on current plot

	if countcircle~=1
		if timer~=0
			dumtext=abs('Select leader for ');
			messtext=[dumtext,appendonto]; % concatenate strings to create full expression
			typeofcall=1; % white text
			messfun(typeofcall,messtext,currentfigurenum);
		end
		% Call function to determine which entity was selected
		[numberofwinner]=closest(smartcircle);
		if globalcolortypeofcall==6
			set(leadersmart(smartcircle(numberofwinner,3),stamat),'Color',setstr(indexcolor));
			leadersmart(smartcircle(numberofwinner,3),stamat+5:stamat+7)=get(leadersmart(smartcircle(numberofwinner,3),stamat),'Color');
			delete(tempcircle);clear tempcircle;
		else 
			set(leadersmart(smartcircle(numberofwinner,3),stamat),'Linestyle',setstr(indexfonttype));
			if length(indexfonttype)==1 % does linetype require double element storage
				leadersmart(smartcircle(numberofwinner,3),stamat+8:stamat+9)=[indexfonttype 0];
				delete(tempcircle);clear tempcircle;
			else % linetype requires single element storage
				leadersmart(smartcircle(numberofwinner,3) ,stamat+8:stamat+9)=[indexfonttype];
				delete(tempcircle);clear tempcircle;
			end
		end
	

	hold_datavar=leadersmart;
	end
end

return

