function [smartcircle,countcircle,tempcircle]=entselec(hold_datavar,stamat,typeofcall)

% Version 1.0 of ProPlot 1.0
%
%    // entselec.m \\
%
%     Scott Keane
%  skeane@uceng.uc.edu
%
%  Created on:     8:01 AM 6/1/96
%  Last Modified:  6:08 PM 6/15/96
% *****************************************
% Matlab function to highlight with white circles any
% text, lines, or leaders.
% *****************************************

% ************************************************
% ********* Highlight all text *******************
% ************************************************

if typeofcall==1 
	textsmart=hold_datavar;	

	lengthtextsmart=size(textsmart);
	lengthtextsmart=lengthtextsmart(1,1);
	countcircle=1;
	getaxisvalue=axis;
	for qw=1:lengthtextsmart
		if textsmart(qw,stamat)~=0;
			smartcircle(countcircle,1)=textsmart(qw,stamat+1);
			smartcircle(countcircle,2)=textsmart(qw,stamat+2);
			smartcircle(countcircle,3)=qw;
			axis(getaxisvalue);
			hold on,tempcircle(countcircle,1)=plot(smartcircle(countcircle,1),smartcircle(countcircle,2),'wo');
			countcircle=countcircle+1;
		end
	end

% ************************************************
% ********* Highlight all lines ******************
% ************************************************

elseif typeofcall==2 

	linesmart=hold_datavar;

	lengthlinesmart=size(linesmart);
	lengthlinesmart=lengthlinesmart(1,1);
	countcircle=1;
	dumaxis=axis;
	for qw=1:lengthlinesmart    % ******* Look at lesser of two 
		if linesmart(qw,stamat+3)==linesmart(qw,stamat+4) & linesmart(qw,stamat+1)~=linesmart(qw,stamat+2)   % ******* Hor line
			if dumaxis(1,2)-dumaxis(1,1) <= linesmart(qw,stamat+2)-linesmart(qw,stamat+1);
				smartcircle(countcircle,1:2)=[.9.*((dumaxis(1,2)-dumaxis(1,1))+dumaxis(1,1)),linesmart(qw,stamat+3)];
				smartcircle(countcircle,3)=qw;
				tempcircle(countcircle,1)=plot(smartcircle(countcircle,1),smartcircle(countcircle,2),'wo');
			else;
				smartcircle(countcircle,1:2)=[.9.*((linesmart(qw,stamat+2)-linesmart(qw,stamat+1))+linesmart(qw,stamat+1)),linesmart(qw,stamat+3)];
				tempcircle(countcircle,1)=plot(smartcircle(countcircle,1),smartcircle(countcircle,2),'wo');
			end;
			countcircle=countcircle+1;	

		elseif linesmart(qw,stamat+1)==linesmart(qw,stamat+2) & linesmart(qw,stamat+3)~=linesmart(qw,stamat+4)     % ************Vert Line
			if dumaxis(1,4)-dumaxis(1,3) <= linesmart(qw,stamat+4)-linesmart(qw,stamat+3);
				smartcircle(countcircle,1:2)=[linesmart(qw,stamat+1),.9.*((dumaxis(1,4)-dumaxis(1,3))+dumaxis(1,3))];
				smartcircle(countcircle,3)=qw;
				tempcircle(countcircle,1)=plot(smartcircle(countcircle,1),smartcircle(countcircle,2),'wo');
			else
				smartcircle(countcircle,1:2)=[linesmart(qw,stamat+1),.9.*((linesmart(qw,stamat+4)-linesmart(qw,stamat+3))+linesmart(qw,stamat+3))];
				smartcircle(countcircle,3)=qw;
				tempcircle(countcircle,1)=plot(smartcircle(countcircle,1),smartcircle(countcircle,2),'wo');
			end
			countcircle=countcircle+1;
		end
	end	

% ************************************************
% ********* Highlight all leaders ****************
% ************************************************

elseif typeofcall==3 
	leadersmart=hold_datavar;

	lengthleadersmart=size(leadersmart);
	lengthleadersmart=lengthleadersmart(1,1);
	countcircle=1;
	dumaxis=axis;
	for qw=1:lengthleadersmart
		if leadersmart(qw,stamat)~=0
			xget=get(leadersmart(qw,stamat),'XData');
			yget=get(leadersmart(qw,stamat),'YData');
			[sortdatax,indicex]=sort(xget);
			indicex=fliplr(indicex);
			flag=1;
			for xc=1:length(xget);
				if flag~=0;
					if xget(indicex(xc)) < dumaxis(1,2) & xget(indicex(xc)) > dumaxis(1,1);
						if yget(indicex(xc)) < dumaxis(1,4) & yget(indicex(xc)) > dumaxis(1,3);
							smartcircle(countcircle,1:2)=[xget(indicex(xc)),yget(indicex(xc))];
							smartcircle(countcircle,3)=qw;
							tempcircle(countcircle,1)=plot(smartcircle(countcircle,1),smartcircle(countcircle,2),'wo');
							countcircle=countcircle+1;
							flag=0;
						end
					end
				end
			end
		end
	end

end

return