function [hold_datavar,hold_datavar2]=modcolor(hold_datavar,hold_datavar2,globalcolortypeofcall,numoffigs,figanddatawin,indexnum)

% Version 1.0 of ProPlot 1.0
%
%    // modcolor.m \\
%
%     Scott Keane
%  skeane@uceng.uc.edu
%
%  Created on:     8:01 AM 6/1/96
%  Last Modified:  6:08 PM 6/15/96
% *****************************************
% Matlab function to modify color of all xy labels, title labels,
% figure background, axis, axisbackground, lines, leaders,
% and text.
% *****************************************

if indexnum==1,indexcolor='w';end;
if indexnum==2,indexcolor='b';end;
if indexnum==3,indexcolor='m';end;
if indexnum==4,indexcolor='r';end;
if indexnum==5,indexcolor='y';end;
if indexnum==6,indexcolor='c';end;
if indexnum==7,indexcolor='g';end;
if indexnum==8,indexcolor='k';end;


% Note the following loop is shared by all

for bb=1:numoffigs
	if figanddatawin(1,bb)==gcf
		currentfigurenum=bb;
	end
end


% ***********************************************************************************************
% ******************************** Label xy axis color ******************************************
% ***********************************************************************************************
if globalcolortypeofcall==1
	labelxyaxis=hold_datavar;
	testing=get(labelxyaxis(indexnum,currentfigurenum),'Checked');  % is it selected?
	if length(testing)==3 % is it off?
		set(get(gca,'XLabel'),'Color',setstr(indexcolor));
		set(get(gca,'YLabel'),'Color',setstr(indexcolor));
	
		for hh=1:8
			if hh ~= indexnum    % turn it off
				set(labelxyaxis(hh,currentfigurenum),'checked','off');
			else
				set(labelxyaxis(hh,currentfigurenum),'checked','on');
			end
		end
	else
		set(labelxyaxis(indexnum,currentfigurenum),'checked','on');
	end
	hold_datavar=labelxyaxis;
	hold_datavar2=0;

% ***********************************************************************************************
% *********************************** Title axis color ******************************************
% ***********************************************************************************************
elseif globalcolortypeofcall==2
	labeltitaxis=hold_datavar;
	testing=get(labeltitaxis(indexnum,currentfigurenum),'Checked');  % is it selected?

	if length(testing)==3 % is it off?
		set(get(gca,'Title'),'Color',setstr(indexcolor));
	
		for hh=1:8
			if hh ~= indexnum    % turn it off
				set(labeltitaxis(hh,currentfigurenum),'checked','off');
			else
				set(labeltitaxis(hh,currentfigurenum),'checked','on');
			end
		end
	else
		set(labeltitaxis(indexnum,currentfigurenum),'checked','on');
	end
	hold_datavar=labeltitaxis;
	hold_datavar2=0;

% ***********************************************************************************************
% ****************************** Figure background color ****************************************
% ***********************************************************************************************
elseif globalcolortypeofcall==3
	figbackcolor=hold_datavar;
	testing=get(figbackcolor(indexnum,currentfigurenum),'Checked');  % is it selected?

	if length(testing)==3 % is it off?
		set(figanddatawin(1,currentfigurenum),'Color',setstr(indexcolor));
	
		for hh=1:8
			if hh ~= indexnum    % turn it off
				set(figbackcolor(hh,currentfigurenum),'checked','off');
			else
				set(figbackcolor(hh,currentfigurenum),'checked','on');
			end
		end
	else
		set(figbackcolor(indexnum,currentfigurenum),'checked','on');
	end
	hold_datavar=figbackcolor;
	hold_datavar2=0;

% ***********************************************************************************************
% ************************************* Axis color **********************************************
% ***********************************************************************************************
elseif globalcolortypeofcall==4
	axisplotcolor=hold_datavar;
	testing=get(axisplotcolor(indexnum,currentfigurenum),'Checked');  % is it selected?

	if length(testing)==3 % is it off?
		set(gca,'XColor',setstr(indexcolor));
		set(gca,'YColor',setstr(indexcolor));
	
		for hh=1:8
			if hh ~= indexnum    % turn it off
				set(axisplotcolor(hh,currentfigurenum),'checked','off');
			else
				set(axisplotcolor(hh,currentfigurenum),'checked','on');
			end
		end
	else
		set(axisplotcolor(indexnum,currentfigurenum),'checked','on');
	end
	hold_datavar=axisplotcolor;
	hold_datavar2=0;

% ***********************************************************************************************
% ****************************** Axis background color ******************************************
% ***********************************************************************************************
elseif globalcolortypeofcall==5
	axisbackgroundcolor=hold_datavar;
	testing=get(axisbackgroundcolor(indexnum,currentfigurenum),'Checked');  % is it selected?

	if length(testing)==3 % is it off?
		set(gca,'Color',setstr(indexcolor));
	
		for hh=1:8
			if hh ~= indexnum    % turn it off
				set(axisbackgroundcolor(hh,currentfigurenum),'checked','off');
			else
				set(axisbackgroundcolor(hh,currentfigurenum),'checked','on');
			end
		end
	else
		set(axisbackgroundcolor(indexnum,currentfigurenum),'checked','on');
	end
	hold_datavar=axisbackgroundcolor;
	hold_datavar2=0;

% ***********************************************************************************************
% *********************************** Text all color ********************************************
% ***********************************************************************************************
elseif globalcolortypeofcall==6
	textbackall=hold_datavar;
	textsmart=hold_datavar2;
	testing=get(textbackall(indexnum,currentfigurenum),'Checked');
	if length(testing)==3
		stamat=1+(currentfigurenum-1).*24;
		lengthtextsmart=size(textsmart);
		lengthtextsmart=lengthtextsmart(1,1);
		for qw=1:lengthtextsmart
			textsmart(qw,stamat);
			if textsmart(qw,stamat)~=0
				set(textsmart(qw,stamat),'Color',setstr(indexcolor));
				textsmart(qw,stamat+3:stamat+5)=get(textsmart(qw,stamat),'Color');
			end
		end
		for hh=1:8
			if hh ~= indexnum    % turn it off
				set(textbackall(hh,currentfigurenum),'checked','off');
			else
				set(textbackall(hh,currentfigurenum),'checked','on');
			end
		end
	else
		set(textbackall(indexnum,currentfigurenum),'checked','on');
	end
	hold_datavar=textbackall;
	hold_datavar2=textsmart;

% ***********************************************************************************************
% *********************************** Line all color ********************************************
% ***********************************************************************************************
elseif globalcolortypeofcall==7
	linebackall=hold_datavar;
	linesmart=hold_datavar2;
	testing=get(linebackall(indexnum,currentfigurenum),'Checked');
		if length(testing)==3
			stamat=1+(currentfigurenum-1).*11;
			lengthlinesmart=size(linesmart);
			lengthlinesmart=lengthlinesmart(1,1);
			for qw=1:lengthlinesmart
				linesmart(qw,stamat);
				if linesmart(qw,stamat)~=0
					set(linesmart(qw,stamat),'Color',setstr(indexcolor));
					linesmart(qw,stamat+5:stamat+7)=get(linesmart(qw,stamat),'Color');
				end
			end

			for hh=1:8
			if hh ~= indexnum    % turn it off
				set(linebackall(hh,currentfigurenum),'checked','off');
			else
				set(linebackall(hh,currentfigurenum),'checked','on');
			end
		end
	else
		set(linebackall(indexnum,currentfigurenum),'checked','on');
	end
	hold_datavar=linebackall;
	hold_datavar2=linesmart;

% ***********************************************************************************************
% *********************************** Leader all color ********************************************
% ***********************************************************************************************
elseif globalcolortypeofcall==8
	leaderbackall=hold_datavar;
	leadersmart=hold_datavar2;
	testing=get(leaderbackall(indexnum,currentfigurenum),'Checked');
	if length(testing)==3
		stamat=1+(currentfigurenum-1).*11;
		lengthleadersmart=size(leadersmart);
		lengthleadersmart=lengthleadersmart(1,1);
		for qw=1:lengthleadersmart
			leadersmart(qw,stamat);
			if leadersmart(qw,stamat)~=0
				set(leadersmart(qw,stamat),'Color',setstr(indexcolor));
				leadersmart(qw,stamat+5:stamat+7)=get(leadersmart(qw,stamat),'Color');
			end
		end

		for hh=1:8
			if hh ~= indexnum    % turn it off
				set(leaderbackall(hh,currentfigurenum),'checked','off');
			else
				set(leaderbackall(hh,currentfigurenum),'checked','on');
			end
		end
	else
		set(leaderbackall(indexnum,currentfigurenum),'checked','on');
	end
	hold_datavar=leaderbackall;
	hold_datavar2=leadersmart;
	
end		
return