function [hold_datavar,hold_datavar2]=modfont(hold_datavar,hold_datavar2,globalfonttypeofcall,numoffigs,figanddatawin,indexnum)

% Version 1.0 of ProPlot 1.0
%
%    // modfont.m \\
%
%     Scott Keane
%  skeane@uceng.uc.edu
%
%  Created on:     8:01 AM 6/1/96
%  Last Modified:  6:05 PM 6/15/96
% *****************************************
% Matlab function to modify font type of all xy labels, title labels,
% axis labels, and text.
% *****************************************

if indexnum==1,indexfont='Times New Roman';end;
if indexnum==2,indexfont='Terminal';end;
if indexnum==3,indexfont='System';end;
if indexnum==4,indexfont='MS Serif';end;
if indexnum==5,indexfont='MS Sans Serif';end;
if indexnum==6,indexfont='Modern';end;
if indexnum==7,indexfont='Fixedsys';end;
if indexnum==8,indexfont='Courier';end;
if indexnum==9,indexfont='Courier New';end;
if indexnum==10,indexfont='Arial';end;
if indexnum==11,indexfont='Helvetica';end;

% Note the following loop is shared by all

for bb=1:numoffigs
	if figanddatawin(1,bb)==gcf
		currentfigurenum=bb;
	end
end

% **************************************************************************************
% *************** Modify x,y label font ***********************************************
% **************************************************************************************
if globalfonttypeofcall==1
	labelxyfont=hold_datavar;
	testing=get(labelxyfont(indexnum,currentfigurenum),'Checked');  % is it selected?

	if length(testing)==3 % is it off?
		set(get(gca,'XLabel'),'FontName',setstr(indexfont));
		set(get(gca,'YLabel'),'FontName',setstr(indexfont));
	
		for hh=1:11
			if hh ~= indexnum    % turn it off
				set(labelxyfont(hh,currentfigurenum),'checked','off');
			else
				set(labelxyfont(hh,currentfigurenum),'checked','on');
			end
		end
	else
		set(labelxyfont(indexnum,currentfigurenum),'checked','on');
	end
	hold_datavar=labelxyfont;
	hold_datavar2=0;

% **************************************************************************************
% *************** Modify title font ***********************************************
% **************************************************************************************
elseif globalfonttypeofcall==2
	labeltitfont=hold_datavar;
	testing=get(labeltitfont(indexnum,currentfigurenum),'Checked');  % is it selected?

	if length(testing)==3 % is it off?
		set(get(gca,'Title'),'FontName',setstr(indexfont));
	
		for hh=1:11
			if hh ~= indexnum    % turn it off
				set(labeltitfont(hh,currentfigurenum),'checked','off');
			else
				set(labeltitfont(hh,currentfigurenum),'checked','on');
			end
		end
	else
		set(labeltitfont(indexnum,currentfigurenum),'checked','on');
	end
	hold_datavar=labeltitfont;
	hold_datavar2=0;

% **************************************************************************************
% *************** Modify axis font ***********************************************
% **************************************************************************************
elseif globalfonttypeofcall==3
	axisfont=hold_datavar;
	testing=get(axisfont(indexnum,currentfigurenum),'Checked');  % is it selected?

	if length(testing)==3 % is it off?
		set(gca,'FontName',setstr(indexfont));
	
		for hh=1:11
			if hh ~= indexnum    % turn it off
				set(axisfont(hh,currentfigurenum),'checked','off');
			else
				set(axisfont(hh,currentfigurenum),'checked','on');
			end
		end
	else
		set(axisfont(indexnum,currentfigurenum),'checked','on');
	end
	hold_datavar=axisfont;
	hold_datavar2=0;

% **************************************************************************************
% *************** Modify all text font ***********************************************
% **************************************************************************************
elseif globalfonttypeofcall==4
	textfontall=hold_datavar;
	textsmart=hold_datavar2;
	testing=get(textfontall(indexnum,currentfigurenum),'Checked');
	if length(testing)==3
		stamat=1+(currentfigurenum-1).*24;
		lengthtextsmart=size(textsmart);
		lengthtextsmart=lengthtextsmart(1,1);
		for qw=1:lengthtextsmart
			textsmart(qw,stamat);
			if textsmart(qw,stamat)~=0
				set(textsmart(qw,stamat),'FontName',setstr(indexfont));
				fontname=abs(setstr(indexfont));
				fontnamelength=length(fontname);
				fontname=[fontname zeros(1,15-fontnamelength)];
				textsmart(qw,stamat+7:stamat+21)=fontname;
			end
		end

		for hh=1:11
			if hh ~= indexnum    % turn it off
				set(textfontall(hh,currentfigurenum),'checked','off');
			else
				set(textfontall(hh,currentfigurenum),'checked','on');
			end
		end
	else
		set(textfontall(indexnum,currentfigurenum),'checked','on');
	end
	hold_datavar=textfontall;
	hold_datavar2=textsmart;

end
return