function [hold_datavar,hold_datavar2]=modsize(hold_datavar,hold_datavar2,globalfontsizetypeofcall,numoffigs,figanddatawin,indexnum)

% Version 1.0 of ProPlot 1.0
%
%    // modsize.m \\
%
%     Scott Keane
%  skeane@uceng.uc.edu
%
%  Created on:     8:01 AM 6/1/96
%  Last Modified:  6:01 PM 6/15/96
% *****************************************
% Matlab function to modify font size of xy labels, title labels,
% axis labels, and text.
% *****************************************

if indexnum==1,indexfontsize=8;end;
if indexnum==2,indexfontsize=9;end;
if indexnum==3,indexfontsize=10;end;
if indexnum==4,indexfontsize=11;end;
if indexnum==5,indexfontsize=12;end;
if indexnum==6,indexfontsize=13;end;
if indexnum==7,indexfontsize=14;end;
if indexnum==8,indexfontsize=15;end;
if indexnum==9,indexfontsize=16;end;
if indexnum==10,indexfontsize=17;end;

% Note the following loop is shared by all

for bb=1:numoffigs
	if figanddatawin(1,bb)==gcf
		currentfigurenum=bb;
	end
end

% **************************************************************************************
% *************** Modify x,y label fontsize ***********************************************
% **************************************************************************************
if globalfontsizetypeofcall==1
	labelxyfontsize=hold_datavar;
	testing=get(labelxyfontsize(indexnum,currentfigurenum),'Checked');  % is it selected?

	if length(testing)==3 % is it off?
		set(get(gca,'XLabel'),'FontSize',indexfontsize);
		set(get(gca,'YLabel'),'FontSize',indexfontsize);
	
		for hh=1:10
			if hh ~= indexnum    % turn it off
				set(labelxyfontsize(hh,currentfigurenum),'checked','off');
			else
				set(labelxyfontsize(hh,currentfigurenum),'checked','on');
			end
		end
	else
		set(labelxyfontsize(indexnum,currentfigurenum),'checked','on');
	end
	hold_datavar=labelxyfontsize;
	hold_datavar2=0;

% **************************************************************************************
% *************** Modify title fontsize ***********************************************
% **************************************************************************************
elseif globalfontsizetypeofcall==2
	labeltitfontsize=hold_datavar;
	testing=get(labeltitfontsize(indexnum,currentfigurenum),'Checked');  % is it selected?

	if length(testing)==3 % is it off?
		set(get(gca,'Title'),'FontSize',indexfontsize);
	
		for hh=1:10
			if hh ~= indexnum    % turn it off
				set(labeltitfontsize(hh,currentfigurenum),'checked','off');
			else
				set(labeltitfontsize(hh,currentfigurenum),'checked','on');
			end
		end
	else
		set(labeltitfontsize(indexnum,currentfigurenum),'checked','on');
	end
	hold_datavar=labeltitfontsize;
	hold_datavar2=0;

% **************************************************************************************
% *************** Modify axis units fontsize ***********************************************
% **************************************************************************************
elseif globalfontsizetypeofcall==3
	axisfontsize=hold_datavar;
	testing=get(axisfontsize(indexnum,currentfigurenum),'Checked');  % is it selected?

	if length(testing)==3 % is it off?
	
		set(gca,'FontSize',indexfontsize);
		for hh=1:10
			if hh ~= indexnum    % turn it off
				set(axisfontsize(hh,currentfigurenum),'checked','off');
			else
				set(axisfontsize(hh,currentfigurenum),'checked','on');
			end
		end
	else
		set(axisfontsize(indexnum,currentfigurenum),'checked','on');
	end
	hold_datavar=axisfontsize;
	hold_datavar2=0;

% **************************************************************************************
% *************** Modify text fontsize all***********************************************
% **************************************************************************************
elseif globalfontsizetypeofcall==4
	textsizeall=hold_datavar;
	textsmart=hold_datavar2;
	testing=get(textsizeall(indexnum,currentfigurenum),'Checked');
	if length(testing)==3
		stamat=1+(currentfigurenum-1).*24;
		lengthtextsmart=size(textsmart);
		lengthtextsmart=lengthtextsmart(1,1);
		for qw=1:lengthtextsmart
			textsmart(qw,stamat);
			if textsmart(qw,stamat)~=0
				set(textsmart(qw,stamat),'FontSize',indexfontsize);
				textsmart(qw,stamat+6)=8;
			end
		end
		for hh=1:10
			if hh ~= indexnum    % turn it off
				set(textsizeall(hh,currentfigurenum),'checked','off');
			else
				set(textsizeall(hh,currentfigurenum),'checked','on');
			end
		end
	else
		set(textsizeall(indexnum,currentfigurenum),'checked','on');
	end
	hold_datavar=textsizeall;
	hold_datavar2=textsmart;	

end

return