% Version 1.0 of ProPlot 1.0
%
%    // chaxis1.m \\
%
%     Scott Keane
%  skeane@uceng.uc.edu
%
%  Created on:     1:58 AM 2/4/96
%  Last Modified:  11:48 PM 6/22/96
% *****************************************
% Matlab script to add a gui driven slider 
% axis control
% *****************************************




uniqueoneeach(currentfigurenum)=1;

% ****************************************************
% ************ GET CURRENT AXIS SCALE ****************
% ****************************************************

v=axis;
currentxlow(currentfigurenum)=v(1); newxlow(currentfigurenum)=currentxlow(currentfigurenum);
currentxhigh(currentfigurenum)=v(2); newxhigh(currentfigurenum)=currentxhigh(currentfigurenum);
currentylow(currentfigurenum)=v(3); newylow(currentfigurenum)=currentylow(currentfigurenum);
currentyhigh(currentfigurenum)=v(4); newyhigh(currentfigurenum)=currentyhigh(currentfigurenum);

% ****************************************************
% *************** DEFINE SLIDERS *********************
% ****************************************************

slidexlow(currentfigurenum)=uicontrol(figanddatawin(1,currentfigurenum),...
	'Style','slider',...
	'Position',[80 170 80 20],...
	'Min',(currentxlow(currentfigurenum)-(currentxhigh(currentfigurenum)-currentxlow(currentfigurenum))),'Max',(currentxhigh(currentfigurenum)+(currentxhigh(currentfigurenum)-currentxhigh(currentfigurenum))),'Value',currentxlow(currentfigurenum),...
	'CallBack',['for bb=1:numoffigs,if figanddatawin(1,bb)==gcf,',...
		'currentfigurenum=bb;end,end,',...
		'newxlow=get(slidexlow(currentfigurenum),''Value'');',...
		'newxhigh=get(slidexhigh(currentfigurenum),''Value'');',...
		'if newxlow < newxhigh,',...
			'set(xlow_cur(currentfigurenum),''String'',num2str(get(slidexlow(currentfigurenum),''Value'')));',...
			'newylow=get(slideylow(currentfigurenum),''Value'');',...
			'newyhigh=get(slideyhigh(currentfigurenum),''Value'');',...
			'temphold=[newxlow,newxhigh,newylow,newyhigh];',...
			'axis(temphold);',...
		'end;']);

 slidexhigh(currentfigurenum)=uicontrol(figanddatawin(1,currentfigurenum),...
	'Style','slider',...
	'Position',[180 170 80 20],...
	'Min',currentxlow(currentfigurenum),'Max',(currentxhigh(currentfigurenum)+(currentxhigh(currentfigurenum)-currentxlow(currentfigurenum))),'Value',currentxhigh(currentfigurenum),...
	'CallBack',['for bb=1:numoffigs,if figanddatawin(1,bb)==gcf,',...
		'currentfigurenum=bb;end,end,',...
		'newxlow=get(slidexlow(currentfigurenum),''Value'');',...
		'newxhigh=get(slidexhigh(currentfigurenum),''Value'');',...
		'if newxlow < newxhigh,',...
			'set(xhigh_cur(currentfigurenum),''String'',num2str(get(slidexhigh(currentfigurenum),''Value'')));',...
			'newylow=get(slideylow(currentfigurenum),''Value'');',...
			'newyhigh=get(slideyhigh(currentfigurenum),''Value'');',...
			'temphold=[newxlow,newxhigh,newylow,newyhigh];',...
			'axis(temphold);',...
		'end;']);


slideylow(currentfigurenum)=uicontrol(figanddatawin(1,currentfigurenum),...
	'Style','slider',...
	'Position',[80 100 80 20],...
	'Min',(currentylow(currentfigurenum)-(currentyhigh(currentfigurenum)-currentylow(currentfigurenum))),'Max',(currentyhigh(currentfigurenum)+(currentyhigh(currentfigurenum)-currentyhigh(currentfigurenum))),'Value',currentylow(currentfigurenum),...
	'CallBack',['for bb=1:numoffigs,if figanddatawin(1,bb)==gcf,',...
		'currentfigurenum=bb;end,end,',...
		'newylow=get(slideylow(currentfigurenum),''Value'');',...
		'newyhigh=get(slideyhigh(currentfigurenum),''Value'');',...
		'if newylow < newyhigh,',...
			'set(ylow_cur(currentfigurenum),''String'',num2str(get(slideylow(currentfigurenum),''Value'')));',...
			'newxlow=get(slidexlow(currentfigurenum),''Value'');',...
			'newxhigh=get(slidexhigh(currentfigurenum),''Value'');',...
			'temphold=[newxlow,newxhigh,newylow,newyhigh];',...
			'axis(temphold);',...
		'end;']);


slideyhigh(currentfigurenum)=uicontrol(figanddatawin(1,currentfigurenum),...
	'Style','slider',...
	'Position',[180 100 80 20],...
	'Min',currentylow(currentfigurenum),'Max',(currentyhigh(currentfigurenum)+(currentyhigh(currentfigurenum)-currentylow(currentfigurenum))),'Value',currentyhigh(currentfigurenum),...
	'CallBack',['for bb=1:numoffigs,if figanddatawin(1,bb)==gcf,',...
		'currentfigurenum=bb;end,end,',...
		'newylow=get(slideylow(currentfigurenum),''Value'');',...
		'newyhigh=get(slideyhigh(currentfigurenum),''Value'');',...
		'if newylow < newyhigh,',...
			'set(yhigh_cur(currentfigurenum),''String'',num2str(get(slideyhigh(currentfigurenum),''Value'')));',...
			'newxlow=get(slidexlow(currentfigurenum),''Value'');',...
			'newxhigh=get(slidexhigh(currentfigurenum),''Value'');',...
			'temphold=[newxlow,newxhigh,newylow,newyhigh];',...
			'axis(temphold);',...
		'end;']);

% ******************************************
% ********* CLOSE BUTTON *******************
% ******************************************

closeme(currentfigurenum)=uicontrol(figanddatawin(1,currentfigurenum),...
	'Style','push',...
	'Position',[185 70 70 20],...
	'String','Dismiss',...
	'CallBack',['for bb=1:numoffigs,if figanddatawin(1,bb)==gcf,',...
		'currentfigurenum=bb;end,end,',...
		'uniqueoneeach(currentfigurenum)=0;',...
		'delete(slidexlow(currentfigurenum),slidexhigh(currentfigurenum),slideylow(currentfigurenum),slideyhigh(currentfigurenum),closeme(currentfigurenum)),',...
		'delete(xlow_cur(currentfigurenum),xhigh_cur(currentfigurenum),ylow_cur(currentfigurenum),yhigh_cur(currentfigurenum),resetxlow(currentfigurenum)),',...
		'delete(xl(currentfigurenum),xh(currentfigurenum),yl(currentfigurenum),yh(currentfigurenum)),zoommake,zoomio']);


% *****************************************
% ************ TEXT SLIDER CONTROLS *******
% *****************************************

xlow_cur(currentfigurenum)=uicontrol(figanddatawin(1,currentfigurenum),...
	'Style','text',...
	'ForegroundColor','y',...
	'BackgroundColor','k',...
	'Position',[85 190 70 20],...
	'String',num2str(get(slidexlow(currentfigurenum),'Value')));

xhigh_cur(currentfigurenum)=uicontrol(figanddatawin(1,currentfigurenum),...
	'Style','text',...
	'ForegroundColor','y',...
	'BackgroundColor','k',...
	'Position',[185 190 70 20],...
	'String',num2str(get(slidexhigh(currentfigurenum),'Value')));

ylow_cur(currentfigurenum)=uicontrol(figanddatawin(1,currentfigurenum),...
	'Style','text',...
	'ForegroundColor','y',...
	'BackgroundColor','k',...
	'Position',[85 120 70 20],...
	'String',num2str(get(slideylow(currentfigurenum),'Value')));

yhigh_cur(currentfigurenum)=uicontrol(figanddatawin(1,currentfigurenum),...
	'Style','text',...
	'ForegroundColor','y',...
	'BackgroundColor','k',...
	'Position',[185 120 70 20],...
	'String',num2str(get(slideyhigh(currentfigurenum),'Value')));

% ************************************************
% ****************** RESET VALUES ****************
% ************************************************

resetxlow(currentfigurenum)=uicontrol(figanddatawin(1,currentfigurenum),...
	'Style','push',...
	'Position',[85 70 70 20],...
	'String','Reset ',...
	'CallBack',['for bb=1:numoffigs,if figanddatawin(1,bb)==gcf,',...
		'currentfigurenum=bb;end,end,',...
		'set(xlow_cur(currentfigurenum),''String'',num2str(currentxlow(currentfigurenum)));',...
		'set(xhigh_cur(currentfigurenum),''String'',num2str(currentxhigh(currentfigurenum)));',...
		'set(ylow_cur(currentfigurenum),''String'',num2str(currentylow(currentfigurenum)));',...
		'set(yhigh_cur(currentfigurenum),''String'',num2str(currentyhigh(currentfigurenum)));',...
		'axis([currentxlow(currentfigurenum) currentxhigh(currentfigurenum) currentylow(currentfigurenum) currentyhigh(currentfigurenum)]);',...
		'set(slidexlow(currentfigurenum),''Value'',currentxlow(currentfigurenum));',...
		'set(slidexhigh(currentfigurenum),''Value'',currentxhigh(currentfigurenum));',...
		'set(slideylow(currentfigurenum),''Value'',currentylow(currentfigurenum));',...
		'set(slideyhigh(currentfigurenum),''Value'',currentyhigh(currentfigurenum));']);

% ************************************************
% ************* ADD TEXT LABELS ******************
% ************************************************

xl(currentfigurenum)=uicontrol(figanddatawin(1,currentfigurenum),...
	'Style','text',...
	'ForegroundColor','w',...
	'BackgroundColor','k',...
	'Position',[85 210 70 20],...
	'String','xmin');

xh(currentfigurenum)=uicontrol(figanddatawin(1,currentfigurenum),...
	'Style','text',...
	'ForegroundColor','w',...
	'BackgroundColor','k',...
	'Position',[185 210 70 20],...
	'String','xmax');

yl(currentfigurenum)=uicontrol(figanddatawin(1,currentfigurenum),...
	'Style','text',...
	'ForegroundColor','w',...
	'BackgroundColor','k',...
	'Position',[85 140 70 20],...
	'String','ymin');

yh(currentfigurenum)=uicontrol(figanddatawin(1,currentfigurenum),...
	'Style','text',...
	'ForegroundColor','w',...
	'BackgroundColor','k',...
	'Position',[185 140 70 20],...
	'String','ymax');



set(slidexlow(currentfigurenum),'Units','normal');
set(slidexhigh(currentfigurenum),'Units','normal');
set(slideylow(currentfigurenum),'Units','normal');
set(slideyhigh(currentfigurenum),'Units','normal');
set(closeme(currentfigurenum),'Units','normal');
set(xlow_cur(currentfigurenum),'Units','normal');
set(xhigh_cur(currentfigurenum),'Units','normal');
set(ylow_cur(currentfigurenum),'Units','normal');
set(yhigh_cur(currentfigurenum),'Units','normal');
set(resetxlow(currentfigurenum),'Units','normal');
set(xl(currentfigurenum),'Units','normal');
set(xh(currentfigurenum),'Units','normal');
set(yl(currentfigurenum),'Units','normal');
set(yh(currentfigurenum),'Units','normal');