% Version 1.0 of ProPlot 1.0
%
%    // dataaxs1.m \\
%
%     Scott Keane
%  skeane@uceng.uc.edu
%
%
% *****************************************
% Matlab script to add a menu driven 
% axis control
% *****************************************



% ****************************************************************
% ********** CHANGE AXIS FROM MENU *******************************
% ****************************************************************
% sliders and 2 point

axisdata(numoffigs)=uimenu(figanddatawin(1,numoffigs),...
	'Label','A&xis',...
	'Separator','on');
	

axisscale(numoffigs)=uimenu(figanddatawin(1,numoffigs),...
	'Label','&Zoom');


twopoint(numoffigs)=uimenu(axisscale(numoffigs),...
	'Label','&2-Point Zoom',...
	'CallBack',['for bb=1:numoffigs,if figanddatawin(1,bb)==gcf,',...
		'currentfigurenum=bb;end,end,',...
		'if uniqueoneeach(currentfigurenum)~=1;',...
		'if timer~=0;',...
			'messtext=''Select 2 points'';',...
			'typeofcall=1;',...
			'messfun(typeofcall,messtext,currentfigurenum);',...
		'end;',...
		'[cox,coy]=ginput(2),axis([min(cox) max(cox) min(coy) max(coy)]);',...
		'zoommake;zoomio;end']);

% call zoomnew, one of the fixes

zoomnew




chaxisslider(numoffigs)=uimenu(axisscale(numoffigs),...
	'Label','&Slider Zoom',...
	'Separator','on',...
	'CallBack',['for bb=1:numoffigs,if figanddatawin(1,bb)==gcf,',...
		'currentfigurenum=bb;end,end,',...
		'if uniqueoneeach(currentfigurenum)~=1;',...
		'chaxis1,end']);

zoomout(numoffigs)=uimenu(axisscale(numoffigs),...
	'Label','Zoom &History',...
	'Separator','on',...
	'Enable','off');

axisbox(numoffigs)=uimenu(axisdata(numoffigs),...
	'Label','&Box',...
	'Checked','off',...
	'Separator','off',...
	'CallBack',['for bb=1:numoffigs,if figanddatawin(1,bb)==gcf,',...
		'currentfigurenum=bb;end,end,',...
		'testing=get(axisbox(currentfigurenum),''Checked'');',...
		'if length(testing)==3,',...
			'set(gca,''Box'',''on'');',...
			'set(axisbox(currentfigurenum),''checked'',''on'');',...
		'else,',...
			'set(gca,''Box'',''off'');',...
			'set(axisbox(currentfigurenum),''checked'',''off'');',...
		'end']);

tickdirection(numoffigs)=uimenu(axisdata(numoffigs),...
	'Label','&Tickmarks',...
	'Separator','on');

tickin(numoffigs)=uimenu(tickdirection(numoffigs),...
	'Label','&In',...
	'Checked','off',...
	'CallBack',['for bb=1:numoffigs,if figanddatawin(1,bb)==gcf,',...
		'currentfigurenum=bb;end,end,',...
		'testing=get(tickin(currentfigurenum),''Checked'');',...
		'if length(testing)==3,',...
			'set(tickin(currentfigurenum),''Checked'',''on'');',...
			'set(tickout(currentfigurenum),''Checked'',''off'');',...
			'set(gca,''TickDir'',''in'');',...
		'end']);

tickout(numoffigs)=uimenu(tickdirection(numoffigs),...
	'Label','&Out',...
	'Checked','off',...
	'Separator','on',...
	'CallBack',['for bb=1:numoffigs,if figanddatawin(1,bb)==gcf,',...
		'currentfigurenum=bb;end,end,',...
		'testing=get(tickout(currentfigurenum),''Checked'');',...
		'if length(testing)==3,',...
			'set(tickout(currentfigurenum),''Checked'',''on'');',...
			'set(tickin(currentfigurenum),''Checked'',''off'');',...
			'set(gca,''TickDir'',''out'');',...
		'end']);
% **************************************************************

axiscolor(numoffigs)=uimenu(axisdata(numoffigs),...
	'Label','Axis &Color',...
	'Separator','on');


axisplotcolor(1,numoffigs)=uimenu(axiscolor(numoffigs),...
	'Label','&White',...
	'Checked','off',...
	'CallBack',['hold_xlabelcolor=get(get(gca,''XLabel''),''Color'');',...
		'globalcolortypeofcall=4;indexnum=1;hold_datavar=axisplotcolor;',...
		'[axisplotcolor,nullvalue]=modcolor(hold_datavar,0,globalcolortypeofcall,numoffigs,figanddatawin,indexnum);',...
		'set(get(gca,''XLabel''),''Color'',hold_xlabelcolor);',...
		'set(get(gca,''YLabel''),''Color'',hold_xlabelcolor);']);

axisplotcolor(2,numoffigs)=uimenu(axiscolor(numoffigs),...
	'Label','&Blue',...
	'Separator','on',...
	'Checked','off',...
	'CallBack',['hold_xlabelcolor=get(get(gca,''XLabel''),''Color'');',...
		'globalcolortypeofcall=4;indexnum=2;hold_datavar=axisplotcolor;',...
		'[axisplotcolor,nullvalue]=modcolor(hold_datavar,0,globalcolortypeofcall,numoffigs,figanddatawin,indexnum);',...
		'set(get(gca,''XLabel''),''Color'',hold_xlabelcolor);',...
		'set(get(gca,''YLabel''),''Color'',hold_xlabelcolor);']);

axisplotcolor(3,numoffigs)=uimenu(axiscolor(numoffigs),...
	'Label','&Magenta',...
	'Separator','on',...
	'Checked','off',...
	'CallBack',['hold_xlabelcolor=get(get(gca,''XLabel''),''Color'');',...
		'globalcolortypeofcall=4;indexnum=3;hold_datavar=axisplotcolor;',...
		'[axisplotcolor,nullvalue]=modcolor(hold_datavar,0,globalcolortypeofcall,numoffigs,figanddatawin,indexnum);',...
		'set(get(gca,''XLabel''),''Color'',hold_xlabelcolor);',...
		'set(get(gca,''YLabel''),''Color'',hold_xlabelcolor);']);

axisplotcolor(4,numoffigs)=uimenu(axiscolor(numoffigs),...
	'Label','&Red',...
	'Separator','on',...
	'Checked','off',...
	'CallBack',['hold_xlabelcolor=get(get(gca,''XLabel''),''Color'');',...
		'globalcolortypeofcall=4;indexnum=4;hold_datavar=axisplotcolor;',...
		'[axisplotcolor,nullvalue]=modcolor(hold_datavar,0,globalcolortypeofcall,numoffigs,figanddatawin,indexnum);',...
		'set(get(gca,''XLabel''),''Color'',hold_xlabelcolor);',...
		'set(get(gca,''YLabel''),''Color'',hold_xlabelcolor);']);

axisplotcolor(5,numoffigs)=uimenu(axiscolor(numoffigs),...
	'Label','&Yellow',...
	'Separator','on',...
	'Checked','off',...
	'CallBack',['hold_xlabelcolor=get(get(gca,''XLabel''),''Color'');',...
		'globalcolortypeofcall=4;indexnum=5;hold_datavar=axisplotcolor;',...
		'[axisplotcolor,nullvalue]=modcolor(hold_datavar,0,globalcolortypeofcall,numoffigs,figanddatawin,indexnum);',...
		'set(get(gca,''XLabel''),''Color'',hold_xlabelcolor);',...
		'set(get(gca,''YLabel''),''Color'',hold_xlabelcolor);']);

axisplotcolor(6,numoffigs)=uimenu(axiscolor(numoffigs),...
	'Label','&Cyan',...
	'Separator','on',...
	'Checked','off',...
	'CallBack',['hold_xlabelcolor=get(get(gca,''XLabel''),''Color'');',...
		'globalcolortypeofcall=4;indexnum=6;hold_datavar=axisplotcolor;',...
		'[axisplotcolor,nullvalue]=modcolor(hold_datavar,0,globalcolortypeofcall,numoffigs,figanddatawin,indexnum);',...
		'set(get(gca,''XLabel''),''Color'',hold_xlabelcolor);',...
		'set(get(gca,''YLabel''),''Color'',hold_xlabelcolor);']);

axisplotcolor(7,numoffigs)=uimenu(axiscolor(numoffigs),...
	'Label','&Green',...
	'Separator','on',...
	'Checked','off',...
	'CallBack',['hold_xlabelcolor=get(get(gca,''XLabel''),''Color'');',...
		'globalcolortypeofcall=4;indexnum=7;hold_datavar=axisplotcolor;',...
		'[axisplotcolor,nullvalue]=modcolor(hold_datavar,0,globalcolortypeofcall,numoffigs,figanddatawin,indexnum);',...
		'set(get(gca,''XLabel''),''Color'',hold_xlabelcolor);',...
		'set(get(gca,''YLabel''),''Color'',hold_xlabelcolor);']);


axisplotcolor(8,numoffigs)=uimenu(axiscolor(numoffigs),...
	'Label','&Black',...
	'Separator','on',...
	'Checked','off',...
	'CallBack',['hold_xlabelcolor=get(get(gca,''XLabel''),''Color'');',...
		'globalcolortypeofcall=4;indexnum=8;hold_datavar=axisplotcolor;',...
		'[axisplotcolor,nullvalue]=modcolor(hold_datavar,0,globalcolortypeofcall,numoffigs,figanddatawin,indexnum);',...
		'set(get(gca,''XLabel''),''Color'',hold_xlabelcolor);',...
		'set(get(gca,''YLabel''),''Color'',hold_xlabelcolor);']);

% *************************************************************
% **************** Background Axis Color **********************
% *************************************************************

axisbackcolor(numoffigs)=uimenu(axisdata(numoffigs),...
	'Label','Axis &Background Color',...
	'Separator','on');


axisbackgroundcolor(1,numoffigs)=uimenu(axisbackcolor(numoffigs),...
	'Label','&White',...
	'Checked','off',...
	'CallBack',['globalcolortypeofcall=5;indexnum=1;hold_datavar=axisbackgroundcolor;',...
		'[axisbackgroundcolor,nullvalue]=modcolor(hold_datavar,0,globalcolortypeofcall,numoffigs,figanddatawin,indexnum);']);

axisbackgroundcolor(2,numoffigs)=uimenu(axisbackcolor(numoffigs),...
	'Label','&Blue',...
	'Separator','on',...
	'Checked','off',...
	'CallBack',['globalcolortypeofcall=5;indexnum=2;hold_datavar=axisbackgroundcolor;',...
		'[axisbackgroundcolor,nullvalue]=modcolor(hold_datavar,0,globalcolortypeofcall,numoffigs,figanddatawin,indexnum);']);

axisbackgroundcolor(3,numoffigs)=uimenu(axisbackcolor(numoffigs),...
	'Label','&Magenta',...
	'Separator','on',...
	'Checked','off',...
	'CallBack',['globalcolortypeofcall=5;indexnum=3;hold_datavar=axisbackgroundcolor;',...
		'[axisbackgroundcolor,nullvalue]=modcolor(hold_datavar,0,globalcolortypeofcall,numoffigs,figanddatawin,indexnum);']);

axisbackgroundcolor(4,numoffigs)=uimenu(axisbackcolor(numoffigs),...
	'Label','&Red',...
	'Separator','on',...
	'Checked','off',...
	'CallBack',['globalcolortypeofcall=5;indexnum=4;hold_datavar=axisbackgroundcolor;',...
		'[axisbackgroundcolor,nullvalue]=modcolor(hold_datavar,0,globalcolortypeofcall,numoffigs,figanddatawin,indexnum);']);

axisbackgroundcolor(5,numoffigs)=uimenu(axisbackcolor(numoffigs),...
	'Label','&Yellow',...
	'Separator','on',...
	'Checked','off',...
	'CallBack',['globalcolortypeofcall=5;indexnum=5;hold_datavar=axisbackgroundcolor;',...
		'[axisbackgroundcolor,nullvalue]=modcolor(hold_datavar,0,globalcolortypeofcall,numoffigs,figanddatawin,indexnum);']);



axisbackgroundcolor(6,numoffigs)=uimenu(axisbackcolor(numoffigs),...
	'Label','&Cyan',...
	'Separator','on',...
	'Checked','off',...
	'CallBack',['globalcolortypeofcall=5;indexnum=6;hold_datavar=axisbackgroundcolor;',...
		'[axisbackgroundcolor,nullvalue]=modcolor(hold_datavar,0,globalcolortypeofcall,numoffigs,figanddatawin,indexnum);']);

axisbackgroundcolor(7,numoffigs)=uimenu(axisbackcolor(numoffigs),...
	'Label','&Green',...
	'Separator','on',...
	'Checked','off',...
	'CallBack',['globalcolortypeofcall=5;indexnum=7;hold_datavar=axisbackgroundcolor;',...
		'[axisbackgroundcolor,nullvalue]=modcolor(hold_datavar,0,globalcolortypeofcall,numoffigs,figanddatawin,indexnum);']);


axisbackgroundcolor(8,numoffigs)=uimenu(axisbackcolor(numoffigs),...
	'Label','&Black',...
	'Separator','on',...
	'Checked','off',...
	'CallBack',['globalcolortypeofcall=5;indexnum=8;hold_datavar=axisbackgroundcolor;',...
		'[axisbackgroundcolor,nullvalue]=modcolor(hold_datavar,0,globalcolortypeofcall,numoffigs,figanddatawin,indexnum);']);
