% Version 1.0 of ProPlot 1.0
%
%    // dataaxs2.m \\
%
%     Scott Keane
%  skeane@uceng.uc.edu
%
%
% *****************************************
% Matlab script to add a menu driven 
% axis control
% *****************************************


% ****************************************************************
% ***************** Axis Font ************************************
% ****************************************************************


axisfontmenu(numoffigs)=uimenu(axisdata(numoffigs),...
	'Label','&Font',...
	'Checked','off',...
	'Separator','on');

% ############# Axis Font ###################################

axisfont(1,numoffigs)=uimenu(axisfontmenu(numoffigs),...
	'Label','Times New &Roman',...
	'Checked','off',...
	'Separator','off',...
	'CallBack',['globalfonttypeofcall=3;indexnum=1;hold_datavar=axisfont;',...
		'[axisfont,nullvalue]=modfont(hold_datavar,0,globalfonttypeofcall,numoffigs,figanddatawin,indexnum);']);


% ############# Axis Font ###################################

axisfont(2,numoffigs)=uimenu(axisfontmenu(numoffigs),...
	'Label','&Terminal',...
	'Checked','off',...
	'Separator','on',...
	'CallBack',['globalfonttypeofcall=3;indexnum=2;hold_datavar=axisfont;',...
		'[axisfont,nullvalue]=modfont(hold_datavar,0,globalfonttypeofcall,numoffigs,figanddatawin,indexnum);']);

% ############# Axis Font ###################################

axisfont(3,numoffigs)=uimenu(axisfontmenu(numoffigs),...
	'Label','&System',...
	'Checked','off',...
	'Separator','on',...
	'CallBack',['globalfonttypeofcall=3;indexnum=3;hold_datavar=axisfont;',...
		'[axisfont,nullvalue]=modfont(hold_datavar,0,globalfonttypeofcall,numoffigs,figanddatawin,indexnum);']);


% ############# Axis Font ###################################

axisfont(4,numoffigs)=uimenu(axisfontmenu(numoffigs),...
	'Label','MS S&erif',...
	'Checked','off',...
	'Separator','on',...
	'CallBack',['globalfonttypeofcall=3;indexnum=4;hold_datavar=axisfont;',...
		'[axisfont,nullvalue]=modfont(hold_datavar,0,globalfonttypeofcall,numoffigs,figanddatawin,indexnum);']);


% ############# Axis Font ###################################

axisfont(5,numoffigs)=uimenu(axisfontmenu(numoffigs),...
	'Label','MS Sans Ser&if',...
	'Checked','off',...
	'Separator','on',...
	'CallBack',['globalfonttypeofcall=3;indexnum=5;hold_datavar=axisfont;',...
		'[axisfont,nullvalue]=modfont(hold_datavar,0,globalfonttypeofcall,numoffigs,figanddatawin,indexnum);']);


% ############# Axis Font ###################################

axisfont(6,numoffigs)=uimenu(axisfontmenu(numoffigs),...
	'Label','&Modern',...
	'Checked','off',...
	'Separator','on',...
	'CallBack',['globalfonttypeofcall=3;indexnum=6;hold_datavar=axisfont;',...
		'[axisfont,nullvalue]=modfont(hold_datavar,0,globalfonttypeofcall,numoffigs,figanddatawin,indexnum);']);


% ############# Axis Font ###################################

axisfont(7,numoffigs)=uimenu(axisfontmenu(numoffigs),...
	'Label','&Fixedsys',...
	'Checked','off',...
	'Separator','on',...
	'CallBack',['globalfonttypeofcall=3;indexnum=7;hold_datavar=axisfont;',...
		'[axisfont,nullvalue]=modfont(hold_datavar,0,globalfonttypeofcall,numoffigs,figanddatawin,indexnum);']);


% ############# Axis Font ###################################

axisfont(8,numoffigs)=uimenu(axisfontmenu(numoffigs),...
	'Label','&Courier',...
	'Checked','off',...
	'Separator','on',...
	'CallBack',['globalfonttypeofcall=3;indexnum=8;hold_datavar=axisfont;',...
		'[axisfont,nullvalue]=modfont(hold_datavar,0,globalfonttypeofcall,numoffigs,figanddatawin,indexnum);']);


% ############# Axis Font ###################################

axisfont(9,numoffigs)=uimenu(axisfontmenu(numoffigs),...
	'Label','Courier &New',...
	'Checked','off',...
	'Separator','on',...
	'CallBack',['globalfonttypeofcall=3;indexnum=9;hold_datavar=axisfont;',...
		'[axisfont,nullvalue]=modfont(hold_datavar,0,globalfonttypeofcall,numoffigs,figanddatawin,indexnum);']);


% ############# Axis Font ###################################

axisfont(10,numoffigs)=uimenu(axisfontmenu(numoffigs),...
	'Label','&Arial',...
	'Checked','off',...
	'Separator','on',...
	'CallBack',['globalfonttypeofcall=3;indexnum=10;hold_datavar=axisfont;',...
		'[axisfont,nullvalue]=modfont(hold_datavar,0,globalfonttypeofcall,numoffigs,figanddatawin,indexnum);']);


% ############# Axis Font ###################################

axisfont(11,numoffigs)=uimenu(axisfontmenu(numoffigs),...
	'Label','&Helvetica',...
	'Checked','off',...
	'Separator','on',...
	'CallBack',['globalfonttypeofcall=3;indexnum=11;hold_datavar=axisfont;',...
		'[axisfont,nullvalue]=modfont(hold_datavar,0,globalfonttypeofcall,numoffigs,figanddatawin,indexnum);']);






% ****************************************************************
% ***************** Axis Font Size *******************************
% ****************************************************************


axisfontsizemenu(numoffigs)=uimenu(axisdata(numoffigs),...
	'Label','&Font Size',...
	'Checked','off',...
	'Separator','on');

% ############# Axis Font ###################################

axisfontsize(1,numoffigs)=uimenu(axisfontsizemenu(numoffigs),...
	'Label','&8',...
	'Checked','off',...
	'Separator','off',...
	'CallBack',['globalfontsizetypeofcall=3;indexnum=1;hold_datavar=axisfontsize;',...
		'[axisfontsize,nullvalue]=modsize(hold_datavar,0,globalfontsizetypeofcall,numoffigs,figanddatawin,indexnum);']);



% ############# Axis Font ###################################

axisfontsize(2,numoffigs)=uimenu(axisfontsizemenu(numoffigs),...
	'Label','&9',...
	'Checked','off',...
	'Separator','on',...
	'CallBack',['globalfontsizetypeofcall=3;indexnum=2;hold_datavar=axisfontsize;',...
		'[axisfontsize,nullvalue]=modsize(hold_datavar,0,globalfontsizetypeofcall,numoffigs,figanddatawin,indexnum);']);


% ############# Axis Font ###################################

axisfontsize(3,numoffigs)=uimenu(axisfontsizemenu(numoffigs),...
	'Label','1&0',...
	'Checked','off',...
	'Separator','on',...
	'CallBack',['globalfontsizetypeofcall=3;indexnum=3;hold_datavar=axisfontsize;',...
		'[axisfontsize,nullvalue]=modsize(hold_datavar,0,globalfontsizetypeofcall,numoffigs,figanddatawin,indexnum);']);


% ############# Axis Font ###################################

axisfontsize(4,numoffigs)=uimenu(axisfontsizemenu(numoffigs),...
	'Label','1&1',...
	'Checked','off',...
	'Separator','on',...
	'CallBack',['globalfontsizetypeofcall=3;indexnum=4;hold_datavar=axisfontsize;',...
		'[axisfontsize,nullvalue]=modsize(hold_datavar,0,globalfontsizetypeofcall,numoffigs,figanddatawin,indexnum);']);



% ############# Axis Font ###################################

axisfontsize(5,numoffigs)=uimenu(axisfontsizemenu(numoffigs),...
	'Label','1&2',...
	'Checked','off',...
	'Separator','on',...
	'CallBack',['globalfontsizetypeofcall=3;indexnum=5;hold_datavar=axisfontsize;',...
		'[axisfontsize,nullvalue]=modsize(hold_datavar,0,globalfontsizetypeofcall,numoffigs,figanddatawin,indexnum);']);


% ############# Axis Font ###################################

axisfontsize(6,numoffigs)=uimenu(axisfontsizemenu(numoffigs),...
	'Label','1&3',...
	'Checked','off',...
	'Separator','on',...
	'CallBack',['globalfontsizetypeofcall=3;indexnum=6;hold_datavar=axisfontsize;',...
		'[axisfontsize,nullvalue]=modsize(hold_datavar,0,globalfontsizetypeofcall,numoffigs,figanddatawin,indexnum);']);


% ############# Axis Font ###################################

axisfontsize(7,numoffigs)=uimenu(axisfontsizemenu(numoffigs),...
	'Label','1&4',...
	'Checked','off',...
	'Separator','on',...
	'CallBack',['globalfontsizetypeofcall=3;indexnum=7;hold_datavar=axisfontsize;',...
		'[axisfontsize,nullvalue]=modsize(hold_datavar,0,globalfontsizetypeofcall,numoffigs,figanddatawin,indexnum);']);


% ############# Axis Font ###################################

axisfontsize(8,numoffigs)=uimenu(axisfontsizemenu(numoffigs),...
	'Label','1&5',...
	'Checked','off',...
	'Separator','on',...
	'CallBack',['globalfontsizetypeofcall=3;indexnum=8;hold_datavar=axisfontsize;',...
		'[axisfontsize,nullvalue]=modsize(hold_datavar,0,globalfontsizetypeofcall,numoffigs,figanddatawin,indexnum);']);


% ############# Axis Font ###################################

axisfontsize(9,numoffigs)=uimenu(axisfontsizemenu(numoffigs),...
	'Label','1&6',...
	'Checked','off',...
	'Separator','on',...
	'CallBack',['globalfontsizetypeofcall=3;indexnum=9;hold_datavar=axisfontsize;',...
		'[axisfontsize,nullvalue]=modsize(hold_datavar,0,globalfontsizetypeofcall,numoffigs,figanddatawin,indexnum);']);


% ############# Axis Font ###################################

axisfontsize(10,numoffigs)=uimenu(axisfontsizemenu(numoffigs),...
	'Label','1&7',...
	'Checked','off',...
	'Separator','on',...
	'CallBack',['globalfontsizetypeofcall=3;indexnum=10;hold_datavar=axisfontsize;',...
		'[axisfontsize,nullvalue]=modsize(hold_datavar,0,globalfontsizetypeofcall,numoffigs,figanddatawin,indexnum)']);