% Version 1.0 of ProPlot 1.0
%
%    // datagrid.m \\
%
%     Scott Keane
%  skeane@uceng.uc.edu
%
%
% *****************************************
% Matlab script to add a grid control options
% *****************************************



gridyn(numoffigs)=uimenu(figanddatawin(1,numoffigs),...
	'Label','G&rid',...
	'CallBack','');

gridx(numoffigs)=uimenu(gridyn(numoffigs),...
	'Label','&X Only',...
	'CallBack',['for bb=1:numoffigs,if figanddatawin(1,bb)==gcf,',...
		'currentfigurenum=bb;end,end,',...
		'testing=get(gridx(currentfigurenum),''Checked'');',...		
		'if length(testing)==3,',...
			'set(gca,''XGrid'',''on'');',...
			'set(gca,''YGrid'',''off'');',...
			'set(gca,''YGrid'',''off'');',...
			'set(gridx(currentfigurenum),''Checked'',''on'');',...
			'set(gridyn(currentfigurenum),''Checked'',''on'');',...
			'set(gridstyle(currentfigurenum),''Enable'',''on'');',...
			'set(grid1(currentfigurenum),''Value'',0);',...
			'set(grid2(currentfigurenum),''Value'',0);',...
		'else,',...
			'set(gca,''XGrid'',''off'');',...
			'set(gridx(currentfigurenum),''Checked'',''off'');',...
			'set(gridyn(currentfigurenum),''Checked'',''off'');',...
			'set(gridstyle(currentfigurenum),''Enable'',''off'');',...
		'end,',...
		'set(gridy(currentfigurenum),''Checked'',''off'');',...
		'set(gridboth(currentfigurenum),''Checked'',''off'')']);

gridy(numoffigs)=uimenu(gridyn(numoffigs),...
	'Label','&Y Only',...
	'Separator','on',...
	'CallBack',['for bb=1:numoffigs,if figanddatawin(1,bb)==gcf,',...
		'currentfigurenum=bb;end,end,',...
		'testing=get(gridy(currentfigurenum),''Checked'');',...
		'if length(testing)==3,',...
			'set(gca,''YGrid'',''on'');',...
			'set(gca,''XGrid'',''off'');',...
			'set(gca,''XGrid'',''off'');',...
			'set(gridy(currentfigurenum),''Checked'',''on'');',...
			'set(gridyn(currentfigurenum),''Checked'',''on'');',...
			'set(gridstyle(currentfigurenum),''Enable'',''on'');',...
			'set(grid1(currentfigurenum),''Value'',0);',...
			'set(grid2(currentfigurenum),''Value'',0);',...
		'else,',...
			'set(gca,''YGrid'',''off'');',...
			'set(gridy(currentfigurenum),''Checked'',''off'');',...
			'set(gridyn(currentfigurenum),''Checked'',''off'');',...
			'set(gridstyle(currentfigurenum),''Enable'',''off'');',...
		'end,',...
		'set(gridx(currentfigurenum),''Checked'',''off'');',...
		'set(gridboth(currentfigurenum),''Checked'',''off'')']);

gridboth(numoffigs)=uimenu(gridyn(numoffigs),...
	'Label','&Both X and Y',...
	'Separator','on',...
	'CallBack',['for bb=1:numoffigs,if figanddatawin(1,bb)==gcf,',...
		'currentfigurenum=bb;end,end,',...
		'testing=get(gridboth(currentfigurenum),''Checked'');',...
		'if length(testing)==3,',...
			'set(gca,''XGrid'',''on'');',...
			'set(gca,''YGrid'',''on'');',...
			'set(gridx(currentfigurenum),''Checked'',''off'');',...
			'set(gridy(currentfigurenum),''Checked'',''off'');',...
			'set(gridboth(currentfigurenum),''Checked'',''on'');',...
			'set(gridyn(currentfigurenum),''Checked'',''on'');',...
			'set(gridstyle(currentfigurenum),''Enable'',''on'');',...
			'set(grid1(currentfigurenum),''Value'',1);',...
			'set(grid2(currentfigurenum),''Value'',1);',...
		'else,',...
			'set(gca,''XGrid'',''off'');',...
			'set(gca,''YGrid'',''off'');',...
			'set(gridx(currentfigurenum),''Checked'',''off'');',...
			'set(gridy(currentfigurenum),''Checked'',''off'');',...
			'set(gridboth(currentfigurenum),''Checked'',''off'');',...
			'set(gridyn(currentfigurenum),''Checked'',''off'');',...
			'set(gridstyle(currentfigurenum),''Enable'',''off'');',...
			'set(grid1(currentfigurenum),''Value'',0);',...
			'set(grid2(currentfigurenum),''Value'',0);',...
		'end;']);


gridstyle(numoffigs)=uimenu(gridyn(numoffigs),...
	'Label','&Style',...
	'Enable','off',...
	'Separator','on');

dottedgrid(numoffigs)=uimenu(gridstyle(numoffigs),...
	'Label','dotted',...
	'Checked','off',...
	'CallBack',['for bb=1:numoffigs,if figanddatawin(1,bb)==gcf,',...
		'currentfigurenum=bb;end,end,',...
		'testing=get(dottedgrid(currentfigurenum),''Checked'');',...
		'if length(testing)==3,',...
			'set(gca,''GridLineStyle'','':'');',...
			'set(solidgrid(currentfigurenum),''Checked'',''off'');',...
			'set(dashedgrid(currentfigurenum),''Checked'',''off'');',...
			'set(dashdotgrid(currentfigurenum),''Checked'',''off'');',...
			'set(dottedgrid(currentfigurenum),''Checked'',''on'');',...
		'else,',...
			'set(dottedgrid(currentfigurenum),''Checked'',''on'');',...
		'end;']);


solidgrid(numoffigs)=uimenu(gridstyle(numoffigs),...
	'Label','solid',...
	'Separator','on',...
	'Checked','off',...
	'CallBack',['for bb=1:numoffigs,if figanddatawin(1,bb)==gcf,',...
		'currentfigurenum=bb;end,end,',...
		'testing=get(solidgrid(currentfigurenum),''Checked'');',...
		'if length(testing)==3,',...
			'set(gca,''GridLineStyle'',''-'');',...
			'set(solidgrid(currentfigurenum),''Checked'',''on'');',...
			'set(dashedgrid(currentfigurenum),''Checked'',''off'');',...
			'set(dashdotgrid(currentfigurenum),''Checked'',''off'');',...
			'set(dottedgrid(currentfigurenum),''Checked'',''off'');',...
		'else,',...
			'set(solidgrid(currentfigurenum),''Checked'',''on'');',...
		'end;']);


dashedgrid(numoffigs)=uimenu(gridstyle(numoffigs),...
	'Label','dashed',...
	'Separator','on',...
	'Checked','off',...
	'CallBack',['for bb=1:numoffigs,if figanddatawin(1,bb)==gcf,',...
		'currentfigurenum=bb;end,end,',...
		'testing=get(dashedgrid(currentfigurenum),''Checked'');',...
		'if length(testing)==3,',...
			'set(gca,''GridLineStyle'',''--'');',...
			'set(solidgrid(currentfigurenum),''Checked'',''off'');',...
			'set(dashedgrid(currentfigurenum),''Checked'',''on'');',...
			'set(dashdotgrid(currentfigurenum),''Checked'',''off'');',...
			'set(dottedgrid(currentfigurenum),''Checked'',''off'');',...
		'else,',...
			'set(dashedgrid(currentfigurenum),''Checked'',''on'');',...
		'end;']);


dashdotgrid(numoffigs)=uimenu(gridstyle(numoffigs),...
	'Label','dashdot',...
	'Separator','on',...
	'Checked','off',...
	'CallBack',['for bb=1:numoffigs,if figanddatawin(1,bb)==gcf,',...
		'currentfigurenum=bb;end,end,',...
		'testing=get(dashdotgrid(currentfigurenum),''Checked'');',...
		'if length(testing)==3,',...
			'set(gca,''GridLineStyle'',''-.'');',...
			'set(solidgrid(currentfigurenum),''Checked'',''off'');',...
			'set(dashedgrid(currentfigurenum),''Checked'',''off'');',...
			'set(dashdotgrid(currentfigurenum),''Checked'',''on'');',...
			'set(dottedgrid(currentfigurenum),''Checked'',''off'');',...
		'else,',...
			'set(dashdotgrid(currentfigurenum),''Checked'',''on'');',...
		'end;']);

