% Version 1.0 of ProPlot 1.0
%
%    // zoommake.m \\
%
%     Scott Keane
%  skeane@uceng.uc.edu
%
%
% *****************************************
% Matlab script to store a history of axis 
% scales and create a uimenu file zoomio.m
% *****************************************



% ***********************************************
% ************ Switch to onthefly directory *******
% ***********************************************

profly




[fid]=fopen('zoomio.m','wt');


fprintf(fid,'%% *********************************************************\n');
fprintf(fid,'%% **********   File Created by ProPlot 1.0   **************\n');
fprintf(fid,'%% *********************************************************\n');
fprintf(fid,'%% ---------------------------------------------------------\n');
fprintf(fid,'%% *************** ProPlot written by **********************\n');
fprintf(fid,'%% ********Scott Keane (skeane@uceng.uc.edu) ***************\n');
fprintf(fid,'%% ---------------------------------------------------------\n');
data=clock;
fprintf(fid,'%% ******* File written at %i:%i on %i-%i-%i *************** \n',data(1,4),data(1,5),data(1,2),data(1,3),data(1,1));
fprintf(fid,'%% *********************************************************\n');
fprintf(fid,'%% *********************************************************\n');


stop=1;
if exist('zoomoutchoice') ==0 % first run?
	nextnum=1;
	zoommat=zeros(10,200);
	zoommat(currentfigurenum,1:4)=[axis];
	%fprintf('Executed initial loop!!');
	stop=0;
end

% ***************************************************************
% ************ assign zoommat a value only if unique ************
% ***************************************************************

if stop==1
	% ******
	sizezochoice=size(zoomoutchoice);	
	lengthzochoice=sizezochoice(1,2);
	heightzochoice=sizezochoice(1,1);
	zoomans=existfun(zoomoutchoice);
	for cc=1:numoffigs
		for aa=1:lengthzochoice
			if zoomans(cc,aa)~=-1
				if zoomoutchoice(cc,aa)~=0
					delete(zoomoutchoice(cc,aa));	
					zoomoutchoice(cc,aa)=0;
				end
			end
			if heightzochoice >= cc+10
				if zoomans(cc+10,aa)~=-1
					if zoomoutchoice(cc+10,aa)~=0
						delete(zoomoutchoice(cc+10,aa));
						zoomoutchoice(cc+10,aa)=0;
					end
				end
			end
		end
	end
	%fprintf('\n Executing assign loop!!!! \n');
	flag=1;
	flag1=1;
	axisunique=1;
	for longji=1:50
		if flag==1
			if zoommat(currentfigurenum,(4.*longji-3):(4.*longji-3)+3)==zeros(1,4) % found first zero quad
				for midship=1:longji-1
					if flag1==1
						if zoommat(currentfigurenum,(4.*midship-3):(4.*midship-3)+3)==axis %duplicates existing data on current figure			
							axisunique=0;
							flag1=0;
						end
					end
				end
				if axisunique==1 % does not duplicate data on current figure
					zoommat(currentfigurenum,(4.*longji-3):(4.*longji-3)+3)=axis;
					flag=0;
				end			
			end
		end
	end
end

% *************************************************************
% ******************** set up nextnum matrix ******************
% *************************************************************


%fprintf('Executing nextnum matrix');
for haji=1:10
	flag=1;
	for longji=1:50
		if flag==1
			if zoommat(haji,(4.*longji-3):(4.*longji-3)+3)==zeros(1,4);
				datanum(haji,1)=longji-1;
				flag=0;
			end
		end
	end
end


% *************************************************************
% ******************** set up a single row matrix *************
% *************************************************************
linzoommat=[];
for haji=1:10
	for tamb=1:datanum(haji,1)
		linzoommat=[linzoommat zoommat(haji,(4.*tamb-3):(4.*tamb-3)+3)];
	end
end


% *************************************************************
% ******************** disect datanum for fig list *************
% *************************************************************
figlist=[];
for bar=1:length(datanum)
	figlist=[figlist ,bar.*ones(1,datanum(bar,1))];
end


% *************************************************************
% ******************** begin file write ***********************
% *************************************************************


for tsch=1:numoffigs
	timesrun=0; 
	sumdatanum=datanum(1,1)+datanum(2,1)+datanum(3,1)+datanum(4,1)+datanum(5,1)+datanum(6,1)+datanum(7,1)+datanum(8,1)+datanum(9,1)+datanum(10,1);
	for tatertot=1:sumdatanum
		timesrun=timesrun+1;
		fprintf(fid,'\n\nzoomoutchoice(%i,%i)=uimenu(zoomout(%i),...',(tsch+(tsch-1).*10)-(tsch-1),timesrun,tsch);
		
		fprintf(fid,'\n\t\t''Label'',''X=[%0.2f %0.2f]  Y=[%0.2f %0.2f]\t(Fig%i)'',...',linzoommat(1,4.*timesrun-3),linzoommat(1,(4.*timesrun-3)+1),linzoommat(1,(4.*timesrun-3)+2),linzoommat(1,(4.*timesrun-3)+3),figlist(1,timesrun));

		if timesrun==1
			fprintf(fid,'\n\t\t''Separator'',''off'',...');
		else
			fprintf(fid,'\n\t\t''Separator'',''on'',...');
		end
	
		fprintf(fid,'\n\t\t''CallBack'',[''for bb=1:numoffigs,if figanddatawin(1,bb)==gcf,'',...');
		fprintf(fid,'\n\t\t\t''currentfigurenum=bb;end,end,'',...');
		fprintf(fid,'\n\t\t\t''testing=get(zoomoutchoice(currentfigurenum+%i,%i),''''Checked'''');'',...',(tsch-1).*9,timesrun);

		fprintf(fid,'\n\t\t\t''if length(testing)==3,'',...');
		fprintf(fid,'\n\t\t\t\t''set(zoomoutchoice(currentfigurenum+%i,%i),''''Checked'''',''''on'''');'',...',(tsch-1).*9,timesrun);
	

		% for loop turn remaining off

		if timesrun==1
			for mandm=2:sumdatanum
				fprintf(fid,'\n\t\t\t\t''set(zoomoutchoice(currentfigurenum+%i,%i),''''Checked'''',''''off'''');'',...',(tsch-1).*9,mandm);
			end
		elseif timesrun==nextnum
			for mandm=1:sumdatanum-1
				fprintf(fid,'\n\t\t\t\t''set(zoomoutchoice(currentfigurenum+%i,%i),''''Checked'''',''''off'''');'',...',(tsch-1).*9,mandm);
			end
		else
			for mandm=1:timesrun-1
				fprintf(fid,'\n\t\t\t\t''set(zoomoutchoice(currentfigurenum+%i,%i),''''Checked'''',''''off'''');'',...',(tsch-1).*9,mandm);
			end
			for mandm=timesrun+1:sumdatanum
				fprintf(fid,'\n\t\t\t\t''set(zoomoutchoice(currentfigurenum+%i,%i),''''Checked'''',''''off'''');'',...',(tsch-1).*9,mandm);
			end
		end




		fprintf(fid,'\n\t\t\t\t''axis([%i %i  %i %i]);'',...',linzoommat(1,4.*timesrun-3),linzoommat(1,(4.*timesrun-3)+1),linzoommat(1,(4.*timesrun-3)+2),linzoommat(1,(4.*timesrun-3)+3));
		fprintf(fid,'\n\t\t\t''else,'',...');
		fprintf(fid,'\n\t\t\t\t''set(zoomoutchoice(currentfigurenum+%i,%i),''''Checked'''',''''on'''');'',...',(tsch-1).*9,timesrun);
		fprintf(fid,'\n\t\t\t''end,'']);');	
		
			
	end
end


fclose(fid);



% ***********************************************
% ************ Switch to proplot directory ******
% ***********************************************


prodir