% Version 1.0 of ProPlot 1.0
%
%    // datalin1.m \\
%
%     Scott Keane
%  skeane@uceng.uc.edu
%
% Created on: 10:43 AM 3/24/96
% Last Modifed: 12:52 PM 6/23/96
%
% *****************************************
% Matlab script to add menu to create 
% horizontal and vertical lines and modify
% single line colors
% *****************************************

linesmenu(numoffigs)=uimenu(goodies(numoffigs),...
	'Separator','off',...
	'Label','&Lines');

% *****************************************************************
% ********** HORIZONTAL LINES *********************************
% *****************************************************************

horline(numoffigs)=uimenu(linesmenu(numoffigs),...
	'Label','Create &Horizontal Line',...
	'CallBack',['for bb=1:numoffigs,if figanddatawin(1,bb)==gcf,',...
		'currentfigurenum=bb;end,end,',...
		'getaxisvalue=axis;',...
		'low=getaxisvalue(1,1);high=getaxisvalue(1,2);',...
		'if timer~=0;',...
			'messtext=''Select a y-value for line'';',...
			'typeofcall=1;',...
			'messfun(typeofcall,messtext,currentfigurenum);',...
		'end;',...
		'[noth constant]=ginput(1);',...
		'typeofcall=1;',...% from ProPlot(Hor)
		'linecre(typeofcall,0,0,low,high,constant,currentfigurenum);']);



% *****************************************************************
% ********** VERTICAL LINES *********************************
% *****************************************************************

verline(numoffigs)=uimenu(linesmenu(numoffigs),...
	'Label','Create &Vertical Line',...
	'Separator','on',...
	'CallBack',['for bb=1:numoffigs,if figanddatawin(1,bb)==gcf,',...
		'currentfigurenum=bb;end,end,',...
		'getaxisvalue=axis;',...
		'low=getaxisvalue(1,3);high=getaxisvalue(1,4);',...
		'if timer~=0;',...
			'messtext=''Select a x-value for line'';',...
			'typeofcall=1;',...
			'messfun(typeofcall,messtext,currentfigurenum);',...
		'end;',...
		'[constant noth]=ginput(1);',...
		'typeofcall=3;',...% from ProPlot(Vert)
		'linecre(typeofcall,0,0,low,high,constant,currentfigurenum);']);


		

% *************************************************************
% **************** Lines Color ********************************
% *************************************************************

modifylinessingle(numoffigs)=uimenu(linesmenu(numoffigs),...
	'Label','Modify &Single',...
	'Enable','off',...
	'Separator','on');


modifylinesall(numoffigs)=uimenu(linesmenu(numoffigs),...
	'Label','Modify &All',...
	'Enable','off',...
	'Separator','on');


colorlinessingle(numoffigs)=uimenu(modifylinessingle(numoffigs),...
	'Label','&Color');

% ***************************************************************

linebacksingle(1,numoffigs)=uimenu(colorlinessingle(numoffigs),...
	'Label','&White',...
	'Checked','off',...
	'CallBack',['globalcolortypeofcall=5;indexnum=1;hold_datavar=linesmart;',...
		'[linesmart]=entcolor(hold_datavar,numoffigs,globalcolortypeofcall,indexnum,winsize_figure_width,figanddatawin);']);

% ############# Lines Color ###################################

linebacksingle(2,numoffigs)=uimenu(colorlinessingle(numoffigs),...
	'Label','&Blue',...
	'Separator','on',...
	'Checked','off',...
	'CallBack',['globalcolortypeofcall=5;indexnum=2;hold_datavar=linesmart;',...
		'[linesmart]=entcolor(hold_datavar,numoffigs,globalcolortypeofcall,indexnum,winsize_figure_width,figanddatawin);']);

% ############# Lines Color ###################################

linebacksingle(3,numoffigs)=uimenu(colorlinessingle(numoffigs),...
	'Label','&Magenta',...
	'Separator','on',...
	'Checked','off',...
	'CallBack',['globalcolortypeofcall=5;indexnum=3;hold_datavar=linesmart;',...
		'[linesmart]=entcolor(hold_datavar,numoffigs,globalcolortypeofcall,indexnum,winsize_figure_width,figanddatawin);']);

% ############# Lines Color ###################################

linebacksingle(4,numoffigs)=uimenu(colorlinessingle(numoffigs),...
	'Label','&Red',...
	'Separator','on',...
	'Checked','off',...
	'CallBack',['globalcolortypeofcall=5;indexnum=4;hold_datavar=linesmart;',...
		'[linesmart]=entcolor(hold_datavar,numoffigs,globalcolortypeofcall,indexnum,winsize_figure_width,figanddatawin);']);

% ############# Lines Color ###################################

linebacksingle(5,numoffigs)=uimenu(colorlinessingle(numoffigs),...
	'Label','&Yellow',...
	'Separator','on',...
	'Checked','off',...
	'CallBack',['globalcolortypeofcall=5;indexnum=5;hold_datavar=linesmart;',...
		'[linesmart]=entcolor(hold_datavar,numoffigs,globalcolortypeofcall,indexnum,winsize_figure_width,figanddatawin);']);

% ############# Lines Color ###################################

linebacksingle(6,numoffigs)=uimenu(colorlinessingle(numoffigs),...
	'Label','&Cyan',...
	'Separator','on',...
	'Checked','off',...
	'CallBack',['globalcolortypeofcall=5;indexnum=6;hold_datavar=linesmart;',...
		'[linesmart]=entcolor(hold_datavar,numoffigs,globalcolortypeofcall,indexnum,winsize_figure_width,figanddatawin);']);

% ############# Lines Color ###################################

linebacksingle(7,numoffigs)=uimenu(colorlinessingle(numoffigs),...
	'Label','&Green',...
	'Separator','on',...
	'Checked','off',...
	'CallBack',['globalcolortypeofcall=5;indexnum=7;hold_datavar=linesmart;',...
		'[linesmart]=entcolor(hold_datavar,numoffigs,globalcolortypeofcall,indexnum,winsize_figure_width,figanddatawin);']);

% ############# Lines Color ###################################

linebacksingle(8,numoffigs)=uimenu(colorlinessingle(numoffigs),...
	'Label','&Black',...
	'Separator','on',...
	'Checked','off',...
	'CallBack',['globalcolortypeofcall=5;indexnum=8;hold_datavar=linesmart;',...
		'[linesmart]=entcolor(hold_datavar,numoffigs,globalcolortypeofcall,indexnum,winsize_figure_width,figanddatawin);']);
