% Version 1.0 of ProPlot 1.0
%
%    // datarmv.m \\
%
%     Scott Keane
%  skeane@uceng.uc.edu
%
%
% *****************************************
% Matlab script to add a menu driven 
% hor and ver line removal control
% *****************************************


% ****************************************************************
% ********************** Remove Single ***************************
% ****************************************************************

removelinessingle(numoffigs)=uimenu(modifylinessingle(numoffigs),...
	'Label','&Remove Single',...
	'Separator','on',...
	'CallBack',['for bb=1:numoffigs,if figanddatawin(1,bb)==gcf,',...
		'currentfigurenum=bb;end,end,',...
		'dumaxis=axis;',...
		'stamat=1+(currentfigurenum-1).*11;',...
					'hold_datavar=linesmart;typeofcall=2;',... % call function to highlight entities
					'[smartcircle,countcircle,tempcircle]=entselec(hold_datavar,stamat,typeofcall);',...
		'if countcircle~=1,',...
		'if timer~=0;',...
			'messtext=''Select line to remove'';',...
			'typeofcall=1;',...
			'messfun(typeofcall,messtext,currentfigurenum);',...
		'end;',...
		'[numberofwinner]=closest(smartcircle);',...% determine which one to delete
		'delete(linesmart(smartcircle(numberofwinner,3),stamat));',...
		'delete(tempcircle);clear tempcircle;',...
		'if smartcircle(numberofwinner,3)==1 & (countcircle-1) > 1,',...
			'linesmart(1:countcircle-2,stamat:stamat+9)=linesmart(2:countcircle-1,stamat:stamat+9);',...
			'linesmart(countcircle-1,stamat:stamat+9)=zeros(1,10);',...
		'elseif smartcircle(numberofwinner,3) > 1 & smartcircle(numberofwinner,3) < (countcircle-1),',...
			'tempupper=linesmart(1:smartcircle(numberofwinner,3)-1,stamat:stamat+9);',...
			'templower=linesmart(smartcircle(numberofwinner,3)+1:(countcircle-1),stamat:stamat+9);',...
			'linesmart(1:countcircle-2,stamat:stamat+9)=[tempupper;templower];',...
			'linesmart(countcircle-1,stamat:stamat+9)=zeros(1,10);',...
		'elseif smartcircle(numberofwinner,3)==(countcircle-1),',...
			'linesmart(smartcircle(numberofwinner,3),stamat:stamat+9)=zeros(1,10);',...
		'end,',...
		'end;',...
		'if countcircle==2;',...
			'set(modifylinessingle(currentfigurenum),''Enable'',''off'');',...
			'set(modifylinesall(currentfigurenum),''Enable'',''off'');',...
		'end;']);

			
		



		

% ****************************************************************
% ************************ Remove All ****************************
% ****************************************************************

removelinesall(numoffigs)=uimenu(modifylinesall(numoffigs),...
	'Label','Remove &All',...
	'Separator','on',...
	'CallBack',['for bb=1:numoffigs,if figanddatawin(1,bb)==gcf,',...
		'currentfigurenum=bb;end,end,',...
		'stamat=1+(currentfigurenum-1).*11;',...
		'lengthlinesmart=size(linesmart);',...
		'lengthlinesmart=lengthlinesmart(1,1);',...
		'for qw=1:lengthlinesmart,',...
			'if linesmart(qw,stamat)~=0,',...
				'delete(linesmart(qw,stamat));',...
				'linesmart(qw,stamat:stamat+9)=zeros(1,10);',...
			'end,',...
		'end,',...
		'set(modifylinessingle(currentfigurenum),''Enable'',''off'');',...
		'set(modifylinesall(currentfigurenum),''Enable'',''off'');']);
	



