function linecre(typeofcall,opt_color,opt_ltype,low,high,constant,currentfigurenum)

% Version 1.0 of ProPlot 1.0
%
%    // linecre.m \\
%
%     Scott Keane
%  skeane@uceng.uc.edu
%
%  Created on: 7:32 PM 6/19/96
%  Last Modified on: 11:39 AM 6/23/96
%
% Called by: buildfun.m,datalin1.m
%
% *****************************************
% Matlab function to create horizontal and 
% vertical lines on a plot.
% *****************************************

global linesmart;
global figanddatawin;
global modifylinessingle;
global modifylinesall;

stamat=1+(currentfigurenum-1).*11;
if isempty(linesmart)
	qw=1;
	dumaxis=axis;axis(dumaxis);
	if typeofcall==1 | typeofcall==2 % Horizontal Call
		hold on,linesmart(qw,stamat)=plot([low high],[constant constant]);
		linesmart(qw,stamat+1:stamat+2)=[low high];
		linesmart(qw,stamat+3:stamat+4)=[constant constant];
	elseif typeofcall==3 | typeofcall==4 % Vertical Call
		hold on;linesmart(qw,stamat)=plot([constant constant],[low high]);
		linesmart(qw,stamat+1:stamat+2)=[constant constant];
		linesmart(qw,stamat+3:stamat+4)=[low high];
	end
	linesmart(qw,stamat+5:stamat+7)=get(linesmart(qw,stamat),'Color');
	% ***********************************************************
	if typeofcall==2 | typeofcall==4 % from load command
		if opt_color==linesmart(qw,stamat+5:stamat+7),else % if different modify
			set(linesmart(qw,stamat),'Color',opt_color);
			linesmart(qw,stamat+5:stamat+7)=opt_color;
		end
	end
	% ***********************************************************

	if length(abs(get(linesmart(qw,stamat),'Linestyle')))==1		
		linesmart(qw,stamat+8:stamat+9)=[abs(get(linesmart(qw,stamat),'Linestyle')) 0];
	else
		linesmart(qw,stamat+8:stamat+9)=abs(get(linesmart(qw,stamat),'Linestyle'));
	end
	% ************************************************************
	if typeofcall==2 | typeofcall==4 % from load command
		if opt_ltype==linesmart(qw,stamat+8:stamat+9),else % if different modify
			set(linesmart(qw,stamat),'Linestyle',setstr(opt_ltype));
			linesmart(qw,stamat+8:stamat+9)=opt_ltype;
		end
	end
else
	flag=1;
	lengthlinesmart=size(linesmart);
	lengthlinesmart=lengthlinesmart(1,1);
	for qw=lengthlinesmart:-1:1
		if flag==1
			if linesmart(qw,stamat)~=0				
				dumaxis=axis;axis(dumaxis);
				if typeofcall==1 | typeofcall==2 % Horizontal Call
					hold on;linesmart(qw+1,stamat)=plot([low high],[constant constant]);
					linesmart(qw+1,stamat+1:stamat+2)=[low high];
					linesmart(qw+1,stamat+3:stamat+4)=[constant constant];
				elseif typeofcall==3 | typeofcall==4 % Vertical Call
					linesmart(qw+1,stamat)=plot([constant constant],[low high]);
					linesmart(qw+1,stamat+1:stamat+2)=[constant constant];
					linesmart(qw+1,stamat+3:stamat+4)=[low high];
				end
				% ******************************************************
				if typeofcall==1 | typeofcall==3 % from ProPlot
					getcurrcolor=linesmart(qw,stamat+5:stamat+7);						
					getcurrltype=linesmart(qw,stamat+8:stamat+9);
					set(linesmart(qw+1,stamat),'Color',getcurrcolor);					
					set(linesmart(qw+1,stamat),'Linestyle',setstr(getcurrltype));
					linesmart(qw+1,stamat+5:stamat+7)=get(linesmart(qw+1,stamat),'Color');
				elseif typeofcall==2 | typeofcall==4 % typeofcall==2 % from load command
					
					if opt_color==linesmart(qw+1,stamat+5:stamat+7),else % if different modify
						set(linesmart(qw+1,stamat),'Color',opt_color);
						linesmart(qw+1,stamat+5:stamat+7)=opt_color;
					end
				end
				% ***********************************************************
				if length(abs(get(linesmart(qw+1,stamat),'Linestyle')))==1			
					linesmart(qw+1,stamat+8:stamat+9)=[abs(get(linesmart(qw+1,stamat),'Linestyle')) 0];
				else
					linesmart(qw+1,stamat+8:stamat+9)=abs(get(linesmart(qw+1,stamat),'Linestyle'));
				end			
				% ************************************************************
				if typeofcall==2 | typeofcall==4 % from load command
					if opt_ltype==linesmart(qw+1,stamat+8:stamat+9),else % if different modify
						set(linesmart(qw+1,stamat),'Linestyle',setstr(opt_ltype));
						linesmart(qw+1,stamat+8:stamat+9)=opt_ltype;
					end
				end
 				% *************************************************************	
				flag=0;
			end
			if (linesmart(qw,stamat)==0 & qw==1)
				dumaxis=axis;axis(dumaxis);
				if typeofcall==1 | typeofcall==2 % Horizontal Line
					hold on;linesmart(qw,stamat)=plot([low high],[constant constant]);
					linesmart(qw,stamat+1:stamat+2)=[low high];
					linesmart(qw,stamat+3:stamat+4)=[constant constant];
				elseif typeofcall==3 | typeofcall==4 % Vertical Line
					hold on,linesmart(qw,stamat)=plot([constant constant],[low high]);
					linesmart(qw,stamat+1:stamat+2)=[constant constant];
					linesmart(qw,stamat+3:stamat+4)=[low high];
				end
				linesmart(qw,stamat+5:stamat+7)=get(linesmart(qw,stamat),'Color');
				% ***********************************************************
				if typeofcall==2 | typeofcall==4 % from load command
					if opt_color==linesmart(qw,stamat+5:stamat+7),else % if different modify
						set(linesmart(qw,stamat),'Color',opt_color);
						linesmart(qw,stamat+5:stamat+7)=opt_color;
					end
				end
				% ***********************************************************
				if length(abs(get(linesmart(qw,stamat),'Linestyle')))==1			
					linesmart(qw,stamat+8:stamat+9)=[abs(get(linesmart(qw,stamat),'Linestyle')) 0];
				else
					linesmart(qw,stamat+8:stamat+9)=abs(get(linesmart(qw,stamat),'Linestyle'));
				end		
				% ************************************************************
				if typeofcall==2 | typeofcall==4 % from load command
					if opt_ltype==linesmart(qw,stamat+8:stamat+9),else % if different modify
						set(linesmart(qw,stamat),'Linestyle',setstr(opt_ltype));
						linesmart(qw,stamat+8:stamat+9)=opt_ltype;
					end
				end			
				flag=0;
			end
		end
	end
end
set(modifylinessingle(currentfigurenum),'Enable','on');
set(modifylinesall(currentfigurenum),'Enable','on');

return