% Version 1.0 of ProPlot 1.0
%
%    // datatex3.m \\
%
%     Scott Keane
%  skeane@uceng.uc.edu
%
%
% *****************************************
% Matlab script to add a menu driven 
% text single fontsize and fonttype control
% *****************************************



% ****************************************************************
% ********************* Modify Text Font Type Single *************
% ****************************************************************

typetextsingle(numoffigs)=uimenu(modifytextssingle(numoffigs),...
	'Label','Font &Type',...
	'Separator','on');

% ################# Text Font Type Single ########################

textfontsin(1,numoffigs)=uimenu(typetextsingle(numoffigs),...
	'Label','Times New &Roman',...
	'Checked','off',...
	'CallBack',['globalcolortypeofcall=2;indexnum=1;hold_datavar=textsmart;',...
		'[textsmart]=entcolor(hold_datavar,numoffigs,globalcolortypeofcall,indexnum,winsize_figure_width,figanddatawin);']);


% ################# Text Font Type Single ########################


textfontsin(2,numoffigs)=uimenu(typetextsingle(numoffigs),...
	'Label','&Terminal',...
	'Checked','off',...
	'Separator','on',...
	'CallBack',['globalcolortypeofcall=2;indexnum=2;hold_datavar=textsmart;',...
		'[textsmart]=entcolor(hold_datavar,numoffigs,globalcolortypeofcall,indexnum,winsize_figure_width,figanddatawin);']);

% ################# Text Font Type Single ########################


textfontsin(3,numoffigs)=uimenu(typetextsingle(numoffigs),...
	'Label','&System',...
	'Checked','off',...
	'Separator','on',...
	'CallBack',['globalcolortypeofcall=2;indexnum=3;hold_datavar=textsmart;',...
		'[textsmart]=entcolor(hold_datavar,numoffigs,globalcolortypeofcall,indexnum,winsize_figure_width,figanddatawin);']);

% ################# Text Font Type Single ########################


textfontsin(4,numoffigs)=uimenu(typetextsingle(numoffigs),...
	'Label','MS S&erif',...
	'Checked','off',...
	'Separator','on',...
	'CallBack',['globalcolortypeofcall=2;indexnum=4;hold_datavar=textsmart;',...
		'[textsmart]=entcolor(hold_datavar,numoffigs,globalcolortypeofcall,indexnum,winsize_figure_width,figanddatawin);']);

% ################# Text Font Type Single ########################



textfontsin(5,numoffigs)=uimenu(typetextsingle(numoffigs),...
	'Label','MS Sans Ser&if',...
	'Checked','off',...
	'Separator','on',...
	'CallBack',['globalcolortypeofcall=2;indexnum=5;hold_datavar=textsmart;',...
		'[textsmart]=entcolor(hold_datavar,numoffigs,globalcolortypeofcall,indexnum,winsize_figure_width,figanddatawin);']);


% ################# Text Font Type Single ########################



textfontsin(6,numoffigs)=uimenu(typetextsingle(numoffigs),...
	'Label','&Modern',...
	'Checked','off',...
	'Separator','on',...
	'CallBack',['globalcolortypeofcall=2;indexnum=6;hold_datavar=textsmart;',...
		'[textsmart]=entcolor(hold_datavar,numoffigs,globalcolortypeofcall,indexnum,winsize_figure_width,figanddatawin);']);

% ################# Text Font Type Single ########################

textfontsin(7,numoffigs)=uimenu(typetextsingle(numoffigs),...
	'Label','&Fixedsys',...
	'Checked','off',...
	'Separator','on',...
	'CallBack',['globalcolortypeofcall=2;indexnum=7;hold_datavar=textsmart;',...
		'[textsmart]=entcolor(hold_datavar,numoffigs,globalcolortypeofcall,indexnum,winsize_figure_width,figanddatawin);']);

% ################# Text Font Type Single ########################


textfontsin(8,numoffigs)=uimenu(typetextsingle(numoffigs),...
	'Label','&Courier',...
	'Checked','off',...
	'Separator','on',...
	'CallBack',['globalcolortypeofcall=2;indexnum=8;hold_datavar=textsmart;',...
		'[textsmart]=entcolor(hold_datavar,numoffigs,globalcolortypeofcall,indexnum,winsize_figure_width,figanddatawin);']);

% ################# Text Font Type Single ########################


textfontsin(9,numoffigs)=uimenu(typetextsingle(numoffigs),...
	'Label','Courier &New',...
	'Checked','off',...
	'Separator','on',...
	'CallBack',['globalcolortypeofcall=2;indexnum=9;hold_datavar=textsmart;',...
		'[textsmart]=entcolor(hold_datavar,numoffigs,globalcolortypeofcall,indexnum,winsize_figure_width,figanddatawin);']);


% ################# Text Font Type Single ########################


textfontsin(10,numoffigs)=uimenu(typetextsingle(numoffigs),...
	'Label','&Arial',...
	'Checked','off',...
	'Separator','on',...
	'CallBack',['globalcolortypeofcall=2;indexnum=10;hold_datavar=textsmart;',...
		'[textsmart]=entcolor(hold_datavar,numoffigs,globalcolortypeofcall,indexnum,winsize_figure_width,figanddatawin);']);

% ################# Text Font Type Single ########################


textfontsin(11,numoffigs)=uimenu(typetextsingle(numoffigs),...
	'Label','&Helvetica',...
	'Checked','off',...
	'Separator','on',...
	'CallBack',['globalcolortypeofcall=2;indexnum=11;hold_datavar=textsmart;',...
		'[textsmart]=entcolor(hold_datavar,numoffigs,globalcolortypeofcall,indexnum,winsize_figure_width,figanddatawin);']);




% ****************************************************************
% ********************* Modify Font Size Single ******************
% ****************************************************************

sizetextsingle(numoffigs)=uimenu(modifytextssingle(numoffigs),...
	'Label','Font &Size',...
	'Separator','on');

% ################# Text Font Size Single ########################


textfontsizesin(1,numoffigs)=uimenu(sizetextsingle(numoffigs),...
	'Label','&8',...
	'Checked','off',...
	'CallBack',['globalcolortypeofcall=3;indexnum=1;hold_datavar=textsmart;',...
		'[textsmart]=entcolor(hold_datavar,numoffigs,globalcolortypeofcall,indexnum,winsize_figure_width,figanddatawin);']);


% ################# Text Font Size Single ########################



textfontsizesin(2,numoffigs)=uimenu(sizetextsingle(numoffigs),...
	'Label','&9',...
	'Checked','off',...	
	'Separator','on',...
	'CallBack',['globalcolortypeofcall=3;indexnum=2;hold_datavar=textsmart;',...
		'[textsmart]=entcolor(hold_datavar,numoffigs,globalcolortypeofcall,indexnum,winsize_figure_width,figanddatawin);']);



% ################# Text Font Size Single ########################



textfontsizesin(3,numoffigs)=uimenu(sizetextsingle(numoffigs),...
	'Label','1&0',...
	'Checked','off',...
	'Separator','on',...
	'CallBack',['globalcolortypeofcall=3;indexnum=3;hold_datavar=textsmart;',...
		'[textsmart]=entcolor(hold_datavar,numoffigs,globalcolortypeofcall,indexnum,winsize_figure_width,figanddatawin);']);

% ################# Text Font Size Single ########################



textfontsizesin(4,numoffigs)=uimenu(sizetextsingle(numoffigs),...
	'Label','1&1',...
	'Checked','off',...
	'Separator','on',...
	'CallBack',['globalcolortypeofcall=3;indexnum=4;hold_datavar=textsmart;',...
		'[textsmart]=entcolor(hold_datavar,numoffigs,globalcolortypeofcall,indexnum,winsize_figure_width,figanddatawin);']);


% ################# Text Font Size Single ########################



textfontsizesin(5,numoffigs)=uimenu(sizetextsingle(numoffigs),...
	'Label','1&2',...
	'Checked','off',...
	'Separator','on',...
	'CallBack',['globalcolortypeofcall=3;indexnum=5;hold_datavar=textsmart;',...
		'[textsmart]=entcolor(hold_datavar,numoffigs,globalcolortypeofcall,indexnum,winsize_figure_width,figanddatawin);']);

% ################# Text Font Size Single ########################


textfontsizesin(6,numoffigs)=uimenu(sizetextsingle(numoffigs),...
	'Label','1&3',...
	'Checked','off',...
	'Separator','on',...
	'CallBack',['globalcolortypeofcall=3;indexnum=6;hold_datavar=textsmart;',...
		'[textsmart]=entcolor(hold_datavar,numoffigs,globalcolortypeofcall,indexnum,winsize_figure_width,figanddatawin);']);


% ################# Text Font Size Single ########################



textfontsizesin(7,numoffigs)=uimenu(sizetextsingle(numoffigs),...
	'Label','1&4',...
	'Checked','off',...
	'Separator','on',...
	'CallBack',['globalcolortypeofcall=3;indexnum=7;hold_datavar=textsmart;',...
		'[textsmart]=entcolor(hold_datavar,numoffigs,globalcolortypeofcall,indexnum,winsize_figure_width,figanddatawin);']);


% ################# Text Font Size Single ########################



textfontsizesin(8,numoffigs)=uimenu(sizetextsingle(numoffigs),...
	'Label','1&5',...
	'Checked','off',...
	'Separator','on',...
	'CallBack',['globalcolortypeofcall=3;indexnum=8;hold_datavar=textsmart;',...
		'[textsmart]=entcolor(hold_datavar,numoffigs,globalcolortypeofcall,indexnum,winsize_figure_width,figanddatawin);']);


% ################# Text Font Size Single ########################



textfontsizesin(9,numoffigs)=uimenu(sizetextsingle(numoffigs),...
	'Label','1&6',...
	'Checked','off',...
	'Separator','on',...
	'CallBack',['globalcolortypeofcall=3;indexnum=9;hold_datavar=textsmart;',...
		'[textsmart]=entcolor(hold_datavar,numoffigs,globalcolortypeofcall,indexnum,winsize_figure_width,figanddatawin);']);

% ################# Text Font Size Single ########################



textfontsizesin(10,numoffigs)=uimenu(sizetextsingle(numoffigs),...
	'Label','1&7',...
	'Checked','off',...
	'Separator','on',...
	'CallBack',['globalcolortypeofcall=3;indexnum=10;hold_datavar=textsmart;',...
		'[textsmart]=entcolor(hold_datavar,numoffigs,globalcolortypeofcall,indexnum,winsize_figure_width,figanddatawin);']);
