% Version 1.0 of ProPlot 1.0
%
%    // datatex4.m \\
%
%     Scott Keane
%  skeane@uceng.uc.edu
%
%
% *****************************************
% Matlab script to add a menu driven 
% text removal control
% *****************************************

% ****************************************************************
% ********************* Remove Text Single ***********************
% ****************************************************************

removetextsingle(numoffigs)=uimenu(modifytextssingle(numoffigs),...
	'Label','&Remove Single',...
	'Separator','on',...
	'CallBack',['for bb=1:numoffigs,if figanddatawin(1,bb)==gcf,',...
		'currentfigurenum=bb;end,end,',...
		'getaxisvalue=axis;',...
		'stamat=1+(currentfigurenum-1).*24;',...
			'hold_datavar=textsmart;typeofcall=1;',... % call function to highlight entities
			'[smartcircle,countcircle,tempcircle]=entselec(hold_datavar,stamat,typeofcall);',...
		'if countcircle~=1,',...
		'if timer~=0;',...
			'messtext=''Select text to remove'';',...
			'typeofcall=1;',...
			'messfun(typeofcall,messtext,currentfigurenum);',...
		'end;',...
		'[numberofwinner]=closest(smartcircle);',...% determine which one to delete
		'delete(textsmart(smartcircle(numberofwinner,3),stamat));',...
		'delete(tempcircle);clear tempcircle;',...
		'if smartcircle(numberofwinner,3)==1 & (countcircle-1) > 1,',...
			'textsmart(1:countcircle-2,stamat:stamat+23)=textsmart(2:countcircle-1,stamat:stamat+23);',...
			'textsmart(countcircle-1,stamat:stamat+23)=zeros(1,24);',...
		'elseif smartcircle(numberofwinner,3) > 1 & smartcircle(numberofwinner,3) < (countcircle-1),',...
			'tempupper=textsmart(1:smartcircle(numberofwinner,3)-1,stamat:stamat+23);',...
			'templower=textsmart(smartcircle(numberofwinner,3)+1:(countcircle-1),stamat:stamat+23);',...
			'textsmart(1:countcircle-2,stamat:stamat+23)=[tempupper;templower];',...
			'textsmart(countcircle-1,stamat:stamat+23)=zeros(1,24);',...
		'elseif smartcircle(numberofwinner,3)==(countcircle-1),',...
			'textsmart(smartcircle(numberofwinner,3),stamat:stamat+23)=zeros(1,24);',...
		'end,',...
		'end;',...
		'if countcircle==2;',...
			'set(modifytextssingle(currentfigurenum),''Enable'',''off'');',...
			'set(modifytextsall(currentfigurenum),''Enable'',''off'');',...
		'end;']);



% ****************************************************************
% ********************* Remove Text All **************************
% ****************************************************************


removetextall(numoffigs)=uimenu(modifytextsall(numoffigs),...
	'Label','Remove &All',...
	'Separator','on',...
	'CallBack',['for bb=1:numoffigs,if figanddatawin(1,bb)==gcf,',...
		'currentfigurenum=bb;end,end,',...
		'stamat=1+(currentfigurenum-1).*24;',...
		'lengthtextsmart=size(textsmart);',...
		'lengthtextsmart=lengthtextsmart(1,1);',...
		'for qw=1:lengthtextsmart,',...
			'if textsmart(qw,stamat)~=0,',...
				'delete(textsmart(qw,stamat));',...
				'textsmart(qw,stamat:stamat+23)=zeros(1,24);',...
			'end,',...
		'end,',...
		'set(modifytextssingle(currentfigurenum),''Enable'',''off'');',...
		'set(modifytextsall(currentfigurenum),''Enable'',''off'');']);
