% Version 1.0 of ProPlot 1.0
%
%    // datatex5.m \\
%
%     Scott Keane
%  skeane@uceng.uc.edu
%
%
% *****************************************
% Matlab script to add a menu driven 
% text position control
% *****************************************




% note all pauses are only 1 second

if numoffigs==1
	row2modify=[];
	
end
uniqueoneeach(numoffigs)=0;


modifytextloc(numoffigs)=uimenu(modifytextssingle(numoffigs),...
	'Label','&Modify Text Location',...
	'Separator','on');


	
mouseclicktext(numoffigs)=uimenu(modifytextloc(numoffigs),...
	'Label','&Mouse Click',...
	'Checked','off',...
	'Separator','off',...
	'CallBack',['for bb=1:numoffigs,if figanddatawin(1,bb)==gcf,',...
		'currentfigurenum=bb;end,end,',...
		'if uniqueoneeach(currentfigurenum)~=1,',...
		'stamat=1+(currentfigurenum-1).*24;',...
			'hold_datavar=textsmart;typeofcall=1;',... % call function to highlight entities
			'[smartcircle,countcircle,tempcircle]=entselec(hold_datavar,stamat,typeofcall);',...
		'if countcircle~=1,',...
		'if timer~=0;',...
			'messtext=''Select text to modify'';',...
			'typeofcall=1;',...
			'messfun(typeofcall,messtext,currentfigurenum);',...
		'end;',...
		'[xfocus,yfocus]=ginput(1);',...
		'delete(tempcircle);clear tempcircle;',...
		'lengthsmartcircle=size(smartcircle);',...
		'lengthsmartcircle=lengthsmartcircle(1,1);',...
		'[numberofwinner]=closest(smartcircle);',...% determine which one to modify
			'row2modify(currentfigurenum)=smartcircle(numberofwinner,3);',...
			'if timer~=0;',...
			'messtext=''Select new text location(Press enter when done)'';',...
			'typeofcall=1;',...
			'messfun(typeofcall,messtext,currentfigurenum);',...
		'end;',...
			'newposx=[1];newposy=[1];',...
			'while isempty(newposx)==0;',...%run til return
				'newposx=[];newposy=[];',...
				'[newposx,newposy,but]=ginput(1);',...
				' ',...
				'if but==13;',...
					'newposx=[];newposy=[];',...
				'else;',...
				' ',...
				'newpos=[newposx newposy];',...
				'set(textsmart(row2modify(currentfigurenum),stamat),''Position'',newpos);',...
				'textsmart(row2modify(currentfigurenum),stamat+1)=newposx;',...	
				'textsmart(row2modify(currentfigurenum),stamat+2)=newposy;',...	
				'end;',...	
			'end;',...
		'end,',...
		'end']);





% ################# Modify Text Location Fine Tune ###################

finetunetext(numoffigs)=uimenu(modifytextloc(numoffigs),...
	'Label','&Fine Tune',...
	'Separator','on',...
	'Checked','off',...
	'CallBack',['for bb=1:numoffigs,if figanddatawin(1,bb)==gcf,',...
		'currentfigurenum=bb;end,end,',...
		'if uniqueoneeach(currentfigurenum)~=1,',...
		'stamat=1+(currentfigurenum-1).*24;',...
			'hold_datavar=textsmart;typeofcall=1;',... % call function to highlight entities
			'[smartcircle,countcircle,tempcircle]=entselec(hold_datavar,stamat,typeofcall);',...
		'if countcircle~=1,',...
		'if timer~=0;',...
			'messtext=''Select text to fine tune'';',...
			'typeofcall=1;',...
			'messfun(typeofcall,messtext,currentfigurenum);',...
		'end;',...
		'[numberofwinner]=closest(smartcircle);',...% determine which one to modify
		'uniqueoneeach(currentfigurenum)=1;',...
		'row2modify(currentfigurenum)=smartcircle(numberofwinner,3);',...
		'finetune;',...
		'end,',...
		'delete(tempcircle);clear tempcircle,end']);


	
