% Version 1.0 of ProPlot 1.0
%
%    // finetune.m \\
%
%     Scott Keane
%  skeane@uceng.uc.edu
%
% Created on:     5:34 PM  2/28/96
% Modified on:    6:12 AM  4/26/96
% *****************************************
% Matlab script to add sliders 
% to fine tune text location
% *****************************************



% Only run this if it is unique to current figure

s=axis;
xslidetext(currentfigurenum)=uicontrol(figanddatawin(1,currentfigurenum),...
	'Style','slider',...
	'Position',[100 130 60 20],...
	'Min',s(1,1),...
	'Max',s(1,2),...
	'Value',textsmart(row2modify(currentfigurenum),stamat+1),...
	'CallBack',['for bb=1:numoffigs,if figanddatawin(1,bb)==gcf,',...
		'currentfigurenum=bb;end,end,',...
		'stamat=1+(currentfigurenum-1).*24;',...
		'[valuex]=get(xslidetext(currentfigurenum),''Value'');',...
		'textsmart(row2modify(currentfigurenum),stamat+1)=valuex;',...
		'newpos=get(textsmart(row2modify(currentfigurenum),stamat),''Position'');',...
		'newpos=[valuex newpos(1,2:3)];',...
		'set(textsmart(row2modify(currentfigurenum),stamat),''Position'',newpos);']);
		


xtexttext(currentfigurenum)=uicontrol(figanddatawin(1,currentfigurenum),...
	'Style','text',...
	'String','x-value',...
	'Position',[100 150 60 20],...
	'ForegroundColor',[1 1 1],...
	'BackgroundColor',[0 0 0]);
	
yslidetext(currentfigurenum)=uicontrol(figanddatawin(1,currentfigurenum),...
	'Style','slider',...
	'Position',[200 130 60 20],...
	'Min',s(1,3),...
	'Max',s(1,4),...
	'Value',textsmart(row2modify(currentfigurenum),stamat+2),...
	'CallBack',['for bb=1:numoffigs,if figanddatawin(1,bb)==gcf,',...
		'currentfigurenum=bb;end,end,',...
		'stamat=1+(currentfigurenum-1).*24;',...
		'[valuey]=get(yslidetext(currentfigurenum),''Value'');',...
		'textsmart(row2modify(currentfigurenum),stamat+2)=valuey;',...
		'newpos=get(textsmart(row2modify(currentfigurenum),stamat),''Position'');',...
		'newpos=[newpos(1) valuey newpos(2)];',...
		'set(textsmart(row2modify(currentfigurenum),stamat),''Position'',newpos);']);

ytexttext(currentfigurenum)=uicontrol(figanddatawin(1,currentfigurenum),...
	'Style','text',...
	'String','y-value',...
	'Position',[200 150 60 20],...
	'ForegroundColor',[1 1 1],...
	'BackgroundColor',[0 0 0]);	

finetunetexttext(currentfigurenum)=uicontrol(figanddatawin(1,currentfigurenum),...
	'Style','text',...
	'String','x-y text fine tuning',...
	'Position',[120 170 130 20],...
	'ForegroundColor',[1 1 1],...
	'BackgroundColor',[0 0 0]);

finishedtext(currentfigurenum)=uicontrol(figanddatawin(1,currentfigurenum),...
	'Style','push',...
	'Position',[130 100 100 20],...
	'String','Dismiss',...
	'CallBack',['for bb=1:numoffigs,if figanddatawin(1,bb)==gcf,',...
		'currentfigurenum=bb;end,end,',...	
		'uniqueoneeach(currentfigurenum)=0;',...
		'delete(finetunetexttext(currentfigurenum),ytexttext(currentfigurenum),yslidetext(currentfigurenum),xtexttext(currentfigurenum),xslidetext(currentfigurenum),finishedtext(currentfigurenum))']);

set(xslidetext(currentfigurenum),'Units','normal');
set(xtexttext(currentfigurenum),'Units','normal');
set(yslidetext(currentfigurenum),'Units','normal');
set(ytexttext(currentfigurenum),'Units','normal');
set(finetunetexttext(currentfigurenum),'Units','normal');
set(finishedtext(currentfigurenum),'Units','normal');