function textfun(xtext,ytext,currentfigurenum,texttoadd,typeofcall)


% Version 1.0 of ProPlot 1.0
%
%    // textfun.m \\
%
%     Scott Keane
%  skeane@uceng.uc.edu
%
% 
% *****************************************
% Matlab function to add text 
% to a figure window.  Called by textadd.m
% and intgui.m + statrun.m + cfit1.m
% *****************************************

global textsmart;
global figanddatawin;
global winsize_figure_width;
global timer;
global row_hold;
global col_hold;

%fprintf('Running textfun!! \n')
stamat=1+(currentfigurenum-1).*24;

if typeofcall==1 | typeofcall==4 % text or roots
	getaxisvalue=axis;
	
	if timer~=0;
		messtext='Select text location';
		type=1;
		messfun(type,messtext,currentfigurenum);
	end

	[xtext ytext]=ginput(1);

elseif typeofcall==0 %int or stats 
	posdata=get(texttoadd(currentfigurenum),'Position');
	xtext=posdata(1,1);
	ytext=posdata(1,2);

elseif typeofcall==3
	% do nothing


else % cfit
	posdata=get(texttoadd(currentfigurenum),'Position');
	xtext=posdata(1,1);
	ytext=posdata(1,2);
	convert=abs(num2str(typeofcall));
	colorind=setstr(convert(1,2));
	colorind=str2num(colorind);

end

% *****************************************************************
if isempty(textsmart)
	qw=1;
	row_hold=qw;
	col_hold=stamat;
	if typeofcall~=3 & typeofcall~=4
		texttoplot=abs(get(texttoadd(currentfigurenum),'String'));
	else % load
		texttoplot=abs(texttoadd);
	end
	
	textsmart(qw,stamat)=text(xtext,ytext,setstr(texttoplot));
	% ******************************************************
	if typeofcall~=1 & typeofcall~=0 & typeofcall~=3 & typeofcall~=4 %call from cfit
		colormat=['g','m','b','r','y','c','w'];
		set(textsmart(qw,stamat),'Color',colormat(colorind));
	end
	% ******************************************************
	textsmart(qw,stamat+1:stamat+2)=[xtext ytext];
	textsmart(qw,stamat+3:stamat+5)=get(textsmart(qw,stamat),'Color');
	textsmart(qw,stamat+6)=get(textsmart(qw,stamat),'FontSize');
	fontname=abs(get(textsmart(qw,stamat),'FontName'));
	fontnamelength=length(fontname);
	fontname=[fontname zeros(1,15-fontnamelength)];
	textsmart(qw,stamat+7:stamat+21)=fontname;
else
	flag=1;
	lengthtextsmart=size(textsmart);
	lengthtextsmart=lengthtextsmart(1,1);
	for qw=lengthtextsmart:-1:1
		if flag==1,
			if textsmart(qw,stamat)~=0	
				row_hold=qw+1;
				col_hold=stamat;
				getcurrcolor=textsmart(qw,stamat+3:stamat+5);					
				getcurrfontsize=textsmart(qw,stamat+6);
				getcurrfonttype=textsmart(qw,stamat+7:stamat+21);
				if typeofcall~=3 & typeofcall~=4
					texttoplot=abs(get(texttoadd(currentfigurenum),'String'));
				else % load
					texttoplot=abs(texttoadd);
				end
				hold on;textsmart(qw+1,stamat)=text(xtext,ytext,setstr(texttoplot));
				% ******************************************************
				if typeofcall~=1 & typeofcall~=0 & typeofcall~=3 & typeofcall~=4 % only for cfit where colors are sent
					colormat=['g','m','b','r','y','c','w'];
					set(textsmart(qw+1,stamat),'Color',colormat(colorind));
					textsmart(qw+1,stamat+3:stamat+5)=get(textsmart(qw+1,stamat),'Color');
					getcurrcolor=textsmart(qw+1,stamat+3:stamat+5);
				end
				% ******************************************************
				set(textsmart(qw+1,stamat),'Color',getcurrcolor);						
				set(textsmart(qw+1,stamat),'FontSize',getcurrfontsize);
				set(textsmart(qw+1,stamat),'FontName',setstr(getcurrfonttype));
				textsmart(qw+1,stamat+1:stamat+2)=[xtext ytext];
				textsmart(qw+1,stamat+3:stamat+5)=get(textsmart(qw+1,stamat),'Color');
				textsmart(qw+1,stamat+6)=get(textsmart(qw+1,stamat),'FontSize');
				fontname=abs(get(textsmart(qw+1,stamat),'FontName'));
				fontnamelength=length(fontname);
				fontname=[fontname zeros(1,15-fontnamelength)];
				textsmart(qw+1,stamat+7:stamat+21)=fontname;			
				flag=0;
			end
			if (textsmart(qw,stamat)==0 & qw==1)
				if typeofcall~=3 & typeofcall~=4
					texttoplot=abs(get(texttoadd(currentfigurenum),'String'));
				else % load
					texttoplot=abs(texttoadd);
				end
				hold on;textsmart(qw,stamat)=text(xtext,ytext,setstr(texttoplot));
				% ******************************************************
				if typeofcall~=1 & typeofcall~=0 & typeofcall~=3 & typeofcall~=4
					colormat=['g','m','b','r','y','c','w'];
					set(textsmart(qw,stamat),'Color',colormat(colorind));
				end
				% ******************************************************
				row_hold=qw;
				col_hold=stamat;
				textsmart(qw,stamat+1:stamat+2)=[xtext ytext];
				textsmart(qw,stamat+3:stamat+5)=get(textsmart(qw,stamat),'Color');
				textsmart(qw,stamat+6)=get(textsmart(qw,stamat),'FontSize');
				fontname=abs(get(textsmart(qw,stamat),'FontName'));
				fontnamelength=length(fontname);
				fontname=[fontname zeros(1,15-fontnamelength)];
				textsmart(qw,stamat+7:stamat+21)=fontname;		
				flag=0;
			end
		end
	end
end

return