% Version 1.0 of ProPlot 1.0
%
%    // promodfy.m \\
%
%     Scott Keane
%  skeane@uceng.uc.edu
%
%
% *****************************************
% Script to add plot modifiers(color,linetype...)
% *****************************************



% Topbotdata=1


% ***********************************************************
% ********** Creating a row of plot modifiers  **************
% ***********************************************************

uicontrol(figanddatawin(2,numoffigs),...
	'Style','text',...
	'String','color',...
	'BackgroundColor','k',...
	'ForegroundColor','w',...
	'Position',[5 340 80 20],...
	'CallBack','');

uicontrol(figanddatawin(2,numoffigs),...
	'Style','text',...
	'String','style',...
	'BackgroundColor','k',...
	'ForegroundColor','w',...
	'Position',[90 340 60 20],...
	'CallBack','');

uicontrol(figanddatawin(2,numoffigs),...
	'Style','text',...
	'String','width',...
	'BackgroundColor','k',...
	'ForegroundColor','w',...
	'Position',[165 340 60 20],...
	'CallBack','');

uicontrol(figanddatawin(2,numoffigs),...
	'Style','text',...
	'String','marker size',...
	'BackgroundColor','k',...
	'ForegroundColor','w',...
	'Position',[210 340 90 20],...
	'CallBack','');
% @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
% @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@


linecolor(numoffigs,1)=uicontrol(figanddatawin(2,numoffigs),...
	'Style','popup',...
	'String','yellow|magenta|cyan|red|green|blue|white|black',...
	'Position',[5 320 80 160],...
	'Callback',['lcolor=[''Y'',''M'',''C'',''R'',''G'',''B'',''W'',''K''];disp begin,',...
		'topbotdata=1;',...
		'flag=1;',...
		'for you=1:numoffigs,',... % determine current figure(note complex,because of previous window setup)
			'if flag == 1,',...
				'gcfholder=[''get(figbox'',num2str(you),'',''''Value'''')''];',...
				'if eval(gcfholder)==1,',...
					'currentfigurenum=you;',...
					'callfigurenum=you;',...
					'flag=0;',...
				'end,',...	
			'end,',...
		'end,',...	
		'if isempty(plotvar)==0,',...
			'plotvarinfo=existfun(plotvar);',...
			'if plotvarinfo(currentfigurenum,1)~=0 & plotvarinfo(currentfigurenum,1)~=-1,',...
		'for cc=1:numoffigs,',...
			'if enmul==1,',...
				'if topbotdata==1,extra=0;else,extra=numoffigs;end,',...
				'if get(figbox(callfigurenum+extra,cc),''Value'') == 1,',...
					'currentfigurenum=cc;',...
					'getuserdata=get(plotvar(currentfigurenum,1),''UserData'');',...
					'getuserdatalen=size(getuserdata);getuserdatalen=getuserdatalen(1,1);',...
					'flag=1;',...
					'for qw=1:getuserdatalen,',...
						'if flag==1,',...
							'if getuserdata(qw,1:2)==[callfigurenum,topbotdata];',...
								'plottomodify=getuserdata(qw,3);',...
								'set(plotvar(currentfigurenum,plottomodify+1),''Color'',lcolor(get(linecolor(callfigurenum,1),''Value'')));',...
								'getuserdata(qw,5:7)=get(plotvar(currentfigurenum,plottomodify+1),''Color'');',...
								'set(plotvar(currentfigurenum,1),''UserData'',getuserdata);',...
								'flag=0;',...
							'end,',...
						'end,',...
					'end,',...
				'end,',...
			'else,',...
				'getuserdata=get(plotvar(currentfigurenum,1),''UserData'');',...
				'getuserdatalen=size(getuserdata);getuserdatalen=getuserdatalen(1,1);',...
				'flag=1;',...
				'for qw=1:getuserdatalen,',...
					'if flag==1,',...
						'if getuserdata(qw,1:2)==[currentfigurenum,topbotdata];',...
							'plottomodify=getuserdata(qw,3);',...
							'set(plotvar(currentfigurenum,plottomodify+1),''Color'',lcolor(get(linecolor(callfigurenum,1),''Value'')));',...
							'getuserdata(qw,5:7)=get(plotvar(currentfigurenum,plottomodify+1),''Color'');',...
							'set(plotvar(currentfigurenum,1),''UserData'',getuserdata);',...
							'flag=0;',...
						'end,',...
					'end,',...
				'end,',...
			'end,',...
		'end;end;end']); 

		



% @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
% @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@


linestyle(numoffigs,1)=uicontrol(figanddatawin(2,numoffigs),...
	'Style','popup',...
	'Value',6,...
	'String','point|circle|x-mark|plus|star|solid|dotted|dashdot|dashed',...
	'Position',[90 320 80 180],...
	'Callback',['lstyle=[setstr(''.''),0;setstr(''o''),0;setstr(''x''),0;setstr(''+''),0;setstr(''*''),0;setstr(''-''),0;setstr('':''),0;setstr(''-.'');setstr(''--'')];disp begin,',...
		'flag=1;',...
		'topbotdata=1;',...
		'for you=1:numoffigs,',...
			'if flag == 1,',...
				'gcfholder=[''get(figbox'',num2str(you),'',''''Value'''')''];',...
				'if eval(gcfholder)==1,',...
					'currentfigurenum=you;',...
					'callfigurenum=you;',...
					'flag=0;',...
				'end,',...	
			'end,',...
		'end,',...	
		'if isempty(plotvar)==0,',...
			'plotvarinfo=existfun(plotvar);',...
			'if plotvarinfo(currentfigurenum,1)~=0 & plotvarinfo(currentfigurenum,1)~=-1,',...
		'for cc=1:numoffigs,',...
			'if enmul==1,',...
				'if topbotdata==1,extra=0;else,extra=numoffigs;end,',...
				'if get(figbox(callfigurenum+extra,cc),''Value'') == 1,',...
					'currentfigurenum=cc;',...
					'getuserdata=get(plotvar(currentfigurenum,1),''UserData'');',...
					'getuserdatalen=size(getuserdata);getuserdatalen=getuserdatalen(1,1);',...
					'flag=1;',...
					'for qw=1:getuserdatalen,',...
						'if flag==1,',...
							'if getuserdata(qw,1:2)==[callfigurenum,topbotdata];',...
								'plottomodify=getuserdata(qw,3);',...
								'valuepopup=get(linestyle(callfigurenum,1),''Value'');',...
								'if lstyle(valuepopup,2)==0,',...
									'set(plotvar(currentfigurenum,plottomodify+1),''Linestyle'',lstyle(get(linestyle(callfigurenum,1),''Value''),1));',...
									'pstyle=abs(get(plotvar(currentfigurenum,plottomodify+1),''Linestyle''));',...
								'else,',...
									'set(plotvar(currentfigurenum,plottomodify+1),''Linestyle'',lstyle(get(linestyle(callfigurenum,1),''Value''),1:2));',...
									'pstyle=abs(get(plotvar(currentfigurenum,plottomodify+1),''Linestyle''));',...
								'end,',...
								'getuserdata(qw,8:9)=abs(lstyle(valuepopup,1:2));',...
								'set(plotvar(currentfigurenum,1),''UserData'',getuserdata);',...
								'flag=0;',...
							'end,',...		
						'end,',...
					'end,',...
				'end,',...
			'else,',...
				'getuserdata=get(plotvar(currentfigurenum,1),''UserData'');',...
				'getuserdatalen=size(getuserdata);getuserdatalen=getuserdatalen(1,1);',...
				'flag=1;',...
				'for qw=1:getuserdatalen,',...
					'if flag==1,',...
						'if getuserdata(qw,1:2)==[currentfigurenum,topbotdata];',...
							'plottomodify=getuserdata(qw,3);',...
							'valuepopup=get(linestyle(callfigurenum,1),''Value'');',...
							'if lstyle(valuepopup,2)==0,',...
								'set(plotvar(currentfigurenum,plottomodify+1),''Linestyle'',lstyle(get(linestyle(callfigurenum,1),''Value''),1));',...
								'pstyle=abs(get(plotvar(currentfigurenum,plottomodify+1),''Linestyle''));',...
							'else,',...
								'set(plotvar(currentfigurenum,plottomodify+1),''Linestyle'',lstyle(get(linestyle(callfigurenum,1),''Value''),1:2));',...
								'pstyle=abs(get(plotvar(currentfigurenum,plottomodify+1),''Linestyle''));',...
							'end,',...
							'getuserdata(qw,8:9)=abs(lstyle(valuepopup,1:2));',...
							'set(plotvar(currentfigurenum,1),''UserData'',getuserdata);',...
							'flag=0;',...
						'end,',...
					'end,',...
				'end,',...
			'end,',...
		'end;end;end']); 



		
% @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
% @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@


linewidth(numoffigs,1)=uicontrol(figanddatawin(2,numoffigs),...
	'Style','popup',...
	'String','1|2|3|4|5|6|7|8|9|10',...
	'Position',[175 320 40 200],...
	'Callback',['lwidth=[1:10];disp begin,',...
		'flag=1;',...
		'topbotdata=1;',...
		'for you=1:numoffigs,',...
			'if flag == 1,',...
				'gcfholder=[''get(figbox'',num2str(you),'',''''Value'''')''];',...
				'if eval(gcfholder)==1,',...
					'currentfigurenum=you;',...
					'callfigurenum=you;',...
					'flag=0;',...
				'end,',...	
			'end,',...
		'end,',...	
		'if isempty(plotvar)==0,',...
			'plotvarinfo=existfun(plotvar);',...
			'if plotvarinfo(currentfigurenum,1)~=0 & plotvarinfo(currentfigurenum,1)~=-1,',...
		'for cc=1:numoffigs,',...
			'if enmul==1,',...
				'if topbotdata==1,extra=0;else,extra=numoffigs;end,',...
				'if get(figbox(callfigurenum+extra,cc),''Value'') == 1,',...
					'currentfigurenum=cc;',...
					'getuserdata=get(plotvar(currentfigurenum,1),''UserData'');',...
					'getuserdatalen=size(getuserdata);getuserdatalen=getuserdatalen(1,1);',...
					'flag=1;',...
					'for qw=1:getuserdatalen,',...
						'if flag==1,',...
							'if getuserdata(qw,1:2)==[callfigurenum,topbotdata];',...
								'plottomodify=getuserdata(qw,3);',...
								'set(plotvar(currentfigurenum,plottomodify+1),''Linewidth'',lwidth(get(linewidth(callfigurenum,1),''Value'')));',...
								'getuserdata(qw,10)=get(plotvar(currentfigurenum,plottomodify+1),''Linewidth'');',...
								'set(plotvar(currentfigurenum,1),''UserData'',getuserdata);',...
								'flag=0;',...
							'end,',...		
						'end,',...
					'end,',...
				'end,',...
			'else,',...
				'getuserdata=get(plotvar(currentfigurenum,1),''UserData'');',...
				'getuserdatalen=size(getuserdata);getuserdatalen=getuserdatalen(1,1);',...
				'flag=1;',...
				'for qw=1:getuserdatalen,',...
					'if flag==1,',...
						'if getuserdata(qw,1:2)==[callfigurenum,topbotdata];',...
							'plottomodify=getuserdata(qw,3);',...
							'set(plotvar(currentfigurenum,plottomodify+1),''Linewidth'',lwidth(get(linewidth(callfigurenum,1),''Value'')));',...
							'getuserdata(qw,10)=get(plotvar(currentfigurenum,plottomodify+1),''Linewidth'');',...
							'set(plotvar(currentfigurenum,1),''UserData'',getuserdata);',...
							'flag=0;',...
						'end,',...		
					'end,',...
				'end,',...
			'end,',...
		'end,end,end']);




% @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
% @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@



markersize(numoffigs,1)=uicontrol(figanddatawin(2,numoffigs),...
	'Style','popup',...
	'String','2|3|4|5|6|7|8|9',...
	'Value',5,...
	'Position',[230 320 40 160],...
	'Callback',['msize=[2:9];disp begin,',...
		'flag=1;',...
		'topbotdata=1;',...
		'for you=1:numoffigs,',...
			'if flag == 1,',...
				'gcfholder=[''get(figbox'',num2str(you),'',''''Value'''')''];',...
				'if eval(gcfholder)==1,',...
					'currentfigurenum=you;',...
					'callfigurenum=you;',...
					'flag=0;',...
				'end,',...	
			'end,',...
		'end,',...	
		'if isempty(plotvar)==0,',...
			'plotvarinfo=existfun(plotvar);',...
			'if plotvarinfo(currentfigurenum,1)~=0 & plotvarinfo(currentfigurenum,1)~=-1,',...
		'for cc=1:numoffigs,',...
			'if enmul==1,',...
				'if topbotdata==1,extra=0;else,extra=numoffigs;end,',...
				'if get(figbox(callfigurenum+extra,cc),''Value'') == 1,',...
					'currentfigurenum=cc;',...
					'getuserdata=get(plotvar(currentfigurenum,1),''UserData'');',...
					'getuserdatalen=size(getuserdata);getuserdatalen=getuserdatalen(1,1);',...
					'flag=1;',...
					'for qw=1:getuserdatalen,',...
						'if flag==1,',...
							'if getuserdata(qw,1:2)==[callfigurenum,topbotdata];',...
								'plottomodify=getuserdata(qw,3);',...
								'set(plotvar(currentfigurenum,plottomodify+1),''MarkerSize'',msize(get(markersize(callfigurenum,1),''Value'')));',...
								'getuserdata(qw,11)=get(plotvar(currentfigurenum,plottomodify+1),''MarkerSize'');',...
								'set(plotvar(currentfigurenum,1),''UserData'',getuserdata);',...
								'flag=0;',...
							'end,',...		
						'end,',...
					'end,',...
				'end,',...
			'else,',...
				'getuserdata=get(plotvar(currentfigurenum,1),''UserData'');',...
				'getuserdatalen=size(getuserdata);getuserdatalen=getuserdatalen(1,1);',...
				'flag=1;',...
				'for qw=1:getuserdatalen,',...
					'if flag==1,',...
						'if getuserdata(qw,1:2)==[callfigurenum,topbotdata];',...
							'plottomodify=getuserdata(qw,3);',...
							'set(plotvar(currentfigurenum,plottomodify+1),''MarkerSize'',msize(get(markersize(callfigurenum,1),''Value'')));',...
								'getuserdata(qw,11)=get(plotvar(currentfigurenum,plottomodify+1),''MarkerSize'');',...
								'set(plotvar(currentfigurenum,1),''UserData'',getuserdata);',...
								'flag=0;',...
							'end,',...		
						'end,',...
					'end,',...
				'end,',...
			'end,',...
		'end,end,end']);





% Topbotdata=2

% ***********************************************************
% ********** Creating a row of plot modifiers  **************
% ***********************************************************

uicontrol(figanddatawin(2,numoffigs),...
	'Style','text',...
	'String','color',...
	'BackgroundColor','k',...
	'ForegroundColor','w',...
	'Position',[5 120 80 20],...
	'CallBack','');

uicontrol(figanddatawin(2,numoffigs),...
	'Style','text',...
	'String','style',...
	'BackgroundColor','k',...
	'ForegroundColor','w',...
	'Position',[90 120 60 20],...
	'CallBack','');

uicontrol(figanddatawin(2,numoffigs),...
	'Style','text',...
	'String','width',...
	'BackgroundColor','k',...
	'ForegroundColor','w',...
	'Position',[165 120 60 20],...
	'CallBack','');

uicontrol(figanddatawin(2,numoffigs),...
	'Style','text',...
	'String','marker size',...
	'BackgroundColor','k',...
	'ForegroundColor','w',...
	'Position',[210 120 90 20],...
	'CallBack','');
% @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
% @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@


linecolor(numoffigs,2)=uicontrol(figanddatawin(2,numoffigs),...
	'Style','popup',...
	'Value',2,...
	'String','yellow|magenta|cyan|red|green|blue|white|black',...
	'Position',[5 100 80 160],...
	'Callback',['lcolor=[''Y'',''M'',''C'',''R'',''G'',''B'',''W'',''K''];disp begin,',...
		'flag=1;',...
		'topbotdata=2;',...
		'for you=1:numoffigs,',...
			'if flag == 1,',...
				'gcfholder=[''get(figbox'',num2str(you),'',''''Value'''')''];',...
				'if eval(gcfholder)==1,',...
					'currentfigurenum=you;',...
					'callfigurenum=you;',...
					'flag=0;',...
				'end,',...	
			'end,',...
		'end,',...	
		'if isempty(plotvar)==0,',...
			'plotvarinfo=existfun(plotvar);',...
			'if plotvarinfo(currentfigurenum,1)~=0 & plotvarinfo(currentfigurenum,1)~=-1,',...
		'for cc=1:numoffigs,',...
			'if enmul==1,',...
				'if topbotdata==1,extra=0;else,extra=numoffigs;end,',...
				'if get(figbox(callfigurenum+extra,cc),''Value'') == 1,',...
					'currentfigurenum=cc;',...
					'getuserdata=get(plotvar(currentfigurenum,1),''UserData'');',...
					'getuserdatalen=size(getuserdata);getuserdatalen=getuserdatalen(1,1);',...
					'flag=1;',...
					'for qw=1:getuserdatalen,',...
						'if flag==1,',...
							'if getuserdata(qw,1:2)==[callfigurenum,topbotdata];',...
								'plottomodify=getuserdata(qw,3);',...
								'set(plotvar(currentfigurenum,plottomodify+1),''Color'',lcolor(get(linecolor(callfigurenum,2),''Value'')));',...
								'getuserdata(qw,5:7)=get(plotvar(currentfigurenum,plottomodify+1),''Color'');',...
								'set(plotvar(currentfigurenum,1),''UserData'',getuserdata);',...
								'flag=0;',...
							'end,',...
						'end,',...
					'end,',...
				'end,',...
			'else,',...
				'getuserdata=get(plotvar(currentfigurenum,1),''UserData'');',...
				'getuserdatalen=size(getuserdata);getuserdatalen=getuserdatalen(1,1);',...
				'flag=1;',...
				'for qw=1:getuserdatalen,',...
					'if flag==1,',...
						'if getuserdata(qw,1:2)==[currentfigurenum,topbotdata];',...
							'plottomodify=getuserdata(qw,3);',...
							'set(plotvar(currentfigurenum,plottomodify+1),''Color'',lcolor(get(linecolor(callfigurenum,2),''Value'')));',...
							'getuserdata(qw,5:7)=get(plotvar(currentfigurenum,plottomodify+1),''Color'');',...
							'set(plotvar(currentfigurenum,1),''UserData'',getuserdata);',...
							'flag=0;',...
						'end,',...
					'end,',...
				'end,',...
			'end,',...
		'end;end;end']); 

		



% @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
% @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@


linestyle(numoffigs,2)=uicontrol(figanddatawin(2,numoffigs),...
	'Style','popup',...
	'Value',7,...
	'String','point|circle|x-mark|plus|star|solid|dotted|dashdot|dashed',...
	'Position',[90 100 80 180],...
	'Callback',['lstyle=[setstr(''.''),0;setstr(''o''),0;setstr(''x''),0;setstr(''+''),0;setstr(''*''),0;setstr(''-''),0;setstr('':''),0;setstr(''-.'');setstr(''--'')];disp begin,',...
		'flag=1;',...
		'topbotdata=2;',...
		'for you=1:numoffigs,',...
			'if flag == 1,',...
				'gcfholder=[''get(figbox'',num2str(you),'',''''Value'''')''];',...
				'if eval(gcfholder)==1,',...
					'currentfigurenum=you;',...
					'callfigurenum=you;',...
					'flag=0;',...
				'end,',...	
			'end,',...
		'end,',...	
		'if isempty(plotvar)==0,',...
			'plotvarinfo=existfun(plotvar);',...
			'if plotvarinfo(currentfigurenum,1)~=0 & plotvarinfo(currentfigurenum,1)~=-1,',...
		'for cc=1:numoffigs,',...
			'if enmul==1,',...
				'if topbotdata==1,extra=0;else,extra=numoffigs;end,',...
				'if get(figbox(callfigurenum+extra,cc),''Value'') == 1,',...
					'currentfigurenum=cc;',...
					'getuserdata=get(plotvar(currentfigurenum,1),''UserData'');',...
					'getuserdatalen=size(getuserdata);getuserdatalen=getuserdatalen(1,1);',...
					'flag=1;',...
					'for qw=1:getuserdatalen,',...
						'if flag==1,',...
							'if getuserdata(qw,1:2)==[callfigurenum,topbotdata];',...
								'plottomodify=getuserdata(qw,3);',...
								'valuepopup=get(linestyle(callfigurenum,2),''Value'');',...
								'if lstyle(valuepopup,2)==0,',...
									'set(plotvar(currentfigurenum,plottomodify+1),''Linestyle'',lstyle(get(linestyle(callfigurenum,2),''Value''),1));',...
									'pstyle=abs(get(plotvar(currentfigurenum,plottomodify+1),''Linestyle''));',...
								'else,',...
									'set(plotvar(currentfigurenum,plottomodify+1),''Linestyle'',lstyle(get(linestyle(callfigurenum,2),''Value''),1:2));',...
									'pstyle=abs(get(plotvar(currentfigurenum,plottomodify+1),''Linestyle''));',...
								'end,',...
								'getuserdata(qw,8:9)=abs(lstyle(valuepopup,1:2));',...
								'set(plotvar(currentfigurenum,1),''UserData'',getuserdata);',...
								'flag=0;',...
							'end,',...		
						'end,',...
					'end,',...
				'end,',...
			'else,',...
				'getuserdata=get(plotvar(currentfigurenum,1),''UserData'');',...
				'getuserdatalen=size(getuserdata);getuserdatalen=getuserdatalen(1,1);',...
				'flag=1;',...
				'for qw=1:getuserdatalen,',...
					'if flag==1,',...
						'if getuserdata(qw,1:2)==[currentfigurenum,topbotdata];',...
							'plottomodify=getuserdata(qw,3);',...
							'valuepopup=get(linestyle(callfigurenum,2),''Value'');',...
							'if lstyle(valuepopup,2)==0,',...
								'set(plotvar(currentfigurenum,plottomodify+1),''Linestyle'',lstyle(get(linestyle(callfigurenum,2),''Value''),1));',...
								'pstyle=abs(get(plotvar(currentfigurenum,plottomodify+1),''Linestyle''));',...
							'else,',...
								'set(plotvar(currentfigurenum,plottomodify+1),''Linestyle'',lstyle(get(linestyle(callfigurenum,2),''Value''),1:2));',...
								'pstyle=abs(get(plotvar(currentfigurenum,plottomodify+1),''Linestyle''));',...
							'end,',...
							'getuserdata(qw,8:9)=abs(lstyle(valuepopup,1:2));',...
							'set(plotvar(currentfigurenum,1),''UserData'',getuserdata);',...
							'flag=0;',...
						'end,',...
					'end,',...
				'end,',...
			'end,',...
		'end;end;end']); 



		
% @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
% @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@


linewidth(numoffigs,2)=uicontrol(figanddatawin(2,numoffigs),...
	'Style','popup',...
	'String','1|2|3|4|5|6|7|8|9|10',...
	'Position',[175 100 40 200],...
	'Callback',['lwidth=[1:10];disp begin,',...
		'flag=1;',...
		'topbotdata=2;',...
		'for you=1:numoffigs,',...
			'if flag == 1,',...
				'gcfholder=[''get(figbox'',num2str(you),'',''''Value'''')''];',...
				'if eval(gcfholder)==1,',...
					'currentfigurenum=you;',...
					'callfigurenum=you;',...
					'flag=0;',...
				'end,',...	
			'end,',...
		'end,',...	
		'if isempty(plotvar)==0,',...
			'plotvarinfo=existfun(plotvar);',...
			'if plotvarinfo(currentfigurenum,1)~=0 & plotvarinfo(currentfigurenum,1)~=-1,',...
		'for cc=1:numoffigs,',...
			'if enmul==1,',...
				'if topbotdata==1,extra=0;else,extra=numoffigs;end,',...
				'if get(figbox(callfigurenum+extra,cc),''Value'') == 1,',...
					'currentfigurenum=cc;',...
					'getuserdata=get(plotvar(currentfigurenum,1),''UserData'');',...
					'getuserdatalen=size(getuserdata);getuserdatalen=getuserdatalen(1,1);',...
					'flag=1;',...
					'for qw=1:getuserdatalen,',...
						'if flag==1,',...
							'if getuserdata(qw,1:2)==[callfigurenum,topbotdata];',...
								'plottomodify=getuserdata(qw,3);',...
								'set(plotvar(currentfigurenum,plottomodify+1),''Linewidth'',lwidth(get(linewidth(callfigurenum,2),''Value'')));',...
								'getuserdata(qw,10)=get(plotvar(currentfigurenum,plottomodify+1),''Linewidth'');',...
								'set(plotvar(currentfigurenum,1),''UserData'',getuserdata);',...
								'flag=0;',...
							'end,',...		
						'end,',...
					'end,',...
				'end,',...
			'else,',...
				'getuserdata=get(plotvar(currentfigurenum,1),''UserData'');',...
				'getuserdatalen=size(getuserdata);getuserdatalen=getuserdatalen(1,1);',...
				'flag=1;',...
				'for qw=1:getuserdatalen,',...
					'if flag==1,',...
						'if getuserdata(qw,1:2)==[callfigurenum,topbotdata];',...
							'plottomodify=getuserdata(qw,3);',...
							'set(plotvar(currentfigurenum,plottomodify+1),''Linewidth'',lwidth(get(linewidth(callfigurenum,2),''Value'')));',...
							'getuserdata(qw,10)=get(plotvar(currentfigurenum,plottomodify+1),''Linewidth'');',...
							'set(plotvar(currentfigurenum,1),''UserData'',getuserdata);',...
							'flag=0;',...
						'end,',...		
					'end,',...
				'end,',...
			'end,',...
		'end,end,end']);




% @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
% @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@



markersize(numoffigs,2)=uicontrol(figanddatawin(2,numoffigs),...
	'Style','popup',...
	'Value',5,...
	'String','2|3|4|5|6|7|8|9',...
	'Position',[230 100 40 160],...
	'Callback',['msize=[2:9];disp begin,',...
		'flag=1;',...
		'topbotdata=2;',...
		'for you=1:numoffigs,',...
			'if flag == 1,',...
				'gcfholder=[''get(figbox'',num2str(you),'',''''Value'''')''];',...
				'if eval(gcfholder)==1,',...
					'currentfigurenum=you;',...
					'callfigurenum=you;',...
					'flag=0;',...
				'end,',...	
			'end,',...
		'end,',...	
		'if isempty(plotvar)==0,',...
			'plotvarinfo=existfun(plotvar);',...
			'if plotvarinfo(currentfigurenum,1)~=0 & plotvarinfo(currentfigurenum,1)~=-1,',...
		'for cc=1:numoffigs,',...
			'if enmul==1,',...
				'if topbotdata==1,extra=0;else,extra=numoffigs;end,',...
				'if get(figbox(callfigurenum+extra,cc),''Value'') == 1,',...
					'currentfigurenum=cc;',...
					'getuserdata=get(plotvar(currentfigurenum,1),''UserData'');',...
					'getuserdatalen=size(getuserdata);getuserdatalen=getuserdatalen(1,1);',...
					'flag=1;',...
					'for qw=1:getuserdatalen,',...
						'if flag==1,',...
							'if getuserdata(qw,1:2)==[callfigurenum,topbotdata];',...
								'plottomodify=getuserdata(qw,3);',...
								'set(plotvar(currentfigurenum,plottomodify+1),''MarkerSize'',msize(get(markersize(callfigurenum,2),''Value'')));',...
								'getuserdata(qw,11)=get(plotvar(currentfigurenum,plottomodify+1),''MarkerSize'');',...
								'set(plotvar(currentfigurenum,1),''UserData'',getuserdata);',...
								'flag=0;',...
							'end,',...		
						'end,',...
					'end,',...
				'end,',...
			'else,',...
				'getuserdata=get(plotvar(currentfigurenum,1),''UserData'');',...
				'getuserdatalen=size(getuserdata);getuserdatalen=getuserdatalen(1,1);',...
				'flag=1;',...
				'for qw=1:getuserdatalen,',...
					'if flag==1,',...
						'if getuserdata(qw,1:2)==[callfigurenum,topbotdata];',...
							'plottomodify=getuserdata(qw,3);',...
							'set(plotvar(currentfigurenum,plottomodify+1),''MarkerSize'',msize(get(markersize(callfigurenum,2),''Value'')));',...
								'getuserdata(qw,11)=get(plotvar(currentfigurenum,plottomodify+1),''MarkerSize'');',...
								'set(plotvar(currentfigurenum,1),''UserData'',getuserdata);',...
								'flag=0;',...
							'end,',...		
						'end,',...
					'end,',...
				'end,',...
			'end,',...
		'end,end,end']);