% Version 1.0 of ProPlot 1.0
%
%    // specbeg.m \\
%
%     Scott Keane
%  skeane@uceng.uc.edu
%
% 
% *****************************************
% Matlab script to add user
% data load capabilities, and a size() button
% *****************************************


% ************************************************
% ************ Create special figure *************
% ************************************************

% Note position of window is stored in defaults file 

% ***********************************************************
% ********** Creating a special figure initially off ********
% ***********************************************************


dumspec1=['specialfig=figure(''Visible'',''off'',''Resize'',''on'',''Pointer'',''arrow'',''MenuBar'',''none'',''Position'',[',num2str(winsize_load_left),' ',num2str(winsize_load_bottom),' ',num2str(winsize_load_width),' ',num2str(winsize_load_height),'],''NumberTitle'',''off'',''Name'',''Load Data'');'];
eval(dumspec1);
% ''Name'',''Figure ',num2str(currentfigurenum),' / Data ',num2str(topbotdata),' / Special'')





% @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
% @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@


% *************************************************
% *************** Load File Edit *******************
% *************************************************

uicontrol(specialfig,...
	'Style','text',...
	'String','Load an external data file',...
	'BackgroundColor','k',...
	'ForegroundColor','y',...
	'Position',[25 380 200 20],...
	'CallBack','');

loadedit=uicontrol(specialfig,...
	'Style','edit',...
	'ForegroundColor','w',...
	'BackgroundColor','b',...
	'Position',[5 325 95 20],...
	'CallBack','  ');

uicontrol(specialfig,...
	'Style','text',...
	'String','Filename',...
	'ForegroundColor','w',...
	'BackgroundColor','k',...
	'Position',[5 345 85 20]);


uicontrol(specialfig,...
	'Style','text',...
	'String','-->',...
	'ForegroundColor','w',...
	'BackgroundColor','k',...
	'Position',[100 325 30 20]);

% *************************************************
% *************** Load File checkboxes ************
% *************************************************

loadcbox1=uicontrol(specialfig,...
	'Style','checkbox',...
	'String','ascii',...
	'BackgroundColor','k',...
	'ForegroundColor','g',...
	'Position',[130 345 180 20],...
	'CallBack',['a=get(loadcbox1,''Value'');',...
		'if a==1,',...
			'set(loadcbox2,''Value'',0);',...
			'set(loadcbox3,''Value'',0);',...
		'else,',...
			'set(loadcbox1,''Value'',1);',...
		'end']);


loadcbox2=uicontrol(specialfig,...
	'Style','checkbox',...
	'String','binary (with .mat extension)',...
	'BackgroundColor','k',...
	'ForegroundColor','g',...
	'Value',1,...
	'Position',[130 325 180 20],...
	'CallBack',['a=get(loadcbox2,''Value'');',...
		'if a==1,',...
			'set(loadcbox1,''Value'',0);',...
			'set(loadcbox3,''Value'',0);',...
		'else,',...
			'set(loadcbox2,''Value'',1);',...
		'end']);


loadcbox3=uicontrol(specialfig,...
	'Style','checkbox',...
	'String','binary (w/out .mat extension)',...
	'BackgroundColor','k',...
	'ForegroundColor','g',...
	'Position',[130 305 180 20],...
	'CallBack',['a=get(loadcbox3,''Value'');',...
		'if a==1,',...
			'set(loadcbox1,''Value'',0);',...
			'set(loadcbox2,''Value'',0);',...
		'else,',...
			'set(loadcbox3,''Value'',1);',...
		'end']);


% *************************************************
% *************** Load File Button *******************
% *************************************************

% *** if load file successful, store the name of load file in loaddatastore ***
% *** for later saving to .m file ***
% *** currently support 10 unique data files ***


loadbutton=uicontrol(specialfig,...
	'Style','push',...
	'String','Load File',...
	'Position',[315 325 80 20],...
	'CallBack',['file2load=abs(get(loadedit,''String''));',...
		'baddum=1;',...
		'if get(loadcbox1,''Value'') == 1,',...
			'dumload=[''load '',setstr(file2load),'' -ascii''];',...
			'eval(dumload,''baddum=0;'');',...
			'if baddum==1,',...% *** ok
				'set(answerfileload,''ForegroundColor'',''y'');',...
				'set(answerfileload,''String'',''<SUCCESSFUL>'');',...
				'unique=1;',... % *** determine if file2load is unique ***
				'for i=1:10;',...
					'lenfileload=length(file2load);',...
					'if unique==1;',...
						'if loaddatastore(i,1:lenfileload)==file2load;',...
							'unique=0;',...
						'end;',...
					'end;',...
				'end;',...
				'if unique==1;',...% *** determine how many entries are in loaddatastore ***		
					'found0=0;',...
					'addtorow=0;',...
					'for i=1:10;',...
						'if found0==0;',...
							'if loaddatastore(i,1)==0;',...
								'found0=1;',...
								'addtorow=i;',...
							'end;',...
						'end;',...
					'end;',...
					'if addtorow ~= 0;',...
						'loaddatastore(addtorow,1:lenfileload)=file2load;',...
					'end;',...
				'end;',...
			'else;',...% *** failed
				'set(answerfileload,''ForegroundColor'',''r'');',...
				'set(answerfileload,''String'',''<ERROR LOADING>'');',...
			'end,',...
		'elseif get(loadcbox2,''Value'') == 1,',...
			'dumload=[''load '',setstr(file2load)];',...
			'eval(dumload,''baddum=0;'');',...
			'if baddum==1,',...% *** ok
				'set(answerfileload,''ForegroundColor'',''y'');',...
				'set(answerfileload,''String'',''<SUCCESSFUL>'');',...
				'unique=1;',... % *** determine if file2load is unique ***
				'for i=1:10;',...
					'lenfileload=length(file2load);',...
					'if unique==1;',...
						'if loaddatastore(i,1:lenfileload)==file2load;',...
							'unique=0;',...
						'end;',...
					'end;',...
				'end;',...
				'if unique==1;',...% *** determine how many entries are in loaddatastore ***
					'found0=0;',...
					'addtorow=0;',...
					'for i=1:10;',...
						'if found0==0;',...
							'if loaddatastore(i,1)==0;',...
								'found0=1;',...
								'addtorow=i;',...
							'end;',...
						'end;',...
					'end;',...
					'if addtorow ~= 0;',...
						'loaddatastore(addtorow,1:lenfileload)=file2load;',...			
					'end;',...
				'end;',...
			'else;',...% *** failed
				'set(answerfileload,''ForegroundColor'',''r'');',...
				'set(answerfileload,''String'',''<ERROR LOADING>'');',...
			'end,',...
		'elseif get(loadcbox3,''Value'') == 1,',...
			'dumload=[''load '',setstr(file2load),'' -mat''];',...
			'eval(dumload,''baddum=0;'');',...
			'if baddum==1,',...% *** ok
				'set(answerfileload,''ForegroundColor'',''y'');',...
				'set(answerfileload,''String'',''<SUCCESSFUL>'');',...
				'unique=1;',... % *** determine if file2load is unique ***
				'for i=1:10;',...
					'lenfileload=length(file2load);',...
					'if unique==1;',...
						'if loaddatastore(i,1:lenfileload)==file2load;',...
							'unique=0;',...
						'end;',...
					'end;',...
				'end;',...
				'if unique==1;',...% *** determine how many entries are in loaddatastore ***
					'found0=0;',...
					'addtorow=0;',...
					'for i=1:10;',...
						'if found0==0;',...
							'if loaddatastore(i,1)==0;',...
								'found0=1;',...
								'addtorow=i;',...
							'end;',...
						'end;',...
					'end;',...
					'if addtorow ~= 0;',...
						'loaddatastore(addtorow,1:lenfileload)=file2load;',...			
					'end;',...
				'end;',...
			'else;',...% *** failed
				'set(answerfileload,''ForegroundColor'',''r'');',...
				'set(answerfileload,''String'',''<ERROR LOADING>'');',...
			'end,',...
		'end']);

answerfileload=uicontrol(specialfig,...
	'Style','text',...
	'visible','on',...
	'backgroundcolor','k',...
	'Position',[410 325 130 20]);


% ***********************************************************
% ********** Text for Length of Workspace *******************
% ***********************************************************

uicontrol(specialfig,...
	'Style','text',...
	'String','____________________________________________________________________________________',...
	'Position',[0 290 600 20],...
	'ForegroundColor','r',...
	'BackgroundColor','k');

uicontrol(specialfig,...
	'Style','text',...
	'String','Check the length of a matrix in workspace',...
	'BackgroundColor','k',...
	'ForegroundColor','y',...
	'Position',[25 270 300 20],...
	'CallBack','');

	
% ***********************************************************
% ******* Check Length of Workspace Variable ****************
% ***********************************************************

uicontrol(specialfig,...
	'Style','text',...
	'String','Matrix',...
	'ForegroundColor','w',...
	'BackgroundColor','k',...
	'Position',[5 240 85 20]);

checklengthtext=uicontrol(specialfig,...
	'Style','edit',...
	'BackgroundColor','b',...
	'ForegroundColor','w',...
	'Position',[5 220 115 20],...
	'CallBack','');

uicontrol(specialfig,...
	'Style','text',...
	'String','-->',...
	'ForegroundColor','w',...
	'BackgroundColor','k',...
	'Position',[130 220 30 20]);


checklength=uicontrol(specialfig,...
	'Style','push',...
	'String','Size of Matrix?',...
	'Position',[170 220 130 20],...
	'CallBack',['length2check=abs(get(checklengthtext,''String''));',...	
	'dumexist=[''doesexist=exist('''''',setstr(length2check),'''''');''];',...
	'eval(dumexist,''doesexist=0;'');',...% ** if fail then not defined
	'if doesexist ~= 0,',...
		'set(answerlength,''ForegroundColor'',''y'');',...
		'dumlen=[''lengthof=size('',setstr(length2check),'');''];',...
		'eval(dumlen);',...
		'lengthof=[num2str(lengthof(1,1)),'' X '',num2str(lengthof(1,2))];',...
		'set(answerlength,''string'',lengthof);',...
	'else,',...
		'set(answerlength,''ForegroundColor'',''r'');',...
		'set(answerlength,''string'',''<NOT DEFINED>'');',...
	'end']);


answerlength=uicontrol(specialfig,...
	'Style','text',...
	'visible','on',...
	'backgroundcolor','k',...
	'Position',[310 220 130 20]);

% ***********************************************************
% ********** Text for Uniform Array *************************
% ***********************************************************

uicontrol(specialfig,...
	'Style','text',...
	'String','____________________________________________________________________________________',...
	'Position',[0 185 600 20],...
	'ForegroundColor','r',...
	'BackgroundColor','k');

uicontrol(specialfig,...
	'Style','text',...
	'String','Create a uniformly spaced vector',...
	'BackgroundColor','k',...
	'ForegroundColor','y',...
	'Position',[25 165 300 20]);


% ***********************************************************
% ********** Begin Option One *******************************
% ***********************************************************

linspaceedit=uicontrol(specialfig,...
	'Style','edit',...
	'BackgroundColor','b',...
	'ForegroundColor','w',...
	'Position',[10 120 100 20],...
	'CallBack','');


uicontrol(specialfig,...
	'Style','text',...
	'String','Vector Name',...
	'BackgroundColor','k',...
	'ForegroundColor','w',...
	'Position',[10 140 100 20]);

% !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

startedit=uicontrol(specialfig,...
	'Style','edit',...
	'BackgroundColor','b',...
	'ForegroundColor','w',...
	'Position',[125 120 60 20],...
	'CallBack','');


uicontrol(specialfig,...
	'Style','text',...
	'String','Start',...
	'BackgroundColor','k',...
	'ForegroundColor','w',...
	'Position',[125 140 60 20]);

% !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
endedit=uicontrol(specialfig,...
	'Style','edit',...
	'BackgroundColor','b',...
	'ForegroundColor','w',...
	'Position',[195 120 60 20],...
	'CallBack','');


uicontrol(specialfig,...
	'Style','text',...
	'String','End',...
	'BackgroundColor','k',...
	'ForegroundColor','w',...
	'Position',[195 140 60 20]);

% !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
numedit=uicontrol(specialfig,...
	'Style','edit',...
	'BackgroundColor','b',...
	'ForegroundColor','w',...
	'Position',[265 120 60 20]);

uicontrol(specialfig,...
	'Style','text',...
	'String','# Points',...
	'BackgroundColor','k',...
	'ForegroundColor','w',...
	'Position',[265 140 60 20]);

linspaceapply=uicontrol(specialfig,...
	'Style','push',...
	'String','Create',...
	'Position',[340 120 60 20],...
	'CallBack',['buildtext=[get(linspaceedit,''string''),''=linspace(''];',...
		'buildtext=[buildtext,get(startedit,''string''),'',''];',...
		'buildtext=[buildtext,get(endedit,''string''),'',''];',...
		'buildtext=[buildtext,get(numedit,''string''),'');''];',...
		'badbuild=1;',...% ** assume ok
		'eval(buildtext,''badbuild=0;'');',...
		'if badbuild==1;',...% *** ok
			'set(linspacestatus,''ForegroundColor'',''y'');',...
			'set(linspacestatus,''String'',''<SUCCESSFUL>'');',...
		'else;',...% *** failed
			'set(linspacestatus,''ForegroundColor'',''r'');',...
			'set(linspacestatus,''String'',''<ERROR>'');',...
		'end;']);

linspacestatus=uicontrol(specialfig,...
	'Style','text',...
	'visible','on',...
	'backgroundcolor','k',...
	'Position',[420 120 100 20]);


% ***********************************************************
% ********** Begin Option Two *******************************
% ***********************************************************

freqspaceedit=uicontrol(specialfig,...
	'Style','edit',...
	'BackgroundColor','b',...
	'ForegroundColor','w',...
	'Position',[10 60 100 20],...
	'CallBack','');


uicontrol(specialfig,...
	'Style','text',...
	'String','Vector Name',...
	'BackgroundColor','k',...
	'ForegroundColor','w',...
	'Position',[10 80 100 20]);

% !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
sampfreq=uicontrol(specialfig,...
	'Style','edit',...
	'BackgroundColor','b',...
	'ForegroundColor','w',...
	'Position',[120 60 100 20],...
	'CallBack','');

uicontrol(specialfig,...
	'Style','text',...
	'String','Samp. Rate (Hz)',...
	'BackgroundColor','k',...
	'ForegroundColor','w',...
	'Position',[120 80 100 20]);

% !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
startedit2=uicontrol(specialfig,...
	'Style','edit',...
	'BackgroundColor','b',...
	'ForegroundColor','w',...
	'Position',[230 60 60 20],...
	'CallBack','');

uicontrol(specialfig,...
	'Style','text',...
	'String','Start',...
	'BackgroundColor','k',...
	'ForegroundColor','w',...
	'Position',[230 80 60 20]);

% !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
numedit2=uicontrol(specialfig,...
	'Style','edit',...
	'BackgroundColor','b',...
	'ForegroundColor','w',...
	'Position',[300 60 60 20],...
	'CallBack','');

uicontrol(specialfig,...
	'Style','text',...
	'String','# Points',...
	'BackgroundColor','k',...
	'ForegroundColor','w',...
	'Position',[300 80 60 20]);

freqapply=uicontrol(specialfig,...
	'Style','push',...
	'String','Create',...
	'Position',[375 60 60 20],...
	'CallBack',['buildtext=[get(freqspaceedit,''string''),''=linspace(''];',...
		'buildtext=[buildtext,get(startedit2,''string''),'',''];',...
		'buildtext=[buildtext,get(numedit2,''string''),''./''];',...
		'buildtext=[buildtext,get(sampfreq,''string''),'',''];',...
		'buildtext=[buildtext,get(numedit2,''string''),'');''];',...
		'badbuild=1;',...% ** assume ok
		'eval(buildtext,''badbuild=0;'');',...
		'if badbuild==1;',...% *** ok
			'set(freqspacestatus,''ForegroundColor'',''y'');',...
			'set(freqspacestatus,''String'',''<SUCCESSFUL>'');',...
		'else;',...% *** failed
			'set(freqspacestatus,''ForegroundColor'',''r'');',...
			'set(freqspacestatus,''String'',''<ERROR>'');',...
		'end;']);

freqspacestatus=uicontrol(specialfig,...
	'Style','text',...
	'visible','on',...
	'backgroundcolor','k',...
	'Position',[450 60 100 20]);


% *************************************************
% *************** Done Button *******************
% *************************************************

donewithspec=uicontrol(specialfig,...
	'Style','push',...
	'String','Dismiss',...
	'Position',[190 5 100 20],...
	'CallBack',['for bb=1:numoffigs,if figanddatawin(2,bb)==gcf,',...
		'currentfigurenum=bb;callfigurenum=bb;end,end,',...
		'set(specialfig,''Visible'',''off'');',...
			'for yimi=1:numoffigs;',...
				'set(loaditup(yimi),''Checked'',''off'');',...
			'end;']);






