% Version 1.0 of ProPlot 1.0
%
%    // addwarn.m \\
%
%     Scott Keane
%  skeane@uceng.uc.edu
%
%  Created on:     12:06 AM 3/27/96
%  Last Modified:  6:16 PM 6/15/96
% *****************************************
% Add-on's Removal Warning.  Add-ons enable the
% user to easily perform operations that would
% be manually painstaking.  Turning this off
% will signifigantly boost performance of ProPlot.
% *****************************************

if userdispaddon==1

figadd=figure('Resize','on','Pointer','arrow','MenuBar','none','Position',[50 50 350 200],'NumberTitle','off','Name','ProPlot Warning');

% *******************************************
% ******* Define Data 1,2 *******************
% *******************************************

uicontrol(figadd,...
	'Style','text',...
	'ForegroundColor','y',...
	'BackgroundColor','k',...
	'Position',[50 170 200 20],...
	'String','***ProPlot Warning***');

uicontrol(figadd,...
	'Style','text',...
	'ForegroundColor','r',...
	'BackgroundColor','k',...
	'Position',[10 150 310 20],...
	'String','Turning Add-on Menus off will inhibit the ability of the');

uicontrol(figadd,...
	'Style','text',...
	'ForegroundColor','r',...
	'BackgroundColor','k',...
	'Position',[10 130 320 20],...
	'String','user to create lines,leaders,text,... Once Add-on Menus');




uicontrol(figadd,...
	'Style','text',...
	'ForegroundColor','r',...
	'BackgroundColor','k',...
	'Position',[10 110 290 20],...
	'String','is turned off, it may not be turned back on without');



uicontrol(figadd,...
	'Style','text',...
	'ForegroundColor','r',...
	'BackgroundColor','k',...
	'Position',[10 90 300 20],...
	'String','restarting.  The primary reason to turn Add-on Menus');

uicontrol(figadd,...
	'Style','text',...
	'ForegroundColor','r',...
	'BackgroundColor','k',...
	'Position',[10 70 310 20],...
	'String','off is to significantly improve the run speed of ProPlot.');
		
		
	

uicontrol(figadd,...
	'Style','text',...
	'String','Would you like to Proceed?',...
	'Position',[10 50 250 20],...
	'ForegroundColor','w',...
	'BackgroundColor','k');


againadd=uicontrol(figadd,...
	'Style','checkbox',...
	'Value',1,...
	'String','Show this alert next time?',...
	'Position',[50 30 250 20],...
	'ForegroundColor','y',...
	'BackgroundColor','k',...
	'CallBack',['choice=get(againadd,''Value'');',...
		'if choice==1;',...
			'userdispaddon=1;',...
		'else;',...
			'userdispaddon=0;',...
		'end;',...
		'profly;',...%switch to onthefly directory and write
		'[fid]=fopen(''notifyda.m'',''wt'');',...
		'fprintf(fid,''%% *********************************************************\n'');',...
		'fprintf(fid,''%% **********   File Created by ProPlot 1.0   **************\n'');',...
		'fprintf(fid,''%% *********************************************************\n'');',...
		'fprintf(fid,''%% ---------------------------------------------------------\n'');',...
		'fprintf(fid,''%% *************** ProPlot written by **********************\n'');',...
		'fprintf(fid,''%% ********Scott Keane (skeane@uceng.uc.edu) ***************\n'');',...
		'fprintf(fid,''%% ---------------------------------------------------------\n'');',...
		'data=clock;',...
		'fprintf(fid,''%% ******* File written at %i:%i on %i-%i-%i *************** \n'',data(1,4),data(1,5),data(1,2),data(1,3),data(1,1));',...
		'fprintf(fid,''%% *********************************************************\n'');',...
		'fprintf(fid,''%% *********************************************************\n'');',...
		'fprintf(fid,''userdisphist=%i;\n'',userdisphist);',...
		'fprintf(fid,''userdispmult=%i;\n'',userdispmult);',...
		'fprintf(fid,''userdispaddon=%i;\n'',userdispaddon);',...
		'fclose(fid);',...
		'prodir;']);% switch back to proplot directory






uicontrol(figadd,...
	'Style','push',...
	'String','Yes',...
	'Position',[50 5 50 20],...
	'ForegroundColor','w',...
	'BackgroundColor','k',...
	'CallBack',['if exist(''axisdata''),',...
			'delete(axisdata);',...		
			'delete(axisscale);',...
			'delete(goodies);',...
			'delete(numeric);',...
			'delete(plottype);',...
			'delete(gridyn);',...
			'delete(timermenu);',...
			'delete(titlemenu);',...
		'end,',...
		'if exist(''warnuser'');',...
			'for jj=1:numoffigs;',...
				'set(warnuser(jj),''Separator'',''off'');',...
			'end;',...
		'end;',...
		'delete(enableaddon);close(figadd);clear figadd;']);


uicontrol(figadd,...
	'Style','push',...
	'String','No',...
	'Position',[150 5 50 20],...
	'ForegroundColor','w',...
	'BackgroundColor','k',...
	'CallBack',['enaddon=1;set(enableaddon,''Value'',1);close(figadd);clear figadd;']);


else

	if exist('axisdata')
			delete(axisdata);
			delete(axisscale);
			delete(goodies);
			delete(numeric);
			delete(plottype);
			delete(gridyn);
			delete(timermenu);
			delete(titlemenu);
	end
	delete(enableaddon);

end