% Version 1.0 of ProPlot 1.0
%
%    // cfit1.m \\
%
%     Scott Keane
%  skeane@uceng.uc.edu
%
% Created          11:21PM  2/26/96
% Last Modified    11:48 PM 6/21/96
%
% *****************************************
% Matlab script to create curve fit by menu
% and modify color single
% *****************************************


if numoffigs==1
	cfitsmart=[];
end

% *****************************************************************
% ********** Curve Fit *********************************
% *****************************************************************
cfitmenus(numoffigs)=uimenu(numeric(numoffigs),...
	'Label','&Curve Fit',...
	'Enable','off',...
	'Separator','on');


curvefit1(numoffigs)=uimenu(cfitmenus(numoffigs),...
	'Label','&1st Order',...
	'Separator','off',...
	'CallBack',['for bb=1:numoffigs,if figanddatawin(1,bb)==gcf,',...
		'currentfigurenum=bb;end,end,',...
		'if uniqueoneeach(currentfigurenum)~=1;',...
		'if isempty(plotvar)==1,',...
			'usefulinfo=zeros(1,3);',...
		'else,',...
			'plotvarinfo=existfun(plotvar);',...
			'if plotvarinfo(1,1)==0 | plotvarinfo(1,1)==-1,',...
				'usefulinfo=zeros(1,3);',...
			'else,',...
				'usefulinfo=get(plotvar(currentfigurenum,1),''UserData'');',...
			'end,',...
		'end,',...
		'lengthuseful=size(usefulinfo);',...
		'lengthuseful=lengthuseful(1,1);',...
		'countcircle=1;',...
		'for qw=1:lengthuseful,',...
			'if usefulinfo(qw,3)~=0,',...
				'dumaxis=axis;',...
				'getaxisvalue=axis;',...
				'pullxdata=get(plotvar(currentfigurenum,usefulinfo(qw,3)+1),''XData'');',...		
				'pullydata=get(plotvar(currentfigurenum,usefulinfo(qw,3)+1),''YData'');',...
				'flag=1;',...
				'for ind=length(pullxdata):-1:1;',...
					'if flag~=0;',...
						'xtointer=(pullxdata(ind)-pullxdata(1)).*.9;',...
						'if xtointer < dumaxis(1,2) & xtointer > dumaxis(1,1);',...
							'ytointer=interp1(pullxdata,pullydata,xtointer);',...
							'if ytointer < dumaxis(1,4) & ytointer > dumaxis(1,3);',...
								'smartcircle(countcircle,1)=xtointer;',...
								'smartcircle(countcircle,2)=ytointer;',...
								'smartcircle(countcircle,3)=qw;',...
								'axis(getaxisvalue);',...
								'hold on,tempcircle(countcircle,1)=plot(smartcircle(countcircle,1),smartcircle(countcircle,2),''wo'');',...
								'countcircle=countcircle+1;',...
								'flag=0;',...	
							'end,',...
						'end,',...
					'end;',...
				'end;',...
			'end;',...
		'end;',...
		'if countcircle~=1,',...
			'if timer~=0;',...
				'messtext=''Select data to curve fit'';',...
				'typeofcall=1;',...
			'messfun(typeofcall,messtext,currentfigurenum);',...
		'end;',...			
		'[numberofwinner]=closest(smartcircle);',...	% Call function to determine which entity was selected
			'delete(tempcircle);clear tempcircle;',...
			'num2modify=usefulinfo(smartcircle(numberofwinner,3),3);',...
			'xtofit=get(plotvar(currentfigurenum,num2modify+1),''XData'');',...
			'ytofit=get(plotvar(currentfigurenum,num2modify+1),''YData'');',...
			'[xfitted,yfitted,delta,coef]=cfitfun(xtofit,ytofit,1);',...
			'stamat=1+(currentfigurenum-1).*16;',...
			'if isempty(cfitsmart),',...
				'qw=1;',...
				'dumaxis=axis;axis(dumaxis);',...
				'hold on,cfitsmart(qw,stamat)=plot(xfitted,yfitted,''w'');',...
				'cfitsmart(qw,stamat+1)=1;',...%1 is fit
				'cfitsmart(qw,stamat+2:stamat+7)=[coef,zeros(1,6-length(coef))];',...
				'cfitsmart(qw,stamat+10:stamat+12)=get(cfitsmart(qw,stamat),''Color'');',...
				'cfitcolor=cfitsmart(qw,stamat+10:stamat+12);',...
				'if length(abs(get(cfitsmart(qw,stamat),''Linestyle'')))==1,',...			
					'cfitsmart(qw,stamat+13:stamat+14)=[abs(get(cfitsmart(qw,stamat),''Linestyle'')) 0];',...
				'else,',...
					'cfitsmart(qw,stamat+13:stamat+14)=abs(get(cfitsmart(qw,stamat),''Linestyle''));',...
				'end,',...	
				'textffun(cfitcolor,currentfigurenum,getaxisvalue,coef,textsmart);',...%function to add coef text
			'else,',...
				'flag=1;',...
				'lengthcfitsmart=size(cfitsmart);',...
				'lengthcfitsmart=lengthcfitsmart(1,1);',...
				'for qw=lengthcfitsmart:-1:1,',...
					'if flag==1,',...
						'if cfitsmart(qw,stamat)~=0,',...				
							'dumaxis=axis;axis(dumaxis);',...
							'colorsofcfit=[''g'',''m'',''b'',''r'',''y'',''c'',''w''];',...
							'hold on;cfitsmart(qw+1,stamat)=plot(xfitted,yfitted,setstr(colorsofcfit(ceil(rand*6.99))));',...
							'cfitsmart(qw+1,stamat+1)=1;',...%1 is fit
							'cfitsmart(qw+1,stamat+2:stamat+7)=[coef,zeros(1,6-length(coef))];',...
							'cfitsmart(qw+1,stamat+10:stamat+12)=get(cfitsmart(qw+1,stamat),''Color'');',...
							'cfitcolor=cfitsmart(qw+1,stamat+10:stamat+12);',...
							'if length(abs(get(cfitsmart(qw+1,stamat),''Linestyle'')))==1,',...			
								'cfitsmart(qw+1,stamat+13:stamat+14)=[abs(get(cfitsmart(qw+1,stamat),''Linestyle'')) 0];',...
							'else,',...
								'cfitsmart(qw+1,stamat+13:stamat+14)=abs(get(cfitsmart(qw+1,stamat),''Linestyle''));',...
							'end,',...					
							'flag=0;',...
							'textffun(cfitcolor,currentfigurenum,getaxisvalue,coef,textsmart);',...%function to add coef text
						'end,',...
						'if (cfitsmart(qw,stamat)==0 & qw==1),',...
							'dumaxis=axis;axis(dumaxis);',...
							'colorsofcfit=[''g'',''m'',''b'',''r'',''y'',''c'',''w''];',...
							'hold on;cfitsmart(qw,stamat)=plot(xfitted,yfitted,setstr(colorsofcfit(ceil(rand*6.99))));',...
							'cfitsmart(qw,stamat+1)=1;',...%1 is fit
							'cfitsmart(qw,stamat+2:stamat+7)=[coef,zeros(1,6-length(coef))];',...
							'cfitsmart(qw,stamat+10:stamat+12)=get(cfitsmart(qw,stamat),''Color'');',...
							'cfitcolor=cfitsmart(qw,stamat+10:stamat+12);',...
							'if length(abs(get(cfitsmart(qw,stamat),''Linestyle'')))==1,',...			
								'cfitsmart(qw,stamat+13:stamat+14)=[abs(get(cfitsmart(qw,stamat),''Linestyle'')) 0];',...
							'else,',...
								'cfitsmart(qw,stamat+13:stamat+14)=abs(get(cfitsmart(qw,stamat),''Linestyle''));',...
							'end,',...					
							'flag=0;',...
							'textffun(cfitcolor,currentfigurenum,getaxisvalue,coef,textsmart);',...%function to add coef text
						'end,',...
					'end,',...
				'end,',...
			'end;',...
		'end;',...
		'end;',...
		'set(modifycfitssingle(currentfigurenum),''Enable'',''on'');',...
		'set(removecfitsall(currentfigurenum),''Enable'',''on'');',...
		'set(modifytextssingle(currentfigurenum),''Enable'',''on'');',...
		'set(modifytextsall(currentfigurenum),''Enable'',''on'');',...
		'set(rootspro(currentfigurenum),''Enable'',''on'');',...
		'end']);



% *********************************************************************
% ************* 2nd order curve fit ***********************************
% *********************************************************************

curvefit2(numoffigs)=uimenu(cfitmenus(numoffigs),...
	'Label','&2nd Order',...
	'Separator','off',...
	'CallBack',['for bb=1:numoffigs,if figanddatawin(1,bb)==gcf,',...
		'currentfigurenum=bb;end,end,',...
		'if uniqueoneeach(currentfigurenum)~=1;',...
		'if isempty(plotvar)==1,',...
			'usefulinfo=zeros(1,3);',...
		'else,',...
			'plotvarinfo=existfun(plotvar);',...
			'if plotvarinfo(1,1)==0 | plotvarinfo(1,1)==-1,',...
				'usefulinfo=zeros(1,3);',...
			'else,',...
				'usefulinfo=get(plotvar(currentfigurenum,1),''UserData'');',...
			'end,',...
		'end,',...
		'lengthuseful=size(usefulinfo);',...
		'lengthuseful=lengthuseful(1,1);',...
		'countcircle=1;',...
		'for qw=1:lengthuseful,',...
			'if usefulinfo(qw,3)~=0,',...
				'dumaxis=axis;',...
				'getaxisvalue=axis;',...
				'pullxdata=get(plotvar(currentfigurenum,usefulinfo(qw,3)+1),''XData'');',...		
				'pullydata=get(plotvar(currentfigurenum,usefulinfo(qw,3)+1),''YData'');',...
				'flag=1;',...
				'for ind=length(pullxdata):-1:1;',...
					'if flag~=0;',...
						'xtointer=(pullxdata(ind)-pullxdata(1)).*.9;',...
						'if xtointer < dumaxis(1,2) & xtointer > dumaxis(1,1);',...
							'ytointer=interp1(pullxdata,pullydata,xtointer);',...
							'if ytointer < dumaxis(1,4) & ytointer > dumaxis(1,3);',...
								'smartcircle(countcircle,1)=xtointer;',...
								'smartcircle(countcircle,2)=ytointer;',...
								'smartcircle(countcircle,3)=qw;',...
								'axis(getaxisvalue);',...
								'hold on,tempcircle(countcircle,1)=plot(smartcircle(countcircle,1),smartcircle(countcircle,2),''wo'');',...
								'countcircle=countcircle+1;',...
								'flag=0;',...	
							'end,',...
						'end,',...
					'end;',...
				'end;',...
			'end;',...
		'end;',...
		'if countcircle~=1,',...
			'if timer~=0;',...
				'messtext=''Select data for curve fit'';',...
				'typeofcall=1;',...
				'messfun(typeofcall,messtext,currentfigurenum);',...
			'end;',...			
			'[numberofwinner]=closest(smartcircle);',...% Call function to determine which entity was selected
			'delete(tempcircle);clear tempcircle;',...
			'num2modify=usefulinfo(smartcircle(numberofwinner,3),3);',...
			'xtofit=get(plotvar(currentfigurenum,num2modify+1),''XData'');',...
			'ytofit=get(plotvar(currentfigurenum,num2modify+1),''YData'');',...
			'[xfitted,yfitted,delta,coef]=cfitfun(xtofit,ytofit,2);',...
			'stamat=1+(currentfigurenum-1).*16;',...
			'if isempty(cfitsmart),',...
				'qw=1;',...
				'dumaxis=axis;axis(dumaxis);',...
				'hold on,cfitsmart(qw,stamat)=plot(xfitted,yfitted,''w'');',...
				'cfitsmart(qw,stamat+1)=2;',...%2 is fit
				'cfitsmart(qw,stamat+2:stamat+7)=[coef,zeros(1,6-length(coef))];',...
				'cfitsmart(qw,stamat+10:stamat+12)=get(cfitsmart(qw,stamat),''Color'');',...
				'cfitcolor=cfitsmart(qw,stamat+10:stamat+12);',...
				'if length(abs(get(cfitsmart(qw,stamat),''Linestyle'')))==1,',...			
					'cfitsmart(qw,stamat+13:stamat+14)=[abs(get(cfitsmart(qw,stamat),''Linestyle'')) 0];',...
				'else,',...
					'cfitsmart(qw,stamat+13:stamat+14)=abs(get(cfitsmart(qw,stamat),''Linestyle''));',...
				'end,',...	
				'textffun(cfitcolor,currentfigurenum,getaxisvalue,coef,textsmart);',...%function to add coef text
			'else,',...
				'flag=1;',...
				'lengthcfitsmart=size(cfitsmart);',...
				'lengthcfitsmart=lengthcfitsmart(1,1);',...
				'for qw=lengthcfitsmart:-1:1,',...
					'if flag==1,',...
						'if cfitsmart(qw,stamat)~=0,',...				
							'dumaxis=axis;axis(dumaxis);',...
							'colorsofcfit=[''g'',''m'',''b'',''r'',''y'',''c'',''w''];',...
							'hold on;cfitsmart(qw+1,stamat)=plot(xfitted,yfitted,setstr(colorsofcfit(ceil(rand*6.99))));',...
							'cfitsmart(qw+1,stamat+1)=2;',...%2 is fit
							'cfitsmart(qw+1,stamat+2:stamat+7)=[coef,zeros(1,6-length(coef))];',...
							'cfitsmart(qw+1,stamat+10:stamat+12)=get(cfitsmart(qw+1,stamat),''Color'');',...
							'cfitcolor=cfitsmart(qw+1,stamat+10:stamat+12);',...
							'if length(abs(get(cfitsmart(qw+1,stamat),''Linestyle'')))==1,',...			
								'cfitsmart(qw+1,stamat+13:stamat+14)=[abs(get(cfitsmart(qw+1,stamat),''Linestyle'')) 0];',...
							'else,',...
								'cfitsmart(qw+1,stamat+13:stamat+14)=abs(get(cfitsmart(qw+1,stamat),''Linestyle''));',...
							'end,',...					
							'flag=0;',...
							'textffun(cfitcolor,currentfigurenum,getaxisvalue,coef,textsmart);',...%function to add coef text
						'end,',...
						'if (cfitsmart(qw,stamat)==0 & qw==1),',...
							'dumaxis=axis;axis(dumaxis);',...
							'colorsofcfit=[''g'',''m'',''b'',''r'',''y'',''c'',''w''];',...
							'hold on;cfitsmart(qw,stamat)=plot(xfitted,yfitted,setstr(colorsofcfit(ceil(rand*6.99))));',...
							'cfitsmart(qw,stamat+1)=2;',...%2 is fit
							'cfitsmart(qw,stamat+2:stamat+7)=[coef,zeros(1,6-length(coef))];',...
							'cfitsmart(qw,stamat+10:stamat+12)=get(cfitsmart(qw,stamat),''Color'');',...
							'cfitcolor=cfitsmart(qw,stamat+10:stamat+12);',...
							'if length(abs(get(cfitsmart(qw,stamat),''Linestyle'')))==1,',...			
								'cfitsmart(qw,stamat+13:stamat+14)=[abs(get(cfitsmart(qw,stamat),''Linestyle'')) 0];',...
							'else,',...
								'cfitsmart(qw,stamat+13:stamat+14)=abs(get(cfitsmart(qw,stamat),''Linestyle''));',...
							'end,',...					
							'flag=0;',...
							'textffun(cfitcolor,currentfigurenum,getaxisvalue,coef,textsmart);',...%function to add coef text
						'end,',...
					'end,',...
				'end,',...
			'end;',...
		'end;',...
		'end;',...
		'set(modifycfitssingle(currentfigurenum),''Enable'',''on'');',...
		'set(removecfitsall(currentfigurenum),''Enable'',''on'');',...
		'set(modifytextssingle(currentfigurenum),''Enable'',''on'');',...
		'set(modifytextsall(currentfigurenum),''Enable'',''on'');',...
		'set(rootspro(currentfigurenum),''Enable'',''on'');',...
		'end']);



% *********************************************************************
% ************* 3rd order curve fit ***********************************
% *********************************************************************

curvefit3(numoffigs)=uimenu(cfitmenus(numoffigs),...
	'Label','&3rd Order',...
	'Separator','off',...
	'CallBack',['for bb=1:numoffigs,if figanddatawin(1,bb)==gcf,',...
		'currentfigurenum=bb;end,end,',...
		'if uniqueoneeach(currentfigurenum)~=1;',...
		'if isempty(plotvar)==1,',...
			'usefulinfo=zeros(1,3);',...
		'else,',...
			'plotvarinfo=existfun(plotvar);',...
			'if plotvarinfo(1,1)==0 | plotvarinfo(1,1)==-1,',...
				'usefulinfo=zeros(1,3);',...
			'else,',...
				'usefulinfo=get(plotvar(currentfigurenum,1),''UserData'');',...
			'end,',...
		'end,',...
		'lengthuseful=size(usefulinfo);',...
		'lengthuseful=lengthuseful(1,1);',...
		'countcircle=1;',...
		'for qw=1:lengthuseful,',...
			'if usefulinfo(qw,3)~=0,',...
				'dumaxis=axis;',...
				'getaxisvalue=axis;',...
				'pullxdata=get(plotvar(currentfigurenum,usefulinfo(qw,3)+1),''XData'');',...		
				'pullydata=get(plotvar(currentfigurenum,usefulinfo(qw,3)+1),''YData'');',...
				'flag=1;',...
				'for ind=length(pullxdata):-1:1;',...
					'if flag~=0;',...
						'xtointer=(pullxdata(ind)-pullxdata(1)).*.9;',...
						'if xtointer < dumaxis(1,2) & xtointer > dumaxis(1,1);',...
							'ytointer=interp1(pullxdata,pullydata,xtointer);',...
							'if ytointer < dumaxis(1,4) & ytointer > dumaxis(1,3);',...
								'smartcircle(countcircle,1)=xtointer;',...
								'smartcircle(countcircle,2)=ytointer;',...
								'smartcircle(countcircle,3)=qw;',...
								'axis(getaxisvalue);',...
								'hold on,tempcircle(countcircle,1)=plot(smartcircle(countcircle,1),smartcircle(countcircle,2),''wo'');',...
								'countcircle=countcircle+1;',...
								'flag=0;',...	
							'end,',...
						'end,',...
					'end;',...
				'end;',...
			'end;',...
		'end;',...
		'if countcircle~=1,',...
			'if timer~=0;',...
				'messtext=''Select data to curve fit'';',...
				'typeofcall=1;',...
				'messfun(typeofcall,messtext,currentfigurenum);',...
			'end;',...			
			'[numberofwinner]=closest(smartcircle);',...	% Call function to determine which entity was selected			
			'delete(tempcircle);clear tempcircle;',...
			'num2modify=usefulinfo(smartcircle(numberofwinner,3),3);',...
			'xtofit=get(plotvar(currentfigurenum,num2modify+1),''XData'');',...
			'ytofit=get(plotvar(currentfigurenum,num2modify+1),''YData'');',...
			'[xfitted,yfitted,delta,coef]=cfitfun(xtofit,ytofit,3);',...
			'stamat=1+(currentfigurenum-1).*16;',...
			'if isempty(cfitsmart),',...
				'qw=1;',...
				'dumaxis=axis;axis(dumaxis);',...
				'hold on,cfitsmart(qw,stamat)=plot(xfitted,yfitted,''w'');',...
				'cfitsmart(qw,stamat+1)=3;',...%3 is fit
				'cfitsmart(qw,stamat+2:stamat+7)=[coef,zeros(1,6-length(coef))];',...
				'cfitsmart(qw,stamat+10:stamat+12)=get(cfitsmart(qw,stamat),''Color'');',...
				'cfitcolor=cfitsmart(qw,stamat+10:stamat+12);',...
				'if length(abs(get(cfitsmart(qw,stamat),''Linestyle'')))==1,',...			
					'cfitsmart(qw,stamat+13:stamat+14)=[abs(get(cfitsmart(qw,stamat),''Linestyle'')) 0];',...
				'else,',...
					'cfitsmart(qw,stamat+13:stamat+14)=abs(get(cfitsmart(qw,stamat),''Linestyle''));',...
				'end,',...	
				'textffun(cfitcolor,currentfigurenum,getaxisvalue,coef,textsmart);',...%function to add coef text
			'else,',...
				'flag=1;',...
				'lengthcfitsmart=size(cfitsmart);',...
				'lengthcfitsmart=lengthcfitsmart(1,1);',...
				'for qw=lengthcfitsmart:-1:1,',...
					'if flag==1,',...
						'if cfitsmart(qw,stamat)~=0,',...				
							'dumaxis=axis;axis(dumaxis);',...
							'colorsofcfit=[''g'',''m'',''b'',''r'',''y'',''c'',''w''];',...
							'hold on;cfitsmart(qw+1,stamat)=plot(xfitted,yfitted,setstr(colorsofcfit(ceil(rand*6.99))));',...
							'cfitsmart(qw+1,stamat+1)=3;',...%3 is fit
							'cfitsmart(qw+1,stamat+2:stamat+7)=[coef,zeros(1,6-length(coef))];',...
							'cfitsmart(qw+1,stamat+10:stamat+12)=get(cfitsmart(qw+1,stamat),''Color'');',...
							'cfitcolor=cfitsmart(qw+1,stamat+10:stamat+12);',...
							'if length(abs(get(cfitsmart(qw+1,stamat),''Linestyle'')))==1,',...			
								'cfitsmart(qw+1,stamat+13:stamat+14)=[abs(get(cfitsmart(qw+1,stamat),''Linestyle'')) 0];',...
							'else,',...
								'cfitsmart(qw+1,stamat+13:stamat+14)=abs(get(cfitsmart(qw+1,stamat),''Linestyle''));',...
							'end,',...					
							'flag=0;',...
							'textffun(cfitcolor,currentfigurenum,getaxisvalue,coef,textsmart);',...%function to add coef text
						'end,',...
						'if (cfitsmart(qw,stamat)==0 & qw==1),',...
							'dumaxis=axis;axis(dumaxis);',...
							'colorsofcfit=[''g'',''m'',''b'',''r'',''y'',''c'',''w''];',...
							'hold on;cfitsmart(qw,stamat)=plot(xfitted,yfitted,setstr(colorsofcfit(ceil(rand*6.99))));',...
							'cfitsmart(qw,stamat+1)=3;',...%3 is fit
							'cfitsmart(qw,stamat+2:stamat+7)=[coef,zeros(1,6-length(coef))];',...
							'cfitsmart(qw,stamat+10:stamat+12)=get(cfitsmart(qw,stamat),''Color'');',...
							'cfitcolor=cfitsmart(qw,stamat+10:stamat+12);',...
							'if length(abs(get(cfitsmart(qw,stamat),''Linestyle'')))==1,',...			
								'cfitsmart(qw,stamat+13:stamat+14)=[abs(get(cfitsmart(qw,stamat),''Linestyle'')) 0];',...
							'else,',...
								'cfitsmart(qw,stamat+13:stamat+14)=abs(get(cfitsmart(qw,stamat),''Linestyle''));',...
							'end,',...					
							'flag=0;',...
							'textffun(cfitcolor,currentfigurenum,getaxisvalue,coef,textsmart);',...%function to add coef text
						'end,',...
					'end,',...
				'end,',...
			'end;',...
		'end;',...
		'end;',...
		'set(modifycfitssingle(currentfigurenum),''Enable'',''on'');',...
		'set(removecfitsall(currentfigurenum),''Enable'',''on'');',...
		'set(modifytextssingle(currentfigurenum),''Enable'',''on'');',...
		'set(modifytextsall(currentfigurenum),''Enable'',''on'');',...
		'set(rootspro(currentfigurenum),''Enable'',''on'');',...
		'end']);



% *********************************************************************
% ************* 4th order curve fit ***********************************
% *********************************************************************

curvefit4(numoffigs)=uimenu(cfitmenus(numoffigs),...
	'Label','&4th Order',...
	'Separator','off',...
	'CallBack',['for bb=1:numoffigs,if figanddatawin(1,bb)==gcf,',...
		'currentfigurenum=bb;end,end,',...
		'if uniqueoneeach(currentfigurenum)~=1;',...
		'if isempty(plotvar)==1,',...
			'usefulinfo=zeros(1,3);',...
		'else,',...
			'plotvarinfo=existfun(plotvar);',...
			'if plotvarinfo(1,1)==0 | plotvarinfo(1,1)==-1,',...
				'usefulinfo=zeros(1,3);',...
			'else,',...
				'usefulinfo=get(plotvar(currentfigurenum,1),''UserData'');',...
			'end,',...
		'end,',...
		'lengthuseful=size(usefulinfo);',...
		'lengthuseful=lengthuseful(1,1);',...
		'countcircle=1;',...
		'for qw=1:lengthuseful,',...
			'if usefulinfo(qw,3)~=0,',...
				'dumaxis=axis;',...
				'getaxisvalue=axis;',...
				'pullxdata=get(plotvar(currentfigurenum,usefulinfo(qw,3)+1),''XData'');',...		
				'pullydata=get(plotvar(currentfigurenum,usefulinfo(qw,3)+1),''YData'');',...
				'flag=1;',...
				'for ind=length(pullxdata):-1:1;',...
					'if flag~=0;',...
						'xtointer=(pullxdata(ind)-pullxdata(1)).*.9;',...
						'if xtointer < dumaxis(1,2) & xtointer > dumaxis(1,1);',...
							'ytointer=interp1(pullxdata,pullydata,xtointer);',...
							'if ytointer < dumaxis(1,4) & ytointer > dumaxis(1,3);',...
								'smartcircle(countcircle,1)=xtointer;',...
								'smartcircle(countcircle,2)=ytointer;',...
								'smartcircle(countcircle,3)=qw;',...
								'axis(getaxisvalue);',...
								'hold on,tempcircle(countcircle,1)=plot(smartcircle(countcircle,1),smartcircle(countcircle,2),''wo'');',...
								'countcircle=countcircle+1;',...
								'flag=0;',...	
							'end,',...
						'end,',...
					'end;',...
				'end;',...
			'end;',...
		'end;',...
		'if countcircle~=1,',...
			'if timer~=0;',...
				'messtext=''Select data to curve fit'';',...
				'typeofcall=1;',...
				'messfun(typeofcall,messtext,currentfigurenum);',...
			'end;',...
			'[numberofwinner]=closest(smartcircle);',...		% Call function to determine which entity was selected
			'delete(tempcircle);clear tempcircle;',...
			'num2modify=usefulinfo(smartcircle(numberofwinner,3),3);',...
			'xtofit=get(plotvar(currentfigurenum,num2modify+1),''XData'');',...
			'ytofit=get(plotvar(currentfigurenum,num2modify+1),''YData'');',...
			'[xfitted,yfitted,delta,coef]=cfitfun(xtofit,ytofit,4);',...
			'stamat=1+(currentfigurenum-1).*16;',...
			'if isempty(cfitsmart),',...
				'qw=1;',...
				'dumaxis=axis;axis(dumaxis);',...
				'hold on,cfitsmart(qw,stamat)=plot(xfitted,yfitted,''w'');',...
				'cfitsmart(qw,stamat+1)=4;',...%4 is fit
				'cfitsmart(qw,stamat+2:stamat+7)=[coef,zeros(1,6-length(coef))];',...
				'cfitsmart(qw,stamat+10:stamat+12)=get(cfitsmart(qw,stamat),''Color'');',...
				'cfitcolor=cfitsmart(qw,stamat+10:stamat+12);',...
				'if length(abs(get(cfitsmart(qw,stamat),''Linestyle'')))==1,',...			
					'cfitsmart(qw,stamat+13:stamat+14)=[abs(get(cfitsmart(qw,stamat),''Linestyle'')) 0];',...
				'else,',...
					'cfitsmart(qw,stamat+13:stamat+14)=abs(get(cfitsmart(qw,stamat),''Linestyle''));',...
				'end,',...	
				'textffun(cfitcolor,currentfigurenum,getaxisvalue,coef,textsmart);',...%function to add coef text
			'else,',...
				'flag=1;',...
				'lengthcfitsmart=size(cfitsmart);',...
				'lengthcfitsmart=lengthcfitsmart(1,1);',...
				'for qw=lengthcfitsmart:-1:1,',...
					'if flag==1,',...
						'if cfitsmart(qw,stamat)~=0,',...				
							'dumaxis=axis;axis(dumaxis);',...
							'colorsofcfit=[''g'',''m'',''b'',''r'',''y'',''c'',''w''];',...
							'hold on;cfitsmart(qw+1,stamat)=plot(xfitted,yfitted,setstr(colorsofcfit(ceil(rand*6.99))));',...
							'cfitsmart(qw+1,stamat+1)=4;',...%4 is fit
							'cfitsmart(qw+1,stamat+2:stamat+7)=[coef,zeros(1,6-length(coef))];',...
							'cfitsmart(qw+1,stamat+10:stamat+12)=get(cfitsmart(qw+1,stamat),''Color'');',...
							'cfitcolor=cfitsmart(qw+1,stamat+10:stamat+12);',...
							'if length(abs(get(cfitsmart(qw+1,stamat),''Linestyle'')))==1,',...			
								'cfitsmart(qw+1,stamat+13:stamat+14)=[abs(get(cfitsmart(qw+1,stamat),''Linestyle'')) 0];',...
							'else,',...
								'cfitsmart(qw+1,stamat+13:stamat+14)=abs(get(cfitsmart(qw+1,stamat),''Linestyle''));',...
							'end,',...					
							'flag=0;',...
							'textffun(cfitcolor,currentfigurenum,getaxisvalue,coef,textsmart);',...%function to add coef text
						'end,',...
						'if (cfitsmart(qw,stamat)==0 & qw==1),',...
							'dumaxis=axis;axis(dumaxis);',...
							'colorsofcfit=[''g'',''m'',''b'',''r'',''y'',''c'',''w''];',...
							'hold on;cfitsmart(qw,stamat)=plot(xfitted,yfitted,setstr(colorsofcfit(ceil(rand*6.99))));',...
							'cfitsmart(qw,stamat+1)=4;',...%4 is fit
							'cfitsmart(qw,stamat+2:stamat+7)=[coef,zeros(1,6-length(coef))];',...
							'cfitsmart(qw,stamat+10:stamat+12)=get(cfitsmart(qw,stamat),''Color'');',...
							'cfitcolor=cfitsmart(qw,stamat+10:stamat+12);',...
							'if length(abs(get(cfitsmart(qw,stamat),''Linestyle'')))==1,',...			
								'cfitsmart(qw,stamat+13:stamat+14)=[abs(get(cfitsmart(qw,stamat),''Linestyle'')) 0];',...
							'else,',...
								'cfitsmart(qw,stamat+13:stamat+14)=abs(get(cfitsmart(qw,stamat),''Linestyle''));',...
							'end,',...					
							'flag=0;',...
							'textffun(cfitcolor,currentfigurenum,getaxisvalue,coef,textsmart);',...%function to add coef text
						'end,',...
					'end,',...
				'end,',...
			'end;',...
		'end;',...
		'end;',...
		'set(modifycfitssingle(currentfigurenum),''Enable'',''on'');',...
		'set(removecfitsall(currentfigurenum),''Enable'',''on'');',...
		'set(modifytextssingle(currentfigurenum),''Enable'',''on'');',...
		'set(modifytextsall(currentfigurenum),''Enable'',''on'');',...
		'set(rootspro(currentfigurenum),''Enable'',''on'');',...
		'end']);






% *********************************************************************
% ************* 5th order curve fit ***********************************
% *********************************************************************

curvefit5(numoffigs)=uimenu(cfitmenus(numoffigs),...
	'Label','&5th Order',...
	'Separator','off',...
	'CallBack',['for bb=1:numoffigs,if figanddatawin(1,bb)==gcf,',...
		'currentfigurenum=bb;end,end,',...
		'if uniqueoneeach(currentfigurenum)~=1;',...
		'if isempty(plotvar)==1,',...
			'usefulinfo=zeros(1,3);',...
		'else,',...
			'plotvarinfo=existfun(plotvar);',...
			'if plotvarinfo(1,1)==0 | plotvarinfo(1,1)==-1,',...
				'usefulinfo=zeros(1,3);',...
			'else,',...
				'usefulinfo=get(plotvar(currentfigurenum,1),''UserData'');',...
			'end,',...
		'end,',...
		'lengthuseful=size(usefulinfo);',...
		'lengthuseful=lengthuseful(1,1);',...
		'countcircle=1;',...
		'for qw=1:lengthuseful,',...
			'if usefulinfo(qw,3)~=0,',...
				'dumaxis=axis;',...
				'getaxisvalue=axis;',...
				'pullxdata=get(plotvar(currentfigurenum,usefulinfo(qw,3)+1),''XData'');',...		
				'pullydata=get(plotvar(currentfigurenum,usefulinfo(qw,3)+1),''YData'');',...
				'flag=1;',...
				'for ind=length(pullxdata):-1:1;',...
					'if flag~=0;',...
						'xtointer=(pullxdata(ind)-pullxdata(1)).*.9;',...
						'if xtointer < dumaxis(1,2) & xtointer > dumaxis(1,1);',...
							'ytointer=interp1(pullxdata,pullydata,xtointer);',...
							'if ytointer < dumaxis(1,4) & ytointer > dumaxis(1,3);',...
								'smartcircle(countcircle,1)=xtointer;',...
								'smartcircle(countcircle,2)=ytointer;',...
								'smartcircle(countcircle,3)=qw;',...
								'axis(getaxisvalue);',...
								'hold on,tempcircle(countcircle,1)=plot(smartcircle(countcircle,1),smartcircle(countcircle,2),''wo'');',...
								'countcircle=countcircle+1;',...
								'flag=0;',...	
							'end,',...
						'end,',...
					'end;',...
				'end;',...
			'end;',...
		'end;',...
		'if countcircle~=1,',...
			'if timer~=0;',...
				'messtext=''Select data to curve fit'';',...
				'typeofcall=1;',...
				'messfun(typeofcall,messtext,currentfigurenum);',...
			'end;',...
			'[numberofwinner]=closest(smartcircle);',...	% Call function to determine which entity was selected			
			'delete(tempcircle);clear tempcircle;',...
			'num2modify=usefulinfo(smartcircle(numberofwinner,3),3);',...
			'xtofit=get(plotvar(currentfigurenum,num2modify+1),''XData'');',...
			'ytofit=get(plotvar(currentfigurenum,num2modify+1),''YData'');',...
			'[xfitted,yfitted,delta,coef]=cfitfun(xtofit,ytofit,5);',...
			'stamat=1+(currentfigurenum-1).*16;',...
			'if isempty(cfitsmart),',...
				'qw=1;',...
				'dumaxis=axis;axis(dumaxis);',...
				'hold on,cfitsmart(qw,stamat)=plot(xfitted,yfitted,''w'');',...
				'cfitsmart(qw,stamat+1)=5;',...%5 is fit
				'cfitsmart(qw,stamat+2:stamat+7)=[coef,zeros(1,6-length(coef))];',...
				'cfitsmart(qw,stamat+10:stamat+12)=get(cfitsmart(qw,stamat),''Color'');',...
				'cfitcolor=cfitsmart(qw,stamat+10:stamat+12);',...
				'if length(abs(get(cfitsmart(qw,stamat),''Linestyle'')))==1,',...			
					'cfitsmart(qw,stamat+13:stamat+14)=[abs(get(cfitsmart(qw,stamat),''Linestyle'')) 0];',...
				'else,',...
					'cfitsmart(qw,stamat+13:stamat+14)=abs(get(cfitsmart(qw,stamat),''Linestyle''));',...
				'end,',...	
				'textffun(cfitcolor,currentfigurenum,getaxisvalue,coef,textsmart);',...%function to add coef text
			'else,',...
				'flag=1;',...
				'lengthcfitsmart=size(cfitsmart);',...
				'lengthcfitsmart=lengthcfitsmart(1,1);',...
				'for qw=lengthcfitsmart:-1:1,',...
					'if flag==1,',...
						'if cfitsmart(qw,stamat)~=0,',...				
							'dumaxis=axis;axis(dumaxis);',...
							'colorsofcfit=[''g'',''m'',''b'',''r'',''y'',''c'',''w''];',...
							'hold on;cfitsmart(qw+1,stamat)=plot(xfitted,yfitted,setstr(colorsofcfit(ceil(rand*6.99))));',...
							'cfitsmart(qw+1,stamat+1)=5;',...%5 is fit
							'cfitsmart(qw+1,stamat+2:stamat+7)=[coef,zeros(1,6-length(coef))];',...
							'cfitsmart(qw+1,stamat+10:stamat+12)=get(cfitsmart(qw+1,stamat),''Color'');',...
							'cfitcolor=cfitsmart(qw+1,stamat+10:stamat+12);',...
							'if length(abs(get(cfitsmart(qw+1,stamat),''Linestyle'')))==1,',...			
								'cfitsmart(qw+1,stamat+13:stamat+14)=[abs(get(cfitsmart(qw+1,stamat),''Linestyle'')) 0];',...
							'else,',...
								'cfitsmart(qw+1,stamat+13:stamat+14)=abs(get(cfitsmart(qw+1,stamat),''Linestyle''));',...
							'end,',...					
							'flag=0;',...
							'textffun(cfitcolor,currentfigurenum,getaxisvalue,coef,textsmart);',...%function to add coef text
						'end,',...
						'if (cfitsmart(qw,stamat)==0 & qw==1),',...
							'dumaxis=axis;axis(dumaxis);',...
							'colorsofcfit=[''g'',''m'',''b'',''r'',''y'',''c'',''w''];',...
							'hold on;cfitsmart(qw,stamat)=plot(xfitted,yfitted,setstr(colorsofcfit(ceil(rand*6.99))));',...
							'cfitsmart(qw,stamat+1)=5;',...%5 is fit
							'cfitsmart(qw,stamat+2:stamat+7)=[coef,zeros(1,6-length(coef))];',...
							'cfitsmart(qw,stamat+10:stamat+12)=get(cfitsmart(qw,stamat),''Color'');',...
							'cfitcolor=cfitsmart(qw,stamat+10:stamat+12);',...
							'if length(abs(get(cfitsmart(qw,stamat),''Linestyle'')))==1,',...			
								'cfitsmart(qw,stamat+13:stamat+14)=[abs(get(cfitsmart(qw,stamat),''Linestyle'')) 0];',...
							'else,',...
								'cfitsmart(qw,stamat+13:stamat+14)=abs(get(cfitsmart(qw,stamat),''Linestyle''));',...
							'end,',...					
							'flag=0;',...
							'textffun(cfitcolor,currentfigurenum,getaxisvalue,coef,textsmart);',...%function to add coef text
						'end,',...
					'end,',...
				'end,',...
			'end;',...
		'end;',...
		'end;',...
		'set(modifycfitssingle(currentfigurenum),''Enable'',''on'');',...
		'set(removecfitsall(currentfigurenum),''Enable'',''on'');',...
		'set(modifytextssingle(currentfigurenum),''Enable'',''on'');',...
		'set(modifytextsall(currentfigurenum),''Enable'',''on'');',...
		'set(rootspro(currentfigurenum),''Enable'',''on'');',...
		'end']);


rootspro(numoffigs)=uimenu(cfitmenus(numoffigs),...
	'Label','&Find Roots',...
	'Enable','off',...
	'Separator','off',...
	'CallBack',['for bb=1:numoffigs,if figanddatawin(1,bb)==gcf,',...
		'currentfigurenum=bb;end,end,',...
		'stamat=1+(currentfigurenum-1).*16;',...
		'lengthcfitsmart=size(cfitsmart);',...
		'lengthcfitsmart=lengthcfitsmart(1,1);',...
		'countcircle=1;',...
		'dumaxis=axis;',...
		'for qw=1:lengthcfitsmart,',...
			'if cfitsmart(qw,stamat)~=0,',...
				'xget=get(cfitsmart(qw,stamat),''XData'');',...
				'yget=get(cfitsmart(qw,stamat),''YData'');',...
				'[sortdatax,indicex]=sort(xget);',...
				'indicex=fliplr(indicex);',...
				'flag=1;',...
				'for xc=1:length(xget);',...
					'if flag~=0;',...
						'if xget(indicex(xc)) < dumaxis(1,2) & xget(indicex(xc)) > dumaxis(1,1);',...
							'if yget(indicex(xc)) < dumaxis(1,4) & yget(indicex(xc)) > dumaxis(1,3);',...
								'smartcircle(countcircle,1:2)=[xget(indicex(xc)),yget(indicex(xc))];',...
								'smartcircle(countcircle,3)=qw;',...
								'tempcircle(countcircle,1)=plot(smartcircle(countcircle,1),smartcircle(countcircle,2),''wo'');',...
								'countcircle=countcircle+1;',...	
								'flag=0;',...
							'end;',...
						'end;',...
					'end;',...
				'end;',...
			'end,',...
		'end,',...
		'if countcircle~=1,',...
		'if timer~=0;',...
			'messtext=''Select curve fit to find roots of'';',...
			'typeofcall=1;',...
			'messfun(typeofcall,messtext,currentfigurenum);',...
		'end;',...
		'[numberofwinner]=closest(smartcircle);',...	% Call function to determine which entity was selected			
		'coefs_to_process=cfitsmart(smartcircle(numberofwinner,3),stamat+2:stamat+7);',...
		'num_roots=cfitsmart(smartcircle(numberofwinner,3),stamat+1);',...
		'roots_to_process=roots(coefs_to_process(1:num_roots+1));',...	
		'to_plot=[];',...%got a matrix exceeds matrix dimensions....
		'for j=1:num_roots;',...
			'if j==1;',...
				'to_plot=[num2str(roots_to_process(j))];',...
			'else;',...
				'to_plot=[to_plot,'', '',num2str(roots_to_process(j))];',...% add comma between roots on screen
			'end;',...
		'end;',...
		'texttoadd=[''Roots= '',to_plot];',...
		'typeofcall=4;',...
		'textfun(0,0,currentfigurenum,texttoadd,typeofcall);',...
		'delete(tempcircle);clear tempcircle;end']);	
