% Version 1.0 of ProPlot 1.0
%
%    // cfit3.m \\
%
%     Scott Keane
%  skeane@uceng.uc.edu
%
% Created          11:21PM  2/26/96
% Last Modified    11:31PM  2/29/96
%
% *****************************************
% Matlab script to modify linetype of
% single curve fits
% *****************************************



% ****************************************************************
% ********************* Modify Curve Type Single ******************
% ****************************************************************

typecfitssingle(numoffigs)=uimenu(modifycfitssingle(numoffigs),...
	'Label','&Line Type',...
	'Separator','on');


dottedcfitsingle(numoffigs)=uimenu(typecfitssingle(numoffigs),...
	'Label','&dotted',...
	'Checked','off',...
	'CallBack',['for bb=1:numoffigs,if figanddatawin(1,bb)==gcf,',...
		'currentfigurenum=bb;end,end,',...
		'stamat=1+(currentfigurenum-1).*16;',...
		'lengthcfitsmart=size(cfitsmart);',...
		'lengthcfitsmart=lengthcfitsmart(1,1);',...
		'countcircle=1;',...
		'dumaxis=axis;',...
		'for qw=1:lengthcfitsmart,',...
			'if cfitsmart(qw,stamat)~=0,',...
				'xget=get(cfitsmart(qw,stamat),''XData'');',...
				'yget=get(cfitsmart(qw,stamat),''YData'');',...
				'[sortdatax,indicex]=sort(xget);',...
				'indicex=fliplr(indicex);',...
				'flag=1;',...
				'for xc=1:length(xget);',...
					'if flag~=0;',...
						'if xget(indicex(xc)) < dumaxis(1,2) & xget(indicex(xc)) > dumaxis(1,1);',...
							'if yget(indicex(xc)) < dumaxis(1,4) & yget(indicex(xc)) > dumaxis(1,3);',...
								'smartcircle(countcircle,1:2)=[xget(indicex(xc)),yget(indicex(xc))];',...
								'smartcircle(countcircle,3)=qw;',...
								'tempcircle(countcircle,1)=plot(smartcircle(countcircle,1),smartcircle(countcircle,2),''wo'');',...
								'countcircle=countcircle+1;',...	
								'flag=0;',...
							'end;',...
						'end;',...
					'end;',...
				'end;',...
			'end,',...
		'end,',...
		'if timer~=0;',...
			'messtext=''Select curve fit to find turn dotted'';',...
			'typeofcall=1;',...
			'messfun(typeofcall,messtext,currentfigurenum);',...
		'end;',...
		'[numberofwinner]=closest(smartcircle);',...	% Call function to determine which entity was selected			
		'set(cfitsmart(smartcircle(numberofwinner,3),stamat),''Linestyle'','':'');',...
		'cfitsmart(qw,stamat+8:stamat+9)=[abs('':'') 0];',...
		'delete(tempcircle);clear tempcircle;end']);

% ############# cfits Linetype ################################

solidcfitsingle(numoffigs)=uimenu(typecfitssingle(numoffigs),...
	'Label','&solid',...
	'Checked','off',...
	'Separator','on',...
	'CallBack',['for bb=1:numoffigs,if figanddatawin(1,bb)==gcf,',...
		'currentfigurenum=bb;end,end,',...
		'stamat=1+(currentfigurenum-1).*16;',...
		'lengthcfitsmart=size(cfitsmart);',...
		'lengthcfitsmart=lengthcfitsmart(1,1);',...
		'countcircle=1;',...
		'dumaxis=axis;',...
		'for qw=1:lengthcfitsmart,',...
			'if cfitsmart(qw,stamat)~=0,',...
				'xget=get(cfitsmart(qw,stamat),''XData'');',...
				'yget=get(cfitsmart(qw,stamat),''YData'');',...
				'[sortdatax,indicex]=sort(xget);',...
				'indicex=fliplr(indicex);',...
				'flag=1;',...
				'for xc=1:length(xget);',...
					'if flag~=0;',...
						'if xget(indicex(xc)) < dumaxis(1,2) & xget(indicex(xc)) > dumaxis(1,1);',...
							'if yget(indicex(xc)) < dumaxis(1,4) & yget(indicex(xc)) > dumaxis(1,3);',...
								'smartcircle(countcircle,1:2)=[xget(indicex(xc)),yget(indicex(xc))];',...
								'smartcircle(countcircle,3)=qw;',...
								'tempcircle(countcircle,1)=plot(smartcircle(countcircle,1),smartcircle(countcircle,2),''wo'');',...
								'countcircle=countcircle+1;',...	
								'flag=0;',...
							'end;',...
						'end;',...
					'end;',...
				'end;',...
			'end,',...
		'end,',...
		'if countcircle~=1,',...
		'if timer~=0;',...
			'messtext=''Select curve fit to turn solid'';',...
			'typeofcall=1;',...
			'messfun(typeofcall,messtext,currentfigurenum);',...
		'end;',...
		'[numberofwinner]=closest(smartcircle);',...	% Call function to determine which entity was selected			
		'set(cfitsmart(smartcircle(numberofwinner,3),stamat),''Linestyle'',''-'');',...
		'cfitsmart(qw,stamat+8:stamat+9)=[abs(''-'') 0];',...
		'delete(tempcircle);clear tempcircle;end']);

% ############# cfits Linetype ################################

dashedcfitsingle(numoffigs)=uimenu(typecfitssingle(numoffigs),...
	'Label','d&ashed',...
	'Checked','off',...
	'Separator','on',...
	'CallBack',['for bb=1:numoffigs,if figanddatawin(1,bb)==gcf,',...
		'currentfigurenum=bb;end,end,',...
		'stamat=1+(currentfigurenum-1).*16;',...
		'lengthcfitsmart=size(cfitsmart);',...
		'lengthcfitsmart=lengthcfitsmart(1,1);',...
		'countcircle=1;',...
		'dumaxis=axis;',...
		'for qw=1:lengthcfitsmart,',...
			'if cfitsmart(qw,stamat)~=0,',...
				'xget=get(cfitsmart(qw,stamat),''XData'');',...
				'yget=get(cfitsmart(qw,stamat),''YData'');',...
				'[sortdatax,indicex]=sort(xget);',...
				'indicex=fliplr(indicex);',...
				'flag=1;',...
				'for xc=1:length(xget);',...
					'if flag~=0;',...
						'if xget(indicex(xc)) < dumaxis(1,2) & xget(indicex(xc)) > dumaxis(1,1);',...
							'if yget(indicex(xc)) < dumaxis(1,4) & yget(indicex(xc)) > dumaxis(1,3);',...
								'smartcircle(countcircle,1:2)=[xget(indicex(xc)),yget(indicex(xc))];',...
								'smartcircle(countcircle,3)=qw;',...
								'tempcircle(countcircle,1)=plot(smartcircle(countcircle,1),smartcircle(countcircle,2),''wo'');',...
								'countcircle=countcircle+1;',...	
								'flag=0;',...
							'end;',...
						'end;',...
					'end;',...
				'end;',...
			'end,',...
		'end,',...
		'if countcircle~=1,',...
		'if timer~=0;',...
			'messtext=''Select curve fit to turn dotted'';',...
			'typeofcall=1;',...
			'messfun(typeofcall,messtext,currentfigurenum);',...
		'end;',...
		'[numberofwinner]=closest(smartcircle);',...	% Call function to determine which entity was selected			
		'set(cfitsmart(smartcircle(numberofwinner,3),stamat),''Linestyle'',''--'');',...
		'cfitsmart(qw,stamat+8:stamat+9)=[abs(''--'')];',...
		'delete(tempcircle);clear tempcircle;end']);

% ############# cfits Linetype ################################

dashdotcfitsingle(numoffigs)=uimenu(typecfitssingle(numoffigs),...
	'Label','das&hdot',...
	'Checked','off',...
	'Separator','on',...
	'CallBack',['for bb=1:numoffigs,if figanddatawin(1,bb)==gcf,',...
		'currentfigurenum=bb;end,end,',...
		'stamat=1+(currentfigurenum-1).*16;',...
		'lengthcfitsmart=size(cfitsmart);',...
		'lengthcfitsmart=lengthcfitsmart(1,1);',...
		'countcircle=1;',...
		'dumaxis=axis;',...
		'for qw=1:lengthcfitsmart,',...
			'if cfitsmart(qw,stamat)~=0,',...
				'xget=get(cfitsmart(qw,stamat),''XData'');',...
				'yget=get(cfitsmart(qw,stamat),''YData'');',...
				'[sortdatax,indicex]=sort(xget);',...
				'indicex=fliplr(indicex);',...
				'flag=1;',...
				'for xc=1:length(xget);',...
					'if flag~=0;',...
						'if xget(indicex(xc)) < dumaxis(1,2) & xget(indicex(xc)) > dumaxis(1,1);',...
							'if yget(indicex(xc)) < dumaxis(1,4) & yget(indicex(xc)) > dumaxis(1,3);',...
								'smartcircle(countcircle,1:2)=[xget(indicex(xc)),yget(indicex(xc))];',...
								'smartcircle(countcircle,3)=qw;',...
								'tempcircle(countcircle,1)=plot(smartcircle(countcircle,1),smartcircle(countcircle,2),''wo'');',...
								'countcircle=countcircle+1;',...	
								'flag=0;',...
							'end;',...
						'end;',...
					'end;',...
				'end;',...
			'end,',...
		'end,',...
		'if countcircle~=1,',...
		'if timer~=0;',...
			'messtext=''Select curve fit to turn dashdot'';',...
			'typeofcall=1;',...
			'messfun(typeofcall,messtext,currentfigurenum);',...
		'end;',...
		'[numberofwinner]=closest(smartcircle);',...	% Call function to determine which entity was selected			
		'set(cfitsmart(smartcircle(numberofwinner,3),stamat),''Linestyle'',''-.'');',...
		'cfitsmart(qw,stamat+8:stamat+9)=[abs(''-.'')];',...
		'delete(tempcircle);clear tempcircle;end']);


% ############# cfits Linetype ################################

pointcfitsingle(numoffigs)=uimenu(typecfitssingle(numoffigs),...
	'Label','&point',...
	'Checked','off',...
	'Separator','on',...
	'CallBack',['for bb=1:numoffigs,if figanddatawin(1,bb)==gcf,',...
		'currentfigurenum=bb;end,end,',...
		'stamat=1+(currentfigurenum-1).*16;',...
		'lengthcfitsmart=size(cfitsmart);',...
		'lengthcfitsmart=lengthcfitsmart(1,1);',...
		'countcircle=1;',...
		'dumaxis=axis;',...
		'for qw=1:lengthcfitsmart,',...
			'if cfitsmart(qw,stamat)~=0,',...
				'xget=get(cfitsmart(qw,stamat),''XData'');',...
				'yget=get(cfitsmart(qw,stamat),''YData'');',...
				'[sortdatax,indicex]=sort(xget);',...
				'indicex=fliplr(indicex);',...
				'flag=1;',...
				'for xc=1:length(xget);',...
					'if flag~=0;',...
						'if xget(indicex(xc)) < dumaxis(1,2) & xget(indicex(xc)) > dumaxis(1,1);',...
							'if yget(indicex(xc)) < dumaxis(1,4) & yget(indicex(xc)) > dumaxis(1,3);',...
								'smartcircle(countcircle,1:2)=[xget(indicex(xc)),yget(indicex(xc))];',...
								'smartcircle(countcircle,3)=qw;',...
								'tempcircle(countcircle,1)=plot(smartcircle(countcircle,1),smartcircle(countcircle,2),''wo'');',...
								'countcircle=countcircle+1;',...	
								'flag=0;',...
							'end;',...
						'end;',...
					'end;',...
				'end;',...
			'end,',...
		'end,',...
		'if countcircle~=1,',...
		'if timer~=0;',...
			'messtext=''Select curve fit to turn to points'';',...
			'typeofcall=1;',...
			'messfun(typeofcall,messtext,currentfigurenum);',...
		'end;',...
		'[numberofwinner]=closest(smartcircle);',...	% Call function to determine which entity was selected			
		'set(cfitsmart(smartcircle(numberofwinner,3),stamat),''Linestyle'',''.'');',...
		'cfitsmart(qw,stamat+8:stamat+9)=[abs(''.'') 0];',...
		'delete(tempcircle);clear tempcircle;end']);




% ############# cfits Linetype ################################

circlecfitsingle(numoffigs)=uimenu(typecfitssingle(numoffigs),...
	'Label','&circle',...
	'Checked','off',...
	'Separator','on',...
	'CallBack',['for bb=1:numoffigs,if figanddatawin(1,bb)==gcf,',...
		'currentfigurenum=bb;end,end,',...
		'stamat=1+(currentfigurenum-1).*16;',...
		'lengthcfitsmart=size(cfitsmart);',...
		'lengthcfitsmart=lengthcfitsmart(1,1);',...
		'countcircle=1;',...
		'dumaxis=axis;',...
		'for qw=1:lengthcfitsmart,',...
			'if cfitsmart(qw,stamat)~=0,',...
				'xget=get(cfitsmart(qw,stamat),''XData'');',...
				'yget=get(cfitsmart(qw,stamat),''YData'');',...
				'[sortdatax,indicex]=sort(xget);',...
				'indicex=fliplr(indicex);',...
				'flag=1;',...
				'for xc=1:length(xget);',...
					'if flag~=0;',...
						'if xget(indicex(xc)) < dumaxis(1,2) & xget(indicex(xc)) > dumaxis(1,1);',...
							'if yget(indicex(xc)) < dumaxis(1,4) & yget(indicex(xc)) > dumaxis(1,3);',...
								'smartcircle(countcircle,1:2)=[xget(indicex(xc)),yget(indicex(xc))];',...
								'smartcircle(countcircle,3)=qw;',...
								'tempcircle(countcircle,1)=plot(smartcircle(countcircle,1),smartcircle(countcircle,2),''wo'');',...
								'countcircle=countcircle+1;',...	
								'flag=0;',...
							'end;',...
						'end;',...
					'end;',...
				'end;',...
			'end,',...
		'end,',...
		'if countcircle~=1,',...
		'if timer~=0;',...
			'messtext=''Select curve fit to turn to circles'';',...
			'typeofcall=1;',...
			'messfun(typeofcall,messtext,currentfigurenum);',...
		'end;',...
		'[numberofwinner]=closest(smartcircle);',...	% Call function to determine which entity was selected			
		'set(cfitsmart(smartcircle(numberofwinner,3),stamat),''Linestyle'',''o'');',...
		'cfitsmart(qw,stamat+8:stamat+9)=[abs(''o'') 0];',...
		'delete(tempcircle);clear tempcircle;end']);



% ############# cfits Linetype ################################

xmarkcfitsingle(numoffigs)=uimenu(typecfitssingle(numoffigs),...
	'Label','&x-mark',...
	'Checked','off',...
	'Separator','on',...
	'CallBack',['for bb=1:numoffigs,if figanddatawin(1,bb)==gcf,',...
		'currentfigurenum=bb;end,end,',...
		'stamat=1+(currentfigurenum-1).*16;',...
		'lengthcfitsmart=size(cfitsmart);',...
		'lengthcfitsmart=lengthcfitsmart(1,1);',...
		'countcircle=1;',...
		'dumaxis=axis;',...
		'for qw=1:lengthcfitsmart,',...
			'if cfitsmart(qw,stamat)~=0,',...
				'xget=get(cfitsmart(qw,stamat),''XData'');',...
				'yget=get(cfitsmart(qw,stamat),''YData'');',...
				'[sortdatax,indicex]=sort(xget);',...
				'indicex=fliplr(indicex);',...
				'flag=1;',...
				'for xc=1:length(xget);',...
					'if flag~=0;',...
						'if xget(indicex(xc)) < dumaxis(1,2) & xget(indicex(xc)) > dumaxis(1,1);',...
							'if yget(indicex(xc)) < dumaxis(1,4) & yget(indicex(xc)) > dumaxis(1,3);',...
								'smartcircle(countcircle,1:2)=[xget(indicex(xc)),yget(indicex(xc))];',...
								'smartcircle(countcircle,3)=qw;',...
								'tempcircle(countcircle,1)=plot(smartcircle(countcircle,1),smartcircle(countcircle,2),''wo'');',...
								'countcircle=countcircle+1;',...	
								'flag=0;',...
							'end;',...
						'end;',...
					'end;',...
				'end;',...
			'end,',...
		'end,',...
		'if countcircle~=1,',...
		'if timer~=0;',...
			'messtext=''Select curve fit to find turn x'';',...
			'typeofcall=1;',...
			'messfun(typeofcall,messtext,currentfigurenum);',...
		'end;',...
		'[numberofwinner]=closest(smartcircle);',...	% Call function to determine which entity was selected			
		'set(cfitsmart(smartcircle(numberofwinner,3),stamat),''Linestyle'',''x'');',...
		'cfitsmart(qw,stamat+8:stamat+9)=[abs(''x'') 0];',...
		'delete(tempcircle);clear tempcircle;end']);


% ############# cfits Linetype ################################

pluscfitsingle(numoffigs)=uimenu(typecfitssingle(numoffigs),...
	'Label','p&lus',...
	'Checked','off',...
	'Separator','on',...
	'CallBack',['for bb=1:numoffigs,if figanddatawin(1,bb)==gcf,',...
		'currentfigurenum=bb;end,end,',...
		'stamat=1+(currentfigurenum-1).*16;',...
		'lengthcfitsmart=size(cfitsmart);',...
		'lengthcfitsmart=lengthcfitsmart(1,1);',...
		'countcircle=1;',...
		'dumaxis=axis;',...
		'for qw=1:lengthcfitsmart,',...
			'if cfitsmart(qw,stamat)~=0,',...
				'xget=get(cfitsmart(qw,stamat),''XData'');',...
				'yget=get(cfitsmart(qw,stamat),''YData'');',...
				'[sortdatax,indicex]=sort(xget);',...
				'indicex=fliplr(indicex);',...
				'flag=1;',...
				'for xc=1:length(xget);',...
					'if flag~=0;',...
						'if xget(indicex(xc)) < dumaxis(1,2) & xget(indicex(xc)) > dumaxis(1,1);',...
							'if yget(indicex(xc)) < dumaxis(1,4) & yget(indicex(xc)) > dumaxis(1,3);',...
								'smartcircle(countcircle,1:2)=[xget(indicex(xc)),yget(indicex(xc))];',...
								'smartcircle(countcircle,3)=qw;',...
								'tempcircle(countcircle,1)=plot(smartcircle(countcircle,1),smartcircle(countcircle,2),''wo'');',...
								'countcircle=countcircle+1;',...	
								'flag=0;',...
							'end;',...
						'end;',...
					'end;',...
				'end;',...
			'end,',...
		'end,',...
		'if countcircle~=1,',...
		'if timer~=0;',...
			'messtext=''Select curve fit to turn plus'';',...
			'typeofcall=1;',...
			'messfun(typeofcall,messtext,currentfigurenum);',...
		'end;',...
		'[numberofwinner]=closest(smartcircle);',...	% Call function to determine which entity was selected			
		'set(cfitsmart(smartcircle(numberofwinner,3),stamat),''Linestyle'',''+'');',...
		'cfitsmart(qw,stamat+8:stamat+9)=[abs(''+'') 0];',...
		'delete(tempcircle);clear tempcircle;end']);


% ############# cfits Linetype ################################

starcfitsingle(numoffigs)=uimenu(typecfitssingle(numoffigs),...
	'Label','s&tar',...
	'Checked','off',...
	'Separator','on',...
	'CallBack',['for bb=1:numoffigs,if figanddatawin(1,bb)==gcf,',...
		'currentfigurenum=bb;end,end,',...
		'stamat=1+(currentfigurenum-1).*16;',...
		'lengthcfitsmart=size(cfitsmart);',...
		'lengthcfitsmart=lengthcfitsmart(1,1);',...
		'countcircle=1;',...
		'dumaxis=axis;',...
		'for qw=1:lengthcfitsmart,',...
			'if cfitsmart(qw,stamat)~=0,',...
				'xget=get(cfitsmart(qw,stamat),''XData'');',...
				'yget=get(cfitsmart(qw,stamat),''YData'');',...
				'[sortdatax,indicex]=sort(xget);',...
				'indicex=fliplr(indicex);',...
				'flag=1;',...
				'for xc=1:length(xget);',...
					'if flag~=0;',...
						'if xget(indicex(xc)) < dumaxis(1,2) & xget(indicex(xc)) > dumaxis(1,1);',...
							'if yget(indicex(xc)) < dumaxis(1,4) & yget(indicex(xc)) > dumaxis(1,3);',...
								'smartcircle(countcircle,1:2)=[xget(indicex(xc)),yget(indicex(xc))];',...
								'smartcircle(countcircle,3)=qw;',...
								'tempcircle(countcircle,1)=plot(smartcircle(countcircle,1),smartcircle(countcircle,2),''wo'');',...
								'countcircle=countcircle+1;',...	
								'flag=0;',...
							'end;',...
						'end;',...
					'end;',...
				'end;',...
			'end,',...
		'end,',...
		'if countcircle~=1,',...
		'if timer~=0;',...
			'messtext=''Select curve fit to turn to astericks'';',...
			'typeofcall=1;',...
			'messfun(typeofcall,messtext,currentfigurenum);',...
		'end;',...
		'[numberofwinner]=closest(smartcircle);',...	% Call function to determine which entity was selected			
		'set(cfitsmart(smartcircle(numberofwinner,3),stamat),''Linestyle'',''*'');',...
		'cfitsmart(qw,stamat+8:stamat+9)=[abs(''*'') 0];',...
		'delete(tempcircle);clear tempcircle;end']);