% Version 1.0 of ProPlot 1.0
%
%    // linesrmv.m \\
%
%     Scott Keane
%  skeane@uceng.uc.edu
%
%
% *****************************************
% Matlab script to remove curve fits(single and all)
% *****************************************

% ****************************************************************
% ********************** Remove Single ***************************
% ****************************************************************

removecfitssingle(numoffigs)=uimenu(modifycfitssingle(numoffigs),...
	'Label','&Remove Single Curve Fit',...
	'Enable','on',...
	'Separator','on',...
	'CallBack',['for bb=1:numoffigs,if figanddatawin(1,bb)==gcf,',...
		'currentfigurenum=bb;end,end,',...
		'dumaxis=axis;',...
		'stamat=1+(currentfigurenum-1).*16;',...
		'lengthcfitsmart=size(cfitsmart);',...
		'lengthcfitsmart=lengthcfitsmart(1,1);',...
		'countcircle=1;',...
		'dumaxis=axis;',...
		'for qw=1:lengthcfitsmart,',...
			'if cfitsmart(qw,stamat)~=0,',...
				'xget=get(cfitsmart(qw,stamat),''XData'');',...
				'yget=get(cfitsmart(qw,stamat),''YData'');',...
				'[sortdatax,indicex]=sort(xget);',...
				'indicex=fliplr(indicex);',...
				'flag=1;',...
				'for xc=1:length(xget);',...
					'if flag~=0;',...
						'if xget(indicex(xc)) < dumaxis(1,2) & xget(indicex(xc)) > dumaxis(1,1);',...
							'if yget(indicex(xc)) < dumaxis(1,4) & yget(indicex(xc)) > dumaxis(1,3);',...
								'smartcircle(countcircle,1:2)=[xget(indicex(xc)),yget(indicex(xc))];',...
								'smartcircle(countcircle,3)=qw;',...
								'tempcircle(countcircle,1)=plot(smartcircle(countcircle,1),smartcircle(countcircle,2),''wo'');',...
								'countcircle=countcircle+1;',...	
								'flag=0;',...
							'end;',...
						'end;',...
					'end;',...
				'end;',...
			'end,',...
		'end,',...
		'if countcircle~=1,',...
		'if timer~=0;',...
			'messtext=''Select curve fit to delete'';',...
			'typeofcall=1;',...
			'messfun(typeofcall,messtext,currentfigurenum);',...
		'end;',...
		'[numberofwinner]=closest(smartcircle);',...	% Call function to determine which entity was selected			
		'delete(cfitsmart(smartcircle(numberofwinner,3),stamat));',...
		'delete(tempcircle);clear tempcircle;',...
		'if smartcircle(numberofwinner,3)==1 & (countcircle-1) > 1,',...
			'cfitsmart(1:countcircle-2,stamat:stamat+9)=cfitsmart(2:countcircle-1,stamat:stamat+9);',...
			'cfitsmart(countcircle-1,stamat:stamat+9)=zeros(1,10);',...
		'elseif smartcircle(numberofwinner,3) > 1 & smartcircle(numberofwinner,3) < (countcircle-1),',...
			'tempupper=cfitsmart(1:smartcircle(numberofwinner,3)-1,stamat:stamat+9);',...
			'templower=cfitsmart(smartcircle(numberofwinner,3)+1:(countcircle-1),stamat:stamat+9);',...
			'cfitsmart(1:countcircle-2,stamat:stamat+9)=[tempupper;templower];',...
			'cfitsmart(countcircle-1,stamat:stamat+9)=zeros(1,10);',...
		'elseif smartcircle(numberofwinner,3)==(countcircle-1),',...
			'cfitsmart(smartcircle(numberofwinner,3),stamat:stamat+9)=zeros(1,10);',...
		'end,',...
		'end;',...
		'if countcircle==2;',...
			'set(modifycfitssingle(currentfigurenum),''Enable'',''off'');',...
			'set(removecfitsall(currentfigurenum),''Enable'',''off'');',...
		'end;']);


		

% ****************************************************************
% ************************ Remove All ****************************
% ****************************************************************

removecfitsall(numoffigs)=uimenu(cfitmenus(numoffigs),...
	'Label','Remove &All',...
	'Enable','off',...
	'Separator','on',...
	'CallBack',['for bb=1:numoffigs,if figanddatawin(1,bb)==gcf,',...
		'currentfigurenum=bb;end,end,',...
		'stamat=1+(currentfigurenum-1).*16;',...
		'lengthcfitsmart=size(cfitsmart);',...
		'lengthcfitsmart=lengthcfitsmart(1,1);',...
		'for qw=1:lengthcfitsmart,',...
			'if cfitsmart(qw,stamat)~=0,',...
				'delete(cfitsmart(qw,stamat));',...
				'cfitsmart(qw,stamat:stamat+9)=zeros(1,10);',...
			'end,',...
		'end,',...
		'set(modifycfitssingle(currentfigurenum),''Enable'',''off'');',...
		'set(removecfitsall(currentfigurenum),''Enable'',''off'');']);
		
