
% Version 1.0 of ProPlot 1.0
%
%    // statrun.m \\
%
%     Scott Keane
%  skeane@uceng.uc.edu
%
%    Created on:    8:48 PM 4/23/96
%    Last Modified: 6:25 AM 4/26/96
%
% *****************************************
% Matlab script to set up a statistical
% menu(min,max,st.dev.,cov.corr coef)
% *****************************************


% ***************************************************************
% ************************ Statistical **************************
% ***************************************************************


letmestat(numoffigs)=uimenu(numeric(numoffigs),...
	'Label','&Statistical',...
	'Enable','off',...
	'Separator','on');	

% ***************************************************************
% ************************ Minimum ******************************
% ***************************************************************

minofdata(numoffigs)=uimenu(letmestat(numoffigs),...
	'Label','Mi&n',...
	'Separator','off',...
	'CallBack',['for bb=1:numoffigs,if figanddatawin(1,bb)==gcf,',...
		'currentfigurenum=bb;end,end,',...
		'if isempty(plotvar)==1,',...
			'usefulinfo=zeros(1,3);',...
		'else,',...
			'plotvarinfo=existfun(plotvar);',...
			'if plotvarinfo(1,1)==0 | plotvarinfo(1,1)==-1,',...
				'usefulinfo=zeros(1,3);',...
			'else,',...
				'usefulinfo=get(plotvar(currentfigurenum,1),''UserData'');',...
			'end,',...
		'end,',...
		'lengthuseful=size(usefulinfo);',...
		'lengthuseful=lengthuseful(1,1);',...
		'countcircle=1;',...
		'for qw=1:lengthuseful,',...
			'if usefulinfo(qw,3)~=0,',...
				'getaxisvalue=axis;',...	
				'dumaxis=axis;',...
				'pullxdata=get(plotvar(currentfigurenum,usefulinfo(qw,3)+1),''XData'');',...		
				'pullydata=get(plotvar(currentfigurenum,usefulinfo(qw,3)+1),''YData'');',...
				'flag=1;',...
				'for ind=length(pullxdata):-1:1;',...
					'if flag~=0;',...
						'xtointer=(pullxdata(ind)-pullxdata(1)).*.9;',...
						'if xtointer < dumaxis(1,2) & xtointer > dumaxis(1,1);',...
							'ytointer=interp1(pullxdata,pullydata,xtointer);',...
							'if ytointer < dumaxis(1,4) & ytointer > dumaxis(1,3);',...
								'smartcircle(countcircle,1)=xtointer;',...
								'smartcircle(countcircle,2)=ytointer;',...
								'smartcircle(countcircle,3)=qw;',...
								'axis(getaxisvalue);',...
								'hold on,tempcircle(countcircle,1)=plot(smartcircle(countcircle,1),smartcircle(countcircle,2),''wo'');',...
								'countcircle=countcircle+1;',...
								'flag=0;',...	
							'end,',...
						'end,',...
					'end;',...
				'end;',...
			'end;',...
		'end;',...	
		'if countcircle~=1,',...
		'if timer~=0;',...
			'messtext=''Select curve for min'';',...
			'typeofcall=1;',...
			'messfun(typeofcall,messtext,currentfigurenum);',...
		'end;',...
		'[numberofwinner]=closest(smartcircle);',...% determine which curve picked
		'num2modify=usefulinfo(smartcircle(numberofwinner,3),3);',...
		'xstat=get(plotvar(currentfigurenum,num2modify+1),''XData'');',...
		'ystat=get(plotvar(currentfigurenum,num2modify+1),''YData'');',...
		'[miny,numof]=min(ystat);',...
		'string2add=[''Min = '',num2str(miny)];',...
		'intarea(currentfigurenum)=text(xstat(numof),miny,num2str(string2add));',...
		'set(intarea(currentfigurenum),''Visible'',''off'');',...
		'texttoadd(currentfigurenum,:)=intarea(currentfigurenum);',...
		'textfun(0,0,currentfigurenum,texttoadd,0);',...
		'delete(intarea(currentfigurenum)); intarea(currentfigurenum)=0;',...
		'delete(tempcircle);clear tempcircle;',... 
		'set(modifytextssingle(currentfigurenum),''Enable'',''on'');',...
		'set(modifytextsall(currentfigurenum),''Enable'',''on'');',...
		'end']);	


% ***************************************************************
% ************************ Maximum ******************************
% ***************************************************************


maxofdata(numoffigs)=uimenu(letmestat(numoffigs),...
	'Label','Ma&x',...
	'Separator','on',...
	'CallBack',['for bb=1:numoffigs,if figanddatawin(1,bb)==gcf,',...
		'currentfigurenum=bb;end,end,',...
		'if isempty(plotvar)==1,',...
			'usefulinfo=zeros(1,3);',...
		'else,',...
			'plotvarinfo=existfun(plotvar);',...
			'if plotvarinfo(1,1)==0 | plotvarinfo(1,1)==-1,',...
				'usefulinfo=zeros(1,3);',...
			'else,',...
				'usefulinfo=get(plotvar(currentfigurenum,1),''UserData'');',...
			'end,',...
		'end,',...
		'lengthuseful=size(usefulinfo);',...
		'lengthuseful=lengthuseful(1,1);',...
		'countcircle=1;',...
		'for qw=1:lengthuseful,',...
			'if usefulinfo(qw,3)~=0,',...
				'getaxisvalue=axis;',...	
				'dumaxis=axis;',...
				'pullxdata=get(plotvar(currentfigurenum,usefulinfo(qw,3)+1),''XData'');',...		
				'pullydata=get(plotvar(currentfigurenum,usefulinfo(qw,3)+1),''YData'');',...
				'flag=1;',...
				'for ind=length(pullxdata):-1:1;',...
					'if flag~=0;',...
						'xtointer=(pullxdata(ind)-pullxdata(1)).*.9;',...
						'if xtointer < dumaxis(1,2) & xtointer > dumaxis(1,1);',...
							'ytointer=interp1(pullxdata,pullydata,xtointer);',...
							'if ytointer < dumaxis(1,4) & ytointer > dumaxis(1,3);',...
								'smartcircle(countcircle,1)=xtointer;',...
								'smartcircle(countcircle,2)=ytointer;',...
								'smartcircle(countcircle,3)=qw;',...
								'axis(getaxisvalue);',...
								'hold on,tempcircle(countcircle,1)=plot(smartcircle(countcircle,1),smartcircle(countcircle,2),''wo'');',...
								'countcircle=countcircle+1;',...
								'flag=0;',...	
							'end,',...
						'end,',...
					'end;',...
				'end;',...
			'end;',...
		'end;',...
		'if countcircle~=1,',...
		'if timer~=0;',...
			'messtext=''Select curve for max'';',...
			'typeofcall=1;',...
			'messfun(typeofcall,messtext,currentfigurenum);',...
		'end;',...
		'[numberofwinner]=closest(smartcircle);',...% determine which curve picked
		'num2modify=usefulinfo(smartcircle(numberofwinner,3),3);',...
		'xstat=get(plotvar(currentfigurenum,num2modify+1),''XData'');',...
		'ystat=get(plotvar(currentfigurenum,num2modify+1),''YData'');',...
		'[maxy,numof]=max(ystat);',...
		'string2add=[''Max = '',num2str(maxy)];',...
		'intarea(currentfigurenum)=text(xstat(numof),maxy,num2str(string2add));',...
		'set(intarea(currentfigurenum),''Visible'',''off'');',...
		'texttoadd(currentfigurenum,:)=intarea(currentfigurenum);',...
		'textfun(0,0,currentfigurenum,texttoadd,0);',...
		'delete(intarea(currentfigurenum)); intarea(currentfigurenum)=0;',...
		'delete(tempcircle);clear tempcircle;',... 
		'set(modifytextssingle(currentfigurenum),''Enable'',''on'');',...
		'set(modifytextsall(currentfigurenum),''Enable'',''on'');',...
		'end']);		

% ***************************************************************
% ************************ Mean *********************************
% ***************************************************************

meanofdata(numoffigs)=uimenu(letmestat(numoffigs),...
	'Label','&Mean',...
	'Separator','on',...
	'CallBack',['for bb=1:numoffigs,if figanddatawin(1,bb)==gcf,',...
		'currentfigurenum=bb;end,end,',...
		'if isempty(plotvar)==1,',...
			'usefulinfo=zeros(1,3);',...
		'else,',...
			'plotvarinfo=existfun(plotvar);',...
			'if plotvarinfo(1,1)==0 | plotvarinfo(1,1)==-1,',...
				'usefulinfo=zeros(1,3);',...
			'else,',...
				'usefulinfo=get(plotvar(currentfigurenum,1),''UserData'');',...
			'end,',...
		'end,',...
		'lengthuseful=size(usefulinfo);',...
		'lengthuseful=lengthuseful(1,1);',...
		'countcircle=1;',...
		'for qw=1:lengthuseful,',...
			'if usefulinfo(qw,3)~=0,',...
				'getaxisvalue=axis;',...	
				'dumaxis=axis;',...	
				'pullxdata=get(plotvar(currentfigurenum,usefulinfo(qw,3)+1),''XData'');',...		
				'pullydata=get(plotvar(currentfigurenum,usefulinfo(qw,3)+1),''YData'');',...
				'flag=1;',...
				'for ind=length(pullxdata):-1:1;',...
					'if flag~=0;',...
						'xtointer=(pullxdata(ind)-pullxdata(1)).*.9;',...
						'if xtointer < dumaxis(1,2) & xtointer > dumaxis(1,1);',...
							'ytointer=interp1(pullxdata,pullydata,xtointer);',...
							'if ytointer < dumaxis(1,4) & ytointer > dumaxis(1,3);',...
								'smartcircle(countcircle,1)=xtointer;',...
								'smartcircle(countcircle,2)=ytointer;',...
								'smartcircle(countcircle,3)=qw;',...
								'axis(getaxisvalue);',...
								'hold on,tempcircle(countcircle,1)=plot(smartcircle(countcircle,1),smartcircle(countcircle,2),''wo'');',...
								'countcircle=countcircle+1;',...
								'flag=0;',...	
							'end,',...
						'end,',...
					'end;',...
				'end;',...
			'end;',...
		'end;',...
		'if countcircle~=1,',...
		'if timer~=0;',...
			'messtext=''Select curve for mean'';',...
			'typeofcall=1;',...
			'messfun(typeofcall,messtext,currentfigurenum);',...
		'end;',...
		'[numberofwinner]=closest(smartcircle);',...% determine which curve picked
		'num2modify=usefulinfo(smartcircle(numberofwinner,3),3);',...
		'xstat=get(plotvar(currentfigurenum,num2modify+1),''XData'');',...
		'ystat=get(plotvar(currentfigurenum,num2modify+1),''YData'');',...
		'[meanofy]=mean(ystat);',...
		'string2add=[''Mean = '',num2str(meanofy)];',...
		'intarea(currentfigurenum)=text((xstat(length(xstat))+xstat(1))./2,meanofy,num2str(string2add));',...
		'set(intarea(currentfigurenum),''Visible'',''off'');',...
		'texttoadd(currentfigurenum,:)=intarea(currentfigurenum);',...
		'textfun(0,0,currentfigurenum,texttoadd,0);',...
		'delete(intarea(currentfigurenum)); intarea(currentfigurenum)=0;',...
		'delete(tempcircle);clear tempcircle;',...
		'set(modifytextssingle(currentfigurenum),''Enable'',''on'');',...
		'set(modifytextsall(currentfigurenum),''Enable'',''on'');',...	
		'end']);		

% ***************************************************************
% ************************ Median *******************************
% ***************************************************************

medianofdata(numoffigs)=uimenu(letmestat(numoffigs),...
	'Label','Me&dian',...
	'Separator','on',...
	'CallBack',['for bb=1:numoffigs,if figanddatawin(1,bb)==gcf,',...
		'currentfigurenum=bb;end,end,',...
		'if isempty(plotvar)==1,',...
			'usefulinfo=zeros(1,3);',...
		'else,',...
			'plotvarinfo=existfun(plotvar);',...
			'if plotvarinfo(1,1)==0 | plotvarinfo(1,1)==-1,',...
				'usefulinfo=zeros(1,3);',...
			'else,',...
				'usefulinfo=get(plotvar(currentfigurenum,1),''UserData'');',...
			'end,',...
		'end,',...
		'lengthuseful=size(usefulinfo);',...
		'lengthuseful=lengthuseful(1,1);',...
		'countcircle=1;',...
		'for qw=1:lengthuseful,',...
			'if usefulinfo(qw,3)~=0,',...
				'getaxisvalue=axis;',...	
				'dumaxis=axis;',...
				'pullxdata=get(plotvar(currentfigurenum,usefulinfo(qw,3)+1),''XData'');',...		
				'pullydata=get(plotvar(currentfigurenum,usefulinfo(qw,3)+1),''YData'');',...
				'flag=1;',...
				'for ind=length(pullxdata):-1:1;',...
					'if flag~=0;',...
						'xtointer=(pullxdata(ind)-pullxdata(1)).*.9;',...
						'if xtointer < dumaxis(1,2) & xtointer > dumaxis(1,1);',...
							'ytointer=interp1(pullxdata,pullydata,xtointer);',...
							'if ytointer < dumaxis(1,4) & ytointer > dumaxis(1,3);',...
								'smartcircle(countcircle,1)=xtointer;',...
								'smartcircle(countcircle,2)=ytointer;',...
								'smartcircle(countcircle,3)=qw;',...
								'axis(getaxisvalue);',...
								'hold on,tempcircle(countcircle,1)=plot(smartcircle(countcircle,1),smartcircle(countcircle,2),''wo'');',...
								'countcircle=countcircle+1;',...
								'flag=0;',...	
							'end,',...
						'end,',...
					'end;',...
				'end;',...
			'end;',...
		'end;',...
		'if countcircle~=1,',...
		'if timer~=0;',...
			'messtext=''Select curve for median'';',...
			'typeofcall=1;',...
			'messfun(typeofcall,messtext,currentfigurenum);',...
		'end;',...
		'[numberofwinner]=closest(smartcircle);',...% determine which curve picked
		'num2modify=usefulinfo(smartcircle(numberofwinner,3),3);',...
		'xstat=get(plotvar(currentfigurenum,num2modify+1),''XData'');',...
		'ystat=get(plotvar(currentfigurenum,num2modify+1),''YData'');',...
		'[medianofy]=median(ystat);',...
		'string2add=[''Median = '',num2str(medianofy)];',...
		'intarea(currentfigurenum)=text((xstat(length(xstat))+xstat(1))./2,medianofy,num2str(string2add));',...
		'set(intarea(currentfigurenum),''Visible'',''off'');',...
		'texttoadd(currentfigurenum,:)=intarea(currentfigurenum);',...
		'textfun(0,0,currentfigurenum,texttoadd,0);',...
		'delete(intarea(currentfigurenum)); intarea(currentfigurenum)=0;',...
		'delete(tempcircle);clear tempcircle;',... 
		'set(modifytextssingle(currentfigurenum),''Enable'',''on'');',...
		'set(modifytextsall(currentfigurenum),''Enable'',''on'');',...
		'end']);			

% ***************************************************************
% ********************** Standard Deviation**********************
% ***************************************************************

sdofdata(numoffigs)=uimenu(letmestat(numoffigs),...
	'Label','&Standard Deviation',...
	'Separator','on',...
	'CallBack',['for bb=1:numoffigs,if figanddatawin(1,bb)==gcf,',...
		'currentfigurenum=bb;end,end,',...
		'if isempty(plotvar)==1,',...
			'usefulinfo=zeros(1,3);',...
		'else,',...
			'plotvarinfo=existfun(plotvar);',...
			'if plotvarinfo(1,1)==0 | plotvarinfo(1,1)==-1,',...
				'usefulinfo=zeros(1,3);',...
			'else,',...
				'usefulinfo=get(plotvar(currentfigurenum,1),''UserData'');',...
			'end,',...
		'end,',...
		'lengthuseful=size(usefulinfo);',...
		'lengthuseful=lengthuseful(1,1);',...
		'countcircle=1;',...
		'for qw=1:lengthuseful,',...
			'if usefulinfo(qw,3)~=0,',...
				'getaxisvalue=axis;',...	
				'dumaxis=axis;',...
				'pullxdata=get(plotvar(currentfigurenum,usefulinfo(qw,3)+1),''XData'');',...		
				'pullydata=get(plotvar(currentfigurenum,usefulinfo(qw,3)+1),''YData'');',...
				'flag=1;',...
				'for ind=length(pullxdata):-1:1;',...
					'if flag~=0;',...
						'xtointer=(pullxdata(ind)-pullxdata(1)).*.9;',...
						'if xtointer < dumaxis(1,2) & xtointer > dumaxis(1,1);',...
							'ytointer=interp1(pullxdata,pullydata,xtointer);',...
							'if ytointer < dumaxis(1,4) & ytointer > dumaxis(1,3);',...
								'smartcircle(countcircle,1)=xtointer;',...
								'smartcircle(countcircle,2)=ytointer;',...
								'smartcircle(countcircle,3)=qw;',...
								'axis(getaxisvalue);',...
								'hold on,tempcircle(countcircle,1)=plot(smartcircle(countcircle,1),smartcircle(countcircle,2),''wo'');',...
								'countcircle=countcircle+1;',...
								'flag=0;',...	
							'end,',...
						'end,',...
					'end;',...
				'end;',...
			'end;',...
		'end;',...
		'if countcircle~=1,',...
		'if timer~=0;',...
			'messtext=''Select curve for standard deviation'';',...
			'typeofcall=1;',...
			'messfun(typeofcall,messtext,currentfigurenum);',...
		'end;',...
		'[numberofwinner]=closest(smartcircle);',...% determine which curve picked
		'num2modify=usefulinfo(smartcircle(numberofwinner,3),3);',...
		'xstat=get(plotvar(currentfigurenum,num2modify+1),''XData'');',...
		'ystat=get(plotvar(currentfigurenum,num2modify+1),''YData'');',...
		'[stdofy]=std(ystat);',...
		'string2add=[''Standard Deviation = '',num2str(stdofy)];',...
		'intarea(currentfigurenum)=text((.5.*xstat(length(xstat))+xstat(1))./2,(.5.*getaxisvalue(1,4)+getaxisvalue(1,3))./2,num2str(string2add));',...
		'set(intarea(currentfigurenum),''Visible'',''off'');',...
		'texttoadd(currentfigurenum,:)=intarea(currentfigurenum);',...
		'textfun(0,0,currentfigurenum,texttoadd,0);',...
		'delete(intarea(currentfigurenum)); intarea(currentfigurenum)=0;',...
		'delete(tempcircle);clear tempcircle;',...
		'set(modifytextssingle(currentfigurenum),''Enable'',''on'');',...
		'set(modifytextsall(currentfigurenum),''Enable'',''on'');',...
		'end']);		 

% ***************************************************************
% ************************ Covariance ***************************
% ***************************************************************

covofdata(numoffigs)=uimenu(letmestat(numoffigs),...
	'Label','Co&variance',...
	'Separator','on',...
	'CallBack',['for bb=1:numoffigs,if figanddatawin(1,bb)==gcf,',...
		'currentfigurenum=bb;end,end,',...
		'if isempty(plotvar)==1,',...
			'usefulinfo=zeros(1,3);',...
		'else,',...
			'plotvarinfo=existfun(plotvar);',...
			'if plotvarinfo(1,1)==0 | plotvarinfo(1,1)==-1,',...
				'usefulinfo=zeros(1,3);',...
			'else,',...
				'usefulinfo=get(plotvar(currentfigurenum,1),''UserData'');',...
			'end,',...
		'end,',...
		'lengthuseful=size(usefulinfo);',...
		'lengthuseful=lengthuseful(1,1);',...
		'countcircle=1;',...
		'for qw=1:lengthuseful,',...
			'if usefulinfo(qw,3)~=0,',...
				'getaxisvalue=axis;',...	
				'dumaxis=axis;',...
				'pullxdata=get(plotvar(currentfigurenum,usefulinfo(qw,3)+1),''XData'');',...		
				'pullydata=get(plotvar(currentfigurenum,usefulinfo(qw,3)+1),''YData'');',...
				'flag=1;',...
				'for ind=length(pullxdata):-1:1;',...
					'if flag~=0;',...
						'xtointer=(pullxdata(ind)-pullxdata(1)).*.9;',...
						'if xtointer < dumaxis(1,2) & xtointer > dumaxis(1,1);',...
							'ytointer=interp1(pullxdata,pullydata,xtointer);',...
							'if ytointer < dumaxis(1,4) & ytointer > dumaxis(1,3);',...
								'smartcircle(countcircle,1)=xtointer;',...
								'smartcircle(countcircle,2)=ytointer;',...
								'smartcircle(countcircle,3)=qw;',...
								'axis(getaxisvalue);',...
								'hold on,tempcircle(countcircle,1)=plot(smartcircle(countcircle,1),smartcircle(countcircle,2),''wo'');',...
								'countcircle=countcircle+1;',...
								'flag=0;',...	
							'end,',...
						'end,',...
					'end;',...
				'end;',...
			'end;',...
		'end;',...
		'if countcircle~=1,',...
		'if timer~=0;',...
			'messtext=''Select curve for covariance'';',...
			'typeofcall=1;',...
			'messfun(typeofcall,messtext,currentfigurenum);',...
		'end;',...
		'[numberofwinner]=closest(smartcircle);',...% determine which curve picked
		'num2modify=usefulinfo(smartcircle(numberofwinner,3),3);',...
		'xstat=get(plotvar(currentfigurenum,num2modify+1),''XData'');',...
		'ystat=get(plotvar(currentfigurenum,num2modify+1),''YData'');',...
		'[covofy]=cov(ystat);',...
		'string2add=[''Covariance = '',num2str(covofy)];',...
		'intarea(currentfigurenum)=text((.5.*xstat(length(xstat))+xstat(1))./2,(.35.*getaxisvalue(1,4)+getaxisvalue(1,3))./2,num2str(string2add));',...
		'set(intarea(currentfigurenum),''Visible'',''off'');',...
		'texttoadd(currentfigurenum,:)=intarea(currentfigurenum);',...
		'textfun(0,0,currentfigurenum,texttoadd,0);',...
		'delete(intarea(currentfigurenum)); intarea(currentfigurenum)=0;',...
		'delete(tempcircle);clear tempcircle;',...
		'set(modifytextssingle(currentfigurenum),''Enable'',''on'');',...
		'set(modifytextsall(currentfigurenum),''Enable'',''on'');',...
		'end']);		

% ***************************************************************
% ************************ Corr Coef ****************************
% ***************************************************************

coercoefofdata(numoffigs)=uimenu(letmestat(numoffigs),...
	'Label','Co&rrelation Coef.',...
	'Separator','on',...
	'CallBack',['for bb=1:numoffigs,if figanddatawin(1,bb)==gcf,',...
		'currentfigurenum=bb;end,end,',...
		'if isempty(plotvar)==1,',...
			'usefulinfo=zeros(1,3);',...
		'else,',...
			'plotvarinfo=existfun(plotvar);',...
			'if plotvarinfo(1,1)==0 | plotvarinfo(1,1)==-1,',...
				'usefulinfo=zeros(1,3);',...
			'else,',...
				'usefulinfo=get(plotvar(currentfigurenum,1),''UserData'');',...
			'end,',...
		'end,',...
		'lengthuseful=size(usefulinfo);',...
		'lengthuseful=lengthuseful(1,1);',...
		'countcircle=1;',...
		'for qw=1:lengthuseful,',...
			'if usefulinfo(qw,3)~=0,',...
				'getaxisvalue=axis;',...	
				'dumaxis=axis;',...
				'pullxdata=get(plotvar(currentfigurenum,usefulinfo(qw,3)+1),''XData'');',...		
				'pullydata=get(plotvar(currentfigurenum,usefulinfo(qw,3)+1),''YData'');',...
				'flag=1;',...
				'for ind=length(pullxdata):-1:1;',...
					'if flag~=0;',...
						'xtointer=(pullxdata(ind)-pullxdata(1)).*.9;',...
						'if xtointer < dumaxis(1,2) & xtointer > dumaxis(1,1);',...
							'ytointer=interp1(pullxdata,pullydata,xtointer);',...
							'if ytointer < dumaxis(1,4) & ytointer > dumaxis(1,3);',...
								'smartcircle(countcircle,1)=xtointer;',...
								'smartcircle(countcircle,2)=ytointer;',...
								'smartcircle(countcircle,3)=qw;',...
								'axis(getaxisvalue);',...
								'hold on,tempcircle(countcircle,1)=plot(smartcircle(countcircle,1),smartcircle(countcircle,2),''wo'');',...
								'countcircle=countcircle+1;',...
								'flag=0;',...	
							'end,',...
						'end,',...
					'end;',...
				'end;',...
			'end;',...
		'end;',...
		'if countcircle~=1,',...
		'if timer~=0;',...
			'messtext=''Select curve for correlation coefficient'';',...
			'typeofcall=1;',...
			'messfun(typeofcall,messtext,currentfigurenum);',...
		'end;',...
		'[numberofwinner]=closest(smartcircle);',...% determine which curve picked
		'num2modify=usefulinfo(smartcircle(numberofwinner,3),3);',...
		'xstat=get(plotvar(currentfigurenum,num2modify+1),''XData'');',...
		'ystat=get(plotvar(currentfigurenum,num2modify+1),''YData'');',...
		'[ccofy]=corrcoef(ystat);',...
		'string2add=[''Correlation coefficient = '',num2str(ccofy)];',...
		'intarea(currentfigurenum)=text((.5.*xstat(length(xstat))+xstat(1))./2,(.15.*getaxisvalue(1,4)+getaxisvalue(1,3))./2,num2str(string2add));',...
		'set(intarea(currentfigurenum),''Visible'',''off'');',...
		'texttoadd(currentfigurenum,:)=intarea(currentfigurenum);',...
		'textfun(0,0,currentfigurenum,texttoadd,0);',...
		'delete(intarea(currentfigurenum)); intarea(currentfigurenum)=0;',...
		'delete(tempcircle);clear tempcircle;',...
		'set(modifytextssingle(currentfigurenum),''Enable'',''on'');',...
		'set(modifytextsall(currentfigurenum),''Enable'',''on'');',...
		'end']);		
