
% Version 1.0 of ProPlot 1.0
%
%    // intgui.m \\
%
%     Scott Keane
%  skeane@uceng.uc.edu
%
% *****************************************
% Matlab script to set up a gui integration
% control
% *****************************************

if numoffigs==1
	figint=[];
end



% Add integration info to main figure
didint(currentfigurenum)=0;
uniqueoneeach(currentfigurenum)=1;

integrate(currentfigurenum)=uicontrol(figanddatawin(1,currentfigurenum),...
	'Style','push',...
	'String','Integrate',...
	'Position',[95 160 70 20],...
	'CallBack',['for bb=1:numoffigs,if figanddatawin(1,bb)==gcf,',...
		'currentfigurenum=bb;callfigurenum=bb;end,end,',...
		'tolmul=[.00001 .0001 .001 .01 .1 1 10];',...
		'tol1=get(tolunit(currentfigurenum),''Value'');tol2=tolmul(get(tolmag(currentfigurenum),''Value''));',...
		'tol=tol1.*tol2;',...
		'xint=xintmat(currentfigurenum,:);',...
		'yint=yintmat(currentfigurenum,:);',...
		' ',...
		'if exist(''traplines'')==0,',...
			'traplines=[];',...
		'else,',...
			'whattodel=existfun(traplines);',...
			'if whattodel(currentfigurenum,1)~=-1 & whattodel(currentfigurenum,1)~=0,',...
				'widthtraplines=size(traplines);',...
				'widthtraplines=widthtraplines(1,2);',...
				'for er=1:widthtraplines,',...
					'if traplines(currentfigurenum,er)~=0 & traplines(currentfigurenum,er)~=-1,',...
						'delete(traplines(currentfigurenum,er));',...
					'end,',...
				'end,',...
				'traplines(currentfigurenum,1:widthtraplines)=-1.*ones(1,widthtraplines);',...	
			'end,',...
		'end,',...
		' ',...
		'didint(currentfigurenum)=1;',...
		'trapnew;']);


tolunitstring(currentfigurenum)=uicontrol(figanddatawin(1,currentfigurenum),...
	'Style','text',...
	'BackgroundColor','k',...
	'ForegroundColor','w',...
	'String','Tolerance',...
	'Position',[135 220 80 20]);


inthelp(currentfigurenum)=uicontrol(figanddatawin(1,currentfigurenum),...
	'Style','push',...
	'BackgroundColor','k',...
	'ForegroundColor','w',...
	'String','?',...
	'Position',[225 220 20 20],...
	'CallBack',['if isempty(figint)==1;',...
		'intquest;end']);




tolunit(currentfigurenum)=uicontrol(figanddatawin(1,currentfigurenum),...
	'Style','popup',...
	'String','1|2|3|4|5|6|7|8|9|10',...
	'Position',[105 190 50 80],...
	'CallBack',['for bb=1:numoffigs,if figanddatawin(1,bb)==gcf,',...
		'currentfigurenum=bb;callfigurenum=bb;end,end,',...
		'tolmul=[.00001 .0001 .001 .01 .1 1 10];',...
		'tol1=get(tolunit(currentfigurenum),''Value'');tol2=tolmul(get(tolmag(currentfigurenum),''Value''));',...
		'set(actualtol(currentfigurenum),''String'',tol1.*tol2)']);



tolmag(currentfigurenum)=uicontrol(figanddatawin(1,currentfigurenum),...
	'Style','popup',...
	'Value',3,...
	'String','*.00001|*.0001|*.001|*.01|*.1|*1|*10',...
	'Position',[155 190 80 80],...
	'CallBack',['for bb=1:numoffigs,if figanddatawin(1,bb)==gcf,',...
		'currentfigurenum=bb;callfigurenum=bb;end,end,',...
		'tolmul=[.00001 .0001 .001 .01 .1 1 10];',...
		'tol1=get(tolunit(currentfigurenum),''Value'');tol2=tolmul(get(tolmag(currentfigurenum),''Value''));',...
		'set(actualtol(currentfigurenum),''String'',tol1.*tol2)']);

tolequal(currentfigurenum)=uicontrol(figanddatawin(1,currentfigurenum),...
	'Style','text',...
	'Position',[240 190 10 20],...
	'BackgroundColor','k',...
	'ForegroundColor','w',...
	'String','=');



actualtol(currentfigurenum)=uicontrol(figanddatawin(1,currentfigurenum),...
	'Style','text',...
	'Position',[255 190 60 20],...
	'BackgroundColor','k',...
	'ForegroundColor','w',...
	'String','.001');


closeint(currentfigurenum)=uicontrol(figanddatawin(1,currentfigurenum),...
	'Style','push',...
	'Position',[175 160 80 20],...
	'BackgroundColor','k',...
	'ForegroundColor','w',...
	'String','Dismiss',...
	'CallBack',['for bb=1:numoffigs,if figanddatawin(1,bb)==gcf,',...
		'currentfigurenum=bb;callfigurenum=bb;end,end,',...
		'if exist(''traplines'')~=0,',...%traplines exist
			'whattodel=existfun(traplines);',...
			'if whattodel(currentfigurenum,1)~=-1 & whattodel(currentfigurenum,1)~=0,',...
				'widthtraplines=size(traplines);',...
				'widthtraplines=widthtraplines(1,2);',...
				'for er=1:widthtraplines,',...
					'if traplines(currentfigurenum,er)~=0 & traplines(currentfigurenum,er)~=-1,',...
						'delete(traplines(currentfigurenum,er));',...
					'end,',...
				'end,',...
				'traplines(currentfigurenum,1:widthtraplines)=-1.*ones(1,widthtraplines);',...	
			'end,',...
		'end,',...
		'delete(inthelp(currentfigurenum),tolequal(currentfigurenum),integrate(currentfigurenum),tolunitstring(currentfigurenum),tolunit(currentfigurenum),tolmag(currentfigurenum),actualtol(currentfigurenum),closeint(currentfigurenum));',...
		'set(keeptext(currentfigurenum),''Visible'',''on'');',...
		'if didint(currentfigurenum)==1,',...
			'delete(intarea(currentfigurenum)); intarea(currentfigurenum)=0;',...
			'testing=get(keeptext(currentfigurenum),''Value'');',...
			'delete(keeptext(currentfigurenum));',...
			'if testing==0;',...
				'if timer~=0;',...
					'messtext=''Select point for integration area text'';',...
					'typeofcall=1;',...
					'messfun(typeofcall,messtext,currentfigurenum);',...
				'end;',...
				'[xtexttoadd,ytexttoadd]=ginput(1);',...
				'intarea(currentfigurenum)=text(xtexttoadd,ytexttoadd,areamat);',...
				'texttoadd(currentfigurenum,:)=intarea(currentfigurenum);',...
				'textfun(0,0,currentfigurenum,texttoadd,0);',...
				'delete(intarea(currentfigurenum)); intarea(currentfigurenum)=0;',...
			'end;',...
		'set(modifytextssingle(currentfigurenum),''Enable'',''on'');',...
		'set(modifytextsall(currentfigurenum),''Enable'',''on'');',...
		'else;',...
			'delete(keeptext(currentfigurenum));',...
		'end,',...
		'if isempty(figint)==0;delete(figint);figint=[];end;',...		
		'uniqueoneeach(currentfigurenum)=0;']);



keeptext(currentfigurenum)=uicontrol(figanddatawin(1,currentfigurenum),...
	'Style','checkbox',...
	'Position',[110 130 120 20],...
	'BackgroundColor','k',...
	'ForegroundColor','y',...
	'Value',1,...
	'String','Delete "Area=##" Text');


% Set units normalized to maintain gui positions upon fig window resize


set(integrate(currentfigurenum),'Units','normal');
set(tolunitstring(currentfigurenum),'Units','normal');
set(inthelp(currentfigurenum),'Units','normal');
set(tolunit(currentfigurenum),'Units','normal');
set(tolmag(currentfigurenum),'Units','normal');
set(tolequal(currentfigurenum),'Units','normal');
set(actualtol(currentfigurenum),'Units','normal');
set(closeint(currentfigurenum),'Units','normal');



