
% Version 1.0 of ProPlot 1.0
%
%    // trapnew.m \\
%
%     Scott Keane
%  skeane@uceng.uc.edu
%
%    Created on:    8:48 PM 4/23/96
%    Last Modified: 6:25 AM 4/26/96
%
% *****************************************
% Matlab script to numerically integrate
% data
% Note:  Red lines represent the finest trapazoids
% possible, whereas blue lines represent a satisfied
% tolerance value
% *****************************************



traplinescount=0;
n=length(xint);
w=n;
highestn=n;
numofdata=n;
tolflag=1;
totalarea=0;
while(numofdata-1 > 1)
	lowestn=n-numofdata+1;
	sum=((yint(lowestn)+yint(n))/2)*(xint(n)-xint(lowestn));
	tolflag=1;
	%fprintf('Start inner while');
	while(numofdata-1 > 1) & tolflag==1
		stop=1;
		initarea=sum;
		cut=rem((w-lowestn),2);
		if cut==0
			highestn=w;
			w=ceil((highestn-lowestn)/2)+lowestn;
			leftarea=((yint(w)+yint(lowestn))/2)*(xint(w)-xint(lowestn));
			rightarea=((yint(highestn)+yint(w))/2)*(xint(highestn)-xint(w));
			sum=leftarea+rightarea;	
		else
			highestn=w;
			w=ceil((highestn-lowestn)./2)+lowestn-1;
			leftarea=((yint(w)+yint(lowestn))/2)*(xint(w)-xint(lowestn));
			rightarea=((yint(highestn)+yint(w))/2)*(xint(highestn)-xint(w));
			sum=leftarea+rightarea;	
		end
		if abs(sum-initarea) <= tol
			dxint=[xint(lowestn) xint(highestn)];dyint=[yint(lowestn) yint(highestn)];hold on;traplinescount=traplinescount+1;traplines(currentfigurenum,traplinescount)=plot(dxint,dyint,'b');
			dxint=[xint(lowestn) xint(lowestn)]; dyint=[yint(lowestn) 0];hold on;traplinescount=traplinescount+1;traplines(currentfigurenum,traplinescount)=plot(dxint,dyint,'b');
			tolflag=0;
			totalarea=sum+totalarea;
			stop=0;
			stoptol=0;
		end
		numofdata=highestn-lowestn+1;
		%fprintf('numofdata=%i \n',numofdata);
		
		if (numofdata-1) <= 1  & stop==1
			dxint=[xint(lowestn) xint(highestn)];dyint=[yint(lowestn) yint(highestn)];hold on;traplinescount=traplinescount+1;traplines(currentfigurenum,traplinescount)=plot(dxint,dyint,'r');
			dxint=[xint(lowestn) xint(lowestn)]; dyint=[yint(lowestn) 0];hold on;traplinescount=traplinescount+1;traplines(currentfigurenum,traplinescount)=plot(dxint,dyint,'r');
			totalarea=sum+totalarea;
			tolflag=0;
			stoptol=1;
		end
	end
%fprintf('\nTotal Area =%i \n\n',totalarea);
numofdata=n-highestn+1;
highestn=n;
w=n;
end

% add last piece on on far right
if numofdata==2 & stoptol==1
	lastarea=((yint(n)+yint(n-1))/2)*(xint(n)-xint(n-1));
	totalarea=lastarea+totalarea;
	%fprintf('Added far right piece \n');
	%fprintf('\nTotal Area =%i \n\n',totalarea);
	dxint=[xint(n) xint(n-1)];dyint=[yint(n) yint(n-1)];hold on;traplinescount=traplinescount+1;traplines(currentfigurenum,traplinescount)=plot(dxint,dyint,'r');
	dxint=[xint(n-1) xint(n-1)]; dyint=[yint(n-1) 0];hold on;traplinescount=traplinescount+1;traplines(currentfigurenum,traplinescount)=plot(dxint,dyint,'r');
	dxint=[xint(n) xint(n)]; dyint=[yint(n) 0];hold on;traplinescount=traplinescount+1;traplines(currentfigurenum,traplinescount)=plot(dxint,dyint,'r');
else
	dxint=[xint(n) xint(n)]; dyint=[yint(n) 0];hold on;traplinescount=traplinescount+1;traplines(currentfigurenum,traplinescount)=plot(dxint,dyint,'r');
end

% **************************************************************
% **************** Plot Horizontal Line ************************
% **************************************************************

dumaxis=axis;
dxint=[min(xint) max(xint)];dyint=[0 0];hold on;traplinescount=traplinescount+1;traplines(currentfigurenum,traplinescount)=plot(dxint,dyint,'r');


areamat=['Area = ',num2str(totalarea)];

% **************************************************************
% **************** Plot Value of Area **************************
% **************************************************************
%if timer~=0;
	%xmess=(.2.*getaxisvalue(1,2)+getaxisvalue(1,1))./2;
	%ymess=(.2.*getaxisvalue(1,4)+getaxisvalue(1,3))./2;
	%leadermess=text(xmess,ymess,'Select point for integration area text')
	%set(leadermess,'Units','normal');
	%pause(timer);delete(leadermess);clear leadermess;
%end

%[xtexttoadd,ytexttoadd]=ginput(1);

xtexttoadd=(.7.*getaxisvalue(1,2)+getaxisvalue(1,1))./2;
ytexttoadd=(.2.*getaxisvalue(1,4)+getaxisvalue(1,3))./2;

if exist('intarea')==0
	intarea(currentfigurenum)=text(xtexttoadd,ytexttoadd,areamat);
else
	whattodel=existfun(intarea);
	if whattodel(currentfigurenum,1)~=-1 & whattodel(currentfigurenum,1)~=0
		delete(intarea(currentfigurenum));
	end
	intarea(currentfigurenum)=text(xtexttoadd,ytexttoadd,areamat);
end