
% Version 1.0 of ProPlot 1.0
%
%    // leadfine.m \\
%
%     Scott Keane
%  skeane@uceng.uc.edu
%
%    Created on:    5:34PM  2/28/96
%    Last Modified: 6:25 AM 4/26/96
%
% *****************************************
% Matlab script to fine tune a leader point
% *****************************************


% Only run this if it is unique to current figure

s=axis;
xslideleader(currentfigurenum)=uicontrol(figanddatawin(1,currentfigurenum),...
	'Style','slider',...
	'Position',[100 130 60 20],...
	'Min',s(1,1),...
	'Max',s(1,2),...
	'Value',xpre(currentfigurenum,n(currentfigurenum)),...
	'CallBack',['for bb=1:numoffigs,if figanddatawin(1,bb)==gcf,',...
		'currentfigurenum=bb;end,end,',...
		'stamat=1+(currentfigurenum-1).*11;',...
		'[valuex]=get(xslideleader(currentfigurenum),''Value'');',...
		'xpre(currentfigurenum,n(currentfigurenum))=valuex;',...
		'set(leadersmart(row2modify(currentfigurenum),stamat),''XData'',xpre(currentfigurenum,1:xprelen(currentfigurenum)),''YData'',ypre(currentfigurenum,1:yprelen(currentfigurenum)));',...
		'set(selcircles(currentfigurenum),''XData'',xpre(currentfigurenum,n(currentfigurenum)),''YData'',ypre(currentfigurenum,n(currentfigurenum)));']);
	



xleadertext(currentfigurenum)=uicontrol(figanddatawin(1,currentfigurenum),...
	'Style','text',...
	'String','x-value',...
	'Position',[100 150 60 20],...
	'ForegroundColor',[1 1 1],...
	'BackgroundColor',[0 0 0]);
	
yslideleader(currentfigurenum)=uicontrol(figanddatawin(1,currentfigurenum),...
	'Style','slider',...
	'Position',[200 130 60 20],...
	'Min',s(1,3),...
	'Max',s(1,4),...
	'Value',ypre(currentfigurenum,n(currentfigurenum)),...
	'CallBack',['for bb=1:numoffigs,if figanddatawin(1,bb)==gcf,',...
		'currentfigurenum=bb;end,end,',...
		'stamat=1+(currentfigurenum-1).*11;',...
		'[valuey]=get(yslideleader(currentfigurenum),''Value'');',...
		'ypre(currentfigurenum,n(currentfigurenum))=valuey;',...		
		'set(leadersmart(row2modify(currentfigurenum),stamat),''XData'',xpre(currentfigurenum,1:xprelen(currentfigurenum)),''YData'',ypre(currentfigurenum,1:yprelen(currentfigurenum)));',...
		'set(selcircles(currentfigurenum),''XData'',xpre(currentfigurenum,n(currentfigurenum)),''YData'',ypre(currentfigurenum,n(currentfigurenum)));']);
	

yleadertext(currentfigurenum)=uicontrol(figanddatawin(1,currentfigurenum),...
	'Style','text',...
	'String','y-value',...
	'Position',[200 150 60 20],...
	'ForegroundColor',[1 1 1],...
	'BackgroundColor',[0 0 0]);	

finetuneleadertext(currentfigurenum)=uicontrol(figanddatawin(1,currentfigurenum),...
	'Style','text',...
	'String','x-y leader fine tuning',...
	'Position',[120 170 130 20],...
	'ForegroundColor',[1 1 1],...
	'BackgroundColor',[0 0 0]);

finishedleader(currentfigurenum)=uicontrol(figanddatawin(1,currentfigurenum),...
	'Style','push',...
	'Position',[130 100 100 20],...
	'String','Dismiss',...
	'CallBack',['for bb=1:numoffigs,if figanddatawin(1,bb)==gcf,',...
		'currentfigurenum=bb;end,end,',...	
		'uniqueoneeach(currentfigurenum)=0;',...
		'delete(finetuneleadertext(currentfigurenum),yleadertext(currentfigurenum),yslideleader(currentfigurenum),xleadertext(currentfigurenum),xslideleader(currentfigurenum),finishedleader(currentfigurenum));',...
		'delete(selcircles(currentfigurenum));']);


set(xslideleader(currentfigurenum),'Units','normal');
set(xleadertext(currentfigurenum),'Units','normal');
set(yslideleader(currentfigurenum),'Units','normal');
set(yleadertext(currentfigurenum),'Units','normal');
set(finetuneleadertext(currentfigurenum),'Units','normal');
set(finishedleader(currentfigurenum),'Units','normal');