% Version 1.0 of ProPlot 1.0
%
%    // lines5.m \\
%
%     Scott Keane
%  skeane@uceng.uc.edu
%
% Created          11:21PM  2/26/96
% Last Modified    11:31PM  2/29/96
%
% *****************************************
% Matlab script to call leader functions
% *****************************************


addsegment(numoffigs)=uimenu(modifyleaderssingle(numoffigs),...
	'Label','&Add Segment to Leader',...
	'Checked','off',...
	'Separator','on',...
	'CallBack',['for bb=1:numoffigs,if figanddatawin(1,bb)==gcf,',...
		'currentfigurenum=bb;end,end,',...
		'stamat=1+(currentfigurenum-1).*11;',...
		'[uniqueoneeach]=addsegfu(currentfigurenum,stamat,uniqueoneeach,winsize_figure_width,figanddatawin);',...
		'uniqueoneeach=0;']);


% ************************************************************
% *************** Remove Segment from Leader *****************
% ************************************************************

remsegment(numoffigs)=uimenu(modifyleaderssingle(numoffigs),...
	'Label','&Remove a Point',...
	'Checked','off',...
	'Separator','on',...
	'CallBack',['for bb=1:numoffigs,if figanddatawin(1,bb)==gcf,',...
		'currentfigurenum=bb;end,end,',...
		'stamat=1+(currentfigurenum-1).*11;',...
		'[uniqueoneeach]=remsegfu(currentfigurenum,stamat,uniqueoneeach,winsize_figure_width,figanddatawin);',...
		'uniqueoneeach=0;']);


% ************************************************************
% *********************** Modify Leader **********************
% ************************************************************

modifysegment(numoffigs)=uimenu(modifyleaderssingle(numoffigs),...
	'Label','&Modify Leader Point',...
	'Checked','off',...
	'Separator','on');


% ************************************************************

mouseclicksegment(numoffigs)=uimenu(modifysegment(numoffigs),...
	'Label','&Mouse Click',...
	'Checked','off',...
	'Separator','off',...
	'CallBack',['for bb=1:numoffigs,if figanddatawin(1,bb)==gcf,',...
		'currentfigurenum=bb;end,end,',...
		'stamat=1+(currentfigurenum-1).*11;',...
		'[uniqueoneeach]=mouclkfu(currentfigurenum,stamat,uniqueoneeach,winsize_figure_width,figanddatawin);',...
		'uniqueoneeach=0;']);

		


% initialize finetune leader values

if numoffigs==1
	row2modify=[];
	xpre=[];
	ypre=[];
	n=[];
	xprelen=[];
	yprelen=[];
	xslideleader=[];
	xleadertext=[];
	yslideleader=[];
	yleadertext=[];
	finetuneleadertext=[];
	finishedleader=[];
	selcircles=[];
end


% ************************************************************


finetunesegment(numoffigs)=uimenu(modifysegment(numoffigs),...
	'Label','&Fine Tune',...
	'Checked','off',...
	'Separator','on',...
	'CallBack',['for bb=1:numoffigs,if figanddatawin(1,bb)==gcf,',...
		'currentfigurenum=bb;end,end,',...
		'stamat=1+(currentfigurenum-1).*11;',...
		'[row2modify,xpre,ypre,n,xprelen,yprelen,uniqueoneeach,xslideleader,selcircles,xleadertext,yslideleader,yleadertext,finetuneleadertext,finishedleader]=fineldfu(selcircles,currentfigurenum,stamat,uniqueoneeach,figanddatawin,numoffigs,row2modify,xpre,ypre,n,xprelen,yprelen,xslideleader,xleadertext,yslideleader,yleadertext,finetuneleadertext,finishedleader,winsize_figure_width);',...
		'uniqueoneeach=0;']);







