function [donelabels,submitlabels,removelabels,resetlabels,figedit,figxedit,figyedit]=labelfun(donelabels,numoffigs,figanddatawin,figedit,figxedit,figyedit);

% Version 1.0 of ProPlot 1.0
%
%    // labelfun.m \\
%
%     Scott Keane
%  skeane@uceng.uc.edu
%
%    Created on:    5:35PM  3/23/96
%    Last Modified: 6:48 AM 4/26/96
%
% *****************************************
% Matlab script to add title,xlabel,and
% ylabel to plot
% *****************************************


% 
% file to ask for title, xlabel,ylabel
% note that the program does its best to determine
% if the xlabel,ylabel,properties exist

% fig100=figure('Resize','off','Pointer','arrow','MenuBar','none','Position',[5,5,450,100],'NumberTitle','off','Name','Labels')

% *********************************************
% ******* Title *******************************
% *********************************************
figtitle=uicontrol(figanddatawin(3,numoffigs),...
	'Style','text',...
	'String','title:',...
	'Position',[10 65 50 20],...
	'ForegroundColor','b',...
	'BackgroundColor','k');

figedit(numoffigs,1)=uicontrol(figanddatawin(3,numoffigs),...
	'Style','edit',...
	'Position',[65 70 380 15],...
	'ForegroundColor','w',...
	'BackgroundColor','b');





% **************************************************
% ************** X-Axis ****************************
% **************************************************
figxaxistitle=uicontrol(figanddatawin(3,numoffigs),...
	'Style','text',...
	'String','x-axis:',...
	'Position',[10 45 50 20],...
	'ForegroundColor','b',...
	'BackgroundColor','k');

figxedit(numoffigs,1)=uicontrol(figanddatawin(3,numoffigs),...
	'Style','edit',...
	'Position',[65 50 380 15],...
	'ForegroundColor','w',...
	'BackgroundColor','b');


% **************************************************
% ************** Y-Axis ****************************
% **************************************************
figyaxistitle=uicontrol(figanddatawin(3,numoffigs),...
	'Style','text',...
	'String','y-axis:',...
	'Position',[10 25 50 20],...
	'ForegroundColor','b',...
	'BackgroundColor','k');

figyedit(numoffigs,1)=uicontrol(figanddatawin(3,numoffigs),...
	'Style','edit',...
	'Position',[65 30 380 15],...
	'ForegroundColor','w',...
	'BackgroundColor','b');



% ******************************************************
% *************** Submit Labels *************************
% ******************************************************

submitlabels(numoffigs,1)=uicontrol(figanddatawin(3,numoffigs),...
	'Style','push',...
	'Position',[50 2.5 90 20],...
	'String','Submit',...
	'CallBack',['for bb=1:numoffigs,if figanddatawin(3,bb)==gcf,',...
		'currentfigurenum=bb;end,end,',...
		'figure(figanddatawin(1,currentfigurenum));',...
		'abstitle=abs(get(figedit(currentfigurenum,1),''String''));',...
		'lengthtitle=length(abstitle);',...
		'titlefig(currentfigurenum,:)=[abstitle,zeros(1,100-lengthtitle)];',...
		'absxlabel=abs(get(figxedit(currentfigurenum,1),''String''));',...
		'lengthxlabel=length(absxlabel);',...
		'xlabelfig(currentfigurenum,:)=[absxlabel,zeros(1,100-lengthxlabel)];',...
		'absylabel=abs(get(figyedit(currentfigurenum,1),''String''));',...
		'lengthylabel=length(absylabel);',...
		'ylabelfig(currentfigurenum,:)=[absylabel,zeros(1,100-lengthylabel)];',...
		'a=[''set(get(gca,''''Title''''),''''String'''','',''setstr(titlefig(currentfigurenum,1:lengthtitle))'','')''];',...
		'b=[''set(get(gca,''''XLabel''''),''''String'''','',''setstr(xlabelfig(currentfigurenum,1:lengthxlabel))'','')''];',...
		'c=[''set(get(gca,''''YLabel''''),''''String'''','',''setstr(ylabelfig(currentfigurenum,1:lengthylabel))'','')''];',...
		'eval(a);eval(b);eval(c);']);


removelabels(numoffigs,1)=uicontrol(figanddatawin(3,numoffigs),...
	'Style','push',...
	'Position',[150 2.5 90 20],...
	'String','Remove',...
	'CallBack',['for bb=1:numoffigs,if figanddatawin(3,bb)==gcf,',...
		'currentfigurenum=bb;end,end,',...
		'titlefig(currentfigurenum,:)=zeros(1,100);',...
		'xlabelfig(currentfigurenum,:)=zeros(1,100);',...
		'ylabelfig(currentfigurenum,:)=zeros(1,100);',...
		'figure(figanddatawin(1,currentfigurenum));',...
		'set(get(gca,''Title''),''String'','''');',...
		'set(get(gca,''XLabel''),''String'','''');',...
		'set(get(gca,''YLabel''),''String'','''');']);


resetlabels(numoffigs,1)=uicontrol(figanddatawin(3,numoffigs),...
	'Style','push',...
	'Position',[250 2.5 90 20],...
	'String','Reset',...
	'CallBack',['for bb=1:numoffigs,if figanddatawin(3,bb)==gcf,',...
		'currentfigurenum=bb;end,end,',...
		'titlefig(currentfigurenum,:)=zeros(1,100);',...
		'xlabelfig(currentfigurenum,:)=zeros(1,100);',...
		'ylabelfig(currentfigurenum,:)=zeros(1,100);',...
		'figure(figanddatawin(1,currentfigurenum));',...
		'set(get(gca,''Title''),''String'','''');',...
		'set(get(gca,''XLabel''),''String'','''');',...
		'set(get(gca,''YLabel''),''String'','''');',...
		'set(figedit(currentfigurenum,1),''String'','''');',...
		'set(figxedit(currentfigurenum,1),''String'','''');',...
		'set(figyedit(currentfigurenum,1),''String'','''');']);


donelabels(numoffigs,1)=uicontrol(figanddatawin(3,numoffigs),...
	'Style','push',...
	'Position',[350 2.5 90 20],...
	'String','Dismiss',...
	'CallBack',['for bb=1:numoffigs,if figanddatawin(3,bb)==gcf,',...
		'currentfigurenum=bb;end,end,',...
		'set(figanddatawin(3,currentfigurenum),''Visible'',''off'');',...
		'set(labelitup(currentfigurenum),''Checked'',''off'');']);










% Need to write code to check the isempty options and when user
% clicks label, the software should be smart enough to realize
% what has already been entered and use these values as the value
% in the edit fields.

% ******************************************************
% ******Apply to Active Figures ************************
% ******************************************************
% remember that everytime you create a new plot this
% has to be updated


return