function [plotvar,popslistx,popslisty,popsx,popsy]=plotfun(thexvalues,theyvalues,linecolor,linestyle,linewidth,markersize,popslistx,popslisty,popsx,popsy,plotvar,bb,currentfigurenum,callfigurenum,numoffigs,gcf,whattoplotx,whattoploty,topbotdata,figanddatawin,enhist,timesplotted)

% Version 1.0 of ProPlot 1.0
%
%    // plotfun.m \\
%
%     Scott Keane
%  skeane@uceng.uc.edu
%
%
% *****************************************
% General Purpose function to plot
% *****************************************
%


% **********************************************************
% ************ Determine type of call **********************
% **********************************************************

%thexvalues=eval(whattoplotx);
%x=thexvalues;
%theyvalues=eval(whattoploty);

% *** if thexvalues and theyvalues are columns then transpose them ***
sizexvalues=size(thexvalues);
if sizexvalues(1,1) ~= 1 % *** col ***
	thexvalues=thexvalues';
end

sizeyvalues=size(theyvalues);
if sizeyvalues(1,1) ~= 1 % *** col ***
	theyvalues=theyvalues';
end


plotvarinfo=existfun(plotvar);


if size(plotvarinfo)==[1,1]  %first call to plot
	plotvarinfo=[zeros(currentfigurenum-1,1);plotvarinfo];
end

% ***********************************************************
% ********** Execute on first plot on new figure ************
% ***********************************************************

if plotvarinfo(currentfigurenum,1) == -1 |  plotvarinfo(currentfigurenum,1) == 0  %first call
	timesrun=1;
	figure(figanddatawin(1,numoffigs));hold on;
	plotvar(currentfigurenum,1)=plot(0,0);hold on;
	set(plotvar(currentfigurenum,1),'Visible','off');hold on;
	% ******get pulldown values and use in plot ***************
	lcolor=['Y','M','C','R','G','B','W','K'];
	lstyle=[setstr('.'),0;setstr('o'),0;setstr('x'),0;setstr('+'),0;setstr('*'),0;setstr('-'),0;setstr(':'),0;setstr('-.');setstr('--')];
	lwidth=[1:10];
	msize=[2:9];

	plotvar(currentfigurenum,2)=plot(thexvalues,theyvalues);hold on;
	
	set(plotvar(currentfigurenum,2),'Color',lcolor(get(linecolor(callfigurenum,topbotdata),'Value')));
	set(plotvar(currentfigurenum,2),'Linestyle',lstyle(get(linestyle(callfigurenum,topbotdata),'Value')));
	set(plotvar(currentfigurenum,2),'Linewidth',lwidth(get(linewidth(callfigurenum,topbotdata),'Value')));
	set(plotvar(currentfigurenum,2),'MarkerSize',msize(get(markersize(callfigurenum,topbotdata),'Value')));

	pcolor(1,1:3)=get(plotvar(currentfigurenum,timesrun+1),'Color');
	pstyle=abs(get(plotvar(currentfigurenum,timesrun+1),'Linestyle'));
	if length(pstyle) == 1
		pstyle=[pstyle 0];
	end
	pwidth=get(plotvar(currentfigurenum,timesrun+1),'Linewidth');
	pmsize=get(plotvar(currentfigurenum,timesrun+1),'MarkerSize');

	lengthofrow=length([callfigurenum,topbotdata,timesrun,1,pcolor,pstyle,pwidth,pmsize,abs(whattoplotx),38,abs(whattoploty)]);
	makecolumnsequal=[callfigurenum,topbotdata,timesrun,1,pcolor,pstyle,pwidth,pmsize,abs(whattoplotx),38,abs(whattoploty),zeros(1,100-lengthofrow)];
	
	set(plotvar(currentfigurenum,1),'UserData',makecolumnsequal);
	figure(figanddatawin(1,callfigurenum));
	figure(figanddatawin(2,callfigurenum));
	
else % @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
	dummyplotvarsize=size(plotvar);
	dummyplotvarsize=dummyplotvarsize(1,2);
	flag=1;
	%fprintf('Stop and debug timesrun loop \n'),%keyboard

	for qq=1:dummyplotvarsize+1
		if flag==1
			%fprintf('flag==1'),% keyboard
			if plotvarinfo(currentfigurenum,qq) == -1 | plotvarinfo(currentfigurenum,qq) == 0
				timesrun=qq-1;
				flag=0;
				%fprintf('Run %i times',timesrun)
			end
		end
	end

	%fprintf('Using previously est. matrix'),%keyboard
	userdata=get(plotvar(currentfigurenum,1),'UserData');
	tempstore=userdata;
	userdatasize=size(userdata);
	userdatasize=userdatasize(1,1);




% ********************************************************************
% ******* Is the data unique (test by looking at columns 1 & 2)? *****
% ********************************************************************
% column 3 contains figure# and 4 the data #
unique=1;
%fprintf('Check User Data Matrix'),%keyboard
	for cc=1:userdatasize 
		if [tempstore(cc,1) tempstore(cc,2)]==[callfigurenum,topbotdata];
			unique=0;
			duplicatenum=cc;
			% plot to be deleted in column 3
			plotnumdelete=tempstore(duplicatenum,3);
			%fprintf('Data Line %i DUPLICATES!!!! \n',cc),%keyboard
		end
	end


% *************************************************************
% *************** Remove Duplicate ****************************
% *************************************************************
%fprintf('Stop and Check unique loop \n');
%keyboard
if unique==0  % duplicate
delete(plotvar(currentfigurenum,plotnumdelete+1)); %removes it from plot
%fprintf('Duplicate just removed from plot!! \n');
%fprintf('Time to remove data from array, check \n'),%keyboard
	if duplicatenum==1
		tempstore=flipud(tempstore);
		tempstore=tempstore(1:userdatasize-1,:);
		tempstore=flipud(tempstore);
		% add new one
	elseif duplicatenum==userdatasize
		tempstore=tempstore(1:userdatasize-1,:);
	else
		firsthalf=tempstore(1:duplicatenum-1,:);
		secondhalf=tempstore(duplicatenum+1:userdatasize,:);
	end
end

% ******get pulldown values and use in plot ***************


lcolor=['Y','M','C','R','G','B','W','K'];
lstyle=[setstr('.'),0;setstr('o'),0;setstr('x'),0;setstr('+'),0;setstr('*'),0;setstr('-'),0;setstr(':'),0;setstr('-.');setstr('--')];
lwidth=[1:10];
msize=[2:9];


% **********************************************************
% ********** Determine axis values *************************
% **********************************************************
figure(figanddatawin(1,currentfigurenum));
getaxisvalue=axis;
xaxismat=[getaxisvalue(1,1) getaxisvalue(1,2) thexvalues];
yaxismat=[getaxisvalue(1,3) getaxisvalue(1,4) theyvalues];
axis([min(xaxismat) max(xaxismat) min(yaxismat) max(yaxismat)]);
hold on;


% ************************************************************

plotvar(currentfigurenum,timesrun+1)=plot(thexvalues,theyvalues);hold on;


% *************************************************************

set(plotvar(currentfigurenum,timesrun+1),'Color',lcolor(get(linecolor(callfigurenum,topbotdata),'Value')));
set(plotvar(currentfigurenum,timesrun+1),'Linestyle',lstyle(get(linestyle(callfigurenum,topbotdata),'Value')));
set(plotvar(currentfigurenum,timesrun+1),'Linewidth',lwidth(get(linewidth(callfigurenum,topbotdata),'Value')));
set(plotvar(currentfigurenum,timesrun+1),'MarkerSize',msize(get(markersize(callfigurenum,topbotdata),'Value')));

% *****************************************************************



pcolor(1,1:3)=get(plotvar(currentfigurenum,timesrun+1),'Color');
pstyle=abs(get(plotvar(currentfigurenum,timesrun+1),'Linestyle'));

if length(pstyle)==1
	pstyle=[pstyle 0];
end
pwidth=get(plotvar(currentfigurenum,timesrun+1),'Linewidth');
pmsize=get(plotvar(currentfigurenum,timesrun+1),'MarkerSize');

lengthofrow=length([callfigurenum,topbotdata,timesrun,1,pcolor,pstyle,pwidth,pmsize,abs(whattoplotx),38,abs(whattoploty)]);
makecolumnsequal=[callfigurenum,topbotdata,timesrun,1,pcolor,pstyle,pwidth,pmsize,abs(whattoplotx),38,abs(whattoploty),zeros(1,100-lengthofrow)];
set(plotvar(currentfigurenum,1),'UserData',[tempstore;makecolumnsequal]);

figure(figanddatawin(1,callfigurenum));
figure(figanddatawin(2,callfigurenum));

end


if enhist==1 %history is on
	if timesplotted==1
		popslistx=[];
		popslisty=[];
	end
	
	% ************************************************************
	% ************** Begin Pull-Down X-Menu Section **************
	% ************************************************************
	%keyboard
	lengthsubmit=length(whattoplotx);
	popslistx=[setstr(whattoplotx),zeros(1,50-length(whattoplotx));popslistx];
	sizepopslistx=size(popslistx);sizepopslistx=sizepopslistx(1,1);
	stop=1;
	for tt=2:sizepopslistx	
		for uu=1:50
			if stop==1
				if setstr(popslistx(tt,1:length(whattoplotx)))==setstr(whattoplotx) & uu==lengthsubmit
					stop=0;
				end
			end
		end
	end
	if stop==0  %remove entry from matrix
		popslistx=popslistx(2:sizepopslistx,:);
	else
		for aaa=1:numoffigs
			for bbb=1:2
				set(popsx(aaa,bbb),'String',popslistx);
			end
		end
	end



	% ************************************************************
	% ************** Begin Pull-Down Y-Menu Section **************
	% ************************************************************

	lengthsubmit=length(whattoploty);
	popslisty=[setstr(whattoploty),zeros(1,50-length(whattoploty));popslisty];
	sizepopslisty=size(popslisty);sizepopslisty=sizepopslisty(1,1);
	stop=1;
	for tt=2:sizepopslisty
		for uu=1:50
			if stop==1
				if setstr(popslisty(tt,1:length(whattoploty)))==setstr(whattoploty) & uu==lengthsubmit
					stop=0;
				end
			end
		end
	end

	if stop==0  %remove entry from matrix
		popslisty=popslisty(2:sizepopslisty,:);
	else
		for aaa=1:numoffigs
			for bbb=1:2
				set(popsy(aaa,bbb),'String',popslisty);
			end
		end
	end

end



refresh(figanddatawin(1,currentfigurenum));







return
