function [plotvar]=removfun(type,lenx,leny,plotvar,bb,currentfigurenum,callfigurenum,numoffigs,gcf,topbotdata,figanddatawin)

% Version 1.0 of ProPlot 1.0
%
%    // removfun.m \\
%
%     Scott Keane
%  skeane@uceng.uc.edu
%
%
% *****************************************
% General Purpose function to remove curves from plot.
% *****************************************


% ************************************************************
% CASE 1: for now assume that data exists and has been plotted
% ************************************************************
% may want to check if program has been run and if it has nt
% donothing,do not even call removfun.m
% may want to call existfun
%fprintf('Start removfun**************\n');
% ****************************************************************
% **************** test for existence of plotvar *****************
% ****************************************************************
plotvarinfo=existfun(plotvar);
%fprintf('check plotvarinfo')

%keyboard
if plotvarinfo(currentfigurenum,1)==-1 | plotvarinfo(currentfigurenum,1)==0
	
	if type==2
		messtext='Nothing to Remove!';
		typeofcall=0;
		messfun(typeofcall,messtext,currentfigurenum);
	elseif type==1 & lenx==0 & leny==0
		messtext='Nothing to Reset!';
		typeofcall=0;
		messfun(typeofcall,messtext,currentfigurenum);
	end
	
else % @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
	userdata=get(plotvar(currentfigurenum,1),'UserData');
	tempstore=userdata;
	userdatasize=size(userdata);
	userdatasize=userdatasize(1,1);

% ********************************************************************
% ******* Is the data unique (test by looking at columns 1 & 2)? *****
% ********************************************************************
% column 3 contains figure# and 4 the data #
 unique=1;
%fprintf('Getting ready to determine if unique')
	for cc=1:userdatasize 
		if [tempstore(cc,1) tempstore(cc,2)]==[callfigurenum,topbotdata];
			unique=0;
			duplicatenum=cc;
			% plot to be deleted in column 3
			plotnumdelete=tempstore(duplicatenum,3);
			%fprintf('Data Line %i DUPLICATES!!!! \n',cc)
		end
	end


% *************************************************************
% *************** Remove Duplicate ****************************
% *************************************************************
%fprintf('Stop and Check unique loop \n');

if unique==0  % duplicate
%fprintf('Check delete next'),keyboard
delete(plotvar(currentfigurenum,plotnumdelete+1)); %removes it from plot
%fprintf('Duplicate just removed from plot!! \n');
%fprintf('Time to remove data from array, check \n')
	if duplicatenum==1
		tempstore=flipud(tempstore);
		tempstore=tempstore(1:userdatasize-1,:);
		tempstore=flipud(tempstore);
		% add new one
	elseif duplicatenum==userdatasize
		tempstore=tempstore(1:userdatasize-1,:);
	else
		firsthalf=tempstore(1:duplicatenum-1,:);
		secondhalf=tempstore(duplicatenum+1:userdatasize,:);
		tempstore=[firsthalf;secondhalf];
	end
else
	if type==2
		messtext='Nothing to Remove!';
		typeofcall=0;
		messfun(typeofcall,messtext,currentfigurenum);
	elseif type==1 & lenx==0 & leny==0
		messtext='Nothing to Reset!';
		typeofcall=0;
		messfun(typeofcall,messtext,currentfigurenum);
	end
end

set(plotvar(currentfigurenum,1),'UserData',[tempstore]);
	
end

return
