% Version 1.0 of ProPlot 1.0
%
%    // ProPlot.m \\
%
%     Scott Keane
%  skeane@uceng.uc.edu
%
%  Created       12:43 AM 2/25/96
%  Last Mofified 11:34 AM 9/11/96
% 
% **********************************
% Main Startup Program for Proplot.
% Note that this code was written for Matlab 4.2b
% and exits with the close all command(Not available in Matlab4.0). 
% To my knowledge the rest of the code should run in Matlab 4.0 and higher.
% To load previously saved data(unsupported by me in Release 1.0), set 
% loaddataoption=1 about 50 lines below(after close figure and clear all; 
% **********************************

% **************************************
% *** PROMPT USER TO CLEAR WORKSPACE ***
% **************************************

clearque=1; % *** initially assume user wants to clear ***

clearres=input('ProPlot would like to Clear Workspace, OK (y/n)? ','s');

if isempty(clearres)==0 % *** not empty ***
	if length(clearres)==1
		if clearres=='n' | clearres=='N'
			clearque=0;
		end
	elseif length(clearres)==2
		if clearres=='No' | clearres=='no' | clearres=='NO' | clearres=='nO' 
			clearque=0;
		end
	end
end

if clearque==1
	clear
	fprintf('Clearing Workspace, All Previous Variables Are Lost! \n');
else
	fprintf('Variables maintained, Warning: Naming Conflicts May Exist! \n');

end

% ****************************************
% *** PROMPT USER TO CLOSE ALL FIGURES ***
% ****************************************

clearque=1; % *** initially assume user wants to close all ***

clearres=input('ProPlot would like to Close all Figures, OK (y/n)? ','s');

if isempty(clearres)==0 % *** not empty ***
	if length(clearres)==1
		if clearres=='n' | clearres=='N'
			clearque=0;
		end
	elseif length(clearres)==2
		if clearres=='No' | clearres=='no' | clearres=='NO' | clearres=='nO' 
			clearque=0;
		end
	end
end

if clearque==1
	close all
	fprintf('Closing All Figures, Previous UnSaved Entities Are Lost! \n');
else
	fprintf('Figures maintained! \n');

end



% *** To enable loading saved files, set loaddataoption below=1 
% *** Note: This is not fully supported!
% *** It does read text, lines, leaders,and axis properties previously 
% *** created and supports their modification
% *** Other entities may or may not read, so use at your own risk! ***

loaddataoption=0;

% ***** check, plot,remove all, then save, crash ***

numoffigs=0;
timesplotted=0;
global figinput;
% *********************************************************
% ***************** Add all Proplot paths *****************
% *********************************************************
if exist('datasmar.m')==0
	addpath;
else
	prodir
	oldpath=pwd;
end

% **************************************************
% **** Call notifyda.m to initialize warning info **
% **************************************************
% Note if you have accidentally suppressed warning
% messages, you can turn them back on by setting all
% of the values in this file to equal 1.  The file
% resides in /data/onthefly/ directory.  You can
% also use pull down menu under defaults

if exist('notifyda')==2 % is it m-file in matlab search path
	notifyda
else
	userdisphist=1;
	userdispmult=1;
	userdispaddon=1;
end
% ***********************************************************
% ********** Load windef.dat (Defaults File) ******************
% ***********************************************************
load windef.dat

% Note: First row contains input window defaults
% Note: Second row contains data window defaults
% Note: Third row contains main window defaults
% Note: Fourth row contains label window defaults
% Note: Fifth row contains load window defaults

winsize_input_left=windef(1,1);
winsize_input_bottom=windef(1,2);
winsize_input_width=windef(1,3);
winsize_input_height=windef(1,4);

winsize_data_left=windef(2,1);
winsize_data_bottom=windef(2,2);
winsize_data_width=windef(2,3);
winsize_data_height=windef(2,4);

winsize_figure_left=windef(3,1);
winsize_figure_bottom=windef(3,2);
winsize_figure_width=windef(3,3);
winsize_figure_height=windef(3,4);

winsize_label_left=windef(4,1);
winsize_label_bottom=windef(4,2);
winsize_label_width=windef(4,3);
winsize_label_height=windef(4,4);

winsize_load_left=windef(5,1);
winsize_load_bottom=windef(5,2);
winsize_load_width=windef(5,3);
winsize_load_height=windef(5,4);

% *******************************************************************
% ******************** Declare Intro Window *************************
% *******************************************************************
%%pict_height=375;
%%pict_width=500;
pict_height=315;
pict_width=415;
dumfig=['startupwindow=figure(''Resize'',''on'',''Pointer'',''arrow'',''MenuBar'',''none'',''NumberTitle'',''off'',''Name'',''ProPlot 1.0  / Introduction'');'];
%dumfig=['startupwindow=figure(''Resize'',''on'',''Pointer'',''arrow'',''MenuBar'',''none'',''Position'',[',num2str(winsize_figure_left),' ',num2str(winsize_figure_bottom),' ',num2str(pict_width),' ',num2str(pict_height),'],''NumberTitle'',''off'',''Name'',''ProPlot 1.0'');'];
eval(dumfig);
load intropic;
image(X);colormap(map);set(gca,'Visible','off');
clear X;
clear map;

pause;

delete(startupwindow);

% *******************************************************************
% ******************** Declare Input Window *************************
% *******************************************************************

dumfiginput=['figinput=figure(''Resize'',''on'',''Pointer'',''arrow'',''MenuBar'',''none'',''Position'',[',num2str(winsize_input_left),' ',num2str(winsize_input_bottom),' ',num2str(winsize_input_width),' ',num2str(winsize_input_height),'],''NumberTitle'',''off'',''Name'',''Input'');'];
eval(dumfiginput);


% *********************************************
% ******** New Figure Button ********************
% *********************************************

newfigure=uicontrol(figinput,...
	'Style','push',...
	'Position',[10 80 80 20],...
	'String','Start',...
	'CallBack',['datajump']);

% *** Load is not fully supported in Release 1.0 ***
% *** You are welcome to experiment with however ***

if loaddataoption==1
	fprintf('Warning: Loading previous files is not fully supported yet! \n');

	loaddata=uicontrol(figinput,...
		'Style','push',...
		'Position',[10 55 80 20],...
		'String','Load',...
		'Visible','on',...
		'Callback',['testrea1']);
end

% *** create a save data button ***
% *** note this is right on top of load button ***
% *** initially visibility is off ***

savedatabutton=uicontrol(figinput,...
	'Style','push',...
	'Position',[10 55 80 20],...
	'Visible','off',...
	'String','Save',...
	'CallBack',['if numoffigs > 0;',...
		'savedata;end']);

% *** Create a text box for load and save ***

saveloadfile=uicontrol(figinput,...
	'Style','edit',...
	'Position',[100 55 80 20],...
	'ForegroundColor','w',...
	'BackgroundColor','b',...
	'Visible','off');

if loaddataoption==1
	set(saveloadfile,'Visible','on');
end

startedyet=0; % *** holds whether we are still on startup figures ***

exitproplot=uicontrol(figinput,...
	'Style','push',...
	'Position',[100 80 80 20],...
	'String','Exit',...
	'CallBack',['if startedyet==1;profly;',...% *** write window positions to file windef.dat ***
		'[fid]=fopen(''windef.dat'',''wt'');',...
		'fprintf(fid,''%i\t%i\t%i\t%i\n'',get(figinput,''Position''));',...
		'fprintf(fid,''%i\t%i\t%i\t%i\n'',get(figanddatawin(2,1),''Position''));',...
		'fprintf(fid,''%i\t%i\t%i\t%i\n'',get(figanddatawin(1,1),''Position''));',...
		'fprintf(fid,''%i\t%i\t%i\t%i\n'',get(figanddatawin(3,1),''Position''));',...
		'fprintf(fid,''%i\t%i\t%i\t%i\n'',get(specialfig,''Position''));',...
		'fclose(fid);',...
		'prodir;end;close all']);

% *********************************************
% ******** Disable History ********************
% *********************************************
enhist=1;
enablehistory=uicontrol(figinput,...
	'Style','checkbox',...
	'String',' XY Plot History',...
	'Value',1,...
	'Position',[200 80 120 20],...
	'ForegroundColor','y',...
	'BackgroundColor','k',...
	'CallBack',['enhist=get(enablehistory,''Value'');',...
		'if enhist==0,',...
			'set(enablehistory,''Value'',1);',...
			'histwarn;',...
		'end,']);


% *********************************************
% ******** Disable Multiple Plotting **********
% *********************************************
enmul=1;
enablemulti=uicontrol(figinput,...
	'Style','checkbox',...
	'String','Multi-Plotting',...
	'Value',1,...
	'Position',[200 60 120 20],...
	'ForegroundColor','y',...
	'BackgroundColor','k',...
	'CallBack',['enmul=get(enablemulti,''Value'');',...
		'if enmul==0,',...
			'set(enablemulti,''Value'',1);',...
			'multwarn;',...
		'end,']);


% *********************************************
% ******** Disable Menu Addon *****************
% *********************************************
enaddon=1;
enableaddon=uicontrol(figinput,...
	'Style','checkbox',...
	'String','Add-on Menus',...
	'Value',1,...
	'Position',[200 40 120 20],...
	'ForegroundColor','y',...
	'BackgroundColor','k',...
	'CallBack',['enaddon=get(enableaddon,''Value'');',...
		'if enaddon==0,',...
			'set(enableaddon,''Value'',1);',...
			'addwarn;',...
		'end,']);


aboutpro % *** run to setup About form (invisible)

gobacktoread=0; % datajump default is call by Pro not load

% ******************************************************
% *********** Call Specbeg to setup special figure *****
% ******************************************************

specbeg

