function ex_chlin(MAXLINES,line_success_mat)

% Version 1.0 of ProPlot 1.0
%
%    // ex_chlin.m \\
%
%     Scott Keane
%  skeane@uceng.uc.edu
%
%  Created on: 7:32 PM 6/19/96
%  Last Modified on: 7:32 PM 6/19/96
%
% *****************************************
% Matlab function run upon completion of reading in data to
% check data and return warning messages
% *****************************************

% *************** Check line information ************************
for w=1:MAXLINES
	if line_success_mat(w,1)~=0 | line_success_mat(w,5)~=0 % run unless both are zero
		if line_success_mat(w,1)~=line_success_mat(w,5)
			if line_success_mat(w,1)==0 
				fprintf('***ProPlot Load Warning: A matching xline%d definition was not found for yline%d. \n',w,w);
				fprintf('xline%d and yline%d data will be ignored. \n\n',w,w);
			elseif line_success_mat(w,5)==0
				fprintf('***ProPlot Load Warning: A matching yline%d definition was not found for xline%d. \n',w,w);
				fprintf('xline%d and yline%d data will be ignored. \n\n',w,w);
			end
		end
	end
	if line_success_mat(w,1)~=0 & line_success_mat(w,5)~=0 % run if both are not zero
		if line_success_mat(w,1) > 1
			fprintf('***ProPlot Load Warning: The definition for xline%d was defined %d times. \n',w,line_success_mat(w,1));
			fprintf('Only the last definition will be used. \n\n');
		end
		if line_success_mat(w,5) > 1
			fprintf('***ProPlot Load Warning: The definition for yline%d was defined %d times. \n',w,line_success_mat(w,5));
			fprintf('Only the last definition will be used. \n\n');
		end
		if line_success_mat(w,2)==0 & line_success_mat(w,6)==0 % both are zero
			fprintf('***ProPlot Load Warning: The definition for xline%d and yline%d. \n',w,w);
			fprintf('must be either a horizontal (y values the same) or a \n');
			fprintf('vertical (x values the same) line.  Use xleader/yleader instead. \n');
			fprintf('xline%d and yline%d data will be ignored. \n\n',w,w);
		end
	end
end
% ***************** End line check information **********************

return