function [success,read_line_num,datamat]=ex_lin(datareadin,typeofcall,i,lastmatch,count)

% Version 1.0 of ProPlot 1.0
%
%    // ex_lin.m \\
%
%     Scott Keane
%  skeane@uceng.uc.edu
%
%  Created on: 7:32 PM 6/19/96
%  Last Modified on: 7:32 PM 6/19/96
%
% *****************************************
% Matlab function run to translate the data
% file into something ProPlot can understand.
% *****************************************

success=1;
read_line_num=[];
datamat=[];stop=1;
% ******************String xline or yline ********************
if typeofcall==1
	teststring=abs('xline');
	jumper=4;
elseif typeofcall==2
	teststring=abs('yline');
	jumper=4;
elseif typeofcall==3
	stop=0;
	teststring=abs('xleader');
	jumper=6;
else
	teststring=abs('yleader');
	jumper=6;
end

badsyntax=0;
eval(datareadin(lastmatch:i),'badsyntax=1'); % if I can not evaluate line, then syntax is bad.

if badsyntax==1 % bad syntax
	fprintf('***ProPlot Load Warning on line %d: The following \n',count);
	fprintf('could not be read properly.  %s \n\n.',setstr(datareadin(lastmatch:i)));
	success=0;
% note if next character after initial string is not a number, give warning and return
elseif datareadin(lastmatch+jumper+1) >= 57 | datareadin(lastmatch+jumper+1) <= 48 % between ASCII codes 0-9
	fprintf('***ProPlot Load Warning on line %d: %s definitions \n',count,setstr(teststring));
	fprintf('should have a number appended to them. (i.e. %s1=[0 2];) \n',setstr(teststring));
	fprintf('%s data will be ignored. \n\n',setstr(teststring));
	success=0;
	datamat=[0];
else 
	%fprintf('%s is a xline declaration. \n',datareadin(lastmatch:i));
	flag=1;
	found=0;
	for j=1:3 %check the number(s) following line,999 max
		if flag==1 % do loop as long as number found
			if datareadin(lastmatch+jumper+j) <= 57 & datareadin(lastmatch+jumper+j) >= 48 % between ASCII codes 0-9
				found=1;
			elseif found==1 % must find a number first(was elseif found=1?)
				%fprintf('%c is the line#. \n',setstr(datareadin(lastmatch+jumper+1:lastmatch+jumper+j-1)));
				read_line_num=eval(datareadin(lastmatch+jumper+1:lastmatch+jumper+j-1));
				flag=0; % exit loop
				stoppedat=j; % hold variable for next operation([])
			end
		end
	end
	% Everything went ok, set up datamat to be sent back
	uservar=[setstr(teststring),setstr(datareadin(lastmatch+jumper+1:lastmatch+jumper+stoppedat-1))];
	%disp(uservar);
	datamat=eval(uservar);
	
	% loop to check for only 2 elements in xline,yline definitions

	if jumper==4 % only do this if xline, yline
		if length(eval(uservar))~=2
			fprintf('***ProPlot Load Warning on line %d: xline,yline \n',count);
			fprintf('definitions must contain only 2 elements. %s%d contains %d elements. \n',setstr(teststring),read_line_num,length(eval(uservar)));
			fprintf('xline%d and yline%d data will be ignored. \n\n',read_line_num,read_line_num);
			datamat=[0 0];
			success=0;
		end
	end
end
return