function [plot_mat,continue_flag]=itemfun(itemlen,item,teststring,u,count,datareadin,lastmatch,i)	

% Version 1.0 of ProPlot 1.0
%
%    // itemfun.m \\
%
%     Scott Keane
%  skeane@uceng.uc.edu
%
%  Created on: 12:38 PM 6/22/96
%  Last Modified on: 10:45 AM 6/23/96
%
% Called by: plotload.m
%
% *****************************************
% Matlab function to translate extracted plot info.
% *****************************************

continue_flag=1;
testlen=length(teststring);
if itemlen >= testlen % only let names longer than teststring through(was >)
	if abs(item(1:testlen))==teststring % found a recognizeable definition
		
		% be sure that something follows matching string
		if itemlen >= testlen+1;
			num=itemlen-testlen; % characters following matching string
		else
			num=[]; % nothing follows
			fprintf('***ProPlot Load Warning on line %d: The following \n',count);
			fprintf('definition was incorrect and will not be plotted \n');
			fprintf('\t%s \n\n.',setstr(datareadin(lastmatch:i)));
			continue_flag=0;
		end
		if isempty(num) 
			plot_mat(1,1)=0; % nothing follows teststring, probably result of leaving off number in definition
			plot_mat(1,2)=0;
		else
			if item(testlen+1:testlen+num) <=57 & item(testlen+1:testlen+num) >= 48 % remainder between ASCII codes 0-9 
				plot_mat(1,2)=str2num(setstr(item(testlen+1:testlen+num))); % pull the number for table lookup
				plot_mat(1,1)=1;
				fprintf('Found %s definition in plot (yes)! \n',setstr(teststring));		
			else
				plot_mat(1,1)=0; % whatever follows in not a number
				plot_mat(1,2)=0;
				fprintf('***ProPlot Load Warning on line %d: The following \n',count);
				fprintf('definition was incorrect and will not be plotted \n');
				fprintf('\t%s \n\n.',setstr(datareadin(lastmatch:i)));
				continue_flag=0;
			end
		end
	else
		plot_mat(1,1)=0; % string does not match 
		plot_mat(1,2)=0;
	end	
else
	plot_mat(1,1)=0; % string is not long enough to test
	plot_mat(1,2)=0;
end
return