% Version 1.0 of ProPlot 1.0
%
%    // loadaxex.m \\
%
%     Scott Keane
%  skeane@uceng.uc.edu
%
% Created on:       10:29 AM 6/29/96
% Last Modified on: 12:05 PM 6/29/96
%
% *****************************************
% File run upon entering ProPlot to establish axis
% properties(colors,fonttypes,fontsizes,...)
% *****************************************

if enaddon==1

for p=1:numoffigs
	figure(figanddatawin(1,p)); % set appropriate figure	

	% ********** FigureBackgroundColor ***********************
	read_figbackcolor=get(figanddatawin(1,p),'Color');  % retrieve information from user figures
	if read_figbackcolor==[0 0 0]
		set(figbackcolor(8,p),'Checked','on');
	else
		[numoption]=readcol(read_figbackcolor);
		set(figbackcolor(numoption,p),'Checked','on');
	end

	% ********** AxisColor ************************************
	read_axcolor=get(gca,'XColor');
	if read_axcolor==[1 1 1]
		set(axisplotcolor(1,p),'Checked','on');
	else
		[numoption]=readcol(read_axcolor);
		set(axisplotcolor(numoption,p),'Checked','on');
	end

	% ********** Grid *****************************************
	read_gridxinfo=get(gca,'XGrid');
	read_gridyinfo=get(gca,'YGrid');
	if length(read_gridxinfo)==2 & length(read_gridyinfo)==2 % both grid x and y on
		set(gridboth(p),'Checked','on');
	elseif length(read_gridxinfo)==2 % xgrid on
		set(gridx(p),'Checked','on');
	elseif length(read_gridyinfo)==2 % ygrid on
		set(gridy(p),'Checked','on');
	end
	% ********** AxisBackgroundColor ***********************
	read_axisbackgroundc=get(gca,'Color');
	if length(read_axisbackgroundc)~=4 %does not equal none
		if read_axisbackgroundc==[0 0 0]
			set(axisbackgroundcolor(8,p),'Checked','on');
		else % only do if axis background color different than default black
			[numoption]=readcol(read_axisbackgroundc);
			set(axisbackgroundcolor(numoption,p),'Checked','on');
		end
	else
		set(axisbackgroundcolor(8,p),'Checked','on');
	end

	% ************ AxisFontName *********************
	read_axisfonttypes=abs(get(gca,'FontName'));
	len_fname_axis=length(read_axisfonttypes);
	if len_fname_axis==length(abs('Helvetica')) % one criteria for comparing is string length
		if read_axisfonttypes==abs('Helvetica')
			set(axisfont(11,p),'Checked','on');
		else % only do this if different that default, Helvetica
			[numoption]=readfnam(len_fname_axis,read_axisfonttypes);
			set(axisfont(numoption,p),'Checked','on');
		end
	else % string lengths not equal, then different
		[numoption]=readfnam(len_fname_axis,read_axisfonttypes);
		set(axisfont(numoption,p),'Checked','on');
	end

	% ************ AxisFontSize *********************
	read_axisfontsizes=get(gca,'FontSize');
	if read_axisfontsizes==12 	
		set(axisfontsize(5,p),'Checked','on');
	else % only do this if different than default,12
		set(axisfontsize(read_axisfontsizes-7,p),'Checked','on');
	end

	% ************ Box ******************************
	read_boxinfo=get(gca,'Box');
	if length(read_boxinfo)==2 % only do this if box is on,default is off
		set(axisbox(p),'Checked','on');
	else
		set(axisbox(p),'Checked','off');
	end

	% ************ Tick In/Out **********************
	read_tickinfo=get(gca,'TickDir');
	if length(read_tickinfo)==3 % only do this if tickdir is out, default is in
		set(tickout(p),'Checked','on');
	else
		set(tickin(p),'Checked','on');
	end

	% *********************************************************
	% ************* Begin XY Information **********************
	% *********************************************************

	read_xstring=abs(get(get(gca,'XLabel'),'String'));
	set(figxedit(p,1),'String',setstr(read_xstring));
	%read_xstatus=isempty(read_xstring);

	read_ystring=abs(get(get(gca,'YLabel'),'String'));
	set(figyedit(p,1),'String',setstr(read_ystring));
	%read_ystatus=isempty(read_ystring);
	%if read_xstatus==0 | read_ystatus==0 % only do following if string is not null

		% ************ XYLabel *****************************
		%if read_xstatus==0
		%	set(figxedit(p,1),'String',setstr(read_xstring));
		%end
		%if read_ystatus==0
		%	set(figyedit(p,1),'String',setstr(read_ystring));
		%end
		% ************ XYLabelFontSize *********************
		read_xylabelfontsize=get(get(gca,'XLabel'),'FontSize');
		if read_xylabelfontsize==12 
			set(labelxyfontsize(5,p),'Checked','on');
		else % only do this if different than default,12
			set(labelxyfontsize(read_xylabelfontsize-7,p),'Checked','on');
		end
		% ************ XYLabelFontName *********************
		read_xylabelfonttype=abs(get(get(gca,'XLabel'),'FontName'));
		len_xylabel_fname=length(read_xylabelfonttype);
		if len_xylabel_fname==length(abs('Helvetica')) % one criteria for comparing is string length
			if read_xylabelfonttype==abs('Helvetica')
				set(labelxyfont(11,p),'Checked','on');
			else % only do this if different that default, Helvetica
				[numoption]=readfnam(len_xylabel_fname,read_xylabelfonttype);
				set(labelxyfont(numoption,p),'Checked','on');
			end
		else % string lengths not equal, then different
			[numoption]=readfnam(len_xylabel_fname,read_xylabelfonttype);
			set(labelxyfont(numoption,p),'Checked','on');
		end

		% ************ XYLabelColor ************************
		read_xylabelcolors=get(get(gca,'XLabel'),'Color');	
		if read_xylabelcolors==[1 1 1]
			set(labelxyaxis(1,p),'Checked','on');
		else % only do this if different that default, white
			[numoption]=readcol(read_xylabelcolors);
			set(labelxyaxis(numoption,p),'Checked','on');
		end
	%end
	% *************************************************************
	% ***************** Title Information *************************
	% *************************************************************

	read_titlestring=abs(get(get(gca,'Title'),'String'));
	set(figedit(p,1),'String',setstr(read_titlestring));
	%read_titlestatus=isempty(read_titlestring);
	%if read_titlestatus==0 % only do following if string is not null

		% ************ TitleLabel *****************************
		%	set(figedit(p,1),'String',setstr(read_titlestring));
		
		% ************ TitleLabelFontSize *********************
		read_titlelabelfontsize=get(get(gca,'Title'),'FontSize');
		if read_titlelabelfontsize==12 
			set(labeltitfontsize(5,p),'Checked','on');
		else % only do this if different than default,12
			set(labeltitfontsize(read_titlelabelfontsize-7,p),'Checked','on');
		end

		% ************ TitleLabelFontName *********************
		read_titlelabelfonttype=abs(get(get(gca,'Title'),'FontName'));
		len_title_fname=length(read_titlelabelfonttype);
		if len_title_fname==length(abs('Helvetica')) % one criteria for comparing is string length
			if read_titlelabelfonttype==abs('Helvetica')
				set(labeltitfont(11,p),'Checked','on');
			else % only do this if different that default, Helvetica
				[numoption]=readfnam(len_title_fname,read_titlelabelfonttype);
				set(labeltitfont(numoption,p),'Checked','on');
			end
		else % string lengths not equal, then different
			[numoption]=readfnam(len_title_fname,read_titlelabelfonttype);
			set(labeltitfont(numoption,p),'Checked','on');
		end

		% ************ TitleLabelColor ************************
		read_titlelabelcolors=get(get(gca,'Title'),'Color');	
		if read_titlelabelcolors==[1 1 1]
			set(labeltitaxis(1,p),'Checked','on');
		else % only do this if different that default, white
			[numoption]=readcol(read_titlelabelcolors);
			set(labeltitaxis(numoption,p),'Checked','on');
		end
	%end
end
end
