function [opt_color,opt_ltype]=optfun(options)

% Version 1.0 of ProPlot 1.0
%
%    // optfun.m \\
%
%     Scott Keane
%  skeane@uceng.uc.edu
%
%  Created on: 5:40 PM 6/22/96
%  Last Modified on: 5:40 PM 6/22/96
%
% Called by: plotload.m
%
% *****************************************
% Matlab function to take plotting options
% and return a two element matrix for linetype
% and a three element matrix for line color
% note this function assumes that a single
% digit character is used for color and
% a one or two character series is used
% for linetype
% *****************************************

fprintf('Running optfun! \n');

% remove ' ' from data.  ' is ASCII 39

flag=1;
flag2=1;
lenopt=length(options);
for h=1:lenopt	
	char=abs(options(h));
	if char==39
		% do nothing
	else
		if flag2==1
			% *************** colors **************
			if char==119 % white
				opt_color=[1 1 1];
				flag2=0;
			elseif char==98 % blue
				opt_color=[0 0 1];
				flag2=0;
			elseif char==109 % magenta
				opt_color=[1 0 1];
				flag2=0;
			elseif char==114 % red
				opt_color=[1 0 0];
				flag2=0;
			elseif char==99 % cyan
				opt_color=[0 1 1];
				flag2=0;
			elseif char==103 % green
				opt_color=[0 1 0];
				flag2=0;
			elseif char==107 % black
				opt_color=[0 0 0];
				flag2=0;
			else % default to yellow
				opt_color=[1 1 0];
				flag2=0;
			end
		end
		% ************* line types ***********
		if flag==1 % not found yet
			if char==46 % .
				opt_ltype=[abs('.') 0];
				flag=0;
			elseif char==111 % o
				opt_ltype=[abs('o') 0];
				flag=0;
			elseif char==120 % x
				opt_ltype=[abs('x') 0];
				flag=0;
			elseif char==43 % +
				opt_ltype=[abs('+') 0];
				flag=0;
			elseif char==42 % *
				opt_ltype=[abs('*') 0];
				flag=0;
			elseif char==58 % :
				opt_ltype=[abs(':') 0];
				flag=0;
			elseif char==45 % -
				if options(h+1)==46 % .
					opt_ltype=[abs('-.')];
					flag=0;
				elseif options(h+1)==45 % -
					opt_ltype=[abs('--')];
					flag=0;
				else % just -
					opt_ltype=[abs('-') 0];
					flag=0;
				end
			else % default -
				opt_ltype=[abs('-') 0];
				flag=1; % making this one allows us to reenter loop
			end
		end
	end
end

return














