% Version 1.0 of ProPlot 1.0
%
%    // test_rea1.m \\
%
%     Scott Keane
%  skeane@uceng.uc.edu
%
%  Created on: 7:32 PM 6/19/96
%  Last Modified on: 8:28 AM 6/20/96
%
% *****************************************
% Matlab function to read in ProPlot files.  Note
% that any ProPlot file will run in Matlab, but the
% opposite is not true.
% *****************************************
% need to consider removing spaces after newline or semicolons
% in case user puts space at beginning of new line
tic

loadok=1; % *** init ok ***

file2load=abs(get(saveloadfile,'String'));

if length(file2load)==0 % ***nothing specified ***
	set(saveloadfile,'String','ERROR!');
	loadok=0;

elseif length(file2load) > 12
	set(saveloadfile,'String','ERROR!');
	loadok=0;

elseif length(file2load)==6
	if abs('ERROR!')==file2load
		loadok=0;
	end
end


if loadok==1


[fidload]=fopen(setstr(file2load),'rt');

% ************** Define maximum size of lines and leaders
MAXLINES=30;
MAXLEADERS=30;
dfig=[];
donetop=0;
newfig=1; % counter for unique fig definitions
timesplotted=1; % used as index into matrix of test plots
plot_tempmat=[];
timestextplotted=1;
figurestorage=[]; %holds unique fig definitions

[datareadin,numofcharacters] = fscanf(fidload,'%c');
line_success_mat=zeros(MAXLINES,8); % 30 lines max, line defs must only be 2 points
leader_success_mat=zeros(MAXLEADERS,34); % 30 leaders max,15 points max

last_fig_found=[];
% read until end of line(10) or semicolon(59)
lastmatch=1;
count=1; % count holds the line numbers
for i=1:length(datareadin)
    	startagain=0;
	
	if datareadin(i)==10 | datareadin(i)==59		
	 
		%if datareadin(i)==10
		%	fprintf('Line: %d ## %s',count,datareadin(lastmatch:i));
		%else
		%	fprintf('Line: %d ## %s\n',count,datareadin(lastmatch:i));
		%end
		% ***************** String figure(fig ******************
		testfigure=abs('figure(fig');
		
		if i-lastmatch > 10 % to compare string must be at least 10 characters long
			if abs(datareadin(lastmatch:lastmatch+9))==testfigure % if this is true then found a figure switch
				startagain=1;
				
				last_fig_found=str2num(datareadin(lastmatch+10));
				if isempty(last_fig_found)==0 % not empty
					if isempty(figurestorage)
						figurestorage(newfig)=last_fig_found;
						gobacktoread=1; % tells datajump to return to this program
						datajump % call to startup
						figanddatawin(1,last_fig_found);
						% Create a dummy figure to plot on and hide it from user.
						%lendfig=length(dfig);
						%fprintf('lendfig=%i \n',lendfig);
						%tfig=['dfig(',num2str(last_fig_found),')=figure(''Visible'',''off'');'];
						%eval(tfig);
						%fprintf('Created new figure invisibly! \n');
						
					else
						for p=1:newfig
							if last_fig_found==figurestorage(p)
								uniquefig(p)=0;
							else
								uniquefig(p)=1;
							end	
						end
						if uniquefig==ones(1:newfig) % unique figure declaration
							newfig=newfig+1;
							figurestorage(newfig)=last_fig_found;
							gobacktoread=1; % tells datajump to return to this program
							datajump % call to startup
							figanddatawin(1,last_fig_found);
							%tfig=['dfig(',num2str(last_fig_found),')=figure(''Visible'',''off'');'];
							%eval(tfig);
							%fprintf('Created new figure invisibly! \n');
						else %  figure found in figurestorage, make it current
							figanddatawin(1,last_fig_found);
							%figure(dfig(last_fig_found)); % set the fig to be current
							%set(dfig(last_fig_found),'Visible','off');
							%fprintf('Using same figure for plotting \n');
						end
					end
				end

			end
		end
	    if donetop==0 & startagain==0
		% ********************************************
		% ************* Text *************************
		% ********************************************
		if i-lastmatch > 5 % to compare string must be at least 5 characters long
			teststring=abs('[text');
			if abs(datareadin(lastmatch:lastmatch+4))==teststring
				fprintf('Found a string [text \n');
				if isempty(last_fig_found) % if empty print error
					fprintf('***ProPlot Load Warning on line %d: Could not plot text. \n',count);
					fprintf('ProPlot needs a figure declaration to plot text. \n');
					fprintf('A figure must first be defined. (i.e. fig1=figure) \n');							
					fprintf('A default figure may then be set for plotting text. (i.e. figure(fig1) ) \n\n');
				else % ok
					badsyntax=0;
					[text_success,text_tempmat,timestextplotted]=textload(text_tempmat,timestextplotted,last_fig_found,lastmatch,i,count,datareadin);
					eval(datareadin(lastmatch:i),'badsyntax=1;'); % if ProPlot can not evaluate line, then syntax is bad.
					
					if text_success==1
						if badsyntax==1 % bad syntax .this next should never be run if logic is correct
							fprintf('***ProPlot Load Warning on line %d: Text read error? \n',count);
							fprintf('The following could not be read properly and will be ignored. \n');
							fprintf('\t%s \n\n.',setstr(datareadin(lastmatch:i)));
						end	
							
							
					end



				end	
			end
		end
		% ******************* set commands ************************
		badsyntax=0;
		if i-lastmatch > 4 % to compare string must be at least 4 characters long
			teststring=abs('set(');
			if abs(datareadin(lastmatch:lastmatch+3))==teststring
				fprintf('Found a set definition \n');
				eval(datareadin(lastmatch:i),'badsyntax=1;');
				if badsyntax==1
					fprintf('***ProPlot Load Warning on line %d: Line will be ignored. \n',count);
					fprintf('The following line has an incorrect syntax. \n');							
					fprintf('\t%s \n\n',setstr(datareadin(lastmatch:i)));
				end
			end
		end

		% *****************************Test xline,yline ************
		% note: criteria, if one specifed, other must be specified
		% and must contain same number of points.
		if i-lastmatch > 5 % to compare string must be at least 5 characters long
			teststring=abs('xline');
			if abs(datareadin(lastmatch:lastmatch+4))==teststring
				[xlinesuccess,read_xline_num,xlinemat]=ex_lin(datareadin,1,i,lastmatch,count); % search for xline
				if xlinesuccess==1 % only do the following if successful
					line_success_mat(read_xline_num,1)=line_success_mat(read_xline_num,1)+1; % store a matrix of success information for user
					if xlinemat(1)==xlinemat(2) %add check for hor or ver line
						line_success_mat(read_xline_num,2)=1; % same
					else
						line_success_mat(read_xline_num,2)=0; % different
					end
					line_success_mat(read_xline_num,3:4)=xlinemat;
					eval(datareadin(lastmatch:i));
					
				end
			end	

			teststring=abs('yline');
			if abs(datareadin(lastmatch:lastmatch+4))==teststring
				[ylinesuccess,read_yline_num,ylinemat]=ex_lin(datareadin,2,i,lastmatch,count); % search for yline
				if ylinesuccess==1 % only do the following if successful
					line_success_mat(read_yline_num,5)=line_success_mat(read_yline_num,5)+1; % store a matrix of success information for user
					if ylinemat(1)==ylinemat(2) %add check for hor or ver line
						line_success_mat(read_yline_num,6)=1; % same
					else
						line_success_mat(read_yline_num,6)=0; % different
					end
					line_success_mat(read_yline_num,7:8)=ylinemat;
					eval(datareadin(lastmatch:i));
				end
			end
		end
		% *****************************Test xleader, yleader ************
		% note: criteria, if one specifed, other must be specified
		% and must contain same number of points.
		if i-lastmatch > 7 % to compare string must be at least 7 characters long
			teststring=abs('xleader');
			if abs(datareadin(lastmatch:lastmatch+6))==teststring
				[xleadersuccess,read_xleader_num,xleadermat]=ex_lin(datareadin,3,i,lastmatch,count); % search for xleader
				if xleadersuccess==1 % only do the following if successful
					leader_success_mat(read_xleader_num,1)=leader_success_mat(read_xleader_num,1)+1; % store a matrix of success information for user
					lengthdata=length(xleadermat);
					if lengthdata > 15 % Must remove anything greater than 15
						leader_success_mat(read_xleader_num,2)=15; % specifies how many points to follow
						leader_success_mat(read_xleader_num,3:17)=xleadermat(1:15); % lengthdata is 15 in this case
						% form new matrix from user matrix with 15 points max
						tempmat=['xleader',num2str(read_xleader_num),'=leader_success_mat(',num2str(read_xleader_num),',3:17);'];
						eval(tempmat);clear tempmat;

					else % length is less than max 15 points
						leader_success_mat(read_xleader_num,2)=lengthdata; % specifies how many points to follow
						leader_success_mat(read_xleader_num,3:17)=[xleadermat,zeros(1,15-lengthdata)];
						eval(datareadin(lastmatch:i));
					end
				end
			end
			teststring=abs('yleader');
			if abs(datareadin(lastmatch:lastmatch+6))==teststring
				[yleadersuccess,read_yleader_num,yleadermat]=ex_lin(datareadin,4,i,lastmatch,count); % search for yleader
				if yleadersuccess==1 % only do the following if successful
					leader_success_mat(read_yleader_num,18)=leader_success_mat(read_yleader_num,18)+1; % store a matrix of success information for user
					lengthdata=length(yleadermat);
					if lengthdata > 15 % Must remove anything greater than 15
						leader_success_mat(read_yleader_num,19)=15; % specifies how many points to follow
						leader_success_mat(read_yleader_num,20:34)=yleadermat(1:15); % lengthdata is 15 in this case
						% form new matrix from user matrix with 15 points max
						tempmat=['yleader',num2str(read_yleader_num),'=leader_success_mat(',num2str(read_yleader_num),',20:34);'];
						eval(tempmat);clear tempmat;

					else % length is less than 15 points
						leader_success_mat(read_yleader_num,19)=lengthdata; % specifies how many points to follow
						leader_success_mat(read_yleader_num,20:34)=[yleadermat,zeros(1,15-lengthdata)];
						eval(datareadin(lastmatch:i));
					end
				end
			end
		end
		if i-lastmatch > 5 % to compare string must be at least 5 characters long
			teststring=abs('plot(');
			if abs(datareadin(lastmatch:lastmatch+4))==teststring
				if isempty(last_fig_found) % if empty print error
					fprintf('***ProPlot Load Warning on line %d: Could not plot. \n',count);
					fprintf('ProPlot needs a figure declaration to plot. \n');
					fprintf('A figure must first be defined. (i.e. fig1=figure) \n');							
					fprintf('A default figure may then be set for plotting. (i.e. figure(fig1) ) \n\n');
				else % ok
					badsyntax=0;
					hold on;
					%keyboard
					appended_string=['[plot_tempmat(timesplotted)]=',setstr(datareadin(lastmatch:i))];
					eval(appended_string,'badsyntax=1;'); % if ProPlot can not evaluate line, then syntax is bad.
					
					if badsyntax==1 % bad syntax
						fprintf('***ProPlot Load Warning on line %d: The following \n',count);
						fprintf('could not be read properly and will be ignored. \n');
						fprintf('\t%s \n\n.',setstr(datareadin(lastmatch:i)));
						success=0;
					else
						timesplotted=timesplotted+1;
						fprintf('Calling plotload! \n');
						% call plot function	
						[sep,dfig]=plotload(dfig,line_success_mat,leader_success_mat,last_fig_found,lastmatch,i,count,datareadin,MAXLINES,MAXLEADERS);
					end
				end
			end
		end
		% ***********************************************************
		% look for line containing %%extras, once found, do not do above anymore
		if i-lastmatch > 7 % to compare string must be at least 5 characters long
			teststring=abs('% Extras');
			if abs(datareadin(lastmatch:lastmatch+7))==teststring
				donetop=1;startagain=1;
			end
		end
	   elseif startagain==0 % done with top, in extra section now
		%fprintf('Done with top! \n');
		
		badsyntax=0;
		if isempty(last_fig_found)==1,else % keep looking if empty
			if exist('figanddatawin')==0 % means datajump was not run,error
				fprintf('***ProPlot Error on line %d: Figure not defined properly. \n',count);
				fprintf('A figure to plot on was not set correctly. \n');			
				fprintf('Check to be sure a definition of the following type is \n');
				fprintf('defined. figure(fig1);');error('!!Cannot recover,dumping Proplot!!');		
				
			else
				figure(figanddatawin(1,last_fig_found));
				eval(datareadin(lastmatch:i),'badsyntax=1;');
				if badsyntax==1
					fprintf('***ProPlot Load Warning on line %d: Line will be ignored. \n',count);
					fprintf('The following line has an incorrect syntax. \n');							
					fprintf('\t%s \n\n',setstr(datareadin(lastmatch:i)));
				end
			end
	  	 end
	   end
	   lastmatch=i+1;
	   count=count+1;
	end
end

% ######### Call functions to check data and give warnings #######

ex_chlin(MAXLINES,line_success_mat);
ex_chlea(MAXLEADERS,leader_success_mat);

% warn user if no figure definition was found
if length(figurestorage)==0
	fprintf('***ProPlot Warning: Figure not defined properly. \n');
	fprintf('There exists no valid figure definitions in file. \n');			
	fprintf('Check to be sure a definition of the following type is \n');
	fprintf('defined. figure(fig1); \n\n');
end


fprintf('File successfully read into ProPlot.  ');
fprintf('(%d lines,%d characters) \n\n',count,numofcharacters);

% ************ delete evaluated plots ******************

if isempty(plot_tempmat)==0
	delete(plot_tempmat);
	clear plot_tempmat;
end

% ********* call script to update text *************
textmod
% ************ delete evaluated text *******************
if isempty(text_tempmat)==0
	for j=1:length(text_tempmat)
		confused=0;
		text_dummy=['text',num2str(text_tempmat(j,1))];
		del_dummy=['delete(',setstr(text_dummy),');'];
		eval(del_dummy,'confused=1');
		if confused==1
			fprintf('***ProPlot Oops: Delete failed. \n');
			fprintf('Could not clean up a text item properly. \n');							
		end
	end
end


% call script to check proper menu items
loadaxex
gobacktoread=0; % tell datajump that read is complete
toc
fclose(fidload);

end