% Version 1.0 of ProPlot 1.0
%
%    // savedata.m \\
%
%     Scott Keane
%  skeane@uceng.uc.edu
%
% Created          11:21PM  2/26/96
% Last Modified    11:48 PM 9/12/96
%
% *****************************************
% Matlab Script to save data to .m file
% *****************************************

saveok=1; % *** init ok ***

file2save=abs(get(saveloadfile,'String'));

if length(file2save)==0 % ***nothing specified ***
	set(saveloadfile,'String','ERROR!');
	saveok=0;

elseif length(file2save) > 12
	set(saveloadfile,'String','ERROR!');
	saveok=0;

elseif length(file2save)==6
	if abs('ERROR!')==file2save
		saveok=0;
	end
end


if saveok==1

	[fid]=fopen(setstr(file2save),'wt');

	% *** load appropriate data 9-13-96 ***
	for i=1:10
		if loaddatastore(i,1) ~= 0
			firststring=['load ',deblank(setstr(loaddatastore(i,:)))];
			secondstring=['Could not open data file ',deblank(setstr(loaddatastore(i,:))),' for reading! \n'];
			fprintf(fid,'eval(''%s'',''%s'');',firststring,secondstring);

			fprintf('Added Loaded Data File %s to save file %s \n',deblank(setstr(loaddatastore(i,:))),file2save);
		end
	end

	fprintf(fid,'%% ************ Set up Figures ***************\n');
	for num=1:numoffigs
		fprintf(fid,'fig%i=figure; \n',num);
	end


	% ****************************************
	% ************ Lines information *********
	% ****************************************
	% assume stamat is +11
	% assume x data is stamat+1 to stamat+2
	% assume y data is stamat+3 to stamat +4
	% assume color is stamat+5 to stamat+7
	% assume linetype is stamat+8 to stamat+9


	count=1;
	heightlines=size(linesmart);heightlines=heightlines(1,1);
	widthlines=size(linesmart);widthlines=widthlines(1,2);
	for p=1:ceil(widthlines/11);	
		stamat=(p-1).*11+1;	
		fprintf(fid,'\n\n%% ************ Lines(Figure %d) ***************\n',p);
		fprintf(fid,'figure(fig%i); \n',p);  % set appropriate figure
		for m=1:heightlines
			if linesmart(m,stamat)~=0 % linedata exists
			
				fprintf(fid,'xline%i=[%i %i];yline%i=[%i %i]; \n',count,linesmart(m,stamat+1:stamat+2),count,linesmart(m,stamat+3:stamat+4));
		
				% *******determine color of line **************
				if linesmart(m,stamat+5:stamat+7)==[1 1 0]; choice='y';  % yellow
				elseif linesmart(m,stamat+5:stamat+7)==[1 0 1]; choice='m';  % magenta
				elseif linesmart(m,stamat+5:stamat+7)==[0 1 1]; choice='c';  % cyan
				elseif linesmart(m,stamat+5:stamat+7)==[1 0 0]; choice='r';  % red
				elseif linesmart(m,stamat+5:stamat+7)==[0 1 0]; choice='g';  % green
				elseif linesmart(m,stamat+5:stamat+7)==[0 0 1]; choice='b';  % blue
				elseif linesmart(m,stamat+5:stamat+7)==[1 1 1]; choice='w';  % white
				elseif linesmart(m,stamat+5:stamat+7)==[0 0 0]; choice='k';  % black
				end
				if linesmart(m,stamat+9)==0
					fprintf(fid,'hold on;plot(xline%i,yline%i,''%c%c'') \n',count,count,choice,setstr(linesmart(m,stamat+8)));
				else
					fprintf(fid,'hold on;plot(xline%i,yline%i,''%c%c%c'') \n',count,count,choice,setstr(linesmart(m,stamat+8:stamat+9)));
				end
				count=count+1;
			end
		end
	end

	% ****************************************
	% ************ Leaders information *********
	% ****************************************
	% assume stamat is +11
	% assume x data is stamat+1 to stamat+2
	% assume y data is stamat+3 to stamat +4
	% assume color is stamat+5 to stamat+7
	% assume linetype is stamat+8 to stamat+9
	count=1;
	heightleaders=size(leadersmart);heightleaders=heightleaders(1,1);
	widthleaders=size(leadersmart);widthleaders=widthleaders(1,2);
	for p=1:ceil(widthleaders/11);
		stamat=(p-1).*11+1;
		fprintf(fid,'\n\n%% ************ Leaders(Figure %d) ***************\n',p);
		fprintf(fid,'figure(fig%i); \n',p);  % set appropriate figure
		for m=1:heightleaders
			if leadersmart(m,stamat)~=0 % leaders data exists
				xdata=get(leadersmart(m,stamat),'XData');
				ydata=get(leadersmart(m,stamat),'YData');
				fprintf(fid,'xleader%i=[',count);
				for g=1:length(xdata)
					fprintf(fid,'%i ',xdata(g));
				end
				fprintf(fid,']; \n');
				fprintf(fid,'yleader%i=[',count);

				for g=1:length(xdata)
					fprintf(fid,'%i ',ydata(g));
				end
				fprintf(fid,']; \n');
				
				% *******determine color of line **************
				if leadersmart(m,stamat+5:stamat+7)==[1 1 0]; choice='y';  % yellow
				elseif leadersmart(m,stamat+5:stamat+7)==[1 0 1]; choice='m';  % magenta
				elseif leadersmart(m,stamat+5:stamat+7)==[0 1 1]; choice='c';  % cyan
				elseif leadersmart(m,stamat+5:stamat+7)==[1 0 0]; choice='r';  % red
				elseif leadersmart(m,stamat+5:stamat+7)==[0 1 0]; choice='g';  % green
				elseif leadersmart(m,stamat+5:stamat+7)==[0 0 1]; choice='b';  % blue
				elseif leadersmart(m,stamat+5:stamat+7)==[1 1 1]; choice='w';  % white
				elseif leadersmart(m,stamat+5:stamat+7)==[0 0 0]; choice='k';  % black
				end
				if leadersmart(m,stamat+9)==0
					fprintf(fid,'hold on;plot(xleader%i,yleader%i,''%c%c''); \n',count,count,choice,setstr(leadersmart(m,stamat+8)));
				else
					fprintf(fid,'hold on;plot(xleader%i,yleader%i,''%c%c%c''); \n',count,count,choice,setstr(leadersmart(m,stamat+8:stamat+9)));
				end

				count=count+1;
			end
		end
	end


	% ****************************************
	% ************ Text information *********
	% ****************************************
	% assume stamat is +24
	% assume x data is stamat+1 
	% assume y data is stamat+2 
	% assume color is stamat+3 to stamat+5
	% assume fontsize is stamat+6
	% assume fonttype is stamat+7 to stamat +2?
	count=1;
	heighttexts=size(textsmart);heighttexts=heighttexts(1,1);
	widthtexts=size(textsmart);widthtexts=widthtexts(1,2);
	for p=1:ceil(widthtexts/24);
		stamat=(p-1).*24+1;
		fprintf(fid,'\n\n%% ************ Text(Figure %d) ***************\n',p);
		fprintf(fid,'figure(fig%i); \n',p);  % set appropriate figure
		for m=1:heighttexts
			if textsmart(m,stamat)~=0 % text data exists
				
				usertext=get(textsmart(m,stamat),'String');	
				usertext=deblank(usertext);
				% ******determine color of line **************
				if textsmart(m,stamat+3:stamat+5)==[1 1 0]; choice='y';  % yellow
				elseif textsmart(m,stamat+3:stamat+5)==[1 0 1]; choice='m';  % magenta
				elseif textsmart(m,stamat+3:stamat+5)==[0 1 1]; choice='c';  % cyan
				elseif textsmart(m,stamat+3:stamat+5)==[1 0 0]; choice='r';  % red
				elseif textsmart(m,stamat+3:stamat+5)==[0 1 0]; choice='g';  % green
				elseif textsmart(m,stamat+3:stamat+5)==[0 0 1]; choice='b';  % blue
				elseif textsmart(m,stamat+3:stamat+5)==[1 1 1]; choice='w';  % white
				elseif textsmart(m,stamat+3:stamat+5)==[0 0 0]; choice='k';  % black
				end
		
				fprintf(fid,'[text%i]=text(%i,%i,''',count,textsmart(m,stamat+1:stamat+2));
				for k=1:length(usertext)
					fprintf(fid,'%c',setstr(usertext(k)));
				end
				fprintf(fid,'''); \n');
				% ********* Compare to default color *************
				if choice~='w'
					fprintf(fid,'set(text%i,''Color'',''%c''); \n',count,choice);
				end
			
				% ********* Compare to default fontsize *************
				if textsmart(m,stamat+6)~=12
					fprintf(fid,'set(text%i,''FontSize'',%i); \n',count,textsmart(m,stamat+6));
				end

				% ********* Compare to default fontname *************
				if textsmart(m,stamat+7:stamat+21)==[abs('Helvetica') 0 0 0 0 0 0],else			
					fonttext=setstr(textsmart(m,stamat+7:stamat+21));
					fonttext=deblank(fonttext);
					fprintf(fid,'set(text%i,''FontName'',''',count);
					for r=1:length(fonttext)
						fprintf(fid,'%c',setstr(fonttext(r)));
					end
					fprintf(fid,'''); \n');
				end

				count=count+1;
			end
		end
	end


	% ****************************************
	% ************ Plot information *********
	% ****************************************
	% color is in columns 5,6,7
	% linetype is in columns 8,9
	% linewidth is in column 10
	% marker size is is column 11
	% x & y are 12-100


	if isempty(plotvar)==0
		for p=1:numoffigs 
			fprintf(fid,'\n\n%% ************ Plot(Figure %d) ***************\n',p);
			fprintf(fid,'figure(fig%i); \n',p); % set appropriate figure
			plotvarinfo=existfun(plotvar);
			if plotvarinfo(1,1)==0 | plotvarinfo(1,1)==-1
				getuserinfo=zeros(1,3); 
			else
				getuserinfo=get(plotvar(p,1),'UserData');
			end
			if getuserinfo(1,1)~=0 % plotvar exists for this figure
				count=1;
				heightplot=size(getuserinfo);heightplot=heightplot(1,1);
				widthplot=size(getuserinfo);widthplot=widthplot(1,2);
				plotfiginfo=existfun(getuserinfo);	
					for m=1:heightplot
						if plotfiginfo(m,1)==0 | plotfiginfo(m,1)==-1,else,

							% *******determine color of line **************
							if getuserinfo(m,5:7)==[1 1 0]; choice='y';  % yellow
							elseif getuserinfo(m,5:7)==[1 0 1]; choice='m';  % magenta
							elseif getuserinfo(m,5:7)==[0 1 1]; choice='c';  % cyan
							elseif getuserinfo(m,5:7)==[1 0 0]; choice='r';  % red
							elseif getuserinfo(m,5:7)==[0 1 0]; choice='g';  % green
							elseif getuserinfo(m,5:7)==[0 0 1]; choice='b';  % blue
							elseif getuserinfo(m,5:7)==[1 1 1]; choice='w';  % white
							elseif getuserinfo(m,5:7)==[0 0 0]; choice='k';  % black
							end
							% ***** pull x,y data ****************************
					
							xpull=getuserinfo(m,12:100);
							% Separate xdata from ydata
							flag=1;
							for z=1:length(xpull)
								if flag==1
									if xpull(z)==38
										numstop=z-1;
									end
								end
							end
							ypull=getuserinfo(m,numstop+13:100);
							ypull=deblank(setstr(ypull));
							xpull=xpull(setstr(1:numstop));
						
							fprintf(fid,'xdata%i=',count);
							for u=1:length(xpull)
								fprintf(fid,'%c',xpull(u));
							end
							fprintf(fid,'; %% %i,%i,%i,1\n',p,getuserinfo(m,1:2));

							fprintf(fid,'ydata%i=',count);
							for u=1:length(ypull)
							
								fprintf(fid,'%c',ypull(u));
								if ypull(u)==120 % if character is x, precede it with appropriate number
									fprintf(fid,'data%d',count);
								end
							end
							fprintf(fid,'; %% %i,%i,%i,2\n',p,getuserinfo(m,1:2));
					
							if getuserinfo(m,9)==0 % is plot type character one or two elements
								fprintf(fid,'hold on;[plot%i]=plot(xdata%i,ydata%i,''%c%c''); \n',count,count,count,choice,getuserinfo(m,8));
							else
								fprintf(fid,'hold on;[plot%i]=plot(xdata%i,ydata%i,''%c%c%c''); \n',count,count,count,choice,getuserinfo(m,8),getuserinfo(m,9));
							end


							if getuserinfo(m,10)~=1
								fprintf(fid,'set(plot%i,''Linewidth'',%d); \n',count,getuserinfo(m,10));
							end
							if getuserinfo(m,11)~=6
								fprintf(fid,'set(plot%i,''MarkerSize'',%d); \n',count,getuserinfo(m,11));
							end
			
							count=count+1;
						end
					
				end
			end
		end
	end

	% **************************************************************
	% ************ Setup proper axis information *******************
	% **************************************************************
	fprintf(fid,'%% Extras ***************\n');

	for p=1:numoffigs
		figure(figanddatawin(1,p)); % set appropriate figure	

		fprintf(fid,'\n\n%% ******** Extra Info(Figure %d) ***************\n',p);
		fprintf(fid,'figure(fig%i); \n',p); % set appropriate figure
	
		% ********** FigureBackgroundColor ***********************
		savefigbackcolor=get(figanddatawin(1,p),'Color');  % retrieve information from user figures
		if savefigbackcolor==[0 0 0],else
			fprintf(fid,'set(gcf,''Color'',[%d %d %d]); \n',savefigbackcolor(1:3));
		end

		% ********** AxisColor ************************************
		axcolor=get(gca,'XColor');
		if axcolor==[1 1 1],else
			fprintf(fid,'set(gca,''XColor'',[%d %d %d]); \n',axcolor(1:3));
			fprintf(fid,'set(gca,''YColor'',[%d %d %d]); \n',axcolor(1:3));
		end

		% ********** Grid *****************************************
		gridxinfo=get(gca,'XGrid');
		gridyinfo=get(gca,'YGrid');
		if length(gridxinfo)==2 & length(gridyinfo)==2 % both grid x and y on
			fprintf(fid,'grid; \n');
		elseif length(gridxinfo)==2 % xgrid on
			fprintf(fid,'set(gca,''XGrid'',''on''); \n',p);
		elseif length(gridyinfo)==2 % ygrid on
			fprintf(fid,'set(gca,''YGrid'',''on''); \n',p);
		end
		% ********** Grid line type ***********************************
		if length(gridxinfo)==2 | length(gridyinfo)==2
			savegridtype=abs(get(gca,'GridLineStyle'));
			if length(savegridtype)==1
				savegridtype=[savegridtype 0];
			end
			if savegridtype==[abs(':') 0] 
				% do nothing,default
			elseif savegridtype==[abs('-') 0]
				fprintf(fid,'set(gca,''GridLineStyle'',''-'');');
			elseif savegridtype==abs('--')
				fprintf(fid,'set(gca,''GridLineStyle'',''--'');');
			elseif savegridtype==abs('-.')
				fprintf(fid,'set(gca,''GridLineStyle'',''-.'');');
			end
		end
	

		% ********** AxisBackgroundColor ***********************
		axisbackgroundc=get(gca,'Color');
		if length(axisbackgroundc)==4,else % if 4, then value is none and do nothing
			if axisbackgroundc==[0 0 0],else % only do if axis background color different than default black
				fprintf(fid,'set(gca,''Color'',[%d %d %d]); \n',axisbackgroundc(1:3));
			end
		end	

		% ************ AxisFontName *********************
		axisfonttypes=abs(get(gca,'FontName'));
		if length(axisfonttypes)==length(abs('Helvetica')) % one criteria for comparing is string length
			if axisfonttypes==abs('Helvetica'),else % only do this if different that default, Helvetica
				fprintf(fid,'set(gca,''FontName'',''%s''); \n',setstr(axisfonttypes));
			end
		else % string lengths not equal, then different
			fprintf(fid,'set(gca,''FontName'',''%s''); \n',setstr(axisfonttypes));
		end

		% ************ AxisFontSize *********************
		axisfontsizes=get(gca,'FontSize');
		if axisfontsizes~=12 % only do this if different than default,12
			fprintf(fid,'set(gca,''FontSize'',%d); \n',axisfontsizes);
		end

		% ************ Box ******************************
		boxinfo=get(gca,'Box');
		if length(boxinfo)==2 % only do this if box is on,default is off
			fprintf(fid,'set(gca,''Box'',''on''); \n');
		end

		% ************ Tick In/Out **********************
		tickinfo=get(gca,'TickDir');
		if length(tickinfo)==3 % only do this if tickdir is out, default is in
			fprintf(fid,'set(gca,''TickDir'',''out''); \n');
		end

		% *********************************************************
		% ************* Begin XY Information **********************
		% *********************************************************

		xstring=abs(get(get(gca,'XLabel'),'String'));
		xstatus=isempty(xstring);
		ystring=abs(get(get(gca,'YLabel'),'String'));
		ystatus=isempty(ystring);
		if xstatus==0 | ystatus==0 % only do following if string is not null

			% ************ XYLabel *****************************
			if xstatus==0
				fprintf(fid,'xlabel(''%s''); \n',setstr(xstring));
			end
			if ystatus==0
				fprintf(fid,'ylabel(''%s''); \n',setstr(ystring));
			end
			% ************ XYLabelFontSize *********************
			xylabelfontsize=get(get(gca,'XLabel'),'FontSize');
			if xylabelfontsize~=12 % only do this if different than default,12
				fprintf(fid,'set(get(gca,''XLabel''),''FontSize'',%d); \n',xylabelfontsize);
				fprintf(fid,'set(get(gca,''YLabel''),''FontSize'',%d); \n',xylabelfontsize);
			end

			% ************ XYLabelFontName *********************
			xylabelfonttype=abs(get(get(gca,'XLabel'),'FontName'));
			if length(xylabelfonttype)==length(abs('Helvetica')) % one criteria for comparing is string length
				if xylabelfonttype==abs('Helvetica'),else % only do this if different that default, Helvetica
					fprintf(fid,'set(get(gca,''XLabel''),''FontName'',''%s''); \n',setstr(xylabelfonttype));
					fprintf(fid,'set(get(gca,''YLabel''),''FontName'',''%s''); \n',setstr(xylabelfonttype));
				end
			else % string lengths not equal, then different
				fprintf(fid,'set(get(gca,''XLabel''),''FontName'',''%s''); \n',setstr(xylabelfonttype));
				fprintf(fid,'set(get(gca,''YLabel''),''FontName'',''%s''); \n',setstr(xylabelfonttype));
			end

			% ************ XYLabelColor ************************
			xylabelcolors=get(get(gca,'XLabel'),'Color');	
			if xylabelcolors==[1 1 1],else % only do this if different that default, white
				fprintf(fid,'set(get(gca,''XLabel''),''Color'',[%d %d %d]); \n',xylabelcolors(1:3));
				fprintf(fid,'set(get(gca,''YLabel''),''Color'',[%d %d %d]); \n',xylabelcolors(1:3));
			end
		end
		% *************************************************************
		% ***************** Title Information *************************
		% *************************************************************

		titlestring=abs(get(get(gca,'Title'),'String'));
		titlestatus=isempty(titlestring);
		if titlestatus==0 % only do following if string is not null

			% ************ TitleLabel *****************************
		
			fprintf(fid,'title(''%s''); \n',setstr(titlestring));
		
		
			% ************ TitleLabelFontSize *********************
			titlelabelfontsize=get(get(gca,'Title'),'FontSize');
			if titlelabelfontsize~=12 % only do this if different than default,12
				fprintf(fid,'set(get(gca,''Title''),''FontSize'',%d); \n',titlelabelfontsize);
			end	

			% ************ TitleLabelFontName *********************
			titlelabelfonttype=abs(get(get(gca,'Title'),'FontName'));
			if length(titlelabelfonttype)==length(abs('Helvetica')) % one criteria for comparing is string length
				if titlelabelfonttype==abs('Helvetica'),else % only do this if different that default, Helvetica
					fprintf(fid,'set(get(gca,''Title''),''FontName'',''%s''); \n',setstr(titlelabelfonttype));
				end
			else % string lengths not equal, then different
				fprintf(fid,'set(get(gca,''Title''),''FontName'',''%s''); \n',setstr(titlelabelfonttype));
			end

			% ************ TitleLabelColor ************************
			titlelabelcolors=get(get(gca,'Title'),'Color');	
			if titlelabelcolors==[1 1 1],else % only do this if different that default, white
				fprintf(fid,'set(get(gca,''Title''),''Color'',[%d %d %d]); \n',titlelabelcolors(1:3));
			end
		end
	end
	fclose(fid);
	fprintf('%s : Saved successfully in %s \n',file2save,pwd);
end
