% Abstract (Sep. 26, 1991)
%
% Program ROTAPOLH illustrates the animated rotation of 3D
% objects about an arbitrary axis. Shapes considered include
% a cube, a pyramid, and a tetrahedron.
 
%       Written by Howard Wilson and Sanjay Gupta
%       Department of Engineering Mechanics
%       University of Alabama
%       Box 870278
%       Tuscaloosa, Alabama 35487-0278
%       Phone 205 348-1617
%       Email address: HWILSON @ UA1VM.UA.EDU
%
% PROGRAM ROTAPOLH
clear; clg; hold off; option=0;
fprintf('\n ^* ANIMATED ROTATION OF A 3D OBJECT ^*\n')
while option~=4, clear
  fprintf('\n Select an option: 1 => cube,       2 => pyramid ')
  fprintf('\n                   3 => terahedron, 4 => stop ')
  option=input('? '); if option==1, r=box(.25); end
  if option==2, r=pyramid(.5); end, if option==3, r=tetra(.5); end
  if option==4, return; end
  nrot=input('Give the number of revolutions turned: ');
  fprintf('\nInput a vector to define the rotation axis')
  vec=readv(3); amat=rotmat(vec,10); nstep=360*nrot/10;
  axis('square'); border(-1,1,-1,1); hold on
  for i=1:nstep
    plot(r(2,:),r(3,:)); plot(r(2,:),r(3,:),'i'); r=amat*r;
  end
  plot(r(2,:),r(3,:)); hold off
end
