function [fh] = scalefigure(fh);
% function [fh] = scalefigure(fh);
% sets axis scales the same for all plots in a single figure.
% gets X,Y,and Z axis limits for every subplot and chooses
% choses the minimum or maximum for each axis component.
% Then replots figure.
% Input: fh  (optional) figure handle.If no input uses current figure
% Output: figure handle

%Copyright Roger Meredith July 1996
%NRL Code 7174, SSC MS 39529

if nargin==0
	fh=gcf ;% current figure
end

ch=get(fh,'Children') ;% get subplots and children

for i=1:1:length(ch);
	sub_pl_axis(i,:)=[get(ch(i),'XLim') get(ch(i),'YLim') get(ch(i),'ZLim')];
end

maxval=max(sub_pl_axis) ;% new axis max values for all subplots
minval=min(sub_pl_axis) ;% new axis min values

for i=1:1:length(ch)
	set(ch(i),'XLim',[minval(1) maxval(2)]);
	set(ch(i),'YLim',[minval(3) maxval(4)]);
	drawnow;
end



