function [x,y] = d_gin
%D_GIN -- a simpler version of ginput with no parameters 
%       USE: [x,y] = d_gin
%       the position of the button press in normalized coordinates
%       WRT the figure.
%
%       AUTHOR: Dan(k) Braithwaite, Dept. of Hydrology U.of.A
%                      5/93
 
pointer = get(gcf,'pointer');
set(gcf,'pointer','crosshair')
unis = get(gcf,'units');
set(gcf,'units','pixels');
frect = get(gcf,'posi');
keydown = waitforbuttonpress;
 
pt = get(gcf,'currentpoint');
x = pt(1)/frect(3);
y = pt(2)/frect(4);
set(gcf,'pointer',pointer)
set(gcf,'units',unis)
