function handleit = gptex(str,clr)
%GPTEX -- primitive used in *tex commands
%     USE:  gptex(str,clr)
%       to create a section of superscript text (str) optional
%       clr parameter for specifying the color of this piece of
%       text. Default color is white.
%     NEW:
%       This is to have greek characters in superscript
%
%
%       AUTHOR: Dan(k) Braithwaite, Dept. of Hydrology U.of.A
%                      5/93
%
%       Modified By Louis Verhagen, Dept of Civil Engineering Canberra
%       Australia    24/3/94
%


if nargin == 1
        clr = 'w';
end
 
if ~isempty(get(gcf,'children'))
        oldax = gca;
        meaxhand = findthx;
else
        oldax = axes;
        meaxhand = findthx;
end
 
axes(meaxhand);
fs = get(gcf,'defaulttextfontsize');
handleit = text('posi',[0 0],'vis','off','units','norm','string',str,'color',clr,'userdata','gup','fontsize',floor(fs*.7),'fontname','symbol');
 
axes(oldax);
