function handleit = gsptex(ss,ps,sc,pc)
%GSPTEX --  primitive used in *tex commands.
%    USE:   gsptex(ss,ps,sc,pc)
%       to create a section of text with both a subscript (ss) and
%       superscript (ps) optional sc & pc parameters for 
%       specifying the color of the subscript & superscript 
%       portions of text respectively.  Default color is white.
%	NEW:
%	  This is to have greek characters in subscript & superscript
%
%       AUTHOR: Dan(k) Braithwaite, Dept. of Hydrology U.of.A
%                      5/93
%
%	  Modified By Louis Verhagen, Dept of Civil Engineering Canberra
%	  Australia    24/3/94
%	  
 
if nargin < 3
        pc = 'w';
end
if nargin < 4
        sc = 'w';
end
 
if ~isempty(get(gcf,'children'))
        oldax = gca;
        meaxhand = findthx;
else
        oldax = axes;
        meaxhand = findthx;
end
 
axes(meaxhand);
smat = str2mat(ss,ps);
fs = get(gcf,'defaulttextfontsize');
shand = text('posi',[0 0],'vis','off','units','norm','string',smat(1,:),'color',sc,'userdata','glw','fontsize',round(fs*.7),'fontname','symbol');
phand = text('posi',[0 0],'vis','off','units','norm','string',smat(2,:),'color',pc,'userdata','gpp','fontsize',round(fs*.7),'fontname','symbol');
handleit = [shand phand];
 
axes(oldax);
