function handleit = gtex(str,clr)
%GTEX -- primitive used in *tex commands
%     USE:      gtex(str,clr)
%       to create of section of greek text (str) optional clr
%       parameter for specifying the color of this piece of
%       text. Default color is white.
%
%          use the following regular characters in the string
%          argument of gtex to produce the corresponding greek
%          letters:
%
%               a -- alpha
%               b -- beta
%               c -- chi
%               d -- delta
%               e -- epsilon
%               f -- phi
%               g -- gamma
%               h -- eta
%               i -- iota
%               j -- ???
%               k -- kappa
%               l -- lambda
%               m -- mu
%               n -- nu
%               o -- omicron
%               p -- pi
%               q -- theta
%               r -- ro
%               s -- sigma
%               t -- tau
%               u -- upsilon
%               v -- ???
%               w -- omega
%               x -- xi
%               y -- psi
%               z -- zeta
%
%               capitals will produce corresponding capitals
%
%       AUTHOR: Dan(K) Braithwaite, Dept. of Hydrology U.of.A
%                       5/93
 
if nargin == 1
        clr = 'w';
end
 
if ~isempty(get(gcf,'children'))
        oldax = gca;
        meaxhand = findthx;
else
        oldax = axes;
        meaxhand = findthx;
end
 
axes(meaxhand);
handleit = text('posi',[0 0],'vis','off','units','norm','string',str,'color',clr,'userdata','grk','fontname','symbol');
 
axes(oldax);
