function mout = mget(m,prop)
%MGET -- returns a matrix with each line containing the "get" of
%         the corresponding handle in the vector of handles-- m
%
%   SYNTAX:
%       [mout] = mget(m,prop)
%
%       where m is the vector of handles prop is the property
%       to be gotten and mout is the vector/matrix of values
%       of the property for each handle.
%   NOTE:  if mget is to be used to return string values for
%       each handle then the strings returned must be the same
%       length.  
%
%       AUTHOR: Dan(k) Braithwaite, Dept. of Hydrology U.of.A
%                      5/93
 
n = length(m);
mout = [];
 
for i=1:n
        mout = [mout;get(m(i),prop)];
end
