function handleit = ntex(str,clr)
%NTEX -- primitive used in *tex commands
%     USE:   ntex(str,clr)
%       to create a section of normal text (str) as opposed to
%       greek,subscript, or superscript text. The optional clr
%       parameter is for specifying the color of this piece of
%       text. Default color is white.
%
%       AUTHOR: Dan(k) Braithwaite, Dept. of Hydrology U.of.A
%                      5/93
 
if nargin == 1
        clr = 'w';
end
 
if ~isempty(get(gcf,'children'))
        oldax = gca;
        meaxhand = findthx;
else
        oldax = axes;
        meaxhand = findthx;
end
 
axes(meaxhand);
handleit = text('posi',[0 0],'vis','off','units','norm','string',str,'color',clr,'userdata','nor');
 
axes(oldax);
