function handleit = ptex(str,clr)
%PTEX -- primitive used in *tex commands
%     USE:  ptex(str,clr)
%       to create a section of superscript text (str) optional
%       clr parameter for specifying the color of this piece of
%       text. Default color is white.
%
%       AUTHOR: Dan(k) Braithwaite, Dept. of Hydrology U.of.A
%                      5/93
 
if nargin == 1
        clr = 'w';
end
 
if ~isempty(get(gcf,'children'))
        oldax = gca;
        meaxhand = findthx;
else
        oldax = axes;
        meaxhand = findthx;
end
 
axes(meaxhand);
fs = get(gcf,'defaulttextfontsize');
handleit = text('posi',[0 0],'vis','off','units','norm','string',str,'color',clr,'userdata','sup','fontsize',floor(fs*.7));
 
axes(oldax);
