function handleit = sptex(ss,ps,sc,pc)
%SPTEX --  primitive used in *tex commands.
%    USE:   sptex(ss,ps,sc,pc)
%       to create a section of text with both a subscript (ss) and
%       superscript (ps) optional sc & pc parameters for 
%       specifying the color of the subscript & superscript 
%       portions of text respectively.  Default color is white.
%
%       AUTHOR: Dan(k) Braithwaite, Dept. of Hydrology U.of.A
%                      5/93
 
if nargin < 3
        pc = 'w';
end
if nargin < 4
        sc = 'w';
end
 
if ~isempty(get(gcf,'children'))
        oldax = gca;
        meaxhand = findthx;
else
        oldax = axes;
        meaxhand = findthx;
end
 
axes(meaxhand);
smat = str2mat(ss,ps);
fs = get(gcf,'defaulttextfontsize');
shand = text('posi',[0 0],'vis','off','units','norm','string',smat(1,:),'color',sc,'userdata','low','fontsize',round(fs*.7));
phand = text('posi',[0 0],'vis','off','units','norm','string',smat(2,:),'color',pc,'userdata','upp','fontsize',round(fs*.7));
handleit = [shand phand];
 
axes(oldax);
