function handleit = stex(str,clr)
%STEX -- primitive used in *tex commands
%     USE:      stex(str,clr)
%       to create a section of subscript text (str) optional clr 
%       parameter for specifying the color of this piece of text. 
%       Default color is white.
%
%       AUTHOR: Dan(k) Braithwaite, Dept. of Hydrology U.of.A
%                      5/93
 
if nargin == 1
        clr = 'w';
end
 
if ~isempty(get(gcf,'children'))
        oldax = gca;
        meaxhand = findthx;
else
        oldax = axes;
        meaxhand = findthx;
end
 
axes(meaxhand);
fs = get(gcf,'defaulttextfontsize');
handleit = text('posi',[0 0],'vis','off','units','norm','string',str,'color',clr,'userdata','sub','fontsize',floor(fs*.7));
 
axes(oldax);
