% Abstract

% This function is data acquisition via a IEEE-interface (mex-function
% written in C ) to plot every new datapoint and provoke rescaling
% of the entire plot only when outside the frame.

% By Hilmar Schlegel

% pplot.m

function frame = plotpoint(x,y,x3,x4,x5,x6,x7,x8,x9)
% plots point (x,y) in existing frame or rescales entire plot
% frame = pointplot(x,y,x3,x4,x5,x6,x7,x8,x9)

% PPLOT.M                 1/30/91                             Hilmar Schlegel
% Central Institute of Electron Physics, Hausvogteiplatz 5-7, 1086 Berlin
% e-Mail: SCHLEGEL@DB0ADW11.bitnet
% Latest change: 1/30/91

frame = axis;
axis;                % get frame, but stay in autoscale mode
if sum([frame(1),x,frame(3),y]>[x,frame(2),y,frame(4)])==0
        if isstr(x3)
                plot(x,y,x3)
        else
                plot(x,y)
        end
else
        n = nargin;        % if more args required see GPLOT
        arglist = ['x'*ones(1,n-2);  '0'+(3:n);  ','*ones(1,n-3) ' '];
        arglist = arglist(:)';
        hold off
        eval(['plot(x,y,',arglist,')']);
        hold on
        frame = 0;
end

