function item=plt_menu(items)
% function item=plt_menu(items)
% Graphics menu routine - mouse driven.
% Calls show_plt_menu, waits for clicking on one of menu
% items and returns its number.
% If the right button is clicked, returns 0 (none).
% If a point outside the menu area is clicked, does nothing.
% Used in tsplot routine.

% KNOWN BUGS:
% As it is impossible to clear "clicks" and keyboard buffer from
% within Matlab, some "old" clicks will sometimes be interpreted
% by the program which will result in erratic but not disastrous
% effects. To avoid this, click buttons briefly and keep the
% mouse stationary when clicking.
%%
% Please, report bugs, modifications etc. to:
%       W. Tych,
%       Dept. of Environmental Sciences
%       University of Lancaster
%       e-mail:            tych@uk.ac.lancs.cent1
%             from BITNET: tych@cent1.lancs.ac.uk
%
% Wlodek Tych, 24.3.89.

p=show_plt_menu(items);
[n,m]=size(p);
item=-1;
while item<0
        clear x y but
        pause(1)
        [x,y,but]=ginput(1,'sc');
        if but==3, item=0; break, end
        for i=1:m
                tt=(x>p(1,i))*(x<p(3,i))*(y<p(2,i))*(y>p(4,i));
                if tt==1, item=i; break, end
        end
end
%
