%lsode - Livermore Solver for Ordinary Differential Equations.
%[y istate rworko iworko] = lsode(f,jac,time,y0,rtol,atol,itsom[,rworki[,iworki]])\n");
%
% Input Arguments:
%    dy/dt = f(t,y,rwork,iwork) =
%            MATLAB callable function to be solved: dy/dt = f(t,y).  f returns a
%            column vector valued function describing the system of first order
%            ODEs, t (scalar) is an arbitrary time point between time(0) and
%            time(length(time)).
%    pd = jac(t,y,ml,mu,rwork,iwork) =
%            MATLAB callable Jacobian function or '' when Jacobian is to
%            be computed numerically (mf=10,22,25).  pd(i,j) = df(i)/dy(j).
%    time   = Row vector containing initial time (time(1)) and other time
%             points at which to evaluate y.
%    y0     = Column vector containing initial value of y.
%    rtol   = Relative tolerance (scalar or column vector).
%    atol   = Absolute tolerance (scalar or column vector).
%    itsom  = [itask istate iopt mf].
%    rworki = Input optional real work array.  May be used for passing
%             optional arguments.  Automatically sized if not specified.
%    iworki = Input optional integer work array.  May be used for passing
%             optional arguments.  Automatically sized if not specified.
% Output Arguments:
%    y(:,i) = Solution to ODE system at time t(i).
%    istate(i) = Return status from LOSDE corresponding to t(i+1).
%    rworko = Output real work array.
%    iworko = Output integer work array.
%
%For additional documentation, see comments in the FORTRAN LSODE program.
%(uhd:lsode.for).
%For an example of MATLAB usage see: lsode_examp.m, flsode.m, jlsode.m
%(in uhmat:).
%
%MATLAB interface Copyright 1992 by Ray Muzic
%     V. 1.0: 7-Apr-1992, Ray Muzic
%
%Reference: Alan C. Hindmarsh,  Odepack, A Systematized Collection of ODE
%     Solvers, in Scientific Computing, R. S. Stepleman et al. (eds.),
%     North-Holland, Amsterdam, 1983, pp. 55-64.
%            Alan C. Hindmarsh,
%            Computing and Mathematics Research Div., l-316
%            Lawrence Livermore National Laboratory
%            Livermore, CA 94550

