% npts     equals one fourth of the number of points computed
%          on the stability boundary of an explicit Runge-Kutta
%          integrator
% xrang    controls the square window within which the diagram
%          is drawn. [ -3, 3, -3, 3] is appropriate for the
%          fourth order integrator.

%          by Howard Wilson, U. of Alabama, November,1989

fprintf('\nSTABILITY REGION FOR AN EXPLICIT RUNGE-KUTTA')
fprintf('\n     INTEGRATOR OF ARBITRARY ORDER\n')
disp('input the number of points used to define')
npts=input('the boundary (80 is typical) > ');
disp('input a vector to define the plot range')
disp('-3, 3,-3, 3 is typical')
xrang=readv(4);
nordr=input('give the integrator order > ');
d=pi/(npts-1); i=sqrt(-1); n=nordr+1; hold off; clg
v=1; for j=2:nordr, v=[v;gamma(j+1)]; end; v=1 ./flipud(v);
if nargin==2, xrang=[-3,3,-3,3]; end
axis(xrang), axis('square')
for tj=0:d:2*pi, v(n)=1-exp(i*tj); r=roots(v);
plot(real(r),imag(r),'.'); hold on, end
xlabel('real part of h*lambda')
ylabel('imaginary part of h*lambda'), ns=int2str(nordr);
st=['STABILITY ZONE FOR EXPLICIT INTEGRATOR OF ORDER ',ns];
title(st), grid
