function A = bdiag(A1,A2,A3,A4,A5,A6,A7,A8,A9,A10);

%BDIAG  The function bdiag(A1,A2,...,Ak), where k <= 10, generates the
%       block diagonal matrix whose diagonal blocks are the matrices 
%       A1, A2, ... , Ak in that order.  In the event that you need k > 10 ,
%       simply nest one or more calls for bdiag.

%       May, 1994
%       Jeffrey L. Stuart
%       Department of Mathematics
%       University of Southern Mississippi
%       Hattiesburg, MS  39406
%       jeffrey_stuart@bull.cc.usm.edu

k = nargin;

if k > 10,
   k = 10;
end

%       Assign the empty string to each unused input.
if k < 10
   p = 10 - k;
   for j = 1:p
       eval(['A' num2str(k+j) ' = [];'])
   end
end

%      Determine sizes of the nonempty, diagonal blocks.

m = zeros(k,1);
for j = 1:k
    m(j) = max(size(eval(['A' num2str(j)])));
end

%      Pre-allocate space for the output matrix.

s = sum(m);
A = zeros(s,s);
t = 0;

%      Map Aj to the jth diagonal block of A.
 
for j = 1:k,
	u = t+1;
	v = t+m(j);
	A(u:v,u:v) = eval(['A' num2str(j)]);
	t = t + m(j);
end

