% This example illustrates the effects which the number of
% digits of precision being used has on the accuracy which
% a system of simultaneous equations can be solved using
% Gauss-Jordan reduction.

%    hy Howard Wilson, Fall 1989

clc
fprintf(' Solution Accuracy of Simultaneous Equations\n')
fprintf(' Using Varying Numbers of Digits of Precision\n')
ityp=input('Select the matrix type: 1=Random  2=Hilbert >  ');
n=input('Input the matrix order >  ');
if ityp==1, a=-.5*rand(n,n); else a=hilb(n); end
w=ones(n,1); b=a*w; tol=0.;
ndig=(2:1:16); nd=length(ndig); erv=zeros(nd,1);
acracy=zeros(nd,1); dopiv=1;
for j=1:nd, fprintf(['  Digits = ',int2str(ndig(j))])
[y,resid]=gje(a,b,tol,dopiv,ndig(j));
acracy(j)=norm(w-y); end, fprintf('\n')
semilogy(ndig,acracy,'-',ndig,acracy,'o')
xlabel('number of digits of precision')
ylabel('norm of solution error')
title('ERROR IN SOLUTION OF A*X=B FOR VARYING PRECISION')
if ityp==1, its='Random'; else, its='Hilbert'; end
h1=50*min(acracy); h2=100*h1;
text(2.5,h2,['A is a ',its,' matrix of order ',int2str(n)]);
text(2.5,h1,'B is chosen such that X(j) = 1  for all j');
%pause
%meta gjerun.met
