function A = rbdiag(A1,A2);

%RBDIAG The function rbdiag(A1,A2) generates a block diagonal matrix
%       with diagonal blocks A1 and A2.  This m-file is designed for
%       recursively generating a block diagonal matrix.  Thus
%       rbdiag(A1,rbdiag(A2,rbdiag(A3,A4))) produces the block diagonal
%       matrix whose diagonal blocks are  A1, A2, A3, A4  in that order.
%       For convenience, rbdiag(A1) = A1.
%       See also BDIAG.
 
%       May 1994
%       Jeff Stuart, Department of Mathematics
%       University of Southern Mississippi
%       jeffrey_stuart@bull.cc.usm.edu

endflag = 0;
 
if nargin == 1
   A = A1;
   endflag = 1;
end

if endflag == 0;
   m1 = max(size(A1));
   m2 = max(size(A2));

   error = 0;
   if (m1 ~= min(size(A1))) | (m2 ~=min(size(A2)));
      disp('The matrices A1 and A2 must be square.')
      error = 1;
   end

   if error == 0;
      A = [A1, zeros(m1,m2);zeros(m2,m1),A2];
   end
end
