function x = basic(Q,R,Pi,b,rank)
% x = basic(Q,R,Pi,b,rank)
%
% Compute the basic solution.  If the RRQR of A is
%    A*Pi = Q*R = Q [ R_11 R_12 ] ,
%                   [  0   R_22 ]
% where A_11 is rank-by-rank, then the basic solution is
%    x = Pi*[ inv(R_11) 0 ]*Q'*b .
%          ([     0     0 ]

% Ref.: G. H. Golub & C. F. Van Loan, "Matrix Computations", 2. Ed.,
% Johns Hopkins, 1989.  Subsection 5.5.6.

% Per Christian Hansen, UNI-C, 07/11/90.

x = Pi(:,1:rank)*(R(1:rank,1:rank)\(Q(:,1:rank)'*b));
