function [c,s] = gen_g(r1,r2)
% [c,s] = gen_g(r1,r2)
%
% Given row vectors r1 and r2, compute c and s such that
%    [  c  s ]*[ r1(1) ] = [ * ] .
%    [ -s  c ] [ r2(1) ]   [ 0 ]

% Per Christian Hansen, UNI-C, 03/21/90.

if (r2(1)==0)
  c = 1; s = 0;
else
  if (abs(r2(1)) > abs(r1(1)))
    t = r1(1)/r2(1); s = 1/sqrt(1 + t^2); c = s*t;
  else
    t = r2(1)/r1(1); c = 1/sqrt(1 + t^2); s = c*t;
  end
end
