function A_k = mat_approx(Q,R,Pi,k)
% A_k = mat_approx(Q,R,Pi,k)
%
% Compute the rank-k approximation A_k to the matrix A,
% using the RRQR factorization of A.

% Ref.: G. H. Golub & C. F. Van Loan, "Matrix Computations", 2. Ed.,
% Johns Hopkins, 1989.  Subsection 2.5.3.

% Per Christian Hansen, UNI-C, 07/13/90.

A_k = Q(:,1:k)*R(1:k,:)*Pi';
