function x = tsvd(U,S,V,b,k)
% x = tsvd(U,S,V,b,k)
%
% Computes the truncated-SVD solution, with truncation parameter k,
% using the SVD of A.

% Ref.: G. H. Golub & C. F. Van Loan, "Matrix Computations", 2. Ed.,
% Johns Hopkins, 1989.  Subsection 5.5.8.

% Per Christian Hansen, UNI-C, 07/19/1990.

x = V(:,1:k)*((U(:,1:k)'*b)./diag(S(1:k,1:k)));
