/*-
 * Brian P. Fitzgerald
 * Mechanics of Materials Laboratory
 * Rensselaer Polytechnic Institute
 * Troy, NY
 * December 3, 1993
 *
 * Incomplete elliptic integrals
 *
 * Ellike.c	MEX file implementation of the C functions:
 *
 * double phi, modulus, y, ellie(), ellik();
 *
 * y = ellie( phi, modulus );
 *
 * y = ellik( phi, modulus );
 *
 * from Stephen L. Mosher's Cephes package
 *
 * Call from matlab as:
 *
 * [ kret,  eret ] = Ellike( phi, modulus )
 *
 *              2
 * modulus = sin (alpha)
 *
 */

#include "mex.h"

/* Input Arguments */

#define	PHI		prhs[0]
#define	MODULUS		prhs[1]

/* Output Arguments */

#define	KRET		plhs[0]
#define	ERET		plhs[1]

mexFunction(nlhs, plhs, nrhs, prhs)
    int             nlhs, nrhs;
    Matrix         *plhs[], *prhs[];
{
    double         *phi, *modulus;
    double          ellie(), ellik();
    double         *kret, *eret;
    register unsigned int l, m, n;

    if (nrhs != 2)
	mexErrMsgTxt("Wrong number of input arguments for Ellike");
    else if (nlhs != 1 && nlhs != 2)
	mexErrMsgTxt("Wrong number of output arguments for Ellike");

    if ((m = mxGetM(PHI)) != mxGetM(MODULUS)
	|| (n = mxGetN(PHI)) != mxGetN(MODULUS))
	mexErrMsgTxt("Ellike: phi and modulus matrices must have the same dimensions");

    phi = mxGetPr(PHI);
    modulus = mxGetPr(MODULUS);
    KRET = mxCreateFull(m, n, REAL);
    kret = mxGetPr(KRET);
    l = m * n;
    while (l--) {
	*kret++ = ellik(*phi++, *modulus++);
    }

    if (nlhs == 2) {
	phi = mxGetPr(PHI);
	modulus = mxGetPr(MODULUS);
	ERET = mxCreateFull(m, n, REAL);
	eret = mxGetPr(ERET);
	l = m * n;
	while (l--) {
	    *eret++ = ellie(*phi++, *modulus++);
	}
    }
}
