function korzac(x)
% korzac(x)
% given a time series x, it determines its range, divides it
% into ten parts (levels), and for each determines the time
% intervals between level crossings.  It plot the log number
% of level crossings against the log time interval.
% Written by Gerry Middleton, Jan. 1996. Press <space> to start.
help korzac;
pause;
N = length(x);
xmax = max(x);
xmin = min(x);
for i = 1:10                              % vector lev contains 10
equally
        lev(i) = xmin + i*(xmax-xmin)/12; % spaced levels inside the
range
        end
      %
 of x
x1 = x(1:N-1);
x2 = x(2:N);
tint = [];
for i = 1:10
  tc1 = find(x1 <= lev(i) & x2 > lev(i));
  tc2 = find(x1 > lev(i) & x2 <= lev(i));
  tc = [tc1 tc2];
  tc = sort(tc);
  n = length(tc);
  ti = tc(2:n) - tc(1:n-1);
  tinc = [tinc ti];
  end
tinc = sort(tinc);                      %time increments ordered by
length
tinc = fliplr(tinc);
m = length(tinc);
st = num2str(m);
sst     = ['No of data = ' st];
f = (1:m);
ltinc = log2(tinc);
lf = log2(f);
xmin = min(ltinc);
ymin = min(lf);
plot(ltinc, lf,'o');
xlabel('log2 tinc'), ylabel('log2 N(tinc>t)');
text(xmin+1, ymin+1,sst);
hold on;
mmax = input('Enter max no N for regression:  ');
mmin = m - mmax;
p = polyfit(ltinc(mmin:m), lf(mmin:m),1);
ff = polyval(p, ltinc);
plot(ltinc, ff);
s= num2str(p(1));
ss = ['Slope = ' s];
title(ss)

