function B=bounded(P);
%  Tests whether a polyhedron is bounded
%  Usage:
%         B = bounded(P)
%    P  -  polyhedron in GBT format, i.e. P(1,1)=4 or P(1,1)=6 
%          and hence P contains a vertex-vertex adjacency table
%    B  -  0  or  1  according to the boundedness of  P
%
%  GBT, S M Veres, 1993   

% The simple cases:
B=0;
if (P(1,1)<4), B=1;return; else B=0;end;
[nr,d]=size(P);d=d-1;
if (d<1),
  disp('Dimension of object must be at least 1.');break;
end; 
if (d==1),  
  if (P(1,2)<2),B=0;else B=1;end;
  return;
end;

% Testing for polyhedra of type 4:

if (P(1,1)==4),
   nvh=2+P(1,2)+2*P(1,3);
   VV=P(nvh:nr,1:d);
   [rvh,cvh]=size(VV);
   if (rvh>0),
     m=min(min(VV));
   else 
     m=0;
   end;
   if ((rvh<1)|(m==0)), 
     B=0;
   else 
     B=1;
   end;
end;

% Testing for polyhedra of type 6:

if (P(1,1)==6),
  if (d>2), d=P(1,4); end;  
  nv=2+P(1,2); 
  V1=P(nv:nv+P(1,3)-1,d+1);
  if (min(abs(V1))>0),
    B=1;
  else 
    B=0;
  end;
end;

return;
end;
