function PH=convp_ph(P);
% Converting polytope format type 2 into polyhedron format type 4 .
% Usage:   
%         PH = convp_ph(P)
%   P     polytope
%   PH    polyhedron
%
%  GBT, S M Veres,  1993

% Diagnosis:

[nr,nc]=size(P);d=nc-1;
if (nr<1),
  PH=[];return;
end;
if (d==1),
  PH=P;PH(1,1)=4;return;
end;

if (P(1,1)==4), 
  PH=P;return;
end;

% Conversion:

nh=P(1,2);nv=P(1,3);
if(P(1,1)==2)&(nr>=1+nh+nv),
  P=P(1:1+nh+2*nv,:);P(1,1)=2;
  VH=P(2+nh+nv:1+nh+2*nv,1:d);
  VV=zeros(nv,d+1);
  msk=(1:nv);
  for i=1:nv,
    mski=zeros(1,nh);
    for j=1:d, mski(VH(i,j))=1;end;
    mskiv=zeros(1,nv);
    for j=1:nv,
      mskj=zeros(1,nh);
      for k=1:d, mskj(VH(j,k))=1;end;
      if (sum(mski&mskj)==d-1), mskiv(j)=1;end; 
    end;
    if (sum(mskiv)~=d),
      disp('Input polytope to CONVP_PH was incorrect.');
      break;
    end;
    VV(i,1:d)=msk(mskiv);
  end;
  PH=[P;VV];PH(1,1)=4;
else
  disp('Polytope format was incorrect into CONVP_PH.');
  break;
end;

return;
end;


