function P=convph_p(PH);
% Converting polyhedron format type 4 into polytope format type 2.
% Usage:   
%         P = convph_p(PH)
%   P     polytope
%   PH    polyhedron
%
%  GBT, S M Veres, 1993

% Diagnosis:

[nr,nc]=size(PH);
if (nc<=2), 
  P=PH;P(1,1)=2;
  return;
end;
if (PH(1,1)==2), 
   P=PH;return;
end;

% Conversion:

if bounded(PH)&(PH(1,1)==4)&(nr==1+PH(1,2)+3*PH(1,3)),
  P=PH(1:1+PH(1,2)+2*PH(1,3),:);P(1,1)=2;
else
  disp('Polyhedron could not be converted into polytope by CONVPH_P.');
  break;
end;

return;
end;


