% Displays a symmetric random polytope and courrounds it with an ellips 

R=rand(10,3)-0.5*ones(10,3);    % random inequalities
H=[R ones(10,1);-R ones(10,1)]; % inequalities to produce symmetry
v=10*ones(1,3);                 % corner of a box to limit size of cristall 
P=defbox(-v,v);                 % definition of box
P=polybnd(H,P);                 % intersection of box with sets by inequalities
[d,ds,de]=diameter(P);          % computing diameter of P
N=d*d/3*eye(3);E=defell(N);     % defining an ellipsoid around P, with centre 0 and matrix N
viewgbt([E' P']',[1 2 3]);      % displaying crystall and ellipsoid