function E=defell(P,c)
%      Creates and ellipsoid in  GBT format representing the set                   
%                    { x | [x-c]' P^-1 [x-c]  1 }      
%      Usage:
%              E=defell(P,c) 
%        P   -   positive definite symmetric normal matrix of the ellipsoid
%        c   -   centre of the ellipsoid
%
%  Check at "http://sun1.bham.ac.uk/veressm/gbt.html " for more routines.
%
% GBT, S Hermsmeyer, 1993

% Diagnosis:

[m1,n]=size(P);
if (m1<1),
  disp('Dimension of object must be at least 1.');break;
end;


if exist('c');
  if (m1 ~= n)|(m1 ~= length(c)), 
    error('Incompatible matrix dimensions in "defell.m" ');
  end; 
  [cr,cc]=size(c); 
  if (cr==1),c=c'; end;
else
  c=zeros(m1,1);
end;  

% Building ellipsoid matrix:

if (m1==1), 
  E=[1,1;P(1,1),c];return;
end;

E=[1 zeros(1,n);P c];

return
end


