 function P=defpipe(A,b1,b2);
%  Calculates the solution to the set of inequalities  b1 <= Ax <= b2 .
%  Usage:
%            P = defpipe(A,b1,b2);
%   A      -   (n x d) matrix of coefficients of inequalities, n >= d  
%   b1,b2  -    column vectors of dimension   n 
%
%  Check at "http://sun1.bham.ac.uk/veressm/gbt.html " for more routines.
%
%  GBT, S M Veres,  1993

[n,d]=size(A);
if ~((length(b1)==n)&(length(b2)==n)), 
   disp(' Unequal dimensions in "defpipe".');break;
end;
B=[A b2;-A -b1];
P=polyhedr(B);

return;
end;

