function [F,nh]=faces(P);
%  Extracts the active supporting hyperplanes of a polytope or polyhedron.
%  Usage:
%        [F,nh] = faces(P) 
%    P   -  polytope in GBT format 
%    F   -  list of hyperplane equations. Each row F(i) has the form 
%           [a(i)' b(i)]  with the meaning  a(i)'x <= b(i)
%   nh   -  number of hyperplane faces
%
%  GBT, S M Veres, 1993

[pr,pc]=size(P);
if (pc<3)|(P(1,1)<2)|(P(1,1)>6),
   disp('Dimension or object type is wrong in "faces.m".');
end;

if (P(1,2)>0),
  nh=P(1,2);
  F=P(2:1+P(1,2),:);
else
 disp('Object type is wrong in "faces.m". ');
end;

return;
end;
