function find=perspect(P,vdir,sun);
% PERSPECT displays the shaded view of an object
% from given directions of view and ligt
% Usage:
%           find=perspect(P,vdir,sun);
%
%  P   - is the name of the object to be diplayed
%  vdir  - the azimuth  and elevation of direction of view
%  sun - the azimuth and elevation of the direction of the sun
%
% GBT Copyright, S M Veres, 1995

% Converting directions:
sun=[cos(sun(1))*cos(sun(2)) sin(sun(1))*cos(sun(2)) sin(sun(2)) ]';
di=[cos(vdir(1))*cos(vdir(2)) sin(vdir(1))*cos(vdir(2)) sin(vdir(2)) ]';
w1=[ -di(2) di(1) 0];w1=w1/norm(w1);
w2=[ di(1) di(2) -(di(1)*di(1)+di(2)*di(2))/di(3)];w2=w2/norm(w2);
Tr=[w1;w2];


if (P(1,1)==2), P=convp_ph(P);end;  % conversion in case of type 2

if (P(1,1)==4),     %  handling of type 4 polytope

%  Identifying visible faces
[F,nf]=faces(P);
vis=F(:,1:3)*di>0;nvis=sum(vis);
fac=F(vis,1:3);
ind=(1:nf);
find=ind(vis);
[V,nv]=vertices(P);
VF=P(2+nf+nv:1+nf+2*nv,1:3);
ind=(1:nv);

% Colouring-loop for visible faces for colouring 

for i=1:nvis,
  ViF=VF-find(i)*ones(nv,3);
  ViFp=ViF>0;ViFn=ViF<0;
  Vi=~(ViFp+ViFn)>0;
  iV=ind(sum(Vi'))';
  [nind,n1]=size(iV);
  iVl=(1+nf+2*nv)*ones(nind,1)+iV;VV=P(iVl,1:3);
  for k=1:nind-2,
     for m=k+2:nind,
        if sum(abs(VV(m,:)-iV(k)*ones(1,3))<0.5)>0,
            ci=iV(m);iV(m)=iV(k+1);iV(k+1)=ci;
            c=VV(m,:);VV(m,:)=VV(k+1,:);VV(k+1,:)=c;
        end;
     end;
  end;
  f=F(find(i),1:3)';
  r=abs(sun'*f/norm(f));
   hold on;
  X=V(iV,:)*w1';Y=V(iV,:)*w2';pth=patch(X,Y,[r 0.3*r 0.1*r]);set(pth,'edgecolor','white');
end;

 
return;
end;  % of case of type 4 polytope


end; 

  
