function [V,nv]=vertices(P);
% VERTICES lists the vertices of a polytope in GBT format
% Usage:
%         [V,nv] = vertices(P);
%
%    P   -  polytope in format of GBT
%    V   -  array of vertex row-vectors
%    nv  -  number of vertices
%
%    GBT, S M Veres, 1993

[nv,d]=size(P);
if (d<2),
  disp('Dimension must be at least one in "vertices.m".');break;
end;
% Scalar case:
if (d==2), 
  V=[ -P(3,2) P(2,2) ];return;
end;

% General case:
if (P(1,1)>1),
  nv=1+P(1,2)+P(1,3);
  V=P(2+P(1,2):nv,1:(d-1));
  if (P(1,1)==6),
     mask=-P(2+P(1,2):1+P(1,2)+P(1,3),d);
     V=V(mask,:);
  end;
  [nv,d]=size(V);
else
  disp('Object must be of type 2,4 or 6 in VERTICES.');break;
end;

return;
end;
