function C=signprod(A,B);
%SIGNPROD returns the sign pattern matrix C corresponding to the 
%         product AB.  An entry of C is +1,-1,0, or NaN depending
%         on whether that entry is unambigously signed positive,
%         unambiguously signed negative, unambiguously zero, or
%         ambiguously signed.

%        Jeff Stuart, USM Math Department, April, 1996.
%        jeffrey_stuart@bull.cc.usm.edu

sizeA=size(A);
sA=sizeA(1);
sizeB=size(B);
sB=sizeB(2);
C=zeros(sA,sB);
for i=1:sA,
    for j=1:sB,
        C(i,j)=signsum(A(i,:),B(:,j));
    end
end
