efunction C=signpwr(A,k);
%SIGNPWR computes the kth iterate of the sequence: signs(A),
%signs(signs(A)*signs(A)), signs(signs(A)*signs(signs(A)*signs(A)),
%...  If the resultant matrix has no ambiguous entries, then all
%     matrices sharing the sign pattern of A have no ambigous entries
%     in their kth power.

%     Jeff Stuart, USM Math Department, April 1996.
%     jeffrey_stuart@bull.cc.usm.edu

if k == 1,
   C=signprod(A,eye(size(A)));
else C=signprod(A,signpwr(A,k-1));
end
