function v=specdisp(A,B);

%SPECDISP The function specdisp(A,B) plots the eigenvalues of A on
%         the complex plane using "x"'s, and if a second matrix B
%         is provided, then the eigenvalues of B are simultaneously
%         plotted using "o"'s.  The origin is marked with a red "+".
%         Spec(A) plots the eigenvalues of A only.

%         June 1994, Jeff Stuart,  Univ. of Southern Mississippi

v=[];
loop = 2;
if nargin == 1
   loop = 1;
end

%Plot the spectrum of A.
e=eig(A);
plot(real(e),imag(e),'wx')
hold on
plot([0],[0],'r+')
grid
pause

%If matrix B is input, plot spectrum of B.
if loop ==2
   f=eig(B);
   plot(real(f),imag(f),'bo')
   pause
end

hold off
