function r = randnmbr(k);
%RANDNMBR  randnmbr(k) returns k independent, random real numbers.
%          The default value of k is 1.  By editing the parameters
%          in x3, the range of numbers can be extended and contracted,
%          and the probability that the output will be less than one
%          in magnitude can be increased or decreased.
%
%June, 1994.  Jeff Stuart, Math Department, Univ. of Southern Miss.
%             e-mail: jeffrey_stuart@bull.cc.usm.edu

if nargin == 0
   k = 1;
end
x=rand(3*k,1);
x1=(-1).^round(x(1:k));
x2=x((k+1):(2*k));
x3=-2+6*x((2*k+1):3*k);
r=x1.*x2.*exp(x3);
