function A=randpat(m,n,p,q)

%RANDPAT randpat(m,n,p,q) produces a random, mxn {-1,0,1}matrix with
%        100p% of the entries equal to zero (in a probabilistic sense),
%        and 100q% of the nonzero entries equal to one.
%        randpat(m,n) assumes p = q = 0.5 . 

%        Jeff Stuart, USM Math Department, March, 1994.
%        jeffrey_stuart@bull.cc.usm.edu

if (nargin == 2)
   p=0.5;
   q=0.5;
end
A=(-ones(m,n)).^(round((rand(m,n))-(q-0.5)));
B=round((rand(m,n)) - (p-0.5));
A=A.*B;
