function x=chaos(r,x0,nfrst,nlast)
% x=chaos(r,x0,nfrst,nlast)
% Generate a chaos diagram based on parameter values
% defined by vector r. Start the iteration using an
% initial x value of x0. Iterate nfrst times to reach
% starting points, then compute nlast values for each
% value of r. Typical parameter choices would be:
%    r=(3.4:.003:3.9); x0=.3; nfrst=200; nlast=200;
% Results can be plotted using the function chaosplt.

%     Howard Wilson, U. of Alabama, Fall 1989

%r=r(:); y=(x0*ones(r)-.5).*r;
r=r(:); y=(x0*(r*0+1)-.5).*r;%DT
a=(.5*r-1).*(.5*r);
for j=1:nfrst, y=a-y.*y; end;
x=zeros(length(r),nlast); x(:,1)=y;
for j=1:nlast-1, x(:,j+1)=a-x(:,j).^2; end
r=1 ./r; x=(r*ones(1,nlast)).*x+.5;
