function chaosplt(r,x)
% chaosplt(r,x)
% Plot a chaos diagram using values produced by
% function chaos.m

%   Howard Wilson, U. of Alabama, Fall 1989

hold off
rmin=min(r); rmax=max(r); xmin=min(min(x)); xmax=max(max(x));
clg; axis([rmin,rmax,xmin,xmax]); [nrows,ncols]=size(x);
w=ones(1,ncols);
for i=1:nrows, plot(w*r(i),x(i,:),'.'), hold on, end;
xlabel('R axis'); ylabel('x axis');
title('CHAOS DIAGRAM FOR X(N+1) = R*X(N)*( 1 - X(N) )')
hold off
