function isp = isprime(p)
%usage:  isp = isprime(p)
%isprime returns 1 for prime numbers and 0 for non-prime numbers

p_max=max(max(p));
isp = ones(size(p));

nonprime=find(rem(p,2)==0 & p>2*ones(size(p)));
isp(nonprime) = zeros(size(nonprime));

for n=3:2:ceil(sqrt(p_max)),
  nonprime=find(rem(p,n)==0 & p>n*ones(size(p)));
  isp(nonprime) = zeros(size(nonprime));
  if (n * (n+1)) >= p_max,
    break;
  end
end

nonprime=find(p==1);
isp(nonprime) = zeros(size(nonprime));

% By:   Bryce Gardner
%       1077 Ray W. Herrick Labs
%       Mechanical Engineering
%       Purdue University
%       West Lafayette, IN 47907-1077
%       Work: (317) 494-0231
%       Home: (317) 743-2367
%       Fax:  (317) 494-0787
%       Email: gardner@ecn.purdue.edu

