function isp = isprime2(p)
%usage:  isp = isprime2(p)
%isprime returns 1 for prime numbers and 0 for non-prime numbers

p_max=max(max(p));
primes=[2,3:2:ceil(sqrt(p_max))];

for i=2:length(primes);
  primes=[primes(i),primes(find(rem(primes,primes(i))~=0))];
  if (length(primes) == i),
    break;
  end
end

isp = ones(size(p));
for i=1:length(primes),
  nonprime=find(rem(p,primes(i))==0 & p~=primes(i)*ones(size(p)));
  isp(nonprime) = zeros(size(nonprime));
end

nonprime=find(p==1);
isp(nonprime) = zeros(size(nonprime));

% By:   Bryce Gardner
%       1077 Ray W. Herrick Labs
%       Mechanical Engineering
%       Purdue University
%       West Lafayette, IN 47907-1077
%       Work: (317) 494-0231
%       Home: (317) 743-2367
%       Fax:  (317) 494-0787
%       Email: gardner@ecn.purdue.edu

