function [isp,div]=isprime(p);

%ISPRIME Checks whether elements of a matrix are prime.
% [isp]=ISPRIME(P) returns 1s in locations where there is a prime
% element, and 0s where the elements are not prime.
% [isp,div]=ISPRIME(P) also returns a divisor of the non-prime
% numbers, and NaN otherwise.

% Eric Sandeen, University of Illinois.  6/28/93
% e-sandeen@uiuc.edu

isp=ones(size(p));

if nargout==1 | nargout==0
	for a=2:sqrt(max(max(p)))
		test=find(p./a==round(p./a) & p~=a);
		isp(test)=zeros(size(test));
	end

elseif nargout==2
	div=NaN*zeros(size(p));
	for a=2:sqrt(max(max(p)))
		test=find(p./a==round(p./a) & p~=a);
		isp(test)=zeros(size(test));
		div(test)=a*ones(size(test));
	end

end

