function isp = isprime(p)
% ISPRIME	This function determines if each element in the input matrix
%		is a prime number.  The output is a matrix which returns 1s
%		for the prime elements in the input matrix and 0s otherwise.
%

% Author:  Kay Nilson
%	   email:  knilson@motown.ge.com
%	   work phone:  (609) 722-7896
%	   home phone:  (215) 543-0864
% Date:  29 June 1993

[num_rows, num_cols] = size(p);

%  Are any of the elements divisible by two?
%  If they are make the corresponding output element 0
isp = rem(p,2) ~= 0;

for i = 1:num_rows
  for j = 1:num_cols

   %  Is this element = 2 or 1?
    if (p(i,j) == 1)
      isp(i,j) = 0;
    elseif (p(i,j) == 2)
      isp(i,j) = 1;

   %  If this element has not already been determined to be divisible by two
   %  cycle through numbers <= sqrt(p(i,j)) by twos to determine if prime
    elseif isp(i,j) == 1
      for k = 3: 2: ceil(sqrt(p(i,j)))
        if (rem(p(i,j),k) == 0)
          isp(i,j) = 0;
          break
        end
      end
    end
  end
end


