function Z = contest(Z)  
%
% Drea's Desk: M-file contest!
%
% The function solves the following problem:
%
% Problem: You have a NxM matrix which contains integers from
%          1 to 255 (an image, perhaps). There are only K unique
%          integers in the matrix (K < 255). Your mission, should
%          you choose to accept it, is to map the integers in the
%          the matrix from the range 1-255 to 1-K while preserving
%          the order of the numbers (see example). This operation
%          is similar to compressing the colormap of an image.
% 
% Example:    1   10  25             1  2  3
%             123 233 255     =>     5  8  9
%             172 201 54             6  7  4
%
% The execution takes 0 flops and prod(size(Z))+255 array elements. 
% 
% Author: T. Hristov
% Dec 8, 1993
%
 
   flags = zeros(1,255) ; 
           
   flags(Z) = ones(size(Z(:))) ;     
    
   flags(flags) = 1:max(size(flags(flags))) ;
  
   Z(:) = flags(Z) ;
   
