function Z = colorcompress(Z)
% PJ 2.12.1993
% Z is a matrix with integer entries in the range 1..255.
% Result is a version of Z where unused integers have been
% removed.
%  Example:    1   10  25             1  2  3
%              123 233 255     =>     5  8  9
%              172 201 54             6  7  4
[N,M] = size(Z);
% 'used' is a vector 1..255 with Boolean entries telling
% whether the color is used in Z or not.
used = zeros(1,255);
used(Z) = ones(N,M);
% 'news' is a vector 1..255 with news(i) telling the mapped
% color index of i, if i is among the used indices
f = find(used);
news = zeros(1,255);
news(f) = 1:length(f);
% finally apply the mapping defined by vector 'news'
Z(:) = news(Z);
