function A=compress(A,maxK)
% Compresses A while preserving the ordering of the colors.
%
% Written by Hans Olsson, hanso@dna.lth.se
%
% A contains elements from 1..maxK
%
if nargin<2
  maxK=max(max(A));
end
i=A(:);
rc=length(i);
K=zeros(maxK,1);
K(i)=ones(rc,1);
i2=find(K);                             % Find the interesting ones.
%K(i2)=cumsum(K(i2)); % The same as K=cumsum(K) but this means fewer flops.
for j=i2'
  K(j)=length(find(i2<=j));
end;
A(:)=K(i);
