function X=crunch(Z);
% CRUNCH  Colormap compaction 
%         X=CRUNCH(Z) takes an array Z of integers in the range 1-M, of 
%         which there are K<M unique values, and returns a matrix X of the 
%         same size in which the elements are mapped into the range 1-K 
%         while preserving order.
 
% Author: R. Pawlowicz 2/12/93
%         rich@boreas.whoi.edu
 
 
X(Z)=ones(size(Z));    % Identify all unique (non-zero) values
 
F=find(X>0);           % 
J(F)=1:length(F);      % This is only place where flops occur,
                       % so by adding the F vector we can reduce
                       % the number of ops from 255 (approx) to 0,
                       % at the expense of a little more memory.
                      
                       % Final (ordered) solution.
X=reshape(J(Z),size(Z,1),size(Z,2));
