function [A,K]=squash(A)
%function [A,K]=squash(A)
%
% Takes a matrix A of integers on any interval and replaces it with a
% matrix of integers in the range [1,K], where K is the number of
% unique integers in A.  That is, the positions in A holding the
% smallest integer are replaced with 1, the positions with the next
% smallest integer are replaced with 2, and so on up to K.  The
% routine also returns the value of K.
% 
 
y=sort(A(:));
K=length(y);
y=y([find(~[0;y(2:K)==y(1:length(y(2:K)))])]);
K=length(y);
ind(y)=[1:K]';
A(:)=ind(A);
