function B=lexsort(x)
 
[N1 N2]=size(x);
 
% generation of numerical matrix corresponding to x 
B=abs(x)-97;   % let 'a'=0
for i=1:N1    
    j=1;
        while(B(i,j)==-65) % find leading spaces
            j=j+1;
        end
   B(i,:)=[B(i,j:N2),-65*ones(1,j-1)]; % push out leading spaces
   B_upper(i,:)=B(i,:)>=-33 & B(i,:)<=-7; % matrix containing upper cases
   B_lower(i,:)=B(i,:)>=0 & B(i,:)<=25;  % matrix containing lower cases
end
C=((2*B)+1).*B_lower+(2*(B+32)+2).*B_upper; % combining lower cases and
                   % upper cases. ' '->0, 'a'->1, 'A'->2, 'b'->3,...
                   % characters other than 'a'-'z' and 'A'-'Z' -> 0
 
% Compressed numerical matrix
n1=rem(N2,6);
n=(N2-n1)/6;
if n>0
  V=(53*ones(1,6)).^(5:-1:0); 
  for i=1:n
    BB(:,i)=C(:,(6*(i-1)+1):6*i)*V';  % weighted sum of every 6 columes
                                      % 6 is a compromise
  end
end
 
if n1>0
  V=(53*ones(1,n1)).^(n1-1:-1:0);       
  BB(:,n+1)=C(:,6*n+1:N2)*V';   % weighted sum of the remaining columes
  n=n+1;
end
 
 
% initialization
 
clear INDX;             % store the order of strings
midnt=1;                % # of identical blocks in sorted sub-vector
midnt2=0;               % updated value of midnt
midnt_sum=0;            % # of identical elements in sub-vector
m_past=0;               % # of elements in sub-vector examined so far
Vrem=[1 N1 0; 0 0 N1];  % Vrem(j,:) range, size and last element 
                        % of the jth block
Vvec=1:N1;              % index of identical elements
 
% sorting. starting from the first colume of BB, picking up rows whose order 
% can be uniquely determined. Keeping remaining rows and sorting them on next 
% colume. Sorting is finished when the order of all the rows are picked up 
% or the columes are exausted.
 
for k=1:n               % colume of BB
  for j=1: midnt
    head=Vrem(j,1);     % the first row of the exameined sub vector of BB
    tail=Vrem(j,2);     % the last row of sub-vector of BB
    m=head; 
    [C V]=sort(BB(Vvec(Vrem(j,3)+1:Vrem(j+1,3)),k));
              % sort the kth colume of sub-vector
    while m<=tail
      if k==n           % all columes exausted
        INDX(head:tail)=Vvec(Vrem(j,3)+V);  %  non-distinguishable, add to INDX
                                             % in sorted order
         vsize=Vrem(j+1,3)-Vrem(j,3);
      else
         vec=C==C(m-head+1);            % identical elements
         vsize=sum(vec);                % # of identical elements
         if vsize==1                    % unique element
            INDX(m)=Vvec(Vrem(j,3)+V(m-head+1));  % singled out, add to INDX
         else
           midnt2=midnt2+1;  % increament of # identical blocks
           Vrem2(midnt2,:)=[m m+vsize-1 midnt_sum]; 
                            % range of identical elements
           Vvec2(midnt_sum+1:midnt_sum+vsize)= ...
              Vvec(m_past+(V(m-head+1:m+vsize-head))'); % update Vvec
           midnt_sum=midnt_sum+vsize;
         end
      end
      m=m+vsize;                % # of examined elements
    end % while m
    m_past=m_past+Vrem(j+1,3)-Vrem(j,3);
  end                   % for j
  if midnt2==0          % no more identical element
    B=x(INDX,:);        % return sorted strings
    return
  end
  midnt=midnt2; 
  midnt2=0;
  Vrem=Vrem2;
  Vrem(midnt+1,:)=[0 0 midnt_sum];      % index to the last identical element
  midnt_sum=0;
  Vvec=Vvec2;
  m_past=0;
end             % for k
