function [A, sort_index]=lexsort(A)
%A=lexsort(A)
%
%Sorts a string matrix into dictionary order, ignoring leading spaces.
%If using ascii above 127, modify lines 12 and 23
 
% First get size of matrix.
[m,n]=size(A);
 
% Get number of columns to operate on.
% If using ascii above 127 replace maximum number 7 by 6.
order=min(n,7);
 
% Remove the leading spaces
if nargout<2
        A_dash=A';
        [dummy1, blank_index]=sort(A_dash==' ');
        A=A_dash(blank_index+ones(n,1)*[0:n:m*n-1])';
end
 
% comp=128.^[6:-1:0]
% If using ascii above 127 replace comp by 256.^[5:-1:0] 
comp=[4398046511104; 34359738368; 268435456; 2097152; 16384; 128; 1];
 
% Obtain a sorted vector of weights of the first order columns.
[metric, sort_index]=sort((A(:,1:order)*comp(1:order))');
 
% If there are more columns then sort any rows that have the same metric.
if order<n
        A=A(sort_index, :);
        detect_repeat=metric(2:m)>metric(1:m-1);
        for recur=[find([detect_repeat 1]<[1 detect_repeat]);
                                  find([detect_repeat 1]>[1 detect_repeat])]
                r=recur(1):recur(2);
                [dummy2, recur_sort]=lexsort(A(r,order+1:n));
                sort_index(r)=sort_index(r(recur_sort));
        end
end
 
% Finally, replace spacing.
if nargout<2
        A=A_dash(:,sort_index)';
end
