function [A, index]= lexsort(A)
%
% Dreas's Desk: M-file contest! V2.0
%
% LEXSORT
%          Lexical sorting of a string matrix ignoring leading spaces.
%
%          [S, I]=lexsort(A)
%          S is the sorted string matrix, I is the vector that sorts A:
%          S=A(I,:) ;
%
% Author: T. Hristov
% Feb 7, 1994
 
    aCopy = abs(A) ;
 
    %
    % Convert to upper case
    % In general, dictionaries are case insensitive
    %
    A_ASCII = abs('A') ;
    Z_ASCII = abs('Z') ;
    a_ASCII = abs('a') ;
    z_ASCII = abs('z') ;
    aCopy = aCopy - ....
            (a_ASCII - A_ASCII) * ((aCopy >= a_ASCII) & (aCopy <= z_ASCII));
 
    %
    % Webster ignores all the spaces and punctuation characters in the string
    %
    [nrows ncols] = size(A) ;
    for row = 1:nrows
        letters_flags = ((aCopy(row,:) >= A_ASCII) & (aCopy(row,:) <= Z_ASCII));
        aCopy(row,:)  = [aCopy(row, letters_flags) aCopy(row, ~letters_flags)];
    end
 
    %
    % Now we sort the strings
    %
    index = (1:nrows)';
    i     = (1:nrows)';
    tmp   = (1:nrows)';
    for col = ncols:-1:1
        [tmp i] = sort(aCopy(index,col)) ;
        index = index(i) ;
    end
 
    A=A(index,:) ;
 end
