          function StrMat=lexsort(StrMat);
          %function StrMat=lexsort(StrMat);
          %
          % FILE LEXSORT.M
          %
          % PURPOSE: Sort the rows of the string matrix "StrMat"
          %          in dictionary order (ignoring leading spaces);
          
          %Make all letters in each string lower case
           ASCII=lower(StrMat);
          
          %Move leading blanks to end of string
           [n,m]=size(StrMat);
           for i=1:n                              %for each string
            if min(ASCII(i,:)==32*ones(1,m))==0   % if it's not all blank
             while ASCII(i,1)==32,                %  while char(1) is blank
              ASCII(i,1:m-1)=ASCII(i,2:m);        %   move other chars up
              ASCII(i,m)=32;                      %   add blank to end
             end%while
            end%if
           end%for
          
          %Sort The String Matrix
           IND=1:n;                          %init index vector
           for i=m:-1:1                      %sort str ord last->1st char
            [ignore,ind]=sort(ASCII(IND,i)); %get sorted indices
            IND=IND(ind);                    %reorder indices
           end;
           StrMat=StrMat(IND,:);                  %output string matrix
                                             % based on sorted indices
