function Y = lexsort(A);
%
% sort strings in lexical order.
% A is the input matrix of strings, Y is the ordered output.
%
% converting spaces to zeros.
 
A=A-32;  
 
% finding the non-space elements
 
[k,l]=find(A');
 
% j is the place of the first non-space character in each row.
 
j=k(diff([0;l]));
 
% creating a vector of weights V, to sort A (ignoring the leading spaces - by multipling % with the vector s). 
% each character is multiplied by a power of 256 (No. of ascii characters) 
% according to its place in the word.
 
V=256.^(size(A,2)-1:-1:0)';
s=256.^(j-1);
[ln,cn]=sort((A*V).*s);
 
% sorting A, putting back the spaces.
 
Y=setstr(A(cn,:)+32);
