function SortIt = lexsort(SortMe),
% LEXSORT: Text = lexsort(Text),
%          lexical sorting, uses the Radix sorting procedure
%          Tomas P. Runarsson (tpr@verk.hi.is)
 
% initialise
  SortIt = SortMe ;
  [m,n] = size(SortIt) ;
% remove leading spaces and pad trailing spaces with (' ' + 1/2)
  while 1,
    I = find(SortMe(:,1) == ' ') ;
    if I == [],
      break ;
    end
    SortMe(I,1:n-1) = SortMe(I,2:n) ;
    SortMe(I,n) = 32.5*ones(size(I)) ;
  end
% case upper, set upper = (lower - 1/2)
  Mask = ((SortMe(:,1) >= 'A') & (SortMe(:,1) <= 'Z')) ;
  SortMe(:,1) = SortMe(:,1) + 31.5*Mask ;
% push row-index in first column
  SortMe = [(1:m)' SortMe] ;
% radix sorting procedure
  for i = (n+1):-1:2,
    [V,I] = sort(SortMe(:,i)) ;
    SortMe = SortMe(I,:) ;
  end
% finally sort the original matrix
  SortIt = SortIt(SortMe(:,1),:) ;
end
