function A = lexsort(B)
% LEXSORT --- Lexical sorting.  Sorts rows of string matrix
%         in dictionary order, ignoring leading spaces.
%         A = lexsort(B)
%
 
A = B;
[m, n] = size(A);
spc = 32;
spaces = ones(1, n) * spc;
temp = zeros(1, n);
indices = zeros(m, 1);
 
% get rid of leading spaces
for i=1:m
  for j = 1:n
    if A(i, j) ~= spc
      indices(i, 1) = j;
      if j > 1
        temp = spaces;
        temp(1,1:n-j+1) = A(i,j:n);
        A(i,:) = temp(1, :);
      end % if
      break;      
    end % if
  end % for j
end % for i
 
% sort in lexical order
for j=n:-1:1
  [Y, I] = sort(A(:, j));
  A = A(I, :);
  indices = indices(I, 1);
end % for j
 
% re-insert leading spaces
 
for i=1:m
  j = indices(i, 1);
  if j > 1
    temp = spaces;
    temp(1,j:n) = A(i,1:n-j+1);
    A(i,:) = temp(1,:);
  end % if
end % for i
 
clear temp spaces indices m n i j spc I Y
