function r = isrect(x, y)
 %ISRECT True if polygon encloses a rectangular shape.
 %       ISRECT(X, Y) returns 1 if X and Y are the x- and y-coordinates
 %       of the vertices of a polygon that encloses a rectangular
 %       shape.  Otherwise it returns 0.  X and Y must be vectors that
 %       have the same length.  The input polygon must be closed; in
 %       other words, X(1)==X(length(X)) and Y(1)==Y(length(Y)).  
 %
 % 	Note: the line width tolerence is 10^-6 of the size of the rectangle 
 
 % SD 20/1/94 LMU
r=0;
if length(x)==1,r=1;break,end
rn=rand(1);
t=[cos(rn) -sin(rn);sin(rn) cos(rn)];
tm=t*[x;y];x=tm(1,:);y=tm(2,:);
m=rand(1,2)*[x;y];
[q,i]=sort(m);n2=[1 diff(q)~=0 ];
xn=x(i(n2))';yn=y(i(n2))';s=sum(n2);
vertc=xn==min(xn)|yn==min(yn)|xn==max(xn)|yn==max(yn);
if sum(vertc)==3,break,end
vert=[xn(vertc) yn(vertc)];
if sum(vertc)==4
	m1=vert(2,:)-vert(4,:);m2=vert(1,:)-vert(3,:);m1=m1*m1';m2=m2*m2';
	fl=abs((m1-m2)/m1)<1e-3;
else
	fl=1;
end
if fl
	r=1;i=1;
	vp=any(tm(ones(1,length(vert)),:)==vert(:,ones(1,length(tm))));
	vp(1)=1;vp(length(vp))=1;vp=find(vp);
	a=diff(vert([1 2],:));mr=inv([a(1) -a(2);a(2) a(1)]);  	
	ch=mr*tm;
	while(r & i<length(vp))
		sec=ch(:,vp(i):vp(i+1));
		r=r&all(abs(sec(1,:)-sec(1,1))<1e-6)|all(abs(sec(2,:)-sec(2,1))<1e-6);
		i=i+1;
	end
end


