function   hour = date2hour(date)
%
%
%	 hour = date2hour(date)
%
%	 This function returns the hour from a date. 
%	 Date must be in a yymmddhh format.
%
%	 Whoever thought up this system of time must not
%	 have had a computer. It is hard to convert
%	 time in to hour because of exceptions like leap
%	 years and not equal days in a month. 
%
%      Bugs: It won't work from century to century. But
%		 that's easy to fix up when the time comes
%		
%
%	 Made by Louis Verhagen 
%	 submited to Matlab on 24/3/1994
%
%	 
monthvec=[0 31 59 90 120 151 181 212 243 273 304 334]';

if size(date,1) == 1
  date=date';
end
compdate1=fix(date/100);
hourtemp=date-(compdate1*100);			% in hours
compdate2=fix(compdate1/100);
day=compdate1-(compdate2*100);			% in days

compdate3=fix(compdate2/100);
monthindx=compdate2-(compdate3*100);
month=monthvec(monthindx);				% in days

compdate4=fix(compdate3/100);
year=compdate3-(compdate4*100);		% in days

leapdays=fix(year/4);

if (fix(year/4))*4 == year;
  if monthindx < 3;
    leapdays=leapdays-1;
  end;
end;

hour=hourtemp +(day+month+leapdays+(year*365))*24;
