function mfplot(a,b,c,d,e,f,g,h)
%MFPLOT: To plot the membership functions defined on a fuzzy matrix of
%        fuzzy value  A over universe U, or more general, to plot the
%        rules given for a rule base with maximum 4 input and one output
%        this command can be used.
%
%                               MFPLOT(A,U)
%                               MFPLOT(A,U,B,V)
%                               MFPLOT(A1,U1,..,A3,U3,B,V)
%

% FISMAT: Fuzzy Inference Systems toolbox for MATLAB
% (c) A. Lotfi, University of Queensland (Email: lotfia@s1.elec.uq.oz.au)
% 13-10-93
% The program has been tested on MATLAB version 4.1, Sun workstation.
%
% 16-4-94
% The program has been modified for MATLAB version 3.5b, Personal Computer.

clg;

if nargin == 2
                axis([min(b),max(b),0,1]);
                plot(b,a);
                xlabel('Universe of U');ylabel('Grade of MF')
                title('Antecedent')
elseif nargin == 4
                subplot(121);
                axis([min(b),max(b),0,1]);
                plot(b,a);
                xlabel('Universe of U');ylabel('Grade of MF')
                title('Antecedent')

                subplot(122);
                axis([min(d),max(d),0,1]);
                plot(d,c);
                xlabel('Universe of V');ylabel('Grade of MF')
                title('Consequent')

elseif nargin == 6
                subplot(221);
                axis([min(b),max(b),0,1]);
                plot(b,a);
                xlabel('Universe of U1');ylabel('Grade of MF')
                title('Antecedent 1')

                subplot(222);
                axis([min(d),max(d),0,1]);
                plot(d,c);
                xlabel('Universe of U2');ylabel('Grade of MF')
                title('Antecedent 2')

                subplot(223);
                axis([min(f),max(f),0,1]);
                plot(f,e);
                xlabel('Universe of V');ylabel('Grade of MF')
                title('Consequent')
elseif nargin == 8
                subplot(221);
                axis([min(b),max(b),0,1]);
                plot(b,a);
                xlabel('Universe of U1');ylabel('Grade of MF')
                title('Antecedent 1')

                subplot(222);
                axis([min(d),max(d),0,1]);
                plot(d,c);
                xlabel('Universe of U2');ylabel('Grade of MF')
                title('Antecedent 2')

                subplot(223);
                axis([min(f),max(f),0,1]);
                plot(f,e);
                xlabel('Universe of U3');ylabel('Grade of MF')
                title('Antecedent 3')

                subplot(224);
                axis([min(h),max(h),0,1]);
                plot(h,g);
                xlabel('Universe of V');ylabel('Grade of MF')
                title('Consequent')
else
        error('Inputs argument is not correct')
end
hold off;axis('normal');
