%FISMAT: Fuzzy Inference Systems toolbox for Matlab
%(c) A. Lotfi, Department of Manufacturing Engineering
%	      The nottingham Trent University	
%25-6-1996
%
%*** Membership Functios ***
%
%BELL_1:     Generalized bell-shaped membership function. 
%BELL_2:     Generalized bell-shaped membership function. 
%TRAPEZE:    Triangular Membership function. 
%SIGMOID:    Sigmoidal membership function.
%
%*** Fuzzy Reasoning ****
%
%CENTRE:     This function returns the centre of matrix of fuzzy value. 
%CRI:        Compositional Rule of Inference.
%CTRSURF:    Control surface.
%DEFZFIR     Defuzzification methods.
%FZFIR       Fuzzification operation.
%GRADEMF:    Grade of Membership Function.
%IMPLY       Fuzzy implication relation.
%INTEGRAL:   This function returns the integral of matrix of fuzzy value. 
%KOSKO:      Kosko fuzzy model.
%LARSEN:     Larsen fuzzy model.
%MAMDANI:    Mamdani fuzzy model.
%MF_PANEL:   Manual tuning of different types of membership functions. 
%MFPLOT:     To plot the membership functions defined on a fuzzy matrix. 
%MODIFY:     Consequence Modification.
%QUANTIZE:   To quantize the input matrix X with a quantum size Q.
%REASON:     This function manipulate the Max-Min for matrix of fuzzy value.
%RULEBASE:   To ease membership function definition.
%SIMILAR:    Similarity Measure: This function manipulate the similarity.
%SUGENO:     Sugeno and Takagi's model of fuzzy systems.
%TURKSEN:    Turksen's Approximate Analogical Reasoning Approach.
%ZADEH:      Zadeh's Compositional rule of inference reasoning. 
%
%*** Fuzzy Operation ****
%
%ARITH: 	    Fuzzy Arithmetic.
%NOT:  	    A quantifier on matrix of fuzzy values.
%UNION:      The union of matrix of fuzzy values A and B. 
%INTERSEC:   The intersection of matrix of fuzzy values A and B.
%VERY:       A quantifier on matrix of fuzzy values.
%ORELESS:   A quantifier on matrix of fuzzy values.
%COMPLE:     A quantifier on matrix of fuzzy values.
%
%*** Demo ****
%
%FISDEMO:    Main demonstration
%TRUCK:      The nonlinear model for Truck Backer-Upper Control.
%TRUCK_9:    To be called from FISDEMO.M.
%CTR_DEMO:   To be called from FISDEMO.M.
%INVPEND4:   To be called from FISDEMO.M.
%REASDEMO:   To be called from FISDEMO.M.
%INTRDEMO:   To be called from FISDEMO.M.
%INVPEND:    The nonlinear model for inverted pendulum.
%IMPLDEMO:   To be called from FISDEMO.M.
%DA_PANEL.M: To be called from FISDEMO.M.

