function [low,high]=multilim(x,I,nbins)
% Used to "decrypt" the numbers from histmulti
%
% [low,high]=multilim(x,I [,nbins])
%
% In:
%  x - as from histmulti
%  I - the index(indicies) in the n-vector from histmulti
%  
% Out:
%  low,high: The limits of the bins.
%             one row for every I-value.

%  n(i) from histmulti is now number of y-values such that
%   y>=low(i) & y<high(i)
%
% Written by hanso@dna.lth.se

if (nargin<3)
  nbins=sum(~isnan(x));
end;
I=I(:);
low=zeros(length(I),size(x,2));
high=low;

I=I-1;
x=[x;zeros(1,size(x,2))];
for i=size(x,2):-1:1
  thisind=1+rem(I,nbins(i));
  I=fix(I./nbins(i));
  x(nbins(i)+1,i)=inf;
  low(:,i)=x(thisind,i);
  high(:,i)=x(thisind+1,i);
end;
