function F = generate(E)
% Generate(E) by C. Bailey, May 1996
% 
% generate() prompts the user to input the expressions
% which will determine a set of differential equations
% describing an enzyme system.
%
% Input:  E = text column vector containing symbol
%             for each enzyme species
% Output: M = matrix of differential coefficients

N = symsize(E,1);	% N = no. of species in system
M = sym(zeros(N,N));	% Dimension of matrix of coefficients
C = sym(zeros(N,1));	% Column vector for column totals of M

for i=1:N
 for j=1:N
  if i ~= j
   sprintf('Rate of conversion of %s to %s',sym(E,j,1),sym(E,i,1))
   t=input(': ','s');
   M=sym(M,i,j,t);
   t=symadd(t,sym(C,j,1));
   C=sym(C,j,1,t);
  end
 end
end

C=symop('-',C);

for i=1:N
 M=sym(M,i,i,sym(C,i,1));
end

F=M; 

% end generate() with F = matrix of coefficients
