% kinetic2.m    by C. Bailey, May 1996
%
% This script will guide the user through a series of
% functions relating to the solution of a kinetic
% mechanism for the transient state in the initial
% phase. Input is all prompted for by the script.
%
% Output:
%  N = number of species in the system
%  E = text column vector of species names
%  M = Matrix of differential coefficients
%      such that dE/dt = MxE
%  C = Initial concn's of each species
%  T = Concentrations of each species as f(t)

N=input('Number of species in system: ');

if N > 5
 'WARNING: System may be too complex'
end

E=name(N)
M=generate(E)
C=concn(E)
F=trans(M,C)

% end kinetic2.m
