function y = linspace(first,lastorinc,length)
%
% y = linspace(first,lastorinc,length)
%
% create a linearly spaced vector with more precision and
% more flexibility than first:increment:last
%
%     first = first element in vector
% lastorinc = last element in vector if positive
%           = increment of vector if negative
%    length = length of the vector
%
% if length is ommitted, default is 50
%

% Written by: Duane Hanselman, University of Maine, (207)-581-2246

if nargin == 2, length = 50; end
lnm1 = length-1;
if lastorinc >= 0;
              y = first + (0:lnm1)*(lastorinc-first)/lnm1;
else
              y = first: -lastorinc : first-lnm1*lastorinc;
end
