function [string] = com2str(num)
%
% FUNCTION [STR] = com2str(NUM)
%
% Returns NUM as a string of form
% a, if NUM is real,
% bi if NUM is imaginary, or
% a+bi if NUM is complex
%
% Written by Keith Rogers (kerog@athena.mit.edu)
% Last revised 8/12/93

rnum = abs(real(num));
inum = abs(imag(num));
if isstr(num)
	string = num;
else
	if (rnum/100000 > inum)
  		num = real(num);
		inum = 0;
	elseif (inum/100000 > rnum)
  		num = imag(num)*j;
		rnum = 0;
	end
	if (rnum ~= 0 | inum == 0),
 	string = num2str(real(num));
	end
	if (rnum ~= 0 & imag(num) > 0),
 	string = [string '+'];
	end
	if inum ~= 0,
 	string = [string num2str(imag(num)) 'i'];
	end
end
