function string = fracprint(num,den)
%string = FRACPRINT(num,den)
%
%fracprint returns a string which will generate a "pretty"
%fraction if pasted into editor.  editor is a global variable 
%which may be either 'MSWORD' or 'TEX' and defaults to 'TEX'
%
%	Argument definitions:
%
%	num = numerator of the fraction
%	den = denominator of the fraction
%
%	Written by Keith Rogers (kerog@athena.mit.edu) 
%	Last revised 8/12/93

global editor;
if ~exist('editor')
	editor = 'TEX';
end
while (~(strcmp(editor,'TEX') | strcmp(editor,'MSWORD')))
	editor = input2('Unrecognized editor! Do you want TEX or MSWORD?','TEX');
end
	if isstr(num) == 0,
	 num = num2str(num);
	end
	if isstr(den) == 0,
	 den = num2str(den);
	end

if strcmp(editor,'MSWORD')
	string = ['\F(' num ',' den ')'];
elseif strcmp(editor,'TEX')
	string = ['{' num '}\over{' den '}'];
else
	error('Don''t recognize editor! Use ''TEX'' or ''MSWORD''.');
end
