function string = polyprint(poly,var)
%string = POLYPRINT(poly,var)
%
% polyprint prints a polynomial vector in such a form that it
% will look nice if pasted into editor.  Note that if Microsoft
% Word is used, the \'s will have to be replaced with MSWORD's 
% special .\'s, accessible from the Macintosh keyboard with CMD-OPT-\.
% editor is a global variable which may be either 'MSWORD' or 'TEX'
% and defaults to 'TEX'.
%
%	Argument definitions:
%
%	poly = matrix of polynomial coefficients
%	var  = variable polynomial is to be expressed in;
%              if var is 's', then [1 1] will yield 's+1'
%
%	Written by Keith Rogers (kerog@athena.mit.edu) 
%	Last revised 8/12/93

global editor;

if ~exist('editor')
	editor = 'TEX';
end
while (~(strcmp(editor,'TEX') | strcmp(editor,'MSWORD')))
	editor = input2('Unrecognized editor! Do you want TEX or MSWORD?','TEX');
end
pow = length(poly);
pos = 1;
string = [];
while (pow-pos) > 1,
  if (abs(poly(pos)) > 1e-8),
	if(strcmp(editor,'MSWORD'))
		string = [string ppn2str(poly(pos)) var ...
		'\s\up4(' num2str(pow-pos) ')'];
	elseif(strcmp(editor,'TEX'))
		string = [string ppn2str(poly(pos)) var ...
		'^{' num2str(pow-pos) '}'];
	else 
		error('Don''t recognize editor! Use ''TEX'' or ''MSWORD''.');
	end
  end
  if (poly(pos+1) > 1e-8),
   	string = [string '+'];
  end
  pos = pos + 1;
end
if ((pow - pos) == 1 & abs(poly(pos))>1e-8),
  string = [string ppn2str(poly(pos)) var];
  if poly(pow) > 0,
    string = [string '+'];
  end
end
if abs(poly(pow)) > 1e-5,
  string = [string num2str(poly(pow))];
end
