function tfmatprint(numvec1,numvec2,den)
% function  tfmatprint(numvec1,numvec2,den)
%
% Outputs a string that will produce a pretty 2x2 transfer function
% matrix if pasted into EDITOR.  EDITOR is a global variable which you
% will be prompted for if it is not yet defined.  It may be either
% 'MSWORD' or 'TEX'.
%
% Arguments:
%     numvec1	matrix of polynomial coefficients of the numerator
% 				(left hand side, 2 by n)
%     numvec2	matrix of polynomial coefficients of the numerator
% 				(right hand side, 2 by n)
%     den	    matrix of polynomial coefficients of the denominator
%
% Written by Keith Rogers (kerog@athena.mit.edu)
% Last revised 8/12/93

string1 = tfprint(numvec1(1,:),den);
string2 = tfprint(numvec2(1,:),den);
string3 = tfprint(numvec1(2,:),den);
string4 = tfprint(numvec2(2,:),den);
mat = [string1 '!' string2 '#' string3 '!' string4 '#'];
matprint(mat);
