/*
        % Rename matrix with name Name.
        % mxRename(Mtx,Name);
 
    I don't know who wrote this originally, but I've modified it somewhat:
    
      1. to make the error messages more explanatory.
      2. to check that we don't duplicate matrix names.
    
    Erik A. Johnson <johnsone@uxh.cso.uiuc.edu>, 7/27/95
*/

#include <stdio.h>
#include <string.h>
#include "mex.h"

/* Arguments */
/*#define MTX prhs[0]*/
#define NAME prhs[1]


#ifdef __STDC__
char *getstring(int n, Matrix *matrix)
#else
char *getstring(n, matrix)
int n;
Matrix *matrix;
#endif
  {char *Name;
   int  error;
    Name=mxCalloc(n,sizeof(char));
    error=mxGetString(matrix,Name,n);
    if (error==1)
        mexErrMsgTxt("MXRENAME got an error reading the new name string.");
    return(Name);
   }


#ifdef __STDC__
void mexFunction(
        int             nlhs,
        Matrix  *plhs[],
        int             nrhs,
        Matrix  *prhs[]
        )
#else
mexFunction(nlhs, plhs, nrhs, prhs)
int nlhs, nrhs;
Matrix *plhs[], *prhs[];
#endif
{
        Matrix *Mtx;
        int n, error;
        char *Name;
        
        Matrix *lhs[1],*NameMtx;
        double existval;
        char errmsg1[]="MXRENAME found that '";
        char errmsg2[]="' already exists in the workspace.";
        char *errmsg;
        int errmsg1len,errmsg2len;

        /* Check for proper number of arguments */
        if (nrhs != 2)
                mexErrMsgTxt("MXRENAME requires exactly 2 input arguments.");
        else if (nlhs != 0)
                mexErrMsgTxt("MXRENAME produces no output arguments.");

        /* Check if new name is a string matrix */
        if (!mxIsString(NAME))
                mexErrMsgTxt("MXRENAME requires that the new name be a string.");

        /* Check if new name is non-empty */
        n=mxGetN(NAME)*mxGetM(NAME)+1;
        if (n<=1)
            mexErrMsgTxt("MXRENAME requires that the new name not be empty.");
        
        /* Make copy of new name */
        Name=getstring(n,NAME);
        NameMtx = mxCreateString(Name);
        mxFree(Name);
        
        /* Check if new name already exists in workspace */
        mexCallMATLAB(1,lhs,1,&NameMtx,"exist");
        existval = mxGetScalar(lhs[0]);
        mxFreeMatrix(lhs[0]);
        if (existval == 1.0)
          { errmsg1len = strlen(errmsg1);
            errmsg2len = strlen(errmsg2);
            errmsg = mxCalloc(errmsg1len+errmsg2len+n,sizeof(char));
            strcpy(errmsg,errmsg1);
            Name=getstring(n,NameMtx);
            strcpy(errmsg+errmsg1len,Name);
            mxFree(Name);
            strcpy(errmsg+errmsg1len+n-1,errmsg2);
            mexErrMsgTxt(errmsg);
           }
        
        /* change the name */
        Name=getstring(n,NameMtx);
        mxSetName(prhs[0],Name);
        mxFree(Name);
        mxFreeMatrix(NameMtx);
        
        return;
}



