%  Rad plots the array pattern (in the H-plane) for a uniform linear
%  antenna array.  The antennas are positioned along the x-axis with a
%  spacing of 'd' wavelengths between them.  The linear phase shift from
%  antenna to antenna is eta(degrees).  Phi is the azimuthal angle and
%  A(phi) is the array pattern.  Before the program runs, it expects the
%  following variables to be loaded:
%
%       phi = 0:.007:2*pi;
%       N = Array Order
%       d = Element Spacing (unit wavelength)
%       eta = linear phase shift (degrees)

Eta = eta*pi/180;                     % Convert to radians
psi = 2*pi*d*cos(phi) + Eta;          % Pattern argument
A=abs((sin(N*psi/2)/N)./sin(psi/2));  % Array Pattern
polar(phi,A)                          % Show the result
hold;del=.1;u=-(N-1)*del/2:del:(N-1)*del/2;v=zeros(u);
title('Radiation Pattern in H-Plane')
plot(u,v,'*c6')
hold off

Cheers!

Jack Higbie
University of Queensland
Australia
