function wc = clipdata(w,lim)
%	Clips data to current axes limits.  See M-file for details.

%	When adding curves one by one to a plot, it may be desirable to
%	override the defualt behavior of redrawing the entire plot each
%	time. This is done with the line's EraseMode property.
%	Unfortunately, in no-redraw modes lines are not clipped to the
%	axes box.  This routine clips manually.  The input vector W
%	should be a vector of closely spaced complex points tracing out
%	a smooth curve.  A cluster of points outside the box is replaced
%	with NaN's, except for the first and last points of the cluster.
%	
%	By Toby Driscoll.  Last updated 1/11/94.

x = real(w);
y = imag(w);
outside = (x < lim(1)) | (x > lim(2)) | (y < lim(3)) | (y > lim(4));
dout = diff(outside);
kill = outside & [1;dout~=1] & [dout~=-1;1];
wc = w;
junk = NaN;
wc(kill) = junk(ones(size(wc(kill))));


