function fprime = rderiv(zp,z,corners,L,zs,betas)
%	Evaluates the integrand of the rectangle map.

%	By Toby Driscoll.  Last updated 7/7/94.

n = length(z);

% First compute map and derivative from rectangle to strip
K = z(corners(1));
Kp = imag(z(corners(2)));
[F,dF] = r2strip(zp,L,K,Kp);

% Now compute derivative of map from strip to polygon
dG = stderiv(F,zs,betas,corners(3)-1);

% Put it together
fprime = dF.*dG;
