function z = vaddr(x,y)
%
%  z = vaddr(x,y)
%
%  add two ROW vectors of (unequal) length,
%  shorter vector is padded with zeros on the left then added to longer
%
%  x,y = two vectors to be added
%
%  z = sum of x and y
%
lx = length(x);
ly = length(y);
x = x(:)'; y = y(:)';   % make sure x and y are row vectors
if lx == ly
          z = x + y;
elseif lx > ly
          z = x + [zeros(1,lx-ly) y];
else
          z = y + [zeros(1,ly-lx) x];
end
