function d = dprimef(uA,uB,covmat)
%d = dprimef(uA,uB,covmat)
%  computes d-prime from the population parameters.
%
%  D-prime is the standardized distance between means
%  of two distributions which are assumed to be normal.
%
%  Parameters:
%    uA is a column vector containing the population mean
%       of category A
%    uB is a column vector containing the population mean
%       of category B
%    covmat is the covariance matrix for each category

% Created by Leola A. Alfonso-Reese / 3-March-94
% Copyright (c) 1995
% $Revisions:$
%   Date           Modification and Name
%   ----           ---------------------


d = sqrt((uA - uB)'*inv(covmat)*(uA-uB));
	
