function a = asigmoid(n,b)
% ASIGMOID quickprop asymmetrical sigmoid transfer function
%
%     ASIGMOID(N,B)
%         N - SxQ Matrix of weighted input (column) vectors.
%         B - Sx1 Bias (column) vector.
%
%     ASIGMOID('delta') returns name of delta function.
%
%     Ray Byler, 24 Nov 1995, byler@cs.utk.edu.

if nargin ~= 1 & nargin ~= 2
  error('Wrong number of arguments.')
end

if isstr(n)
  if strcmp(lower(n),'delta')
    a = 'deltaasi';
  end
else
  [nr,nc] = size(n);
  n = n + b*ones(1,nc);
  a = 1 ./ (1+exp(-n));
end

