function [y,m,b] = scale(x,mx,bx)
%  [y,slope,intercept] = scale(x, mx, bx)
%
%  Ray Byler, 24 Nov 95, byler@cs.utk.edu
%
%  Linearly scales the data between .1 and .9, returns the
%  scaled data, the slope, and the intercept.
%
%  If the number of inputs is one, scale the input, and
%  return the scaled output, the slope, and the intercept.
%
%  If the number of inputs is three, use the input values
%  of slope (mx) and intercept (bx) to scale the input. 


if nargin == 1
  m = 0.8 ./ (max(x) - min(x));
  b = 0.1 - m.*min(x);
else
  m = mx;
  b = bx;
end

[nrows, ncols] = size(x);

y = (ones(nrows,1) * m).*x + ones(nrows,1)*b;


