function a = sigmoid(n,b)
% SIGMOID QuickProp symmetrical sigmoid transfer function
%
%     SIGMOID(N,B)
%         N - SxQ Matrix of weighted input (column) vectors.
%         B - Sx1 Bias (column) vector.
%
%     SIGMOID('delta') returns name of delta function.
%
%     Ray Byler, 24 Nov 1995, byler@cs.utk.edu.

if nargin ~= 1 & nargin ~= 2
  error('Wrong number of arguments.')
end

if isstr(n)
  if strcmp(lower(n),'delta')
    a = 'deltasig';
  end
else
  [nr,nc] = size(n);
  n = n + b*ones(1,nc);
  a = (1 ./ (1+exp(-n))) - 0.5;
end

