function peakfit(command,param1) 
%  peakfit.m 
%  Created: 4-Mar-94 
%  Using  : GUIMaker by Patrick Marchand 
%                         (pmarchan@motown.ge.com) 
%  Author :  Sean M. Brennan (Bren@SLAC.stanford.edu)
%  Mods.  :  5-3-94 change cursor procedure
%   

%  Copyright (c) 1994 by Patrick Marchand 
%       Permission is granted to modify and re-distribute this 
%	code in any manner as long as this notice is preserved. 
%	All standard disclaimers apply. 

global FITX FITDY FITFY FIT_LAMBDA verbose;

verbose(1)=0; verbose(2)=1;
if nargin == 0 
	command = 'init';
end 
if ~strcmp(command,'init'), 
	[ed,ck,rb]= pk_udata;
end 
if isstr(command) 
	if strcmp(command,'init') 
		dummy=pk_init;
		[ed,ck,rb]= pk_udata;
		pk_inivl(rb,ck,ed);
		h=axes('position',[0.1 0.3 .88 .65]);
		plot(FITX,FITDY,'+');
	elseif strcmp(command,'new') 
		plot(FITX,FITDY,'+');
		pk_inivl(rb,ck,ed);
	elseif strcmp(command,'fitbut') 
		FIT_LAMBDA=[]; 
		if str2num(get(ed(15),'String')) > 0,
			lam_len= 16;
		elseif str2num(get(ed(11),'String')) > 0,
			lam_len= 12;
		elseif str2num(get(ed(7),'String')) > 0,
			lam_len= 8;
		elseif str2num(get(ed(3),'String')) > 0,
			lam_len= 4;
		end
		FIT_LAMBDA=zeros(1,lam_len);
		for i=1:lam_len,
			FIT_LAMBDA(i)= str2num(get(ed(i),'String'));
		end
		lam_len=lam_len+2;
		FIT_LAMBDA(lam_len-1)= str2num(get(ed(17),'String'));
		FIT_LAMBDA(lam_len)= str2num(get(ed(18),'String'));
		constrain=pk_gtcon(ck,lam_len);
		npts=length(FITX);
		wt=ones(npts,1);
		FITFY=pk_qvt(FITX,FIT_LAMBDA);
		plot(FITX,FITDY,'+',FITX,FITFY); drawnow;
		set(gcf,'Pointer','watch');
tic;
		[FITFY,FIT_LAMBDA,kvg,iter,corp,covp,covr,stdresid,Z,r2]= ...
		leasqr(FITX,FITDY,FIT_LAMBDA,'pk_qvt',.001,50,wt,constrain ...
		,'pk_qvtdf');
toc
		set(gcf,'Pointer','arrow');
		chi2= sum(((FITDY-FITFY).*wt).^2)/(npts-lam_len);
		fprintf('Chisqr= %g\n',chi2);
%		plot(FITX,FITDY,'+',FITX,FITFY);
		total_area= trapz(FITX,FITFY);
		s= sprintf('Total area= %-8.3g',total_area);
		disp(s);
		npeaks= floor(lam_len/4);
		if npeaks > 1,
			fred= axis;
			axis([fred(1) fred(2) 0 fred(4)]);
			hold on
			col= ['c' 'r' 'g' 'b'];
			for i=1:npeaks
				base=(i-1)*4;
				lam(1:4)= FIT_LAMBDA(base+1:base+4);
				f=pk_voigt(FITX,lam);
				plot(FITX,f,col(i));
				area(i)= trapz(FITX,f);
				s= sprintf('Area of peak %-1g = %-8.3g',i,area(i));
				disp(s);
			end
			hold off
		end
		for i=1:lam_len-2,
			set(ed(i),'String',num2str(FIT_LAMBDA(i)));
		end
		set(ed(17),'String',num2str(FIT_LAMBDA(lam_len-1)));		
		set(ed(18),'String',num2str(FIT_LAMBDA(lam_len)));
	
	elseif strcmp(command,'curbut') 
		once= 0;
		[xpos,ypos,button]= ginput(1);
		gerr= pk_inbds(xpos,ypos);
		while ~gerr,
			if get(rb(1),'Value')==1
				set(ed(1),'String',num2str(xpos));
				set(ed(2),'String',num2str(ypos));
				set(rb(1),'Value',0);
				set(rb(2),'Value',1);
			elseif get(rb(2),'Value')==1
				if once,
					fred= abs(xpos-xpos1);
					set(ed(3),'String',num2str(fred));
					set(rb(2),'Value',0);
					set(rb(3),'Value',1);
					once= 0;
				else
					xpos1= xpos;
					once= 1;
				end
			elseif get(rb(3),'Value')==1
				set(ed(5),'String',num2str(xpos));
				set(ed(6),'String',num2str(ypos));
				set(rb(3),'Value',0);
				set(rb(4),'Value',1);
			elseif get(rb(4),'Value')==1
				if once,
					fred= abs(xpos-xpos1);
					set(ed(7),'String',num2str(fred));
					set(rb(4),'Value',0);
					set(rb(5),'Value',1);
					once= 0;
				else
					xpos1= xpos;
					once= 1;
				end
			elseif get(rb(5),'Value')==1
				set(ed(9),'String',num2str(xpos));
				set(ed(10),'String',num2str(ypos));
				set(rb(5),'Value',0);
				set(rb(6),'Value',1);
			elseif get(rb(6),'Value')==1
				if once,
					fred= abs(xpos-xpos1);
					set(ed(11),'String',num2str(fred));
					set(rb(6),'Value',0);
					set(rb(7),'Value',1);
					once= 0;
				else
					xpos1= xpos;
					once= 1;
				end
			elseif get(rb(7),'Value')==1
				set(ed(13),'String',num2str(xpos));
				set(ed(14),'String',num2str(ypos));
				set(rb(7),'Value',0);
				set(rb(8),'Value',1);
			elseif get(rb(8),'Value')==1
				if once,
					fred= abs(xpos-xpos1);
					set(ed(15),'String',num2str(fred));
					set(rb(8),'Value',0);
					set(rb(9),'Value',1);
					once= 0;
				else
					xpos1= xpos;
					once= 1;
				end
			elseif get(rb(9),'Value')==1
				set(ed(17),'String',num2str(ypos));
				set(ck(17),'Value',0);
				set(rb(9),'Value',0);
				set(rb(10),'Value',1);
			elseif get(rb(10),'Value')==1
				fred=str2num(get(ed(17),'string'));
				mort= (FITX(length(FITX))-FITX(1));
				slope= (ypos-fred)/mort;
				set(ed(18),'String',num2str(slope));
				set(ck(18),'Value',0);
			end
			[xpos,ypos,button]= ginput(1);
			gerr= pk_inbds(xpos,ypos);
		end
	elseif strcmp(command,'rb(1)')
		pk_setrb(rb,1);
	elseif strcmp(command,'rb(2)') 
		pk_setrb(rb,2);
	elseif strcmp(command,'rb(3)') 
		pk_setrb(rb,3);
	elseif strcmp(command,'rb(4)') 
		pk_setrb(rb,4);
	elseif strcmp(command,'rb(5)') 
		pk_setrb(rb,5);
	elseif strcmp(command,'rb(6)') 
		pk_setrb(rb,6);
	elseif strcmp(command,'rb(7)') 
		pk_setrb(rb,7);
	elseif strcmp(command,'rb(8)') 
		pk_setrb(rb,8);
	elseif strcmp(command,'rb(9)') 
		pk_setrb(rb,9);
	elseif strcmp(command,'rb(10)') 
		pk_setrb(rb,10);
	end 
end
