%BASELINE Baseline correction and offset correction
%
%Syntax NDATA = baseline(DATA, [POINTS[ ,VSCALE[, POS]]])
%
%Input	DATA	Datenvektor
%	POINTS	Anzahl der darzustellenden Punkte
%	VSCALE  Vertikaler Skalierungfaktor (0<VSCALE<100)
%	POS	Anfangsposition des darzustellenden Bereichs
%
%Output	NDATA	Vektor mit den korrigierten Daten
%
%Usage: Ranges without channel openings are marked with cursors
%	Jumps in baseline which occur at the edges of marked ranges
%	are corrected finally by choosing 'OK'
%
%	(c) A.K. 11.3.1995

function ndata=baseline(data, points, vscale, pos)

global G1 G2 G3 G4
if nargin<2, points=round(length(data)/8); end
if nargin<3, vscale=1; end
if nargin<4, pos=1; end

uibasel('init', data, points, vscale, pos);
t=input('Please press RETURN when finished ! ');
ndata=G1;
