%BURSTLST	Burst analysis of an eventlist for single
%		channel data
%
%Syntax		LST = burstlst(EVLST, TC[, MODE])
%
%Input	EVLST	List of events from eventlst or csim
%	TC	Critical time for short events belonging to
%		a burst
%	MODE    =1 adding short closures to open event  [1]
%		=2 adding short closures to closed event
%
%Output	LST	Eventlist of the form [time level current] where
%		short events of evlst are pooled
%
%Remark		Multiple Channels cannot be analyzed
%
%	(c) A.K. 15.Juni 1997

function lst=burstlst(evlst, tc, mode)

lst=evlst;
if mode==1
   h=find(evlst(:,1)<=tc & evlst(:,2)==0);
else
   h=find(evlst(:,1)<=tc & evlst(:,2)==1);
end %if

for i=1:length(h)
    lst(h(i)-1,1)=lst(h(i)-1,1)+lst(h(i),1);
end %for i
lst(h,:)=[];


% Fusing adjacent events of the same level

h=zeros(size(lst));
h(1,:)=lst(1,:);
n=1;
for i=2:length(lst(:,1))
    if h(n, 2)~=lst(i,2)
       n=n+1;
       h(n,:)=lst(i,:);
    else
       h(n,1)=h(n,1)+lst(i,1);
    end %if
end %for i
lst=h(1:n,:);

