%CORRBL1 Automatic correction of baseline
%
%Syntax	nd = corrbl1(DATA, THRESHOLD[, BASELINE[, LEN]])
%
%Input	DATA
%	THRESHOLD	Threshold for detection of 'not baseline'
%	BASELINE	New value for baseline [0]
%	LEN		Length for calculation of baseline [20]
%
%Output	ND              Data with corrected baseline
%
%Remark	corrbl2 is better and faster
%
%	(c) A.K. 28.8.1995

function nd=corrbl1(data, threshold, baseline, len)

if nargin<3, baseline=0;
if nargin<4, len=20;

l=length(data);
nd=gfilt(data,3);

% Finde Basislinienbereiche

mark=1; pos=zeros(1,100);
h=(nd>threshold); z=0;
blalt=mean(nd(1:len));
for i=1:l
    if h(i)==0
       z=z+1;
       if z>=len+4
          pos(mark)=i-len-2; pos(mark+1)=i-2; mark=mark+2;
          bl=mean(nd(i-(len+2):i-2));
          threshold=threshold+(bl-blalt);
          blalt=bl; z=0;
	  h=(nd>threshold);
       end %if
    else
       z=0;
    end %if
end %for i
mark=mark-1;

% Berechne korrigierte Basislinie in yi

for i=1:2:mark
    h2=pos(i):pos(i+1);
    h1=nd(h2);
    p1=[p1; polyfit(h2, h1, 2)];
    h=[h h1]; x=[x h2];
end %for  
for i=1:2:mark-3
    p2=[p2; polyfit([pos(i):pos(i+1) pos(i+2):pos(i+3)], [nd(pos(i):pos(i+1)) nd(pos(i+2):pos(i+3))], 2)];
end %for
pos(mark+1)=0; p2(mark/2,:)=[0 0 0];
for i=2:2:mark
    yi=[yi polyval(p1(i/2,:), pos(i-1):pos(i)) polyval(p2(i/2,:), pos(i):pos(i+1))];
end %for
% Extrapolation am Anfang und Ende
h=length(yi);
p2=polyfit((h-.1*h):h, yi((h-.1*h):h), 4);
yi=[polyval(p1(1,:), 1:pos(1)-1) yi polyval(p2, pos(mark)+1:length(nd))]; 
yi=rmpeaks(yi(1:length(nd)));
nd=data-(yi-baseline);
