%CORRBL2 Automatic correction of baseline
%
%Syntax	nd = corrbl1(DATA, THRESHOLD[, BASELINE[, LEN]])
%
%Input	DATA
%	THRESHOLD	Threshold for detection of 'not baseline'
%	BASELINE	New value for baseline [0]
%	LEN		Length for calculation of baseline [20]
%
%Output	ND              Data with corrected baseline
%
%	(c) A.K. 28.8.1995

function nd=corrbl2(data, threshold, baseline, len)

if nargin<3, baseline=0;end
if nargin<4, len=20;end

l=length(data);
nd=gfilt(data,3);
basel=zeros(size(data));

% Finde Basislinienbereiche und korrigiere Daten

h=(nd>threshold); z=0;
blalt=mean(nd(1:len)); basel(1:len)=ones(1,len)*blalt; alt=len;
for i=len+1:l
    if h(i)==0
       z=z+1;
       if z>=len+4
          h2=i-(len+2);
          bl=mean(nd(h2:i-2));
          threshold=threshold+(bl-blalt);
	  basel(alt+1:h2)=(bl-blalt)/(h2-(alt+1))*(0:(h2-alt-1)) + blalt;
          basel(h2+1:l)=ones(1,(l-h2))*bl;
          blalt=bl; alt=i; z=0;
	  h=(nd>threshold);
       end %if
    else
       z=0;
    end %if
end %for i
basel=gfilt(basel,10);
nd=data-(basel-baseline);

