%CUT    Deletion of data-ranges
%
%Syntax	NDATA = cut(DATA[, FACTOR[, POINTS[ ,VSCALE[, POS]]]])
%
%Input	DATA	
%	FACTOR	Data display with number of data points reduced by 1/FACTOR
%	POINTS	Number of points to show
%	VSCALE  Vertical scale factor
%	POS	Starting position
%
%Output	NDATA	Vector withot the marked data ranges
%
%Remark If the number of marks is odd all data up to the first mark
%	is selected and the other data as usual.
%
%	(c) A.K. 11.3.1995

function ndata=cut(data, factor, points, vscale, pos)

global G1 G2 G3 G4
if nargin<3, points=round(length(data)/factor/8); end
if nargin<4, vscale=1; end
if nargin<5, pos=1; end

uiselect('init', data(1:factor:length(data)), points, vscale, pos);
t=input('Please press RETURN when finished ! ');

% G3=MARK, G4=POS

   G4=G4*factor;
if G3>0, 
   G4(G3+1)=length(data);
   if rem(G3,2)>0
      s=1;
   else
      s=2; h=data(1:G4(1));
   end %if
   for i=s:2:G3
       h=[h data(G4(i):G4(i+1))];
   end %for
   data=h;
end %if

ndata=data;
