%DIFDIS distribution of open or closed times from eventlists
%
%Syntax [y x] = difdis(Z, LEVEL[, BINW[, MODE]])
%
%Input	Z	eventlist or Z-Matrix
%	LEVEL	(set to 0.5 for eventlst) 
%	BINW	Bin width [1]
%
%Output	y	Number of events with opentime(closedtime) around x
%	x	time axis-vector set to the mean of the interval
%
%	(c) A.K. 21.7.1995

function [y, x]=difdis(z, level, binw, mode)

if nargin<3, binw=1; end

y = z(z(:,2)==level, 1);
end %if
x=(0:binw:max(y))+(binw/2);
[y x] = hist(y, x);

if nargout==0, bar(x,y); end;

