%GSFILT Digital Gaussian filter
%
%Syntax	nd = gsfilt(D, FC[, DT])
%
%Input	D	Data (row vector)
%	FC	-3 DB cutoff frequency in Hz
%	dt	sampling interval in sec [1]
%
%Output	nd	filtererd data
%
%	(c) A.K. 27.7.1996

function nd=gsfilt(d, fc, dt)

fc=fc.*dt;
sigma=(0.132505/fc);
n=round(5*sigma);

if sigma>0.63,
   ak=exp(-(.5*(1:n).^2/(sigma*sigma)));
   ak=[fliplr(ak) 1 ak];
   ak=ak/sum(ak);
else
   n=1; ak=zeros(1,3);
   ak(1)=sigma^2/2; ak(2)=1-2*ak(1); ak(3)=ak(1);
end

h=length(d);
nd=filter(ak, 1, d);
nd=[nd nd(1:n)]; nd(1:n)=[];
