function ll=likeexp(x, n, tmin, tmax)

%LIKEEXP Calculating the log-likelihood assuming a probability density 
%	 function of n exponentials
%	 XDATA contains the open or closed times
%
%	(c) A.K. 6.8.1996

global XDATA

if n==1, 
   numerator=1/x(1)*exp(-XDATA./x(1));
   denominator=exp(-tmin/x(1))-exp(-tmax/x(1));
elseif n==2,
   numerator=x(2)/x(1)*exp(-XDATA./x(1))+(1-x(2))/x(3)*exp(-XDATA./x(3));
   denominator=x(2)*(exp(-tmin/x(1))-exp(-tmax/x(1)))+(1-x(2))*(exp(-tmin/x(3))-exp(-tmax/x(3)));
elseif n==3,
   numerator=x(2)/x(1)*exp(-XDATA./x(1))+x(4)/x(3)*exp(-XDATA./x(3))+(1-x(2)-x(4))/x(5)*exp(-XDATA./x(5));
   denominator=x(2)*(exp(-tmin/x(1))-exp(-tmax/x(1)))+x(4)*(exp(-tmin/x(3))-exp(-tmax/x(3)))+(1-x(2)-x(4))*(exp(-tmin/x(5))-exp(-tmax/x(5)));
elseif n==4,
   numerator=x(2)/x(1)*exp(-XDATA./x(1))+x(4)/x(3)*exp(-XDATA./x(3))+x(6)/x(5)*exp(-XDATA./x(5))+(1-x(2)-x(4)-x(6))/x(7)*exp(-XDATA./x(7));
   denominator=x(2)*(exp(-tmin/x(1))-exp(-tmax/x(1)))+x(4)*(exp(-tmin/x(3))-exp(-tmax/x(3)))+x(6)*(exp(-tmin/x(5))-exp(-tmax/x(5)))+(1-x(2)-x(4)-x(6))*(exp(-tmin/x(78))-exp(-tmax/x(7)));
elseif n==5,
   numerator=x(2)/x(1)*exp(-XDATA./x(1))+x(4)/x(3)*exp(-XDATA./x(3))+x(6)/x(5)*exp(-XDATA./x(5))+x(8)/x(7)*exp(-XDATA./x(7))+(1-x(2)-x(4)-x(6)-x(8))/x(9)*exp(-XDATA./x(9));
   denominator=x(2)*(exp(-tmin/x(1))-exp(-tmax/x(1)))+x(4)*(exp(-tmin/x(3))-exp(-tmax/x(3)))+x(6)*(exp(-tmin/x(5))-exp(-tmax/x(5)))+x(8)*(exp(-tmin/x(7))-exp(-tmax/x(7)))+(1-x(2)-x(4)-x(6)-x(8))*(exp(-tmin/x(9))-exp(-tmax/x(9)));
end %if
if tmin>=tmax, denominator=1; end
ll=-sum(log(numerator./denominator));
