%RMPEAKS Remove peaks from data
%
%Syntax	ND = rmpeaks(Y)
%
%Usage	Removal of peaks and sharp jumps in Y
%	
%Remark	Peaks are defined by the differnce between to successive data points. If
%	the difference diveded by 1/length(Y) is higher than 200 a peak is assumed.
%	These range will be cut and the rest of points will be interpolated by spline
%	(every 100th point are used for spline).
%	These two parameters 200 and 100 influences the output of rmpeaks and can
%	be modified in the program.
%	rmpeaks is used by baseline.
%
%	(c) A.K. 13.Mai 1995

function nd=rmpeaks(y)

n=length(y);

% Parameter <200
h=[abs(diff(y))./(1/n)<200 1];
x=1:n;
y=y(h); x=x(h);

% Parameter 100, d.h. jeden 100. Datenpunkt
y=y(1:100:length(y)); x=x(1:100:length(x));

nd=spline(x, y, 1:n);


