%SELECT Selection of data-ranges
%
%Syntax	NDATA = select(DATA, [FACTOR[, POINTS[ ,VSCALE[, POS]]]])
%
%Input	DATA	
%	FACTOR	Reduce DATA by 1/FACTOR for display only
%	POINTS	Number of data points to display in window
%	VSCALE  Vertical scale factor (0<VSCALE<100)
%	POS	Starting position of window
%
%Output	NDATA	Vector containing the selected ranges
%
%Remark	If the number of markers is odd the data point number one serves as
%	the 'first' marker. That means all data points from the beginning to
%	the first cursor are selected.
%
%	(c) A.K. 11.3.1995

function ndata=select(data, factor, points, vscale, pos)

global G1 G2 G3 G4
if nargin<2, factor=1; end
if nargin<3, points=round(length(data)/factor/8); end
if nargin<4, vscale=1; end
if nargin<5, pos=1; end

uiselect('init', data(1:factor:length(data)), points, vscale, pos);
t=input('Please press RETURN when finished ! ');

   G4=G4*factor;
   s=1;
   if G3>0, 
     if rem(G3,2)>0, h=data(1:G4(1)); s=2; end
     for i=s:2:G3
         h=[h data(G4(i):G4(i+1))];
     end %for
     data=h;
   end %if

ndata=data;
