function show(d1, d2, points, mode, dt, vscale)
%SHOW Display of data records, horizontally aligned
%
%Syntax	SHOW(d1[, d2[, points[, mode, [dt[, vscale]]]]])
%
%Input	D1	data vector 1
%	D2	data vector 2			 []
%	POINTS	Anzahl darzustellender Punkte 	 [1000]
%	MODE    =1 upward  =-1 downward openings [1]
%	dt	sampling interval		 [0.00025]
%	vscale	length of vertical scale bar	 [auto]
%
%	(c) A.K. 9.4.1996
%	last modification 22.10.1996

m=max(d1)-min(d1);
m=m+.1*m; % Addiere 10%
if nargin==5 & size(d2)==[1 1]
   vscale=dt; dt=mode; mode=points; points=d2; d2=[]; m=vscale*2.5;
elseif nargin==4 & size(d2)==[1 1]
   dt=mode; mode=points; points=d2; d2=[];
elseif nargin==3 & size(d2)==[1 1]
   mode=points; points=d2; dt=0.00025; d2=[];
elseif nargin==2 & size(d2)==[1 1]
   points=d2; mode=1; dt=0.00025; d2=[];
elseif nargin==1
   mode=1; points=1000; dt=0.00025;
elseif nargin==2
   points=1000; mode=1; dt=0.00025
elseif nargin==3
   mode=1; dt=0.00025;
elseif nargin==4
   dt=0.00025
elseif nargin==5
   vscale=1;
elseif nargin==6
   m=vscale*2.5;
end %if

l=length(d1);
traces=round(l/points);
fontsize=round(-.15*traces+8.15);
if fontsize<=4, fontsize=4; end
tlabeldisplacement=.5;

starthl=points+points*.025; endhl=starthl+points*.1;
tlabel=[num2str((endhl-starthl)*dt*1000) ' ms'];
curr=round(m/2.5);
currlabel=[num2str(curr) ' pA'];

k=0;flagg=0;
while k<=traces,
      h=(k+1)*points;
      if h>l, h=l;end;
      plot(d1(k*points+1:h)-k*m); hold on;
      if d2~=[], plot(d2(k*points+1:h)-k*m, 'g'); end 
      if k*points+1<=l
         line([starthl endhl endhl], [-k*m -k*m -k*m+curr*mode], 'Color', 'w');
         text(starthl, -k*m-(tlabeldisplacement*curr)*mode, tlabel, 'Fontsize', fontsize);
         text(endhl+(endhl-starthl)*.15, -k*m+mode, currlabel, 'Fontsize', fontsize);
      end %if
      k=k+1;
end %while
set(gca, 'XLim', [0 endhl+(endhl-starthl)], 'YTick', []);hold off;

