function [fdata, freq] = ft(data, sampl)
%FT	Fourier-Transformation of real-valued data
%
%Syntax	[FREQ FDATA] = ft(DATA[, SAMPL])
%
%Input	DATA
%	SAMPL	Sampling interval
%
%Output	FDATA	Vector of fft'ed-data
%	FREQ	Frequencies if SAMPL was given
%
%	(c) A.K. 16.7.1994

n = length(data);
fdata=fft(data);
fdata(n/2+2:n)=[];

if nargin==2, freq=freqaxis(n, sampl); end
