function data = ift(fdata, window)
%IFT	Calculates the inverse Fourier-Transformation of the 
%	data obtained with ft
%
%Syntax	DATA = ift(FDATA[, 'WINDOW'])
%
%Input	FDATA	Datenvektor, i.A. komplex
%	WINDOW	Fensterfunktion [Reckteck]
%
%Output	DATA	Vector of IFFT'd data
%
%Remark If fdata=ft(window(d),1024) specify the window-function for back
%	transformation
%
%	(c) A.K. 16.7.1994

n = length(fdata);
fdata = [fdata; conj(fdata(n-1:-1:2))];
data = real(ifft(fdata));

if nargin>1,
   h=[window '(ones(size(data)))'];
   data = data ./ eval(h);
end %if
