function wdata = wkaiser(data, b)
%WKAISER Weightens DATA with a Kaiser-window
%
%Syntax DATA = wkaiser(DATA[, B])
%
%Input	DATA
%	B	Controls the heigth of the highest side lobe. As higher
%		b as smaller is the side lobe.
%
%Output	WDATA	Vernderter Vektor
%
%	 (c) A.K. 16.7.1994

if nargin<2, b=5; end
l1 = length(data)-1;
bh1 = besselj(0, b); vh=(1:l1+1)';
bh2 = besselj(0, 2*b*sqrt(vh/l1-(vh/l1).^2) ); 
wdata = data .* (bh2./bh1);
