%^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
%                          aorb program                               *
%             compute the orbit transformation matrix                 *
%                    from the  orbit parameters                       *
%                                                                     *
%     don mackison                                                    *
%     university of colorado                                          *
%     2207 holyoke drive                                              *
%     boulder, co 80303                                               *
%     (303) 939-5880                                                  *
%     (303) 499-0883                                                  *
%                                                                     *
%                                                                     *
%          input:                                                     *
%                                                                     *
%          output:                                                    *
%                                                                     *
%          files called:                                              *
%                                                                     *
%          math routines required:                                    *
%                                                                     *
%          [torbit] = aorb(om,wp,f,fin)                               *
%                                                                     *
%                                                                     *
%^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

function [torbit] = aorb(om,wp,f,fin)

     torbit = zeros(3,3);
     t1     = zeros(3,3);
     t2     = zeros(3,3);
     t3     = zeros(3,3);

     t1 = [ cos(wp+f)    sin(wp+f)     0
           -sin(wp+f)    cos(wp+f)     0
            0            0             1 ];

     t2 = [ 1            0             0
            0            cos(fin)      sin(fin)
            0           -sin(fin)      cos(fin) ];

     t3 = [ cos(om)      sin(om)       0
           -sin(om)      cos(om)       0
            0            0             1 ];

     dum = t1*t2;
     torbit = dum*t3;

%========================================================================





