%^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
%                           gauss.m                                   *
%          given the eccentric anomaly and eccentricity ,             *
%          solve for the true anomaly                                 *
%                                                                     *
%     don mackison                                                    *
%     university of colorado                                          *
%     2207 holyoke drive                                              *
%     boulder, co 80303                                               *
%     (303) 939-5880                                                  *
%     (303) 499-0883                                                  *
%                                                                     *
%                                                                     *
%                                                                     *
%          input: e=eccentric anomaly,ee=eccentricity                 *
%                                                                     *
%          output: f, true anomaly                                    *
%                                                                     *
%          files called:                                              *
%                                                                     *
%          math routines required:                                    *
%                                                                     *
%          [f] = gauss(e,ee)                                          *
%                                                                     *
%                                                                     *
%^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

function [f] = gauss(e,ee)

       x1 = tan(e/2.);
       x2 = sqrt( (1.+ee)/(1.-ee) ) * x1;
       f = 2.*atan(x2);
       if f< 0
           f = f + 2.*pi;
       else
       end

%======================================================================



