%^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
%                         kepler program                              *
%          solve kepler's equation for the eccentric anomaly          *
%                                                                     *
%          don mackison                                               *
%          university of colorado                                     *
%          2207 holyoke drive                                         *
%          boulder, co 80303                                          *
%          (303) 939-0883                                             *
%          (303) 499-0883                                             *
%                                                                     *
%                                                                     *
%          input:m,ee                                                 *
%                                                                     *
%          output: e                                                  *
%                                                                     *
%          files called:                                              *
%                                                                     *
%          math routines required:                                    *
%                                                                     *
%          [e] = kepler(m,ee)                                         *
%                                                                     *
%                                                                     *
%^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

function [e] = kepler(m,ee)

%     evaluate e0
      e = m + ee*sin(m);
%      e = modf(e,2*pi)

%     start iteration on kepler's equation
      de=10.;
      while de>0.00001
%          evaluate pme
           pme = 1 - ee*cos(e);

%          compute de
           m0 = e - ee*sin(e);
           de = (m-m0)/pme;

%          compute  e
           e = e + de;

%          check convergence
      end

      if e>=0
           while e > 2.*pi;
                e = e-2*pi;
           end
      elseif e<0
           while abs(e) > 2.*pi
                e=e+2.*pi;
           end
      end


%=============================================================================







