function rochkinp(Elements, Rays, Wvl);
%ROCHKINP test entries in input matrices
%
%           rochkinp(Elements, Rays, Wvl);
%
%

% Version 0.4  February 1996
% Part of the RayOptik toolbox
% Copyright 1996 by Georg Beyerle. All rights reserved.
% beyerle@tmf.jpl.nasa.gov

  MFile = [upper(mfilename) ': '];

  [RRow,RCol] = size(Rays);

  if RRow ~= 6,
    error([MFile 'Matrix Rays not a 6xM matrix (' int2str(RRow) 'x' int2str(RCol) ')']);
  end

  if RCol < 1,
    error([MFile '# no rays defined!'])
  end

  [WRow,WCol] = size(Wvl);

  if WCol ~= RCol,
    error([MFile '# rays (' int2str(RCol) ') ~= # wavelengths (' int2str(WCol) ')!'])
  end

  [ERow,ECol] = size(Elements);

  ColReq = 63;

  if ECol == ColReq-8,
    error([MFile 'dimension of element matrix has changed since version 0.3 - check documentation' ...
           ' (' int2str(ECol) ' ~= ' int2str(ColReq) ')']);
  end

  if ECol ~= ColReq,
    error([MFile 'element matrix has less/more than ' ...
            int2str(ColReq) ' columns (' int2str(ECol) '~=' int2str(ColReq) ') - check documentation']);
  end

%
%  check element entries
%
  for i = 1:ERow,

    if ~isnan(Elements(i,11)) & Elements(i,11) <= 0,
      error([MFile 'distance between elements ' int2str(i-1) ...
          ' and ' int2str(i) ' <= 0'])
    end

    if Elements(i,1:2) == 'le' | Elements(i,1:2) == 'mi' | ...
       Elements(i,1:2) == 'ap',

      if isnan(Elements(i,19))
        error([MFile 'inner radius NaN (element # ' int2str(i) ')']);
      end

      if isnan(Elements(i,20))
        error([MFile 'outer radius NaN (element # ' int2str(i) ')']);
      end

    end

    if Elements(i,1:2) == 'le' | Elements(i,1:2) == 'pr',
      if Elements(i,19) > 0,
        error([MFile 'lenses/prisms may not have holes (element # ' int2str(i) ')']);
      end
    end

    if ~isnan(Elements(i,15)) & (Elements(i,15) > 90 | Elements(i,15) < -90) 
      error([MFile 'tilt angle > 90 or < -90 not allowed (' int2str(Elements(i,15)) ')']);
    end

  end

end

