function [Center, Normal] = roctrnrm(Center,Normal,Pt,Dir,Dist,Angle)
%ROCTRNRM calculate center and normal vector of optical element
%
%           [Center, Normal] = roctrnrm(Center,Normal,Pt,Dir,Dist,Angle)
%

% Version 0.4  February 1996
% Part of the RayOptik toolbox
% Copyright 1996 by Georg Beyerle.  All rights reserved.
% beyerle@tmf.jpl.nasa.gov

  if max(~finite(Center))
    Center = Pt(:,1) + Dist * Dir(:,1);
  end

  if max(~finite(Normal))
    Normal(1)   = cos(Angle) * Dir(1,1) - sin(Angle) * Dir(2,1);
    Normal(2)   = sin(Angle) * Dir(1,1) + cos(Angle) * Dir(2,1);
    Normal(3)   = Dir(3,1);
    Normal      = -Normal;
  end

end
