function [Key,CmdStr] = rodspspt(SpotUV,Center,NofRay,NofElem,Units,CmdStr);
%RODSPSPT plot spot diagram
%
%           [Key,CmdStr] = rodspspt(SpotUV,Center,NofRay,NofElem,Units,CmdStr)
%

% Version 0.4  February 1996
% Part of the RayOptik toolbox
% Copyright 1996 by Georg Beyerle. All rights reserved.
% beyerle@tmf.jpl.nasa.gov
  
  MFile = [upper(mfilename) ': '];

  i = 0;
  Idx = (1:NofRay);

%
%  loop thru all virtual screens
%
  while 1,

    disp([MFile 'virtual screen at position (' ...
          sprintf('%g,%g,%g ',Center(:,i+1)) Units ')']);

    clg

    h = plot(SpotUV(1,Idx),SpotUV(2,Idx),'.');
    set(h,'markersize',10);

    title('RayOptik');

    xlabel(Units);
    ylabel(Units);

    drawnow

    i   = i + 1;
    Idx = Idx + NofRay;

    if i >= NofElem
      i   = 0;
      Idx = (1:NofRay);
    end

%
% ask for new command
%
    CmdStr(1) = [];
    if length(CmdStr) < 1,
      CmdStr = input('RO > ','s');
      if length(CmdStr) < 1,
        CmdStr = 'm';
      end
    end

    Key = CmdStr(1);

    if Key ~= 'm'
      return;
    end

  end

end
