function [Elem, Rays, Wvl, Units] = roexpl05
%ROEXPL05 Example input file for RayOptik
%
%         prism
%

% Version 0.4  February 1996
% Part of the RayOptik toolbox
% Copyright 1996 by Georg Beyerle. All rights reserved.
% beyerle@tmf.jpl.nasa.gov

%
%  units : mm
%
  Units = 'mm';

%
%  rays (start points & directions)
%
  M    = 11;
  Pt   = [0;0;0] * ones(1,M);

  LenPt = length(Pt(1,:));
  Dir   = [1;0;0] * ones(1,LenPt);

%
%  wavelength in m
%
  Wvl = (1:1/LenPt:2) * 400e-9;

%
%  element description
%
  Elem = [...
          'screen    ', ...
          1,[NaN,NaN,NaN],0,[NaN,NaN,NaN], ...
          NaN,NaN,NaN, ...
          NaN,[NaN,NaN,NaN],NaN,[NaN,NaN,NaN], ...
          '          ', ...
          '          ',[NaN,NaN], ...
          '          ',[NaN,NaN]; ...
%
          'prism     ', ...
          100,[NaN,NaN,NaN],0,[NaN,NaN,NaN], ...
          0,25,22, ...
          -22.5,[NaN,NaN,NaN],22.5,[NaN,NaN,NaN], ...
          'bk7       ', ...
          'spherical ',[50,NaN], ...
          'spherical ',[50,NaN]; ...
%
          'screen    ', ...
          100,[NaN,NaN,NaN],0,[NaN,NaN,NaN], ...
          NaN,NaN,NaN, ...
          NaN,[NaN,NaN,NaN],NaN,[NaN,NaN,NaN], ...
          '          ', ...
          '          ',[NaN,NaN], ...
          '          ',[NaN,NaN]; ...
];

%
%  optical axis
%
  OAPt  = [0,0,0];
  OADir = [1,0,0];

  Rays  = [OAPt(:) Pt; OADir(:) Dir];

end



