function Dsp = roheight(Rad,Par)
%ROHEIGHT calculate 'height' of surface 
%
%           Dsp = roheight(Rad,Par)
%
%         Solve equation
%
%           r^2 + Par(1)*z^2 + Par(2)*z + Par(3) = 0
%
%         for z
%

% Version 0.4  February 1996
% Part of the RayOptik toolbox
% Copyright 1996 by Georg Beyerle. All rights reserved.
% beyerle@tmf.jpl.nasa.gov

  if (Par(1) ~= 0),

    SqrtArg = (Par(2)^2-4*Par(1)*Par(3))/4/Par(1)^2 - ...
           Rad.^2/Par(1);

    Idx = find(SqrtArg < 0);
    SqrtArg(Idx) = Idx * NaN;

    Dsp = -Par(2)/2/Par(1) + sqrt(SqrtArg) * sign(Par(2)*Par(1));

  elseif (Par(2) ~= 0),

    Dsp = -Par(3)/Par(2) - Rad.^2/Par(2);

  else
  
    Dsp = Rad * 0;

  end

end

