function Norm = roplnnrm(ObjNorm,Angle,PlnNorm)
%ROPLNNRM calculate normal vector of plane surface
%
%           PlnNorm = roplnnrm(ObjNorm,Angle,PlnNorm)
%

% Version 0.4  February 1996
% Part of the RayOptik toolbox
% Copyright 1996 by Georg Beyerle. All rights reserved.
% beyerle@tmf.jpl.nasa.gov

  Norm = ObjNorm;
  
  if max(~finite(PlnNorm))
    Norm(1)   = cos(Angle) * ObjNorm(1,1) - sin(Angle) * ObjNorm(2,1);
    Norm(2)   = sin(Angle) * ObjNorm(1,1) + cos(Angle) * ObjNorm(2,1);
    Norm(3)   = ObjNorm(3,1);
  else
    Norm = PlnNorm;
  end

end
