function [OutPt,OutDir,Center,Normal,ElemPoints] = roscreen(InPt,InDir, ...
                                                            Center,Normal)
%ROSCREEN  virtual screen
%
%          [OutPt,OutDir,ElemPoints] = roscreen(InPt,InDir,Center, ...
%                                               Dist,Normal,Angle)
%
%          Virtual screen object doesn't change direction of rays.
%          Defines positions where spot diagrams are calculated.
%
%          InPt    : last intersection of incomimg rays
%          InDir   : direction of incoming rays
%          Center  : intersection of screen with optical axis
%          Normal  : normal vector of screen
%

% Version 0.4  February 1996
% Part of the RayOptik toolbox
% Copyright 1996 by Georg Beyerle. All rights reserved.
% beyerle@tmf.jpl.nasa.gov

  OutPt  = InPt;
  OutDir = InDir;

  [OutPt,Tmp,Hit,Fct] = rosrfrfl(InPt,InDir,Center,Normal,[0,Inf],[0,0,0]);

  OutPt(:,1)  = Center;
  OutDir      = InDir;

end
