function OutPar = rosetpar(SurfType,Par)
%ROSETPAR  calculate surface parameters
%
%

% Version 0.4  February 1996
% Part of the RayOptik toolbox
% Copyright 1996 by Georg Beyerle. All rights reserved.
% beyerle@tmf.jpl.nasa.gov

  if SurfType(1:3) == 'pla',
%
% plane
%
    OutPar = [0, 0, 0];
  elseif SurfType(1:3) == 'sph',
%
% spherical
%
    OutPar = [ 1, 2*Par(1), 0];
  elseif SurfType(1:3) == 'par',
%
% parabolic
%
    OutPar = [ 0, 4*Par(1), 0];
  elseif SurfType(1:3) == 'hyp',
%
% hyperbolic
%
    OutPar = [ -tan(Par(2)*pi/360)^2, 4*Par(1), 0];
  elseif SurfType(1:3) == 'ell',
%
% elliptical
%
    OutPar = [ Par(2)^2, 4*Par(1), 0];
  else
    error([upper(mfilename) ': unknown surface type >' setstr(SurfType) '<']);
  end

end

