function SpotUV = rosptscr(Center,Normal,Pt,Len)
%ROSPTSCR calculate spot positions on virtual screens
%
%           SpotUV = rosptscr(Center,Normal,Pt,Len)
%  

% Version 0.4  February 1996
% Part of the RayOptik toolbox
% Copyright 1996 by Georg Beyerle.  All rights reserved.
% beyerle@tmf.jpl.nasa.gov

  One = ones(1,Len);

  PtMinCtr = Pt - Center * One;

  Idx = (Normal(1,:) == 0);

%
% create unit vectors perpendicular to Normal and to each other
%
  Tmp = [Idx; ~Idx; Idx*0];
  UnitVecV = cross(Tmp,Normal);
  UnitVecU = cross(UnitVecV,Normal);

  SpotU = UnitVecU' * PtMinCtr;
  SpotV = UnitVecV' * PtMinCtr;

  SpotUV = [SpotU;SpotV];

end
