function pix = opBitsToPix(ch, bits, bright, contr, box)
% pix = opBitsToPix(ch, bits, bright, contr)
% Convert spectrogram values from log-scaled numbers to grayscale values.
% Color in the selection, if any.
% Also flipud because MATLAB displays images with index 0 at the top.

global opColorDepth opColor

opColorMap(ch, bright, contr, 'setlimits');
[lolim, hilim, n] = opColorMap(ch, 'getlim');
if (~opColorMap(ch, bright, contr)), error('Internal colormap error.'); end

mul = (n-1) / (hilim - lolim);
pix = min(n, max(1, round((bits + (1/mul - lolim)) * mul)));
%pix = (bits - lolim) / (hilim - lolim);
%pix = round(min(max(pix, 0), 1) * (n - 1)) + 1;

box = [max(box(1),1)  max(box(2),1) ...
       min(box(3),nCols(pix))  min(box(4),nRows(pix))];
if (box(1) <= box(3) & box(2) <= box(4))
  % do the selection
  pix(box(2):box(4), box(1):box(3)) = pix(box(2):box(4), box(1):box(3)) + n;
end
