function z = opCacheData(ch, cmd, x, y)
% opCacheData: Perform various functions on the cache for a given channel.
% Each of these functions operates on the cache for the given channel ch.
% Here is the only place where the opCacheData<n> arrays and 
% opCacheIndex<n> arrays are accessed.
%
% opCacheData(ch, 'clear')
% Clear the cache and index, i.e. do    cache = [];  index = [];
% 
% nCols = opCacheData(ch, 'ncols')
% Return the number of columns in the cache, i.e. nCols(cache)
%
% opCacheData(ch, 'append', cols)
% Append cols to the end of the cache, i.e. do    cache = [cache, cols]   .
%
% opCacheData(ch, 'sub', rows, cols)
% Return the values at the given subscripts, i.e. cache(rows,cols)
%
% opCacheData(ch, 'setcols', colIndex)
% Set the cache to the subscript of it given by colIndex, i.e. do
% cache = cache(:, colIndex)
%
% index = opCacheData(ch, 'iget')
% Return the index for the cache.  Usually opCacheIndex is set to this.
%
% opCacheData(ch, 'iset', index)
% Set the index for the cache.


global opCacheData1  opCacheData2  opCacheData3  opCacheData4
global opCacheData5  opCacheData6  opCacheData7  opCacheData8
global opCacheIndex1 opCacheIndex2 opCacheIndex3 opCacheIndex4
global opCacheIndex5 opCacheIndex6 opCacheIndex7 opCacheIndex8

nm = ['opCacheData', num2str(ch)];
if (strcmp(cmd, 'clear'))
  eval([nm, '=[];  opCacheIndex', num2str(ch), '=[];']);

elseif (strcmp(cmd, 'ncols'))
  eval(['z=nCols(', nm, ');']);

elseif (strcmp(cmd, 'append'))
  eval([nm, '=[', nm, ',x];']);

elseif (strcmp(cmd, 'sub'))
  eval(['z=', nm, '(x,y);']);

elseif (strcmp(cmd, 'setcols'))
  eval([nm, '=', nm, '(:,x);']);

elseif (strcmp(cmd, 'iget'))
  eval(['z=opCacheIndex', num2str(ch), ';']);

elseif (strcmp(cmd, 'iset'))
  eval(['opCacheIndex', num2str(ch), '=x;']);

else
  error(['Unknown command: ', cmd]);
end
