function spect = opCacheMakeSpect(ch, x1, x2, y1, y2)
% spect = opCacheMakeSpect(ch, x1, x2, y1, y2)
% Assemble frames x1 to x2, which are in the cache, into a single block,
% using only frequency bins y1 to y2.
% Assumes the index is sorted into increasing order.

global opCacheIndex

off1 = max(x1 - opCacheIndex(1,:), zeros(1, nCols(opCacheIndex))) ...
    + opCacheIndex(4,:);
off2 = min(x2 - opCacheIndex(1,:), opCacheIndex(2,:) - opCacheIndex(1,:))...
    + opCacheIndex(4,:);

which = find(off1 <= off2);
off1 = off1(which);
off2 = off2(which);

ix = [];
for i = 1:length(off1)
  ix = [ix, off1(i) : off2(i)];
end
spect = opCacheData(ch, 'sub', y1:y2, ix);
