function [fr0,fr1] = opCacheSplitSegs(g0, g1, maxsize)
% [fr0,fr1] = opCacheSplit(fr0, fr1, maxsize)
% Split any interval [fr0(i),fr1(i)] longer that maxsize up into pieces
% of length at most maxsize.  fr0 and fr1 should be the same length.

fr0 = [];  fr1 = [];
for i = 1:length(g0)
  fr0 = [fr0, g0(i)           : maxsize : g1(i)];
  fr1 = [fr1, g0(i)+maxsize-1 : maxsize : g1(i)];
  if (length(fr1) < length(fr0)), fr1 = [fr1, g1(i)]; end
end
