function x = opCurParams(ch, long)
% x = opCurParams(ch)
% Return a vector containing the spect-file header parameters
% for the currently-in-force settings.  This is used for comparing
% the saved spect file params to the current settings.
%
% x = opCurParams(ch, 1)
% As above, but return the 'long form' of the vector, which includes 
% optional data that doesn't have to match (e.g. brightness/contrast).
%
% See also opLoadSpect and opSetFileInfo.

global opDataSize opSrate opHopSize opZeroPad opWinType opBrightness opContrast

version = 1;		% version numbers are used in opSetSpectParams.

ds = opDataSize(ch);
x = [opSrate(ch)  ds  round(opHopSize(ch)*ds)  opZeroPad(ch)  opWinType(ch)];
if (nargin > 1)
  if (long)
    x = [version, x, opBrightness(ch)*1000, opContrast(ch)*1000];
  end
end
