function z = opFileName(ch, cmd, x)
% opFileName(ch, 'setsound', name)
% Set the sound file name for the given channel.
%
% name = opFileName(ch, 'getsound')
% Return the sound file name set by opFileName(ch, 'setsound', ...).
%
% opFileName(ch, 'setspect', name)
% Set the spectrogram file name for the given channel.
%
% name = opFileName(ch, 'getspect')
% Return the spectrogram file name set by opFileName(ch, 'setspect', ...).

global opc
global opSoundFile1 opSoundFile2 opSoundFile3 opSoundFile4
global opSoundFile5 opSoundFile6 opSoundFile7 opSoundFile8

global opSpectFile1 opSpectFile2 opSpectFile3 opSpectFile4
global opSpectFile5 opSpectFile6 opSpectFile7 opSpectFile8

if (nargin < 2), cmd = 'getsound'; end
if (nargin < 1), ch = opc; end

nm = ['File', num2str(ch)];
if (strcmp(cmd, 'setsound'))
  eval(['opSound', nm, ' = x;']);

elseif (strcmp(cmd, 'getsound'))
  eval(['z = opSound', nm, ';']);

elseif (strcmp(cmd, 'setspect'))
  eval(['opSpect', nm, ' = x;']);

elseif (strcmp(cmd, 'getspect'))
  eval(['z = opSpect', nm, ';']);

else
  error(['Unknown command: ', cmd]);
end
