
% Declare all of the global variables.  This is useful when debugging:
% just type opGlobals to make them all accessible.

% Comments starting with () mean the variable is a vector, with one
% value per channel.

global opc		% current channel number
global opAxes		% bounding box of image
global opBrightness	% () current setting of the brightness slider
global opCacheData1	% spectrogram values; also opCacheData2, 3, ..., 8
global opCacheIndex	% cache indices; rows are first, last, used, idx
global opCacheIndex1	% per-chan index; also opCacheIndex2, 3, ..., 8
global opColor 		% highlight color
global opColorDepth	% depth of highlighting
global opContrast	% () current setting of the contrast slider
global opDataSize	% () samples per spect frame
global opF0 opT0	% () portion of the signal on-screen
global opF1 opT1
global opFileType	% () 'b' for binary 16-bit, 's' for .str, 'a' for .au
global opHiLimit	% () max value displayable via colormap hacks
global opHopSize	% () hop size factor, default 1/2
global opHScrollSkip	% amount of image motion for click in h scroll bar
global opLoLimit	% () min value displayable via colormap hacks
global opMeasures	% () boolean vector of which measures to show
global opMeasureSel	% boolean vector of which measures are about selection
global opMeasureGram	% boolean vector of which measures need gram of sel
global opMeasureNames	% string matrix
global opMeasurePos	% () vector of [left top] values
global opMousePos	% () position of last mouse click
global opNsamp		% () number of smaples in the sound
global opPlayRate	% () playback rate number (popup choice - 1)
global opPrintMargin	% size of margin (inches) around edges of printed page
global opSelT0 opSelF0	% () selection box
global opSelT1 opSelF1
global opShareColors	% share colormap entries with other windows?
global opSoundFile1	% chan 1 sound file name; also opSoundFile2, 3, ..., 8
global opSpectFile1	% chan 1 spect file name; also opSpectFile2, 3, ..., 8
global opSpectParams	% () spect file params
global opSpectVer	% () spect file version
global opSrate		% () sampling rate, samples/s
global opTimeStamp	% counter for flushing old spectrogram frames
global opTMax		% () the end of time
global opVScrollSkip	% amount of image motion for click in v scroll bar
global opWinType	% () 1=kaiser, 2=bartlett, etc.  See opWinTypeF.
global opZeroPad	% () zero pad factor, default 0

% User interface objects.
global opDataSizePopup opHopSizePopup opZeroPadPopup opWinTypePopup
global opHScrollBar opVScrollBar opContrastSlider opBrightnessSlider
global opFig opPlayBut opContrastText opBrightnessText opSliderValues
global opPlayRateMenu opMeasureMenus opMeasureTexts opMeasureNums opWindowAxes
global opHScrollMenu opVScrollMenu opPrefMenus
