function opInitFigure(windowname)
% opInitFigure(windowname)
% Draw the main Osprey window, with buttons and sliders and so on.
%
% See also opOpen.

global opFig opAxes opMeasureTexts opMeasureNums opShareColors

% First get rid of any existing figure.
x = 0;
if (exist('opFig')), if (any(find(opFig == get(0,'Children')))), x=1; end; end
if (x)
  set(opFig, 'Visible', 'on');
  delete(get(opFig, 'Children'));  drawnow;
  opAxes = -1 * ones(1, length(opAxes));
  opMeasureTexts = zeros(size(opMeasureTexts));
  opMeasureNums  = zeros(size(opMeasureNums));
  figure(opFig);
else
  opFig = figure('Units', 'pixels', 'Position', [200 395 850 400]);
  opAxes = -1;
end

set(opFig, 'Name', windowname, 'NumberTitle', 'off', 'Units', 'pixels',...
    'Resize', 'on', 'SelectionType', 'extend', 'Pointer', 'crosshair', ...
    'Visible', 'on', 'ShareColors', 'no', 'NextPlot', 'new');
if (opShareColors), set(opFig, 'ShareColors', 'on'); end
