function opNewChan(ch)
% Initialize things for a new channel number, and make that channel
% the current one.  Nothing is known about the new sound yet.

% disp(['Creating new channel ', num2str(ch)]);

global opc opF0 opF1 opT0 opT1 opSrate opNsamp
global opSelT0 opSelT1 opSelF0 opSelF1 opAxes opMousePos
global opDataSize opHopSize opZeroPad opWinType opBrightness opContrast
global opHScrollSkip opVScrollSkip opFileType opSpectParams
global opColorDepth opColor opPrintMargin opTMax opPlayRate opShareColors

% assume new channel number is previous one plus 1
opFileName(ch, 'setsound','');
opFileName(ch, 'setspect','');
opFileType(ch)	= 0;
opF0(ch)	= 0;  opF1(ch) = 100;
opT0(ch)	= 0;  opT1(ch) = 100;
opSelF0(ch)	= 0;  opSelF1(ch) = -1;
opSelT0(ch)	= 0;  opSelT1(ch) = -1;
opSrate(ch)	= 100;
opNsamp(ch)	= 100;
opTMax(ch)	= 1;
opAxes(ch)	= -1;
opHopSize(ch)	= opHopSizeF('default');
opWinType(ch)	= opWinTypeF('default');
opDataSize(ch)	= opDataSizeF('default');
opZeroPad(ch)	= opZeroPadF('default');
opContrast(ch)	= 0.5;
opBrightness(ch)= 0.5;
opLoLimit(ch)	= 0;
opHiLimit(ch)	= 0;
opPlayRate(ch)	= 1;
opMousePos(ch,1:4) = [Inf Inf Inf Inf];		% flag values; see opMouseClick
opCacheData(ch, 'clear');
if (~exist('opHScrollSkip')),	opHScrollSkip = 0.75;		 end
if (~exist('opVScrollSkip')),	opVScrollSkip = 0.5;		 end
if (~exist('opColor')), 	opColor       = [1 1 0];	 end
if (~exist('opColorDepth')),	opColorDepth  = 0.4;		 end
if (~exist('opPrintMargin')),	opPrintMargin = [1.0 .73 .5 .5]; end  % L,B,R,T
if (~exist('opShareColors')),	opShareColors = 0;		 end
opSpectParams(ch, 1:5) = zeros(1,5);

opc = ch;
