function opPrefs(cmd, ch, x0)
% opPrefs('newmenu', chan, parent)
% Create a menu (a child of the parent) listing miscellaneous preferences.
%
% opPrefs('checkmenu')
% Set check-marks on the menu for the current channel appropriately.
%
% opPrefs('share')
% Flip the 'share colors' bit.

global opShareColors opMiscMenus opFig

if (strcmp(cmd, 'newmenu'))
  set(x0, 'Callback', 'opPrefs(''checkmenu'');');
  opMiscMenus(ch,1) = uimenu(x0, 'Label', 'Share Colors', ...
      				'Callback', 'opPrefs(''share'');');
  
elseif (strcmp(cmd, 'checkmenu'))
  for i = 1:nCols(opMiscMenus)
    if (i==1), x = opShareColors; end
  end
  if (x), set(opMiscMenus(i), 'Checked', 'on');
  else    set(opMiscMenus(i), 'Checked', 'off');
  end

elseif (strcmp(cmd, 'share'))
  opShareColors = ~opShareColors;
  if (opShareColors), set(opFig, 'ShareColors', 'yes');
  else                set(opFig, 'ShareColors', 'no');
  end

else
  error(['Osprey internal error: Unknown command: ', cmd]);
end
