function opRefreshChan(ch)
% opRefreshChan(ch)
% Repaint a channel and its axes.  If noNums is absent or zero, also
% show the channel parameters in the figure.

% Note that this is also called from opPrint, which messes with opAxes.
% opPrint depends on this guy not changing the axes.

global opAxes opT0 opT1 opF0 opF1 opSelT0 opSelT1 opSelF0 opSelF1
global opBrightnessSlider opContrastSlider opBrightness opContrast
global opSrate opTMax opHScrollBar opVScrollBar opSliderValues
global pix opFig

t0 = opT0(ch);  t1 = opT1(ch);
f0 = opF0(ch);  f1 = opF1(ch);

x = get(opAxes(ch),'children');
if (length(x)), delete(x); drawnow; end

selbox = [opSelT0(ch)  opSelF0(ch)  opSelT1(ch)  opSelF1(ch)];
[bits, pixbox, realbox] = opGetSpect(ch, t0, t1, f0, f1, selbox);
set(opAxes(ch), 'XLim', [t0 t1], 'YLim', [f0 f1]);
pix = opBitsToPix(ch, bits, opBrightness(ch), 1-opContrast(ch), pixbox);
set(opFig, 'NextPlot', 'add');
axes(opAxes);
image(realbox([1 3]), realbox([2 4]), pix, 'ButtonDownFcn','opMouseClick');
set(opFig, 'NextPlot', 'new');

% Have to redraw axes (matlab bug, I think).
set(opAxes(ch), 'Box', 'off', 'XLim', [t0 t1], 'YLim', realbox([2 4]), ...
    'YDir', 'normal', 'TickDir', 'out');

% Set scroll bars and play-button.
uiSlider(opHScrollBar, 'Value', opSliderSetting(opTMax(ch), t0, t1));
uiSlider(opVScrollBar, 'Value', opSliderSetting(opSrate(ch)/2, f0, f1));
set(opBrightnessSlider, 'Value', opBrightness(ch));
set(opContrastSlider,   'Value', opContrast(ch));
opPlay('disptext', ch);
