function opRepaintControls(ch)
% opRepaintControls(ch)
% Redraw the buttons, sliders, text boxes, and so on in the osprey window.

global opFig opContrastSlider opBrightnessSlider opPlayRateMenu opPlayRate
global opDataSizePopup opHopSizePopup opZeroPadPopup opHScrollBar opVScrollBar
global opWinTypePopup opPlayBut opContrastText opBrightnessText opAxes
global opMeasurePos opWindowAxes opHScrollMenu opVScrollMenu opShareColors

% Menus.
f = uimenu('Label','File   ');
uimenu(f, 'Label', 'Open',		'Callback', 'opOpen(''open'');');
uimenu(f, 'Label', 'Store gram',	'Callback', 'opSaveSpect');
uimenu(f, 'Label', 'Play whole sound',	'Callback', 'opPlay(''all'')');
pr = uimenu(f, 'Label', 'Print');
uimenu(pr, 'Label', 'full page',	'Callback', 'opPrint(''fullpage'')');
uimenu(pr, 'Label', 'screen size',	'Callback', 'opPrint(''wysiwyg'')');
uimenu(pr, 'Label', 'many pages',	'Callback', 'opPrint(''manypages'')');
uimenu(f, 'Label', 'Quit',		'Callback', 'opOpen(''quit'')');

s = uimenu('Label', 'Select  ');
uimenu(s, 'Label', 'None',            'Callback', 'opSelect(''none'')');
uimenu(s, 'Label', 'All',             'Callback', 'opSelect(''all'')');
uimenu(s, 'Label', 'All, H only',     'Callback', 'opSelect(''all-h'')');
uimenu(s, 'Label', 'All, V only',     'Callback', 'opSelect(''all-v'')');
uimenu(s, 'Label', 'Window, H only',  'Callback', 'opSelect(''win-h'')');
uimenu(s, 'Label', 'Window, V only',  'Callback', 'opSelect(''win-v'')');

z = uimenu('Label', 'Zoom  ');
uimenu(z, 'Label', 'to whole sound',  'Callback', 'opZoom(''all'')');
uimenu(z, 'Label', 'to selection',    'Callback', 'opZoom(''sel'')');
uimenu(z, 'Label', 'to sel., H only', 'Callback', 'opZoom(''sel-h'')');
uimenu(z, 'Label', 'to sel., V only', 'Callback', 'opZoom(''sel-v'')');

w = uimenu('Label','Window  ');
uimenu(w, 'Label', 'Redraw',    	'Callback', 'opRedraw(''redraw'')');
uimenu(w, 'Label', 'Manual sizing...',  'Callback', 'opRedraw(''mansize'')');
uimenu(w, 'Label', 'Manual scaling...', 'Callback', 'opRedraw(''manscale'')');

p = uimenu('Label','Preferences  ');
ms = uimenu(p, 'Label', 'Measurements');
opMeasure('newmenu', ch, ms);
hs = uimenu(p, 'Label', 'H Scroll', 'Callback','opScrollAmount(''s'')');
opHScrollMenu = hs;		% see opScrollAmount
uimenu(hs, 'Label', 'H slider scrolls by...');
uimenu(hs, 'Label', '     1/4 screen', 'Callback','opScrollAmount(''h'',1/4)');
uimenu(hs, 'Label', '     1/2 screen', 'Callback','opScrollAmount(''h'',1/2)');
uimenu(hs, 'Label', '     3/4 screen', 'Callback','opScrollAmount(''h'',3/4)');
uimenu(hs, 'Label', '      1   screen','Callback','opScrollAmount(''h'',1)');
vs = uimenu(p, 'Label', 'V Scroll', 'Callback','opScrollAmount(''s'')');
opVScrollMenu = vs;
uimenu(vs, 'Label', 'V slider scrolls by...');
uimenu(vs, 'Label', '     1/4 screen', 'Callback','opScrollAmount(''v'',1/4)');
uimenu(vs, 'Label', '     1/2 screen', 'Callback','opScrollAmount(''v'',1/2)');
uimenu(vs, 'Label', '     3/4 screen', 'Callback','opScrollAmount(''v'',3/4)');
uimenu(vs, 'Label', '      1   screen','Callback','opScrollAmount(''v'',1)');
cs = uimenu(p, 'Label', 'Color');
uimenu(cs, 'Label', 'Selection Color:');
uimenu(cs, 'Label','  Yellow', 'Callback', 'global opColor; opColor=[1 1 0];');
uimenu(cs, 'Label','  Red',    'Callback', 'global opColor; opColor=[1 0 0];');
uimenu(cs, 'Label','  Green',  'Callback', 'global opColor; opColor=[0 1 0];');
uimenu(cs, 'Label','  Aqua',   'Callback', 'global opColor; opColor=[0 1 1];');
uimenu(cs, 'Label','  Purple', 'Callback', 'global opColor; opColor=[1 0 1];');
uimenu(cs, 'Label','  Blue',   'Callback', 'global opColor; opColor=[0 0 1];');
ss = uimenu(p, 'Label', 'Misc.', 'Callback', 'opPrefs(''checkmenu'');');
opPrefs('newmenu', ch, ss);

xywh = get(opFig, 'Position');
opWindowAxes = axes('Position', [0 0 xywh(3) xywh(4)], 'Visible', 'off');

% Buttons.
left = 10;
wide = 100;
top  = xywh(4) - 10;
high = 22;
inc  = high + 8;
uicontrol('Style', 'PushB', 'Callback', 'opZoomCrunch(''h'',''z'')', ...
          'HorizontalAlign','center', 'String', 'Horz. Zoom', ...
          'Position', [left top-high wide high]);
top = top - inc;
uicontrol('Style', 'PushB', 'Callback', 'opZoomCrunch(''h'',''c'')', ...
          'HorizontalAlign','center', 'String', 'Horz. Crunch', ...
          'Position', [left top-high wide high]);   
top = top - inc;
uicontrol('Style', 'PushB', 'Callback', 'opZoomCrunch(''v'',''z'')', ...
          'HorizontalAlign','center', 'String', 'Vert. Zoom', ...
          'Position', [left top-high wide high]);   
top = top - inc;
uicontrol('Style', 'PushB', 'Callback', 'opZoomCrunch(''v'',''c'')', ...
          'HorizontalAlign','center', 'String', 'Vert. Crunch', ...
          'Position', [left top-high wide high]);   
top = top - inc;
uicontrol('Style', 'PushB', 'Callback', 'opZoom(''sel'')', ...
          'HorizontalAlign','center', 'String', 'Zoom to Sel.', ...
          'Position', [left top-high wide high]);
%top = top - inc;
%uicontrol('Style', 'PushB', 'Callback', 'opSelect', ...
%          'HorizontalAlign','center', 'String', 'Select', ...
%          'Position', [left top-high wide high]);
bBot   = top - high;
bRight = left + wide;

% Brightness and contrast sliders.
left = bRight + 40;
wide = 200;
bot = 10;
high = 16;
inc = high + 8;
opContrastSlider = uicontrol('Style', 'slider', ...
	'Callback', 'opSlider(''c'')', 'Value', 0.5,...
	'Position', [left bot wide high]);
opContrastText(ch) = text('Units', 'pixels', 'String', 'Contrast', ...
	                  'Position', [left+wide+5 bot+8]);
bot = bot + inc;
opBrightnessSlider = uicontrol('Style', 'slider', ...
	'Callback','opSlider(''b'')', 'Value', 0.5,...
	'Position', [left bot wide high]);
opBrightnessText(ch) = text('Units','pixels', 'String','Brightness', ...
			    'Position',[left+wide+5 bot+8]);
sTop   = bot + high;
sRight = left + wide + 70;

% Play button
left = sRight + 20;
wide = 100;
bot = 10;
high = 40;
opPlayBut(ch) = uicontrol('Style','PushB','Callback', 'opPlay(''button'')', ...
	'Position', [left bot wide high], 'HorizontalAlign', 'center');
pRight = left + wide;
opPlay('disptext', ch);		% set to default

% Play rate button.
left = pRight + 10;
wide = 70;
bot = 10;
high = 40;
opPlayRateMenu = uicontrol('Style', 'popup', 'HorizontalAlign', 'right', ...
    'Position', [left bot wide high], 'Callback', 'opPlay(''setrate'')',...
    'String', opPlay('ratetext', ch), 'Value', opPlayRate(ch)+1);
rRight = left + wide;

% Popup menus.
left = 10;
wide = 100;
top  = bBot - 15;
high = 18;
inc  = high + 8;
opDataSizePopup = uicontrol('Style', 'Popup','String',opDataSizeF('string'),...
	'Callback', 'opDataSizeF', 'Position', [left top-high wide high]);
opDataSizeF(ch);		% set to default

top = top - inc;
opZeroPadPopup = uicontrol('Style', 'Popup', 'String', opZeroPadF('string'),...
	'Callback', 'opZeroPadF', 'Position', [left top-high wide high]);
opZeroPadF(ch);		% set to default

top = top - inc;
opHopSizePopup = uicontrol('Style', 'Popup', 'String', opHopSizeF('string'),...
	'Callback', 'opHopSizeF', 'Position', [left top-high wide high]);
opHopSizeF(ch);		% set to default

top = top - inc;
opWinTypePopup = uicontrol('Style', 'Popup', 'String', opWinTypeF('string'),...
	'Callback', 'opWinTypeF', 'Position', [left top-high wide high]);
opWinTypeF('disp', ch);		% set to default

pBot   = top - high;
pRight = left + wide;


% Measures
top = pBot - 20;
left = 10;
opMeasurePos = [left top];
opMeasure('painttext', ch);


% Scrollbars.
thick   = 15;
left    = 10;			% space beside vertical scrollbar.
right   = 10;
top     = 10;			% space above horizontal scrollbar.
bot     = 10;
imLeft  = 50 + bRight;
imWide  = xywh(3) - imLeft - left - right - thick;
imBot   = 30 + sTop;
imHigh  = xywh(4) - imBot - bot - top - thick;

opHScrollBar = uicontrol('Style', 'slider', 'Callback', 'opSlider(''h'')', ...
	'Position', [imLeft  (xywh(4)-top-thick)  imWide  thick]);
uiSlider(opHScrollBar);
opVScrollBar = uicontrol('Style', 'slider', 'Callback', 'opSlider(''v'')', ...
	'Position', [(xywh(3)-right-thick)  imBot  thick  imHigh]);
uiSlider(opVScrollBar);

% axes object
if (opAxes(ch) >= 0), delete(opAxes(ch)); end;
opAxes(ch) = axes('Units', 'pixels', 'Position',[imLeft imBot imWide imHigh]);
