function opZoom(typ)
% All of these commands erase the selection and redisplay.
% 
% opZoom('sel')
% Zoom to the current selection.
% 
% opZoom('sel-h')
% Zoom to selection in the horizontal direction.
%
% opZoom('sel-v')
% ... only in the vertical direction.
%
% opZoom('all')
% Zoom to the whole sound.

global opSelT0 opSelT1 opSelF0 opSelF1 opT0 opT1 opF0 opF1 opc opTMax opSrate

issel = opSelect(opc);

if (strcmp(typ, 'sel') & issel)
  opT0(opc) = opSelT0(opc);
  opT1(opc) = opSelT1(opc);
  opF0(opc) = opSelF0(opc);
  opF1(opc) = opSelF1(opc);
  opEraseSelection(opc);
  opRefresh(opc);

elseif (strcmp(typ, 'sel-h') & issel)
  opT0(opc) = opSelT0(opc);
  opT1(opc) = opSelT1(opc);
  opEraseSelection(opc);
  opRefresh(opc);

elseif (strcmp(typ, 'sel-v') & issel)
  opF0(opc) = opSelF0(opc);
  opF1(opc) = opSelF1(opc);
  opEraseSelection(opc);
  opRefresh(opc);

elseif (strcmp(typ, 'all'))
  opF0(opc) = 0;
  opF1(opc) = opSrate(opc) / 2;
  opT0(opc) = 0;
  opT1(opc) = opTMax(opc);
  opRefresh(opc);

end
