function y = defaultsrate
% defaultsrate   Return the default sampling rate of the machine.
%
% y = defaultsrate
% Return the default sampling rate available with the current hardware.
% This should porobably be a vector of available numbers, but isn't yet.

c = computer;

if     (strcmp(c(1:3), 'SUN')),   y = 8000;
elseif (strcmp(c(1:3), 'MAC')),   y = 22254 + 54/99;
elseif (strcmp(c,      'NEXT')),  y = 22050;		% or 44100?

else
  error(['Don''t know default sampling rate for machine ',c,'.  If you know it, please fix defaultsrate.m and send mail to dkm1@cornell.edu .']);
end
  
