function y = gauss(x, mean, sd)
% y = gauss(x [,mean [,sd]])
% The usual (normalized) gaussian function.
% The mean defaults to 0, and the standard deviation to 1.

if (nargin < 3), sd = 1.0; end
if (nargin < 2), mean = 0.0; end

y = 1 / sqrt(2 * pi) ./ sd * ...
    exp( -1/2 * ((x - mean) ./ sd) .^ 2 );
