function e = pathExt(p)
% ext = pathExt(pathname)
% Given a pathname, return the extension (without its initial '.').
% If there is no '.' in the filename, return ''.
%
% See also pathDir, pathRoot, pathFile, pathSep.

ext = '.';		% character that starts an extension

e = '';
w = find(p == ext);
if (length(w))
  w = w(length(w));
  if (w > length(pathDir(p)))	% check that '.' is not in dirname
    e = p(w+1:length(p));
  end
end
