function r = pathRoot(p)
% root = pathRoot(pathname)
% Given a pathname, return the pathname sans extension.
% This includes the directory name(s) in the path.
% 
% Note that this is slightly different from
%      [pathHead(pathname), '/', pathFile(pathname)]
% because if the file is in the current directory, the latter
% puts on an initial './' while the former does not.
%
% See also pathDir, pathExt, pathFile, pathSep.

ext = '.';

r = p;
w = find(p == ext);
if (length(w))
  w = w(length(w));
  if (w > length(pathDir(p)))	% check that '.' is not in dirname
    r = p(1:w-1);
  end
end
