function printf(fmt, a0,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16)
% PRINTF(format, args...)
% This is just like disp(sprintf(format, args...)), except that it
% allows up to 17 args instead of the 3 sprintf gives you.
% It's often better than disp([ ... ]) because numbers are shown
% better than with num2str.
%
% Use %f or %g as the format, since floats are the only data types in Matlab.
% Also %s works, but you can't specify a format control (like %-20s) for it.
%
% Unlike C's printf, this one always puts a newline afterwards.  Unavoidable.
% Always prints a newline, so just saying 'printf' gives you a blank line.
%
% See also sprintf, disp, num2str.

if (nargin < 1), disp(' '); return; end

str = '';
n = 0;
while (length(fmt) > 0),
  p = strindex(fmt, '%');
  if (~p | p == length(fmt)),
    str = [str, fmt];
    fmt = '';
  elseif (fmt(p+1) == '%')
    str = [str, fmt(1:p)];
    fmt = fmt(p+2:length(fmt));
  else
    if     n==0,  y = a0;  elseif n==1,  y = a1;  elseif n==2,  y = a2;
    elseif n==3,  y = a3;  elseif n==4,  y = a4;  elseif n==5,  y = a5;
    elseif n==6,  y = a6;  elseif n==7,  y = a7;  elseif n==8,  y = a8;
    elseif n==9,  y = a9;  elseif n==10, y = a10; elseif n==11, y = a11;
    elseif n==12, y = a12; elseif n==13, y = a13; elseif n==14, y = a14;
    elseif n==15, y = a15; elseif n==16, y = a16;
    else error('Something''s wrong.'); end
    n = n+1;
    if (fmt(p+1) == 's')
      str = [str, fmt(1:p-1), y];
      fmt = fmt(p+2:length(fmt));
    else
      done = 0;
      for x = p:length(fmt)
        if (isletter(fmt(x))),
          str = [str, sprintf(fmt(1:x), y)];
          fmt = fmt(x+1:length(fmt));
          done = 1;
          break
        end
      end
      if (~done),
        str = [str, fmt];
        fmt = '';
      end
    end
  end
end

if (length(str) == 0), str = ' '; end
disp(str)
