function y = uniq(y)
% y = UNIQ(x)
% Return vector x with runs of identical elements shortened to one element.
%
% This is a little like the unix uniq command.

if (length(y) == 0), return; end

while (1)
  n = length(y);
  y = [reduce(y, y(1:n-1) ~= y(2:n)), y(n)];
  if (length(y) == n)
    return
  end
end
