function anademo(swtch,id)
%
%ANADEMO Analyze demo
% Copyright (c) 1994-96 by G. Evangelista, Universita` "Federico II" di Napoli, Italia
if nargin<1, 
	msg='ANALYZE    Signal/Image Processing Commander - Rel. 6.0d\n\n';
	msg=[msg,'We are going to demonstrate some advanced features of ANALYZE\n'];
	msg=[msg,'that are implemented in registered versions only.\n\n'];
	msg=[msg,'This demo will close all your previous figures'];
	R=messageb('Analyze Demo',msg,'OkC','?',0,'appl');
	if R>1, return, end
	close('all');
	chkid('');
	msg='The following Signal Panel contains a violin tone\n\n';
	msg=[msg,'To resume this Demo select the Resume_Demo command\n'];
	msg=[msg,'in the next Signal Panel(s)'];
	messageb('Analyze Demo',msg,'Ok','?',0,'appl');
	load violin
	zoomplot(signal,SR,'Violin Tone');
	CF=gcf; id=figpar(CF);
	uimenu(CF,'Label','Resume_Demo','Callback',['anademo(1,',int2str(id),')']);
elseif swtch==1
	msg='The following Signal Panels contain the\n';
	msg=[msg,'Discrete Wavelet Transform of the violin tone\n\n'];
	msg=[msg,'To resume this Demo select the Resume_Demo command\n'];
	msg=[msg,'in the next Signal Panel(s)'];
	messageb('Analyze Demo',msg,'Ok','?',0,'nof');
	for n=1:3, WTF(n,1)=newfig(id,['WT_scale_',int2str(n)],201); end
	WTF(4,1)=newfig(id,['Scaling_scale_',int2str(3)],201.1); 
	tile2(WTF); 
	for n=1:3
		figure(WTF(n));
		eval(['load violinw',num2str(n)]);
		zoomplot(signal,SR,'','Time','Coeff.',get(gcf,'position'),0,1);
		closeall(WTF,WTF(n),'CloseDWT'); 
		uimenu(WTF(n),'Label','Resume_Demo','Callback',['anademo(2,',int2str(id),')']);
	end
	figure(WTF(4));
	load violinsc
	zoomplot(signal,SR,'','Time','Coeff.',get(gcf,'position'),0,1);
	closeall(WTF,WTF(4),'CloseDWT'); 
	uimenu(WTF(4),'Label','Resume_Demo','Callback',['anademo(2,',int2str(id),')']);
elseif swtch==2
	msg='By means of the Multiplexed Wavelet Transform\n';
	msg=[msg,'it is possible to separate the harmonic from the\n'];
	msg=[msg,'inharmonic components. The latter are generated\n'];
	msg=[msg,'by the friction of the bow on the string.\n\n'];
	msg=[msg,'Listen to them by selecting the Play command\n'];
	msg=[msg,'in the next two Signal Panels.\n\n'];
	msg=[msg,'To resume this Demo select the Resume_Demo command\n'];
	msg=[msg,'in the next Signal Panel(s)'];
	messageb('Analyze Demo',msg,'Ok','?',0,'appl');
	WTF='';
	WTF(1,1)=newfig(id,'Inharmonic_Components',204.5); 
	WTF(2,1)=newfig(id,'Harmonic_Component',204.51); 
	tile2(WTF); 
	load inviolin
	figure(WTF(1));
	zoomplot(signal,SR,'','Time','Amplitude',get(gcf,'position'),0,1);
	closeall(WTF,WTF(1),'CloseNoiseSep.');
	uimenu(WTF(1),'Label','Resume_Demo','Callback',['anademo(3,',int2str(id),')']);
	figure(WTF(2));
	load haviolin
	zoomplot(signal,SR,'','Time','Amplitude',get(gcf,'position'),0,1);
	closeall(WTF,WTF(2),'CloseNoiseSep.'); 
	uimenu(WTF(2),'Label','Resume_Demo','Callback',['anademo(3,',int2str(id),')']);
elseif swtch==3
	msg='The full version of Analyze contains several signal\n';
	msg=[msg,'and image processing features. It is constantly\n'];
	msg=[msg,'updated to allow you to experiment with the most\n'];
	msg=[msg,'outstanding techniques as soon as they are published.\n\n'];
	msg=[msg,'Would you like to close the figures generated by this demo ?\n\n'];
	R=messageb('Analyze Demo',msg,'OkC','?',0,'appl');
	if R==1, closeid(1:7); chkid(''); end
end