function [H,Nme,fid,typ,fn]=ldmathd(kind,filename)
%
%LDMATHD This function is for Analyze internal use only

%Copyright (c) 1994-96 by G. Evangelista, Universita` "Federico II" di Napoli, Italia.   
%	
if nargin<2
	if nargin<1, kind=''; end
	curdir=cd;
	[fn,pth]=uigetfile('*.mat',['Load ',kind]);
	eval(['cd ',curdir]);
	if fn
		filename=[pth,fn];
	else return, end
end
fid=fopen(filename,'r','ieee-le'); 
ty=fread(fid,1,'ulong');
if ty>=2^16
	fclose(fid);
	fid=fopen(filename,'r','ieee-be');
	ty=fread(fid,1,'ulong');
end
mach=floor(ty/1000);
if mach>1
	if mach==2, machf='vaxd';
	elseif mach==3, machf='vaxg';
	elseif mach==4, machf='cray';
	else
		sigerr(1000,gcf,filename);
		fclose(fid); H=''; return;  
	end
	fclose(fid);
	fid=fopen(filename,'r',machf);
end
fseek(fid,0,-1);
k=1; s=20;
if ~(fid==-1)
	while ~feof(fid)
		[hh,cnt]=fread(fid,5,'ulong'); 
		%    type;   /* type */
		%    mrows;  /* row dimension */
		%    ncols;  /* column dimension */
		%    imagf;  /* flag indicating imag part */
		%    namlen; /* name length (including NULL) */
		if cnt==5
			H(:,k)=hh;
			[Nm,cnt]=fread(fid,H(5,k),'char'); 
			if (cnt==0)|(H(5,k)>24),
				sigerr(1001,gcf,filename); 
				fclose(fid); H=''; return;  
			end 
			Nme(k,1:H(5,k))=setstr(Nm');
			hh=floor(rem(H(1,k),1000)/10);
			if hh==0,
				typ(k,1:6)='double'; NByte=8;
			elseif hh==1 
				typ(k,1:5)='float'; NByte=4; 
			elseif hh==2,
				typ(k,1:5)='long'; NByte=4; 
			elseif hh==3, 
				typ(k,1:5)='short'; NByte=2; 
			elseif hh==4
				typ(k,1:6)='ushort'; NByte=2; 
			elseif hh==5,
				typ(k,1:4)='char'; NByte=1;
			else 
				sigerr(1001,gcf,filename); 
				fclose(fid); H=''; return; 
			end

			L = NByte*H(2,k)*H(3,k)*(1+H(4,k)); H(5,k)=s+H(5,k);
			status=fseek(fid,L,0);
			if status, sigerr(1001,gcf,filename);  fclose(fid); H=''; return;  end 
			s=H(5,k)+L+20;
			k=k+1; 
		elseif k==1
			sigerr(1001,gcf,filename); 
			fclose(fid); H=''; return;
		end
	end
else
	sigerr(1002,gcf,filename); 
end