function resp=messageb(title,msg,but,icon,defbut,modal)
%MESSAGEB This function is for Analyze internal use only
%
%Copyright (c) 1994-96 by G. Evangelista, Universita` "Federico II" di Napoli, Italia.   
%	
%
% RESP=MESSAGEB(TITLE,MSG,BUT,ICON,DEFBUT,MODAL)
%	Opens a Windows Message Box with
%		TITLE	(string) Box title
%		MSG 	(string) Message
%		BUT	(string) Button Definition  [ 'Ok' 'OkC' 'ARI' 'YNC' 'YN' 'RC' ]
%		ICON	(string) Icon ['' 'hand' '?' '!' '*']
%		DEFBUT  (integer) Default Button [0 1 2]
%		MODAL   (string) Application, Task, System Modal or NoFocus ['appl' 'task' 'system' 'nof']
%
%		RESP	(integer) Response Button coded as follows
%				OK	    1
%				CANCEL	    2
%				ABORT 	    3
%				RETRY 	    4
%				IGNORE	    5
%				YES	    6
%				NO	    7
if nargin<6, m=0;
elseif strcmp(modal,'task'), m=4096;
elseif strcmp(modal,'system'), m=8192;
elseif strcmp(modal,'nof'), m=32768;
else m=0;
end
if nargin<5, 
	defbut=0;
else 
	defbut=defbut*256;
end
if nargin<4, ic=0;
elseif strcmp(icon,'hand'), ic=16;
elseif strcmp(icon,'?'), ic=32;
elseif strcmp(icon,'!'), ic=48;
elseif strcmp(icon,'*'), ic=64;
else ic=0;
end
if nargin<3, b=0;
elseif strcmp(but,'Ok'), b=0;
elseif strcmp(but,'OkC'), b=1;
elseif strcmp(but,'ARI'), b=2;
elseif strcmp(but,'YNC'), b=3;
elseif strcmp(but,'YN'), b=4;
elseif strcmp(but,'RC'), b=5;
else b=0;
end
if nargin<2, msg=''; end
if nargin<1, title=''; end
resp=msgbox(title,sprintf(msg),m+defbut+ic+b);
