function A=remap(x,row,zi);
%       A=remap(x,N)
%               remap vector x into an N row matrix, truncating x to a multiple
%               of N elements.
%       A=remap(x,N,1)
%               automatical zero padding x to reach a multiple of N elements.
%
%	REMAP This function is for Analyze internal use only

%Copyright (c) 1994-96 by G. Evangelista, Universita` "Federico II" di Napoli, Italia   		

if nargin<3, zi=0; end
x=x(:);         % make x into a column vector
L=length(x);
q=rem(L,row);
if q>0,
        if zi,
                x=[x;zeros(row-q,1)];
                L=length(x);
        else
                 fprintf('Warning: the number of elements is not an integer multiple of\n');
                 fprintf('         the required number of rows. Extra data will be discarded.\n');
        end
end
Q=floor(L/row);
ofs=1;
for k=1:Q
 A(1:row,k)=x(ofs:ofs+row-1);
 ofs=ofs+row;
end
 
