function xy=selectw3(p)
%	xy=SELECTW3
%		select a window in the current plot
%		mouse button should be held down before calling
%		this function without input parameter.
%		xy=[xmin xmax ymin ymax] is returned.
%	xy=SELECTW3(1)
%		wait for button press.
%
%	SELECTW This function is for Analyze internal use only

%Copyright (c) 1994-96 by G. Evangelista, Universita` "Federico II" di Napoli, Italia   		

CA=gca; CF=gcf;
if nargin==1,
	ptr=get(CF,'Pointer'); 
	if p==0; return; 	% do nothing (used to load and precompile function) 
	elseif p==2, set(CF,'Pointer','crosshair'); end
	waitforbuttonpress; 
	set(CF,'Pointer',ptr);
end
axu=get(CA,'Units');
fig_u=get(CF,'units');
set(CA,'Units','normalized');
x1=get(CA,'CurrentPoint');
set(CA,'Units',axu);
xx1=get(CA,'CurrentPoint');
set(CF,'units','pixels');
x=get(CF,'CurrentPoint');
set(CF,'units',fig_u);
x1=xx1(1,1); y1=xx1(1,2);
rbbox([x(1,1),x(1,2),0,0],[x(1,1),x(1,2)]);
CFF=get(0,'PointerWindow'); 
if CFF==CF
	[x2,y2]=ginp1(CF);
	xy(1)=min([x1,x2]);
	xy(2)=max([x1,x2]);
	xy(3)=min([y1,y2]);
	xy(4)=max([y1,y2]);
elseif CFF
	refresh(CFF)
	refresh(CF)
end