function selframe(swtch)
%
%SELFRAME This function is for Analyze internal use only

%Copyright (c) 1994-96 by G. Evangelista, Universita` "Federico II" di Napoli, Italia   		

loadoff=['SelSView SelSig'];
if isempty(findstr(loadoff,swtch))
	H=gcf;
	[s,vars,hand]=getdata;
	[nsig,t0,ofs,zo,endp,SR,ms,Ms,pit,XS,YS,PTrack]=getvars(vars);
	[C,Cz,Cb,Cb1,Cb2,CT,XYc,An,Uw,Rb,CTS,Hx,Hy,SSR,ext]=gethands(hand);
end
if strcmp(swtch,'Origin')		% Select Origin
	chkhelp('Select_Origin');
	g=ginput(1); t0=t0-g(1);
	replot(s,ofs,endp,zo,SR,ms,Ms,t0,XYc,XS,YS);
	vars=[nsig; t0; ofs; zo; endp; SR; ms; Ms; pit; XS; YS; PTrack];
	putdata(s,vars,hand);
elseif strcmp(swtch,'SelSDlg')		% Select Signals Dialog
	chkhelp('Select_Signals','Context');
	[id,pos,xlab,ylab]=figpar(gcf);
	dlg(['Select Signal(s) <',int2str(id),'>'],'Signal(s)',num2str(nsig),'selframe(''SelSig'')','selframe(''SelSView'')');
	set(gcf,'user',[get(gcf,'user') nsig id]);
elseif strcmp(swtch,'SelSView')		% View Select Signals
	CF=gcf;
	NS=get(CF,'userdata');
	if isidon(NS(4))
		sig=parseran(get(NS(1),'string'));
		if ~isempty(sig)&isempty(find((sig<1)&(sig>NS(3))))
			CF=gcf;
			[s,vars,hand]=getdata(NS(2)); 
			figure(NS(2));
			[nsig,t0,ofs,zo,endp,SR,ms,Ms,pit,XS,YS,PTrack]=getvars(vars);
			[C,Cz,Cb,Cb1,Cb2,CT,XYc,An,Uw,Rb,CTS,Hx,Hy,SSR,ext]=gethands(hand);
			replot(s,ofs,endp,zo,SR,ms,Ms,t0,XYc,XS,YS,sig);
			figure(CF);
		else
			sigerr(0.6,CF);
		end
	else
		sigerr(100,CF,NS(4));
	end
elseif strcmp(swtch,'SelSig')		% Select Signals
	CF=gcf;
	NS=get(CF,'userdata');
	if isidon(NS(4))
		ss=get(NS(1),'string');
		sig=parseran(ss);
		if ~isempty(sig)&isempty(find((sig<1)&(sig>NS(3))))
			close(CF);
			[s,vars,hand]=getdata(NS(2)); 
			[nsig,t0,ofs,zo,endp,SR,ms,Ms,pit,XS,YS,PTrack]=getvars(vars);
			[id,pos,xlab,ylab]=figpar(NS(2)); 
			t0=t0+(ofs-1)/SR;
			newfig(id,['Select[',ss,']'],'Select');
			zoomplot(s(ofs:endp,sig),SR,' ',xlab,ylab,pos,t0,0);
			closepar(gcf);		
		else
			sigerr(0.6,CF);
		end
	else
		sigerr(100,CF,NS(4));
	end
elseif strcmp(swtch,'SelPoint')		% Select Point
	xy=ginp1(gcf); XL=get(gca,'XLim'); YL=get(gca,'YLim');
	if (xy(1)<XL(1))|(xy(1)>XL(2))|(xy(2)<YL(1))|(xy(2)>YL(2))
		return
	end
	chkhelp('Selecting_Points','Context');
	g=round(SR*(xy-t0)+1);
	h=get(XYc,'user'); L=size(h,2);
	if ~isempty(h), 
		if h(1,1), delete(h(1,:)); end
	end

	if (g(1)>=ofs)&(g(1)<=endp)
		for k=1:nsig
			hold on,
			h(1,k)=plot(t0+(g(1)-1)/SR,s(g(1),k),'*m');
			hold off;
			if k>L
				h(2,k)=uimenu(XYc,'Label',[num2str(k),') Sel: X=',num2str(t0+(g(1,1)-1)/SR),' Y=',num2str(s(g(1,1),k))]);
			else
				set(h(2,k),'Label',[num2str(k),') Sel: X=',num2str(t0+(g(1,1)-1)/SR),' Y=',num2str(s(g(1,1),k))],'Visible','on');
			end
		end
		set(XYc,'user',h);
	else
		h(1,1)=0;
		if L==0
			h(2,1)=uimenu(XYc,'Label',['Sel: Point Out of Range'])
		else
			set(h(2,1),'Label',['Sel: Point Out of Range']);
		end
		set(XYc,'user',h);
	end
	hU=findobj(XYc,'Tag','Unsel');
	set(hU,'Enable','on');
elseif strcmp(swtch,'Unselect')		% Unselect Point
	h=get(XYc,'user'); L=size(h,2);
	if ~isempty(h), 
		if h(1,1), delete(h(1,:)); h(1,1)=0; end
		set(XYc,'user',h);
		set(h(2,:),'Visible','off');
		hU=findobj(XYc,'Tag','Unsel');
		set(hU,'Enable','off');
	end
elseif strcmp(swtch,'SelFrame')		% Select Frame
	chkhelp('Selecting_Areas','Context');
	[L,K]=size(s);
	xy=selectw3; 
	if ~isempty(xy)
		ofs=round(SR*(xy(1)-t0)+1); 
		ofs=min([max([ofs,1]),L-1]);
		zo=floor(SR*(xy(2)-t0))-ofs+2;
		zo=max([2,min([L,zo])]);
		endp=min([ofs+zo-1,L]);
		replot(s,ofs,endp,zo,SR,ms,Ms,t0,XYc,XS,YS);
		set(C,'Value',(ofs-1)/L);
		set(Cz,'Value',1-log(zo/2)/log(L/2));
		set(CT,'String',int2str(zo));	set(CTS,'String',int2str(ofs));
		vars=[nsig; t0; ofs; zo; endp; SR; ms; Ms; pit; XS; YS; PTrack];
		putdata(s,vars,hand);
	end
elseif strcmp(swtch,'Samples')		% Samples
	chkhelp('Sample_Button'); 
	hold on;  
	plot(t0+((ofs:endp)'-1)/SR,s(ofs:endp,:),'bo');
	hold off;
elseif strcmp(swtch,'Reset')		% Signal Reset Button 
	chkhelp('Restore_Button');
	L=size(s,1);
	replot(s,1,L,L,SR,ms,Ms,t0,XYc,XS,YS);
	set(C,'Value',0);
	set(Cz,'Value',0);
	set(CT,'String',int2str(L)); set(CTS,'String','1');
	vars=[nsig; t0; 1; L; L; SR; ms; Ms; pit; XS; YS; PTrack];
	putdata(s,vars,hand);

elseif strcmp(swtch,'Play')		% Play
	chkhelp('Play');
	if nsig==1, sound8(s(ofs:endp,1),SR);
	else, sound8(sum(s(ofs:endp,:)'),SR); end

elseif strcmp(swtch,'SR')		% Change SR
	chkhelp('Sampling_Rate_Box');
	CF=gcf;
	NSR=str2num(get(SSR,'string'));
	if NSR~=SR
		if NSR>0
			replot(s,ofs,endp,zo,NSR,ms,Ms,t0,XYc,XS,YS);
			vars=[nsig; t0; ofs; zo; endp; NSR; ms; Ms; pit; XS; YS; PTrack];
			putdata(s,vars,hand);

		else
			sigerr(6.1,CF);
			set(SSR,'string',num2str(SR));
		end
	end

elseif  strcmp(swtch,'TimeShiftSli')	% Time-Shift Slider
	chkhelp('Shift_Slider');
	[L,K]=size(s);
	ofs=L*min([1,get(C,'Value')])+1;
	ofs=min([max([ofs,1]),L-1]); ofs=fix(ofs);
	endp=min([ofs+zo-1,L]);	endp=fix(endp);
	replot(s,ofs,endp,zo,SR,ms,Ms,t0,XYc,XS,YS);
	set(CTS,'String',int2str(ofs));
	vars=[nsig; t0; ofs; zo; endp; SR; ms; Ms; pit; XS; YS; PTrack];
	putdata(s,vars,hand);
elseif strcmp(swtch,'TimeShiftEd')	% Shift Edit
	chkhelp('Offset_Edit_Box');
	[L,K]=size(s);
	ofs=round(str2num(get(CTS,'String'))); 
	ofs=max([min([L-1,ofs]),1]);
	set(C,'Value',(ofs-1)/L);
	set(CTS,'String',int2str(ofs));
	endp=fix(min([ofs+zo-1,L])); 
	replot(s,ofs,endp,zo,SR,ms,Ms,t0,XYc,XS,YS);
  	vars=[nsig; t0; ofs; zo; endp; SR; ms; Ms; pit; XS; YS; PTrack];
	putdata(s,vars,hand);
elseif strcmp(swtch,'ZoomSli')		% Zoom Slider
	chkhelp('Zoom_Slider');
	[L,K]=size(s);
	zo=round(2*((L/2)^(1-get(Cz,'Value')))); 
	set(CT,'String',int2str(zo));
	endp=min([ofs+zo-1,L]); 
	replot(s,ofs,endp,zo,SR,ms,Ms,t0,XYc,XS,YS);
  	vars=[nsig; t0; ofs; zo; endp; SR; ms; Ms; pit; XS; YS; PTrack];
	putdata(s,vars,hand);
elseif strcmp(swtch,'ZoomEd')		% Zoom Edit
	chkhelp('Zoom_Edit_Box');
	[L,K]=size(s);
	zo=round(str2num(get(CT,'String'))); 
	zo=min([L,max([zo,2])]);
	set(Cz,'Value',1-log(zo/2)/log(L/2));
	set(CT,'String',int2str(zo));
	endp=fix(min([ofs+zo-1,L])); 
	replot(s,ofs,endp,zo,SR,ms,Ms,t0,XYc,XS,YS);
  	vars=[nsig; t0; ofs; zo; endp; SR; ms; Ms; pit; XS; YS; PTrack];
	putdata(s,vars,hand);
elseif strcmp(swtch,'LeftShift')	% Left-Shift Button
	chkhelp('Shift_Buttons');
	[L,K]=size(s);
	ofs=ofs-zo;
	ofs=min([max([ofs,1]),L-1]);
	endp=min([ofs+zo-1,L]);
	replot(s,ofs,endp,zo,SR,ms,Ms,t0,XYc,XS,YS);
	set(C,'Value',ofs/L);	set(CTS,'String',int2str(ofs));
  	vars=[nsig; t0; ofs; zo; endp; SR; ms; Ms; pit; XS; YS; PTrack];
	putdata(s,vars,hand);
elseif strcmp(swtch,'RightShift')	% Right-Shift Button
	chkhelp('Shift_Buttons');
	[L,K]=size(s);
	ofs=ofs+zo;
	ofs=min([max([ofs,1]),L-1]);
	endp=min([ofs+zo-1,L]);
	replot(s,ofs,endp,zo,SR,ms,Ms,t0,XYc,XS,YS);
	set(C,'Value',ofs/L); 	set(CTS,'String',int2str(ofs));
  	vars=[nsig; t0; ofs; zo; endp; SR; ms; Ms; pit; XS; YS; PTrack];
	putdata(s,vars,hand);

elseif strcmp(swtch,'Max')		% Max
	chkhelp('Select_Max');
	h=get(XYc,'user'); L=size(h,2);
	if ~isempty(h), 
		if h(1,1), delete(h(1,:)); end
	end

	for k=1:nsig
		[ma,mx]=max(s(ofs:endp,k));
		hold on,
		h(1,k)=plot(t0+(ofs+mx-2)/SR,s(ofs+mx-1,k),'*m');
		hold off;
		if k>L
			h(2,k)=uimenu(XYc,'Label',[num2str(k),') Max: X=',num2str(t0+(ofs+mx-2)/SR),'  Y=',num2str(s(ofs+mx-1,k))]);
		else
			set(h(2,k),'Label',[num2str(k),') Max: X=',num2str(t0+(ofs+mx-2)/SR),'  Y=',num2str(s(ofs+mx-1,k))],'Visible','on');
		end
	end
	set(XYc,'user',h);
	hU=findobj(XYc,'Tag','Unsel');
	set(hU,'Enable','on');
elseif strcmp(swtch,'Min')		% Min
	chkhelp('Select_Min');
	h=get(XYc,'user'); L=size(h,2);
	if ~isempty(h), 
		if h(1,1), delete(h(1,:)); end
	end

	for k=1:nsig
		[ma,mx]=min(s(ofs:endp,k));
		hold on,
		h(1,k)=plot(t0+(ofs+mx-2)/SR,s(ofs+mx-1,k),'*m');
		hold off;
		if k>L
			h(2,k)=uimenu(XYc,'Label',[num2str(k),') Min: X=',num2str(t0+(ofs+mx-2)/SR),'  Y=',num2str(s(ofs+mx-1,k))]);
		else
			set(h(2,k),'Label',[num2str(k),') Min: X=',num2str(t0+(ofs+mx-2)/SR),'  Y=',num2str(s(ofs+mx-1,k))],'Visible','on');
		end
	end
	set(XYc,'user',h);
	hU=findobj(XYc,'Tag','Unsel');
	set(hU,'Enable','on');
end