function sigedit(swtch)
%
%SIGEDIT This function is for Analyze internal use only

%Copyright (c) 1994-96 by G. Evangelista, Universita` "Federico II" di Napoli, Italia.   
%	
loadoff=['DecDlg Decimate IntDlg Interp ZeroDlg ZeroIns MergeDlg Merge Title ChangeTitle AppendDlg Append SegmDlg Segment'];
if isempty(findstr(loadoff,swtch))
	H=gcf;
	[s,vars,hand]=getdata;
	[nsig,t0,ofs,zo,endp,SR,ms,Ms,pit,XS,YS,PTrack]=getvars(vars);
	[C,Cz,Cb,Cb1,Cb2,CT,XYc,An,Uw,Rb,CTS,Hx,Hy,SSR,ext]=gethands(hand);
end
if strcmp(swtch,'Delete')		% Delete
	chkhelp('Delete');
	[L,K]=size(s);
	xy=selectw3(2);
	if isempty(xy), return; end 
	ofsd=ceil(SR*(xy(1)-t0)+1); 
	if ofsd<=L
		endpd=floor(SR*(xy(2)-t0)+1);
		if endpd>0	
			s=[s(1:ofsd-1,:); s(endpd+1:L,:)];
			[id,pos,xlab,ylab]=figpar(gcf);
			newfig(id,'Del','Del');
			zoomplot(s,SR,'Del',xlab,ylab,pos,t0,0);
			closepar(gcf);
		end
	end

elseif strcmp(swtch,'AppendDlg')		% Append
	chkhelp('Append');
	id=getfigid(gcf);
	dlg(['Append ID#',num2str(id)],'To ID#',' ','sigedit(''Append'')','CF=gcf; ud=get(gcf,''user''); f=str2num(get(ud(1),''string'')); am=id2fig(f); if am, figure(am); figure(CF); end');
	[PU,idd]=allid([10,80,300,140]); ud=get(gcf,'user'); set(gcf,'user',[ud,PU]); set(ud(1),'string',int2str(idd(1)));
	set(PU,'Callback','ud=get(gcf,''user''); idd=get(ud(3),''user''); cid=get(ud(3),''value''); set(ud(1),''string'',int2str(idd(cid)));');
elseif strcmp(swtch,'Append')			% Append Figures
	CF=gcf; a=get(CF,'userdata');
	am=id2fig(str2num(get(a(1),'string')));
	if am>0
		close(CF);
		[s,vars]=getdata(am);
		if ~isempty(s)
			figure(am);
			[nsig,t0,ofs,zo,endp,SR,ms,Ms,pit, XS, YS, PTrack]=getvars(vars);
			[id,pos,xlab,ylab]=figpar(gcf);
			figure(a(2));
			id=[id,getfigid(a(2))];
			ss=getdata;
			[R,K]=size(s);
			[RR,KK]=size(ss);
			s=[s zeros(R,KK-K)];
			s(R+1:R+RR,:)=ss; 
			newfig(id,'Append','Append');
			zoomplot(s,SR,'Append',xlab,ylab,pos,t0,1);
			closepar(gcf);
		end
	else
		sigerr(100,gcf);
	end

elseif strcmp(swtch,'MergeDlg')		% Merge
	chkhelp('Merge');
	id=getfigid(gcf);
	dlg(['Merge ID#',int2str(id)],'With ID#',' ','sigedit(''Merge'')','CF=gcf; ud=get(gcf,''user''); f=str2num(get(ud(1),''string'')); am=id2fig(f); if am, figure(am); figure(CF); end');
	[PU,idd]=allid([10,80,300,140]); ud=get(gcf,'user'); set(gcf,'user',[ud,PU]); set(ud(1),'string',int2str(idd(1)));
	set(PU,'Callback','ud=get(gcf,''user''); idd=get(ud(3),''user''); cid=get(ud(3),''value''); set(ud(1),''string'',int2str(idd(cid)));');
elseif strcmp(swtch,'Merge')		% Merge Figures
	CF=gcf; a=get(CF,'userdata');
	am=id2fig(str2num(get(a(1),'string')));
	if am>0
		close(CF);
		figure(a(2));
		[s,vars]=getdata;
		[nsig,t0,ofs,zo,endp,SR,ms,Ms,pit, XS, YS, PTrack]=getvars(vars);
		[id,pos,xlab,ylab]=figpar(gcf);
		ss=getdata(am);
		if ~isempty(ss)
			figure(am);
			id=[id,getfigid(gcf)]; 
			[R,K]=size(s);
			[RR,KK]=size(ss);
			s=[s;zeros(RR-R,K)];
			s(1:RR,K+1:K+KK)=ss; 
			newfig(id,'Merge','Merge');
			zoomplot(s,SR,'Merge',xlab,ylab,pos,t0,0);
			closepar(gcf);
		end
	else
		sigerr(100,gcf);
	end

elseif strcmp(swtch,'Split')		%Split
	chkhelp('Split');
	[id,pos,xlab,ylab]=figpar(gcf);
	for k=1:nsig
		F(k,1)=newfig(id,['Split[',num2str(k),']'],'Split');
	end
	tile2(F); 
	for k=1:nsig
		figure(F(k));
		pos=get(gcf,'position');
		zoomplot(s(:,k),SR,'',xlab,ylab,pos,t0,1);
		closeall(F,F(k),'CloseSplit');
	end	


elseif strcmp(swtch,'SegmDlg')		%Segment Signal Dialog
	chkhelp('Segment');
	dlg('Segment Signal','Segment Length (sam.)',' ','sigedit(''Segment'');','');
elseif strcmp(swtch,'Segment')		%Segment Signal
	CF=gcf;
	h=get(CF,'userdata'); P=str2num(get(h(1),'string')); 
	if fix(P)>1
		close(CF);
		figure(h(length(h))); h(length(h));
		CF=gcf; 	
		[id,pos,xlab,ylab]=figpar(gcf);
		[s,vars,hand]=getdata;
		R=size(s,1); 
		[nsig,t0,ofs,zo,endp,SR,ms,Ms,pit]=getvars(vars);
		S=remap([s(ofs:endp,:);zeros(R-P*floor(R/P),nsig)],P,1);
		newfig(id,'Segm','Segm');
		zoomplot(S,SR,'Segm',xlab,ylab,pos,t0,1);
		closepar(gcf);
	else
		sigerr(33.1,CF,P);
	end	
elseif strcmp(swtch,'Juxt')		%Juxtapose Signals
	chkhelp('Juxtapose');
	if nsig>1
		[id,pos,xlab,ylab]=figpar(gcf);
		newfig(id,'Juxt','Juxt');
		zoomplot(s(:),SR,'Juxt.',xlab,ylab,pos,t0,1);
		closepar(gcf);
	end
elseif strcmp(swtch,'Reverse')			% Reverse
	chkhelp('Reverse');
	s=s(endp:-1:ofs,:);  t0=t0+(ofs-1)/SR;
	[id,pos,xlab,ylab]=figpar(gcf);
	newfig(id,'Rev','Rev');
	zoomplot(s,SR,'Rev.',xlab,ylab,pos,t0,1);
	closepar(gcf);
elseif  strcmp(swtch,'ZeroDlg')		% Insert zeros Dialog
	chkhelp('ZeroInsert');
	id=getfigid(gcf);
	dlg('Insert Zeros','Length (sam.)',' ','sigedit(''ZeroIns'')','');
elseif  strcmp(swtch,'ZeroIns')		% Insert zeros
	CF=gcf; a=get(CF,'userdata');
	av=str2num(get(a(1),'string'));
	[s,vars]=getdata(a(2));
	[nsig,t0,ofs,zo,endp,SR,ms,Ms,pit, XS, YS, PTrack]=getvars(vars);
	if av>0
		close(CF)
		g=round(SR*(ginput(1)-t0)+1);
		g(1)=min([max([g(1),1]),size(s,1)+1]);
		s=[s(1:g(1)-1,:); zeros(av,size(s,2)); s(g(1):size(s,1),:)];
		[id,pos,xlab,ylab]=figpar(a(2));
		newfig(id,'ZeroIns.','ZeroIns');
		zoomplot(s,SR,'',xlab,ylab,pos,t0,0);
		closepar(gcf);
	else
		sigerr(7.7,CF);
	end
elseif strcmp(swtch,'DecDlg')			% DecimateDialog
	chkhelp('Decimate');
	id=getfigid(gcf);
	dlg('Decimate','Downsampling (sam.)',' ','sigedit(''Decimate'')','');
elseif strcmp(swtch,'Decimate')			% Decimate
	CF=gcf; a=get(CF,'userdata');
	if ~(exist('decimate')==2), 
		sigerr(3500,CF);
		return
	end
	av=str2num(get(a(1),'string'));
	[s,vars]=getdata(a(2));
	[nsig,t0,ofs,zo,endp,SR,ms,Ms,pit, XS, YS, PTrack]=getvars(vars);
	if av>0
		close(CF)
		if (endp-ofs)>=24
			for k=1:nsig
				ss(:,k)=decimate(s(ofs:endp,k),av);
			end
			t0=t0+(ofs-1)/SR;
			[id,pos,xlab,ylab]=figpar(a(2));
			newfig(id,'Decimate','Dec');
			zoomplot(ss,SR/av,'',xlab,ylab,pos,t0,0);
		else
			sigerr(7.57,gcf);
		end
	else
		sigerr(7.56,CF,av);
	end
elseif strcmp(swtch,'IntDlg')			% Interpolate Dialog
	chkhelp('Interpolate');
	id=getfigid(gcf);
	dlg('Interpolate','Upsampling (sam.)',' ','sigedit(''Interp'')','');
elseif  strcmp(swtch,'Interp')			% Interpolate
	CF=gcf; a=get(CF,'userdata');
	if ~(exist('interp')==2), 
		sigerr(3500,CF);
		return
	end
	av=str2num(get(a(1),'string'));
	[s,vars]=getdata(a(2));
	[nsig,t0,ofs,zo,endp,SR,ms,Ms,pit, XS, YS, PTrack]=getvars(vars);
	if av>0
		close(CF)
		if (endp-ofs)>=8
			for k=1:nsig
				ss(:,k)=interp(s(ofs:endp,k),av);
			end
			t0=t0+(ofs-1)/SR;
			[id,pos,xlab,ylab]=figpar(a(2));
			newfig(id,'Interp','Interp');
			zoomplot(ss,av*SR,'',xlab,ylab,pos,t0,0);
		else
			sigerr(7.57,gcf);
		end
	else
		sigerr(7.58,CF,av);
	end
elseif strcmp(swtch,'Scale1')			% Scale to [-1 1]
	chkhelp('Scale_to_1');
	MM=max(max(abs(s)));
	replot(s/MM,ofs,endp,zo,SR,ms/MM,Ms/MM,t0,XYc);
	vars=[nsig; t0; ofs; zo; endp; SR; ms/MM; Ms/MM; pit; XS; YS; PTrack];
	putdata(s/MM,vars,hand);
elseif strcmp(swtch,'Norm')			% Normalize
	chkhelp('Normalize');
	NM=norm(s);
	replot(s/NM,ofs,endp,zo,SR,ms/NM,Ms/NM,t0,XYc);
	vars=[nsig; t0; ofs; zo; endp; SR; ms/NM; Ms/NM; pit; XS; YS; PTrack];
	putdata(s/NM,vars,hand);
elseif strcmp(swtch,'Mix')			%Mixer
	chkhelp('Mixer');
	mixer(nsig,'v=get(gcf,''userdata''); scalesig(v);');
elseif strcmp(swtch,'Title')			%Title
	chkhelp('Title');
	[id,parid,Nme]=getfigid(gcf);
	dlg('Title','New Title',Nme,'sigedit(''ChangeTitle'')','',[100 100],[200 0]);
elseif strcmp(swtch,'ChangeTitle')		%Change Title
	CF=gcf; h=get(CF,'userdata');
	Nme=get(h(1),'string');
	close(CF)
	[id,parid]=getfigid(gcf);
	setfname(id,parid,Nme);
end