function sigerr(code,retfig,par)
%
%SIGERR This function is for Analyze internal use only

%Copyright (c) 1994-96 by G. Evangelista, Universita` "Federico II" di Napoli, Italia   		

if nargin>2,
	if isempty(par), par=0; end
end
if code==0
	Tit='Data Warning';
	Err='Signal is complex: imaginary data will be discarded\n';
	Err=[Err,'Max Imag. = ',int2str(par(1))];
elseif code==0.1
	Tit='DCT Error';
	Err=['Illegal block size selected: ',int2str(par(1))];
elseif code==0.6
	Tit='Select Signal Error';
	Err=['Illegal signal(s) specified'];
elseif code==6
	Tit='Pitch Error';
	Err=['Illegal pitch value specified: ',int2str(par(1))];
elseif code==6.1
	Tit='Sampling Rate Error';
	Err=['Illegal SR value specified'];
elseif code==7.56
	Tit='DownSampling Error';
	Err=['Illegal value specified: ',int2str(par(1))];
elseif code==7.57
	Tit='Decimate / Interpolate Error';
	Err='Signal (window) is too short ';
elseif code==7.58
	Tit='UpSampling Error';
	Err=['Illegal value specified: ',int2str(par(1))];

elseif code==7.7
	Tit='ZeroInsert Error';
	Err=['Illegal length specified'];
elseif code==8
	Tit='Fractal Mod. Error';
	Err=['Illegal degree specified'];
elseif code==11.1
	Tit='Filter Error';
	Err=['Illegal filter order specified: ',int2str(par(1))];
elseif code==13.05
	Tit='Pitch error detected';
	Err='Figure does not contain enough samples or no pitch detected';
elseif code==14.6
	Tit='Cepstrum Error';
	Err=['Illegal window length specified: ',int2str(par(1))];
elseif code==15.5
	Tit='Correlogram Error';
	Err=['Illegal window length specified: ',int2str(par(1))];
elseif code==17.5
	Tit='Zak Transform Error';
	Err=['Illegal window length specified: ',int2str(par(1))];
elseif code==18
	Tit='Gabor Expansion Error';
	Err=['Illegal window or parameters specified'];
elseif code==18.5
	Tit='Gabor Expansion Error';
	Err=['The Zak Transform of the Selected Window vanishes on the von Neumann lattice'];
elseif code==20.1
	Tit='Karhunen-Love Transform Error';
	Err=['Illegal block size selected: ',int2str(par(1))];

elseif code==33.1	
	Tit='Segment Error';
	Err=['Illegal segment length specified: ',int2str(par(1))];
elseif code==35	
	Tit='Constant Error';
	Err='Illegal constant value specified';
elseif code==100
	Tit='Figure Error';
	Err='Selected figure ID is not valid or currently open';
elseif code==100.1
	Tit='Figure Error';
	Err='Selected figure is empty or not a signal';
elseif code==110
	Tit='Filter Error';
	Err='Selected file is illegal';
elseif code==110.5
	Tit='Lin. Reg. Error';
	Err='You need more than two data points to compute the regression line';
elseif code==119
	Tit='Matching FIR / IIR Warning';
	Err='The frequency response to be matched has negative values\n';
	Err=[Err,'Matching magnitude ...'];
elseif code==1000
	Tit=['File Read Error: ',par];
	Err='Unsupported File Format or not a MAT-file';
elseif code==1001
	Tit=['File Read Error: ',par];
	Err='File may be corrupt or not a MatLab file';
elseif code==1002
	Tit=['File Read Error: ',par];
	Err='Error opening file';
elseif code==1003
	Tit='File Read Error';
	Err='Unexpected EOF';
elseif code==2000
	Tit='Surf/Mesh Error';
	Err='Surf or Mesh cannot be performed on scalars or vectors';
elseif code==3000
	Tit='Analyze Demo';
	Err='This function is not implemented in this unregistered version\n';
	Err=[Err,'Please, register and you will get the necessary upgrade.'];
elseif code==3500
	Tit='Signal Processing Error';
	Err='This function requires the Matlab Signal Toolbox.\n';
	Err=[Err,'This library was not found in the current path.'];
end 
%message(Tit,Err,'CF=get(gcf,''user''); close(gcf); figure(CF);',...
%	'CF=get(gcf,''user''); close(gcf); figure(CF);');
%set(gcf,'userdata',retfig); 
messageb(Tit,Err,'Ok','!',0,'appl');
if strcmp(computer,'PCWIN')&exist('msgbox.dll'), figure(retfig); 
else
	set(gcf,'user',retfig);
end