function siggen(swtch,typ)
%
%SIGGEN This function is for Analyze internal use only

%Copyright (c) 1994-96 by G. Evangelista, Universita` "Federico II" di Napoli, Italia   		

if isstr(swtch)
	txt=str2mat('SR (Hz.)','Duration (sec.)','Length (sam.)');
	if strcmp(swtch,'Wave')
		txt=str2mat(txt,'Freq. (Hz.)','Period (sam.)');
		ini=vect2str([20000;.3;4096;200;100]); n1=0;
	elseif strcmp(swtch,'Noise')
		ini=[20000;.3;4096;0;1]; n1=2;
		if strcmp(typ,'Exp_Damping')
			txt=str2mat(txt,'Freq. (Hz)','Decay (sec.)'); 
		elseif strcmp(typ,'Envelope')
			txt=str2mat(txt,'Break_Pts','Amplitude'); ini(4)=4;
		elseif strcmp(typ,'Random_Walk'),
			txt=str2mat(txt,'Starting','Step');
		elseif strcmp(typ,'Poisson_Points'),
			txt=str2mat(txt,'Amplitude','Density'); ini(4)=1;
		elseif strcmp(typ,'1/f'),
			txt=str2mat(txt,'Mean','Fract. Dim.');
		elseif strcmp(typ,'Dy-Homogeneous')
			txt=str2mat(txt,'Levels','Period (sam.)','Degree'); ini(4)=8; ini(6)=1;
		elseif strcmp(typ,'fdGn')
			txt=str2mat(txt,'Degree [-.5,.5]','Variance','Period (sam.)');
			ini=[ini;1];
		elseif strcmp(typ,'Weierstrass_Cosine')
			txt=str2mat(txt,'Contract.','Fract. Dim.'); ini(4)=5;
		else
			txt=str2mat(txt,'Mean','Variance');
		end
		ini=vect2str(ini);
	end
	dlg(['Generate ',typ,'_',swtch],txt,ini,['siggen(20,''',typ,''')'],'');
	H=get(gcf,'user');
	set(H(1),'CallBack','siggen(1)','Foreground','r');
	set(H(2),'CallBack','siggen(2)','Foreground','r');
	set(H(3),'CallBack','siggen(3)');
	set(H(4),'Callback',['siggen(',int2str(4+n1),');'],'Foreground','r');
	set(H(5),'Callback',['siggen(',int2str(5+n1),');']);
	if length(H)>6
		set(H(6),'Foreground','r','Callback','siggen(8)');
	end
	if n1==2, set(H(5),'Foreground','r'); end
	set(gcf,'user',[H n1*10]);
elseif swtch==0
	G=uimenu(typ,'Label','Generate');
	uimenu(G,'Label','Sine_Wave','Callback','chkhelp(''Wave''); siggen(''Wave'',''Sine'');');
	uimenu(G,'Label','Square_Wave','Callback','chkhelp(''Wave''); siggen(''Wave'',''Square'');');
	uimenu(G,'Label','Triang_Wave','Callback','chkhelp(''Wave''); siggen(''Wave'',''Triang'');');
	uimenu(G,'Label','Ramp_Wave','Callback','chkhelp(''Wave''); siggen(''Wave'',''Ramp'');');
	uimenu(G,'Label','Pulse_Wave','Callback','chkhelp(''Wave''); siggen(''Wave'',''Pulse'');');
	uimenu(G,'Label','Exp_Damping','Callback','chkhelp(''Exp_Damping''); siggen(''Noise'',''Exp_Damping'');');
	uimenu(G,'Label','Envelope','Callback','chkhelp(''Envelope''); siggen(''Noise'',''Envelope'');');
	uimenu(G,'Label','Gaussian_Noise','Callback','chkhelp(''Random_Noise''); siggen(''Noise'',''Normal'');');
	uimenu(G,'Label','Uniform_Noise','Callback','chkhelp(''Random_Noise''); siggen(''Noise'',''Uniform'');');
	uimenu(G,'Label','Random_Walk','Callback','chkhelp(''Random_Walk''); siggen(''Noise'',''Random_Walk'');');
	uimenu(G,'Label','Poisson_Points','Callback','chkhelp(''Poisson_Points''); siggen(''Noise'',''Poisson_Points'');');
	uimenu(G,'Label','1/f_Noise','Callback','chkhelp(''OneOverF_Noise''); siggen(''Noise'',''1/f'');');
	uimenu(G,'Label','fdGn','Callback','chkhelp(''fdGn''); siggen(''Noise'',''fdGn'');');
	uimenu(G,'Label','Dy-Homogeneous_Noise','Callback','chkhelp(''DyHomog_Noise''); siggen(''Noise'',''Dy-Homogeneous'');');
	uimenu(G,'Label','Weierstrass_Cosine','Callback','chkhelp(''Weierstrass_Cosine''); siggen(''Noise'',''Weierstrass_Cosine'');');
elseif swtch==1			% Change SR
	H=get(gcf,'user'); 
	SR=str2num(get(H(1),'String'));	
	if SR>0
		siggen(2);
		if H(length(H))<19, siggen(4); end
	else
		set(H(1),'String','');
	end
elseif swtch==2			% Change Duration
	H=get(gcf,'user'); 
	Tme=str2num(get(H(2),'String'));
	if Tme>0
		SR=str2num(get(H(1),'String'));	
		set(H(3),'String',int2str(Tme*SR));
	else
		set(H(2),'String','');
	end
elseif swtch==3			% Change Size
	H=get(gcf,'user'); 
	Sze=str2num(get(H(3),'String'));
	if Sze>0,
		SR=str2num(get(H(1),'String'));	
		set(H(2),'String',num2str(Sze/SR));
	else
		set(H(3),'String','');
	end
elseif swtch==4			% Change Freq.
	H=get(gcf,'user');
	SR=str2num(get(H(1),'String'));
	F=str2num(get(H(4),'String'));	
	if F>0
		set(H(5),'String',num2str(SR/F));
	else
		set(H(4),'String','');
	end
elseif swtch==5				% Change Period
	H=get(gcf,'user'); 
	SR=str2num(get(H(1),'String'));
	P=str2num(get(H(5),'String'));
	if P>0
		set(H(4),'String',int2str(SR/P));
	else
		set(H(5),'String','');
	end
elseif swtch==6				% Change Mean
	H=get(gcf,'user');
	M=str2num(get(H(4),'String'));
	if isempty(M)
		set(H(4),'String','');
	end
elseif swtch==7				% Change Variance
	H=get(gcf,'user');
	V=str2num(get(H(5),'String'));
	if isempty(V)|(V<0)
		set(H(5),'String','');
	end
elseif swtch==8				% Change Extra Parameter
	H=get(gcf,'user');
	X=str2num(get(H(6),'String'));
	if isempty(X)|(X<=0)
		set(H(6),'String','');
	end

elseif swtch==20			% Build Signal
	CF=gcf;
	H=get(CF,'user');
	SR=str2num(get(H(1),'String'));
	Sze=str2num(get(H(3),'String'));
	if (Sze>0)&(SR>0)
		F=str2num(get(H(4),'String')); M=F;
		V=str2num(get(H(5),'String'));
		close(CF);
		%hlp=ishlp;
		if strcmp(typ,'Sine')
			zoomplot(sin(2*pi*F*(0:Sze-1)/SR),SR,'Sine_Wave');
		elseif strcmp(typ,'Square')
			s=rem(F*(0:Sze-1)/SR,1);
			q=find(s>.5); s=ones(size(s)); s(q)=-ones(size(q));
			zoomplot(s,SR,'Square_Wave');
		elseif strcmp(typ,'Triang')
			s=rem(F*(0:Sze-1)/SR,1);
			q=find(s>.5); s(q)=1-s(q); s=4*(s-.25);
			zoomplot(s,SR,'Triang_Wave');
		elseif strcmp(typ,'Ramp')
			zoomplot(rem(F*(0:Sze-1)/SR,1),SR,'Ramp_Wave');
		elseif strcmp(typ,'Pulse')
			s=zeros(Sze,1); s(1:V:Sze,1)=ones(ceil(Sze/V),1);
			zoomplot(s,SR,'Pulse_Wave');
		elseif strcmp(typ,'Exp_Damping')
			zoomplot(exp(-(0:Sze-1)/(V*SR)).*cos(2*pi*M*(0:Sze-1)/SR),SR,'Exponential_Damping');
		elseif strcmp(typ,'Envelope')
			sigerr(3000,gcf); return
		elseif strcmp(typ,'Normal')
			zoomplot(sqrt(V)*randn(Sze,1)+M,SR,'Gaussian_Noise');
		elseif strcmp(typ,'Uniform')
			zoomplot(2*sqrt(3*V)*(rand(Sze,1)-.5)+M,SR,'Uniform_Noise');
		elseif strcmp(typ,'Random_Walk')
			sigerr(3000,gcf); return
		elseif strcmp(typ,'Poisson_Points')
			s=zeros(Sze,1);
			ii=Sze*rand(V*Sze,1); s(round(ii)+1)=M*ones(size(ii));
			zoomplot(s,SR,'Poisson_Points');
		elseif strcmp(typ,'1/f')
			sigerr(3000,gcf); return
		elseif strcmp(typ,'fdGn');
			sigerr(3000,gcf); return
		elseif strcmp(typ,'Dy-Homogeneous')
			sigerr(3000,gcf); return
		elseif strcmp(typ,'Weierstrass_Cosine')
			sigerr(3000,gcf); return
		end
	end
end