function TT=windower(H,swtch,param)
%
%WINDOWER This function is for Analyze internal use only

%Copyright (c) 1994-96 by G. Evangelista, Universita` "Federico II" di Napoli, Italia   		

MAXMEN=20;
if nargin<2,
	Q=uimenu(H,'Label','AllWindows');
	set(Q,'tag','AllWin');
	T='Q = findobj(gcf,''tag'',''AllWin'');';
	uimenu(Q,'Label','<<Update>>','Callback',['chkhelp(''Update_Figure_List'');',T,'windower(Q,0);']); 
	uimenu(Q,'Label','<<Close Marked>>','Callback',['chkhelp(''Close_Marked'');',T,'windower(Q,5,''on'');']);
	uimenu(Q,'Label','<<Keep Marked>>','Callback',['chkhelp(''Keep_Marked'');',T,'windower(Q,5,''off'');']);
	uimenu(Q,'Label','<<Tile Marked>>','Callback',['chkhelp(''Tile_Marked'');',T,'windower(Q,6,1);']);

elseif swtch==0		% Update
	w=get(0,'Children');
	cw=find(w==gcf);
	w=[w(1:cw-1); w(cw+1:length(w))];
	L=length(w); R=ceil(L/MAXMEN); K=rem(L,MAXMEN); k=0; t=0;
	CC=get(H,'user');
	LC=length(CC); 
	for r=0:R-1
		for t=1:min([MAXMEN,L-r*MAXMEN])
			k=k+1;
			s=get(w(k),'Name');
			if isempty(s), s=['Figure No.',int2str(w(k))]; end
			if t>LC, 
				Q=uimenu(H,'Label',s,'user',w(k),'Separator','off');
				mm=get(H,'user'); set(H,'user',[mm Q]); drawnow;
			else 
				Q=CC(t); set(Q,'Visible','on');
				set(Q,'Label',s,'user',w(k),'Separator','off','Checked','off'); drawnow; 
			end
			if (r==0)&(t==1), set(Q,'Separator','on'); end
			tagstr=['AllWin',int2str(r),'_',int2str(t)];
			set(Q,'tag',tagstr);
			T=['Q = findobj(gcf,''tag'',''',tagstr,''');'];
			%T=sprintf('Q=%6.20g;',Q);
			CQ=get(Q,'Children'); 
			if length(CQ)<2
				uimenu(Q,'Label','Goto','Callback',[T,'windower(Q,1)']);
				uimenu(Q,'Label','Mark','Callback',[T,'windower(Q,4)']); drawnow;
			else
				set(CQ(2),'Label','Goto','Callback',[T,'windower(Q,1)']);
				set(CQ(1),'Label','Mark','Callback',[T,'windower(Q,4)']);
				if length(CQ)>2, set(CQ(3:length(CQ)),'visible','off'); end
				drawnow;
			end
		end
		if (k<L),
			t=t+1; 
			if t>LC
				QQ=uimenu(H,'Label','More...','Separator','on');
				mm=get(H,'user'); set(H,'user',[mm QQ]); drawnow;
				H=QQ;
			else
				H=CC(t); set(H,'Visible','on');
				set(H,'Label','More...','Separator','on','Checked','off'); drawnow;
				%CCC=get(H,'Children'); 
				%if ~isempty(CCC), set(CCC,'visible','off'); end
				%if LC>0, set(CC(1:LC),'visible','off'); LC=0; end
			end
			%t=t+1; 
			%if t<=LC, set(CC(t:LC),'visible','off'); end
			CC=get(H,'user');	
			LC=length(CC); 
		end
	end
	t=t+1;
	if t<=LC, 
		set(CC(t:LC),'Checked','off','visible','off'); 
		set(CC(t:LC),'visible','off');  % duplicate to fix apparent bug
		drawnow;
	end

elseif swtch==1		% Goto
	chkhelp('GoTo');
	w=get(H,'user');
	if isfig(w)
		B=findback(w); 
		if ~isempty(B)
			set(B,'user',getfigid(gcf),'Enable','on'); 
		end
		figure(w); 
	else set(H,'Enable','off'); end
elseif swtch==4
	chkhelp('Mark');
	w=get(H,'user');
	if isfig(w), 
		if strcmp(get(H,'Checked'),'off')
			set(H,'Checked','on');
		else
			set(H,'Checked','off');
		end
	else
		set(H,'Enable','off');
	end
elseif swtch==5		% Close or Keep marked
	w=get(H,'Children');
	for k=1:length(w)
		if strcmp(get(w(k),'Label'),'More...')
			windower(w(k),5,param);
		else
			if strcmp(get(w(k),'Visible'),'on')&strcmp(get(w(k),'Checked'),param)
				Q=get(w(k),'user');
				if isfig(Q), close(Q); end
				if ~isempty(Q), set(w(k),'Enable','off','Checked','off'); end
			end
		end
	end
elseif swtch==6		% Tile marked
	w=get(H,'Children');
	for k=1:length(w)
		if strcmp(get(w(k),'Label'),'More...')
			TT=[TT windower(w(k),6,0)];
		else
			if strcmp(get(w(k),'Checked'),'on')
				Q=get(w(k),'user');
				if isfig(Q), TT=[TT Q]; end
			end
		end
	end
	if param
		TT=[TT gcf];
		tile2(TT'); for k=1:length(TT), figure(TT(k)); end
	end
end
