echo on

% This computes the numeric lowpass filter whose specifications
% are:
%
%	passband: 0-40 Hz	attenuation: 0.1 dB
%	stopband: 45-180 Hz	attenuation: 60 dB
%	sample frequency: 360 Hz
%
% Call ELLIPORD.M, to get the minimal degree of the elliptic
% filter which allow to verify these specifications

[N,Wn]=ellipord(40/180,45/180,0.1,60);

% The minimal degree should be 9. The computed degree is:
N

% system paused. Press any key to continue...
pause
%
% Call to ELLIPFIX.M, to get the optimized z-transfert function

[B,A]=ellipfix(9,60,40/180,45/180);

% Plots the Bode graph:

[H,W]=freqz(B,A);
H=20*log10(abs(H));
semilogx(W/pi*180,H);
grid;

% System paused. Press any key to continue...
pause

% Plots a zoom in the passband:

nf=sum(H>-0.1);
semilogx(W(1:nf)/pi*180,H(1:nf));
grid;

% End.

	