function x=fconv(y, h);

% FCONV	Convolution and polynomial multiplication.
% 	C = FCONV(A, B) convolves vectors A and B.  The resulting
% 	vector is length LENGTH(A)+LENGTH(B)-1.
% 	If A and B are vectors of polynomial coefficients, convolving
% 	them is equivalent to multiplying the two polynomials.
%	If input real then so is Output.
%
%	David Lopes - 26/11/96 - ISVR, University of Southampton, England.

% Zero Pad, FT and IFT
yt=[y, 0*(2:size(h,2))];	ht=[h, 0*(2:size(y,2))];
Y=fft(yt);	H=fft(ht);	t=Y.*H;	
x=ifft(t);

% Output real if Input
if (all(~imag(y))) & (all(~imag(h)))
	x=real(x);
end;