
% Declare all of the global variables.  This is useful when debugging:
% just type opGlobals to make them all accessible.

% Comments starting with () mean the variable is a vector, with one
% value per channel.

global opc		% current channel number
global opAxes		% bounding box of image
global opBrightness	% () current setting of the brightness slider
global opCacheData1	% spectrogram values; also opCacheData2, 3, ..., 8
global opCacheIndex	% cache indices; rows are frame#, timestamp
global opCacheIndex1	% per-chan index; also opCacheIndex2, 3, ..., 8
global opChannelCount	% number of channels in sound file
global opChannelNum	% channel number(s) currently displayed (sorted)
global opColor 		% highlight color
global opColorDepth	% depth of highlighting
global opColorMapName	% function name for generating colormap, e.g. 'gray'
global opContrast	% () current setting of the contrast slider
global opControls	% vector of control objects (buttons, sliders, etc.)
global opDataSize	% () samples per spect frame
global opDefaultWinPos	% size of brand-new windows, [left bot wide high]
global opEpsDir		% dir to save EPS files in
global opEpsMargin	% print margin around EPS images
global opF0 opT0	% () portion of the signal on-screen
global opF1 opT1
global opFileMenu       % menu-bar 'File' menu (to test existence of menus)
global opHCrunchIcon	% that image of a hand squashing the Z
global opHiLimit	% () max value displayable via colormap hacks
global opHopSize	% () hop size factor, default 1/2
global opHScrollSkip	% amount of image motion for click in h scroll bar
global opHZoomIcon	% that image of a hand stretching the Z
global opIconColorMap	% six-element colormap for the zoom/crunch hand icon
global opLastClick	% () last point clicked with mouse, [x y]
global opLog		% data log values
global opLogP		% right-click is extend-sel (0) or add-to-datalog (1)
global opLogPrev	% set of measures for current values in data log
global opLogChanged	% 1 if log has changed since last save
global opLoLimit	% () min value displayable via colormap hacks
global opMeas		% () boolean vector of which measures to show
global opMeasureSel	% boolean vector of which measures are about selection
global opMeasureGram	% boolean vector of which measures need gram of sel
global opMeasureNames	% string matrix
global opMeasurePos	% () vector of [left top] values
global opMousePos	% () position of last mouse click
global opNonSelCount	% number of non-datalog right clicks in a row
global opNsamp		% () number of smaples in the sound
global opPlayRate	% () playback rate number (popup choice - 1)
global opPlayOthers	% extra user-specified play rate factors, initially []
global opPrefDir	% directory prefs were last saved/loaded in
global opPrintMargin	% size of margin (inches) around edges of printed page
global opPsType		% prefSave: window size/duration/scaling interactions
global opPsWin		% the 'save prefs' dialog box
global opPsWinPos	% position of former opPsWin
global opPsChan		% channel to save in a 'save prefs'
global opPsButton	% buttons on the 'save prefs' dialog box
global opPsName		% names for the opPsButtons
global opPsValue	% values (0 or 1) to initialize opPsButtons with
global opSelT0 opSelF0	% () selection box
global opSelT1 opSelF1
global opShareColors	% share colormap entries with other windows?
global opSignal		% for showing sample vector instead of file of samples
global opSoundFile1	% chan 1 sound file name; also opSoundFile2, 3, ..., 8
global opSpectFile1	% chan 1 spect file name; also opSpectFile2, 3, ..., 8
global opSpectParams	% () spect file params
global opSpectVer	% () spect file version
global opSrate		% () sampling rate, samples/s
global opTempTime	% seconds that datalog/extend-select message displayed
global opTimeStamp	% counter for flushing old spectrogram frames
global opTMax		% () the end of time
global opVCrunchIcon	% that image of a hand squashing the Z
global opVScrollSkip	% amount of image motion for click in v scroll bar
global opVZoomIcon	% that image of a hand stretching the Z
global opWinType	% () 1=kaiser, 2=bartlett, etc.  See opWinTypeF.
global opZeroPad	% () zero pad factor, default 0
global opZoomIcon	% that image of hand stretching the Z (qv opCrunchIcon)

% User interface objects.
global opDataSizePopup opHopSizePopup opZeroPadPopup opWinTypePopup
global opHScrollBar opVScrollBar opContrastSlider opBrightnessSlider
global opFig opPlayBut opContrastText opBrightnessText opSliderValues
global opPlayRateMenu opMeasureMenus opMeasureTexts opMeasureNums opWindowAxes
global opHScrollMenu opVScrollMenu opPrefMenus opDataLogMenu opImages
global opChannelMenu
