function opInitFigure(windowname)
% opInitFigure(windowname)
% Draw the main Osprey window, with buttons and sliders and so on.
%
% See also opOpen.

global opFig opAxes opMeasureTexts opMeasureNums opShareColors opDefaultWinPos

menu_bug_correction = [-5 50];	   % MATLAB bug: windows are displaced this much

if (opExists(1) > 0)
  set(opFig, 'Visible', 'on');
  if (gcf ~= opFig)
    figure(opFig); 
  end

else
  opFig = figure('Units', 'pixels');
  set(opFig, 'Position', opDefaultWinPos + [menu_bug_correction 0 0]);
  opAxes = -1;
end

set(opFig, 'Name', windowname, 'NumberTitle', 'off', 'Units', 'pixels',...
    'Resize', 'on', 'Pointer', 'crosshair', 'Visible', 'on', ...
    'ShareColors', iff(opShareColors, 'yes', 'no'), 'NextPlot', 'new');
