function opNewChan(ch)
% Initialize things for a new channel number, and make that channel
% the current one.  Nothing is known about the new sound yet.

global opc opF0 opF1 opT0 opT1 opSrate opNsamp
global opSelT0 opSelT1 opSelF0 opSelF1 opAxes opMousePos
global opDataSize opHopSize opZeroPad opWinType opBrightness opContrast
global opHScrollSkip opVScrollSkip opSpectParams
global opColorDepth opColor opPrintMargin opTMax opPlayRate opShareColors
global opLog opLogP opLogChanged opChannelNum opLastClick opEpsMargin
global opDefaultWinPos opColorMapName

% Set the popup data to the default values.
if (opExists(ch) < 2)
  opHopSizeF('default', ch);
  opWinTypeF('default', ch);
  opDataSizeF('default', ch);
  opZeroPadF('default', ch);
end

% assume new channel number is previous one plus 1
opFileName(ch, 'setsound','');
opFileName(ch, 'setspect','');
opF0(ch)	= 0;  opF1(ch) = 100;
opT0(ch)	= 0;  opT1(ch) = 100;
opSelF0(ch)	= 0;  opSelF1(ch) = -1;
opSelT0(ch)	= 0;  opSelT1(ch) = -1;
opSrate(ch)	= 100;
opNsamp(ch)	= 100;
opTMax(ch)	= 1;
%opAxes(ch)	= -1;
opContrast(ch)	= 0.5;
opBrightness(ch)= 0.5;
opLoLimit(ch)	= 0;
opHiLimit(ch)	= 0;
opPlayRate(ch)	= 1;
opMousePos(ch,1:4) = [Inf Inf Inf Inf];		% flag values; see opMouseClick
opCacheData(ch, 'iclear');
if (~exist('opHScrollSkip')),	opHScrollSkip = 0.75;		 end
if (~exist('opVScrollSkip')),	opVScrollSkip = 0.5;		 end
if (~exist('opColor')), 	opColor       = [1 1 0];	 end
if (~exist('opColorDepth')),	opColorDepth  = 0.4;		 end
if (~exist('opColorMapName')),	opColorMapName='flipud(gray(n))';end
if (~exist('opPrintMargin')),	opPrintMargin = [1.0 .73 .5 .5]; end  % L,B,R,T
if (~exist('opEpsMargin')),	opEpsMargin   = [0.5 0.4 0  0 ]; end  % L,B,R,T
if (~exist('opShareColors')),	opShareColors = 0;		 end
if (~exist('opLogP')),          opLogP = 0;			 end
opLog		= [];
opLogChanged	= 0;
opSpectParams(ch, 1:5) = zeros(1,5);
opChannelNum    = 0;
opLastClick     = [];
opDefaultWinPos = [30 100 800 400];		% size of brand-new window
%opDefaultWinPos = [15 10 1120 390];		% size of brand-new window

opc = ch;
