function opRefresh(ch, newspect, setbc)
% opRefresh(ch)
% Refresh the image for the channel ch, assuming something 
% like brightness or contrast has changed.
%
% opRefresh(ch, 1)
% Recalculate the spectrogram (after something like hopsize has changed)
% (i.e. flush the cache) and refresh the image.
%
% opRefresh(ch, 1 or 0, setbc)
% If a third argument is present and non-zero, set default initial
% brightness/contrast values.

if (nargin < 2), newspect = 0; end
if (nargin < 3), setbc    = 0; end

if (newspect)
  opCacheData(ch, 'iclear');
end

opRefChan(ch, setbc);
