function y = isprime(x)
%ISPRIME	Is a given number prime?
%
% y = isprime(x)
% Returns 1 or 0 according to whether x is prime.  
% If x is a matrix, y is a matrix of the same size.

y = zeros(size(x));
for i = 1:prod(size(x))
  n = x(i);
  y(i) = all(rem(n, [2,3:2:sqrt(n)]));
end

% 1 is not a prime number, 2 is.
y = y & (x > 1) | (x == 2);
