function printf(fmt, a0,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16)
% PRINTF(format, args...)
% This is just like disp(sprintf(format, args...)), except that it
% allows up to 17 args instead of the 3 sprintf gives you.
% It's often better than disp([ ... ]) because numbers are shown
% better than with num2str.
%
% If any numeric-format arg is a vector or matrix, the numbers are printed
% one after another, separated by spaces, using the corresponding character
% from the format string.  This is usually better than what sprintf does,
% which is to cycle through the format string for each successive number.
%
% Use %f or %g as the format, since floats are the only data types in Matlab.
% Also %s works, but you can't specify a format control (like %-20s) for it.
%
% Unlike C's printf, this one always puts a newline afterwards.  Unavoidable.
% Always prints a newline, so just saying 'printf' gives you a blank line.
%
% See also sprintf, disp, num2str.

if (nargin < 1), disp(' '); return; end

str = '';
n = 0;
while (length(fmt) > 0),
  p = strindex(fmt, '%');
  if (~p | p == length(fmt)),
    str = [str, fmt];
    fmt = '';
  elseif (fmt(p+1) == '%')
    str = [str, fmt(1:p)];
    fmt = fmt(p+2:length(fmt));
  else
    if (n >= 0 & n <= 16)
      eval(['y = a' int2str(n) ';']);
    else 
      error('Something''s wrong.'); 
    end
    n = n+1;
    if (fmt(p+1) == 's')
      str = [str, fmt(1:p-1), y];
      fmt = fmt(p+2:length(fmt));
    else
      done = 0;
      for x = p(1) : length(fmt)
        if (isletter(fmt(x))),
          str = [str, fmt(1:p(1)-1), sprintf([fmt(p(1):x) ' '], y)];
	  str(length(str)) = [];		% remove trailing blank
          fmt = fmt(x+1:length(fmt));
          done = 1;
          break
        end
      end
      if (~done),
        str = [str, fmt];
        fmt = '';
      end
    end
  end
end

if (length(str) == 0), str = ' '; end
disp(str)
