function soundOut(filename, data, sRate, offset, pOut)
%soundIn         Write part or all of a sound file. Knows several file formats.
%
% sound = soundOut(filename, sound, sRate)
% Write sound from the given sound vector(s) to the given filename.
% Works for binary and AIFF files; hopefully more formats will be added soon.

if (nargin < 4), offset = 0; end
if (nargin < 5), pOut = 1; end

typ = soundFileType(filename);

if (strcmp(typ, 'aif'))
  aiffwrite(filename, data, sRate);

elseif (strcmp(typ, 'binary'))
  writeBinary(filename, offset * 2, data, 's', 1);
  
else
  error(['Unknown file format for extension ''' typ '''.']);
end
