function [f,p] = uigetfile1(filterSpec, dialogTitle)
%UIGETFILE1	Display centered dialog box, interactively retrieve a filename
%
% [filename,pathname] = uigetfile1(filterSpec, dialogTitle)
% This is just like uigetfile (q.v.), but the dialog box is approximately
% centered instead of appearing in the upper-left corner.
%
% See also uigetfile, uiputfile1, uiputfile.

w = 400;		% no way to find out dialog box size; let's guess this
h = 400;
s = get(0, 'ScreenSize');
[f,p] = uiputfile(filterSpec, dialogTitle, (s(3)-w)/2, (s(4)-h)/2);
