function [f,p] = uiputfile1(initFile, dialogTitle)
%UIPUTFILE1	Display centered dialog box, interactively retrieve a filename
%
% [filename,pathname] = uiputfile1(initFile, dialogTitle)
% This is just like uiputfile (q.v.), but the dialog box is approximately
% centered instead of appearing in the upper-left corner.
%
% See also uiputfile, uigetfile1, uigetfile.

w = 400;		% no way to find out dialog box size; let's guess this
h = 400;
s = get(0, 'ScreenSize');
[f,p] = uiputfile(initFile, dialogTitle, (s(3)-w)/2, (s(4)-h)/2);
