% This is the test program for M-file sirps which shows samples of
% SIRPS-like signals.
%
%        Written by: Martin Werner
%        Email address: werner@nt.e-technik.uni-erlangen.de
%        24Jul91
%
% A test program for M-file SIRPS which shows samples of SIRP-like signals
% mw24-jul-91

M=2000; x=1:M; clg;

% synthesis filter (AR model)
numer=.240638;
denom=[1. -1.821 1.656 -1.436 1.444 -1.365 1.282 -.9123 .6471 -.5336 .2941];

[sl,inicondl,sigmal]=sirps(M,'l',0,numer,denom);
plot(x,sl,x,sigmal,'g',x,-sigmal,'g--');grid
xlabel('k->');
ylabel('s(k)->');
title('SIRP-like signal s(k) and sample of sigma process');
text(1650,4.5,'Laplace')
[sk,inicondk,sigmak]=sirps(M,'k',0,numer,denom);
[sg,inicondg,sigmag]=sirps(M,'g',0,numer,denom);
[ss,iniconds,sigmas]=sirps(M,'s',0,numer,denom);
text(1950,-6,'*');
pause; axis([0 M -5 5]); clg;

subplot(221),plot(x,sl,x,sigmal,'g',x,-sigmal,'g--');grid
xlabel('k->');
ylabel('s(k)->');
text(1300,4,'Laplace')
plot(x,sk,x,sigmak,'g',x,-sigmak,'g--');grid
xlabel('k->');
ylabel('s(k)->');
text(1300,4,'K0')
plot(x,sg,x,sigmag,'g',x,-sigmag,'g--');grid
xlabel('k->');
ylabel('s(k)->');
text(1300,4,'Gamma')
plot(x,ss,x,sigmas,'g',x,-sigmas,'g--');grid
xlabel('k->');
ylabel('s(k)->');
text(1300,4,'''speech''')
%
[sl,inicondl,sigmal]=sirps(M,'l',0,numer,denom,inicondl);
[sk,inicondk,sigmak]=sirps(M,'k',0,numer,denom,inicondk);
[sg,inicondg,sigmag]=sirps(M,'g',0,numer,denom,inicondg);
[ss,iniconds,sigmas]=sirps(M,'s',0,numer,denom,iniconds);
text(1900,-5,'*');
pause; clg; axis([M 2*M -5 5]);
subplot(221),plot(x+M,sl,x+M,sigmal,'g',x+M,-sigmal,'g--');grid
xlabel('k->');
ylabel('s(k)->');
text(3300,4,'Laplace')
plot(x+M,sk,x+M,sigmak,'g',x+M,-sigmak,'g--');grid
xlabel('k->');
ylabel('s(k)->');
text(3300,4,'K0')
plot(x+M,sg,x+M,sigmag,'g',x+M,-sigmag,'g--');grid
xlabel('k->');
ylabel('s(k)->');
text(3300,4,'Gamma')
plot(x+M,ss,x+M,sigmas,'g',x+M,-sigmas,'g--');grid
xlabel('k->');
ylabel('s(k)->');
text(3300,4,'''speech''')
text(3900,-5,'*');
pause; clg;
axis;
plot(x+M,ss,x+M,sigmas,'g',x+M,-sigmas,'g--');grid
xlabel('k->');
ylabel('s(k)->');
title('SIRP-like signal s(k) and sample of sigma process');
text(3700,2.5,'''speech''')
text(3950,-3,'*');
%
%   End of sirpstst.m
