% Signal Processing and Communications Toolbox
% Communications functions.
% Version 3.00, 4/3/94
% LT Dennis W. Brown
% Naval Postgraduate School
% Monterey, CA
%
% Communications signal generation
%   BFSKMSG    Binary phase-shift signal with message.
%   BPSK       Binary phase-shift keyed signal.
%   BPSKMSG    Binary phase-shift signal with message.
%   BFSK       Binary frequency-shift keyed signal.
%   OOKMSG     On-off keyed signal with message.
%   OOK        On-off keyed signal.
%
% Modulation
%   DSBLC      Double-sideband, large-carrier modulation.
%   DSBSC      Double-sideband, suppressed-carrier modulation.
%   MODINDEX   Modulation index.
%
% Demodulation
%   ENVELOPE   Envelope detection.
%   CORRDMOD   Correlation demodulator.
%   PRODDMOD   Product demodulator.
%
% Signal coding
%   LRS        Linear-recursive sequence.
%   MASC2STR   Modem-ASCII to string conversion.
%   STR2MASC   String to modem-ASCII conversion.
%
% Signal mixing
%   SETSNR     Set signal-to-noise ratio.
%   SETSNRBW   Set bandwidth signal-to-noise ratio.
%
% Baseband signal generation
%   ANTPODAL   Baseband anti-podal [-1,1] signal.
%   COSWAVE    Generate sampled cosine wave.
%   SAWWAVE    Generate sampled sawtooth wave.
%   SINWAVE    Generate sampled sine wave.
%   SQWAVE     Generate sampled square wave.
%   TRIWAVE    Generate sampled triangular wave.
%   UNIPOLAR   Baseband unipolar [0,1] signal.

