function answer = taylor(sll,nbar,isize)
% weights = taylor(sll,nbar,isize)


% Initialization of variables
t = 1;
answer = zeros(1,isize);


% Calculate main beam to sidelobe voltage ratio
r = 10^(sll/20);
a = acosh(r)/pi;


% Test nbar and increase if necessary
i1 = 1;
i2 = 0;

if nbar <= 0
	i1 = 0;
end

if nbar <= 1
	nbar = 2;
	i2 = 1;
end


% Calculate the zero location scaling factor
finished = 0;


while finished == 0

s = nbar/sqrt(a^2+(nbar-.5)^2);

if (s >= 1) & (s <= t)
	s = t;
	nbar = nbar-1;
	finished = 1;
elseif s < 1
	i2 = 1;
	nbar = nbar+1;
	t = s;
	if i1 ~= 0
		i1 = 0;
		i2 = 0;
	end
else
	nbar = nbar+1;
	t = s;
	if i1 ~= 0
		i1 = 0;
		i2 = 0;
	end
end
end


% Calculate the zeros of the space factor
nbarm1 = nbar-1;
z = s*sqrt(a^2+([1:nbar-1]-.5).^2);


% Calculate the space factor coefficients
factin = fact(nbarm1);
id1 = nbarm1 + [1:nbarm1];
facid1 = fact(id1);
id2 = nbarm1 - [1:nbarm1];
facid2 = fact(id2);
f = factin^2./facid1./facid2;

for n = 1:nbarm1
	p = prod(1-(n./z).^2);
	f(n) = f(n)*p;
end


% Compute the amplitude weights
d = 2*pi/(isize-1);
x = pi;
last = floor((isize+1)/2);

for j = 1:last
	g = 1;
	g = sum([1 2*f.*cos(x*[1:nbar-1])]);
	if abs(x) < 0.0001
		x = 0;
	end
	answer(j) = g;
	isizmj = isize-j+1;
	answer(isizmj) = g;
	x = x-d;
end

answer = answer*sqrt(isize/sum(answer.^2));