% TBMDISPT
% This script plots all of the targets in the range window and
% plots the current target in a highlighted color.  It also
% puts the parameters of the current target in the target
% parameter fields.

axes(rangeplot);

rangeparam = [eval(get(rangecent,'string')),...
	eval(get(rangewidth,'string'))];
rangelimits = rangeparam(1) + [-rangeparam(2) rangeparam(2)];


if currtarg > 0


% plot all of the targets
hold off;
plot([targparam(:,1)]',zeros(1,numtargs),'linestyle','x',...
	'color','cyan');


% plot the current target
axis(axis);
hold on;
plot(targparam(currtarg,1),0,'linestyle','x','color','yellow');
tbmfixrn;


% put the parameters of the current target into the fields
set(targid,'string',int2str(currtarg));
set(targrange,'string',sprintf('%.8g',targparam(currtarg,1)));
set(targrcs,'string',sprintf('%.8g',targparam(currtarg,2)));
set(targvel,'string',sprintf('%.8g',targparam(currtarg,3)));
set(targang,'string',sprintf('%.8g',targparam(currtarg,4)));


else

hold off;
plot([]);
tbmfixrn;

set(targid,'string','0');
set(targrange,'string','0');
set(targrcs,'string','0');
set(targvel,'string','0');
set(targang,'string','0');

end