% TBMFIXSP
% This script formats the spectrum window and makes sure that there are
% not too many x-labels.

set(specplot,'xlim',rangelimits,'box','on','units','pixels',...
	'xgrid','on','ygrid','on','fontsize',goodsize);
axes(specplot);
xlabel('Range (km)','fontsize',goodsize);
ylabel('Return Power (dB)','fontsize',goodsize);

numlabchars = prod(size(get(specplot,'xticklabels')));
if numlabchars > 60
	xticks = get(specplot,'xticklabels');
	[m,n] = size(xticks);
	for count = 2:2:m
		for count2 = 1:n
			xticks(count,count2) = ' ';
		end
	end
	set(specplot,'xticklabels',xticks);
end