% AVTRACK: plots waveform and rms energy (dB) per frame 
% Usage: av=avtrack(w,rate,twin,thop,plotflag);
% Peter Assmann - Dec 1 1991
function av=avtrack(w,rate,twin,thop,plotflag);
if(nargin==0)
 disp('===========================================');
 filename=input('Enter ASCII waveform filename > ','s');
 rate=input('Enter sample rate in Hz > ');
 twin=input('Enter window length in samples > ');
 thop=input('Enter number of samples between successive frames > ');
 eval(['load ',filename]);     % load waveform
 w=eval(filename(1,1:length(filename)-4));  % assume .XXX extension
end;
n = max(size(w));
if(~exist('rate')) rate=10000; end;
if(~exist('twin')) twin=5; end;
if(~exist('thop')) thop=5; end;
if(~exist('filename')) filename='Waveform'; end;
if(~exist('plotflag')) plotflag=1; end;
nwin=rate/1000*twin;
nhop=rate/1000*thop;
i1=1; iframe=0;
while i1<=n
 i2=min(i1+nwin-1,n); npts=i2-i1+1; iframe=iframe+1;
 p=sqrt( (sum(w(i1:i2).^2))/npts );
 av(iframe)=20*log10(max(p,eps));
 i1=i1+nhop;
end
nw=length(w); nav=length(av);
x=(1:nw).*(1000/rate);
if plotflag==1,
 clg;subplot(211);hold off;
 axis([0 max(x) 10*(round(min(w)/10)-1) 10*(round(max(w)/10)+1)]);
 plot(x,w);grid; hold off;
 xlabel('Time (ms)');ylabel('Amplitude');
 title(filename);        
  x=((1:nav)/nav)*max(x);
 axis([0 max(x) 0 10*(round(max(av)/10)+1)]);
 plot(x,av,'o'); hold on; plot(x,av);
 xlabel('Time (ms)');ylabel('RMS (dB)');title('RMS Amplitude');
 grid; hold off;
end;
