% T0PKR: Function to estimate f0 as the largest 
% peak in the autocorrelation function
% Usage: [f01,f02]=t0pkr(acf,flo,fhi,rate);
function [f01,f02]=t0pkr(acf,flo,fhi,rate);
n=max(size(acf));
ilo=max((rate/fhi)+1,2);
ihi=min((rate/flo)+1,n);
if (ilo<1|ihi>n) f01=0; f02=0; return; end;
x(:)=acf;
for i=1:ilo x(i)=0; end
for i=ihi+1:n x(i)=0; end
[a,i]=max(x);
if(a==0), 
 f01=0; f02=0; return; 
end;
if i>1 alo=x(i-1); else alo=i; end;
if i<n ahi=x(i+1); else ahi=i; end;
if(alo>ahi) 
 ppn=((alo-ahi)/(2*(a-ahi)));
 t=i-1-ppn;
end
if(ahi>alo)
 ppn=((ahi-alo)/(2*(a-alo)));
 t=i-1+ppn;
end
if(ahi==alo)
 t=i-1;
end
f01=rate/t;
x(i)=(x(i-1)+x(i+1))/2; 
if 2*i < n, x(2*i)=(x(2*i-1)+x(2*i+1))/2; end;
[a,i]=max(x);
if(a==0) 
 f01=0; f02=0; return; % function contains only zeros
end;
if i>1 alo=x(i-1); else alo=i; end;
if i<n ahi=x(i+1); else ahi=i; end;
if(alo>ahi) 
 ppn=((alo-ahi)/(2*(a-ahi)));
 t=i-1-ppn;
end
if(ahi>alo)
 ppn=((ahi-alo)/(2*(a-alo)));
 t=i-1+ppn;
end
if(ahi==alo)
 t=i-1;
end
f02=rate/t;


