function CommaLocs=ancomloc(CurrentData)
%ANCOMLOC Find Comma locations in a string.
%	COMMALOCS=ANCOMLOC(CURRENTDATA)finds the commas in a given string
%	that are not enclosed in brackets or parenthesis.
%
%	See also ANDRAG,ANLINE, ANPATCH, ANRECT, ANTEXT, ANOBJ.

%	Loren Dean March, 1995.
%	Copyright (c) 1995 by The MathWorks, Inc.
%
ParenFlag=0;
BrcktFlag=0;
CommaLocs=[];

for lp=2:length(CurrentData)-1,
% Opening
 if CurrentData(lp)=='(',
   ParenFlag=ParenFlag+1;
 end
 if CurrentData(lp)=='[',
   BrcktFlag=BrcktFlag+1;
 end

%Closing
 if CurrentData(lp)==')',
   ParenFlag=ParenFlag-1;
 end
 if CurrentData(lp)==']',
   BrcktFlag=BrcktFlag-1;
 end

%Location
 if BrcktFlag==0 & ParenFlag==0,
   if CurrentData(lp)==',',
     CommaLocs=[CommaLocs lp];
   end
 end
 
end % for lp
%CommaLocs=find(CurrentData==',');

