function CurrentObj=ancurobj(WorkingFig)
%ANCUROBJ Get current animation object.
%	CURRENTOBJ=ANCUROBJ(WORKINGIFG) gets the current animation object.
%
%	CURRENTOBJ is the handle of the object that is selected.
%
%	WORKINGFIG is the handle for the figure the objects are on.

%	Loren Dean   March, 1995.
%	Copyright (c) 1995 by The MathWorks, Inc.

FigData=get(WorkingFig,'UserData');
WorkingAxes=FigData(2);

AllPtData=get(WorkingAxes,'UserData');
CurrentPt=AllPtData(:,1);
[SelectColor,DeselectColor]=angetclr('#GetColor',CurrentPt);
  
CurrentObj=[];
for lp=1:length(CurrentPt),
  if strcmp('line',get(CurrentPt(lp),'Type')) | ...
     strcmp('text',get(CurrentPt(lp),'Type')) ,
    CString='Color';
  else,
    CString='FaceColor';
  end % if strcmp
  if all(SelectColor(lp,:)==get(CurrentPt(lp),CString)),
    CurrentObj=CurrentPt(lp);
    break;
  end % if SelectColor
end % for
  