function andrag(Action)
%ANDRAG	Drag objects around.
%	ANDRAG(ACTION) allows the user to drag animation objects around.
%
%	ACTION may be one of three strings:
%	  '#Motion'  Callback for mouse motion.
%	    '#Down'  Callback for button down.
%	      '#Up'  Callback for button up.
%
%	See also ANEDIT.

%	Loren Dean March,1995.
%	Copyright (c) 1995 by The MathWorks, Inc.

WorkingFig=findobj(0,'type','figure','Tag','WorkingFig');
Data=get(WorkingFig,'UserData');
WorkingAxes=Data(2);
Handle=get(WorkingFig,'CurrentObject');
XLim=get(WorkingAxes,'XLim');
YLim=get(WorkingAxes,'YLim');
ResetHandle=findobj(WorkingFig,'Type','uimenu','Tag','MenuSimulationReset');

%%%%%%%%%%%%%%
%%% Motion %%%
%%%%%%%%%%%%%%
if strcmp(Action,'#Motion'),
  
  eval('Pos=get(WorkingAxes,''CurrentPoint'');Flag=0;','Flag=1;');
  if Flag,
    andrag #Up
  else,
    PosInit=get(ResetHandle,'UserData');
    set(ResetHandle,'UserData',[Pos(1,:);PosInit(2,:)]);
   
    XOff=min(XLim(2),max(Pos(1,1),XLim(1)))- ...
         min(XLim(2),max(PosInit(1,1),XLim(1)));
    YOff=min(YLim(2),max(Pos(1,2),YLim(1)))- ...
         min(YLim(2),max(PosInit(1,2),YLim(1)));

      if strcmp(get(Handle,'Type'),'text'),
        PosNew=get(Handle,'Position')+[XOff YOff 0];
        set(Handle,'Position',PosNew);

      elseif strcmp(get(Handle,'Type'),'axes'),
        % Don't Click So FAST (This could be a bug)
        return
      else,
         XNew=get(Handle,'XData')+XOff;
         YNew=get(Handle,'YData')+YOff;
         set(Handle,'XData',XNew,'YData',YNew);
      end % if strcmp type
  end % Flag
%%%%%%%%%%%%
%%% Down %%%
%%%%%%%%%%%%
elseif strcmp(Action,'#Down'),
  if strcmp(get(WorkingFig,'SelectionType'),'normal'),    
    set(WorkingFig,'Pointer','fleur');
    set(Handle,'EraseMode','xor');
    set(WorkingAxes,'DrawMode','fast');
 
    Pos=get(WorkingAxes,'CurrentPoint');
    Pos=[Pos(1,:);Pos(1,:)];
    set(ResetHandle,'UserData',Pos);
    set(WorkingFig            , ...
       'WindowButtonUpFcn'    ,'andrag #Up'    , ...
       'WindowButtonMotionFcn','andrag #Motion', ...
       'Pointer'              ,'fleur'           ...
       );
  end % if strcmp
 
%%%%%%%%%%
%%% Up %%%
%%%%%%%%%%
elseif strcmp(Action,'#Up'),
  set(WorkingFig                    , ...
     'WindowButtonUp'       ,''     , ...
     'WindowButtonMotionFcn',''     , ...
     'Pointer'              ,'arrow'  ...
     );
     
  set(WorkingAxes,'DrawMode','normal')
  
  if Handle==WorkingAxes, % Don't click so Fast (This could be a bug)
    return
  end
  set(Handle,'EraseMode','normal');

  ResetHandle=findobj(WorkingFig,'Type','uimenu','Tag','MenuSimulationReset');
  PosInit=get(ResetHandle,'UserData');
  Pos=get(WorkingAxes,'CurrentPoint');
  
  XOff=min(XLim(2),max(Pos(1,1),XLim(1)))- ...
       min(XLim(2),max(PosInit(2,1),XLim(1)));
  YOff=min(YLim(2),max(Pos(1,2),YLim(1)))- ...
       min(YLim(2),max(PosInit(2,2),YLim(1)));
  Move=[XOff YOff 0];
  
  if any(Move),
    AxisData=get(WorkingAxes,'UserData');
    Loc=find(AxisData(:,1)==Handle);
    Type=setstr(AxisData(Loc,2:9));
    if strcmp(Type,'anline  ') | strcmp(Type,'anpatch '),
      First=2;Second=3;
    else,
      First=1;Second=2;
    end

    CurrentData=get(Handle,'UserData');
    CommaLocs=ancomloc(CurrentData);
    NewData=[CurrentData(1,1:CommaLocs(First)-1)                 '+('  ... 
             num2str(Move(1))                                     ')'  ...
             CurrentData(1,CommaLocs(First):CommaLocs(Second)-1) '+('  ... 
             num2str(Move(2))                                     ')'  ...
             CurrentData(1,CommaLocs(Second):length(CurrentData(1,:))) ...
            ];

    set(Handle,'UserData',NewData);
  end % if any
  
  andraw(WorkingFig ,Handle,XLim,YLim);
end % if strcmp action
