function anfig(Action)
%ANFIG	Perform button and keypress callbacks for animation figures.
%	ANFIG(ACTION) Performs button and keypress callbacks for animation
%	figures.
%
%	ACTION may be one of two strings:
%	       '#KeyPress'  Figure and axis key press callback.
%	 '#FigButtonPress'  Figure button press callback.
%	'#AxisButtonPress'  Axis button press callback.
%

%	Loren Dean  March, 1995.
%	Copyright (c) 1995 by The MathWorks, Inc.


WorkingFig=findobj(0,'type','figure','Tag','WorkingFig');

%%%%%%%%%%%%%%%%
%%% KeyPress %%%
%%%%%%%%%%%%%%%%
if strcmp(Action,'#KeyPress'),
  AsciiVal= abs(get(WorkingFig,'CurrentCharacter'));
  %disp(AsciiVal);
  if AsciiVal==127 | AsciiVal==24,
    anedit('#Delete',WorkingFig)
  elseif AsciiVal==20,
    ansimltn('#Start/Stop',WorkingFig)
  end %if abs
%%%%%%%%%%%%%%%%%%%%%%
%%% FigButtonPress %%%
%%%%%%%%%%%%%%%%%%%%%%
elseif strcmp(Action,'#FigButtonPress'),
  
  if strcmp(get(WorkingFig,'SelectionType'),'normal'),
    anedit('#Deselect',WorkingFig)
  end % if strcmp
  
%%%%%%%%%%%%%%%%%%%%%%%
%%% AxisButtonPress %%%
%%%%%%%%%%%%%%%%%%%%%%%
elseif strcmp(Action,'#AxisButtonPress'),
  
  if strcmp(get(WorkingFig,'SelectionType'),'normal'),
    ButtonState=btnstate(WorkingFig,'ObjectButtons');
    Loc=find(ButtonState);
    if ~isempty(Loc) & Loc ~=1,
      NewHandle=findobj(WorkingFig,'Type','uimenu','Tag','MenuEditNew');
      NewData=get(NewHandle,'UserData');
      set(WorkingFig,'Pointer','watch');      
      eval([deblank(NewData(Loc-1,:)) '(''#New'',[],'  ...
            num2str(WorkingFig) ',1)'] ...
          );
      set(WorkingFig,'Pointer','arrow');      
    end % if ~isempty

    CurFig=get(0,'CurrentFigure');
    anedit('#Deselect',WorkingFig)
  end % if strcmp
    
end % if Action
