function anreset(WorkingFig,u)
%ANRESET Reset animation object positions.
%	ANRESET(WORKINGFIG,U) resets animation object positions based on
%	the input vector u.
%
%	WORKINGFIG is the handle of the figure that the animation takes
%	place on.
%
%	See also ANSIMLTN, ANSIM.

%	Loren Dean  March, 1995.
%	Copyright (c) 1995 by The MathWorks, Inc.

SimFigData=get(WorkingFig,'UserData');
WorkingAxes=SimFigData(2);
StartHandle=SimFigData(4);
 
SimData=get(WorkingAxes,'UserData');
StartData=get(StartHandle,'UserData');

if ~isempty(SimData),
  for lp=1:2:length(StartData),
    FcnName=deblank(setstr(SimData(StartData(lp),2:9)));
    feval(FcnName,'#Draw',SimData(StartData(lp):StartData(lp+1),1),WorkingFig,u);
  end % lp
end % if ~isempty
drawnow;
