% Simulation Animation Toolbox.
% Version 1.0, March 1995
% Copyright (c) 1995 by The MathWorks, Inc.
%
% Animation Block
%   animblk    - Simulink file containing the Animation Block.
%
% Object Functions.
%   andot      - Dot creation and display function.
%   anline     - Generic line creation and display function.
%   anpatch    - Generic line creation and display function.
%   anrect     - Rectangle creation and display function.
%   antext     - Text creation and display function.
%
% Simulation Functions.
%   ancomloc   - Find Comma locations in a string.
%   ancurobj   - Get current animation object.
%   andrag     - Drag objects around.
%   andraw     - Reset object position.
%   anedit     - Animation edit menu function.
%   anfig      - Perform button and keypress callbacks for animation figures.
%   anfile     - Animation file menu function.
%   angetclr   - Return select and deselect colors for animations.
%   angetic    - Get input vector initial conditions.
%   angetpos   - Get new object position.
%   animicon   - Icons for object types.
%   anobj      - Initialize object icons for animations.
%   anoption   - Animation option menu function.
%   anprpdlg   - Properties dialog function.
%   anreset    - Reset animation object positions.
%   ansetobj   - Set object data in start handle.
%   ansim      - Simulation animation.
%   ansimini   - Initialize figure for SIMULINK animations.
%   ansimltn   - Animation simulation menu function.
%
% Demo Files.
%   anpdemo    - Modification of original penddemo.
%   anpdemo.mat- Sample pendulum animation data.
%   demo       - Object type demo.
%   demo.mat   - Object type data.
%   fourbar    - 4 bar demo.
%   fourbar.mat- 4 bar data.
%   intrface   - Simulink sample animation block interface.
%   piston     - piston demo.
%   piston.mat - piston data.
%
% Readme Files.
%   readme.doc, readme.txt
%
% Other files included with this package 
% (most are already available in the uitools toolbox)
%   axlimdlg, btngroup , btndown , btnicon , btnpress, 
%   btnstate, btnup    , dialog  , getuprop, icondisp, 
%   makemenu, menulabel, questdlg, setuprop, sortrows, 
%   strmatch, ishandle.
