function ansetobj(WorkingFig)
%ANSETOBJ Set object data in start handle.
%	ANSETOBJ(WORKINGFIG) sets matched object type pairs in the Simulation
%	Start menu.  For a given number of objects and object types on an 
%	animation window, this function sorts the object types, puts the sorted
%	objects' handles into a vector and then stores the location of the 
%	first and last occurence of each object type in the Simulation Start 
%	handle.
%
%	WORKINGFIG is the handle for the figure the objects are placed on.

%	Loren Dean  March, 1995.
%	Copyright (c) 1995 by The MathWorks, Inc.

SimFigData=get(WorkingFig,'UserData');
WorkingAxes=SimFigData(2);

AxesData=get(WorkingAxes,'UserData');
NumLocObjs=[];
   
if ~isempty(AxesData),
  [NewData,Index]=sortrows(setstr(AxesData(:,2:9)));
  NewData=AxesData(Index,:);
  set(WorkingAxes,'UserData',NewData);
  NumPts=length(NewData(:,1));
  NumLocObjs=find(sum((NewData(1:NumPts-1,2:9)-NewData(2:NumPts,2:9))'));
end % if ~isempty
      
SearchLoc=1;
for lp=1:length(NumLocObjs),
  SearchLoc=[SearchLoc NumLocObjs(lp) NumLocObjs(lp)+1];
end
SearchLoc=[SearchLoc NumPts];
      
StartHandle=SimFigData(4);
set(StartHandle,'UserData',SearchLoc);