function deehelp(),
% deehelp is displays help for the DEE

% inputs:  none
% outputs: none

% this function:
%      (i)   displays help for the Differential Equation Editor (DEE)

%                                    (i)                                  %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% build matrix for helpdlg
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
helpstring = str2mat('The Differential Equation Editor Block'); 
helpstring = str2mat(helpstring,...
'allows you to quickly enter any set of first order differential',...
'equations to be solved by SIMULINK.  It dynamically builds the system',...
'for you, and the simulation will run with the speed of built-in',...
'SIMULINK blocks.  This gives you an alternative to constructing',...
'the block diagram yourself or writing a MEX-file without losing',...
'simulation speed.',...
' ',...
'                    What the fields will accept: ');
helpstring = str2mat(helpstring,...
'Name: ',...
'      This field will accept any string.',...
' ',...
'# of inputs: ',...
'      Only integers have meaning here.',...
' ',...
'First order equations: ',...
'      These equations must be written in terms of the indexed vectors,',...
'      x and u, any variables in the workspace, and any functions supported,');
helpstring = str2mat(helpstring,...
'      by the SIMULINK Fcn block.  See your manual for a complete listing,',...
'      of legal function calls and built-in variables (eg, pi).',...
' ',...
'X0:',...
'      This list of scalars accepts any legal matlab expression that',...
'      returns a single value for each of its entries.',...
' ',...
'Output Equations:',...
'      Identical requirements as the First order equations.');
helpstring = str2mat(helpstring,...
' ',...
'Trouble shooting: ',...
'If for some reason there seems to be an endless looping of errors,',...
'make sure that the edit fields have the correct information in',...
'them and click on the Rebuild button.  This button reconstructs',...
'the system from scratch.  After a Rebuild, the block will need to',...
'be reconneted to the external system.');




%dialog('Style','help','Name','Differential Equation Editor Help Screen','TextString',helpstring);

disp(helpstring)



