function [sestring,icstring,sostring,nistring,numse,numso,numni] = getsys(figtitle),

%************************************************************************
% check to see if this system was prviously defined and update sestring
%    ,icstring, sostring and nistring appropriately
%************************************************************************


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% update sestring and icstring and deparse sestring
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
count = 1;
sestring = get_param([figtitle,'/x1'],'Expr');
if ~isempty(sestring),
    icstring = get_param([figtitle,'/Integ1'],'Initial');
    i = 2;
    statename = ['x',num2str(i)];
    intname = ['Integ',num2str(i)];
    nextstate = get_param([figtitle,'/',statename],'Expr');
    nextinteg = get_param([figtitle,'/',intname],'Initial');
    while ~isempty(nextstate),
        sestring = str2mat(sestring,nextstate);
        icstring = str2mat(icstring,nextinteg);
        i = i + 1;
        statename = ['x',num2str(i)];
        intname = ['Integ',num2str(i)];
        nextstate = get_param([figtitle,'/',statename],'Expr');
        nextinteg = get_param([figtitle,'/',intname],'Initial');
    end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    % update dimension of sestring
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    [numse,secols] = size(sestring);

else
    sestring = '';
    icstring = '';
    numse = 0;
    numic = 0;
end


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% update nistring, compute numni and offset to pass to dparseit
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
MuxStr     = get_param([figtitle,'/SysMux'],'inputs');
muxputs    = str2num(MuxStr);
checkinput = get_param([figtitle,'/SysInport1'],'Port');

if ~isempty(checkinput),
  numni    = muxputs-numse;
  nistring = num2str(numni);  
else
  numni    = 0;  
  nistring = '0';  
end

offset = numni;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% deparse sestring   - this has to come after offset is defined since
%    offset is a parameter needed by dparseit 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
if ~isempty(sestring),
    tmpstring = dparseit(sestring(1,:),offset);
    for i = 2:numse,
	tmp = dparseit(sestring(i,:),offset);
	tmpstring = str2mat(tmpstring,tmp);
    end
    sestring = tmpstring;
end


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% update sostring and deparse the equations
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
sostring = get_param([figtitle,'/y1'],'Expr');
if ~isempty(sostring),
    count = 2;
    fcnname = ['y',num2str(count)];	
    fcnstring = get_param([figtitle,'/',fcnname],'Expr');
    while ~isempty(fcnstring)
	sostring = str2mat(sostring,fcnstring);
	count = count + 1;
	fcnname = ['y',num2str(count)];	
	fcnstring = get_param([figtitle,'/',fcnname],'Expr');
    end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    % update dimension of sostring
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    [numso,socols] = size(sostring);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    % deparse sostring  
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    tmpstring = dparseit(sostring(1,:),offset);
    for i = 2:numso,
	tmp = dparseit(sostring(i,:),offset);
	tmpstring = str2mat(tmpstring,tmp);
    end
    sostring = tmpstring;
else
    numso = 0;
    sostring = '';
end

