	INTEGER MAX_X, MAX_U, MAX_Y, MAX_STPS, MX_UR 
	CHARACTER *(*) LMAX_X, LMAX_U, LMAX_Y, LMAX_STPS, LMX_UR

c Parmeters below are used to set array storage limits.
c They may be altered to meet different needs as outlined.

c MAX_X sets maximum allowed number of system states
c MAX_Y sets maximum allowed number of system outputs
c MAX_U sets maximum allowed number of system inputs
c MX_UR sets maximum allowed rows in a time/input table (RHS 5)
c MAX_STPS sets the maximum size of the returned time vector
c the returned state (output) trajectory matrices thus have at most MAX_STPS rows

c If MAX_X, MAX_U, MAX_Y, or MAX_STPS is increased, one or more of the others may need
c to be decreased.  For example, on a Macintosh using MPW / LS FORTRAN limits of 
c 20, 20, 20,101, and 101 for X,Y,U,UR and STPS work fine.  However, limits of 
c 50,50,20,50, and 50 generate the following message during the link step of the FMEX script:

c ### Link: Warning: Size of global data area exceeds 65K. (Error 34)

c Despite the above message, MPW still generates an EPISODE.MEX file.  
c However, I doubt that it will work properly.  Use such files at your own risk!

c Other systems such as VAX, UNIX, PC may tolerate larger global data areas.
c If so you may be able to increase ALL of the parameters below on such systems.

	PARAMETER (MAX_X=50, MAX_U=20, MAX_Y=50, MAX_STPS=30, MX_UR=28) 

c The parameters below are displayed in error messages if EPISODE.MEX is asked to uses
c an S-function or time/input table of excessive size.  If you change the size limits
c in the parameters above, please change the character values below to match.

	PARAMETER (LMAX_X='50', LMAX_U='20', LMAX_Y='50', LMAX_STPS='30')
	PARAMETER (LMX_UR='28')
c


