C EPISODEG.FOR - Gateway function for EPISODED.FOR

c EPISODEG.FOR is copywrited by Mark T. Eaton    Sept. 1992

C This is version 1.6    dated 8/23/93   by MT EATON
C 
C       - User input of Jacobian matrix is UNTESTED
C       - May be useful to use option2 (STEPMIN) as H0, the initial EPISODE step size
C       - MATLAB apparently remembers COMMON values at this level until a CLEAR MEX
C       - See note below about SAVEME_ common blocks
C       - Added check for x0 input and, if not empty, only gets SIZES vector from S_FUNCT 8/19/92
C	   - Added P1-P10 parameters as inputs during first call to SYSFUN with flag = 0   8/24/92
C       - Added check for excessive state vector size.  Set max state size from 20 to 50
C	   - Fix bug causing initial step > TEND with index = 2 and T0 <> zero.     9/09/92
C	   - Now uses T0 and Tfinal as integration interval even if UMAT is given 9/10/92
C	   - Allows use of direct feedthrough inputs via new U4Y subroutine         9/10/92
C       - Changed useful parameter and common definitions to INCLUDE files    9/22/92
C       - Set lower limit on utable rows to prevent undefined interpolation      9/22/92
C       - Initialize NPARAMS to zero via = instead of via DATA statement 	    8/23/93
C
C This is an example of the FORTRAN code required for interfacing a FORTRAN program to MATLAB
C
C This subroutine is the main gateway to MATLAB.  When a MEX function
C  is executed MATLAB calls the USRFCN subroutine in the corresponding
C  MEX file.  
C
      SUBROUTINE USRFCN(NLHS, PLHS, NRHS, PRHS)
      INTEGER PLHS(*), PRHS(*)
      INTEGER NLHS, NRHS
C
      INTEGER CRTMAT, REALP, IMAGP, GETGLO, ALREAL, ALINT, GETSTR
C
      DOUBLE PRECISION GETSCA
C
C KEEP THE ABOVE SUBROUTINE, ARGUMENT, AND FUNCTION DECLARATIONS FOR USE
C IN ALL YOUR FORTRAN MEX FILES.
C---------------------------------------------------------------------
C
	INCLUDE 'epi_siz_lim_defs.inc'			! defines input and output size limits
	
      INTEGER ROWS, COLS, N, ND, NOUT, IPLOT_IT           				!Local variables
	INTEGER IERROR, MF, INDEX , ISHOWMESS , J, JJ, K, NO_OF_LINES
	INTEGER NDX, MATSIZE, NOPTS, FLAGVAL, MAX_N_LEN
	INTEGER K1, K2, NSTPS
	DATA MAX_N_LEN /20/ 

	INTEGER MRHS, MLHS, RHS(14), LHS(2), FLAG, TIME, INPUT, STATE, FP, TP, UP, SP, PLT_X, PLT_Y

	DOUBLE PRECISION H0, EPS, TSMALL, SIZES(6),  OUTPUT(MAX_Y), U(MAX_U), TFINAL, T0,  
	1	STEPMIN, STEPMAX         									
	  
	CHARACTER*80 MAINMESSAGE(10)
	  
	INTEGER OPTPTR, T0PTR, X0PTR, UPTR					    			!Pointers to  input parameters 
	INTEGER TOUTPTR, XOUTPTR, YOUTPTR								!Pointers to output parameters

	  DOUBLE PRECISION X0(MAX_X), TOUT(MAX_STPS), XOUT(MAX_X*MAX_STPS), 
	1	YOUT(MAX_Y*MAX_STPS)  
	  DOUBLE PRECISION OPTIONS(6), TF(2)
	  
	INCLUDE 'epi_commons.inc'                     ! defines common blocks storing system names, input tables, etc.
	  
C connect to EPISODE  common blocks if needed
      DOUBLE PRECISION EPSC, EPSJ, ERROR, HMAX, H, HMIN, HUSED,
     1                 PW, SAVE1, SAVE2, SS, T, UROUND, YMAX,
	2				  TAU, EL, TQ, HOLD, ETAMAX, PRL1, HRL1, RC, T0P, Y_EPI,
	3				CRATE, D1, R_EPI
	 
      INTEGER IPIV, JSTART, KFLAG, MFC, NC, NFE, NJE,
     1        NQUSED, NSQ, NSTEP, LMAX, METH, NQ, L, NQINDX,
	2		  N0, NHCUT, MFOLD, MITER, NEWJ, NSTEPJ, MITER1

      COMMON /EPCOM1/ T,H,HMIN,HMAX,EPSC,SS,UROUND,NC,MFC,KFLAG,JSTART
      COMMON /EPCOM2/ YMAX(MAX_X)
      COMMON /EPCOM3/ ERROR(MAX_X)
      COMMON /EPCOM4/ SAVE1(MAX_X)
      COMMON /EPCOM5/ SAVE2(MAX_X)
      COMMON /EPCOM6/ PW(MAX_X*MAX_X)
      COMMON /EPCOM7/ IPIV(MAX_X)
      COMMON /EPCOM8/ EPSJ,NSQ
      COMMON /EPCOM9/ HUSED,NQUSED,NSTEP,NFE,NJE
      COMMON /EPCM10/ TAU(13),EL(13),TQ(5),LMAX,METH,NQ,L,NQINDX
	
C the following common blocks guarentee that certain DDRIVE and DTSTEP  variables are 
C stored as STATIC memory.  This list MAY NOT BE COMPLETE.  Also it may be excessive.
C   TAKE NOTE IF WEIRD BUGS ARE FOUND

	  COMMON/ SAVEME1/ N0, NHCUT, T0P, Y_EPI(MAX_X,13)
	  COMMON /SAVEME2/ HOLD, ETAMAX, PRL1, HRL1, RC, CRATE, D1, R_EPI,
	1						MFOLD, MITER, NEWJ, NSTEPJ, MITER1
	  
c	CALL DISPMESS('ENTERING USERFCN...',1,3)

	WRITE(SYS_NAME, '(20X)' )                                  ! Store spaces for later ease of parsing
	JAC_NAME = SYS_NAME
	U_OF_T = SYS_NAME
	  
C
C CHECK FOR PROPER NUMBER OF ARGUMENTS
C
c	CALL DISPMESS('Checking # of arguments...', 1,3)
      IF ( (NRHS .LT. 2) .OR. (NRHS .GT. 16) .OR. (NLHS .GT. 3) ) THEN
	  		WRITE(MAINMESSAGE,101) 
			CALL DISPMESS(MAINMESSAGE,7,10)
 101		FORMAT(/ 'USAGE:',/ '[{T},{X},{Y}] = EPISODE("SYS", [{T0} TF], {X0}, {OPTS},', /	
	1                     26X, '{UT}, {P1}, ..., {P10}, {"JAC"})', /'Parameters in {} are optional',/
	2				/'version 1.5 of EPISODE.MEX  09/22/92')
			CALL MEXERR(' Returning to MATLAB...')
      ENDIF

c First get P1 - P10 if they exist so we can pass them during the flag=0 call.

	NPARAMS = 0                                      ! Default value unless user gives us a P1-P10

	IF (NRHS. GT. 5) THEN						! get P1 ... P10 and JAC_NAME (if it exits)
c		CALL DISPMESS('GETTING THE P1-P10 PARAMS AND JACOBIAN NAME', 1,3)
		LL = GETSTR(PRHS(NRHS), JAC_NAME)
		IF (LL .NE. 1) THEN
			IF(NRHS .EQ. 16) CALL MEXERR(' Can only pass 10 parameters to S-function')
			NPARAMS = NRHS - 5
		ELSE
			J = 1
			DO WHILE ( (ICHAR(JAC_NAME(J:J)) .NE. 32) .AND. (J. LE. MAX_N_LEN) )
				J = J + 1
			END DO
			J_NAME_LEN = J - 1
			NPARAMS = NRHS - 6
		END IF
		DO J=1,NPARAMS
			PARAMPTR(J) = PRHS(J+5)
		END DO
	END IF

C STORE NON-OPTIONAL INPUT PARAMETERS

C First comes the S-function name after which we need to know sizes, X0, etc.
c	CALL DISPMESS('GETTING SYSTEM NAME ...', 1, 3)
	J = GETSTR(PRHS(1), SYS_NAME)
	IF ( J .NE. 1) THEN
		WRITE(MAINMESSAGE,103) MAX_N_LEN
		CALL DISPMESS(MAINMESSAGE,1,2)
 103	FORMAT('SYS must be a string having a maximum of ', I3,' characters')
		CALL MEXERR( ' Returning to MATLAB ...')		

	ELSE			! J is 1 and we parse sys_name to eliminate trailing spaces
		DO WHILE ( (ICHAR(SYS_NAME(J:J)) .NE. 32) .AND. (J. LE. MAX_N_LEN) )
			J = J + 1
		END DO
		S_NAME_LEN = J - 1
		TIME = CRTMAT(0,0,0)		! Allocate MATLAB storage for flag, t, u, and x inputs
		INPUT = CRTMAT(0,0,0)
		STATE = CRTMAT(0,0,0)
		FLAG = CRTMAT(1,1,0)		

		FP = REALP(FLAG) 			! get pointer to flag and store flag=0
		FLAGVAL = 0        		!tells S_function to return SIZES, X0, etc.
		CALL CPIN(DFLOAT(FLAGVAL),FP,1)

		RHS(1) = TIME		
		RHS(2) = STATE				! form the input to the S_FUNCTION 
		RHS(3) = INPUT
		RHS(4) = FLAG
		DO J = 1,NPARAMS
			RHS(J+4) = PARAMPTR(J)
		END DO
	
		MRHS = 4 + NPARAMS                ! needs four or more inputs
	
c Check if x0 is provided.  if so, we want sizes vector only
		ROWS = 0
		COLS = 0
		IF(NRHS .GT. 2) THEN				! get initial condition vector
			CALL GETSIZ(PRHS(3), ROWS, COLS)
		END IF
		IF (MIN(ROWS,COLS) .GT. 0)  THEN  ! x0 was not empty
			MLHS = 1			! returns only one result
			CALL MATFCN(MLHS,LHS,MRHS,RHS,SYS_NAME(1:S_NAME_LEN))
			CALL CPOUT(REALP(LHS(1)) ,SIZES ,6)   ! get pointer to SIZES result and copy to local
		ELSE
			MLHS = 2                ! return 2 results
			CALL MATFCN(MLHS,LHS,MRHS,RHS,SYS_NAME(1:S_NAME_LEN))
			CALL CPOUT(REALP(LHS(1)) ,SIZES ,6)   ! get pointer to SIZES result and copy to local
			CALL GETSIZ(LHS(2), ROWS,COLS)		! get state vector size and store I.C.s
			IF ( MAX(ROWS,COLS).GT. MAX_X) 
	1		CALL MEXERR(' Episode limited to state vector of size '//lmax_x)
			CALL CPOUT(REALP(LHS(2)), X0, MAX(ROWS,COLS))
		END IF
		
		CALL FREMAT(TIME)  ! free up requested MATLAB space
		CALL FREMAT(STATE)
		CALL FREMAT(INPUT)
		CALL FREMAT(FLAG)
		CALL FREMAT(LHS(1))  !free up space created by MATFCN call
		IF  (MLHS .EQ. 2) CALL FREMAT(LHS(2))  

		N = NINT(SIZES(1)	)			! number of continuous states
		ND = NINT(SIZES(2))			! number of discrete states
		NOUT = NINT(SIZES(3))		! number of outputs
		M = NINT(SIZES(4))			! number of inputs
		
C complain if any of the sizes are excessive
		IF (N .GT. MAX_X) CALL MEXERR(' Episode limited to state vector of size '//lmax_x)
		IF (M .GT. MAX_U) CALL MEXERR('EPISODE limited to input vector of size '//lmax_u)
		IF (NOUT .GT. MAX_Y) CALL MEXERR('EPISODE limited to output vector of size '//lmax_y)
C 		IF (ND .NE. 0) CALL MEXERR('EPISODE cannot do discrete states')

	END IF
		
C Parse TF into TFINAL and T0 if given

	CALL GETSIZ(PRHS(2), ROWS,COLS)
	IF ( (MAX(ROWS,COLS) .GT. 2) .OR. (MIN(ROWS, COLS) .GT. 1) ) THEN
		CALL MEXERR('TF must be length 1 or 2 only')
	END IF
	IF ( MAX(ROWS, COLS) .EQ. 1) THEN
		TFINAL = GETSCA(PRHS(2))
		T0 = 0.0
	ELSE
		T0PTR = REALP(PRHS(2))
		CALL CPOUT(T0PTR, TF, 2)
		T0 = TF(1)
		TFINAL = TF(2)
	END IF
	IF (TFINAL .LE. T0) CALL MEXERR('Final time must be greater than start time!')
	
C ASSIGN DEFAULT VALUES FOR LOCAL VARIABLES
c	CALL DISPMESS('Assigning default variables', 1, 3)
	USE_U = .FALSE.			! inputs set to zero
	EPS = 1E-5							! OPT(1) -- relative error is modest
	STEPMIN = (TFINAL-T0)/2000.0	! OPT(2) 
	STEPMAX = (TFINAL-T0)/(MAX_STPS/2)		! OPT(3)	
	MF = 10						! OPT(4) -- use implicit method
	ISHOWMESS = 0				! OPT(5) -- suppress EPISODE messages unless > 0 
	IPLOT_IT=1         				! OPT(6) plotting is off
	IF (NLHS. EQ. 0) IPLOT_IT = 2   				! plotting on if no RHS given
	IERROR = 3						! OPT(7) -- uses relative error unless X is zero
	INDEX = 1						! OPT(8) -- interpolate outputs unless equals 2
	IRAMP = 1							! OPT(9) -- use peice-wise ramp inputs if 1, peice-wise const if 2
	
C COPY ANY OTHER PARAMETERS PROVIDED AND OVERIDE DEFAULTS AS REQUESTED
	IF(NRHS .GT. 2) THEN				! get initial condition vector
c		CALL DISPMESS('GETTING IC VECTOR FROM RHS ARGUMENTS ...', 1, 3)
		CALL GETSIZ(PRHS(3), ROWS, COLS)
		IF( (MAX(ROWS,COLS) .EQ. N) .AND. (MIN(ROWS,COLS) .EQ. 1) ) THEN
			X0PTR = REALP(PRHS(3))
			CALL CPOUT(X0PTR, X0, N)
		ELSEIF (MIN(ROWS,COLS) .NE. 0) THEN
			CALL MEXERR( 'Initial condition vector is an invalid size!')
		END IF
	END IF

	IF (NRHS .GT. 3) THEN				! get options vector
c		CALL DISPMESS('GETTING OPTIONS VECTOR...', 1, 3)
		CALL GETSIZ(PRHS(4), ROWS, COLS)
		NOPTS = MAX(ROWS,COLS)
		IF (NOPTS. GT. 9) CALL MEXERR(' OPTIONS vector has max length of 9')
		IF (NOPTS .GT. 0) THEN
			OPTPTR = REALP(PRHS(4))
			CALL CPOUT(OPTPTR, OPTIONS, NOPTS)
			
			DO J=1,NOPTS								!parse the given options
			
				IF (OPTIONS(J) .NE. 0.0) GOTO (201, 202, 203, 204, 205, 206, 207, 208, 209) J
				GOTO 250
				
 201			EPS = OPTIONS(1)
				IF (EPS .LT. 0.0) CALL MEXERR('EPSL MUST BE > 0.0')
				GOTO 250
				
 202			STEPMIN = OPTIONS(2)
				IF (STEPMIN . LT. 0.0) CALL MEXERR('MIN STEP MUST BE > 0.0')
				GOTO 250
				
 203			STEPMAX = OPTIONS(3)
				IF ( STEPMAX .LT. STEPMIN) CALL MEXERR('MAX STEP MUST BE > MIN STEP')
				GOTO 250
				
 204			MF = NINT(OPTIONS(4))
				IF (.NOT. ( (MF .EQ. 10) .OR. (MF .EQ. 11) .OR. (MF .EQ. 12) .OR. (MF .EQ. 13)
	1			.OR. (MF .EQ. 20) .OR. (MF .EQ. 21) .OR. (MF .EQ. 22) .OR. (MF .EQ. 23) ) )
	2			CALL MEXERR(' MF must be 10 - 13 or 20 - 23')
				IF ( ((MF .EQ. 11) .OR. (MF .EQ. 21)) .AND.  (ICHAR(JAC_NAME(1:1)) .EQ. 32) ) 
	1			CALL MEXERR(' You must supply a Jacobian routine when option(4) =11 or 21')				
				GOTO 250
				
 205			ISHOWMESS = NINT(OPTIONS(5))
				GOTO 250
				
 206			IPLOT_IT = NINT(OPTIONS(6))
				GOTO 250
				
 207			IERROR = NINT(OPTIONS(7))
				IF ( (IERROR .LT.1) .OR. (IERROR .GT. 3) ) CALL MEXERR('IERROR MUST BE 1, 2, OR 3')
				GOTO 250
				
 208			INDEX = NINT(OPTIONS(8))
				GOTO 250
				
 209			IRAMP = NINT(OPTIONS(9))
				GOTO 250
				
 250		END DO
		END IF	
	END IF
	
	IF (NRHS. GT. 4) THEN
c		CALL DISPMESS('GETTING THE INPUT STRING', 1, 3)
		U_IS_STR = GETSTR(PRHS(5), U_OF_T)
		IF (U_IS_STR .NE. 1) THEN				! must be a matrix if not a string
			CALL GETSIZ(PRHS(5), N_TSTEPS, COLS)
			IF (N_TSTEPS .GT. MX_UR) 
	1		CALL MEXERR('EPISODE limits UT to max # of rows = '//LMX_UR)
			MATSIZE = N_TSTEPS * COLS
			IF (MATSIZE .GT. 0) THEN
				IF (N_TSTEPS .LT. 2)
	1			CALL MEXERR('EPISODE requires that UT have at least 2 rows')
				IF ( COLS .NE. M+1)  CALL MEXERR('UT must have M+1 columns')
				UPTR = REALP(PRHS(5))
					CALL CPOUT(UPTR, UMAT, MATSIZE)
				USE_U = .TRUE.
				LAST_T = 1                              ! set low end of search interval for 1st step
			ENDIF
		ELSE									! this is for a string input u_of_t
			J = 1
			DO WHILE ( (ICHAR(U_OF_T(J:J)) .NE. 32) .AND. (J. LE. MAX_N_LEN) )
				J = J + 1
			END DO
			U_NAME_LEN = J - 1
			USE_U = .TRUE.
		END IF
	END IF
	
	
C BUILD VECTOR OF OUTPUT TIMES

	TOUT(1) = T0													! store ic's for user
c	CALL DISPMESS('BUILDING A VECTOR OF OUTPUT TIMES ...',1,3)
	IF ( (U_IS_STR .NE. 1) .AND.  (USE_U .EQ. .TRUE.) ) THEN	! build tout using time vector stored in UMAT
		IF ( (T0 .GE. UMAT(N_TSTEPS)) .OR. (TFINAL. LE. UMAT(1)) ) GOTO 350  ! selected time not in umat
		K1=1								! assumes T0 < umat(1)
 300	IF (T0. GE. UMAT(K1) ) THEN		! if not, must find where to start using umat values
			K1 = K1 + 1
			GOTO 300
		END IF							! K1 set to  index of smallest umat time value above T0
		K2 = N_TSTEPS  						! assume tfinal > max time in umat
 325	IF (TFINAL .LE. UMAT(K2)) THEN  ! if not, must find where to stop using umat values
			K2 = K2 - 1
			GOTO 325
		END IF		! K2 set to index of biggest umat time value below TFINAL
			
		DO J = 0, MIN((MAX_STPS-2), (K2-K1) ) ! utable may hold more time values than allowd by MAX_STPS
			TOUT(J+2) = UMAT(K1+J)				! fill tout with selected time values from umat
		END DO
		TOUT(J+2) = TFINAL			! put tfinal in next tout location
		NSTPS = J + 2
	ELSE
 350	IF ( (T0 + MAX_STPS*STEPMAX) .LT. TFINAL) THEN    ! need bigger steps than STEPMAX
			NSTPS = MAX_STPS
			STEPMAX = (TFINAL - T0) / DFLOAT(NSTPS-1)
			DO J = 1,NSTPS-1
				TOUT(J+1) = TOUT(J) + STEPMAX
			END DO
		ELSE
			NSTPS = INT( (TFINAL - T0)/STEPMAX ) + 1  !should truncate to be 1 less than desired
			IF (NSTPS .EQ. 1) THEN					! user apparently wants one step if possible
				NSTPS  = 2
				TOUT(2) = TFINAL
			ELSE							! have at least one step to take
				DO J=1, NSTPS-1
					TOUT(J+1) = TOUT(J) + STEPMAX
				END DO
				IF ( (TFINAL - TOUT(NSTPS)) .GT. (STEPMAX/100.0) ) then  
					NSTPS = NSTPS + 1					!add TFINAL if not near enough
					TOUT(NSTPS) = TFINAL
				END IF
			END IF
		END IF
	END IF
	
	DO J = 1,N
		XOUT(J) = X0(J)			! store X0 in first "column" of XOUT
	END DO
C NOW WE CAN RUN EPISODE

	H0 = STEPMAX

	IF ( (INDEX .EQ. 2) )THEN		! We're forced to land exactly on tfinal
		J = 2
		TSMALL = T0 + (TOUT(2)-T0)/10.0			! so we take a tiny first step
		H0 = TSMALL - T0 							! try it in one step so episode doesn't overstep
		NDX = 1
      	CALL DDRIVE(N, T0, H0, X0, TSMALL, EPS, IERROR, MF, NDX, ISHOWMESS)
		IF (NDX .LT. 0) GOTO 900                             ! this means episode failed to converge on answer
		DO J=2, NSTPS                                        ! now ready for repeated index=2 runs
			NDX = 2
      		CALL DDRIVE(N, T0, H0, X0, TOUT(J), EPS, IERROR, MF, NDX, ISHOWMESS)
			IF (NDX .LT. 0) GOTO 900

			TOUT(J) = T0
			DO K = 1,N
				XOUT(K+(J-1)*N) = X0(K)	! store X0 in next "column" of XOUT
			END DO
		END DO
	ELSE
c		use this section for Index = 1 situation
		NDX = 1
		DO J=2,NSTPS
					
			CALL DDRIVE(N, T0, H0, X0, TOUT(J), EPS, IERROR, MF, NDX, ISHOWMESS)
			IF (NDX .LT. 0) GOTO 900			! this means episode failed to converge on answer
			DO K = 1,N
				XOUT(K+(J-1)*N) = X0(K)
			END DO
		END DO	
		
	END IF
		
 900	IF (NDX .LT. 0) THEN
			WRITE(MAINMESSAGE, 905) J-1
			CALL DISPMESS(MAINMESSAGE, 3, 5)
 905		FORMAT(/'WARNING! INTEGRATION FAILED DURING STEP' , I2//)
		END IF

C CREATE MATRICES FOR RETURN ARGUMENTS AND GET POINTERS TO THEM
C ALSO TEMPORARILY STORE RESULTS AND PLOT THEM IF REQUESTED
	K = J-1							! number of successful time steps (including IC's)
	IF (NLHS. GT. 0) THEN  
      	PLHS(1) = CRTMAT(K,1,0)				! allocate storage for time vector
      	TOUTPTR = REALP(PLHS(1))				! point to real part
		CALL CPIN(TOUT, TOUTPTR, K)			! save it
		IF (IPLOT_IT .EQ. 2) PLT_X = PLHS(1)	! time is saved, so we can plot it directly
	ELSE IF (IPLOT_IT .EQ. 2) THEN
		PLT_X = CRTMAT(K,1,0)				! otherwise, save it temporarily for plotting
		TOUTPTR = REALP(PLT_X)
		CALL CPIN(TOUT, TOUTPTR, K)
	END IF 

	IF (NLHS .GT. 1) THEN
      	PLHS(2) = CRTMAT(K,N, 0)				!allocate storage for state vector
		XOUTPTR = REALP(PLHS(2))				! point to real part
		MATSIZE = N*K
		DO JJ=1,K
			DO LL = 1,N
				YOUT(JJ+(LL-1)*K) = XOUT(LL+(JJ-1)*N)		! transpose XOUT for MATLAB use
			END DO
		END DO
		CALL CPIN(YOUT, XOUTPTR, MATSIZE) ! store the results
		IF ( (IPLOT_IT .EQ. 2) .AND. (NOUT .EQ. 0) ) PLT_Y = PLHS(2)			! use for plotting
	ELSE IF ( (IPLOT_IT .EQ. 2) .AND. (NOUT .EQ. 0) ) THEN
		MATSIZE = N*K
		PLT_Y = CRTMAT(K,N,0)
		XOUTPTR = REALP(PLT_Y)
		DO JJ=1,K
			DO LL = 1,N
				YOUT(JJ+(LL-1)*K) = XOUT(LL+(JJ-1)*N)
			END DO
		END DO
		CALL CPIN(YOUT, XOUTPTR, MATSIZE)
	END IF
	
C If needed, we build an output vector from states and inputs	
	IF ( (NLHS .GT. 2) .OR. ( (IPLOT_IT .EQ. 2) .AND. (NOUT. GT. 0) ) ) THEN     ! give states to SYS_NAME to get outputs	
		TIME = CRTMAT(1,1,0)
		STATE = CRTMAT(N,1,0)
		INPUT = CRTMAT(M,1,0)
		FLAG = CRTMAT(1,1, 0)
		FP = REALP(FLAG)
		SP = REALP(STATE)
		TP = REALP(TIME)
		UP = REALP(INPUT)
		FLAGVAL = 3         		!tells S_function to return OUTPUT etc.
		CALL CPIN(DFLOAT(FLAGVAL),FP,1)
			DO LL = 1,M
				U(LL) = 0.0	! this assumes Y = f(X) only  (corrected below if not true)			
			END DO
		CALL CPIN(U, UP, M)

		RHS(1) = TIME		
		RHS(2) = STATE				! form the input to the S_FUNCTION  (should still be set)
		RHS(3) = INPUT
		RHS(4) = FLAG
		DO ICNT= 1,NPARAMS
			RHS(4+ICNT) = PARAMPTR(ICNT)
		END DO
	
		MRHS = 4+NPARAMS                ! needs four or more inputs
		MLHS = 1                			! return 1 results
		
		LAST_T = 1					! Inputs will start near time zero again
		DO JJ=1,K
			CALL CPIN(TOUT(JJ), TP, 1)
			DO LL = 1,N
				X0(LL) = XOUT(LL+ (JJ-1)*N)
			END DO
			CALL CPIN(X0, SP, N)
			
			IF (  (NINT(SIZES(6)) .EQ. 1) .AND.  (USE_U .EQ. .TRUE.) ) THEN  ! has direct feed through of inputs
				CALL U4Y(TOUT(JJ),  U ) 
				CALL CPIN(U, UP, M)
			END IF

			
			CALL MATFCN(MLHS,LHS,MRHS,RHS,SYS_NAME(1:S_NAME_LEN))

			CALL CPOUT(REALP(LHS(1)), OUTPUT, NOUT)   ! get pointer to output result and copy to local
			DO LL = 1,NOUT
				YOUT(JJ+(LL-1)*K) =OUTPUT(LL)		! save output in new '"row" of YOUT
			END DO
			CALL FREMAT(LHS(1))
		END DO
		CALL FREMAT(FLAG)		! free up matlab memory no longer needed
		CALL FREMAT(TIME)
		CALL FREMAT(STATE)
		CALL FREMAT(INPUT)
	END IF
	
c	CALL DISPMESS('STORING THE OUTPUT VECTOR IF NEEDED ...',1,3)
	IF (NLHS .EQ. 3) THEN
		PLHS(3) = CRTMAT(K,NOUT,0)
		YOUTPTR = REALP(PLHS(3))
		MATSIZE = NOUT*K
		CALL CPIN(YOUT, YOUTPTR, MATSIZE)
		IF ( (IPLOT_IT .EQ. 2) .AND. (NOUT .GT. 0) ) PLT_Y = PLHS(3)
	ELSE IF ( (IPLOT_IT .EQ. 2) .AND. (NOUT .GT. 0) ) THEN
		MATSIZE = NOUT*K
		PLT_Y = CRTMAT(K,NOUT,0)
		YOUTPTR = REALP(PLT_Y)
		CALL CPIN(YOUT, YOUTPTR, MATSIZE)
	END IF

C PLOT THE RESULTS IF REQUIRED
	IF (IPLOT_IT .EQ. 2) THEN
		RHS(1) = PLT_X
		RHS(2) = PLT_Y
		MLHS = 0
		MRHS = 2
		CALL MATFCN(MLHS, LHS, MRHS, RHS, 'plot')		! don't FREMAT LHS as NLHS = 0
		IF (NLHS .EQ. 0) THEN							! free x and y values
			CALL FREMAT(PLT_X)
			CALL FREMAT(PLT_Y)
		END IF
		IF (NLHS .EQ. 1) CALL FREMAT(PLT_Y)			! keep the time vector
		IF ( (NLHS .EQ. 2) .AND. (NOUT .GT. 0) ) CALL FREMAT(PLT_Y)
	END IF
		
      RETURN
      END
	
C***********************************************************
C SUBROUTINE DDIFUN - CALLS A SIMULAB S-FUNCITON TO OBTAIN DERIVATIVES
C*************************************************************
	SUBROUTINE DDIFUN(N,T,X,XDOT)
C
C This version of DDIFUN allows the MEX version of episode to get
C the state derivative information, XDOT, from a Simulab system model
C whose name is passed in common
C
	INTEGER N            							! number of states
	DOUBLE PRECISION T, X(N), XDOT(N)		! time, states, and state derivatives

	INCLUDE 'epi_siz_lim_defs.inc'			! defines input and output size limits
	INCLUDE 'epi_commons.inc'                     ! defines common blocks storing system names, input tables, etc.

c Declare MEX utility functions (see MATLAB user's guide)
      integer CRTMAT, REALP, IMAGP, GETGLO, ALREAL, GETSTR
      double precision GETSCA

C Declare variables used as flags, pointers to Matab data space, etc 
	INTEGER TIME, INPUT, STATE, DSTATE, TP,  IP, SP, DP,FP, LHS, RHS(14)
	INTEGER FLAG, NLHS, NRHS
	DOUBLE PRECISION FLAGVAL, U(MAX_u), THIGH, DEL_T, SLOPE
	CHARACTER*80 EMESS(2)

C	WRITE(EMESS,*) 'sys_name is ',SYS_NAME
C	CALL DISPMESS(EMESS,1,5)

C Determine the current input value based on inputs passed in common

c	WRITE(EMESS,*) ' USE_U is ', USE_U
c	CALL DISPMESS(EMESS,1,2)
	IF (USE_U) THEN

		IF (U_IS_STR .EQ. 1) THEN
			TIME = CRTMAT(1,1,0)  ! store the time
			TP = REALP(TIME)
			CALL CPIN(T, TP, 1)
			NRHS =1
			NLHS =1
			CALL MATFCN(NLHS, LHS, NRHS, TIME, U_OF_T(1:U_NAME_LEN))
			IP = REALP(LHS)
			CALL CPOUT(IP, U, M)
			CALL FREMAT(TIME)
			CALL FREMAT(LHS)

C  note: in the tests below, last_t is the LOWER end of the previous interval
C and j gets set to the UPPER end of current interval.

		ELSE								! u must be a table of times and inputs
			IF (T.GT. UMAT(LAST_T) ) THEN			! first look nearby
				IF (T .LE. UMAT(LAST_T+1) ) THEN ! are we in the same interval as last time?
					J=LAST_T + 1
				ELSEIF (T .LE. UMAT( MIN(N_TSTEPS, LAST_T+2)) ) THEN  ! if not, are we in the next interval?
					J = MIN(N_TSTEPS, LAST_T+2)
				ELSEIF (T. GE. UMAT(N_TSTEPS)) THEN  ! if not, check if T is beyond table.
					J = N_TSTEPS	
				ELSEIF (T. LT. UMAT(1) ) THEN ! if not check if we are below smallest t in umat  (NEW)
					J= 2
				ELSE							! if not,  do a binary search for the interval
					J = ISORT(T, LAST_T, 1, UMAT, N_TSTEPS)
				END IF
			ELSE							! new time is below old time range
				IF (T. LT. UMAT(1) ) THEN ! are we below smallest t in umat?
					J = 2
				ELSEIF (T .GE. UMAT(MAX(1, LAST_T-1)) ) THEN ! check one interval back
					J = MAX(2,LAST_T)
				ELSEIF (T .GT. UMAT(N_TSTEPS)) THEN
					J = N_TSTEPS
				ELSE						! if not there, do a full search below old interval
					J = ISORT(T, LAST_T, 0, UMAT, N_TSTEPS)
				END IF
			END IF
			
			LAST_T = J-1					! save LAST_T index for next time
			THIGH = UMAT(J)

			IF (IRAMP .EQ. 2) THEN    ! use piece-wise constant inputs
				JJ = J-1
				IF (T. GT. UMAT(N_TSTEPS) ) JJ = N_TSTEPS   ! needed if t > tfinal
				DO K = 1,M
					U(K) = UMAT(JJ+ K*(N_TSTEPS))			! remember, 1st "column" of UMAT is time
				END DO
c				WRITE(EMESS,*) ' U1 is ', U(1), ' at time ', T
c				CALL DISPMESS(EMESS, 1,2)
			ELSE						! use piece-wise ramps (linear interpolated inputs)
				DEL_T = THIGH - UMAT(J-1)
				DO K = 1,M
					SLOPE = (UMAT(J+ K*N_TSTEPS) - UMAT(J-1+ K*(N_TSTEPS)) ) / DEL_T
					U(K) = UMAT(J + K*N_TSTEPS) + SLOPE * ( T - THIGH)
				END DO
			END IF
			
		END IF
		
	ELSE				! no input given, so default to zero
		DO J=1,M
			U(J) = 0.0
		END DO
	END IF

C Allocate space in matlab memory for storing FLAG, T, U, and X inputs
	TIME = CRTMAT(1,1,0)
	INPUT = CRTMAT(M,1,0)
	STATE = CRTMAT(N,1,0)
	FLAG = CRTMAT(1,1,0)

C Get pointers to these variables and fill with the input data
	TP = REALP(TIME)
	IP = REALP(INPUT)
	SP = REALP(STATE)
	FP = REALP(FLAG)
	CALL CPIN(T,TP,1)
	CALL CPIN(U,IP,M)
	CALL CPIN(X,SP,N)
	FLAGVAL = 1.0         !tells EPISYSTEM to return derivatives
	CALL CPIN(FLAGVAL,FP,1)

C Get the state derivative from the system model

	RHS(1) = TIME		
	RHS(2) = STATE		! form the input to the EPISYSTEM function
	RHS(3) = INPUT
	RHS(4) = FLAG
	DO J = 1,NPARAMS
		RHS(J+4) = PARAMPTR(J)
	END DO
	
	NRHS = 4 + NPARAMS                ! needs four or more inputs
	NLHS = 1                			! SIMULAB systems return 1 result when flag = 1
c	WRITE(EMESS,*) ' NRHS to episystem is', NRHS
c	CALL DISPMESS(EMESS,1,2)
c	WRITE(EMESS,*) ' PARAMPTR(1) IS ', PARAMPTR(1)
c	CALL DISPMESS(EMESS,1,2)

	CALL MATFCN(NLHS,DSTATE,NRHS,RHS,SYS_NAME(1:S_NAME_LEN))

	DP = REALP(DSTATE)      ! get pointer to result
	CALL CPOUT(DP,XDOT,N)   ! copy result into XDOT

C	CALL DISPMESS('Now free-ing up matlab memory',1,2)
	CALL FREMAT(TIME)		! free up matlab memory nolonger needed
	CALL FREMAT(STATE)
	CALL FREMAT(INPUT)
	CALL FREMAT(FLAG)
	CALL FREMAT(DSTATE)

	RETURN
	END


	INTEGER FUNCTION ISORT(T,LAST,IFLAG_UP,TMAT,MAX)
	
	INTEGER LAST, IFLAG_UP, MAX
	DOUBLE PRECISION T, TMAT(MAX)
	
C this function performs a binary sort on the array TMAT
C it returns the index value, J, such that TMAT(J-1) <= T < TMAT(J)
C the local variables act as markers in the array. K is the lower bound
C L is the upper bound, and J is the midpoint to try next
	
	INTEGER J, K, L
	
	IF (IFLAG_UP .EQ. 1) THEN	! search upwards
		K = LAST				! lower bound is old value	
		L = MAX				! upper bound is max value
	ELSE	! search downwards
		K = 1					! lower bound is first array element
		L = LAST				! upper bound is old value
	END IF
	J = L	

	DO WHILE (J .NE. K+1)
		J = K + NINT( (FLOAT(L-K))/2.0 ) ! find the mid point such that J is at least K+1
		IF (T .GT. TMAT(J) ) THEN
			K = J						 ! if T > TMAT(mid) move lower bound up to mid
		ELSE
			L = J						! otherwise move upper bound down to mid
		END IF
	END DO
	
	ISORT = J
	
	RETURN
	END
			
						
C**********************************************************
C SUBROUTINE DPDERV(N,T,Y,PD,N0) RETURNS THE JACOBIAN OF YDOT
C IE, PD(N0,N0) RETURNS THE MATRIX WHOSE ELEMENTS PD(I,J) HOLD
C THE PARTIAL DERIVATIVE OF YDOT(I) WITH RESPECT TO Y(J)
C IT IS CALLED ONLY IF MF=11 OR MF=21 IN EPISODE
C*************************************************************
	  SUBROUTINE DPDERV(N,T,X,PD,N0)
	  INTEGER N, N0
	  DOUBLEPRECISION T, X(N), PD(N0,N0) 

C This version of DPDERV allows the MEX version of episode to get
C the Jacobian derivative information, PD, from a Matlab M-file or MEX-file
C whose name is passed in common variable JAC_NAME

	INCLUDE 'epi_siz_lim_defs.inc'			! defines input and output size limits

	INCLUDE 'epi_commons.inc'                     ! defines common blocks storing system names, input tables, etc.

c Declare MEX utility functions (see MATLAB user's guide)
      integer CRTMAT, REALP, IMAGP, GETGLO, ALREAL, GETSTR
      double precision GETSCA

C Declare variables used as flags, pointers to Matab data space, etc 
	INTEGER RHS(3), TIME, INPUT, STATE, PDSTATE, TP, IP, SP, PDP, FP
	INTEGER NLHS, NRHS, ICNT, NSQ
	CHARACTER*80 EMESS(2)
	DOUBLE PRECISION U(max_u), SLOPE, DEL_T, THIGH

c	WRITE(EMESS,*) 'In DPDERV.  JAC_name is ',JAC_NAME(1:10)
c	CALL DISPMESS(EMESS,1,5)

	NSQ = N0*N0
C Determine the current input value based on inputs passed in common

	IF (USE_U) THEN

		IF (U_IS_STR .EQ. 1) THEN
			TIME = CRTMAT(1,1,0)  ! store the time
			TP = REALP(TIME)
			CALL CPIN(T, TP, 1)
			NRHS =1
			NLHS =1
			CALL MATFCN(NLHS, LHS, NRHS, TIME, U_OF_T(1:U_NAME_LEN))
			IP = REALP(LHS)
			CALL CPOUT(IP, U, M)
			CALL FREMAT(TIME)
			CALL FREMAT(LHS)

		ELSE								! u must be a table of times and inputs

			J = ISORT(T, 1, 1, UMAT, N_TSTEPS) ! just sort it to avoided bashing LAST_T
			THIGH = UMAT(J)

			IF (IRAMP .EQ. 2) THEN    ! use piece-wise constant inputs
				JJ = J-1
				IF (T. GT. UMAT(N_TSTEPS) ) JJ = N_TSTEPS   ! needed if t > tfinal
				DO K = 1,M
					U(K) = UMAT(JJ+ K*(N_TSTEPS))			! remember, 1st "column" of UMAT is time
				END DO
			ELSE						! use piece-wise ramps (linear interpolated inputs)
				DEL_T = THIGH - UMAT(J-1)
				DO K = 1,M
					SLOPE = (UMAT(J+ K*N_TSTEPS) - UMAT(J-1+ K*(N_TSTEPS)) ) / DEL_T
					U(K) = UMAT(J + K*N_TSTEPS) + SLOPE * ( T - THIGH)
				END DO
			END IF
			
		END IF
		
	ELSE				! no input given, so default to zero
		DO J=1,M
			U(J) = 0.0
		END DO
	END IF

C Allocate space in matlab memory for storing FLAG, T, U, and X inputs
	TIME = CRTMAT(1,1,0)
	INPUT = CRTMAT(M,1,0)
	STATE = CRTMAT(N,1,0)

C Get pointers to these variables and fill with the input data
	TP = REALP(TIME)
	IP = REALP(INPUT)
	SP = REALP(STATE)
	CALL CPIN(T,TP,1)
	CALL CPIN(U,IP,M)
	CALL CPIN(X,SP,N)

C Get the state partial derivatives from the Jacobian model

	RHS(1) = TIME		
	RHS(2) = STATE		! form the input for Jacobian calculation function
	RHS(3) = INPUT
	DO ICNT = 1,NPARAMS
		RHS(3+ICNT) = PARAMPTR(ICNT)
	END DO
	
	NRHS = 3 + NPARAMS               ! needs three or more inputs
	NLHS = 1                ! returns 1 result

	CALL MATFCN(NLHS,PDSTATE,NRHS,RHS,SYS_NAME(1:J_NAME_LEN))

	PDP = REALP(PDSTATE)      ! get pointer to result (the Jacobian Matrix)
	CALL CPOUT(PDP,PD,NSQ)   ! copy result into PD

	CALL FREMAT(TIME)		! free up matlab memory nolonger needed
	CALL FREMAT(STATE)
	CALL FREMAT(INPUT)
	CALL FREMAT(PDSTATE)

	RETURN
	END
	
	
C **************************************************************
C Here is the subroutine that displays messages
C in the MATLAB "command" window
C**************************************************************
	  subroutine dispmess(message, lines, maxlines)
	  integer lines, maxlines
	  character *(*) message(maxlines)

	  integer n, string, nlhs, nrhs, lhs, rhs, stp
	  
C INCREASE PARAMETER maxlinelength IF YOU HAVE MESSAGES > 80 CHARACTERS LONG
	  parameter (maxlinelength = 80)
	  double precision out(maxlinelength)

c Declare MEX utility functions (see MATLAB user's guide)
      integer CRTMAT, REALP, IMAGP, GETGLO, ALREAL, GETSTR
      double precision GETSCA
	  
	  do j = 1,lines

c This section appears unneccessary but would work if comments were removed
c	  	do k = 1,maxlinelength
c			out(i) = 32.0       ! erase any old message using spaces (ascii 32)
c		end do	

	  	n = len(message(j))  ! use the actual message length, but note it MUST BE <= maxlength

	  	do k = 1,n
	  	  out(k) = dfloat(ichar(message(j)(k:k)))    ! convert to ascii values
	  	end do
	  
	  	string = CRTMAT(1,n,0)    !create MATLAB storage area for message
	  	stp = REALP(string)       ! get pointer to string
	  	call CPIN(out,stp,n)      ! fill string with ascii value of message
	  
c Convert ascii vector (string) to a MATLAB data type string
C using the MATLAB function setstr

	  	nlhs = 1								! setstr has 1 output
	  	nrhs = 1								! and 1 input
	  	call MATFCN(nlhs,lhs,nrhs,string,'setstr') !string is the input
	  	rhs = lhs    ! lhs "points" to the output of MATLAB setstr function
	  
C Now use MATLAB disp function to display the message

	  	nlhs = 0                              ! disp has 1 input and no output
	  	call MATFCN(nlhs,lhs,nrhs,rhs,'disp')

C Free up MATLAB memory and return

	  	call FREMAT(string)       
	  	call FREMAT(lhs)
	  end do
	  
	  return
	  end
	
	SUBROUTINE U4Y(T,   U )
	DOUBLE PRECISION  T
	
	INCLUDE 'epi_siz_lim_defs.inc'			! defines input and output size limits

	INCLUDE 'epi_commons.inc'                     ! defines common blocks storing system names, input tables, etc.
	
	DOUBLE PRECISION U(MAX_U)

c Declare MEX utility functions (see MATLAB user's guide)
      integer CRTMAT, REALP, IMAGP, GETGLO, ALREAL, GETSTR
      double precision GETSCA

C Declare variables used as flags, pointers to Matab data space, etc 
	INTEGER TIME,  TP, LHS, RHS, J, JJ, K
	INTEGER FLAG, NLHS, NRHS
	DOUBLE PRECISION  THIGH, DEL_T, SLOPE
	CHARACTER*80 EMESS(2)

	IF (U_IS_STR .EQ. 1) THEN
		TIME = CRTMAT(1,1,0)  ! store the time
		TP = REALP(TIME)
		CALL CPIN(T, TP, 1)
		NRHS =1
		NLHS =1
		CALL MATFCN(NLHS, LHS, NRHS, TIME, U_OF_T(1:U_NAME_LEN))
		IP = REALP(LHS)
		CALL CPOUT(IP, U, M)
		CALL FREMAT(TIME)
		CALL FREMAT(LHS)

C  note: in the tests below, last_t is the LOWER end of the previous interval
C and j gets set to the UPPER end of current interval.

	ELSE								! u must be a table of times and inputs
		IF (T.GT. UMAT(LAST_T) ) THEN			! first look nearby
			IF (T .LE. UMAT(LAST_T+1) ) THEN ! are we in the same interval as last time?
				J=LAST_T + 1
			ELSEIF (T .LE. UMAT( MIN(N_TSTEPS, LAST_T+2)) ) THEN  ! if not, are we in the next interval?
				J = MIN(N_TSTEPS, LAST_T+2)
			ELSEIF (T. GE. UMAT(N_TSTEPS)) THEN  ! if not, check if T is beyond table.
				J = N_TSTEPS	
			ELSEIF (T. LT. UMAT(1) ) THEN ! if not check if we are below smallest t in umat  (NEW)
				J= 2
			ELSE							! if not,  do a binary search for the interval
				J = ISORT(T, LAST_T, 1, UMAT, N_TSTEPS)
			END IF
		ELSE							! new time is below old time range
			IF (T. LT. UMAT(1) ) THEN ! are we below smallest t in umat?
				J = 2
			ELSEIF (T .GE. UMAT(MAX(1, LAST_T-1)) ) THEN ! check one interval back
				J = MAX(2,LAST_T)
			ELSEIF (T .GT. UMAT(N_TSTEPS)) THEN
				J = N_TSTEPS
			ELSE						! if not there, do a full search below old interval
				J = ISORT(T, LAST_T, 0, UMAT, N_TSTEPS)
			END IF
		END IF
		
		LAST_T = J-1					! save LAST_T index for next time
		THIGH = UMAT(J)

		IF (IRAMP .EQ. 2) THEN    ! use piece-wise constant inputs
			JJ = J-1
			IF (T. GT. UMAT(N_TSTEPS) ) JJ = N_TSTEPS   ! needed if t > tfinal
			DO K = 1,M
				U(K) = UMAT(JJ+ K*(N_TSTEPS))			! remember, 1st "column" of UMAT is time
			END DO
c				WRITE(EMESS,*) ' U1 is ', U(1), ' at time ', T
c				CALL DISPMESS(EMESS, 1,2)
		ELSE						! use piece-wise ramps (linear interpolated inputs)
			DEL_T = THIGH - UMAT(J-1)
			DO K = 1,M
				SLOPE = (UMAT(J+ K*N_TSTEPS) - UMAT(J-1+ K*(N_TSTEPS)) ) / DEL_T
				U(K) = UMAT(J + K*N_TSTEPS) + SLOPE * ( T - THIGH)
			END DO
		END IF
		
	END IF
	
	RETURN
	END


	
