function vhBlocks = getblock( vhAllBlocks, sProperty, sValue )
%      GETBLOCK get block subset.
%
% INPUTS:
%	vhAllBlocks: A vector of block handles, to be subsetted.
%	sProperty: Property name to be matched.
%	sValue: Property value to match.
% OUTPUTS:
%	vhBlocks: subset of vhAllBlocks with sProperty matching sValue
%	If the property is 'Mask Dialogue' then the first part of the mask must
%	match the property only..
% GLOBALS:
%	none
%

%  TestData: vhAllBlocks = getchild( bdroot );
%		sProperty = 'Mask Dialogue'; sValue = 'Version';
%  TestData: vhAllBlocks = getchild( bdroot );
%		sProperty = 'BlockType'; sValue = 'InPort';
%
%	Author: Mike Wolf 7/11/95
%	Copyright (c) 1995 by The MathWorks Inc.
%	Revision: Bob Silverman 8/21/95
%	    stylistic changes
%	    function name changes

nBlocks = length( vhAllBlocks);
nResult = 0;
if strcmp(sProperty,'Mask Dialogue')
   sValue = [sValue , '|' ]; %add pipe character for matching
end

vhBlocks = [];
for i = 1:nBlocks
   sParmValue = get_param( vhAllBlocks(i), sProperty);
   
%look for matching start of string for MaskDialog, or whole string otherwise
 
   if (strcmp(sProperty,'Mask Dialogue') & findstr(sParmValue, sValue) == 1) ...
	 | strcmp(sParmValue, sValue)
       bFound = 1;
   else
       bFound = 0;
   end

   if bFound
      nResult = nResult + 1;
      vhBlocks(nResult) = vhAllBlocks(i);
   end
end
