function chgblob(xyz1,xyz2,s),
% CHGBLOB Change blob if it's position has changed
%		CHGBLOB(XYZ1,XYZ2,S) sets the xdata, ydata, and zdata
%		of a blob with handle S, if the position of either end,
%		(XYZ1,XYZ2), has change.
%		See also BLOB.

%		Copyright (c) 1994 by The MathWorks, Inc.
%               Jay Torgerson		

%		This function is used in SD/FAST demos.
%

x1 = xyz1(1);
y1 = xyz1(2);
z1 = xyz1(3);
x2 = xyz2(1);
y2 = xyz2(2);
z2 = xyz2(3);

scalev = axis;
scalefactor = .02;
xs = (scalev(2) - scalev(1))* scalefactor;
ys = (scalev(4) - scalev(3))* scalefactor;

x = [x1-xs x2-xs; x1+xs x2+xs; x1+xs x2+xs; x1-xs x2-xs; x1-xs x2-xs];
y = [y1+ys y2+ys; y1+ys y2+ys; y1-ys y2-ys; y1-ys y2-ys; y1+ys y2+ys];
z = [z1 z2; z1 z2; z1 z2; z1 z2; z1 z2];

xold = get(s,'xd');
yold = get(s,'yd');
zold = get(s,'zd');

if (any(any(xold ~= x)) | any(any(yold ~= y)) | any(any(zold ~= z))),
	set(s,'xdata',x,'ydata',y,'zdata',z);
end
