function newstring = dewhite(string),
%DEWHITE Removes white space from the input string.
%
%		The ascii codes for the ascii chars removed are:
%			new line    10
%			cr          13
%			space       32

%		Copyright (c) 1993 by The MathWorks, Inc.

% return if empty input
if isempty(string),
   return
end

whitespace = [ 10 13 32 ];
vec  = abs(string);

for i = 1:length(whitespace),
    vec(vec==whitespace(i)) = [];
end

newstring = setstr(vec);
