sdinputs(t, q, u, qdot, udot, inputs) 

double t, inputs[];                    /* function inputs  */
double q[], u[], qdot[], udot[];       /* function outputs */
{
    double point[3];                   /* Point = C.M. of pendulum        */
    double force[3];                   /* x component of force = first    */
                                       /* input to SD/FAST block.         */  
    double torque = inputs[1];         /* Frictional torque = input #2    */
                                       /* to SD/FAST block.               */

    int body = 0;                      /* Body number for pendulum = 0.   */
    int joint = 0;                     /* Joint number for joint between  */
                                       /* pendulum and ground = 0.        */
    int axis = 0;                      /* Joint axis about which the      */
                                       /* torque applies = 0.             */

                                       /* Initialize point to be the C.M. */
    point[0] = 0;                      /* x component = 0                 */
    point[1] = 0;                      /* y component = 0                 */
    point[2] = 0;                      /* z component = 0                 */
                                       /* Initialize force.               */
    force[0] = inputs[0];              /* x component = input #1          */
    force[1] = 0;                      /* y component = 0                 */
    force[2] = 0;                      /* z component = 0                 */
 
    sdpointf(body,point,force);        /* Apply force to body at point.   */
    sdhinget(joint,axis,torque);       /* Apply torque about joint axis.  */
}
 
/*
 * Copyright (c) 1993 by The MathWorks, Inc.
 */
































