function [sys, x0] = sd4plot(t,x,u,flag,plotit),
%SD4PLOT Plot routine for use with SDDEMO4

%		Copyright (c) 1993 by The MathWorks, Inc.
%		Jay Torgerson

%ts = .11;
global pendhands; 
if abs(flag) == 0,

    sys = [ 0 1 0 4 0 0 ];
    x0 = 0;
    if isempty(pendhands)
      return;
    end
    if plotit,
      set(pendhands(1),'Visible','On','FaceColor','m');
      set(pendhands(2),'Visible','On','FaceColor','m');
      set(pendhands(3),'Visible','On','FaceColor','Cyan');
      set(pendhands(4),'Visible','On','FaceColor','Red');
    end
elseif (flag == 2),
    if isempty(pendhands)
      sys = 0;
      return;
    end
  
%    if  (abs(round(t/ts) - t/ts) < 1e-1), 
	if plotit,
		pendulumlength = u(1);
		displacement = u(2);
        alpha = u(3);
        beta = u(4);
        pend1h = pendhands(1);
        pend2h = pendhands(2);
        springh = pendhands(3);
		groundh = pendhands(4);
		v = axis;

        % compute location of the bottom of pend1
        x1 = -displacement/2 + pendulumlength*sin(alpha);
        y1 = 0;
        z1 = -pendulumlength*cos(alpha);

        % compute location of the bottom of pend2
        x2 =  displacement/2 + pendulumlength*sin(beta);
        y2 = 0;
        z2 = -pendulumlength*cos(beta);

		% set top and bottom points for ground (ceiling)
	    tp = [ v(1) 0 0 ]; 
		bp = [ v(2) 0 0 ];
	 
		% set top and bottom points of pend1
        tp1 = [ -displacement/2 0 0 ];
        bp1 = [ x1 y1 z1 ];
    
		% set top and bottom points of pend2
        tp2 = [ displacement/2 0 0 ];
        bp2 = [ x2 y2 z2 ];
        
		% set top and bottom points of the spring connecting pend1 and pend2
        tp3 = [ (x1/2 - displacement/4)  0 z1/2 ];
        bp3 = [ (x2/2 + displacement/4)  0 z2/2];

		% call chgblob to redraw these blobs if their position has changed
        chgblob(tp1,bp1,pend1h);
        chgblob(tp2,bp2,pend2h);
        chgblob(tp3,bp3,springh);
		chgblob(tp,bp,groundh);
        drawnow
    end
    sys = 0;
else
    sys = [];
end




