function [pendhands] = sd4ploti(),
%SD4PLOTI Initializes figure window for SD4PLOT
%		See also SD4PLOT.

%		Copyright (c) 1993 by The MathWorks, Inc.
%		Jay Torgerson

fig = figure;
[ sys block ] = get_param;
thisblock = [sys,'/',block];

set(fig,'Name','Weakly Coupled Pendulums',...
        'NumberTitle','Off',...
        'Backingstore','Off',...
        'Units','Pixels',...
        'Position',[80 90 500 500]);

mh = uimenu('Label','Plot');
	 uimenu(mh,'Label','Close',...
	'Callback',['if get_param(''',thisblock,''',''parameters''), set_param(''',thisblock,''',''parameters'',''0'');end; clear pendhands; close']);

ah = axes;
set(ah,'XLabel',text(0,0,'x'),'YLabel',text(0,0,'y'),'ZLabel',text(0,0,'z'));
lim = 3;
axis( [ -lim-1 lim+1 -lim lim -lim lim ]);
set(ah,'drawmode','fast','Clipping','off');

view(339,30);
tp1 = [0 0 0];
bp1 = [0 0 0];
pend1h = blob(tp1,bp1); set(pend1h,'Visible','Off');

tp2 = [0 0 0];
bp2 = [0 0 0];
pend2h = blob(tp2,bp2); set(pend2h,'Visible','Off');

tp3 = [ 0 0 0 ];
bp3 = [ 0 0 0 ];
groundh = blob(tp3,bp3); set(groundh,'Visible','Off');

tp4 = [ 0 0 0 ];
bp4 = [ 0 0 0 ];
springh = blob(tp4,bp4); set(springh,'Visible','Off');

pendhands = [ pend1h pend2h springh groundh];
set(fig,'UserData',pendhands);
%global pendhands;


set_param(thisblock,'parameters','1');

