function sdchgedt(neweditor),
%SDCHGEDT changes the editor specified for an SD/FAST Inteface 
%		Control Panel.

%		Copyright (c) 1994 by The MathWorks, Inc.

% inputs:  none
% outputs: none

% this function:
%      (i)   sets the editor option for an SD/FAST Control Panel and
%	     updates the string in the Default Editor dialog.
%      (ii)  sets the command defined in the SIMULINK mask to specify
%            the new editor


% get useful handles
hfig = gcf;
CurrentObj = gco;
FigTitle = get(hfig,'Name');
handles  = get(hfig,'UserData');
editmodehand = handles(2);
newedithand  = handles(length(handles));
sysnamehand  = handles(3);

% get useful variables
sysname = get(sysnamehand,'String');

%                                     (i)                                   %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% set editormodehand for SD/FAST control panel to the new editor just specified
% and update the string in Default Editor Dialog if applicable.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
if strcmp(FigTitle,'SD/FAST: Default Editor'),
	hObjs = findobj(CurrentObj,'flat','Style','pushbutton');
	if isempty(hObjs),
		set(newedithand,'String',neweditor);
	else
		neweditor = get(newedithand,'String');
	end
end
set(editmodehand,'String',neweditor); 

%                                     (ii)                                  %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% reset the simulink mask value with new edit call
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
string = ['eval(''sdpanel(''''',neweditor,''''');'');'];
set_param(sysname,'Mask Dialogue',string);






