function sdgetfil(filestring),
% sdgetfil gets a file using the uigetfile command for and SD/FAST Control
%          panel

%		Copyright (c) 1993 by The MathWorks, Inc.
%		Jay Torgerson

% inputs:  string specifiying which file fields to change
% outputs: none

% this function:
%      (i)   finds out which file fields to edit
%      (ii)  gets the filename and filedir from uigetfile
%      (iii) sets the filehand and dirhand field accordingly
%      (iv)  updates Mask by setting the current obj and calling sdfndfil

% get useful hands
fig = gcf;
handles = get(fig,'UserData');
set(fig,'Pointer','Watch');
statush = handles(1);

previous_string = get(statush,'String');
set(statush,'String','Select New...');

%                                      (i)                                   %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% find out which file to edit
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
if strcmp(filestring,'sd'),
   filehand = handles(5);
   dirhand = handles(4);
   filterspec = '*.sd';
elseif strcmp(filestring,'i'),
   filehand = handles(8);
   dirhand = handles(7);
   filterspec = '*.c';
elseif strcmp(filestring,'o'),
   filehand = handles(11);
   dirhand = handles(10);
   filterspec = '*.c';
end

dir = get(dirhand,'String');
filterspec = [dir,filterspec];


%                                     (ii)                                   %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% get file from uigetfile
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
[filename,filedir] = uigetfile(filterspec,'SD/FAST: Select New');



%                                    (iii)                                   %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% set file fields in control panel
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
if ~isempty(filename),
    if filename~=0,
        set(filehand,'String',filename);
        set(dirhand,'String',filedir);
    end
end

%                                     (ii)                                   %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% update mask
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
set(fig,'CurrentObj',filehand);
sdfndfil;

set(statush,'String',previous_string);
set(fig,'Pointer','Arrow');
drawnow;
