function sdpanel(editstr),
%SDPANEL makes the appropriate calls to construct an SD/FAST Control Panel

%		Copyright (c) 1993 by The MathWorks, Inc.
%		Jay Torgerson

% inputs:  editstr = string that contains the default editor
% outputs: none

% this function
%      (i)   finds out what the name of the simulink block that called it
%            is 
%      (ii)  checks to make sure that there isn't already a contorl panel 
%            up with that name that is visible
%      (iii) calls sdsetup to setup the control panel and get handles
%      (iv)  calls sdinit to initialize the data


%                                    (i)                                    %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% get name of SIMULINK system 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
[windowname,systemname] = get_param;
sys = [windowname,'/',systemname];
figtitle = reslash(sys);
SETUPFLAG = 1;


%                                    (ii)                                   %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
if figflag(figtitle),
   SETUPFLAG = 0;  
end
	
%                                   (iii)                                   %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
if SETUPFLAG,
  handles = sdsetup(sys,figtitle,editstr);
else
  handles = get(gcf,'UserData');
end    

%                                    (iv)                                   %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
sdinit(handles);


