function sdparams(),
%SDPARAMS Updates the parameter dialog box for a SIMULINK MEX-file
%		implementation of an SD/FAST System.

%		Copyright (c) 1993 by The MathWorks, Inc.

fig = gcf;
previous_pointer = get(fig,'Pointer');
set(fig,'Pointer','Watch'); drawnow
handles = get(fig,'UserData');
statushand = handles(1);

% status 
previous_string = get(statushand,'String');
set(statushand,'String','Updating system parameters...'); drawnow

sysname = get(handles(3),'String');

% get handles to q0 and u0 init conditions
%     as well as num of inputs and outpus edit windows.
q0h = handles(13);
u0h = handles(14);
inputsh = handles(15);
outputsh = handles(16);
lockq0h = handles(17);
locku0h = handles(18);
tolq0h = handles(19);
tolu0h = handles(20);

% get their corresponding strings
q0hstr = get(q0h,'String');
u0hstr = get(u0h,'String');
inputshstr = get(inputsh,'String');
outputshstr = get(outputsh,'String');
lockq0str = get(lockq0h,'String');
locku0str = get(locku0h,'String');
tolq0str = get(tolq0h,'String');
tolu0str = get(tolu0h,'String');

% build a string that can be stuffed into the parameters dialog box
%   for the S-Function
comma = ',';
semicolon = ';';
string = [ inputshstr,comma,outputshstr,comma,q0hstr,comma,u0hstr,comma,lockq0str,comma,locku0str,comma,tolq0str,comma,tolu0str];

% remove trailing semicolon if it exists
strlen = length(string);
if string(strlen) == semicolon,
   string(strlen) = [];
end

% stuff string into the parameters dialog box for the appropriate S-Function
set_param(sysname,'parameters',string)

set(statushand,'String',previous_string); drawnow
set(fig,'Pointer',previous_pointer);

