function [success] = touch(filename),
%TOUCH Mimics the touch command found in UNIX in that it creates
%		a file without modifying it, if it doesn't exist.  If the
%		file does exist, nothing happens.
%		[SUCCESS] = TOUCH(FILENAME),
%		SUCCESS = 1, if successfull, and 0 otherwise.

%		Copyright (c) 1993 by The MathWorks, Inc.
%		Jay Torgerson

% inputs:  filename = name of file to be created 
% outputs: none

% this function:
%      (i)   checks to see if the specified file exits on the MATLABPATH
%            and creates it if it doens't or does nothing if it does

%                                     (i)                                   %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% check to see if the file exists
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
fid = fopen(filename,'r');
if fid < 0,
	fid = fopen(filename,'w');
	if fid == -1,
		success = 0;
	else
	    fclose(fid);
		success = 1;
	end
end
