% DataBus Blockset.
% Version 1.1a  2-Mar-96
%
% SIMULINK Libraries.
%   buslib     - Main library for DataBus functions.
%
% SIMULINK Demos.
%   bussamp1   - Block diagram showing all current functions.
%   bussamp2   - Block diagram showing insert and select functions.
%
% M-File Samples.
%   bus1       - Sample bus definition file.
%   bus2       - Sample bus definition file.
%   bus3       - Sample bus definition file.
%
% Utility Functions - these are specific to the DataBus blockset
%                     but could be used as examples.
%   addtobus   - Add to indicies of a signal list in a DataBus.
%   busdmat    - Create D matrix given indices and vector size.
%   busmux     - Validate or create bus definition given two others.
%   busmuxui   - GUI for selecting bus names to mux.
%   busread    - Get sizes and string from a DataBus file.
%   bussel     - Select one or several data channels of a DataBus.
%   bussize    - Get total vector length for a given DataBus
%   dbimdraw   - Call back utility for drawing DataBus icon masks.
%   mask2str   - Get mask entries and store in a string matrix.
%   parsebus   - Find indicies to a given signal list in a DataBus.
%   setnin     - Set the number of inputs to a masked mux block.
%   setnout    - Set the number of outputs from a masked demux block.
%   simbus     - Description of DataBus file format.
%   str2mask   - Set mask entries from a string matrix.

% Hidden utility blocks
%   busconv    - Convert DataBus files from pre 1.0 format.
%   lbblock    - Masked S-function block to call loobprk.mex

% S-Functions.
%  - M
%  - MEX
%  loopbrk.c
%  - C

% Copyright (c) 1995 by The MathWorks, Inc.
% $Revision: 1.14 $  $Date: 1996/05/02 22:40:48 $

