function busconv(inputbus,outputbus)
%BUSCONV Reads bus old style definition file and writes in new format.
%
%Example:
%
% busconv('bus1','newbus1')

if (nargin ~= 2)
  error('BUSCONV requires two input arguments')
end  

if (exist([outputbus '.txt']) == 2)
  error(['Output file ' outputbus '.txt exists - rename or use another name.'])
end  

[strings,sizes]=feval(inputbus);

fid_outputbus=fopen([outputbus '.txt'],'wt');
fprintf(fid_outputbus,'%%This file is a plain text definition for DataBus %s.\n',outputbus);
fprintf(fid_outputbus,'%%\n');
fprintf(fid_outputbus,'%%Type "help simbus" for more information.\n');
fprintf(fid_outputbus,'\n');
[NumSignals,MaxStringWidth]=size(strings);
fprintf(fid_outputbus,['%%%-' num2str(MaxStringWidth) 's%s\n'],'Name','Size');
for (Ind=1:NumSignals)
  fprintf(fid_outputbus,['%-' num2str(MaxStringWidth) 's %d\n'],deblank(strings(Ind,:)),sizes(Ind));
end  

    
