function entries=mask2str(blockhandle)
%MASK2STR Returns entries from a mask dialog as a space padded string matrix.
%
%Example:
%
% h_cs=get_param(gcb,'Handle');
% entries=mask2str(h_cs);
%
%See str2mask to do the converse.

%William York, 12/95.
%Copyright (c) 1995 by The MathWorks, Inc.

%$Revision: 1.3 $ $Date: 1995/12/11 21:48:24 $

% This does not check if a string contains \/.  
% If a mask dialog contains \/, this will fail.
% This test could be done by checking if a given string contains and even
% number of single quotes, but it would be slow.

MaskEntries=get_param(blockhandle,'Mask Entries');

% Parse the entries
[entries,Remainder]=strtok(MaskEntries,'\/');
while (~isempty(Remainder))
  [Entry,Remainder]=strtok(Remainder,'\/');
  if (~isempty(Entry))
    entries=str2mat(entries,Entry);
  end
end
