/*
 *  S-function to break algebraic loops - use carefully.
 */

#define S_FUNCTION_NAME loopbrk

#include <math.h>

#ifdef MATLAB_MEX_FILE
# include "mex.h"
#endif

#include "simstruc.h"

static void mdlInitializeSizes(SimStruct *S)
{
    ssSetNumContStates(    S, 0);      /* number of continuous states */
    ssSetNumDiscStates(    S, 0);      /* number of discrete states */
    ssSetNumInputs(        S, DYNAMICALLY_SIZED);      /* number of inputs */
    ssSetDirectFeedThrough(S, 0);      /* direct feedthrough flag */
    ssSetNumSampleTimes(   S, 1);      /* number of sample times */
    ssSetNumInputArgs(     S, 0);      /* number of input arguments */
    ssSetNumRWork(         S, 0);      /* number of real work vector elements */
    ssSetNumIWork(         S, 0);      /* number of integer work vector elements */
    ssSetNumPWork(         S, 0);      /* number of pointer work vector elements */
    ssSetNumOutputs(       S, DYNAMICALLY_SIZED);      /* number of outputs */
}

static void mdlInitializeSampleTimes(SimStruct *S)
{
    ssSetSampleTimeEvent(S, 0, 0.0);
    ssSetOffsetTimeEvent(S, 0, 0.0);
}

static void mdlInitializeConditions(double *x0, SimStruct *S)
{
}

static void mdlOutputs(double *y, double *x, double *u, SimStruct *S, int tid)
{
  int     i;

  for (i=0;i<ssGetNumInputs(S);i++) {  /* Pass the U vector directly to the Y vector */
    y[i] = u[i];
  }
}

static void mdlUpdate(double *x, double *u, SimStruct *S, int tid)
{
}

static void mdlDerivatives(double *dx, double *x, double *u, SimStruct *S, int tid)
{
}

static void mdlTerminate(SimStruct *S)
{
}

#ifdef  MATLAB_MEX_FILE    /* Is this file being compiled as a MEX-file? */
#include "simulink.c"      /* MEX-file interface mechanism */
#else
#include "cg_sfun.h"       /* Code generation registration function */
#endif
