function typaramX(a0,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16)
% TYPARAMX Prints parameters of a set_param call
%   Called by TYPARAMS
%   Global variables that must be set:
%   TYPARAMS_OUTFID       file to write to
%   TYPARAMS_IGNORELIST   list of block parameters not to write
%   TYPARAMS_NL           new line character(s) of operating system
%
% Name: typaramX.m
% Date: 26.09.94
%
%  Markus A. Mueller, Sept. 26, 1994
%  Copyright (c) 1994 by Markus A. Mueller
%  ABB Corporate Research Center, CH-5405 Baden/Switzerland
%
%       Permission is granted to modify and re-distribute this
%       code in any manner as long as this notice is preserved.
%       Not for use in commercial products.
%       All standard disclaimers apply.
%
% Version history:
% Date      Change
% 06.11.95  changed names of global variables  
% 13.12.95  delete return characters in block names

% max parameter name length assumed to be 20 
% (since Matlab var names <=19 chars)
global TYPARAMS_OUTFID
global TYPARAMS_IGNORELIST
global TYPARAMS_NL

% copy newline string to shorter name to make program legible
nl = TYPARAMS_NL;

% use tabs between varnames and values,
% otherwise use spaces to align stuff

use_tabs_flag = 1;

name_not_printed = 1;
for ct = 1:2:nargin-2
  par_name = eval(['a'  int2str(ct)]);
  if isempty(findstr(par_name,TYPARAMS_IGNORELIST)) % nontrivial parameter
    if name_not_printed                      % not printed yet
	  if findstr('/',a0)                     % not root window
	    indx = find((a0==13)+(a0==10) );     % find occurences of <CR> or <NL>
        a0(indx)=zeros(size(indx))+' ';      % replace them by blanks
	    fprintf(TYPARAMS_OUTFID,[nl '%s' nl],a0);   % print function name once
	    name_not_printed = 0;
	  end
	end
	if use_tabs_flag
      fprintf(TYPARAMS_OUTFID,'\t%s',par_name);  % print parameter name, value
      eval(['fprintf(TYPARAMS_OUTFID,[''\t=\t%s'' nl],a' int2str(ct+1) ');' ]);
	else
	  par_name = [blanks(max(21-size(par_name,2),0)) par_name];
      fprintf(TYPARAMS_OUTFID,'  %s',par_name);  % print parameter name, value
      eval(['fprintf(TYPARAMS_OUTFID,['' = %s'' nl],a' int2str(ct+1) ');' ]);
    end
  end
end
if nargin > 17
  fprintf(TYPARAMS_OUTFID,...
  ['**** Warning: This call to typaramX has >8 parameters' nl]);
  fprintf(TYPARAMS_OUTFID,...
  ['     The remaining parameters have not been printed' nl nl]);
end


