function [a,b]=binom(p,m,n)
%Performs random sampling from a binomial distribution
%Computes mean and standard deviation of occurrence fraction
%
% [a,b]=binom(p,m,n)
% where p=probability of occurrence
%       n=sample size
% and   m= number of trials
%By H. T. McAdams Box 150 Argenta, IL 62501
for k=1:m
     x=rand(n,1);
        i=find(x<=p);
            j=size(i);
                y(k,1)=j(1,1)/n;
end
a=mean(y);
b=std(y);
