% Probability functions (cdb).
% Author: Claude D. Bilbo
% Revised: 12-11-95
%   
% Probability Density Functions (pdf)
%
%   dgauss     - Multivariate gaussian pdf.
%   dln        - Multivariate lognormal pdf.
%   dgaussum   - Multivariate gaussian sum pdf.
%
% Cumulative Distribution Functions (cdf)
%
%   pgauss     - Univariate gaussian cdf
%   pln        - Univariate lognormal cdf
%   pgaussum   - Univariate gaussian sum cdf.
%
% Random Number Generators
%
%   randn2     - Multivariate gaussian random number generator.
%   randln     - Multivariate log-normal random number generator.
%
% Statistical Conversions
%
%   lgn2norm   - Multivariate log-normal to gaussian conversion.
%   norm2lgn   - Multivariate gaussian to log-normal conversion.
%
% Miscellaneous
%
%   demo       - Demonstration program
%   data1.mat  - Data for means, covariances, and weights of a
%                gaussian sum approximation to a lognormal surface
%   data2.mat  - Density values for plot of lognormal surface
%   contents   - This file
%

% Note: Copy freely, but document any changes.
%