
% COMMONITY,redundancy,canonical,analyses: X1 explained by X2

% Same cases (rows) and same variables (columns) for X1 and X2.
% For: data at times 2 next 1, or sensorial data (two judges).

% Commonity analysis and connections with the other authors:
% R. Lafosse 1989: Ressemblance et difference entre deux tableaux
% totalement apparies, Statistique et analyse des donnees
% Vol. 14 n2 pp.1-24
% Applied article:
% R. Lafosse 1991: Explications d'un tableau par un autre.
% la revue de MODULAD, n8, INRIA. Paris.
% Ethernet Mail: lafosse@cix.cict.fr

% COMMONITY ANALYSIS
% Every variable j of X1 is explained by the same variable j of X2
% But the correlations of the variables of X1 with the variable j of X1,
% and those of X2 with the second j, step in on the explanation,
% via the variates.
% Sometimes, for some variables, this is better than REDUNDANCY
% analysis of Wollenberg-Johansson-Tyler-Rao C.R.(P.C.A.I.V.,1964).
% In community, not calculus of inverse of matrix.

% In the COMMONITY's analysis, you can observe in X1 what is
% similar whith X2: a variable (with variance 1) of X1 is well
% represented in a plane by a vector projected if its length is
% next to 1. More the star is next to the extremity, greater is
% the commonity of this variable with its expression in X2.
% It's a comparison between the two shapes of two vectorial case-
% points clouds, or of the two multivariate distributions, with an
% original approach as for the variances and the means.
% In addition, you observe in X1 what is dissimilar from X2,
% with a P.C.A. of residual part of the previous similarity part.

% The same program is used for REDUNDANCY: then, the explained
% variables-X1 are plotted in the best explanatory planes.
% More the star is next to the extremity of the vector, greater
% is the explanation by X2.
% The same program is also used for a particular presentation
% of CANONICAL analysis. More the star is next to the extremity
% of the vector, greater is the communality of this vector with
% X2.

% Several reduction modes are possible. In this example, it is by
% concatenation (square root of arithmetic means of the variances
% of the variables, two by two).

% Do you want COMMONITY? COMMONITY and REDUNDANCY, for comparing?
% only REDUNDANCY? CANONICAL ANALYSIS? See after, modify or not,
% and run readme.

% For your data: remplace tabf, which countains the
% matrices x1 and x2; modify prog4, at line 25: the number of the
% letters in let1 should be equal to the number of columns of x1,
% or of x2. From let, you can paste into let1 these letters.
% Save.

% COMMONITY
% tabf;
%cenandredconcatene;
%prog2;prog3;prog3meantest;prog4;pause

% COMMONITY next REDUNDANCY
tabf;
cenandredconcatene;
prog2;prog3;prog4;
prog1maha;prog2;prog3maha;prog4;pause

% REDUNDANCY
% tabf;
%cenandredconcatene;
%prog1maha;prog2;prog3maha;prog4;pause

% CANONICAL ANALYSIS
% tabf;
%sansred;x1maha;
%prog1maha;prog2;prog3maha;prog4;

% NAMES of the files:
% readme;tabf;cenandredconcatene,cenandredx1,sansred,x1cano,
% prog1maha;prog2;prog3maha;prog3;prog3meantest;prog4;grapsi;
% grapdi;detect;
% Utilities: permute;jel;

