function label=alias(X)
%ALIAS Finds aliased columns of matrix X
%USE: labels=alias(X)
%   where  labels  is a vector of the linearly independent columns
%          X  is the original data matrix.
%X(:,label) is the matrix with aliased variables removed
%For use within  glmlab

%Peter Dunn
%Last revision: 13/11/95

toler=paramtrs;

XX=X(:,1); i=1;label=[1];
for j=1:size(X,2);
   i=i+1; XX=[XX X(:,j)];
   if det(XX'*XX)<toler,
      XX=[ XX(:,1:size(XX,2)-1) ];
   else
      label=[label j];
   end;
end;
