%HELPVARS  Help screen for glmlab

%Peter Dunn
%20/08/1996

figure('Units','normal','Resize','off','NextPlot','new',...
       'Name','glmlab Explanations','NumberTitle','off');

uicontrol('Style','text','Units','normalized',...
 'Position',[0 .95 1 .05],'String',...
 ['Variable names used must refer to variables already ',...
  'defined in the workspace.'],...
 'HorizontalAlignment','left',...
 'BackgroundColor','k','ForegroundColor','w');
uicontrol('Style','text','Units','normalized',...
 'Position',[0 .90 1 .05],'String',...
 'To be safe, don''t use variable whose names are all CAPITAL letters.',...
 'HorizontalAlignment','Left',...
 'BackgroundColor','k','ForegroundColor','w');

uicontrol('Style','text','String','Response (y):',...
 'Units','normalized','Position',[0 .82 .25 .05],...
 'HorizontalAlignment','left',...
 'BackgroundColor','k','ForegroundColor','w');
uicontrol('Style','text','Units','normalized',...
 'Position',[.28 .82 .69 .05],...
 'String','Type the name of the response (y) variable.  For the',...
 'HorizontalAlignment','left',...
 'BackgroundColor','k','ForegroundColor','w');
uicontrol('Style','text','Units','normalized',...
 'Position',[.28 .77 .69 .05],...
 'String','binomial case, use two columns: [counts  sample size]',...
 'HorizontalAlignment','left',...
 'BackgroundColor','k','ForegroundColor','w');

uicontrol('Style','text','String','Covarites (X):',...
 'Units','normalized','Position',[0 .69 .25 .05],...
 'HorizontalAlignment','left',...
 'BackgroundColor','k','ForegroundColor','w');
uicontrol('Style','text','Units','normalized',...
 'Position',[.28 .69 .69 .05],'String',...
 'Enter the list of covariates (X values).  The inclusion of',...
 'HorizontalAlignment','left',...
 'BackgroundColor','k','ForegroundColor','w');
uicontrol('Style','text','Units','normalized',...
 'Position',[.28 .64 .69 .05],'String',...
 'the Constant Term is controlled in the OPTIONS menu.',...
 'HorizontalAlignment','left',...
 'BackgroundColor','k','ForegroundColor','w');
uicontrol('Style','text','Units','normalized',...
 'Position',[.28 .59 .69 .05],'String',...
 'Interactions are specified with the  @  character.',...
 'HorizontalAlignment','left',...
 'BackgroundColor','k','ForegroundColor','w');

uicontrol('Style','text','String','Prior Weights:',...
 'Units','normalized','Position',[0 .53 .25 .05],...
 'HorizontalAlignment','left',...
 'BackgroundColor','k','ForegroundColor','w');
uicontrol('Style','text','Units','normalized',...
 'Position',[.28 .53 .69 .05],...
 'String','Enter the name of the prior weights variable.',...
 'HorizontalAlignment','left',...
 'BackgroundColor','k','ForegroundColor','w');

uicontrol('Style','text','String','Offset Variable',...
 'Units','normalized','Position',[0 .45 .25 .05],...
 'HorizontalAlignment','left',...
 'BackgroundColor','k','ForegroundColor','w');
uicontrol('Style','text','Units','normalized',...
 'Position',[.28 .45 .69 .05],...
 'String','Enter the name of the offset variable.',...
 'HorizontalAlignment','left',...
 'BackgroundColor','k','ForegroundColor','w');

uicontrol('Style','text','String','Fit Model',...
 'Units','normalized','Position',[0 .37 .25 .05],...
 'HorizontalAlignment','left',...
 'BackgroundColor','k','ForegroundColor','w');
uicontrol('Style','text','Units','normalized',...
 'Position',[.28 .37 .69 .05],...
 'String','Fits the model as currently specified.',...
 'HorizontalAlignment','left',...
 'BackgroundColor','k','ForegroundColor','w');

uicontrol('Style','text','String','Residual Plots...',...
 'Units','normalized','Position',[0 .29 .25 .05],...
 'HorizontalAlignment','left',...
 'BackgroundColor','k','ForegroundColor','w');
uicontrol('Style','text','Units','normalized',...
 'Position',[.28 .29 .69 .05],...
 'String','The menu screen for plots about residuals.',...
 'HorizontalAlignment','left',...
 'BackgroundColor','k','ForegroundColor','w');

uicontrol('Style','text',...
 'String','A New Model can be declared in the OPTIONS menu.',...
 'Units','normalized','Position',[0 .21 1 .05],...
 'HorizontalAlignment','left',...
 'BackgroundColor','k','ForegroundColor','w');

uicontrol('Style','pushbutton','String','Finished','Units','normalized',...
 'Position',[.4 .02 .2 .08],'Callback','delete(gcf);');
