function [intmat,indvec]=interact(v1,v2,v3,v4,v5,v6,v7,v8,v9,v10,v11,v12)
%INTERACT: Interactions for up to 12 interacting terms in  glmlab.
%USE:    [intmat, indvec]=interact(v1,v2, ... v12)
%   where  v1, v2, ... v12 are the variables to interact (up to 12)
%          intmat  is the resultant incidence matrix;
%          indvec  is the matrix of  matrix indicies.
%EXAMPLE:  To find the interaction between a (qual), b (qual)
%          and c (quantitative), use:
%             interact(fac(a), fac(b), c);

%This seems very slow code, but it is a more general routine allowing
%for many levels of interactions.  In general, it is a lot slow than the
%old interact.m (up to three times slower), but allows for whatever number 
%of interaction to be found.  This would become very unwieldy 
%with the old version.

%Peter Dunn
%23/07/1996

lengths=zeros(1,nargin);
for i=1:nargin
   eval(['lengths(i)=size(v',num2str(i),',2);']);
end;
matl=prod(lengths);

%intmat
intmat=kron(v1,ones(1,matl/size(v1,2)));
index1=size(v1,2);index2=matl/size(v1,2);
for i=2:nargin,
   eval(['ll=size(v',num2str(i),',2);']);
   index2=index2/ll;
   eval(['newmat=kron(ones(1,index1),kron(v',num2str(i),',ones(1,index2)));']); 
   intmat=intmat.*newmat;
   index1=index1*ll;
end;

%indvec
for i=1:nargin,
   indvec(:,i)=makefac(matl,lengths(i),matl/prod(lengths(1:i)));
end;

%Now some fiddles for when quantitative variables are interacted
%(The guts of glmlab understands negative indicies to be ignored, for
% be the case when quantitative vars interact.)
for i=1:size(indvec,2),
   if all(indvec(:,i)==1), indvec(:,i)=-indvec(:,i); end;
end;

