function [where,ind]=findmat(instr, searchstr)
%FINDTHIS Finds where  searchstr  occurs in (matrix) string instr
%USE:  [where,ind]=findmat(instr, searchstr)
%  where  where  is a string matrix, each row a string of where
%         searchstr  is found.  str2num(where(1,:)) converts to numbers.
%         ind  is a column vector, 1 if the search string is in the row i.

%Peter Dunn
%03/07/1996

if size(searchstr,1)>1, 
   error('Can only search for one-line strings!');
end;

ind=zeros(size(instr,1),1);
if size(instr,1)==1, 
   if strcmp(searchstr,blanks(length(searchstr))),
      padchar='%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%';
      padchar=[padchar,padchar,padchar];
   else
      padchar=blanks(100);
   end;
   ins=[instr,padchar];
   %pad to ensure that searchstr is looked for
   where=findstr(ins,searchstr);if ~isempty(where), ind=1; end;
   where=num2str(where);
else
   where=[];
   if strcmp(searchstr,blanks(length(searchstr))),
      padchar='%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%';
      padchar=[padchar,padchar,padchar];
   else
      padchar=blanks(100);
   end;
   for i=1:size(instr,1), 
      ins=[instr(i,:),padchar];
      ok=findstr(ins,searchstr);
      if ~isempty(ok), ind(i)=1; end;
      where=str2mat(where, mmat2str( ok ));
   end;
   if ~isempty(where), where(1,:)=[]; end;
end;
