function outstr=mmat2str(matrix)
%MMAT2STR  glmlab  version of matlab  mat2str  for those with student editions
%USE  outstr=mmat2str(matrix)
%     where  matrix  is a matrix to convert to a string
%            outstr  is the resultant string.

%Peter Dunn
%03/07/1996

%Heavy borrowing from  matlab's  mat2str

if isstr(matrix), outstr=matrix;return;end;

[rows, cols] = size(matrix);
if rows*cols ~= 1, outstr = '['; else outstr = ''; end;
for i=1:rows,
   for j=1:cols,
      %some special cases out of the way first
      if matrix(i,j) == Inf,
         outstr=[outstr,'Inf'];
      elseif matrix(i,j) == -Inf,
         outstr=[outstr,'-Inf'];
      else
         outstr=[outstr,sprintf('%.15g',real(matrix(i,j)))];
         %Complex entries
         if imag(matrix(i,j))<0,
            outstr=[outstr,'-i*',sprintf('%.15g',abs(imag(matrix(i,j))))];
         elseif(imag(matrix(i,j)) > 0)
            outstr=[outstr,'+i*',sprintf('%.15g',imag(matrix(i,j)))];
         end;
      end;
      outstr=[outstr ' '];
   end;
   l=length(outstr); outstr(l:l+1)='; '; %Row finished
end;
if rows==0, outstr=[outstr,'  ']; end; %empty case
l=length(outstr);
if rows*cols ~= 1
   outstr(l-1)=']';
   outstr(l)=[];
else    
   outstr(l-1:l)=[];
end;
