%GLMPLOT  Plots some graphs within  glmlab
%USE:  glmplot  prints a menu of plots from which to select

%Peter Dunn
%20/08/1996

global FLAG RESIDS RESTYPE ERRDISFUNCTION YVAR NAMEXV;

%before starting new window, check if plot window is already there.
EXISTPLOT=figflag('glmlab Plot Selection Window');
if EXISTPLOT, clear EXISTPLOT; return; end;
clear EXISTPLOT;

if FLAG==1,
   makeline(2);
   disp(' PLEASE FIT A MODEL BEFORE PROCEEDING WITH RESIDUAL PLOTS');
   makeline('','-');bell;
   disp(' You have made some important changes, so you should');
   disp(' refit the model before plotting.  Some information will probably');
   disp(' change, and the plots produced now may be incorrect.');
   GO=input(' Do you wish to continue plotting? (y/n) ','s');
   if ~strcmp(lower(GO(:,1)),'y'), clear GO; return; end; disp(' ');clear GO;
   disp(' If you experience any problems, try fitting the model again.');
elseif FLAG==2,
   makeline(2);
   disp([' Residuals could not be calculated for the ',upper(ERRDISFUNCTION)]);
   disp(' distribution, so no plots can be produced.  Sorry.');
   disp(' You could try a different type of residual.');
   makeline('','-');return;
end;

figure('Name','glmlab Plot Selection Window','NextPlot','new',...
       'Resize','off','MenuBar','none');axis off;
uicontrol(gcf,'String','Select the plots you would like, then press PLOT',...
 'Style','text','Units','normalized','Position',[.1 .9 .8 .05],...
 'BackgroundColor',[0 0 0],'ForegroundColor',[1 1 1]);
uicontrol(gcf,'String','Residuals vs Response Variable (y)',...
 'Style','checkbox','Units',...
 'normalized','Position',[.1 .75 .8 .08],'tag','resvy');
uicontrol(gcf,'String','Residuals vs Covariates (X)',...
 'Style','checkbox','Units',...
 'normalized','Position',[.1 .65 .8 .08],'tag','resvc');
if isempty(NAMEXV),
   set(findobj('tag','resvc'),'Visible','off');
end;
uicontrol(gcf,'String','Normal Probability Plot of Residuals',...
 'Style','checkbox','Units',...
 'normalized','Position',[.1 .55 .8 .08],'tag','npplot');
uicontrol(gcf,'String','Residuals vs Fitted Values','Style','checkbox',...
 'Units','normalized','Position',[.1 .45 .8 .08],'tag','resvf');
if ~strcmp(RESTYPE,'quantile'),
   uicontrol(gcf,'String','Quantile Equivalents','Style','checkbox',...
    'Units','normalized','Position',[.1 .35 .8 .08],'tag','qequiv');
end;
uicontrol(gcf,'String','PLOT','Style','pushbutton',...
 'Units','normalized','Position',[.1 .1 .3 .1],'Callback',...
 'plotwork');
uicontrol(gcf,'String','CANCEL','Style','pushbutton',...
 'Units','normalized','Position',[.6 .1 .3 .1],'Callback','delete(gcf);');
