function [Ds,Da]=diffh(A,k,h1,h2,inc)

% DIFFH       Difference between KDE's using two different values of h.
%
%             Example: load kddata
%                      d=glass(:,5);
%                      [Ds,Da]=diffh(d,'knorm',hns(d,'knorm'),hste(d,'knorm'),128);
%
%             DIFFH(A,K,H1,H2,INC)
%
%             Christian C. Beardah 1995

if nargin==4,
  inc=128;
end;

[y1,x]=kdfft1(A,k,inc,h1,0);

[y2,x]=kdfft1(A,k,inc,h2,0);

figure;
plot(x,y1,'w');
hold on
plot(x,y2,'w--');

figure;
plot(x,(y1-y2).^2,'w');
hold on
plot(x,abs(y1-y2),'w--');

delta=x(2)-x(1);

Ds=delta*sum((y1-y2).^2);

Da=delta*sum(abs(y1-y2));