function [Pmean,Pstd] = ks_prob(files)

% KS_PROB(files) calculates the mean and standard deviation
% of the Kolmorogov-Smirnov statistic given by XORCISE.M, as
% stored in the data files.
% FILES contains the names of the data files eg
%	files=['ks5e1-8';'ks1e2-8';....'ks5e3-8']
%
% Version 1.0 RHS 2/11/94

[m,n]=size(files);

level=100-[0.1:0.1:0.9 1.0:20];		% set probability levels

for k=1:m
	fprintf('Loading and calculating file number %i\n',k)
	eval(['load ' files(k,:)])	% load data
	z=sort(Z);			% sort into ascending order
	prob(k,:)=prctile(z,level)';	% find percentile values
end

Pmean=mean(prob);
Pstd=std(prob);		% find mean and standard deviation