function addcase
% ADDCASE - will add case numbers to data files.  Default extension for input 
% file is  'dat'.   Output files will have an 'smp' extension for simple 
% regression, and an 'mlt' extension for multiple regression.

global PATH_Data PATH_Prg PATH_Demo

SPACE = '  ';
% length of file equals 2 when the user cancels
LEN_NoFileSel = 2;
counter = 1;	

% change directory
eval(PATH_Data);
FILE_Dat = ldfile('*.dat');


% exit if the user chooses cancel button
	if length(FILE_Dat) == LEN_NoFileSel
 		return
	end

	gcases

% NUM_VARIABLES
%	1			empty or has only one column
%	2			simple, must add case numbers
%	3			smp or mlt
%	> 4			mlt
	

if NUM_VARIABLES == 1
	err01
	return
end

if NUM_VARIABLES > 2
	FILE_Out = chgext(1, FILE_Dat, '.MLT');
else
	FILE_Out = chgext(1, FILE_Dat, '.SMP');
	% only two columns must add case numbers
	respone = 'y';
end

% create output file, which contains case numbers in addition to data
	FID_Dat = fopen(FILE_Dat, 'r');
	FID_Out = fopen(FILE_Out, 'wt');

buffer = [];
while ~feof(FID_Dat)

	line = fgets(FID_Dat);

	if ~isstr(line), 
		fclose(FID_Dat),
		fclose(FID_Out),
		eval(PATH_Demo),
		return,
	end
	
	nr_line = sscanf(line, '%f');
	nr_line = nr_line';

	if isempty(nr_line) & counter == 1, 
		err01,
		return, 
	end

	% do not copy blank lines or irregular lines
	if length(nr_line) == NUM_VARIABLES
     		string = [counter nr_line];
		buffer = [buffer; string];
		counter = counter + 1;
	end
end

fclose(FID_Dat);

match = 0;
for I = 1:counter-1
	if buffer(I, 1) == buffer(I, 2)
		match = 1;
		break;
	else
		I = I + 1;
	end
end

if NUM_VARIABLES ~= 2
    if match == 1
	clc
	disp('<<NOTE>> :')
	disp('The first column contains consecutive integers starting with one...');
	disp('    The first two rows are displayed below, to illustrate what the new file')
	disp('    would look like, with case numbers added: ')
	disp(' ')
	disp( buffer(1:2,:) )
	disp(' ')
	disp('Do you want to add case numbers?');
	
	disp(' ')
	disp(' ')
	disp('                             ****      Y - Yes     ****');
	disp('                             ****      N - No      ****');
	
	response = input(' ', 's');
	response = response(1);
    end



 if response == 'y' | response == 'Y' 

	for I = 1:counter-1
		fprintf(FID_Out, '%g     ', buffer(I, :));
		fprintf(FID_Out, '\n');		
		I =I + 1;
	end
	% This is not a case to copy the data file
	copy_only = 0;

 else
	% do nothing to data file, except change extension 
	copy_only = 1;

 end

else

	for I = 1:counter-1
		fprintf(FID_Out, '%g     ', buffer(I, :));
		fprintf(FID_Out, '\n');		
		I =I + 1;
	end

end




if copy_only

	fclose(FID_Out);
		
	if NUM_VARIABLES == 3
		del_string = ['del ' FILE_Out];
		status = dos(del_string);
			if status < 0
				disp('Could not delete file: ')
				disp(FILE_Out);
			end
		FILE_Out = chgext(1, FILE_Dat, '.SMP');
	end


	copy_string = ['COPY ' FILE_Dat SPACE FILE_Out];
	status = dos(copy_string);

	if status < 0
		disp('Could not copy file: ');
		disp(FILE_Dat);
		return;
	end

else
	fclose(FID_Out);
end


eval(PATH_Demo);
clc
