% CHECKBX - uimenu plotting options
% plotting options such as:  axis, background and point colors can be changed.
% When the type of plot is regression, the user can choose among the available 
% regression methods.

FILE_ip = chgext(1, FILE_Dat, '.smp');


%PLOTFIG = gcf;
plot_opt =  uimenu(PLOTFIG,...
	'Label', 'Plot Options');


plot_method = uimenu(plot_opt,...
	'Label', 'Regession Method');


% +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

% set the initial value of the IP plot handle to an empty array
	Hplot_ip = [];

opt_plotip = uimenu(plot_method,...
	'Label',  'IP',...
	'Callback', [...
	'if ~isempty(Hplot_ip),',...
		'if strcmp( get( opt_plotip, ''Checked'' ), ''on''),',...
			'set( opt_plotip, ''Checked'', ''off''),',...
			'set( Hplot_ip, ''Visible'', ''off''),',...
		'else,',...
			'set( opt_plotip, ''Checked'', ''on''),',...
			'set( Hplot_ip, ''Visible'', ''off''),',...
			'Hplot_ip = plotip(FILE_ip);,',...
		'end,',...
	'else,',...
		'Hplot_ip = plotip(FILE_ip);,',...
		'set( opt_plotip, ''Checked'', ''on''),',...
	'end'] );

% +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

% set the initial value of the LMS plot handle to an empty array
	Hplot_lms = [];

opt_plotlms = uimenu(plot_method,...
	'Label',  'LMS',...
	'Callback', [...
	'if ~isempty(Hplot_lms),',...
		'if strcmp( get( opt_plotlms, ''Checked'' ), ''on''),',...
			'set( opt_plotlms, ''Checked'', ''off''),',...
			'set( Hplot_lms, ''Visible'', ''off''),',...
		'else,',...
			'set( opt_plotlms, ''Checked'', ''on''),',...
			'set( Hplot_lms, ''Visible'', ''off''),',...
			'plotlms,',...
		'end,',...
	'else,',...
		'plotlms,',...
		'set( opt_plotlms, ''Checked'', ''on''),',...
	'end'] );

% +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

opt_plotls = uimenu(plot_method,...
	'Label',  'LS',...
	'Callback', [...
	'if strcmp( get( opt_plotls, ''Checked'' ), ''on''),',...
		'set( opt_plotls, ''Checked'', ''off''),',...
		'set( Hplot_ls, ''Visible'', ''off''),',...
	'else,',...
		'set( opt_plotls, ''Checked'', ''on''),',...
		'set( Hplot_ls, ''Visible'', ''on''),',...
	'end'] );

%  set the initial plot method to LS after declaration
	set(opt_plotls, 'Checked', 'on');
% +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

plot_fore = uimenu(plot_opt,...
	'Label', 'Axis Color',...
	'Separator', 'on');

	plot_white_fore = uimenu(plot_fore,...
		'Label', 'White',...
		'Callback', [...
		'set( PLOTAXIS, ''YColor'', ''WHITE'' ),',...
		'set( PLOTAXIS, ''XColor'', ''WHITE'' )'] );

	plot_black_fore = uimenu(plot_fore,...
		'Label', 'Black',...
		'Callback', [...
		'set( PLOTAXIS, ''YColor'', ''BLACK'' ),',...
		'set( PLOTAXIS, ''XColor'', ''BLACK'' )'] );

	plot_red_fore = uimenu(plot_fore,...
		'Label', 'Red',...
		'Callback', [...
		'set( PLOTAXIS, ''YColor'', ''RED'' ),',...
		'set( PLOTAXIS, ''XColor'', ''RED'' )'] );

	plot_green_fore = uimenu(plot_fore,...
		'Label', 'Green',...
		'Callback', [...
		'set( PLOTAXIS, ''YColor'', ''GREEN'' ),',...
		'set( PLOTAXIS, ''XColor'', ''GREEN'' )'] );

	plot_blue_fore = uimenu(plot_fore,...
		'Label', 'Blue',...
		'Callback', [...
		'set( PLOTAXIS, ''YColor'', ''BLUE'' ),',...
		'set( PLOTAXIS, ''XColor'', ''BLUE'' )'] );

	plot_magenta_fore = uimenu(plot_fore,...
		'Label', 'Magenta',...
		'Callback', [...
		'set( PLOTAXIS, ''YColor'', ''MAGENTA'' ),',...
		'set( PLOTAXIS, ''XColor'', ''MAGENTA'' )'] );
% +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

plot_background = uimenu(plot_opt,...
	'Label', 'Background Color');


	plot_white_back = uimenu(plot_background,...
		'Label', 'White',...
		'Callback', [...
		'set( PLOTFIG, ''Color'', ''WHITE'' )'] );

	plot_black_back = uimenu(plot_background,...
		'Label', 'Black',...
		'Callback', [...
		'set( PLOTFIG, ''Color'', ''BLACK'' )'] );

	plot_red_back = uimenu(plot_background,...
		'Label', 'Red',...
		'Callback', [...
		'set( PLOTFIG, ''Color'', ''RED'' )'] );

	plot_green_back = uimenu(plot_background,...
		'Label', 'Green',...
		'Callback', [...
		'set( PLOTFIG, ''Color'', ''GREEN'' )'] );

	plot_blue_back = uimenu(plot_background,...
		'Label', 'Blue',...
		'Callback', [...
		'set( PLOTFIG, ''Color'', ''BLUE'' )'] );

	plot_magenta_back = uimenu(plot_background,...
		'Label', 'Magenta',...
		'Callback', [...
		'set( PLOTFIG, ''Color'', ''MAGENTA'' )'] );
% +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

plot_actual_points = uimenu(plot_opt,...
	'Label', 'Point Color');

	plot_white_points = uimenu(plot_actual_points,...
		'Label', 'White',...
		'Callback', [...
		'set( Hplot_actual, ''Color'', ''WHITE'' )'] );
	
	plot_black_points = uimenu(plot_actual_points,...
		'Label', 'Black',...
		'Callback', [...
		'set( Hplot_actual, ''Color'', ''BLACK'' )'] );

	plot_red_points = uimenu(plot_actual_points,...
		'Label', 'Red',...
		'Callback', [...
		'set( Hplot_actual, ''Color'', ''RED'' )'] );

	plot_green_points = uimenu(plot_actual_points,...
		'Label', 'Green',...
		'Callback', [...
		'set( Hplot_actual, ''Color'', ''GREEN'' )'] );

	plot_blue_points = uimenu(plot_actual_points,...
		'Label', 'Blue',...
		'Callback', [...
		'set( Hplot_actual, ''Color'', ''BLUE'' )'] );

	plot_magenta_points = uimenu(plot_actual_points,...
		'Label', 'Magenta',...
		'Callback', [...
		'set( Hplot_actual, ''Color'', ''MAGENTA'' )'] );

