% LMSCNTRL - create LMS controls for residual plot

% Label the graph


	lms_txt_ystring = uicontrol(PLOTFIG,...
		'Style', 'text',...
		'String', LMS_YSTRING,...
		'BackgroundColor', COLOR04,...
		'Position', pos01);	
		

% YMAX controls
% -------------


%Define YMAX slider
	lms_sli_YMAX = uicontrol(PLOTFIG,...
		'Style', 'slider',...
		'Position', pos04d,...
		'Min', min( abs(rscaled) ) /1.5, 'Max', max( abs(rscaled) )*4, 'Value', lms_YMAX,...
		'Callback', [...
		'set(lms_YMAX_cur,''String'',',...
			'num2str(get(lms_sli_YMAX,''Value''))),',...
		'if get(lms_sli_XMIN,''Value'') < get(lms_sli_XMAX,''Value''),',...
			'slitest2,',...
		'end'] );


%Define text control for minimum value
	lms_YMAX_min = uicontrol(PLOTFIG,...
		'Style', 'text',...
		'Position', pos04c,...
		'BackgroundColor', COLOR04,...
		'String', num2str(get(lms_sli_YMAX, 'Min')));


%Define text control for maximum value
	lms_YMAX_max = uicontrol(PLOTFIG,...
		'Style', 'text',...
		'BackgroundColor', COLOR04,...
		'Position', pos04e,...
		'String', num2str(get(lms_sli_YMAX, 'Max')),...
		'Horiz', 'right');

%Define slider label
	lms_YMAX_lab = uicontrol(PLOTFIG,...
		'Style', 'text',...
		'BackgroundColor', COLOR04,...
		'Position', pos04a,...
		'String', 'Y max');


	lms_YMAX_cur = uicontrol(PLOTFIG,...
		'Style', 'text',...
		'Position', pos04b,...
		'BackgroundColor', COLOR06,...
		'String', num2str(get(lms_sli_YMAX, 'Value')));


% XMIN controls
% -------------

%Define XMIN slider
	lms_sli_XMIN = uicontrol(PLOTFIG,...
		'Style', 'slider',...
		'Position', pos05d,...
		'Min', 0, 'Max', ROWS+1, 'Value', 0,...
		'Callback', [...
		'set(lms_XMIN_cur,''String'',',...
			'num2str(get(lms_sli_XMIN,''Value''))),',...
		'if get(lms_sli_XMIN,''Value'') < get(lms_sli_XMAX,''Value''),',...
			'slitest2,',...
		'end'] );


%Define text control for minimum value
	
	lms_XMIN_min = uicontrol(PLOTFIG,...
		'Style', 'text',...
		'Position', pos05c,...
		'BackgroundColor', COLOR04,...
		'String', num2str(get(lms_sli_XMIN, 'Min')));


%Define text control for maximum value
	lms_XMIN_max = uicontrol(PLOTFIG,...
		'Style', 'text',...
		'BackgroundColor', COLOR04,...
		'Position', pos05e,...
		'String', num2str(get(lms_sli_XMIN, 'Max')),...
		'Horiz', 'right');

%Define slider label
	lms_XMIN_lab = uicontrol(PLOTFIG,...
		'Style', 'text',...
		'BackgroundColor', COLOR04,...
		'Position', pos05a,...
		'String', 'X min');


	lms_XMIN_cur = uicontrol(PLOTFIG,...
		'Style', 'text',...
		'Position', pos05b,...
		'BackgroundColor', COLOR06,...
		'String', num2str(get(lms_sli_XMIN, 'Value')));



% XMAX controls
% -------------


%Define XMAX slider
	lms_sli_XMAX = uicontrol(PLOTFIG,...
		'Style', 'slider',...
		'Position', pos06d,...
		'Min', 0, 'Max', ROWS+1, 'Value', ROWS+1,...
		'Callback', [...
		'set(lms_XMAX_cur,''String'',',...
			'num2str(get(lms_sli_XMAX,''Value''))),',...
		'if get(lms_sli_XMIN,''Value'') < get(lms_sli_XMAX,''Value''),',...
			'slitest2,',...
		'end'] );


%Define text control for minimum value
	lms_XMAX_min = uicontrol(PLOTFIG,...
		'Style', 'text',...
		'Position', pos06c,...
		'BackgroundColor', COLOR04,...
		'String', num2str(get(lms_sli_XMAX, 'Min')));


%Define text control for maximum value
	lms_XMAX_max = uicontrol(PLOTFIG,...
		'Style', 'text',...
		'BackgroundColor', COLOR04,...
		'Position', pos06e,...
		'String', num2str(get(lms_sli_XMAX, 'Max')),...
		'Horiz', 'right');

%Define slider label
	lms_XMAX_lab = uicontrol(PLOTFIG,...
		'Style', 'text',...
		'BackgroundColor', COLOR04,...
		'Position', pos06a,...
		'String', 'X max');


	lms_XMAX_cur = uicontrol(PLOTFIG,...
		'Style', 'text',...
		'Position', pos06b,...
		'BackgroundColor', COLOR06,...
		'String', num2str(get(lms_sli_XMAX, 'Value')));

