% LSCNTRL - create LS controls

% Coefficient string for the graph
	ls_txt_ystring = uicontrol(PLOTFIG,...
		'Style', 'text',...
		'String', LS_YSTRING,...
		'BackgroundColor', COLOR01,...
		'Position', pos01);	

%Define the options menu
	ls_fr_opt = uicontrol(PLOTFIG,...
		'Style', 'frame',...
		'BackgroundColor', COLOR07,...
		'Position', pos02);

	ls_txt_opt = uicontrol(PLOTFIG,...
		'Style', 'text',...
		'String', 'Select View',...
		'BackgroundColor', COLOR08,...
		'Position', pos02c);


% radio buttons
% ----------------------------------------------------------------------------------------

	RB_plot(1) = uicontrol(PLOTFIG,...
		'Style', 'radio',...
		'String', '    LS   ',...
		'BackgroundColor', COLOR08,...
		'Position', pos02b,...
		'Value', 1,...
		'Callback', [...
		'if get(RB_plot(1), ''Value'') == 1,',...
			'ls_res,',...
			'set(RB_plot(2), ''Value'', 0),',...
			'lmscnth,',...
			'lscntv,',...
		'end']);

	RB_plot(2) = uicontrol(PLOTFIG,...
		'Style', 'radio',...
		'String', '    LMS  ',...
		'BackgroundColor', COLOR08,...
		'Position', pos02a,...
		'Value', 0,...
		'Callback', [...
		'if get(RB_plot(2), ''Value'') == 1,',...
			'lms_res,',...
			'set(RB_plot(1), ''Value'', 0),',...
			'lscnth,'...
			'lmscntv,',...
		'end']);


% ---------------------------------------------------------------------------------------

% YMAX controls
% -------------

%Define YMAX slider
	ls_sli_YMAX = uicontrol(PLOTFIG,...
		'Style', 'slider',...
		'Position', pos04d,...
		'Min', min( abs(LS_di) )/1.5, 'Max', max( abs(LS_di) )*4, 'Value', ls_YMAX,...
		'Callback', [...
		'set(ls_YMAX_cur,''String'',',...
			'num2str(get(ls_sli_YMAX,''Value''))),',...
		'if get(ls_sli_XMIN,''Value'') < get(ls_sli_XMAX,''Value''),',...
			'slitest1,',...
		'end'] );


%Define text control for minimum value
	ls_YMAX_min = uicontrol(PLOTFIG,...
		'Style', 'text',...
		'Position', pos04c,...
		'BackgroundColor', COLOR01,...
		'String', num2str(get(ls_sli_YMAX, 'Min')));


%Define text control for maximum value
	ls_YMAX_max = uicontrol(PLOTFIG,...
		'Style', 'text',...
		'BackgroundColor', COLOR01,...
		'Position', pos04e,...
		'String', num2str(get(ls_sli_YMAX, 'Max')),...
		'Horiz', 'right');

%Define slider label
	ls_YMAX_lab = uicontrol(PLOTFIG,...
		'Style', 'text',...
		'BackgroundColor', COLOR01,...
		'Position', pos04a,...
		'String', 'Y max');


	ls_YMAX_cur = uicontrol(PLOTFIG,...
		'Style', 'text',...
		'Position', pos04b,...
		'BackgroundColor', COLOR03,...
		'String', num2str(get(ls_sli_YMAX, 'Value')));


% XMIN controls
% -------------

%Define XMIN slider
	ls_sli_XMIN = uicontrol(PLOTFIG,...
		'Style', 'slider',...
		'Position', pos05d,...
		'Min', 0, 'Max', ROWS, 'Value', 0,...
		'Callback', [...
		'set(ls_XMIN_cur,''String'',',...
			'num2str(get(ls_sli_XMIN,''Value''))),',...
		'if get(ls_sli_XMIN,''Value'') < get(ls_sli_XMAX,''Value''),',...
			'slitest1,',...
		'end'] );


%Define text control for minimum value
	ls_XMIN_min = uicontrol(PLOTFIG,...
		'Style', 'text',...
		'Position', pos05c,...
		'BackgroundColor', COLOR01,...
		'String', num2str(get(ls_sli_XMIN, 'Min')));


%Define text control for maximum value
	ls_XMIN_max = uicontrol(PLOTFIG,...
		'Style', 'text',...
		'BackgroundColor', COLOR01,...
		'Position', pos05e,...
		'String', num2str(get(ls_sli_XMIN, 'Max')),...
		'Horiz', 'right');

%Define slider label
	ls_XMIN_lab = uicontrol(PLOTFIG,...
		'Style', 'text',...
		'BackgroundColor', COLOR01,...
		'Position', pos05a,...
		'String', 'X min');


	ls_XMIN_cur = uicontrol(PLOTFIG,...
		'Style', 'text',...
		'Position', pos05b,...
		'BackgroundColor', COLOR03,...
		'String', num2str(get(ls_sli_XMIN, 'Value')));


% XMAX controls
% -------------

%Define XMAX slider
	ls_sli_XMAX = uicontrol(PLOTFIG,...
		'Style', 'slider',...
		'Position', pos06d,...
		'Min', 0, 'Max', ROWS+1, 'Value', ROWS+1,...
		'Callback', [...
		'set(ls_XMAX_cur,''String'',',...
			'num2str(get(ls_sli_XMAX,''Value''))),',...
		'if get(ls_sli_XMIN,''Value'') < get(ls_sli_XMAX,''Value''),',...
			'slitest1,',...
		'end'] );


%Define text control for minimum value
	ls_XMAX_min = uicontrol(PLOTFIG,...
		'Style', 'text',...
		'Position', pos06c,...
		'BackgroundColor', COLOR01,...
		'String', num2str(get(ls_sli_XMAX, 'Min')));


%Define text control for maximum value
	ls_XMAX_max = uicontrol(PLOTFIG,...
		'Style', 'text',...
		'BackgroundColor', COLOR01,...
		'Position', pos06e,...
		'String', num2str(get(ls_sli_XMAX, 'Max')),...
		'Horiz', 'right');

%Define slider label
	ls_XMAX_lab = uicontrol(PLOTFIG,...
		'Style', 'text',...
		'BackgroundColor', COLOR01,...
		'Position', pos06a,...
		'String', 'X max');


	ls_XMAX_cur = uicontrol(PLOTFIG,...
		'Style', 'text',...
		'Position', pos06b,...
		'BackgroundColor', COLOR03,...
		'String', num2str(get(ls_sli_XMAX, 'Value')));

