% MULTIPLE - Least squares on Simulated multiple regression data

global PATH_Data PATH_Prg PATH_Demo 

% length of file equals 2 when the user cancels
LEN_NoFileSel = 2;
REPEAT = 1;

		eval(PATH_Data);
		FILE_Dat = ldfile('*.mlt');

	% check for an invalid file name or cancel
		if length(FILE_Dat) == LEN_NoFileSel
			eval(PATH_Demo);
			return
		end

	
		FID_Dat = fopen(FILE_Dat, 'r');

	%  point to the beginning of the file name without the path
		nameptr = findstr(FILE_Dat, '\');
		nameptr = max(nameptr);
	

	% create a file to make the next run faster last two characters will be zeros
		FILE_CoefEval = lower( chgext(nameptr+1, FILE_Dat, '') );
		D = length(FILE_CoefEval);
		FILE_CoefEval(D) = '0';
		FILE_CoefEval(D-1) = '0';
		FILE_Coef = [FILE_CoefEval '.m'];

	% check if analysis was done on this file already
		FID_Coef = fopen(FILE_Coef, 'r');

	% if file was created then do quick run 	
		if FID_Coef > 0
			REPEAT = 0;
			gcases
			eval(FILE_CoefEval);
			multipl2;
			fclose(FID_Coef);
			return;
		end

		% fid was not created before, so create now
		FID_Coef = fopen(FILE_Coef, 'wt');


% +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
% first time running the file starts here
% +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++


	% Find the graph title in the paramater file (follows output file name)
		FILE_Out = chgext(1, FILE_Dat, '.out');
		FILE_Out = upper(FILE_Out);

		FILE_Prm = chgext(1, FILE_Dat, '.prm');
		FID_Prm = fopen(FILE_Prm, 'r');


		flag = [];		
		while isempty(flag) 
			line = fgetl(FID_Prm);
			flag = findstr(FILE_Out, line);
		end
		
		TITLE_Graph = fgetl(FID_Prm);
		FORMAT = 'TITLE_Graph = [ '' %s '' ];\n';
		fprintf(FID_Coef, FORMAT, TITLE_Graph);

		fclose(FID_Prm);

	% get the number of variables
		gcases

		FID_Dat = fopen(FILE_Dat ,'r');
		
% get n by m matrix
  MATRIX_Data =[];
  counter = 1;
while 1
	line = fgets(FID_Dat);

	if ~isstr(line), break, end
	
	temp = sscanf(line, '%f');
	temp=temp';

	if isempty(temp) & counter == 1
		err01,
		return, 
	end

	MATRIX_Data = [MATRIX_Data ; temp];
	counter = counter +1;
end

		[ROWS, COLS] = size(MATRIX_Data);
		fprintf(FID_Coef, 'ROWS = %i;\nCOLS = %i;\n', ROWS, COLS);

		fprintf(FID_Coef, 'MATRIX_Data = [ \n');
		FORMAT = [];

		for I = 1:COLS-1
			FORMAT = [FORMAT, '%f,   '];
		end
			FORMAT = [FORMAT, '%f;\n' ];

		fprintf(FID_Coef, FORMAT, MATRIX_Data');
		fprintf(FID_Coef, '    ];\n\n');

	% isolate last column as response vector
		VECTOR_Resp=MATRIX_Data(:,NUM_VARIABLES);
		fprintf(FID_Coef, 'VECTOR_Resp = [\n');
		fprintf(FID_Coef, '%f;\n', VECTOR_Resp);
		fprintf(FID_Coef, '    ];\n\n');


	% isolate middle columns for explanatory variables
		MATRIX_ExpVar=MATRIX_Data(:,2:NUM_VARIABLES-1);

		fprintf(FID_Coef, 'MATRIX_ExpVar = [ \n');
		FORMAT = [];

		for I = 1:COLS-3
			FORMAT = [FORMAT, '%f,   '];
		end
			FORMAT = [FORMAT, '%f;\n' ];

		fprintf(FID_Coef, FORMAT, MATRIX_ExpVar');
		fprintf(FID_Coef, '    ];\n\n');


	 	MATRIX_ExpVarOnes = [ MATRIX_ExpVar, ones(ROWS, 1)];
		fprintf(FID_Coef, 'MATRIX_ExpVarOnes = [ \n');
		FORMAT = [];
	
		for I = 1:COLS-2
			FORMAT = [FORMAT, '%f,   '];
		end
			FORMAT = [FORMAT, '%f;\n' ];

		fprintf(FID_Coef, FORMAT, MATRIX_ExpVarOnes');
		fprintf(FID_Coef, '    ];\n\n');


% add an outlier
% VECTOR_Resp(11) = 11;

		LS_coef=MATRIX_ExpVarOnes\VECTOR_Resp;
	
		FORMAT = [];

		for I = 1:COLS-2
			FORMAT = [FORMAT, '%f;   '];
		end
			FORMAT = [FORMAT, '%f;\n' ];

		fprintf(FID_Coef, 'LS_coef = [ \n');
		fprintf(FID_Coef, FORMAT, LS_coef');
		fprintf(FID_Coef, '    ];\n\n');

	%	fprintf(FID_Coef, '\n\n%s:\n', FILE_Dat);

	
% Create zero line
		zero = linspace(0, 0, ROWS);

		FORMAT = [];
	
		for I = 1:ROWS-1
			FORMAT = [FORMAT, '%i,   '];

			J = I/13;
			K = ceil(J);

		     % if there are too many rows then continue on the next line
		     if J == K  &  I ~= 0
			   FORMAT = [FORMAT, '...\n'];
		     end
		end

		FORMAT = [FORMAT, '%i;\n' ];

		fprintf(FID_Coef, 'zero =   [ \n');
		fprintf(FID_Coef, FORMAT, zero);
		fprintf(FID_Coef, '   ];\n\n');

	fclose(FID_Dat);

	multipl2

	fclose(FID_Coef);
