function [coef_ls, coef_lms] = progc(FILE_Prm)
% PROGC - extracts coefficients from the progress output file

clc

global PATH_Data PATH_Prg PATH_Demo

LEN_NoFileSel = 2;
HEADER_LENGTH = 30;
TEXT_LENGTH = HEADER_LENGTH*3;
LS_STRING = 'LEAST SQUARES REGRESSION';

% flag -- found LS_STRING if not empty, (assume not found yet)
LS = [];  	

% flag -- found coefficients if not empty, (assume not found yet)
coef_ls = [];	
 

LMS_STRING = 'LEAST MEDIAN OF SQUARES REGRESSION';

% flag -- found LS_STRING if not empty, (assume not found yet)
LMS = [];  	

% flag -- found coefficients if not empty, (assume not found yet)
coef_lms = [];	

NAMES_STR = 'VARIABLE';
NAMES = [];

BOSC = 14;
EOSC = 29;

% Create paramater file id
	FID_Prm = fopen(FILE_Prm, 'r');
	
	%Failure opening parameter file
	if FID_Prm == -1
		err02
		coef_ls = 0;
		coef_lms = 0;
		return
	end

%Third line in paramter file conatains the number of cases
	for I = 1:3
		num_cases = fgets(FID_Prm);
	end

	
%Open progress output file
	FILE_Out = chgext(1, FILE_Prm, '.OUT');
	FID_Out = fopen(FILE_Out, 'r');

	if length(FILE_Out) == LEN_NoFileSel
		eval(PATH_Demo);
		return
	end


%Create file to store coefficients
%	FILE_Prg = chgext(1, FILE_Out, '.PRG');
%	FID_Prg = fopen(FILE_Prg, 'wt');


%Bypass header before searching for LEAST SQUARES REGRESSION coefficients
		for I = 1:HEADER_LENGTH
			line = fgets(FID_Out);
		end
		


%Looking for LS_STRING defined above
	while isempty(LS)
		line = fgets(FID_Out);
		LS = findstr(line, LS_STRING);
	end

	while isempty(NAMES)
		line = fgets(FID_Out);
		NAMES = findstr(line, NAMES_STR);
	end

	temp = [];
	while isempty(temp) 
		line = fgets(FID_Out);
		% do not include first column which are variable 
		% names or blanks
		if length(line) > EOSC;
			line_no_name = line( BOSC:EOSC );	
		%convert text to numbers					
		temp = sscanf(line_no_name, '%f');	
		end	
	end

%print the first coefficient
	coef_ls = [coef_ls; temp];

%get other coefficients and print them
	while ~isempty(temp)
		line = fgets(FID_Out);
		if length(line) > EOSC
			line_no_name = line( BOSC:EOSC );
			temp = sscanf(line_no_name, '%f');
			coef_ls = [coef_ls; temp];
		end
	end


% -------------------------------------------------------------------------------------
%Bypass text before searching for LEAST MEDIAN OF SQUARES REGRESSION coefficients
		for I = 1:TEXT_LENGTH
			line = fgets(FID_Out);
		end

% LMS column format adjusted from LS format
BOSC = BOSC + 4;
EOSC = EOSC + 4;


%Looking for LMS_STRING defined above
	while isempty(LMS)
		line = fgets(FID_Out);
		LMS = findstr(line, LMS_STRING);
	end

	NAMES = [];
	while isempty(NAMES)
		line = fgets(FID_Out);
		NAMES = findstr(line, NAMES_STR);
	end

	temp = [];
	while isempty(temp)
		line = fgets(FID_Out);
			% do not include first column which are variable 
			% names or blanks
			line_no_name = line( BOSC:EOSC );

			%convert text to numbers					
			temp = sscanf(line_no_name, '%f');		
		
	end


%print the first coefficient
	coef_lms = [coef_lms; temp];
	
%get other coefficients and print them
	while ~isempty(temp)
		line = fgets(FID_Out);
		if length(line) > EOSC
			line_no_name = line( BOSC:EOSC );
			temp = sscanf(line_no_name, '%f');
			coef_lms = [coef_lms; temp];
		end
	end

	fclose(FID_Out);
%	fclose(FID_Prg);

eval(PATH_Demo);
