% RUNPROG - run external dos program called progress.exe for LMS coefficients

global PATH_Data PATH_Prg PATH_Demo

eval(PATH_Data);
FILE_Prm = chgext(1, FILE_Dat, '.PRM');
LEN_NoFileSel = 2;


% exit if the user chooses cancel button
	if length(FILE_Prm) == LEN_NoFileSel
 		return
	end


eval(PATH_Prg);
run_string = ['progress < ' FILE_Prm];


%----------------------------------------------------------------- beginning of REPEAT

if REPEAT
status =  dos(run_string);

	if status < 0
		disp('Paramater File Missing');
		return
	end

% get LMS coefficients
[cf_ls, cf_lms] = progc(FILE_Prm);


if cf_ls == 0 & cf_lms == 0
	return
end

% compute LMS residuals
	findress

	fprintf(FID_Coef, 'cf_ls = [ \n');
	FORMAT = [];
	for I = 1:COLS-1
		FORMAT = [FORMAT, '%f;'];
	end
		FORMAT = [FORMAT, '%f;\n' ];

	fprintf(FID_Coef, FORMAT, cf_ls');
	fprintf(FID_Coef, '    ];\n\n');

	fprintf(FID_Coef, 'cf_lms = [ \n');
	FORMAT = [];
	for I = 1:COLS-1
		FORMAT = [FORMAT, '%f;'];
	end
		FORMAT = [FORMAT, '%f;\n' ];

	fprintf(FID_Coef, FORMAT, cf_lms');
	fprintf(FID_Coef, '    ];\n\n');




	FID_Dat = fopen(FILE_Dat ,'r');

% get the number of variables
	gcases


	FID_Dat = fopen(FILE_Dat ,'r');

% n by m matrix

MATRIX_Data =[];
while 1
	line = fgets(FID_Dat);

	if ~isstr(line), break, end
	
	temp = sscanf(line, '%f');
	temp=temp';
	MATRIX_Data = [MATRIX_Data ; temp];
end

	[ROWS, COLS] = size(MATRIX_Data);


% isolate last column as response vector
	VECTOR_Resp=MATRIX_Data(:,NUM_VARIABLES);

% isolate middle columns for explanatory variables
	MATRIX_ExpVar=MATRIX_Data(:,2:NUM_VARIABLES-1);


	MATRIX_ExpVarOnes = [ MATRIX_ExpVar, ones(ROWS, 1)];


% YHat - estimated response based on LS coef found by PROGRESS	
	YHat_LS = MATRIX_ExpVarOnes*cf_ls;

	fprintf(FID_Coef, 'YHat_LS =   [\n');
	fprintf(FID_Coef, '%f;\n', YHat_LS);
	fprintf(FID_Coef, '     ];\n\n');

	error_LS = VECTOR_Resp - YHat_LS;
	fprintf(FID_Coef, 'error_LS =   [\n');
	fprintf(FID_Coef, '%f;\n', error_LS);
	fprintf(FID_Coef, '     ];\n\n');

end
%------------------------------------------------------------------- end of REPEAT


% LMS standardized residuals
%--------------------------------------------------------------------------------
% YHat - estimated response based on LS coef found by PROGRESS	
	YHat_LMS = MATRIX_ExpVarOnes*cf_lms;

	fprintf(FID_Coef, 'YHat_LMS =   [\n');
	fprintf(FID_Coef, '%f;\n', YHat_LMS);
	fprintf(FID_Coef, '     ];\n\n');

	error_LMS = VECTOR_Resp - YHat_LMS;
	fprintf(FID_Coef, 'error_LMS =   [\n');
	fprintf(FID_Coef, '%f;\n', error_LMS);
	fprintf(FID_Coef, '     ];\n\n');


	error_sqr = error_LMS .^2;
	med_error_sqr = median(error_sqr);

	sqrt_med_error_sqr = sqrt(med_error_sqr);

%dds see chap 5 section 1 Rousseeuw

	w = [];
 	s0 = 1.4826 * (1+5/(ROWS - COLS +1) ) * sqrt_med_error_sqr;
	for I = 1:ROWS
		if abs(error_LMS(I)/s0) <= 2.5
			w(I) = 1;
		else	
			w(I) = 0;
		end
	end	

	numerator = sum ((w') .* error_sqr);
	denominator = sum (w) - (COLS-1);
	sigma_star = sqrt (numerator/denominator);
	
	
	% old : rscaled = error / sqrt_med_error_sqr;
% dds

	rscaled = error_LMS / sigma_star;
%--------------------------------------------------------------------------------
	
	

	DIMAX = max( abs(rscaled) );
	lms_THRESHOLD = 2.5;


%Create zero line
	lms_zero = linspace(0, 0, ROWS);

%Get file name without path -- coefficient title  
	nameptr = findstr(FILE_Dat, '\');
	nameptr = max(nameptr);
	TITLE_File = chgext(nameptr+1, FILE_Dat, ' ');		


% Prepere Plot
	
	lms_XMIN = 0;
	lms_XMAX = ROWS ;

	if DIMAX > lms_THRESHOLD
		lms_YMIN = -(DIMAX * 1.5);
		lms_YMAX = abs(lms_YMIN);
	else
		lms_YMIN = -3;
		lms_YMAX = 3;
	end


	lms_LINE = linspace(1, lms_XMAX, lms_XMAX);
	
	lms_VALZERO = linspace(0, 0, lms_XMAX);
	lms_VALTHRESH = linspace(lms_THRESHOLD, lms_THRESHOLD, lms_XMAX);

	LMS_YSTRING = [TITLE_File 'COEFICIENTS  =  '];
	for I = 1:NUM_VARIABLES-1

		if I ~= NUM_VARIABLES-1		
			LMS_YSTRING = [LMS_YSTRING,...
		  	num2str(cf_lms(I)) ' x' num2str(I) ' + '];
		else
			LMS_YSTRING = [LMS_YSTRING  num2str(cf_lms(I))];
		end

		I =I + 1;
	end	
	
	
eval(PATH_Demo);
