% SIMPLE - Least squares on Simulated simple regression data

global PATH_Data PATH_Prg PATH_Demo

REPEAT = 1;
LEN_NoFileSel = 2;
counter = 1;

	eval(PATH_Data);
	FILE_Dat = ldfile('*.smp');
	
	%check for invalid fid name whem user chooses to cancel
	if length(FILE_Dat) == LEN_NoFileSel
		eval(PATH_Demo);
		return
	end

% get the number of variables
	gcases

% make sure simple regression data file
	if NUM_VARIABLES ~= 3
		err03
		return
	end


	FID_Dat = fopen(FILE_Dat, 'r');

	%  point to the beginning of the file name without the path
		nameptr = findstr(FILE_Dat, '\');
		nameptr = max(nameptr);
	

	% create a file to make the next run faster last two characters will be zeros
		FILE_CoefEval = lower( chgext(nameptr+1, FILE_Dat, '') );
		D = length(FILE_CoefEval);
		FILE_CoefEval(D) = '0';
		FILE_CoefEval(D-1) = '0';
		FILE_Coef = [FILE_CoefEval '.m'];


		FID_Coef = fopen(FILE_Coef, 'r');

	
	if FID_Coef > 0
		REPEAT = 0;
		gcases
		eval(FILE_CoefEval);
		simple2;
		fclose(FID_Coef);
		return;
	end
		% fid was not created before, so create now
		FID_Coef = fopen(FILE_Coef, 'wt');


	% Find the graph title in the paramater file (follows output file name)
		FILE_Out = chgext(1, FILE_Dat, '.out');
		FILE_Out = upper(FILE_Out);

		FILE_Prm = chgext(1, FILE_Dat, '.prm');
		FID_Prm = fopen(FILE_Prm, 'r');
		
		% Paramater file missing
		if FID_Prm < 1
			err04
			return
		end

		flag = [];		
		while isempty(flag) 
			line = fgetl(FID_Prm);
			flag = findstr(FILE_Out, line);
		end
		
		TITLE_Graph = fgetl(FID_Prm);
		FORMAT = 'TITLE_Graph = [ '' %s '' ];\n';
		fprintf(FID_Coef, FORMAT, TITLE_Graph);
		
		fclose(FID_Prm);

% n by m matrix

MATRIX_Data =[];
while 1
	line = fgets(FID_Dat);

	if ~isstr(line), break,	end
	
	temp = sscanf(line, '%f');
	temp=temp';

	if isempty(temp) & counter == 1
		err01
		return
	end

	MATRIX_Data = [MATRIX_Data ; temp];
	counter = counter + 1;
end

	[ROWS, COLS] = size(MATRIX_Data);

	fprintf(FID_Coef, 'ROWS = %i;\nCOLS = %i;\n', ROWS, COLS);

	fprintf(FID_Coef, 'MATRIX_Data = [ \n');
	FORMAT = [];
	for I = 1:COLS-1
		FORMAT = [FORMAT, '%f,   '];
	end
		FORMAT = [FORMAT, '%f;\n' ];

	fprintf(FID_Coef, FORMAT, MATRIX_Data');
	fprintf(FID_Coef, '    ];\n\n');

     if COLS < NUM_VARIABLES
	err04
	return
     elseif COLS > NUM_VARIABLES
	err05
	return
     end


% isolate last column as response vector
	VECTOR_Resp=MATRIX_Data(:,NUM_VARIABLES);
	fprintf(FID_Coef, 'VECTOR_Resp = [\n');
	fprintf(FID_Coef, '%f;\n', VECTOR_Resp);
	fprintf(FID_Coef, '    ];\n\n');


% isolate middle column for explanatory variables
	MATRIX_ExpVar=MATRIX_Data(:,2);
	fprintf(FID_Coef, 'MATRIX_ExpVar = [ \n');
	FORMAT = [];
	for I = 1:COLS-3
		FORMAT = [FORMAT, '%f,   '];
	end
		FORMAT = [FORMAT, '%f;\n' ];

	fprintf(FID_Coef, FORMAT, MATRIX_ExpVar');
	fprintf(FID_Coef, '    ];\n\n');

	MATRIX_ExpVarOnes = [ MATRIX_ExpVar, ones(ROWS, 1)];
	fprintf(FID_Coef, 'MATRIX_ExpVarOnes = [ \n');
	FORMAT = [];
	for I = 1:COLS-2
		FORMAT = [FORMAT, '%f,   '];
	end
		FORMAT = [FORMAT, '%f;\n' ];

	fprintf(FID_Coef, FORMAT, MATRIX_ExpVarOnes');
	fprintf(FID_Coef, '    ];\n\n');

%solve
% add an outlier
%VECTOR_Resp(11) = 15;

	LS_coef=MATRIX_ExpVarOnes\VECTOR_Resp;
	FORMAT = [];
	for I = 1:COLS-2
		FORMAT = [FORMAT, '%f;   '];
	end
		FORMAT = [FORMAT, '%f;\n' ];

	fprintf(FID_Coef, 'LS_coef = [ \n');
	fprintf(FID_Coef, FORMAT, LS_coef');
	fprintf(FID_Coef, '    ];\n\n');

%	fprintf(FID_Coef, '\n\n%s:\n', FILE_Dat);

%Create zero line
	zero = linspace(0, 0, ROWS);
	FORMAT = [];
	for I = 1:ROWS-1
		FORMAT = [FORMAT, '%i,   '];
	end
		FORMAT = [FORMAT, '%i;\n' ];

	fprintf(FID_Coef, 'zero =   [ \n');
	fprintf(FID_Coef, FORMAT, zero);
	fprintf(FID_Coef, '   ];\n\n');

%LS standardized residuals
	findres

% Prepare Plot
	preplot

%Define control positions
	uidefs

% Run LMS
	fclose(FID_Dat); 
	runprog

	%Failure finding Parameter file in runprog and progc
	if cf_ls == 0 & cf_lms == 0
		return
	end
	

%fclose(FID_Coef);
	


%Define least median squares uicontrols

% Create plot window
	plot_fig

	lmscntrl
	lmscnth

	lscntrl

% Plot least squares residuals
	ls_res	

% Prepare REGRESSION line paramaters
	pre_reg

% toggle uicontrol, between regression line and residual plot
	togg1

eval(PATH_Demo);
