function z = extend(S,rowsTarget,columnsTarget,axisIndex)
% H. Gollwitzer, April 10, 1994, April 20, 1995
% Purpose: Use row major or column major order to periodically
% extend a matrix.  First convert to a vector and
% then duplicate enough to fill it out.
if (nargin < 3)|(nargin > 4)
        disp('extend needs 3 or 4 arguments');
        return
else 
        if nargin == 3
                coordIndex = 2;
        else
                if (axisIndex==1)|(axisIndex==2)
                        coordIndex = axisIndex;
                else
                        disp('extend: The axis index must be 1 or 2');
                        return
                end
        end
end
mn = rowsTarget*columnsTarget;%Total in target
pq = prod(size(S));%Total in source
if mn==0
        z = []; %Null case
        return
end
% More argument checking is needed.
% ***** End of argument checking *****
if coordIndex==2
        S = S';
end
S = S(:);
if mn > pq      % Get enough data via period extension
                colnum = ceil(mn/pq);
                S = reshape(S(:,ones(1,colnum)),1,colnum*pq);
end
if coordIndex==1
        z = reshape(S(1:mn),rowsTarget,columnsTarget);
else% coordIndex==2
        z = reshape(S(1:mn),columnsTarget,rowsTarget)';
end

