/* mstruc.c   for help see mstruc.m                */
  
/* Copyright  Gabe Jan Haarsma, sept 1993          */
/* dept. of Agricultural Engineering, Texas A&M    */
/* E-mail:  gabe@diamond.tamu.edu                  */

#include <stdio.h>
#include <math.h>
#include "mex.h"

#ifdef __STDC__
void mexFunction(
	int		nlhs,
	Matrix	*plhs[],
	int		nrhs,
	Matrix	*prhs[]
	)
#else
mexFunction(nlhs, plhs, nrhs, prhs)
int nlhs, nrhs;
Matrix *plhs[], *prhs[];
#endif

{
  /*   nn  =  The returned matrix containing all combinations of the   */
  /*          orders and delays                                        */
  /*                                                                   */
  /*   v   =  vector for the orders and delays                         */

  double *nn;
  double *v;
  
  /*    i,j,k,l     loopcounters                                       */
  /*    nrc         number of colums for every order and delay         */
  /*    nrepeati    number of repeats for inner loop (counter = l)     */
  /*    nrepeato    number of repeats for outer loop (counter = j)     */
  /*    nrr         number of rows in nn                               */

  int    i,j,k,l,nrc[100],nrepeati[100],nrepeato[100],nrr;

  for (i=0;i<nrhs;i++) nrc[i]=mxGetN(prhs[i]);

  nrepeati[nrhs-1]=1;
  for (i=nrhs-1;i>0;i--) nrepeati[i-1]=nrepeati[i]*nrc[i];
  
  nrr=nrepeati[0]*nrc[0];

  nrepeato[0]=1;
  for (i=1;i<nrhs;i++) nrepeato[i]=nrr/nrepeati[i-1];

  plhs[0]=mxCreateFull(nrr,nrhs,REAL);
  nn=mxGetPr(plhs[0]);

  for (i=0;i<nrhs;i++) {
    v=mxGetPr(prhs[i]);

    for (j=0;j<nrepeato[i];j++) {
      for (k=0;k<nrc[i];k++) {
        for (l=0;l<nrepeati[i];l++) {
          nn[l+k*nrepeati[i]+j*nrc[i]*nrepeati[i]+i*nrr]=v[k];
        }
      }
    }
  }

}
