%
function evalsen         %<<last updated 7/21/88>>
%EVALSEN   Demonstration to show the sensitivity of the calculation of
%          eigenvalues. The (1,6)-entry of 6x6 matrix is changed from zero
%          to 10^(-k) for k = 8,7,...,2. The eigenvalues of each matrix
%          are plotted in the complex plane. A small change in the (1,6)-entry
%          causes a substantially larger change in the eigenvalues.
%          By: David R. Hill, Math Dept, Temple University
%              Philadelphia, Pa.  19122
%     Use in the form --> evalsen <--
cla
disp([blanks(20) 'Eigenvalue Sensitivity Demo']),disp(' ')
disp('This is a demonstration of the potential sensitivity involved in the')
disp('calculation of eigenvalues. The (1,6)-entry of the matrix')
A=5*eye(6)+diag(ones(1,5),-1)
disp('is changed from zero to t = 10^(-k) for k=8,7,...,2. The eigenvalues')
disp('of each of these "altered" matrices are plotted in the complex plane.')
disp('As the value of t increases the eigenvalues are seen to lie on')
disp('circles with substantially larger radii. After each circle of')
disp('of eigenvalues is displayed, press enter to continue.')
disp(' ')
disp('Press enter to begin the demonstration.')
pause
clg
axis([4 6 -.5 .5]);
st1='t=10^(-';
st2='12345678';
st3=')';
plot([5],[0],'+'),xlabel('Press enter')
hold
for j=8:-1:2
   t=1*(10^(-j));
   A(1,6)=t;
   plot(eig(A),'o')
   text(.15,j/10,[st1 st2(j) st3],'sc')
   pause
end
disp('Demonstration is over.')
hold
%
