function app=fixpgraf                %last updated 10/7/90
%FIXPGRAF   Graphical demonstration of Fixed Point method using
%
%                           x = g(x)
%
%           where g(x) is accepted as input together with an
%           initial guess. The graphics scale is adjusted to
%           display sets of five successive approximations.
%
%           Use in the form   --->  fixpgraf  <---
%
%  By: David R. Hill, Math. Dept., Temple University
%      Philadelphia, Pa. 19122
head=[blanks(20) 'Fixed Point Method with Graphical Display'];
s0=' ';
s1='To see the graph of y = x and y = g(x) press ENTER. ';
s2='Your choice is g(x) = ';
s3='Enter an interval in square brackets to sketch y = x and y = g(x) = ';
s3a=' over.';
s4='[a,b] = ';
menu=['     1. See numerical values of last 5 iterates.    ';
      '     2. See numerical values of all iterates so far.';
      '     3. See current picture.                        ';
      '     4. Generate next set of 5 iterates.            ';
      '     0. QUIT                                        '];
gmenu=['  1. Accept g(x).   ';
       '  2. Re-enter g(x). ';
       '  0. QUIT           '];
begtxt='We are to approximate a root of x = g(x)';
begtxt=[begtxt ' using the Fixed Point Method.'];
getgx1='Enter a formula for g(x):';
getgx2='  g(x) = ';
iguess='Enter initial guess: -->   ';
cont='Press ENTER to continue.';
choice='ENTER your choice: --> ';
currapp='The current approximation is:';
gok='N'; %getting a g(x)
while gok=='N'
   clc,disp(head),disp(s0),disp(begtxt),disp(s0)
   disp(getgx1),g=input(getgx2,'s'); %accepting string input
   badch='Y';
   while badch=='Y'
      disp([s2 g]),disp(s0),disp(gmenu),disp(s0),ch=input(choice);
      if ch==0,return,end
      if ch==1,gok='Y';,badch='N';end
      if ch==2,gok='N';badch='N';end
      if ch~=1 & ch~=2
         disp(['Improper choice:  ' cont]),pause
      end
   end
end
disp(s0),disp([s3 g s3a]),intch=input(s4);lowx=intch(1);upx=intch(2);
disp(s1),pause
x=[lowx:(upx-lowx)/100:upx];vg=vectize(g);y=eval(vg);
xp=x;yp=y;vx=[];vy=[];
plot(xp,yp,x,x)
hold %on
%plot(xp,zeros(xp))
plot(xp,(xp*0))%DT
title(['x = g(x) = ' g]),xlabel(cont),pause
clc,disp(head),disp(s0),
x=input(iguess);
app=x;k=1;
sig='Y';format long
while sig=='Y'
   vx=[];vy=[];
   for j=k+1:k+5
      x=app(j-1);gval=eval(g);xg=x;x=gval;app(j)=x;
      vx=[vx xg xg x];vy=[vy xg x x];
   end
   lowx=min(app(k:k+5));upx=max(app(k:k+5));
   if abs(upx - lowx) < .1
      mid=(upx+lowx)/2;lowx=mid-.05;upx=mid+.05;
   end
   k=k+5;
   xnew=x;x=[lowx:abs(upx-lowx)/100:upx];y=eval(vg);xp=x;yp=y;
   hold %off
   plot(xp,yp,x,x)
   hold %on
%   plot(xp,zeros(xp))
   plot(xp,(xp*0))
   title(['x = g(x) = ',g])
   for j=1:5
      plot(vx(3*j-2),vy(3*j-2),'*')
      plot(vx(3*j-2:3*j),vy(3*j-2:3*j),':'),pause(1)
   end
   x=xnew;xlabel(cont),pause
   chok='N';
   while chok=='N'
      clc,disp(head),disp(s0),disp(menu),disp(s0)
      ch=input(choice);
      if ch==0,chok='Y';sig='N';end
      if ch==1,disp('The last 5 approximations:')
         disp(app(k-4:k)'),disp(cont),pause
      end
      if ch==2,disp('The set of approximations:')
         disp(app'),disp(cont),pause
      end
      if ch==3,shg,pause,end
      if ch==4,chok='Y';end
      if ch~=0 & ch~=1 & ch~=2 & ch~=3 & ch~= 4
         disp(['Improper choice:   ' cont]),pause
         clc,disp(head),disp(s0),disp(menu),disp(s0)
         ch=input(choice);
      end
   end
end
disp('FIXED POINT Demo is over!'),hold,format short
