%
function app=newtdemo                         %last updated 5/28/90
%NEWTDEMO  Graphical demonstration of Newton's method using
%
%                       f(x) = x^3 - x - 1
%
%          Sets of five successive approximations are shown with
%          corresponding tangent lines.
%
%  By: David R. Hill, Math. Dept., Temple University
%      Philadelphia, Pa. 19122
f='x^3-x-1';
fp='3*x^2-1';
head=[blanks(20) 'Newton''s Method Graphical DEMO'];
s0=' ';
s1='To see the graph of f(x) press ENTER.                  ';
menu=['     1. See numerical values of last 5 iterates.    ';
      '     2. See numerical values of all iterates so far.';
      '     3. See current picture.                        ';
      '     4. Generate next set of 5 iterates.            ';
      '     0. QUIT                                        '];
begtxt=...
['We are to approximate a root of              ';
 '                                             ';
 '                 f(x) = x^3 - x -1           ';
 '                                             ';
 'in the interval [-1,2] using Newton`s method.'];
iguess='Enter initial guess in [-1 2]: -->   ';
cont='Press ENTER to continue.';
choice='ENTER your choice: --> ';
currapp='The current approximation is:';
x=[-1:.05:2];lowx=-1;upx=2;vf=vectize(f);
y=eval(vf);
xp=x;yp=y;vx=[];vy=[];
clc
disp(head),disp(s0),disp(begtxt),disp(s0),disp(s1),pause
plot(xp,yp)
hold %on
%plot(xp,zeros(xp))
plot(xp,(xp*0))%DT
title(['f(x) = ' f]),xlabel(cont),pause
clc,disp(head),disp(s0),disp(begtxt),disp(s0)
x=input(iguess);
app=x;k=1;
sig='Y';format long
while sig=='Y'
   vx=[];vy=[];
   for j=k+1:k+5
      x=app(j-1);fg=eval(f);xg=x;x=x-fg/eval(fp);app(j)=x;
      vx=[vx xg xg xg x];vy=[vy 0 fg fg 0];
   end
   lowx=min(app(k:k+5));upx=max(app(k:k+5));
   if abs(upx - lowx) < 1
      mid=(upx+lowx)/2;lowx=mid-.5;upx=mid+.5;
   end
   k=k+5;
   xnew=x;x=[lowx:abs(upx-lowx)/100:upx];y=eval(vf);xp=x;yp=y;
   hold %off
   plot(xp,yp)
   hold %on
%   plot(xp,zeros(xp))
   plot(xp,(xp*0))
   title(['f(x) = ',f])
   for j=1:5
      plot(vx(4*j-3),vy(4*j-3),'*')
      plot(vx(4*j-3:4*j),vy(4*j-3:4*j),':'),pause(1)
   end
   x=xnew;xlabel(cont),pause
   chok='N';
   while chok=='N'
      clc,disp(head),disp(s0),disp(menu),disp(s0)
      ch=input(choice);
      if ch==0,chok='Y';sig='N';end
      if ch==1,disp('Last 5 approximations are:')
         app(k-4:k)',disp(cont),pause
      end
      if ch==2,disp('Last 5 approximations are:')
         app',disp(cont),pause
      end
      if ch==3,shg,pause,end
      if ch==4,chok='Y';end
      if ch~=0 & ch~=1 & ch~=2 & ch~=3 & ch~= 4
         disp(['Improper choice:   ' cont]),pause
         clc,disp(head),disp(s0),disp(menu),disp(s0)
         ch=input(choice);
      end
   end
end
disp('NEWTON DEMO is over!'),hold,format short
