function AEQ = reduce(A,r)             %last updated 5/4/90
%REDUCE  Perform row reduction on matrix A by explicitly choosing
%        row operations to use. A row operation can be "undone", but
%        this feature can not be used in succession.
%
%  Use in the form ---> reduce(A,1)  for a rational display format
%   or in the form ---> reduce(A)   for a decimal display format
%
%  By: David R. Hill, Mathematics Dept., Temple Univ.
%      Philadelphia, PA. 19122
if nargin<2,rsig='F';else,rsig='T';end
[m,n]=size(A);
oldA=A;
myeps=1e-14; %my tolerance for zero in rational display
%Set up strings to be used as messages.
s0='     ';
s1='Enter first row number.  ';
s2='Enter second row number.  ';
s3='Enter multiplier.  ';
s4='Enter nonzero multiplier.  ';
s5='Enter row number.  ';
s6='Enter number of row that changes.  ';
s7='Last row operation "undone". ';
s8='               ^^* "REDUCE" a Matrix by Row Reduction ^^*';
s9='         The current matrix is:';
s10='     ENTER your choice ---> ';
s11='Press  ENTER  to continue';
s12='^^*  -->  REDUCE is over. Your final matrix is:';
s13='^ Improper row number! ^';
s14='Interchange Complete.';
s15='Row Multiplication Complete.';
s16='Replacement by Linear Combination Complete.';
menu=['            OPTIONS                           ';
      ' <1>  Interchange two rows.                   ';
      ' <2>  Multiply a row by a nonzero scalar.     ';
      ' <3>  Replace a row by linear combination of  ';
      '               itself with another row.       ';
      '<-1>  "Undo" previous row operation.          ';
      ' <0>  Quit reduce!                            '];
mess=s8;
i=sqrt(-1);
while 1
  cla
  disp(mess)
  disp(s9)
  a=A; %to prevent case mismatch in multiplier choice
  if rsig=='T',Amat=A;A=rat(A,'s'),A=Amat;else,A,end
  disp(menu)
  ch=input(s10);
  if ch==-1
    A=oldA;
    mess=s7;
  end
  if ch==0
    cla
    disp(s12)
    disp(s0)
    if rsig=='T',Amat=A;A=rat(A,'s'),A=Amat;else,A,end
    AEQ=A;
    break
  end
  if ch==1
    sig='Y';
    j=input(s1);
    k=input(s2);
    aj=abs(fix(j));ak=abs(fix(k));
    if j~=aj | j>m | k~=ak | k>m | j==0 | k==0
      disp(s13)
      disp(s11)
      pause
      sig='N';
      mess=s0;
    end
    if sig=='Y'
      oldA=A;
      temp=A(j,:);
      A(j,:)=A(k,:);
      A(k,:)=temp;
      mess=s14;
    end
  end
  if ch==2
    sig='Y';
    k=input(s3);
    while (k==0)
      k=input(s4);
    end
    j=input(s5);
    aj=abs(fix(j));
    if j~=aj | j>m | j==0
      disp(s13)
      disp(s11)
      pause
      sig='N';
      mess=s0;
    end
    if sig=='Y'
      oldA=A;
      A(j,:)=k*A(j,:);
      mess=s15;
    end
  end
  if ch==3
    sig='Y';
    t=input(s3);
    k=input(s1);
    j=input(s6);
    aj=abs(fix(j));ak=abs(fix(k));
    if j~=aj | j>m | k~=ak | k>m | k==0 | j==0
      disp(s13)
      disp(s11)
      pause
      sig='N';
      mess=s0;
    end
    if sig=='Y'
      oldA=A;
      A(j,:)=t*A(k,:)+A(j,:);
      for ii=1:n,if abs(A(j,ii))<=myeps,A(j,ii)=0;end,end
      mess=s16;
    end
  end
end
