%
function sinmovie                 %<<last updated 10/10/90>>
%SINE MOVIE  Taylor polynomial approximations to y = sin x are
%            presented in a graphical form. Successive graphs
%            of Taylor polynomials of degrees 1, 3, 5, 7, 9, and
%            11 are superimposed and labeled. As the degree
%            increases the Taylor polynomials wrap themselves
%            onto the sine curve over longer intervals. There is
%            a built in time delay.
%
%            By:  David R. Hill, Math Dept, Temple University
%                 Philadelphia, Pa.  19122
%
slash='\';
s0=' ';s1='Taylor Polynomials';s2='Press enter to continue.';
s3='degree               ';
f='sin(x)';
g='(-1)^k*(x.^(2*k+1))/(prod([1:(2*k+1)]))';
maxdeg=5; %max degree of Taylor poly is 2*maxdeg + 1
timdelay=6; %time delay for pause
locx=[.15 .2 .25 .25 .3 .3];locy=[.8 .2 .8 .2 .8 .2];
clg
x=[0:.1:10]';fx=eval(f);
clc
disp([blanks(15) 'SINE MOVIE - Taylor Polynomial Approximation']);
disp(s0),help sinmovie,disp(s0),disp(s2),pause
for k = 0:maxdeg
    z = eval(g);
    if k==0,y=z;else,[m,n]=size(y);y=[y y(:,n)+z];end
end
%Begin graphing
axis([0 10 -2 2]),subplot(121),plot(x,fx)
for j=0:maxdeg
    k=2*j+1;
    subplot(122),plot(x,fx,x,y(:,j+1),':')
    if k==11,s3(16)=slash;s3(18:19)='11';
    else
       s3(k+7)=int2str(k);
       if k~=1,s3(k+5)=slash;end
    end
    title(s3),pause(timdelay)
    subplot(122),plot(x,y(:,j+1),':i')
    subplot(121),plot(x,y(:,j+1),':'),title(s1)
    if j==0,title(s1),end
    subplot(121),text(locx(j+1),locy(j+1),int2str(k),'sc')
end
xlabel(s2),pause,clc,clg
disp('SINE MOVIE is over!')
