fprintf('\n    SOLUTION OF THE MATRIX DIFFERENTIAL EQUATION')
fprintf('\n    M*X''''+C*X''+K*X = F1*COS(W*T) + F2*SIN(W*T)  ')
fprintf('\n        SUBJECT TO X(T0) = X0, X''(TO) = V0     \n')

fprintf('\nSelect the mode of data input:')
% fprintf('\n1 => interactive   2 => from a file named fhrmat.dat')
fprintf('\n1 => interactive   2 => from a file ')
idat=input('? ');
if idat ==2
   fprintf('\nThe file must contain all of the variables');
   fprintf('\nm, c, k, f1, f2, w, t0, x0, v0, tf, and h\n');
   pause(3)

% A typical set of data for a three degree of freedom system
% is shown below. The pertinent variables should be created
% and placed in a file with the SAVE command so that they may
% be reloaded with the LOAD command
%

% DATA CASE FOR A THREE MASS SYSTEM SUBJECTED TO A HARMONIC
%  FORCING FUNCTION. THE UNDAMPED CIRCULAR FREQUENCIES ARE
%         [ W1, W2, W3 ] <=> [ .5, 1.0, 1.5 ]
%
%         m                     c                   k
%
%   6     0     0         1     0     0        6    -3     0
%   0     4     0         0     1     0       -3     6    -3
%   0     0     4         0     0     1        0    -3     4
%
%
%   f1     f2    x0    v0     w      t0    tf     h
%
%   0      0      0     0   0.5000    0    40     0.1000
%   0      0      0     0
%   1      0      0     0

   fprintf('\nEnter the  filename\n')
   fnam=input('? ','s');
   eval(['load ',fnam]);
   [n,ncol]=size(m);
else
   n=input('Input the number of degrees of freedom ?  ');

   fprintf(...
   '\nInput the rows of the mass matrix M, one at a time\n')
   m=readm(n,n);

   fprintf(...
   '\nInput the rows of the damping matrix C, one at a time\n')
   c=readm(n,n);

   fprintf(...
   '\nInput the rows of the stiffness matrix K, one at a time\n')
   k=readm(n,n);

   fprintf('\nInput the forcing frequency w'); w=input('?  ');

   fprintf('\nInput vector F1 as a row\n')
   tmp=readv(n); f1=tmp(:);

   fprintf('\nInput vector F2 as a row\n')
   tmp=readv(n); f2=tmp(:);

   fprintf('\nInput the initial position vector X0 as a row\n')
   tmp=readv(n); x0=tmp(:);

   fprintf('\nInput the initial velocity vector V0 as a row\n')
   tmp=readv(n); v0=tmp(:);

   fprintf('\nInput t-initial, t-final and the time stepsize\n')
   tmp=readv(3); t0=tmp(1); tf=tmp(2); h=tmp(3);
end

   [t,x,tcpu]=fhrmck(m,c,k,f1,f2,w,t0,x0,v0,tf,h);

fprintf('\nThe time, position, and cputime are stored in variables')
fprintf('\n      t,     x,   and    tcpu \n')

titl=['DISPLACEMENTS FOR ',int2str(n),' VARIABLES'];
plot1(...
t,x,'time','displacement components',titl)
