function edit2(matName)
% Trivial modification of function EDIT.M (from Notebook Suite) to enable use  
%    of .PIF file and editing of non-MEX ascii files   (j.d.cogdell 22-Dec-95)
%
% EDIT  Edit a matrix or M-file
%        EDIT x opens the matrix 'x' in the Matrix Editor
%
%        If x does not exist in the workspace a new 5x5 matrix
%        of zeros is created.
%
%        If x is an M-file, it is opened in a text editor
% 
%        If x is an arbitrary ascii file, it is opened in a text editor
%
%        EDIT, by itself, opens the matrix editor for a new 
%        5x5 matrix called 'untitled'
%
%        See also WORKSPACE and PATHTOOL.

%       Copyright (c) 1984-94 by The MathWorks, Inc.

% get the MATLAB editor preference
%editor = getprofl('Matlab Settings','Editor Pref','notepad.exe','matlab.ini');
editor = getprofl('Matlab Settings','Editor Pref','c:\windows\edit.pif','matlab.ini');

nbpath=which('edit');
nbpath=nbpath(1:findstr(nbpath,'edit')-1);

if nargin == 0
    % create a new untitled matrix
    eval(['!' nbpath 'wsptool untitled&'])

elseif isstr(matName)
    tp = exist(matName);
    if tp == 2 & isempty(find(matName=='.')),     % open an m-file
       fName=which(matName);
       eval(['!' editor ' ' fName '&'])
    
    elseif tp ==3 | tp==2,                        % open a non-Matlab ascii file
       eval(['!' editor ' ' matName '&'])            
    
    elseif tp==1 | tp==0,                         % open an existing matrix
       eval(['!' nbpath 'wsptool ' matName '&'])
    end
end
