% FASTMAT creates a shell script (called fastmat)
% that starts MATLAB quickly. If fastmat at the
% unix prompt fails, start MATLAB the usual way
% and run this m-file again.

fid = fopen('fastmat','w');

% Choose the bourne shell

fprintf(fid,'#!/bin/sh -f\n');

% export the required variables

fprintf(fid,'export LM_LICENSE_FILE\nLM_LICENSE_FILE=%s\n',getenv('LM_LICENSE_FILE'));
fprintf(fid,'export XAPPLRESDIR    \nXAPPLRESDIR=%s    \n',getenv('XAPPLRESDIR'    ));
fprintf(fid,'export XKEYSYMDB      \nXKEYSYMDB=%s      \n',getenv('XKEYSYMDB'      ));
fprintf(fid,'export MATLABPATH     \nMATLABPATH=%s     \n',matlabpath               );
fprintf(fid,'export MATLAB         \nMATLAB=%s         \n',getenv('MATLAB'         ));

%run the image

fprintf(fid,'%s/bin/%s/matlab\n',getenv('MATLAB'),lower(computer));
fclose(fid);

%Of course, you'll want to run it.

!chmod +x fastmat
