static char rcsid[]="$Id$";
/******************************************************************************
  pgm2mat.c

     Function:  Convert PGM file to Matlab (level 1) format.

Michael Maurer, July 1993.
******************************************************************************/
/* $Log$ */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <pgm.h>
#include "libml.h"

#define PGM2MAT_C
#include "pgm2mat.H"
#include "libml.H"

char *prog;

int
main(argc,argv)
int argc;
char *argv[];
{
   FILE *fin;
   FILE *fout;
   gray **G,maxv;
   int mr,nc,mtype;
   char *pname=NULL;

   prog=argv[0];
   pgm_init(&argc,argv);

   if (argc>1 && pm_keymatch("-n",argv[1],2)) {
      pname=argv[2];
      argv+=2;
      argc-=2;
   }
   if (argc>1 && pm_keymatch("-",argv[1],1))
      pm_usage("[-n name] [pgmfile [matfile]]");

   fin=(argc>1) ? pm_openr(argv[1]) : stdin;
   G=pgm_readpgm(fin,&nc,&mr,&maxv);
   fclose(fin);

   fout=(argc>2) ? fopen(argv[2],"w") : stdout;
   if (fout==NULL) {
      fprintf(stderr,"[main] fopen %s\n",argv[2]);
      return 1;
   }
   if (pname==NULL) {
      if (argc>2) {
         if ((pname=strrchr(argv[2],'/'))==NULL)
            pname=argv[2];
         pname=strtok(pname,".;");
      } else
         pname="pgm";
   }
   fixstr(pname);
   mtype = ML_TYPE + ML_ROW + (maxv<256 ? ML_UCHAR : ML_USHORT);
   if (mlwrite(fout,mtype,pname,mr,nc,0,G[0],NULL)) {
      fprintf(stderr,"[main] mlwrite failed\n");
      return 1;
   }
   fclose(fout);

   return 0;
}

#include <ctype.h>
static char *
fixstr(s1)
char *s1;
{
   char *s0=s1;

   s1--;
   while (*++s1)
      if (!isalnum(*s1))
         *s1='_';
   return s0;
}

