#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include "dapio.h"
#include "c_lib.c"

/* This program is primarily intended for A/D acquisition.
   It may however be used by any program that needs to
   send a DAP command file, run it, and read (preferrably)
   16-bit data from an input pipe */

void dapread( char *cmdfile, char *outfile, unsigned long rows, unsigned long cols )
{
	FILE *out_fp;
	unsigned long r, c;
	int status;
	int data;

/*        printf("Command file: %s\n", cmdfile );
	printf("Output file: %s\n", outfile );
	printf("Rows: %ld\n", rows );
	printf("Cols: %ld\n", cols );*/
	NInitDap( "ACCEL0" );
	if( (out_fp = fopen( outfile, "wb")) == NULL )  {
		puts( "Could not open binary data file\n" );
		exit(1);
	}
	/*puts("Before config\n" );*/
	status = fConfigDap( DapOut, cmdfile );
	if( status >= 200 )  {
		printf("Error '%d' while configuring Dap\n", status );
		exit;
	}
	/*puts("After config\n");*/
	while(  fGetDapAvail( DapIn )  ==  0   );
	/*puts("After fGetDapAvail\n" );*/
	for( r = 0; r<rows; r++ )  {
		for( c = 0; c < cols; c++ )  {
			fscanf(DapIn, "%d", &data );
			/*printf("%d\t", data );*/
			putw( data, out_fp );
		}
		/*puts("\n");*/
	}
	/*puts("Done collecting\n" );*/
	LeaveDap();
	fclose( out_fp );
}


/*y = dap_ad( cmdfile, outfile, rows, cols ) */
int main( int argc, char *argv[] )
{
	unsigned long rows, cols;       

	if( argc != 5 )  {
		puts( "Usage: dap_ad cmdfile resfile rows cols\n" );
		exit(1);
	}
	rows = atol( argv[3] );
	cols = atol( argv[4] );

	dapread( argv[1], argv[2], rows, cols );
}
		
