#include <math.h>
#include <stdlib.h>
#include "mex.h"




static int *gainlist = NULL;
static int listsize = 0;
static int reg_exit_fn = 0;


void ExitFcn( void )
{
	/* Free memory */
	if( gainlist != NULL )  free( gainlist );
}


void mexFunction( int nlhs, Matrix *plhs[], int nrhs, Matrix *prhs[] )
{
	int i;
	double *pr;

	if( reg_exit_fn == 0 )
		if( mexAtExit( ExitFcn ) )
			mexErrMsgTxt( "Could not register exit function" );
		else  reg_exit_fn = 1;
	if( nrhs == 0 )  {
		if( gainlist != NULL )  {
			/* Return current gain */
			plhs[0] = mxCreateFull(1,listsize,REAL);
			if( plhs[0] == NULL )
				mexErrMsgTxt("Could not allocate memory");
			pr = mxGetPr(plhs[0]);
			for( i=0; i<listsize; i++ )
				pr[i] = (double) gainlist[i];
		}
	}
	else if( nrhs == 1 )  {
		if( gainlist != NULL )  free( gainlist );
		listsize = (int) mxGetN(prhs[0]);
		pr = mxGetPr( prhs[0] );
		gainlist = (int *) malloc( sizeof(int) * listsize );
		if( gainlist == NULL )
			mexErrMsgTxt( "Could not allocate memory");
		for( i=0; i< listsize; i++ )
			gainlist[i] = (int) pr[i]; 
	}
	else
		mexErrMsgTxt("Wrong number of input args\n" );
}
