function pulse(t,word)
% pulse(t) puts all the digital outputs in the high
% state for t seconds.  The outputs are then set low.
%
% pulse(t,byte), instead of setting all outputs high,
% writes the 8-bit word BYTE to the output ports.

if nargin == 1
  word = 255;
end
t = t*1000;  %change unit to milliseconds
s = ['RESET\n' ...
     'PIPE P1\n' ...
     'PDEF A\n' ...
       'SQUAREWAVE(1,' int2str(2*t) ',P1)\n' ...
     'END\n' ...
     'PDEF C\n' ...
       'OPIPE0 = (-(P1-1)/2)*' int2str(word) '\n' ...
     'END\n' ...
     'ODEFINE B 1\n' ...
       'SET OPIPE0 B0\n' ...
       'TIME 1000\n' ...  %This is what causes the ms unit
       'COUNT ' int2str(t+1) '\n' ...
     'END\n' ...
     'START\n' ];
%sprintf(s)
outfilestr = 'c:\matlab\dap\writeda.dap';
writedaprog = 'c:\matlab\dap\dap_da';
% Command string creation finished.  Save it
fid = fopen(outfilestr, 'wt');
fprintf(fid, s );
fclose(fid);
% create program string
cmdstr = ['!' writedaprog ' ' outfilestr ' NOFILE 0 0'];
eval( cmdstr );