function dcl(addr_vec)
%dcl --  Device Clear
%
%dcl(addr_vec)   addresses the devices listed in the input vector,
%                and issues an SDC (Selective Device Clear) command.
%
%dcl          issues a DCL (Device Clear) command, thus clearing ALL
%             devices connected to the bus.
%
%See also GP_INIT.

% Get device name and open as file
board = gp_board;
[f,msg] = fopen( gp_dev( board ), 'w+' );
if f == -1
	error( ['dcl fopen() error: ' msg] );
end

if board == 1
	format_str = ' %1.0f';
else
	format_str = ',%1.0f';
end

if nargin == 0 
	fprintf(f,'CLEAR\r\n');
else
	s = 'CLEAR';
	s = [s sprintf(' %1.0f',addr_vec(1))];
	for k=2:length(addr_vec)
		s = [s sprintf(format_str,addr_vec(k))];
	end
	s = [s '\r\n'];
	fprintf(f,s);        
end