function y = enter(address)
%ENTER --
%
%y=enter(ADDRESS) reads a string from the GPIB device assigned
%by ADDRESS, and returns it as a MATLAB string.
%%ENTER stops reading when it encounters an EOS character or the EOI signal.
%The EOS char is LF by default, but may be changed using EOS_IN.
%
%See also SEND, GP_INIT, EOS_OUT, EOS_IN

if (nargin > 1) | (nargin < 0)
	error('enter: One input argument required' )
end

% get device name
[f, msg] = fopen( gp_dev(gp_board), 'w+' );
if f == -1
	error(['enter fopen() error: ' msg]);
end

fprintf(f,'ENTER %1.0f\r\n',address);
y=fgetl(f);

fclose(f);