function y = enternum(address,count)
%ENTERNUM --
%
%y=ENTERNUM(address) reads a string from the GPIB device given by address,
%converts it into a floating-point number and returns it in Y.  Note that the 
%string must NOT contain non-numeric data (such as the string '0.014 V DC') 
%since the conversion procedure automatically stops at the first 
%non-numeric character.
%
%EXAMPLE:  voltage=enternum(3);
%
%y=ENTERNUM(address,count) reads count no of strings, 
%converts them to numbers, and returns them in a column vector.
%
%EXAMPLE:  volt_arr=enternum(3,4);
%
%See also SEND, ENTERNUM, GP_INIT, RARRAY, TARRAY, TRANSMIT, RECEIVE,
%         SPOLL, PPOLL, SRQ, SETTIMEOUT, EOS_OUT, EOS_IN

if (nargin > 2) & (nargin < 0)
	error('enternum: One or two input arguments required' )
end



if nargin == 1
	y=eval(enter(address));
else
	y=zeros(count,1);
	for i=1:count
		y(i)=eval(enter(address));
	end
end

