function eos_in(eos)
%EOS_IN --
%
%eos_in(eos)    modifies the EOS character that make the ENTER
%               command stop reading data from the bus.
%
% Example:
%
%       eos_in(13)
%
%               sets the EOS character to CR (=13 decimal).
%
%
%See also SEND, ENTER, EOS_OUT.

if nargin ~= 1
	error( 'eos_in: wrong number of parameters' )
end

board = gp_board;
[f, msg] = fopen( gp_dev(board), 'w+' );
if f == -1
	error( ['eos_in fopen() error: ' msg] );
end

if board == 1
	if eos == 10
		s = 'INTERM LF\r\n';
	elseif eos == 13
		s = 'INTERM CR\r\n';
	else
		s = ['INTERM "' eos '"\r\n'];
	end
elseif board == 2
	if eos == 10
		s = 'GPIBEOS IN LF\r\n';
	elseif eos == 13
		s = 'GPIBEOS IN CR\r\n';
	else
		s = sprintf('GPIBEOS IN CHR(%1.0f)\r\n',eos);
	end
else
	error('wrong board')
end
fprintf(f,s);
fclose(f);