function ext_clock(y)
%ext_clock(y)
%
%If y==0, internal clock is used for the A/D conversion.  If y != 0
%external clock is used.

board = ad_board;

if board == 0
	error('No board defined');
elseif board == 1
	%DT2801
	if nargin == 1
		dt2801(7,y);
	else
		error('Illegal number of parameters for ext_clock command');
	end
elseif board == 2
	%PCL714
	error('ext_clock command not supported for the PCL714 card.');
elseif board == 3
	%DAP
	dap_clk(y);
else
	error('Illegal board value');
end
