function ext_trig(y)
%ext_trig(y)
%
%If y==0, internal trig is used for the A/D conversion.  If y != 0
%external trig is used.

board = ad_board;

if board == 0
	error('No board defined');
elseif board == 1
	%DT2801
	if nargin == 1
		dt2801(6,y);
	else
		error('Illegal number of parameters for ext_trig command');
	end
elseif board == 2
	%PCL714
	error('ext_trig command not supported for the PCL714 card.');
elseif board == 3
	%DAP
	dap_trig(y);
else
	error('Illegal board value');
end
