function get(addr_vec)
%get --  Group Executive Trig
%
%get          Sends a GET command. Note that only the instruments 
%             currently in the listen mode will accept the command.
%
%get(addr_vec)  Sends the listener addresses given in addr_vec onto the bus
%               prior to sending the GET command.
%
%See also REN.

board = gp_board;
[f, msg] = fopen( gp_dev(board) );
if f == -1
	error( ['get fopen() error: ' msg] );
end

if board == 1
	format_str = ' %1.0f';
else
	format_str = ',%1.0f';
end

if nargin == 0 
        fprintf(f,'TRIGGER\r\n');
else
        s = 'TRIGGER';
        s = [s sprintf(' %1.0f',addr_vec(1))];
        for k=2:length(addr_vec)
                s = [s sprintf(format_str,addr_vec(k))];
        end
        s = [s '\r\n'];
        fprintf(f,s);        
end

fclose(f);