%GP_INIT --
%
% Use this command prior to any other GPIB command.  It will initialize
% the GPIB card as a controller with a device address of 21.  If this is
% not satisfactory, use the address as argument when loading the
% device driver cechp.exe.
%
% Example:
%
%       gp_init
%       send(3,'M1');
%       x=enternum(3,10);
%
%       This will read 10 values from the 7150 voltmeter.
%
%See also SEND, ENTER, REN, GTL, LLO, DCL, GET, 
%         SPOLL, PPOLL, SRQ, EOS_OUT, EOS_IN

board = gp_board;
[f,msg] = fopen( gp_dev(board),'w+' );
if f == -1
	error( ['gp_init fopen() error:' msg] );
end

%send IFC, reset card
fprintf(f,'ABORT\r\n');
fclose(f);
dcl;
pause(3);
eos_out(10);
eos_in(10);