function gtl(addr_vec)
%gtl --  Go to Local
%
%gtl(addr_vec)   addresses the devices listed in the input vector,
%                and issues a GTL (Go To Local) command.
%
%gtl          Unasserts the REN line, thus forcing ALL devices connected 
%             to the bus into local mode.
%

board = gp_board;
[f, msg] = fopen( gp_dev(board), 'w+' );
if f == -1
	error( ['gtl fopen() error: ' msg] );
end

if board == 1
	format_str = ' %1.0f';
else
	format_str = ',%1.0f';
end

if( nargin == 0 )
	fprintf(f,'LOCAL\r\n');
else
	s = 'LOCAL';
	s = [s sprintf(' %1.0f',addr_vec(1))];
	for k=2:length(addr_vec)
		s = [s sprintf(format_str,addr_vec(k))];
	end
	s = [s '\r\n'];
	fprintf(f,s);        
end
fclose(f);