#include "mex.h"
#include <bios.h>

/* Version with 55.6 ms tick time */
#define CLOCKS_PER_SEC 18
#define time_t long

long clock( void )
{
	long time;

	_bios_timeofday( _TIME_GETCLOCK, &time );
	return( time );
}


/*      loop(time_delay) */
void mexFunction(int nlhs, Matrix *plhs[], int nrhs,Matrix *prhs[])
{
	static time_t elapsed_time;
	time_t difftime;

	/* Check arguments! */

	if( nrhs != 1 )  mexErrMsgTxt("One input argument, please");
	if( nlhs != 0 )  mexErrMsgTxt("No output arguments, please");

	difftime = (time_t) (mxGetScalar(prhs[0])*CLOCKS_PER_SEC);
	if( difftime == 0 )  {
		elapsed_time = clock(); /* Init timer */
	}
	else  {
		/* Wait until elapsed time */
		elapsed_time += difftime;
		while( clock() < elapsed_time );
	}
}



