function y=ppoll
%PPOLL --
%
%y=ppoll        executes a parallell poll of the GPIB bus, and returns the
%               parallell poll byte in y.
%
% Example:
%
% poll_val = ppoll;
%
%       will poll the bus.
%
%See also SPOLL, SRQ.

board = gp_board;
[f, msg] = fopen( gp_dev(board), 'w+' );
if f == -1 
	error( ['ppoll fopen() error: ' msg] );
end

if nargin
	error( 'ppoll: no input arguments allowed!' );
end

fprintf(f,'PPOLL\r\n');
y=eval( fgetl(f) );
fclose(f);