function y=readad(count,dtime,start_chan,end_chan)
% readad reads 1 sample from channel 0, using ad_imm.
%  readad(chan) reads 1 sample from chan, using ad_imm.
%  readad(count,dtime) reads count samples with sample period dtime from channel 0.
%  readad(count,dtime,start_chan) reads form channel start_chan.
%  readad(count,dtime,start_chan,end_chan) scans a sequence of channels.
%  From each channel, count samples are read. */

board = ad_board;

if board == 0
	error('No A/D board defined');
elseif board == 1
	if nargin == 0
		y = dt2801(1);
	elseif nargin == 1
		y = dt2801(1,count);
	elseif nargin == 2
                if dtime < 7.5E-5
                        error('Minimum sample time is 7.5E-5 s.');
                end
		y = dt2801(1,count,dtime);
	elseif nargin == 3
                if dtime < 7.5E-5
                        error('Minimum sample time is 7.5E-5 s.');
                end
		y = dt2801(1,count,dtime,start_chan);
	elseif nargin == 4
                if (dtime/(end_chan-start_chan+1)) < 7.5E-5
                        error('Minimum sample time/channel is 7.5E-5 s.');
                end
		y = dt2801(1,count,dtime,start_chan,end_chan);
	else
		error('Illegal number of parameters for DT2801 card');
	end
elseif board == 2
	if nargin == 0
%		y = pcl714(1);
	elseif nargin == 1
%		y = pcl714(1,count);
	elseif nargin == 2
%		y = pcl714(1,count,dtime);
	elseif nargin == 3
%		y= pcl714(1,count,dtime,start_chan);
	else
		error('Illegal number of arguments for PCL714 card.');
	end
elseif board == 3
	if nargin == 0
		y = d_readad;
	elseif nargin == 1
		y = d_readad( count );
	elseif nargin == 2
		y = d_readad( count, dtime );
	elseif nargin == 3
		y = d_readad( count, dtime, start_chan );
	elseif nargin == 4
		y = d_readad( count, dtime, start_chan:end_chan );
	end
end
