function set_gain(y)
%set_gain(y)
%
% Sets the gain used for the A/D conversion.

board = ad_board;

if board == 0
	error('No board defined');
elseif board == 1
	%DT2801
	if( (y==1) | (y==2) | (y==4) | (y==8) )
		dt2801(5,y);
	else
		error('Illegal gain value for the DT2810 card. Use 1,2,4, or 8');
	end
elseif board == 2
	%PCL714
	error('set_gain command not supported for the PCL714 card.');
elseif board == 3
	%DAP
	dap_gain(y);
else
	error('Illegal board value');
end
