function y=spoll(address)
%SPOLL --
%
%y=spoll(ADDRESS)       executes a serial poll of the device assigned by
%                       ADDRESS, and returns the serial poll byte in y.
%                       First, the SPE (Serial Poll Enable) command is sent
%                       over the bus, followed by the instrument's talk
%                       address and the computers listener address.  The
%                       instrument then sends the content of its poll
%                       register as data over the bus, whereafter the
%                       computer sends UNT and SPD (Serial poll disable).
%
% Example:
%
% poll_val = spoll(6);
%
%       will poll device 6.
%
%See also PPOLL, SRQ.

if nargin ~= 1
        error( 'spoll: wrong number of input arguments' );
end

board = gp_board;
[f, msg] = fopen( gp_dev(board), 'w+' );
if f == -1
	error( ['spoll fopen() error: ' msg] );
end

fprintf(f,'SPOLL %1.0f\r\n',address);
y=eval( fgetl(f) );
fclose(f);