function y=srq
%SRQ --
%
%y=srq  checks if any device has requested service.  If so, it returns 1.
%       If not, it returns 0.
%
% Example:
%
% if srq == 1
%       p=ppoll;
% end
%
%       will execute a parallell poll of the bus ONLY if an SRQ has occurred.
%
%See also SPOLL, PPOLL.

if nargin
        error( 'srq: no input arguments please!' );
end

board = gp_board;
[f, msg] = fopen( gp_dev(board), 'w+' );
if f == -1
	error( ['srq fopen() error: ' msg] );
end

if board == 1
	% CEC
	fprintf(f,'SRQ?\r\n');
	y = fgetl(f);
elseif board == 2
	% National
	gtl;
	%ren;
	fprintf(f,'STATUS\r\n' );
	y= fgetl(f);
	i = 1;
	while y(i) ~= ','
	        i = i+1;
	end
	y = y(1:(i-1));
	y = eval( y );
	y = y / 4096;
	y = floor(y);
	clear i
	if floor(y/2) == (y/2)
        	% Even number; srq == 0
	        y = 0;
	else
        	y = 1;
	end
else
	error('Wrong board');
end
fclose(f);