function [xo,yo] = stairs2(x,y)
%STAIRS2 A modification of the standard matlab STAIRS m-file that
%        is better suited to plotting of multiple signals.
%        x should be a column vector of x-axis values               
%        y should be one or more column vectors to be plotted
%        against x

n = length(x);
if nargin == 1
	y = x;
	x = 0:(n-1);
end
[r,c] = size(y);
delta = (max(x) - min(x)) / (n-1);
nn = 2*n - 1;
yy = zeros(nn,c);
xx = zeros(nn,1);
t = x';
%t = x(:)' - 0.5*delta;
xx(1:2:nn) = t(1:n);
xx(2:2:(nn-1)) = t(2:n);
% xx(nn+1:nn+2) = t(n) + [delta;delta];
yy(1:2:nn,:) = y;
yy(2:2:(nn-1),:) = y(1:(n-1),:);
if nargout == 0
	plot(xx,yy)
else
	xo = xx;
	yo = yy;
end
