function mfhelp(P1,P2,P3,P4,P5,P6,P7,P8,P9,P10,P11,P12,P13,P14,P15,P16);
% MfHELP is an .M file which invokes the .M file browser program MfHELP.EXE.
% The syntax is similar to the one of MfHELP.EXE, i.e.
%
% mfhelp [options] [<mfile>]
%
% <mfile>      - The function for which help is requested. May also contain
%                a regular expression, in which case MfHELP will display all
%                matches. If it ends with a backslash, e.g. 'specfun\', this
%                string is specifying a toolbox rather than a function name.
%
% Options:
% --------
% /s,/x <strg> - A text string to search for. /s specifies substring search,
%                while /x specifies a regular expression.
% /o,/n        - Re-use old window (/o) or spawn a new one (/n). If missing,
%                the MfHELP.EXE default is taken.
% /d <dirlist> - A directory list for the search path, in addition to the
%                default one. Can also contain recursive heirarchies, e.g.
%                "d:\eyal!!". If not present, mfhelp.m appends the current
%                directory.
% /h           - Invoke the online help for MfHELP.EXE.
% /c           - Close all MfHELP windows.

EXE='c:\matlab4\bin\mfhelp.exe'; % Edit this to point to the .exe in your installation.
OPT='/r';                        % Prevent MATLAB from waiting for termination.
Dir=pwd;                         % Default additional search path is current dir.

l=1;
mfile=[];
while l<=nargin
  eval(sprintf('P=P%g;',l));
  if isempty(P),P=' '; end
  if P(1)=='-', P(1)='/'; end
  if P(1)=='/'          % options
    if P(2)=='d' | P(2)=='D'
      l=l+1;
      if l>nargin
        Dir=''
      else
        eval(sprintf('Dir=[''"'',P%g,''"''];',l));
      end
      P=[];
    elseif P(2)=='r' | P(2)=='R'
      P=[];
    elseif P(2)=='s' | P(2)=='S' | P(2)=='x' | P(2)=='X'
      if l<nargin
        eval(sprintf('PP=[P%g,''"''];',l+1));
        if PP(1)~='/' & PP(1)~='-'
          l=l+1;
          P=[P,' "',PP];
        end
      end
    end
  else
    if any(P==' ') ,P=['"',P,'"']; end
    mfile=P; P=[];
  end
  if ~isempty(P), OPT=[OPT,' ',P]; end
  l=l+1;
end

OPT=[OPT,' /d ',Dir];

eval(['!',EXE,' ',OPT,' /f ',mfile]);

