/*********************************************************************/
/* Copyright (c) 1990-93 by The MathWorks, Inc. */
/* $Revision: 1.4 $  $Date: 1993/06/08 03:04:32 $ */
/*********************************************************************/

/* appsave: appends varname to filename.mat  */
/* APPSAVE('FILENAME','VARNAME',VAR)         */

#include "mat.h"
#include "mex.h"

#ifdef __STDC__
void mexFunction(
        int             nlhs,
        Matrix  *plhs[],
        int             nrhs,
        Matrix  *prhs[]
        )
#else
mexFunction(nlhs, plhs, nrhs, prhs)
	int nlhs, nrhs;
	Matrix *plhs[], *prhs[];
#endif
{
	int i, len;
	unsigned int m, n;
	MATFile *fp;
	Matrix *a;
	char *varname;
	char *filename;

	/* Check for proper number of arguments */
	
	if (nrhs < 2) 
	  mexErrMsgTxt("At least two argument required.");
	else if (nlhs != 0)
	  mexErrMsgTxt("Cannot have any ouput arguments.");

	m = mxGetM(prhs[0])*mxGetN(prhs[0])+1+4;
	filename = mxCalloc(1,m);
	mxGetString(prhs[0], filename, m);
	strcat(filename, ".mat");

	fp = matOpen(filename, "u");
	
	if (fp == 0) {
	  mexErrMsgTxt("Cannot open .mat file.");
	  exit(-1);
	}

        m = mxGetM(prhs[1])*mxGetN(prhs[1])+1;
        varname = mxCalloc(1,m);
        mxGetString(prhs[1], varname, m);
 
        mxSetName(prhs[2], varname);
	
 	if(matPutMatrix(fp, prhs[2])) {
	    mexPrintf("matPutmatrix failed");
	    mexPrintf("error code %d\n", ferror(matGetFp(fp)));
	    mexErrMsgTxt("");
	}
	
	matClose(fp);
	mxFree(varname);
	mxFree(filename);
	
}
