%     [ a,b,c, ..., t ] = loadop4( 'fn', { # } );
%
%       Function to read OP4 matrices into Matlab.
%
%  Sample Usages:
%
%    1)        [ a,b,c ] = loadop4( 'fn' );
%
%       fn = input-filename with 1 of 2 extensions:  __.bin  or  __.bcd
%       __.bin   -----> input file was written in OP4BIN format 
%       __.bcd   -----> input file was written in OP4BCD format 
%       The first three matrices from fn will be stored in a, b, & c. 
%
%    2)        [ d,e ] = loadop4( 'fn', 20 );
%
%       The optional second right-hand-side (RHS) argument is an integer
%       specifying how many matrices in fn to skip over before reading.
%       In 2), the 21st & 22nd matrices from fn will be stored in d & e. 
%
%  Notes:  
%
% >>>>>	1) Remember to use the ending semicolon to suppress printing to screen.
%	2) Do NOT specify more left-hand-side (LHS) arguments than the actual 
%	   number of matrices in file fn.
%	3) At present, the maximum number of LHS arguments is 20.
%	4) Just like NASTRAN INPUTT4, the input matrix name is independent
%	   of the matrix name stored on the disk file.
%
%  See also:     saveop4

%       Kevin Nguyen 
%       Copyright (c) 1995   
