function parent = f(tree, node)
% GetParent	Move from node to its parent.
%
% parent = GetParent(tree, node)
% Inputs:
%   <tree> = tree matrix;
%   <node> = row index of current node.
% Output:
%   <parent> = row index of the node's parent.  Returns 0 if there was no
%		parent node (i.e., <node> was the root node).
%
% JKS
% $Id$

if nargin < 2,
  error('Usage: parent = GetParent(tree, node)');
end
if (node == 1),			% Root node is special
  parent = 0;
else				% Ordinary node
  parent = tree(node, 1);
end
