function newtree = f(tree, n)
% IncrNchildren		Increase Nchildren for a tree
%
% <newtree> = IncrNchildren(tree, n)
% Inputs:
%   <tree> = a tree matrix;
%   <n> = a positive integer of how many additional children to allow at a node.
%         Defaults to 1.
% Output:
%   <newtree> = the new tree matrix.
%
% JKS
% $Id$

if nargin < 1,
  error('Usage: newtree = IncrNchildren(tree, n)');
end
if nargin < 2,  n = 1; end
if (n < 1), error('<n> must be positive'); end

[M, N] = size(tree);
Nch = tree(1,1);
Ndata = N - Nch - 1;
newNch = Nch + n;
newtree = zeros(M, N+n);
newtree(:,1:(Nch+1)) = tree(:, 1:(Nch+1));
newtree(:,(newNch+2):(N+n)) = tree(:, (Nch+2):N);