function newtree = f(tree, n)
% IncrNdata		Increase Ndata for a tree
%
% <newtree> = IncrNdata(tree, n)
% Inputs:
%   <tree> = a tree matrix;
%   <n> = a positive integer of how many additional data elements to allow at
%	  a node.  Defaults to 1.
% Output:
%   <newtree> = the new tree matrix.
%
% JKS
% $Id$

if nargin < 1,
  error('Usage: newtree = IncrNdata(tree, n)');
end
if nargin < 2,  n = 1; end
if (n < 1), error('<n> must be positive'); end

[M, N] = size(tree);
Nch = tree(1,1);
Ndata = N - Nch - 1;
newNdata = Ndata + n;
newtree = zeros(M, N+n);
newtree(:,1:N) = tree;
