function a = f(tree, node)
% IsLeaf	Indicate whether or not current node is a leaf.
%
% a = IsLeaf(tree, node)
% Inputs:
%   <tree> = tree matrix;
%   <node> = row index of node to check.
% Output:
%   <a> = 0 if the node is not a leaf node (it has children),
%	  1 if the node is a leaf node (it has no children).
%
% JKS
% $Id$

if nargin < 2,
  error('Usage: a = IsLeaf(tree, node)')
end
Nch = tree(1,1);
a = ~any(tree(node, 2:(Nch+1)) > 0);
