function depth = f(tree, node, dsum)
% TreeNodeDepth		Find depth of current node
%
% depth = TreeNodeDepth(tree, node)
% Inputs:
%   <tree> = tree matrix;
%   <node> = row index of node of interest.
% Output:
%   <depth> = depth of node.  1 = root, 2 = immediate child of root, 3 =
%		grandchild of root, etc.
%
% JKS
% $Id$

if nargin < 2,
  error('Usage: depth = TreeNodeDepth(tree, node)');
end
if nargin == 2,		% Initial call
  dsum = 1;
end
parent = GetParent(tree, node);
if (parent),
  dsum = TreeNodeDepth(tree, parent, dsum+1);
end
depth = dsum;
