function f(tree, node, nodefun, branchfun, depth, maxdepth, nodepos, ...
		 clr, style)
% drawtree_rec	Recursive drawing routine called by DrawTree.
%
% JKS
% $Id$

Nch = tree(1,1);
x = nodepos(1);			% Where to draw the current node.
y = nodepos(2);

data = TreeNodeData(tree, node);		% Get node data
eval(['ht = text(x, y, ', nodefun, ');']);	% Draw/Label the node
if (IsLeaf(tree, node)),			% At a leaf node, adjust the
  set(ht, 'verticalalign', 'top', ...		% text.  Stop recursion.
	'horizontalalign', 'center');
else						% At non-leaf node, draw/label
  D = maxdepth - depth - 1;			% branches to children.
  xch = -(Nch-1)*Nch^D / 2;			% Leftmost child's rel. pos.
  ych = y - 1;
  xstep = Nch^D;				% Space between children.
  for ch = 1:Nch,
    child = GetChildren(tree, node, ch);	% Look for ch-th child
    if (child),
      h = line([x, x+xch], [y, ych]);		% Draw branch
      if ~isempty(branchfun),			% Label branch, if desired.
        tx = x + xch/2;
        ty = (y+ych)/2;
        eval(['ht = text(tx, ty, ', branchfun, ');']);
      end
      newpos = [x+xch, ych];
      drawtree_rec(tree, child, nodefun, branchfun, depth+1, maxdepth, ...
			newpos, clr, style);
    end
    xch = xch + xstep;
  end
end

