function [freq,data,erc,ermessage,d1,d2,date,IDs,rptnum,rdir,eptnum,edir, ...
			            function_type] = read_frf_uff(filename)
%usage:  [freq,data,errcode,errmessage,descript1,descript2,date,IDs,     ...
%	  resp_pt_num,r_direction,excit_ptnum,excit_direction,function_type]...
%						= read_frf_uff(filename);
%note: READ_FRF_UFF only reads on data set from a file, if you have more
%      than one data set, use READ_UFF.

[fid,ermesage] = fopen(filename,'rt');
if  fid==-1,
  ermessage = 'could not open file';
  disp(ermessage);
  erc = -1;
  return;
end

FILE = fgetl(fid);
if isstr(FILE),
  while 1,
    line = fgetl(fid);
    if ~isstr(line), break, end
    FILE = str2mat(FILE,line);
  end
else,
  ermessage = 'no lines in file';
  disp(ermessage);
  erc = -1;
  return;
end

num_lines=size(FILE,1);

erclose = fclose(fid);
if  erclose==-1,
  ermessage = 'error while closing file';
  disp(ermessage);
  erc = -1;
  return;
end

%========
line = 1;
%========
code = sscanf(FILE(line,:),'%i',1);
if code ~= -1, 
  ermessage = 'not universal file format';
  disp(ermessage);
  erc = -1;
  return;
end

%========
line = 2;
%========
file_type_num = sscanf(FILE(line,:),'%i',1);

if file_type_num == 15,
  ermessage = 'Coordinate Data Set is Not Implemented, try READ_UFF';
  disp(ermessage);
  erc = -1;
  return;
elseif file_type_num == 55,
  ermessage = 'Modal Data Set is Not Implemented, try READ_UFF';
  disp(ermessage);
  erc = -1;
  return;
elseif file_type_num == 58, % Measurement Data Type

%-----------------------------Start of Measurement Data------------------------
  %========
  line = 3;
  %========
  d1 = sscanf(FILE(line,:),'%s',1);

  %========
  line = 4;
  %========
  d2 = sscanf(FILE(line,:),'%s',1);

  %========
  line = 5;
  %========
  date = sscanf(FILE(line,:),'%s',1);
  
  %========
  line = 6;
  %========
  IDs = sscanf(FILE(line,:),'%s',1);

  %========
  line = 7;
  %========
  temp = sscanf(FILE(line,:),'%s',1);

  %========
  line = 8;
  %========
  function_type = sscanf(FILE(line,1:5),'%i',1);
  if function_type ~=4,
    ermessage = 'not frf data';
    disp(ermessage);
    erc = -1;
  end
  tmp = sscanf(FILE(line,6:15),'%i',1);
  tmp = sscanf(FILE(line,16:20),'%i',1);
  load_case_id = sscanf(FILE(line,21:30),'%i',1);
  if load_case_id ~= 0,
    ermessage = 'need single point excitation';
    disp(ermessage);
    erc = -1;
    return;
  end
  temp = sscanf(FILE(line,32:41),'%s',1);
  rptnum = sscanf(FILE(line,42:51),'%i',1);
  rdir = sscanf(FILE(line,52:55),'%i',1);
  temp = sscanf(FILE(line,57:66),'%s',1);
  eptnum = sscanf(FILE(line,67:76),'%i',1);
  edir = sscanf(FILE(line,77:80),'%i',1);

  %========
  line = 9;  % data form
  %========
  data_type = sscanf(FILE(line,1:10),'%i',1);
  numpt = sscanf(FILE(line,11:20),'%i',1);
  freq_spacing = sscanf(FILE(line,21:30),'%i',1);
  if freq_spacing ~= 1,
    ermessage = 'need evenly spaced frequency';
    disp(ermessage);
    erc = -1;
    return;
  end
  fmin = sscanf(FILE(line,31:43),'%g',1);
  fdel = sscanf(FILE(line,44:56),'%g',1);
  tmp = sscanf(FILE(line,57:69),'%g',1);

  %========
  line = 10;  % abscissa data characteristics
  %========
  ab_data_type = sscanf(FILE(line,1:10),'%i',1);
  if ab_data_type ~= 18,  %Frequency
    ermessage = 'need frequency on abcissa';
    disp(ermessage);
    erc = -1;
    return;
  end
  tmp = sscanf(FILE(line,11:15),'%i',1);
  tmp = sscanf(FILE(line,16:20),'%i',1);
  tmp = sscanf(FILE(line,21:25),'%i',1);
  temp = sscanf(FILE(line,27:46),'%s',1);
  temp = sscanf(FILE(line,48:67),'%s',1);

  %========
  line = 11;  % Ordinate (or ordinate numerator) Data Characteristics
  %========
  or_num_data_type = sscanf(FILE(line,1:10),'%i',1);
%  if or_num_data_type ~= 12,  %Acceleration
%    ermessage = 'expected acceleration data in the ordinate numerator';
%    disp(ermessage);
%  end
  tmp = sscanf(FILE(line,11:15),'%i',1);
  tmp = sscanf(FILE(line,16:20),'%i',1);
  tmp = sscanf(FILE(line,21:25),'%i',1);
  temp = sscanf(FILE(line,27:46),'%s',1);
  temp = sscanf(FILE(line,48:67),'%s',1);

  %========
  line = 12;  % Ordinate Denominator Data Characteristics
  %========
  or_den_data_type = sscanf(FILE(line,1:10),'%i',1);
%  if or_den_data_type ~= 13,  % Excitation force
%    ermessage = 'expected force data in the ordinate denominator';
%    disp(ermessage);
%  end
  tmp = sscanf(FILE(line,11:15),'%i',1);
  tmp = sscanf(FILE(line,16:20),'%i',1);
  tmp = sscanf(FILE(line,21:25),'%i',1);
  temp = sscanf(FILE(line,27:46),'%s',1);
  temp = sscanf(FILE(line,48:67),'%s',1);

  %========
  line = 13;  % Z-axis Data Characteristics
  %========
  tmp = sscanf(FILE(line,1:10),'%i',1);
  tmp = sscanf(FILE(line,11:15),'%i',1);
  tmp = sscanf(FILE(line,16:20),'%i',1);
  tmp = sscanf(FILE(line,21:25),'%i',1);
  temp = sscanf(FILE(line,27:46),'%s',1);
  temp = sscanf(FILE(line,48:67),'%s',1);
  
  %========
  line = 14;  % Data Values
  %========
  %first put all data values in a single row vector (add spaces between lines)
  file_data = FILE(line:num_lines-1,:);
  file_data = [file_data,setstr(32*ones(num_lines-line,1))];
  file_data = file_data';
  file_data = file_data(:)';
  if data_type == 2,
    data = sscanf(file_data,'%g',numpt);
  elseif data_type == 4,
    data = sscanf(file_data,'%g',numpt);
  elseif data_type == 5,
    newdata = sscanf(file_data,'%g',2*numpt);
    im = sqrt(-1);
    indx = 2*[1:numpt];
    data = newdata(indx-1) + im* newdata(indx);
  elseif data_type == 6,
    newdata = sscanf(file_data,'%g',2*numpt);
    im = sqrt(-1);
    indx = 2*[1:numpt];
    data = newdata(indx-1) + im* newdata(indx);
  else,
    ermessage = ['data type ',int2str(data_type),' is not supported'];
    disp(ermessage);
    erc = -1;
    return;
  end
%-------------------------------End of Measurement Data------------------------

elseif file_type_num == 82,
  ermessage = 'Display Sequence Data Set is Not Implemented, try READ_UFF';
  disp(ermessage);
  erc = -1;
  return;
else
  ermessage = 'unrecognized type of data set';
  disp(ermessage);
  erc = -1;
  return;
end
  
end_code = sscanf(FILE(num_lines,:),'%i');
if end_code ~= -1, 
  ermessage = 'eof error--data may or may not be good';
  disp(ermessage);
end
  
freq=[fmin:fdel:fmin+(numpt-1)*fdel]';

erc = 0;
  
