function [erc,ermessage] = write_frf_uff(filename,filetype,d1,d2,date,IDs, ...
	                             rptnum,rdir,eptnum,edir,fmin,fdel,data); 
%usage:  [erc,ermessage] = write_frf_uff(filename, 'FRF',d1,d2,date,IDs,  ...
%			             rptnum,rdir,eptnum,edir,fmin,fdel,data); 

%last modified 9-13-93 by Bryce Gardner

if filetype == 'FRF';
  [fid,ermesage] = fopen(filename,'w');
  fprintf(fid,'%6i%74s\n',-1,' ');
  fprintf(fid,'%6i%74s\n',58,' '); 
  if length(d1)<=80,
    fprintf(fid,'%80s\n',d1);
  else
    fprintf(fid,'%80s\n',d1(1:80));
  end
  if length(d2)<=80,
    fprintf(fid,'%80s\n',d2);
  else
    fprintf(fid,'%80s\n',d2(1:80));
  end
  if length(date)<=80,
    fprintf(fid,'%80s\n',date);
  else
    fprintf(fid,'%80s\n',date(1:80));
  end
  if length(IDs)<=80,
    fprintf(fid,'%80s\n',IDs);
  else
    fprintf(fid,'%80s\n',IDs(1:80));
  end
  fprintf(fid,'%4s%76s\n','NONE',' '); 
  fprintf(fid,'%5i%10i%5i%10i %10s%10i%4i %10s%10i%4i\n',4,0,0,0,'NONE',  ...
	  rptnum,rdir,'NONE',eptnum,edir); 
  numpt = length(data);
  if imag(data)==0,
%single precision
%    fprintf(fid,'%10i%10i%10i%13.5e%13.5e%13.5e           \n',2,numpt,1,fmin,fdel,0);
%double precision
    fprintf(fid,'%10i%10i%10i%13.5e%13.5e%13.5e           \n',4,numpt,1,fmin,fdel,0);
  else,
%single precision
%    fprintf(fid,'%10i%10i%10i%13.5e%13.5e%13.5e           \n',5,numpt,1,fmin,fdel,0);
%double precision
    fprintf(fid,'%10i%10i%10i%13.5e%13.5e%13.5e           \n',6,numpt,1,fmin,fdel,0);
  end
  fprintf(fid,'%10i%5i%5i%5i %20s %20s             \n',18,0,0,0,'NONE','NONE');
  fprintf(fid,'%10i%5i%5i%5i %20s %20s             \n',12,0,0,0,'NONE','NONE');
%                                                      ^--acceleration data
% others: 0=unknown,8=displacement,11=velocity,13=excitation force,15=pressure
  fprintf(fid,'%10i%5i%5i%5i %20s %20s             \n',13,0,0,0,'NONE','NONE');
%                                                      ^--excitation force data
% others: 0=unknown,8=displacement,11=velocity,12=acceleration,15=pressure
  fprintf(fid,'%10i%5i%5i%5i %20s %20s             \n',0,0,0,0,'NONE','NONE');
  if imag(data)==0,
%single precision
%    fprintf(fid,'%13.5e%13.5e%13.5e%13.5e%13.5e%13.5e  \n',data);
%double precision
    fprintf(fid,'%20.12e%20.12e%20.12e%20.12e\n',data);
    newdata=data;
  else,
    indxs=2*[1:length(data)];
    newdata(indxs)=imag(data);
    newdata(indxs-1)=real(data);
%single precision
%    fprintf(fid,'%13.5e%13.5e%13.5e%13.5e%13.5e%13.5e  \n',newdata);
%double precision
    fprintf(fid,'%20.12e%20.12e%20.12e%20.12e\n',newdata);
  end
  if rem(length(newdata),4)~=0,
    fprintf(fid,'\n');
  end
  fprintf(fid,'%6i%74s\n',-1,' ');
  fclose(fid);
  erc=1;
  return;
end

erc = 0;
ermessage = 'only the file type FRF is supported';
