function X=fac(x,aszero)
%FAC Takes vector x (levels of quantitative variable) to give indicator matrix
%USE: X=fac(x, aszero)
%   where  x  is the vector of levels of the variable;
%          aszero  is the variable to set as zero (default: the first).
%If aszero is 0, all columns are returned.
%By default, column one is omitted (ie aszero=1).

%Peter Dunn
%Last revision: 01/07/1996

if nargin==1, aszero=1; end;

if (size(x,1)~=1) & (size(x,2)~=1), X=x; return; end; %probably already fac-ed
x=floor(x(:));
cfmat=ones(size(x))*(min(x):max(x));
datmat=x * ones(1,max(x)-min(x)+1);
cols = (datmat==cfmat);
X=cols(:,any(cols));
if aszero~=0,
    X(:,aszero)=[];
end;
if length(X)==0,X=x;end;
