function [introws,facrows,otherrows,sortlist]=findvars(namexv)
%FINDVARS  Finds the location of different types of x-variables in glmlab

%Peter Dunn
%31/05/1996

nlist=prepare(namexv);
%Now find where the interactions are (finding '@') and where the
%factors are (finding 'fac(', not in '@' rows of course).
introws=[];facrows=[];otherrows=[];
for II=1:size(nlist,1),
   if findstr('@',nlist(II,:)),
      introws=[introws,II];
   else
      if findstr('fac(',nlist(II,:)),
         facrows=[facrows,II];
      else
         otherrows=[otherrows,II];
      end;
   end;
end;
[dummy,ll]=sort([otherrows,facrows,introws]);
[dummy,ll]=sort(ll);
sortlist=nlist(ll,:);
  
introws=[];facrows=[];otherrows=[];
for i=1:size(sortlist,1),
   if findstr('@',sortlist(i,:)),
      introws=[introws,i];
   else
      if findstr('fac(',sortlist(i,:)),
         facrows=[facrows,i];
      else
         otherrows=[otherrows,i];
      end;
   end;
end;
%Now order the interaction rows: 2nd order, 3rd order, etc...
numintvars=[];
for i=1:length(introws),
   numintvars(i)=length(findstr(...
                   sortlist(introws(i),:),'@'))+1;
end;
[dummy, intorder]=sort(numintvars);
introws=introws(intorder);
%introws now orders the interaction rows in increasing order
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Also should sort with quant.qual before qual.qual etc...%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
