%HELPINT  Help screen for interactions

%Peter Dunn
%20/08/1996

figure('Units','normal','Resize','off','NextPlot','new',...
       'Name','glmlab Interaction Explanations','NumberTitle','off');

uicontrol('Style','text','Units','normalized',...
 'Position',[0 .95 1 .05],...
 'String','INTERACTIONS USING glmlab',...
 'BackgroundColor','k','ForegroundColor','w');

uicontrol('Style','text','String',...
 'In glmlab, interactions are specified using the  @  character, which is',...
 'Units','normalized','Position',[0.05 .85 .90 .05],...
 'HorizontalAlignment','left',...
 'BackgroundColor','k','ForegroundColor','w');
uicontrol('Style','text','String',...
 'usually  shift-2  on the keyboard.  Interactions between variables are',...
 'Units','normalized','Position',[0.05 .80 .90 .05],...
 'HorizontalAlignment','left',...
 'BackgroundColor','k','ForegroundColor','w');
uicontrol('Style','text','String',...
 'specified by separating them using  @. ',...
 'Units','normalized','Position',[0.05 .75 .92 .05],...
 'HorizontalAlignment','left',...
 'BackgroundColor','k','ForegroundColor','w');

uicontrol('Style','text','String',...
 'For example, consider variables named  Weight, Height, Risk, Gender.',...
 'Units','normalized','Position',[0.05 .68 .90 .05],...
 'HorizontalAlignment','left',...
 'BackgroundColor','k','ForegroundColor','w');
uicontrol('Style','text','String',...
 'Type  Risk  in the Response area of the glmlab Main Screen.',...
 'Units','normalized','Position',[0.05 .63 .90 .05],...
 'HorizontalAlignment','left',...
 'BackgroundColor','k','ForegroundColor','w');
uicontrol('Style','text','String',...
 'In the Covariates area, type:    Weight@Height',...
 'Units','normalized','Position',[0.05 .58 .90 .05],...
 'HorizontalAlignment','left',...
 'BackgroundColor','k','ForegroundColor','w');
uicontrol('Style','text','String',...
 'This will specifiy the interaction between Height and Weight.',...
 'Units','normalized','Position',[0.05 .53 .90 .05],...
 'HorizontalAlignment','left',...
 'BackgroundColor','k','ForegroundColor','w');

uicontrol('Style','text','String',...
 'When qualitative variables are involved, use the  fac  command as',...
 'Units','normalized','Position',[0.05 .45 .90 .05],...
 'HorizontalAlignment','left',...
 'BackgroundColor','k','ForegroundColor','w');
uicontrol('Style','text','String',...
 'usual.  So, to specify the interaction between  Height  and  Gender, use',...
 'Units','normalized','Position',[0.05 .40 .90 .05],...
 'HorizontalAlignment','left',...
 'BackgroundColor','k','ForegroundColor','w');
uicontrol('Style','text','String',...
 'Height@fac(Gender)',...
 'Units','normalized','Position',[0.05 .35 .90 .05],...
 'BackgroundColor','k','ForegroundColor','w');

uicontrol('Style','text','String',...
 'In practice, the Covariate list will be longer than this; for example:',...
 'Units','normalized','Position',[0.05 .28 .90 .05],...
 'HorizontalAlignment','left',...
 'BackgroundColor','k','ForegroundColor','w');
uicontrol('Style','text','String',...
 'Weight, fac(Gender), fac(Gender)@Height, Weight',...
 'Units','normalized','Position',[0.05 .23 .90 .05],...
 'BackgroundColor','k','ForegroundColor','w');
uicontrol('Style','text','String',...
 '',...
 'Units','normalized','Position',[0.05 .18 .90 .05],...
 'HorizontalAlignment','left',...
 'BackgroundColor','k','ForegroundColor','w');

uicontrol('Style','pushbutton','String','Finished','Units','normalized',...
 'Position',[.4 .01 .2 .08],'Callback','delete(gcf);');
