function x=makefac(size,numlevels,atatime,aszero)
%MAKEFAC Generates a qualitative variable (factor).  Like %gl in GLIM
%USE: x=makefac(size,numlevels,blocks,aszero)
%      where  x  is the new qualitative variable (factor);
%             size  is the length of x;
%             numlevels  is the number of levels of  x;
%             blocks  is the number of times each level occurs in a row;
%             aszero  is the level that is set to zero.
%BY DEFAULT, aszero is set to zero (all columns are returned).
%Only the first three inputs are needed.
%
% x=makefac(a,b,c) is equivalent to the GLIM command  $calc x=%gl(b,c) for
% a preset variable length of  a.

%Peter Dunn
%Last revision: 16/08/1996

if nargin==0, 
   help makefac; return;
elseif nargin==3,
   aszero=0;
elseif nargin==4,
else
   bell;makeline(1);
   disp(' makefac  needs three (or four) parameters!  It works like this:');
   disp('    makefac(length_of_vector, number_of_levels, block_size)');
   makeline;return;
end;
if aszero>numlevels,
   bell;makeline(2);
   disp([' Cannot make level ',num2str(aszero),' the reference column.']);
   disp(' All columns will be returned.');
   makeline;
end;

for i=1:size,
   x(i)=rem( floor( (i-1)/atatime)  ,numlevels )+1;
end;
x=x(:);
