function [toler,maxits,illctol]=paramtrs(imaxits,itoler,iillctol)
%PARAMTRS The default parameters for  glmlab  that the user can safely alter
%USE:  [toler, maxits, illctol]=parametrs;
%   where  maxits  is the maximum number of iteration performed when using
%                  iteratively reweighted least squares with irls.m;
%          toler  is the tolerance for finding parameters.  Basically, this
%                 determines the accuracy of the estimates;
%          illctol  is the tolerance for declaring an ill-conditioned matrix.

%Peter Dunn
%Last revision: 04/09/1996

%BE VERY CAREFUL WHEN ALTERING THIS FILE.  
%IF ANYTHING GOES WRONG, RESTORE TO THE FOLLOWING DEFAULT VALUES:
% maxits=20;
% toler=0.00005;
% illctol=1e-10;
maxits=1000;
toler=0.0001;
illctol=1e-10;

if nargout==0,
   disp(' The current parameter settings are:')
   disp(['   Maximum number of iterations:             ',num2str(maxits)]);
   disp(['   Tolerance (accuracy of estimates):        ',num2str(toler)]);
   disp(['   Tolerance for detecting ill-conditioning: ',num2str(illctol)]);
end; 
