%VAROK   Check to see if the variables in the  glmlab  menu are OK.

%Peter Dunn
%22/07/1996

global NAMELIST INC_CONST STOPME UNFIT RECYCLE

STOPME=0;if isempty(UNFIT), UNFIT=0; end;
yvarcont;xvarcont;wvarcont;ovarcont;

if strcmp(get(findobj('tag','constant'),'checked'),'on'),
   INC_CONST=1;
else
   INC_CONST=0;
end;
  
SIZES=[];IS_THERE=[0 0 0 0];
%y-var
if size(YVAR,1)==1&(size(YVAR,2)~=1), %try transposing y
   NAMEYV=[NAMEYV(1:length(NAMEYV)-1),''']'];
   set(findobj('tag','HYV'),'String',NAMEYV);yvarcont;
end;
if ~isempty(NAMEYV), IS_THERE(1)=1;SIZES=[SIZES,length(YVAR)]; end;
%x-vars
if ~isempty(NAMEXV),
   if size(XVARS,1)~=size(YVAR,1),
      if size(XVARS,2)==size(YVAR,1), %try transposing x
         NAMEXV=[NAMEXV(1:length(NAMEXV)-1),''']'];
         set(findobj('tag','HXV'),'String',NAMEXV);xvarcont;
      end;
   end;
end;

if ~isempty(NAMEXV), IS_THERE(2)=1;SIZES=[SIZES,size(XVARS,1)]; end;
if ~isempty(NAMEOS), IS_THERE(3)=1;SIZES=[SIZES,length(OFFSET)]; end;
if ~isempty(NAMEPW), IS_THERE(4)=1;SIZES=[SIZES,length(WEIGHTS)]; end;
SIZES=SIZES-max(SIZES);
if ~sum(IS_THERE),
   bell;makeline(1);
   disp(' No variables have been assigned yet!  Please type in the name');
   disp(' of the y (reponse) variable and the X (covariate) variable(s).');
   makeline;STOPME=1;clear IS_THERE SIZES;return;
end;
if ~IS_THERE(1),
   bell;makeline(1);
   disp(' No response variable has been assigned, so there is');
   disp(' nothing to fit.  Please define a response (y) variable.');
   makeline;STOPME=1;clear IS_THERE SIZES;return;
end;
if any(SIZES~=0),
   STOPME=1;
   makeline(1);
   disp(' The sizes of all the variables should be the same!');
   disp(' Check the sizes of the variables:');
   if IS_THERE(1),
      disp(['   Length of the response (y):    ',num2str(length(YVAR))]);
   end;
   if IS_THERE(2),
      disp(['   Length of the covariates (x):  ',num2str(size(XVARS,1))]);
   end;
   if IS_THERE(3),
      disp(['   Length of the offset:          ',num2str(length(OFFSET))]);
   end;
   if IS_THERE(4),
      disp(['   Length of the prior weights:   ',num2str(length(WEIGHTS))]);
   end;
   makeline;bell;clear SIZES IS_THERE;
   return;
end;
clear SIZES IS_THERE;

disp(blanks(1)');
makeline(4);
if UNFIT, disp(' Because of errors, some variables have been changed.');end;
if ~isempty(NAMEYV), disp([' Name of Response Variable:      ',NAMEYV]);end;
if ~isempty(NAMEXV), disp([' List of Covariates:             ',NAMEXV]);end;
if INC_CONST, disp([blanks(5),'Fitting a Constant Term']);end;
if ~isempty(NAMEOS), disp([' Name of Offset Variable:        ',NAMEOS]);end;
if ~isempty(NAMEPW), disp([' Name of Prior Weights Variable: ',NAMEPW]);end;
if RECYCLE, disp(' Recycling fitted values as starting values.'); end;
makeline;

return;
