%XVARCONT   Control of the X-variable naming in glmlab

%12/06/1996
%Peter Dunn

OLDNAMEXV=NAMEXV;OLDXVARS=XVARS;NAMEXV=get(findobj('tag','HXV'),'String');

watchon;
if ~isempty(NAMEXV),
   NAMEXV=fixmeup(NAMEXV); %The xvar list as on screen all fixed up
   RUNNAMEXV=strrep(NAMEXV,'@',','); %The var list less interactions...
                                     %making sure all the vars are legit
   eval('XVARS=eval(RUNNAMEXV);','XVARS=['' '',lasterr];');
   if isstr(XVARS),
      opterr(4,XVARS); NAMEXV=OLDNAMEXV;XVARS=OLDXVARS;UNFIT=1;
      set(findobj('tag','HXV'),'String',OLDNAMEXV);
   else
      set(findobj('tag','HXV'),'String',NAMEXV);
      if ~isempty(str2num(RUNNAMEXV)),
         %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
         %THE x-VARIABLES ARE LISTED AS NUMBERS, NOT BY A MATLAB VAR NAME%
         %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
         NAMELIST=[];
         for THISI=1:size(str2num(NAMEXV),2),
            NAMELIST=str2mat(NAMELIST,['Var ',num2str(THISI)]);
         end;
           clear THISI
         if isempty(NAMELIST),
            bell;watchoff;STOPME=1;makeline(1);
            disp(' Sorry, but I couldn''t process the x-variables.');
            disp(' Please define variables, and use variable names in');
            disp(' the glmlab window.');makeline;return;
         else
            NAMELIST(1,:)=[];
         end;
      else 
         %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
         %USE THE NAMES OF THE VARIABLES, BUT REQUIRES A LOT OF FIDDLING%
         %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

         %First, obtain a list version of NAMEXV
         [INTROWS,FACROWS,OTHERROWS,SORTLIST]=findvars(NAMEXV);

         %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
         %Now we have:                                                  %
         % SORTLIST  is  the variables sorted in the order:             %
         %     OTHERROWS FACROW INTROWS                                 %
         %    (eg:  x1                                                  %
         %          fac(f2)  )                                          %
         %          fac(f2)@fac(f4)                                     %
         % INTROWS contains the row numbers with INTeractions, etc...   %
         %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

         %Fix up XVARS properly now:

         if strcmp(get(findobj('tag','constant'),'checked'),'on'),
            INC_CONST=1;
         else
            INC_CONST=0;
         end;
         EQUIVLIST='|'; %A list of parameters with equivalent representations
                        %in the variable list, separated by '|'
         if INC_CONST, EQUIVLIST=[EQUIVLIST,'CONST|']; end;
         EVALLIST=SORTLIST; %EVALLIST will be eval-able, line by line
         XVARS=[]; %Contains the X matrix
         NAMELIST=[]; %Contains the names to print in the output
            %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
            %ROWS containing only QUANTITATIVE variables%
            %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
         for II=OTHERROWS,
            XVARS=[XVARS,eval(EVALLIST(II,:))];
            NAMELIST=str2mat(NAMELIST,SORTLIST(II,:));
            EQUIVLIST=[EQUIVLIST,deblank(SORTLIST(II,:)),'|'];
         end;
            %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
            %Now ROWS containing only QUALITATIVE variables%
            %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
         for II=FACROWS,
            [EQUIVLIST,EVALLIST]=facfidle(1,II,EQUIVLIST,SORTLIST,EVALLIST);
            ADDX=eval(EVALLIST(II,:));
            [NAMELIST,XVARS]=facfidle(2,II,ADDX,SORTLIST,...
                                      XVARS,EVALLIST,NAMELIST);
         end;
         EQUIVLIST=strrep(EQUIVLIST,',0)',')');
         TSORTLIST=[SORTLIST(OTHERROWS,:);SORTLIST(FACROWS,:)];
            clear OTHERROWS FACROWS
         for II=INTROWS,
            [INTTERM,ALLVARS,THISINTLIST,QUANTINTLIST,FACINTLIST]=...
               preint(SORTLIST,II);
            eval(['[INTX,INDVEC]=interact(',INTTERM,');']);
            %Now delete the appropriate rows from INDVEC and cols
            %from  INTX  using  postint
             [NAMELIST,INTX,XVARS]=...
                postint(ALLVARS,THISINTLIST,QUANTINTLIST,FACINTLIST,...
                         TSORTLIST,EQUIVLIST,SORTLIST,INDVEC,INTX,...
                         NAMELIST,XVARS,II                                );
         end;
         NAMELIST(1,:)=[];
      end;
   end;
end;

NEWNAMELIST=[];
for II=1:size(NAMELIST,1),
   NEWROW=strrep(NAMELIST(II,:),'fac(',''); NEWROW=strrep(NEWROW,')(','(');
   NEWNAMELIST=str2mat(NEWNAMELIST,NEWROW);
end;
if ~isempty(NEWNAMELIST), NAMELIST=NEWNAMELIST;NAMELIST(1,:)=[]; end;

clear OLDNAMEXV OLDXVARS II QUANTVARS QUANTTERMS FACINTLIST FACTERMS INTROWS 
clear ALLVARS NEWROW SORTLIST EVALLIST EQUIVLIST NEWNAMELIST INTTERM 
clear RUNNAMEXV QUANTINTLIST INTX THISINTLIST TSORTLIST THISI INDVEC ADDX
watchoff;

return;
