function answ=dstyle(what,input1,input2,input3,input4)
%DSTYLE A template for user-defined distributions in glmlab.
%USE:  answ=dstyle(what,input1,input2,input3,input4)
%   where  input1 ... input4 are inputs depending on what is wanted (see below);
%          what  returns what is asked:
%             what== 'varfn' returns the variance function;
%             what== 'scdev' returns the deviance/scaled deviance;
%             what== 'disppar'  returns the dispersion parameter.
%          answ  is the answer asked for.
%Called by  irls, glmfit.

%Copyright 1996 Peter Dunn
%11/11/1996

%   input3 is only useful with the binomial distn, but always contains  m.
%   input4 always contains the weights
%   for varfn,   input1=m,               input2=mu 
%   for scdev,   input1=y,               input2=mu
%   for disppar, input1=scaled deviance, input2=residual df

%Because of the way glmlab access this file, some things may seem strange,
%but don't monkey with things too much or things will go all crooked.
%REMEMBER TO CHANGE THE FUNCTION NAME IN LINES 1 AND 2, AND DON'T
%OVERWRITE THIS FILE!  THAT WOULD BE SILLY.

global SCALEPAR YVAR FITVALS M WEIGHTS DEGREESOFF; 

%Rename variables to something meaningful
m=input3;weights=input4;
if strcmp(what,'varfn')|strcmp(what,'scdev'),
   mu=input2;y=input1;
elseif strcmp(what,'disppar'),
   scdev=input1;resdf=input2;
end;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%EVERYTHING ABOVE THIS LINE MUST BE INCLUDED%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%BELOW THIS LINE ARE THE MATLAB INSTRUCTION FOR FINDING%%%
%%%THE VARIANCE FUNCTION (varfn), AND THE SCALED DEVIANCE%%%
%%%YOU MAY NEED TO INCLUDE  SOME FANCY  FIDDLING TO ALLOW%%%
%%%FOR SOME ODD SITUATIONS (ie when taking logs to ensure%%%
%%%that you aren't taking the logarithm of a non-positive%%%
%%%quantity).  REMEMBER THE CODE NEEDS TO BE VECTORISED!!%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%Calculate
if strcmp(what,'varfn'),
   %%%In here, you need lines to find the variance function
   %%%from  mu  and  y.
   %%%The section should return the variance function as  answ
elseif strcmp(what,'scdev');
   %%%In here, you need lines to find the scaled deviance
   %%%from  mu  and  y.
   %%%The section should return the scaled deviance as  answ
else %disppar
   %%%DON'T MONKEY WITH THIS BIT EITHER...
   if ~isstr(SCALEPAR),
      answ=SCALEPAR;
   else
      answ=scdev/resdf;
   end;
end;
