%HELPINT  Help screen for interactions

%Copyright 1996 Peter Dunn
%11/11/1996

figure('Units','normal','Resize','off','NextPlot','new',...
       'Name','glmlab Interaction Explanations','NumberTitle','off');

set(gcf,'DefaultUIControlHorizontalAlignment','left',...
        'DefaultUIControlUnits','normalized',...
        'DefaultUIControlStyle','text');

uicontrol('Position',[0 .95 1 .05],'HorizontalAlignment','center',...
 'String','INTERACTIONS USING glmlab',...
 'BackgroundColor','k','ForegroundColor','w');

uicontrol('String',...
 'In glmlab, interactions are specified using the  @  character, which is',...
 'Position',[0.05 .85 .90 .05],'BackgroundColor','k','ForegroundColor','w');
uicontrol('String',...
 'usually  shift-2  on the keyboard.  Interactions between variables are',...
 'Position',[0.05 .80 .90 .05],'BackgroundColor','k','ForegroundColor','w');
uicontrol('String','specified by separating them using  @. ',...
 'Position',[0.05 .75 .92 .05],'BackgroundColor','k','ForegroundColor','w');

uicontrol('String',...
 'For example, consider variables named  Weight, Height, Risk, Gender.',...
 'Position',[0.05 .68 .90 .05],'BackgroundColor','k','ForegroundColor','w');
uicontrol('String',...
 'Type  Risk  in the Response area of the glmlab Main Screen.',...
 'Position',[0.05 .63 .90 .05],'BackgroundColor','k','ForegroundColor','w');
uicontrol('String','In the Covariates area, type:    Weight@Height',...
 'Position',[0.05 .58 .90 .05],'BackgroundColor','k','ForegroundColor','w');
uicontrol('String',...
 'This will specifiy the interaction between Height and Weight.',...
 'Position',[0.05 .53 .90 .05],'BackgroundColor','k','ForegroundColor','w');

uicontrol('String',...
 'When qualitative variables are involved, use the  fac  command as',...
 'Position',[0.05 .45 .90 .05],'BackgroundColor','k','ForegroundColor','w');
uicontrol('String',...
 'usual.  So, to specify the interaction between  Height  and  Gender, use',...
 'Position',[0.05 .40 .90 .05],'BackgroundColor','k','ForegroundColor','w');
uicontrol('String','Height@fac(Gender)',...
 'Position',[0.05 .35 .90 .05],'HorizontalAlignment','center',...
 'BackgroundColor','k','ForegroundColor','w');

uicontrol('String',...
 'In practice, the Covariate list will be longer than this; for example:',...
 'Position',[0.05 .28 .90 .05],'BackgroundColor','k','ForegroundColor','w');
uicontrol('String',...
 'Weight, fac(Gender), fac(Gender)@Height, Weight',...
 'Position',[0.05 .23 .90 .05],'HorizontalAlignment','center',...
 'BackgroundColor','k','ForegroundColor','w');

uicontrol('Style','pushbutton','String','Finished',...
 'HorizontalAlignment','center',...
 'Position',[.4 .01 .2 .08],'Callback','delete(gcf);');
