%HELPOPT  Help  screen for glmlab options in the menu

%Copyright 1996 Peter Dunn
%11/11/1996

figure('Units','normal','Resize','off','NextPlot','new',...
       'Name','glmlab Menu Explanations','NumberTitle','off');

set(gcf,'DefaultUIControlHorizontalAlignment','left',...
        'DefaultUIControlUnits','normalized',...
        'DefaultUIControlStyle','text');

uicontrol('Position',[0 .95 1 .05],'String',...
'To display options, click on the section.  Current settings are indicated.',...
 'BackgroundColor','k','ForegroundColor','w');

uicontrol('String','File:','Position',[0 .88 .25 .05],...
 'BackgroundColor','k','ForegroundColor','w');
uicontrol('Position',[.28 .88 .69 .05],...
 'String','LOAD data; CLOSE glmlab windows; QUIT glmlab.',...
 'BackgroundColor','k','ForegroundColor','w');

uicontrol('String','Distribution:','Position',[0 .80 .25 .05],...
 'BackgroundColor','k','ForegroundColor','w');
uicontrol('Position',[.28 .80 .69 .05],...
 'String','Click for choices of available error distributions.',...
 'BackgroundColor','k','ForegroundColor','w');

uicontrol('String','Link:','Position',[0 .72 .25 .05],...
 'BackgroundColor','k','ForegroundColor','w');
uicontrol('Position',[.28 .72 .69 .05],'String',...
 'Click for choices of available link functions.',...
 'BackgroundColor','k','ForegroundColor','w');

uicontrol('String','Scale Parameter:','Position',[0 .64 .25 .05],...
 'BackgroundColor','k','ForegroundColor','w');
uicontrol('Position',[.28 .64 .69 .05],...
 'String','Either the mean deviance or a fixed value.',...
 'BackgroundColor','k','ForegroundColor','w');
uicontrol('Position',[.28 .59 .69 .05],...
 'String','To enter a particular value, select ''Fixed Value'',',...
 'BackgroundColor','k','ForegroundColor','w');
uicontrol('Position',[.28 .54 .69 .05],...
 'String','and you will be prompted.',...
 'BackgroundColor','k','ForegroundColor','w');

uicontrol('String','Residuals:','Position',[0 .46 525 .05],...
 'BackgroundColor','k','ForegroundColor','w');
uicontrol('Position',[.28 .46 .69 .05],...
 'String','Click for choices of available error types.',...
 'BackgroundColor','k','ForegroundColor','w');

uicontrol('String','Options:','Position',[0 .38 .25 .05],...
 'BackgroundColor','k','ForegroundColor','w');
uicontrol('Position',[.28 .38 .69 .05],...
 'String','Reset the options to their DEFAULTS; declare a',...
 'BackgroundColor','k','ForegroundColor','w');
uicontrol('Position',[.28 .33 .69 .05],...
 'String','NEW MODEL; include a CONSTANT term in the fit;',...
 'BackgroundColor','k','ForegroundColor','w');
uicontrol('Position',[.28 .28 .69 .05],...
 'String','alter output DISPLAY; RECYCLE fitted values as',...
 'BackgroundColor','k','ForegroundColor','w');
uicontrol('Position',[.28 .23 .69 .05],...
 'String','starting values in the next iteration of the fit.',...
 'BackgroundColor','k','ForegroundColor','w');

uicontrol('String','Help:','Position',[0 .15 .25 .05],...
 'BackgroundColor','k','ForegroundColor','w');
uicontrol('Position',[.28 .15 .69 .05],...
 'String','Get some basic HELP (didn''t you just do this?).',...
 'BackgroundColor','k','ForegroundColor','w');

uicontrol('String','Fit Model:','Position',[0 .07 .25 .05],...
 'BackgroundColor','k','ForegroundColor','w');
uicontrol('Position',[.28 .08 .69 .05],...
 'String','Fits the model as specified.',...
 'BackgroundColor','k','ForegroundColor','w');

uicontrol('Style','pushbutton','String','Finished',...
 'Position',[.4 .01 .2 .06],'HorizontalAlignment','center',...
 'Callback','delete(gcf);');
