%HELPVARS  Help screen for glmlab

%Copyright 1996 Peter Dunn
%11/11/1996

figure('Units','normal','Resize','off','NextPlot','new',...
       'Name','glmlab Explanations','NumberTitle','off');
axis('off');

set(gcf,'DefaultUIControlHorizontalAlignment','left',...
        'DefaultUIControlUnits','normalized',...
        'DefaultUIControlStyle','text');

uicontrol('Position',[0 .95 1 .05],'String',...
 ['Variable names used must refer to variables already ',...
  'defined in the workspace.'],...
 'BackgroundColor','k','ForegroundColor','w');
uicontrol('Position',[0 .90 1 .05],'String',...
 'To be safe, don''t use variable whose names are all CAPITAL letters.',...
 'BackgroundColor','k','ForegroundColor','w');

uicontrol('String','Response (y):','Position',[0 .82 .25 .05],...
 'BackgroundColor','k','ForegroundColor','w');
uicontrol('Position',[.28 .82 .69 .05],...
 'String','Type the name of the response (y) variable.  For the',...
 'BackgroundColor','k','ForegroundColor','w');
uicontrol('Position',[.28 .77 .69 .05],...
 'String','binomial case, use two columns: [counts  sample size]',...
 'BackgroundColor','k','ForegroundColor','w');

uicontrol('String','Covarites (X):',...
 'Position',[0 .69 .25 .05],'BackgroundColor','k','ForegroundColor','w');
uicontrol('Position',[.28 .69 .69 .05],'String',...
 'Enter the list of covariates (X values).  The inclusion of',...
 'BackgroundColor','k','ForegroundColor','w');
uicontrol('Position',[.28 .64 .69 .05],'String',...
 'the Constant Term is controlled in the OPTIONS menu.',...
 'BackgroundColor','k','ForegroundColor','w');
uicontrol('Position',[.28 .59 .69 .05],'String',...
 'Interactions are specified with the  @  character.',...
 'BackgroundColor','k','ForegroundColor','w');

uicontrol('String','Prior Weights:',...
 'Position',[0 .53 .25 .05],'BackgroundColor','k','ForegroundColor','w');
uicontrol('Position',[.28 .53 .69 .05],...
 'String','Enter the name of the prior weights variable.',...
 'BackgroundColor','k','ForegroundColor','w');

uicontrol('String','Offset Variable',...
 'Position',[0 .45 .25 .05],'BackgroundColor','k','ForegroundColor','w');
uicontrol('Position',[.28 .45 .69 .05],...
 'String','Enter the name of the offset variable.',...
 'BackgroundColor','k','ForegroundColor','w');

uicontrol('String','Fit Model','Position',[0 .37 .25 .05],...
 'BackgroundColor','k','ForegroundColor','w');
uicontrol('Position',[.28 .37 .69 .05],...
 'String','Fits the model as currently specified.',...
 'BackgroundColor','k','ForegroundColor','w');

uicontrol('String','Residual Plots...',...
 'Position',[0 .29 .25 .05],'BackgroundColor','k','ForegroundColor','w');
uicontrol('Position',[.28 .29 .69 .05],...
 'String','The menu screen for plots about residuals.',...
 'BackgroundColor','k','ForegroundColor','w');

uicontrol('String','A New Model can be declared in the OPTIONS menu.',...
 'Position',[0 .21 1 .05],'BackgroundColor','k','ForegroundColor','w');

uicontrol('Style','pushbutton','String','Finished',...
 'Position',[.4 .02 .2 .08],'HorizontalAlignment','center',...
 'Callback','delete(gcf);');
