function x=makefac(size,numlevels,atatime)
%MAKEFAC Generates a qualitative variable (factor).  Like %gl in GLIM
%USE: x=makefac(size,numlevels,blocks)
%      where  x  is the new qualitative variable (factor);
%             size  is the length of x;
%             numlevels  is the number of levels of  x;
%             blocks  is the number of times each level occurs in a row;
%All three inputs are needed.
%
% x=makefac(a,b,c) is equivalent to the GLIM command  $calc x=%gl(b,c) for
% a preset variable length of  a.

%Copyright 1996 Peter Dunn
%11/11/1996

if nargin==0, 
   help makefac; return;
elseif nargin~=3,
   bell;makeline(1);
   disp(' makefac  needs three parameters!  It works like this:');
   disp('    makefac(length_of_vector, number_of_levels, block_size)');
   makeline;return;
end;
if ~all([size>0, atatime>0, numlevels>0])
   bell;makeline(1);
   disp(' All inpouts need to be positive.')
   makeline;return;
end;
for i=1:size,
   x(i)=rem( floor( (i-1)/atatime)  ,numlevels )+1;
end;
x=x(:);
