function menuwork(num,value)
%MENUWORK  Does the hard slog for option setting within  glmlab
%USE:    menuwork(num,value);
%   where  num is the section to use;
%          value  is the value of the parameter.

%Copyright 1996 Peter Dunn
%11/11/1996

global ERRDISFUNCTION LINKFUNCTION RESTYPE FORMAT SCALEPAR;
global NAMEOS NAMEPW FLAG STR LF RECYCLE DETAILSFILE;

watchon;
lfname=which('llist');
dfname=which('dlist');
l1=linklist(lfname);
d1=distlist(dfname);

if num==1, %dist
   ERRDISFUNCTION=value;
   set(findobj(findobj('tag','distm'),'checked','on'),'checked','off');
   set(findobj(findobj('tag','linkm'),'checked','on'),'checked','off');
   set(findobj(findobj('tag','linkm'),'Enable','off'),'enable','on');
   set(findobj('tag',value),'checked','on');
   set(findobj('tag','quantile'),'Enable','on');
   set(findobj(findobj('tag','scalem'),'checked','on'),'checked','off');
   if strcmp(value,'poisson'),
      set(findobj('tag','log'),'checked','on');
      set(findobj('tag','logit'),'Enable','off');
      set(findobj('tag','probit'),'Enable','off');
      set(findobj('tag','complog'),'Enable','off');
      set(findobj('tag','val'),'checked','on','Label','Fixed Value: 1');
      LINKFUNCTION='log'; SCALEPAR=1;
   elseif strcmp(value,'binoml'),
      set(findobj('tag','logit'),'checked','on');
      set(findobj('tag','val'),'checked','on','Label','Fixed Value: 1');
      LINKFUNCTION='logit'; SCALEPAR=1;
   elseif strcmp(value,'gamma'),
      set(findobj('tag','logit'),'Enable','off');
      set(findobj('tag','probit'),'Enable','off');
      set(findobj('tag','complog'),'Enable','off');
      set(findobj('tag','recip'),'checked','on');
      set(findobj('tag','md'),'checked','on');
      LINKFUNCTION='recip'; SCALEPAR='md';
   elseif strcmp(value,'inv_gsn'),
      set(findobj('tag','logit'),'Enable','off');
      set(findobj('tag','probit'),'Enable','off');
      set(findobj('tag','complog'),'Enable','off');
      set(findobj('tag','power'),'checked','on');
      set(findobj('tag','md'),'checked','on');
      LINKFUNCTION=-2; SCALEPAR='md';
      set(findobj('tag','power'),'Label','power: -2','Checked','on');
   else
      if ~strcmp(value,'normal')
         set(findobj(findobj('tag','linkm'),'checked','on'),'checked','off');
         if strcmp(get(findobj('tag','quantile'),'checked'),'on'),
            set(findobj('tag','quantile'),'checked','off');
            set(findobj('tag','pearson'),'checked','on');
         end;
         set(findobj('tag','quantile'),'enable','off');
         RESTYPE='Pearson';
      end;
      set(findobj('tag','logit'),'Enable','off');
      set(findobj('tag','probit'),'Enable','off');
      set(findobj('tag','complog'),'Enable','off');
      set(findobj('tag','id'),'checked','on');
      set(findobj('tag','md'),'checked','on');
      LINKFUNCTION='id'; SCALEPAR='md';
   end;
   FID=fopen(DETAILSFILE,'a');
   fprintf(FID,' Changed to: %s, %s\n',ERRDISFUNCTION,LINKFUNCTION);
   fclose(FID);
   disp([' Distribution changed to ',ERRDISFUNCTION]);
   disp([' Defaults for the ',ERRDISFUNCTION,' distribution:']);
   if isstr(LINKFUNCTION),
      disp(['  - Link changed to ',LINKFUNCTION]);
   else
      disp(['  - Link changed to Power of ',num2str(LINKFUNCTION)]);
   end;
   if isstr(SCALEPAR),
      disp('  - Scale Parameter changed to Mean Deviance');
   else
      disp(['  - Scale Parameter changed to ',num2str(SCALEPAR)]);
   end;
   watchoff;
elseif num==2, %link
   set(findobj(findobj('tag','linkm'),'checked','on'),'checked','off');
   set(findobj('tag',value),'checked','on');
   LINKFUNCTION=value;
   if strcmp(LINKFUNCTION,'power'),
      figure('Name','Power Link Function','Position',[300 360 350  80]);
      set(findobj('tag','power'),'checked','off');
      uicontrol('tag','HPowerT','Style','Text',...
                'String','Value of Power for Link Function: ',...
                'ForegroundColor','w','BackgroundColor','k',...
                'Position',[15 10 220 50 ]);
      uicontrol('tag','HPowerE','Style','Edit','Callback','menuwork(29);',...
                'Position',[240 10 100 50 ]);
   end;
   FID=fopen(DETAILSFILE,'a');
   fprintf(FID,' Changed to: %s, %s\n',ERRDISFUNCTION,LINKFUNCTION);
   fclose(FID);
   if ~strcmp(LINKFUNCTION,'power'),
      disp([' Link changed to ',LINKFUNCTION]);
   end;
   watchoff;
elseif num==3, %resids
   set(findobj(findobj('tag','residm'),'checked','on'),'checked','off');
   if value==1,
      set(findobj('tag','pearson'),'checked','on');
      RESTYPE='Pearson';
   elseif value==2,
      set(findobj('tag','deviance'),'checked','on');
      RESTYPE='Deviance';
   else
      set(findobj('tag','quantile'),'checked','on');
      RESTYPE='Quantile';
   end;
   disp([' Residual Type changed to ',RESTYPE]);
   watchoff;
elseif num==4, %scale
   set(findobj(findobj('tag','scalem'),'checked','on'),'checked','off');
   if value==1, %md
      set(findobj('tag','md'),'checked','on');
      SCALEPAR='md';
   else
      set(findobj('tag','val'),'checked','on');
      figure('Name','Scale Parameter','Position',[300 360 350  80]);
      uicontrol('tag','HScaleT','Style','Text',...
                'String','Value of Scale Parameter: ',...
                'ForegroundColor','w','BackgroundColor','k',...
                'Position',[15 10 220 50 ]);
      uicontrol('tag','HScaleE','Style','Edit','Callback','menuwork(19);',...
                'Position',[240 10 100 50]);
      if ~isstr(SCALEPAR)&~isempty(SCALEPAR), 
         set(findobj('tag','HScaleE'),'String',num2str(SCALEPAR));
      end;
   end;
   if value==1,
      disp(' Scale Parameter changed to Mean Deviance');
   end;
   watchoff;
elseif num==7, %restore defaults
   set(findobj(findobj('tag','distm'),'checked','on'),'checked','off');
   set(findobj(findobj('tag','linkm'),'checked','on'),'checked','off');
   set(findobj(findobj('tag','residm'),'checked','on'),'checked','off');
   set(findobj(findobj('tag','scalem'),'checked','on'),'checked','off');
   set(findobj('tag','normal'),'checked','on');
   set(findobj('tag','id'),'checked','on');
   set(findobj('tag','md'),'checked','on');
   set(findobj('tag','quantile'),'enable','on');
   set(findobj('tag','pearson'),'checked','on');
   set(findobj('tag','logit'),'enable','off');
   set(findobj('tag','probit'),'enable','off');
   set(findobj('tag','complog'),'enable','off');
   set(findobj('tag','val'),'Label','Fixed Value: 1');
   set(findobj('tag','power'),'Label','power');
   set(findobj('tag','fitinf'),'checked','off');
   set(findobj('tag','pvals'),'checked','on');
   set(findobj('tag','recycle'),'checked','off');
   set(findobj('tag','constant'),'checked','on');
   ERRDISFUNCTION='normal'; LINKFUNCTION='id';
   SCALEPAR='md'; RESTYPE='Pearson';
   FORMAT=[0 1]; RECYCLE=0;INC_CONST=1;
   disp(' Defaults Restored:');
   disp('  - Distribution set to normal');disp('  - Link set to id');
   disp('  - Scale parameter set to mean deviance'); 
   disp('  - Residual Type set to Pearson');
   disp('  - Constant included in the model');
   watchoff;
elseif num==19, %set scale par
   SCALEPAR=get(findobj('tag','HScaleE'),'String');
   if isempty(str2num(SCALEPAR)),
      set(findobj('tag','HScaleE'),'String','');return;
   end;
   if str2num(SCALEPAR)<=0,
      set(findobj('tag','HScaleE'),'String','');return;
   end;
   SCALEPAR=str2num(SCALEPAR);delete(gcf);
   set(findobj('tag','val'),'Label',['Fixed Value: ',num2str(SCALEPAR)]);
   disp([' Scale Parameter changed to ',num2str(SCALEPAR)]);
   watchoff;
   return;
elseif num==29, %set power
   LINKFUNCTION=get(findobj('tag','HPowerE'),'String');
   if isempty(LINKFUNCTION), LINKFUNCTION=1;delete(gcf);return;;end;
   if isempty(str2num(LINKFUNCTION)),
      set(findobj('tag','HPowerE'),'String',''); return;
   end;
   if str2num(LINKFUNCTION)==0,
      set(findobj('tag','HPowerE'),'String','');return;
   end;
   LINKFUNCTION=str2num(LINKFUNCTION);delete(gcf);
   if LINKFUNCTION==1, 
      set(findobj('tag','id'),'Checked','on');
      LINKFUNCTION='id';
   elseif LINKFUNCTION==0.5,
      set(findobj('tag','sqroot'),'Checked','on');
      LINKFUNCTION='sqroot';
   elseif LINKFUNCTION==-1,
      set(findobj('tag','recip'),'Checked','on');
      LINKFUNCTION='recip';
   else
      set(findobj('tag','power'),'Label',['power: ',num2str(LINKFUNCTION)],...
          'Checked','on');
   end;
   if isstr(LINKFUNCTION),
      disp([' Link changed to ',LINKFUNCTION]);
   else
      disp([' Link changed to power of ',num2str(LINKFUNCTION)]);
   end;
   watchoff;
   return;
elseif num==40, %Setting options
   if value==1,
      if strcmp(get(findobj('tag','fitinf'),'checked'),'on'),
         set(findobj('tag','fitinf'),'checked','off');
         FORMAT(1)=0;
      else
         set(findobj('tag','fitinf'),'checked','on');
         FORMAT(1)=1;
      end;
   elseif value==2,
      if strcmp(get(findobj('tag','pvals'),'checked'),'on'),
         set(findobj('tag','pvals'),'checked','off');
         FORMAT(2)=0;
      else
         set(findobj('tag','pvals'),'checked','on');
         FORMAT(2)=1;
      end;
   elseif value==3,
      if strcmp(get(findobj('tag','recycle'),'checked'),'on'),
         set(findobj('tag','recycle'),'checked','off');
         RECYCLE=0;
      else
         set(findobj('tag','recycle'),'checked','on');
         RECYCLE=1;
      end;
   end;
   disp(' Options altered');
   watchoff;
elseif num==50, %Quit  glmlab and Loose Settings
   watchoff;delete(findobj('Name','glmlab Main Window'));
   clear FITVALS STOPME UNFIT
   clear BL D D1 D2 D3 I L1 L2 L3 LB NOBINLIST SLIST V PW;
   clear NOBINLIST NOBINLIST2 BINLIST2 BINLIST;
   clear global NAMEYV NAMEXV NAMEPW NAMEOS YVAR XVARS WEIGHTS OFFSET 
   clear global INC_CONST DETAILSFILE RESTYPE ERRDISFUNCTION SCALEPAR 
   clear global LINKFUNCTION FORMAT RECYCLE NAMELIST STOPME UNFIT FLAG
elseif num==60, %Close Window but Keep Settings
   watchoff;set(findobj('Name','glmlab Main Window'),'Visible','off');
   clear NAMELIST STOPME FLAG FITVALS UNFIT;
   clear YVAR XVARS NAMEXV NAMEYV OFFSET WEIGHTS NAMEOS NAMEPW;
   clear BL D D1 D2 D3 I L1 L2 L3 LB NOBINLIST SLIST V PW;
   clear NOBINLIST NOBINLIST2 BINLIST2 BINLIST;
elseif num==70, %CONSTANT toggle
   if strcmp(get(findobj('tag','constant'),'checked'),'on'),
      set(findobj('tag','constant'),'checked','off');
      INC_CONST=0;
   else
      set(findobj('tag','constant'),'checked','on');
      INC_CONST=1;
   end;
   if INC_CONST,
      disp(' Constant Term now included in the model');
   else
      disp(' Constant Term now omitted from the model');
   end;
   watchoff;
end;

if num==6,
   disp(' ');makeline('OPTIONS ;-)','-');
   disp([' Distribution:    ',upper(ERRDISFUNCTION)]);
   if isstr(LINKFUNCTION),
      disp([' Link Function:   ',upper(LINKFUNCTION)]);
   else
      disp([' Link Function:   TO THE POWER ',num2str(LINKFUNCTION)]);
   end;
   if isstr(SCALEPAR),
      disp([' Scale Parameter: MEAN DEVIANCE']);
   else
      disp([' Scale Parameter: ',num2str(SCALEPAR)]);
   end;
   disp([' Residual Type:   ',upper(RESTYPE)]);
   disp(' Display Format:  RESIDUAL DEVIANCE');
   if FORMAT(1),
      disp('                  FITTING INFORMATION');
   end;
   if FORMAT(2),
      disp('                  PARAMETER ESTIMATES');
   end;
   if RECYCLE,
      disp(' Recycling Fitted Values as Starting Values');
   end;
   makeline('','-');
end;
if num==1,
   clear global STR LF;
   if strcmp(ERRDISFUNCTION,'binoml');
      makeline(4);
      disp(' For binomial responses, remember to include two columns');
      disp(' as the response:  the first column contains the observed');
      disp(' number of successes and the second contains the sample sizes.');
      makeline;
   end;
   watchoff;
end;

return;
