%XVARCONT   Control of the X-variable naming in glmlab

%11/11/1996
%Copyright 1996 Peter Dunn

OLDNAMEXV=NAMEXV;OLDXVARS=XVARS;NAMEXV=get(findobj('tag','HXV'),'String');

watchon; fprintf('.');
if ~isempty(NAMEXV),
   NAMEXV=fixmeup(NAMEXV); %The xvar list as on screen all fixed up
   RUNNAMEXV=strrep(NAMEXV,'@',','); %The var list less interactions...
                                     %making sure all the vars are legit
   eval('XVARS=eval(RUNNAMEXV);','XVARS=['' '',lasterr];');
   if isstr(XVARS),
      opterr(4,XVARS); NAMEXV=OLDNAMEXV;XVARS=OLDXVARS;UNFIT=1;
      set(findobj('tag','HXV'),'String',OLDNAMEXV);
   else
      set(findobj('tag','HXV'),'String',NAMEXV);
      if ~isempty(str2num(RUNNAMEXV)),
         %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
         %THE x-VARIABLES ARE LISTED AS NUMBERS, NOT BY A MATLAB VAR NAME%
         %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
         NAMELIST=[];
         for THISI=1:size(str2num(NAMEXV),2),
            NAMELIST=str2mat(NAMELIST,['Var ',num2str(THISI)]);
         end;
         clear THISI
         if isempty(NAMELIST),
            bell;watchoff;STOPME=1;makeline(1);
            disp(' Sorry, but I couldn''t process the x-variables.');
            disp(' Please define variables, and use variable names in');
            disp(' the glmlab window.');makeline;return;
         else
            NAMELIST(1,:)=[];
         end;
      else 
         %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
         %USE THE NAMES OF THE VARIABLES, BUT REQUIRES A LOT OF FIDDLING%
         %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

         %First, obtain a list version of NAMEXV
         [INTROWS,FACROWS,OTHERROWS,SORTLIST]=findvars(NAMEXV);

         %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
         %Now we have:                                                  %
         % SORTLIST  is  the variables sorted in the order:             %
         %     OTHERROWS FACROW INTROWS                                 %
         %    (eg:  x1                                                  %
         %          fac(f2)  )                                          %
         %          fac(f2)@fac(f4)                                     %
         % INTROWS contains the row numbers with INTeractions, etc...   %
         %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

         %Fix up XVARS properly now:
         if strcmp(get(findobj('tag','constant'),'checked'),'on'),
            INC_CONST=1;CONEQUIV=1;
                %CONEQUIV=1  if the constant term (or equivalent) is present
         else
            INC_CONST=0;CONEQUIV=0;
         end;
         [DUMMY,INTORDER]=findmat(SORTLIST,'@');clear DUMMY
         EVALLIST=SORTLIST; %EVALLIST will soon be eval-able, line by line
         XVARS=[]; %Contains the X matrix
         NAMELIST=[]; %Contains the names to print in the output
            %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
            %ROWS containing only QUANTITATIVE variables%
            %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
         for II=OTHERROWS,
            XVARS=[XVARS,eval(EVALLIST(II,:))];
            NAMELIST=str2mat(NAMELIST,SORTLIST(II,:));
         end;
            %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
            %Now ROWS containing only QUALITATIVE variables%
            %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
         for II=FACROWS,
            [CONEQUIV,EVALLIST]=facfidle(1,II,CONEQUIV,SORTLIST,EVALLIST);
            ADDX=eval(EVALLIST(II,:));
            [NAMELIST,XVARS]=facfidle(2,II,ADDX,SORTLIST,...
                                      XVARS,EVALLIST,NAMELIST);
         end;
         clear OTHERROWS FACROWS
         SEPLIST='|'; %SEPLIST is the var list, vars separated by  |
         for I=1:size(SORTLIST,1),
            SEPLIST=[SEPLIST,deblank(SORTLIST(I,:)),'|'];
         end;
         for II=INTROWS, %for each row containing interaction terms...
            INTTERM=preint(SORTLIST,II);
            eval(['[INTX,INDVEC]=interact(',INTTERM,');']);
            %Now delete the appropriate rows from INDVEC and cols
            %from  INTX  using  loseint
            [NAMELIST,INTX,XVARS,CONEQUIV]=loseint(...
                  SORTLIST(II,:),SEPLIST,INTX,INDVEC,XVARS,NAMELIST,CONEQUIV);
         end;
         clear INTROWS
         NAMELIST(1,:)=[];
      end;
   end;
end;

NEWNAMELIST=[];
for II=1:size(NAMELIST,1),
   NEWROW=strrep(NAMELIST(II,:),'fac(',''); NEWROW=strrep(NEWROW,')(','(');
   NEWNAMELIST=str2mat(NEWNAMELIST,NEWROW);
end;
if ~isempty(NEWNAMELIST), NAMELIST=NEWNAMELIST;NAMELIST(1,:)=[]; end;

clear OLDNAMEXV OLDXVARS II INTROWS NEWROW SORTLIST EVALLIST CONEQUIV 
clear RUNNAMEXV INTX INDVEC ADDX SEPLIST NEWNAMELIST INTTERM I THISI
watchoff;

return;
