%GLMDEMO A demo of glmlab in operation

%Copyright 1996 Peter Dunn
%11/11/1996

echo off;newmodel;more off; echo on;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%              .            .        .             %%
%%        ___  /|   . _  _  /|  __   /| __          %%
%%       /  \   |  /|/ \/ \  |  __\   |/  \         %%
%%       \__/   |   |  |  |  | /  |   |    )        %%
%%       /__    |   |  |  |  | \__|_  |___/         %%
%%    == /  \ ==================================    %%
%%       \__/                                       %%
%%                                                  %%
%%          .                                       %%
%%       __ |    __    . _  _     __                %%
%%      /  \|   /  \  /|/ \/ \   /  \               %%
%%     (    |  |___/   |  |  |  (    )              %%
%%      \___|   \__/   |  |  |   \__/  <>           %%
%%   ===========================================    %%
%%                                                  %%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

                                                                      echo off; 
                                          disp('Press any key to continue...');
                                                                         pause;
                                                                           clc;
                                                                       echo on;
   %%                 _
   %%    <>          / \
   %%    .   . _     |     __
   %%   /|  /|/ \   -+-   /  \
   %%    |   |   |   |   (    )
   %%    |   |   |   |    \__/   <>   <>  <>
   %% ==========================================
   %Before we start, how to use this demo:
   % 1.  Anything appears over here should be ignored-----------------------+
   %     They are just things that show up because I'm not clever           |
   %     clever enough to hide them.  (They are commands to make            |
   %     the demo work properly).  It will usually be words like            |
   %     `echo' and `pause' and so on.                                      |
   % 2.  When windows appear, you will have to click back into this         |
   %     `command window' to keep the demo going.                           |
   % 3.  If it seems to stop, it is probably pausing for a while, so       \ /
   %     press the space bar for it to continue.                            v

                                                                      echo off; 
                                          disp('Press any key to continue...');
                                                                         pause;
                                                                           clc;
                                                                       echo on;
          

   %To begin modelling with  glmlab  first type  glmlab
   %at the  matlab  prompt, like this:
                                                                      echo off;
                                                                disp('glmlab');
                                                                      pause(2)
                                                                      echo off;
                                                                      glmlab
                                                                      echo on;
                                                                      pause;

   %There are buttons at the bottom of the screen---these buttons
   %do things like  FIT MODELS  and  so on.  But for the moment,
   %let's look at the other things on the menu

   %There is a section at the top labelled  `Response (y)'.
   %In here, type in the name of the variable that corresponds
   %to the response variable (usually the  y  variable).

   %To do this, we must first define some variables.
   %Here's some real data concerning fuel consumptions of some
   %popular Australian cars (Wheels magazine, April 1996):

                                                                     pause;clc;

Fconsp=[10.0 11.8 7.4 9.4 8.7 11.3 12.0 6.3 6.6 8.8]';
   %Fuel consumption in litres/100 km

Engsize=[4.0 5.0 1.6 3.8 3.8 5.0 5.0 1.2 1.4 2.6]';
   %Engine Size in litres

Trans=[2 2 1 2 1 1 2 1 1 1]';
   %Transmission type:
   %   1 refers to manual cars and 2 refers to automatic cars

                                                                         pause;

   %Suppose we wanted to fit a regression model with fuel consumption
   %the  response or y  variable (the one we wish to predict, if you like)
   %and the engine size as a covariate.  This is what we would do:

   %First, enter the name of the response variable:
                                                                         pause;
                                                                      echo off;
                                                     Yvar=findobj('tag','HYV');
                                                   set(Yvar,'String','Fconsp');
                                                                       echo on;
                                                                          pause
   %Then, enter the name of the covariates (in this case, just Engsize):
                                                                      echo off;
                                                    Xvar=findobj('tag','HXV');
                                                   set(Xvar,'String','Engsize');
                                                                       echo on;
                                                                     pause;clc;
   %When we have the variable entered, we can press the button that
   % is labelled  FIT MODEL.  This is what would happen:
                                                                         pause;
                                                                      echo off;
                                                                         varok;
[BETA FITS RESIDS COVB COVD DEVLIST]=glmfit(Fconsp,[ones(size(Engsize)),Engsize]);
                                                                       echo on;
                                                                          pause
 
   %As you can see,  glmlab  has fitted the regression model:
   %
   %   (Fuel Consumption)=4.862 + 1.307(Engine Size)
   %
                                                                          pause
   %Suppose it was thought that the transmission type was also
   %important.  To add the variable  trans  first note that  trans
   %is a qualitative variable (`factor') and not a quantitative
   %variable.  To distinguish, we use the following 
   %(look in the  glmlab  window):
                                                                         pause
                                                                      echo off;
                                                    Xvar=findobj('tag','HXV');
                                       set(Xvar,'String','Engsize, fac(Trans)');
                                                                       echo on;
                                                                         pause
   %Notice that we did not use just  Trans  in the covariate list,
   %but  fac(Trans)  instead.  The use of  `fac'  indicates that the
   %variable is qualitative, and  glmlab  makes the appropriate 
   %adjustments.  Anyway, let's fit this model:
                                                                          pause
                                                                       echo off
                                                                         varok;
[BETA FITS RESIDS COVB COVD DEVLIST]=glmfit(Fconsp,[ones(size(Engsize)),Engsize,fac(Trans)]);
                                                                       echo on;
                                                                          pause

   %As you can see, the transmission type didn't make a lot of difference.
 
   %We could also fit interactions:
                                                                          pause
                                                                       echo off
                  set(Xvar,'String','Engsize, fac(Trans), Engsize@fac(Trans)');
                                                                        echo on
                                                                          pause
   %Notice the use of the  @  character to specify interactions.  
   %Pressing the  FIT MODEL  button gives the following:
                                                                          pause
                                                                      echo off;
                                                                         varok;
[BETA FITS RESIDS COVB COVD DEVLIST]=glmfit(Fconsp,[ones(size(Engsize)),Engsize,fac(Trans),interact(Engsize,fac(Trans))]);
                                                                       echo on;
                                                                          pause
   %A file called  DETAILS.m  is produced that captures some of the 
   %information
                                                                       echo off;
                                                                   type DETAILS;
                                                                       echo on;

   %If you want to be fancy, click on the a menu button or the
   %RESIDUAL PLOTS... button.  The menu buttons will let you do many 
   %things.  You can:
   %   load data or close glmlab (File menu button); 
   %   change the error distribution (Distribution); 
   %   change the link (Link);
   %   change the scale parameter (Scale Parameter); 
   %   change the type of errors that are calculated (Residual); 
   %   change some options and declare new models (Options);
   %   get some help (Help).
                                                                      echo off;
                                                                         pause;
                                                                       echo on;
   %The RESIDUALS PLOTS... button produces another window with
   %choices of residual plots from which to choose.
   %Here's what happens when the RESIDUALS PLOTS... button is pressed
                                                                      echo off;
                                                                         pause;
                                                                       glmplot;
                                                                       echo on;
   %Let's choose to plot the normal probability plot and the
   %residuals vs fitted values.  Select those plots:
                                                                      echo off;
                                                                         pause;
                                        set(findobj('tag','npplot'),'value',1);
                                         set(findobj('tag','resvf'),'value',1);
                                                                       echo on;
   %The hit the PLOT button to make the pictures appear.
                                                                      echo off;
                                                                         pause;
                                                                      plotwork;
                                          clear Xvar Yvar Trans Fconsp Engsize;
                                                                       echo on;

echo off;
