function l=makeline(word,type)
%MAKELINE  Make a line with a message if necessary.
%USE:  l=makeline(word,type)
%   where  l  is the resultant line (a string),
%          word  is the message to include (a string),
%                If word is a number, the following is given:
%                word==1: an ERROR line;
%                word==2: a WARNING line;
%                word==3: a QUESTION line;
%                word==4: an INFO line;
%          type  is the type of line (one character long string).
%   If  type  is omitted, then the line is of type: ' === MESSAGE =========');
%   If  word  is omitted, then the line is of type: ' =====================');
%   Both inputs (if given) must be strings.
%   Neither input is needed.
%
%For use in glmlab

%Copyright 1996 Peter Dunn
%11/11/1996

if nargin==1,
if ~isstr(word),
   if word==2, 
   l=' === WARNING :-| =====================================================';
   elseif word==3,
   l=' === QUESTION :-0 ====================================================';
   elseif word==4,
   l=' === INFO :-| ========================================================';
   else
   l=' === ERROR :-< =======================================================';
   end;
   if nargout==0, disp(l); end;
   return;
end;
end;

if nargin<2, type='='; else type=type(1); end;
l=blanks(70);for i=2:70,l(i)=type;end;
if nargin>0,
   if length(word)>0, word=[' ',word,' '];end;
   l=l;l(5:4+length(word))=word;
end;
if nargout==0, disp(l); end;
