%PLOTWORK  Does all the plotting and work attached to  glmplot

%Copyright 1996 Peter Dunn
%11/11/1996

global YVAR XVARS RESIDS RESTYPE ERRDISFUNCTION FITVALS NAMELIST NAMEYV

PMAT(1)=get(findobj('tag','resvy'),'value');
PMAT(2)=get(findobj('tag','resvc'),'value');
PMAT(3)=get(findobj('tag','npplot'),'value');
PMAT(4)=get(findobj('tag','resvf'),'value');
if findobj('tag','qequiv'),
   PMAT(5)=get(findobj('tag','qequiv'),'value');
else
   PMAT(5)=0;
end;
delete(gcf);

TITLEDIS=[upper(ERRDISFUNCTION(1)),ERRDISFUNCTION(2:length(ERRDISFUNCTION))];
TYPER=[upper(RESTYPE(1)),RESTYPE(2:length(RESTYPE))];
if strcmp(TYPER,'Quantile')
   if strcmp(ERRDISFUNCTION,'binomial')|strcmp(ERRDISFUNCTION,'poisson'),
      TYPER='Randomised Quantile';
   end;
end;
TRN=[]; REPS=size(RESIDS,2);
if REPS>1, 
   TRN=': (rep: 1)';
   for II=2:REPS, 
      NEXT=[': (rep: ',num2str(II),')']; TRN=str2mat(TRN,NEXT); 
   end;
else 
   TRN=' ';
end;
if PMAT(2),
   if isempty(XVARS),
      makeline(1);
      disp(' You have requested to plot residuals vs covariates--but there');
      disp(' are no covariates!  I''ll have to pull out I''m sorry.');
      makeline;bell;
   else
   if size(XVARS,2)~=1,
     makeline(3);bell
     disp(' You have indicated that you wish to plot residuals vs covariates.');
     disp(' Please indicate which of the columns of the covariate matrix');
     disp(' you wish to use (you may not want to use all of them).');
     disp(' The first few observations in the list of covariates are:');
     if size(XVARS,1)<5, MX=size(XVARS,1); else MX=5; end; format short;
     COVARS=XVARS(1:MX,:);disp('Covariates =');disp(COVARS),clear COVARS
     disp(' Enter (as a vector enclosed in [ ... ]) the columns against');
     disp(' which you would like to plot the residuals: ');
     PLCOLS=input(' Which columns? (Enter  ''0''  to cancel) ','s');
     if strcmp(PLCOLS,'0')|isempty(PLCOLS),
        PMAT(2)=0;
        makeline(4);
        disp(' Covariates vs Residuals plot cancelled at your request.');
        makeline;
     else
        COLS=str2num(PLCOLS);
        if isempty(COLS), COLS=str2num(['[',PLCOLS,']']); end;
        if isempty(COLS), 
           makeline(1);
           disp(' I can''t understand  you, so I''m giving up!'); 
           makeline;bell;
           PMAT(2)=0;
        end;
        COLS=sort(COLS);
        if any(COLS<1),
           makeline(2);
           disp(' Some zero and/or negative columns numbers were entered.');
           disp(' I''m ignoring those, and continuing to see what I can find.');
           makeline;COLS=COLS(COLS>0);
        end;
        if max(COLS)>size(XVARS,2), 
           makeline(2);
           disp(' You requested columns that don''t exist!  There aren''t' );
           disp(' that many columns.  I''ll continue to see what I can find.');
           makeline;
           COLS=COLS(COLS<=size(XVARS,2));
        end;
        if isempty(COLS),
           makeline(1);
           disp(' No valid column numbers were entered, so I''m giving up!');
           makeline;PMAT(2)=0;bell;
        end;
        if PMAT(2), COLS=COLS([1 diff(COLS)>0]);end;
     end;
   else
      COLS=1;
   end;
end;
end;
if PMAT(1), 
   for II=1:REPS, %res vs y
      figure; plot(YVAR,RESIDS(:,II),'y+');
      title([TYPER,' Residuals vs Response (y)',TRN(II,:)]);
      if isempty(NAMEYV),
         xlabel('Response Variable (y)');
      else
         xlabel(['Response Variable (y): ',NAMEYV]);
      end;
      ylabel([TYPER,' Residuals']);
   end;
end;
if PMAT(2), %res vs cov
   for II=1:REPS, %rep
      for JJ=1:length(COLS), %which covar
         figure;plot(XVARS(:,COLS(JJ)),RESIDS(:,II),'y+');
         title([TYPER,' Residuals vs Covariate ',...
                num2str(COLS(JJ)),TRN(II,:)]);
         ylabel([TYPER,' Residuals']);
         if ~isempty(NAMELIST),
            xlabel(['Covariate ',num2str(COLS(JJ)),' [',...
                     deblank(NAMELIST(JJ,:)),']']);
         else
            xlabel(['Covariate ',num2str(COLS(JJ))]);
         end;
      end;
   end;
end;
if PMAT(3), %npplot
   for II=1:REPS,
      figure;
      if findstr(RESTYPE,'quantile'),
         npplot(RESIDS(:,II),1); 
      else
         npplot(RESIDS(:,II),0);
      end;
      title2('Normal Probability Plot');
      title([TYPER,' Residuals (',TITLEDIS,') ',TRN(II,:)]);
      if ~isempty(NAMEYV),
         ylabel(['Data ',NAMEYV]);
      end;
   end;
end;
if PMAT(4),  %See McCullagh and Nelder p~398--Constant information scales used
   if strcmp(ERRDISFUNCTION,'poisson'),
      XAXIS=2*sqrt(FITVALS);XLAB='2 sqrt(Fitted Values)';
   elseif strcmp(ERRDISFUNCTION,'binomial'),
      XAXIS=2*asin(sqrt(FITVALS));XLAB='2 asin( sqrt(Fitted Values) )';
   elseif strcmp(ERRDISFUNCTION,'gamma'),
      XAXIS=2*log(FITVALS); XLAB='2 log( Fitted Values )';
   elseif strcmp(ERRDISFUNCTION,'inv_gsn'),
      XAXIS=-2/sqrt(mu);XLAB='-2 / sqrt(Fitted Values)';
   else %normal and user-defined
      XAXIS=FITVALS;XLAB='Fitted Values';
   end;
   for II=1:REPS,
      figure;plot(XAXIS,RESIDS(:,II),'y+');
      xlabel(XLAB);ylabel([TYPER,' Residuals']);
      title2([TYPER,' Residuals (',TITLEDIS,') vs ']);
      title([XLAB,TRN(II,:)]);
   end;
end;
if PMAT(5),
   for II=1:REPS,
      figure;plot(cdfnorm(RESIDS(:,1)),FITVALS,'y+');
      xlabel('Quantile Equivalents'); ylabel('Fitted Values');
      title2(['Fitted Values vs Quantile Equivalents for']);
      title([TYPER,' Residuals (',TITLEDIS,') ',TRN]);
   end;
end;
clear PMAT REPS TRN II JJ TITLEDIS XAXIS XLAB TYPER MX NEXT PLCOLS COLS
