%AVERAGE Moving average of data
%
%Syntax NDATA = average(DATA, WINDOW[, WEIGHT])
%
%Input:	DATA	
%	WINDOW	Window width
%	WEIGHT	Vector of weigths (0<=w<=1) for every datapoint
%		within the window [WEIGHT=1/window, equal weights]
%Output:NDATA	Gleitender Durchschnitt von DATA
%
%	(c) A.K. 29.4.1995

function ndata=average(data, window, weigth)

rows=size(data,1);
if nargin<3 & rows>1
   weight=ones(window,1)*(1/window);
elseif nargin<3 & rows==1
   weight=ones(1,window)*(1/window);
end %if

n=length(data);
ndata=zeros(size(data));
h=(window-1)/2;

for i=1+h:n-h,
    ndata(i) = sum(data((i-h):(i+h)).*weight);
end %for i

% Beruecksichtigung der Randbereiche

for i=1:h,
    for j=1:i+i-1,
        ndata(i)=ndata(i)+data(j);
    end %for j
    ndata(i)=ndata(i)/(2*(i-1)+1);
end %for i

for i=n-h+1:n,
    for j=i-n+i:n
        ndata(i)=ndata(i)+data(j);
    end %for j
    ndata(i)=ndata(i)/(2*(n-i)+1);
end %for i

