%EQUILIB Equilibrium occupancies for any kinetic scheme
%
%Syntax	P = equilib(Q)
%
%Input	Q	Q-matrix build up from the system of linear de's
%
%Output	P	equilibrium occupancy for each state
%
%Remark	The Q-Matrix is the transposed form of the standard Q-matrix used
%	in literatur (e.g. Colquhoun, Hawkes in Single Channel Recording 1995)
%
%	(c) A.K. 18.8.1996

function p=equilib(Q)

% Using Colquhoun & Hawkes notation
Q=Q';

u=ones(1,length(Q));
S=[Q ones(length(Q),1)];
p=u*inv(S*S');
