function y=expcalc(xd,x)

%EXPCALC Sum of n exponentials
%
%Syntax	Y = expcalc(XD, X, N)
%
%Input	XD	x-Values to calculate y
%	X	Parameter vector as obtained from efit in global Variable G1
%	N	Number of exponentials
%
%Output	Y	Output of calculated values	
%
%	(c) A.K. 28.9.1996

n=(length(x)-1)/2;
if n==1, 
   y=x(1)*exp(-xd./x(2))+x(3);
elseif n==2
   y=x(1)*exp(-xd./x(2))+x(3)*exp(-xd./x(4))+x(5);
elseif n==3
   y=x(1)*exp(-xd./x(2))+x(3)*exp(-xd./x(4))+x(5)*exp(-xd./x(6))+x(7);
elseif n==4
   y=x(1)*exp(-xd./x(2))+x(3)*exp(-xd./x(4))+x(5)*exp(-xd./x(6))+x(7)*exp(-xd./x(8))+x(9);
elseif n==5
   y=x(1)*exp(-xd./x(2))+x(3)*exp(-xd./x(4))+x(5)*exp(-xd./x(6))+x(7)*exp(-xd./x(8))+x(9)*exp(-xd./x(10))+x(11);
end %if   

