%FUSE	Deleting and fusing events of duration<=p
%
%Syntax	LST = fuse(EVENTS, P)
%
%Input	EVENTS	event list
%	P	minimum event duration
%
%Output LST	event list with fused events
%
%Warning : Multichannel data are not reliably fused

function lst=fuse(events, p);

h=find(events(:,1)<=p);
if length(h)>1,
 start=1;
 if h(1)==1, start=2; end;
 for i=start:length(h)
     if events(h(i)-1,1)>=p & events(h(i)-1, 2)>events(h(i),2)
        events(h(i),2:3)=events(h(i)-1,2:3);        
     elseif events(h(i)+1,1)>p & events(h(i)+1,2)<events(h(i),2)
        events(h(i),2:3)=events(h(i)+1,2:3);
     elseif events(h(i)+1,1)<=p & events(h(i)+1,2)>events(h(i),2)
        events(h(i)+1,2:3)=events(h(i),2:3);
     end %if
 end %for

% Fusing adjacent events of the same level

 h=zeros(size(events));
 h(1,:)=events(1,:);
 n=1;
 for i=2:length(events(:,1))
     if h(n, 2)~=events(i,2)
        n=n+1;
        h(n,:)=events(i,:);
     else
        h(n,1)=h(n,1)+events(i,1);
     end %if
 end %for i
 events=h;
% Deleting isolated levels
 h=find(events(2:length(events),1)<=p);
 events(h-1,1)=events(h-1,1)+events(h,1);
 events(h,:)=[];
end %if


% deleting events of zero duration
h=find(events(:,1)==0);
events(h,:)=[];

lst=events;
