%MEANTIME Calculates mean open and mean closed time from an eventlist
%
%Syntax	[MO MC] = meantime(EVENTS)
%	
%Input	EVENTS	eventlist, matrix of the form [length level current]
%	
%Output [MO MC]	MO: mean open time,  MC: mean closed time
%	time unit is sampling points
%
%	(c) A.K. 19.8.1995

function [mo, mc]=meantime(events)

l=length(events(:,1));

opentime=sum(events(:,1).*events(:,2));
closedtime=sum(events(events(:,2)==0,1));

h(2:l+1)=events(:,2); h(1)=0; events(l+1,2)=0;
diff=events(:,2)-h';
nopen=sum(diff(diff>0));
nclose=-sum(diff(diff<0))+1;

mo=opentime/nopen;
mc=closedtime/nclose;
