%NOTCH	Notch filter, removes a narrow frequency band 
%
%Syntax	NDATA = notch(DATA, F, DF, SAMPL, POINTS[, P])
%
%Input	DATA	data (as row vector !)
%	F     	frequency to remove
%	DF	characteristic for the width of the frequency band
%	SAMPL	sampling interval
%	POINTS	number of points for Fourier-transformation
%	P	extent of removal [1]
%		0 > p >= 1
%
%	(c) A.K. 23.10.1995

function ndata=notch(data, f, df, sampl, points, p)

if nargin<6, p=1; end

% Erzeugung der Gewichtsfunktion

n=f*points*sampl; sn=df*points*sampl;
w=-p.*exp(-( (((0:points/2)-n)/sn).^2 ))+1;

% FT, Multiplikation und inverse FT

for i=1:length(data)/points
    df=ft(data(((i-1)*points+1):i*points)').*w';
    ndata=[ndata ift(df)'];
end %for i
