%RANDDIS Generation of random number with arbitrary discrete distribution 
%
%Syntax	Z = randdis(X, P, N)
%
%Input	X	row vector with values of the random variable
%	P	vector of probabilities
%	N	number of random numbers
%
%Output Z	value from x selected randomly (or vector, if N>1)
%
%	(c) A.K. 12.11.1995

function z=randdis(x, p, n)

if nargin<3, n=1; end

ph=cumsum(p);

for i=1:n,
    z=[z x(min(find(ph>=rand)))];
end %for i

