%RELAX Time course for the relaxation to equilibrium
%
%Syntax	C = relax(Q, T, INIT)
%
%Input	Q	Q-matrix build up from the system of linear de's
%	INIT	initial conditons for each state (row vector)
%	T	row vector containing the times for which to calculate the concentrations
%
%Output	C	Matrix with columns corresponding to each state. Each row contains
%		the concentrations for the time specified in T
%
%Remark	The concentrations are calculated exactly. No numerical solving of
%	differential equations is attempted.
%
%	(c) A.K. 18.8.1996

function c=equilib(Q, t, init)

% Using Colquhoun & Hawkes notation
Q=Q';

for ti=t,
    h=init*expm(ti*Q);
    c=[c; h];
end %for

