%Thresh Eventlist creation by threshold analysis
%
%Syntax	ND = thresh(DATA, THRESHOLD, LEVEL)
%
%Input	DATA		
%	THRESHOLD	Row vector containing thresholds
%	LEVEL		Row vector containing current levels (0, 1.Op, 2.Op, ...)
%	
%Output	EVENTS 		Event list, matrix with three columns (duration, level, current)
%			The current is not calculated but user-supplied (LEVEL-vector).
%
%Remark	Analysis is only for upward openings. For analysis of downward openings convert
%	DATA first: 'DATA = -DATA'.
%	Use of 'fuse' to remove one-point levels will greatly improve the results.
%
%	(c) A.K. 13.8.1995
%	last modified 26.6.1996

function events=thresh(data, threshold, level)

h=zeros(size(data)); events=zeros(size(data,2)/4, 3);
for i=1:length(threshold)
    h=h+(data>threshold(i));
end %for i

lev=h(1); n=1; events(1,2)=h(1);
for i=1:length(h)
    if h(i)==lev
       events(n,1)=events(n,1)+1;
    else
       n=n+1;
       lev=h(i);
       events(n,2)=h(i);
       events(n,1)=1;
   end %if
end %for i
events=events(1:n,:);
events(:,3)=level(events(:,2)+1)';
