function uiselect(action, data, points, vscale, pos)

% last modification 24.7.1996

global P HPOI HPOIVAL HPOS HVSC HSCVAL HUNDO HOK HQUIT HPVAL YLIM HZOOM
global G1 G2 G3 G4
global MARK POS

if nargin<2, data=action; action='init'; end
if nargin<3, points=round(length(data)/8); end
if nargin<4, vscale=1; end
if nargin<5, pos=1; end
   
if strcmp(action, 'init'),
   MARK=0;POS=zeros(1,100);
   G1=data; G2=points; G3=vscale; G4=pos;
   YLIM=[min(G1)-.05*min(G1) max(G1)+0.05*max(G1)];
   YLIM=YLIM/G3; 
   plot((G4:G4+G2), data(G4:G4+G2), 'EraseMode', 'xor'); h=gca; set(h, 'XLim', [G4 G4+G2], 'YLim', YLIM); 
   set(gcf, 'backingstore', 'off', 'WindowButtonDownfcn', 'uiselect(''buttondown'', G1, G2, G3, G4)');
   HPOI=uicontrol('Style', 'slider', 'Units', 'normalized', 'Value', G2, 'Position', [.3 0.93 0.4 0.04], ...
                  'Min', 3, 'Max', length(G1)-1, 'Callback', 'uiselect(''numpoints'', G1, G2, G3, G4)');
   HPOIVAL=uicontrol('Style', 'edit', 'Units', 'normalized', 'String', num2str(G2), 'Position', [0.7 0.93 0.1 0.033], 'BackgroundColor', [0.702 0.702 0.702], ...
                     'Callback', 'uiselect(''poival'', G1, G2, G3, G4)'); 
   HPOS=uicontrol('Style', 'slider', 'Units', 'normalized', 'Value', G4, 'Position', [0 0.97 1 0.04], ...
                  'Min', 1, 'Max', length(G1), 'Callback', 'uiselect(''position'', G1, G2, G3, G4)');
   HPVAL=uicontrol('Style', 'edit', 'Units', 'normalized', 'String', '1', 'Position', [0.9 0.94 0.1 0.03], 'BackgroundColor', [0.702 0.702 0.702], ...
                   'Max', 1, 'Callback', 'uiselect(''posval'', G1, G2, G3, G4)'); 
   HVSC=uicontrol('Style', 'slider', 'Units', 'normalized', 'Value', 1, 'Position', [.94 0.4 .03 0.3], ...
                  'Min', .1, 'Max', 10, 'Callback', 'uiselect(''vscale'', G1, G2, G3, G4)');
   HSCVAL=uicontrol('Style', 'edit', 'Units', 'normalized', 'String', '1', 'Position', [0.93 0.34 0.05 0.03],'BackgroundColor', [0.702 0.702 0.702], ...
                   'Max', 1, 'Callback', 'uiselect(''scval'', G1, G2, G3, G4)');                   
   HOK=uicontrol('Style', 'pushbutton', 'Units', 'normalized', 'String', 'OK', 'Position', [0.92 0.86 .08 0.05], ...
                  'callback', 'uiselect(''ok'', G1, G2, G3, G4)');
   HQUIT=uicontrol('Style', 'pushbutton', 'Units', 'normalized', 'String', 'Quit', 'Position', [0.92 0.79 .08 0.05], ...
                   'callback', 'uiselect(''quit'', G1, G2, G3, G4)');
   HUNDO=uicontrol('Style', 'pushbutton', 'Units', 'normalized', 'String', 'Undo', 'Position', [0.91 0.15 .1 0.08], ...
                   'callback', 'uiselect(''undo'', G1, G2, G3, G4)');
   HZOOM=uicontrol('Style', 'pushbutton', 'Units', 'normalized', 'String', 'Zoom on', 'Position', [0.02 0.01 .1 0.05], ...
                   'callback', 'uiselect(''zoom'', G1, G2, G3, G4)');
elseif strcmp(action, 'position'),
   G4=round(get(HPOS, 'Value'));
   if G4>length(G1)-G2,
      G4=length(G1)-G2; set(HPOS, 'Value', G4);
   end %if
   plot((G4:G4+G2), G1(G4:G4+G2), 'EraseMode', 'xor'); h=gca; set(h, 'XLim', [G4 G4+G2], 'YLim', YLIM/G3);
   y0 = YLIM(1); ym = YLIM(2);
   x0 = G4; xm = G4+G2;
   i=1;
   while POS(i)<xm & i<=MARK,
         line([POS(i) POS(i)], [y0 ym], 'LineStyle', ':', 'Color', [0 1 0], 'EraseMode', 'xor');
         i=i+1;
   end %while
   set(HPVAL, 'String', num2str(G4));
elseif strcmp(action, 'posval'),
   G4=str2num(get(HPVAL, 'String'));
   if G4>length(G1)-G2,
      G4=length(G1)-G2; set(HPOS, 'Value', G4); set(HPVAL, 'String', num2str(G4));
   end %if
   plot((G4:G4+G2), G1(G4:G4+G2), 'EraseMode', 'xor'); h=gca; set(h, 'XLim', [G4 G4+G2], 'YLim', YLIM/G3);
   y0 = YLIM(1); ym = YLIM(2);
   x0 = G4; xm = G4+G2;
   i=1;
   while POS(i)<xm & i<=MARK,
         line([POS(i) POS(i)], [y0 ym], 'LineStyle', ':', 'Color', [0 1 0], 'EraseMode', 'xor');
         i=i+1;
   end %while
   set(HPOS, 'Value', G4);
elseif strcmp(action, 'numpoints'),
   G2=round(get(HPOI, 'Value'));
   if G2>length(G1)-G4,
      G2=length(G1)-G4; 
      set(HPOI, 'Value', G2);
   end %if     
   plot((G4:G4+G2), G1(G4:G4+G2), 'EraseMode', 'xor'); h=gca; set(h, 'XLim', [G4 G4+G2], 'YLim', YLIM/G3);
   y0 = YLIM(1); ym = YLIM(2);
   x0 = G4; xm = G4+G2;
   i=1;
   while POS(i)<xm & i<=MARK,
         line([POS(i) POS(i)], [y0 ym], 'LineStyle', ':', 'Color', [0 1 0], 'EraseMode', 'xor');
         i=i+1;
   end %while
   set(HPOIVAL, 'String', num2str(G2));
elseif strcmp(action, 'poival'),
   G2=str2num(get(HPOIVAL, 'String'));
   if G2>length(G1)-G4,
      G2=length(G1)-G4; 
      set(HPOIVAL, 'String', num2str(G2));
   end %if     
   plot((G4:G4+G2), G1(G4:G4+G2), 'EraseMode', 'xor'); h=gca; set(h, 'XLim', [G4 G4+G2], 'YLim', YLIM/G3);
   y0 = YLIM(1); ym = YLIM(2);
   x0 = G4; xm = G4+G2;
   i=1;
   while POS(i)<xm & i<=MARK,
         line([POS(i) POS(i)], [y0 ym], 'LineStyle', ':', 'Color', [0 1 0], 'EraseMode', 'xor');
         i=i+1;
   end %while
   set(HPOI, 'Value', G2);
elseif strcmp(action, 'vscale'),
   G3=get(HVSC, 'Value');
   set(gca, 'YLim', YLIM/G3);
   set(HSCVAL, 'String', num2str(G3));
elseif strcmp(action, 'scval'),
   G3=str2num(get(HSCVAL, 'String'));
   if G3>10, G3=10; end
   if G3<.1, G3=.1; end
   set(HVSC, 'Value', G3);
   set(gca, 'YLim', YLIM/G3);
elseif strcmp(action, 'buttondown'),
   h=get(gca, 'CurrentPoint');
   MARK=MARK+1; POS(MARK)=h(1,1);
   y0 = YLIM(1); ym = YLIM(2);
   line([POS(MARK) POS(MARK)], [y0 ym], 'LineStyle', ':', 'Color', [0 1 0], 'EraseMode', 'xor');
elseif strcmp(action, 'undo'),
   y0 = YLIM(1); ym = YLIM(2);
   if MARK>0, line([POS(MARK) POS(MARK)], [y0 ym], 'Color', [0 0 0], 'EraseMode', 'background'); end
   MARK=MARK-1;
   if MARK<0, MARK=0; end
elseif strcmp(action, 'zoom'),
   s=get(HZOOM, 'String');
   if strcmp(s, 'Zoom on'), 
      set(HZOOM, 'String', 'Zoom off'); zoom on
   else
      set(HZOOM, 'String', 'Zoom on'); zoom off
      set(gcf, 'WindowButtonDownfcn', 'uiselect(''buttondown'', G1, G2, G3, G4)');
   end %if
elseif strcmp(action, 'ok'),
   close(gcf);
   G3=MARK; G4=POS;
   clear global P; clear global HPOI; clear global HPOS; clear global P;
   clear global HVSC; clear global HUNDO; clear global HOK; clear global HQUIT;
   clear global HPVAL; clear global HPOIVAL; clear global YLIM;
   clear global MARK; clear global POS; clear global HZOOM
elseif strcmp(action, 'quit'),
   G3=0;
   close(gcf);
   clear global P; clear global HPOI; clear global HPOS; clear global P;
   clear global HVSC; clear global HUNDO; clear global HOK; clear global HQUIT;
   clear global HPVAL; clear global HPOIVAL; clear global YLIM
   clear global MARK; clear global POS; clear global HZOOM
end %if

