function c = convolve(s, r)
%CONVOLVE  Calculates the convolution of r and s
%
%Syntax	C = convolve(S, R)
%
%Input	S	Signal to fold with R
%		length(R) <= length(S)
%	R	Column-vector of the response function of the form [Zeit R(t)]
%		where t<0, t>0, t=0
%	
%Output	C	Convolution
%
%	(c) A.K. 9.12.1995

t=r(:,1);
r=r(:,2);
n=length(s);

h=[sum(t<0) sum(t>0)]; hmax=max(h);
s=[s; zeros(hmax, 1)];
r=[r(t>=0); zeros(length(s)-sum(h)-1,1); r(t<0)];
c=real(ifft(fft(s).*fft(r)));
c=c(1:n);
