function s = decon(c, r)
%DECON  Deconvolves r out of c
%
%Syntax	S = decon(C, R)
%
%Input	C	Column vector of a convolution
%		where t<0, t>0, t=0
%	R	Two-column matrix of the response function of the 
%		form [time R(t)]
%		length(R) <= length(C)
%	
%Output	S	System-function
%
%	(c) A.K. 9.12.1995

t=r(:,1);
r=r(:,2);
n=length(c);

h=[sum(t<0) sum(t>0)]; hmax=max(h);
c=[c; zeros(hmax, 1)];
r=[r(t>=0); zeros(length(c)-sum(h)-1,1); r(t<0)];
s=real(ifft(fft(c)./fft(r)));
s=s(1:n);
