function pltpower(data, n, sampl)
%PLTPOWER Plots the power spectral density
%
%Syntax	pltpower(DATA[, N[, SAMPL]])
%
%Input	DATA	Spaltenvektor mit Daten
%	N	Anzahl Punkte fuer eine FT [length(data)]
%	SAMPL	Abtastintervall [1]
%
%Remark	Number of data points / N must be an even number
%
%	(c) A.K. 16.8.1994

if nargin<3, sampl=1; end
if nargin<2, n=length(data); end
loglog(freqaxis(n-1, sampl), powers(data,n) );
