function slotnums = opCacheFindRoom(ch, n, tNow)
% slotnums = opCacheFindRoom(ch, n, tNow)
%
% Make room for n new frames, by creating new ones if necessary and
% flushing existing slots.  Return list of n slot numbers to supplant.
%
% tNow should be non-negative.

global opCacheIndex

x = sum(opCacheIndex(2,:) < tNow);

% Create new slots if necessary.
if (x < n)
  opCacheData(ch, 'extend', n-x+1);
  opCacheIndex = [opCacheIndex, -1 * ones(2, n-x+1)];
end

[dummy,i] = sort(opCacheIndex(2,:));
slotnums = sort(i(1:n));
