function opChannel(cmd, x0)
% opChannel('makemenu')
% Fix up opChannelMenu's children to match the current number of channels
% and the currently selected one.
%
% opChannel('set', c)
% Set c to be the currently selected channel.  Recompute and update the
% display accordingly.

global opChannelCount opChannelNum opChannelMenu opc

if (strcmp(cmd, 'makemenu'))
  delete(get(opChannelMenu, 'Children'));
  for i = 0:opChannelCount-1
    uimenu(opChannelMenu, 'Label', ['channel ', num2str(i)], ...
	'Callback', ['opChannel(''set'', ', num2str(i), ');']);
  end
  opChannel('setmenu');
  
elseif (strcmp(cmd, 'setmenu'))
  % Un-check existing menu items, check the right one.
  kids = get(opChannelMenu, 'Children');
  for k = kids
    set(k, 'Checked', 'off');
  end
  set(kids(length(kids) - opChannelNum), 'Checked', 'on');
  
elseif (strcmp(cmd, 'set'))
  %if (opChannelNum ~= x0)
    disp('Setting up new channel...')
    opChannelNum = x0;
    opChannel('setmenu');
    opRefresh(opc, 1);
  %end

else
  error('Osprey internal error: Unknown cmd arg passed to opChannel.');
end
