function opIcons
% opIcons
%     Create opCrunchIcon and opZoomIcon, the images for the hand-y icons.
%     The images were stolen from Canary.

global opHCrunchIcon opHZoomIcon opVCrunchIcon opVZoomIcon global opIconColorMap

% The color codes are defined below.

opIconColorMap = [
    1	1	1	% white
    0.9	0.9	0.9	% light gray
    0.7	0.7	0.7	% medium gray
    0.5	0.5	0.5	% dark gray
    0	0	0	% black
    0.8	0.8	0.4	% tan (hand color)
    ];

% The crunch icon.
c = [
    'lllllllllllllllllllllllllllllllllllllld'
    'llllllllllllllllllllllllllllllllllllldd'
    'llmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmdd'
    'llmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmdd'
    'llmmbbmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmdd'
    'llmmbbmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmdd'
    'llmmbbmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmdd'
    'llmmbbmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmdd'
    'llmmbbmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmdd'
    'llmmbbmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmdd'
    'llmmbbmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmdd'
    'llmmbbmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmdd'
    'llmmbbmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmdd'
    'llmmbbmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmdd'
    'llmmbbmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmdd'
    'llmmbbmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmdd'
    'llmmbbmmbbbbbbbbbbbbbbbbmmmmmmmmmmmmmdd'
    'llmmbbmmbbbbbbbbbbbbbbbbmmmmmmmmmmmmmdd'
    'llmmbbmmbbbbbbbbbbbbbbbbmmmmmmmmmmmmmdd'
    'llmmbbmmmmmbwwwwwwwwwbmmmmmmmmmmmmmmmdd'
    'llmmbbmmmmmbbbbbbbbbbbmmmmmmmmmmmmmmmdd'
    'llmmbbmmmmmboooooooobbbbbbmmmmmmmmmmmdd'
    'llmmbbmmmmmboooooooooooooobbbbbbbbmmmdd'
    'llmmbbmmmmmbooooooobboooooooooooobmmmdd'
    'llmmbbmmmmmbooooooooobbbbbbbbbbbbbmmmdd'
    'llmmbbmmmmmmbbbbbbbboooobbbbbbbbbmmmmdd'
    'llmmbbmmmmmmbbwwwwwbbbbbbwwwwwwwbbmmmdd'
    'llmmbbmmmmmmbwwwwwwwwwwwwwwwbbwwwbmmmdd'
    'llmmbbmmmmmmbwwwbbbbbbbbbbbbbbwwwbmmmdd'
    'llmmbbmmmmmmbwwwbbwwwwwwwwwwwwwwwbmmmdd'
    'llmmbbmmmmmmbbwwwwwwwwwwwwwwwwwwbbmmmdd'
    'llmmbbmmmmmmmbbbbbbbbbbbbbbbbbbbbmmmmdd'
    'llmmbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbmmdd'
    'llmmbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbmmdd'
    'llmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmdd'
    'llmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmdd'
    'llmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmdd'
    'llddddddddddddddddddddddddddddddddddddd'
    'ldddddddddddddddddddddddddddddddddddddd'
    ];

% The zoom icon.
z = [
    'lllllllllllllllllllllllllllllllllllllld'
    'llllllllllllllllllllllllllllllllllllldd'
    'llmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmdd'
    'llmmmmmmmmmbbbbbbbbbbbbbbbbbbmmmmmmmmdd'
    'llmmmmmmmmmbbbbbbbbbbbbbbbbbbmmmmmmmmdd'
    'llmmbbmmmmmbbbbbbbbbbbbbbbbbbmmmmmmmmdd'
    'llmmbbmmmmmmmbwwwwwwwwwwwwbmmmmmmmmmmdd'
    'llmmbbmmmmmmmbbbbbbbbbbbbbbmmmmmmmmmmdd'
    'llmmbbmmmmmmmmboooooooooobbbbmmmmmmmmdd'
    'llmmbbmmmmmmmmboooooooooooobbbmmmmmmmdd'
    'llmmbbmmmmmmmmmbboooooooooooobmmmmmmmdd'
    'llmmbbmmmmmmmmmmboooobbbbbboobmmmmmmmdd'
    'llmmbbmmmmmmmmbbbooobbwwwwwbbbmmmmmmmdd'
    'llmmbbmmmmmmmbwwbooobwwwwwwwwbmmmmmmmdd'
    'llmmbbmmmmmmmbwwbooobwwwwwwwwbmmmmmmmdd'
    'llmmbbmmmmmmmbwwbooobwwwwwwwwbmmmmmmmdd'
    'llmmbbmmmmmmmbwwwbbbwwwwbbbwwbmmmmmmmdd'
    'llmmbbmmmmmmmbwwwwwwwwwwbbbwwbmmmmmmmdd'
    'llmmbbmmmmmmmbwwwwwwwwwwbbbwwbmmmmmmmdd'
    'llmmbbmmmmmmmbwwwwwwwwwwbbbwwbmmmmmmmdd'
    'llmmbbmmmmmmmbwwwwwwwwwwbbbwwbmmmmmmmdd'
    'llmmbbmmmmmmmbwwwwwwwwwwbbbwwbmmmmmmmdd'
    'llmmbbmmmmmmmbwwwbbbbbbbbbbwwbmmmmmmmdd'
    'llmmbbmmmmmmmbwwbbbbbbbbbbbwwbmmmmmmmdd'
    'llmmbbmmmmmmmbwwbbbbbbbbbbwwwbmmmmmmmdd'
    'llmmbbmmmmmmmbwwbbbwwwwwwwwwwbmmmmmmmdd'
    'llmmbbmmmmmmmbwwbbbwwwwwwwwwwbmmmmmmmdd'
    'llmmbbmmmmmmmbwwbbbwwwwwwwwwwbmmmmmmmdd'
    'llmmbbmmmmmmmbwwbbbwwwwwwwwwwbmmmmmmmdd'
    'llmmbbmmmmmmmbwwbbbwwwwwwwwwwbmmmmmmmdd'
    'llmmbbmmmmmmmbwwbbbwwwwwwwwwwbmmmmmmmdd'
    'llmmbbmmmmmmmbwwwwwwwwwwwwwwwbmmmmmmmdd'
    'llmmbbmmmmmmmbwwwwwwwwwwwwwwwbmmmmmmmdd'
    'llmmbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbmmdd'
    'llmmbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbmmdd'
    'llmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmdd'
    'llmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmdd'
    'llddddddddddddddddddddddddddddddddddddd'
    'ldddddddddddddddddddddddddddddddddddddd'
    ];

ng = opColorMap('getlimits') * 2 + 1;	   % colormap number of first icon color
c = c(:);
z = z(:);

% Change the letters into numeric gray (or yellow) values.
x = (c == 'w'); c(x) = (ng+0) * ones(1,sum(x));		% white
x = (z == 'w'); z(x) = (ng+0) * ones(1,sum(x));
x = (c == 'l'); c(x) = (ng+1) * ones(1,sum(x));		% light gray
x = (z == 'l'); z(x) = (ng+1) * ones(1,sum(x));
x = (c == 'm'); c(x) = (ng+2) * ones(1,sum(x));		% medium gray
x = (z == 'm'); z(x) = (ng+2) * ones(1,sum(x));
x = (c == 'd'); c(x) = (ng+3) * ones(1,sum(x));		% dark gray
x = (z == 'd'); z(x) = (ng+3) * ones(1,sum(x));
x = (c == 'b'); c(x) = (ng+4) * ones(1,sum(x));		% black
x = (z == 'b'); z(x) = (ng+4) * ones(1,sum(x));
x = (c == 'o'); c(x) = (ng+5) * ones(1,sum(x));		% yellow
x = (z == 'o'); z(x) = (ng+5) * ones(1,sum(x));

% Convert back to arrays.
c = reshape(c, 39, 39);
z = reshape(z, 39, 39);

opVCrunchIcon = c;
opVZoomIcon   = z;

% Make the horizontal ones.  Have to fix the borders -- shading is for light 
% source at upper left.
c = flipud(fliplr(c.'));
c([1 2 38 39],:) = c([39 38 2 1],:);
c(:,[1 2 38 39]) = c(:,[39 38 2 1]);
opHCrunchIcon = c;

z = flipud(fliplr(z.'));
z([1 2 38 39],:) = z([39 38 2 1],:);
z(:,[1 2 38 39]) = z(:,[39 38 2 1]);
opHZoomIcon = z;
