function opOpen(cmd)
% opOpen('open')
% Put up a dialog box for opening a new file, get a response, 
% (re-)open an osprey window for the file.
%
% opOpen('quit')
% Close the current Osprey window.

global opFig opc

if (strcmp(cmd, 'open'))
  if (exist('opc')), dir = pathDir(opFileName(opc, 'getsound'));
  else dir = pwd; end
  pos = get(0, 'screensize');
  [f,p] = uigetfile([dir,pathSep,'*'], 'Osprey', pos(3)/2-150, pos(4)/2-200);
  if ((~isstr(f)) | ~min(size(f))), return; end		% Cancel
  osprey([p,f]);

elseif (strcmp(cmd, 'quit'))
  delete(opFig);
  opFig = 0;
  
else
  error(['Internal error: Unknown command ''', cmd, '''.']);
end
