function [y,var] = defaultsrate
% defaultsrate   Return the default sampling rate of the machine.
%
% y = defaultsrate
%   Return the default sampling rate available with the current hardware.
%   This may be a vector of several available sampling rates.
%
% [y,variablesrate] = defaultsrate
%   Return the default sampling rate(s) and a flag that says whether the
%   underlying hard/software can play variable sampling rates.  On a Mac,
%   variable sampling rates are implemented with hard/software interpolation.


c = computer;
var = 0;

if     (strcmp(c(1:3), 'SUN')), y = 8000;			% SunOS
elseif (strcmp(c(1:3), 'SOL')), y = 8000; 			% Solaris
elseif (strcmp(c(1:3), 'MAC')), y = 22254 + 54/99; var = 1;
elseif (strcmp(c,      'NEXT')),y = 22050;			% or 44100?
elseif (strcmp(c(1:3), 'SGI')), y = 22254 + 54/99;		% is variable?
elseif (strcmp(c,    'PCWIN')), y = 22050;	% not sure what's right here

else
  disp(['Don''t know default sampling rate for machine ' c '.  If you know']);
  disp('it, please fix defaultsrate.m and send mail to dkm1@cornell.edu .');
  error('Unknown sampling rate for this machine (see defaultsrate.m)');
end
