function [x,y,bounds]=rhisto(yplot,start,width,xplot)
%RHISTO Plots a relative frequency histogram from raw data in col vector ydata.
%USE:  [x,y,bounds]=rhisto(ydata,start,width,xplot)
%   where  x  is the x-axis midpoints;
%          y  is the y-axis heights;
%          bounds  is the matrix of class boundaries: [lower upper];
%          ydata  is the data for which the histogram is needed;
%          width  is the class width;
%          start  is the starting class lower boundary;
%          xplot  determines how the x-axis is labelled:
%            xplot = 0  means to use class mid-points;
%            xplot = 1  means to use class boundaries.
%            BY DEFAULT, xplot= 1  (plot with boundaries).
%
%   Only the y-data is necessary.
%
%   SEE ALSO: fhisto

%Peter Dunn
%Last edit: 1/2/1996

global TYPE; TYPE='rel';

yplot=yplot(:);
if nargin==1,[x,y,bounds]=feval('fhisto',yplot);end;
if nargin==2,[x,y,bounds]=feval('fhisto',yplot,start);end;
if nargin==3,[x,y,bounds]=feval('fhisto',yplot,start,width);end;
if nargin==4,[x,y,bounds]=feval('fhisto',yplot,start,width,xplot);end;
clear global TYPE;
if isstr(x),ex=x;x=0;error(ex);end;

