function y = sigmoid(x, a, c)

% BELL	Sigmoidal membership function with two parameters a and c.
%	SIGMOID(x, a, c) returns a matrix y with the same size
%	as x; each element of y is a grade of membership.

%	Copyright (c) 1993 Jyh-Shing Roger Jang, U. C. Berkeley
%	jang@eecs.berkeley.edu
%	(Tested on Matlab version 4.0a, HP workstation)
%	Permission is granted to modify and re-distribute this code
%	in any manner as long as this notice is preserved.
%	All standard disclaimers apply.

%	6-29-93.

[m n] = size(x);
y = ones(m,n)./(1 + exp(-a*(x-c)));
